"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  TabbyAgent: () => TabbyAgent,
  agentEventNames: () => agentEventNames
});
module.exports = __toCommonJS(src_exports);

// src/TabbyAgent.ts
var import_events5 = require("events");
var import_uuid2 = require("uuid");
var import_deep_equal4 = __toESM(require("deep-equal"));
var import_deepmerge_ts = require("deepmerge-ts");
var import_dot_prop3 = require("dot-prop");
var import_openapi_fetch3 = __toESM(require("openapi-fetch"));
var semver = __toESM(require("semver"));

// src/dataStore.ts
var import_events = require("events");
var import_path = __toESM(require("path"));
var import_os = __toESM(require("os"));
var import_fs_extra = __toESM(require("fs-extra"));
var import_deep_equal = __toESM(require("deep-equal"));
var import_chokidar = __toESM(require("chokidar"));

// src/env.ts
var isBrowser = false;
var isTest = false;

// src/dataStore.ts
var FileDataStore = class extends import_events.EventEmitter {
  constructor(filepath) {
    super();
    this.filepath = filepath;
    this.data = {};
  }
  async load() {
    this.data = await import_fs_extra.default.readJson(dataFile, { throws: false }) || {};
  }
  async save() {
    await import_fs_extra.default.outputJson(dataFile, this.data);
  }
  watch() {
    this.watcher = import_chokidar.default.watch(this.filepath, {
      interval: 1e3
    });
    const onChanged = async () => {
      const oldData = this.data;
      await this.load();
      if (!(0, import_deep_equal.default)(oldData, this.data)) {
        super.emit("updated", this.data);
      }
    };
    this.watcher.on("add", onChanged);
    this.watcher.on("change", onChanged);
  }
};
var dataFile = import_path.default.join(import_os.default.homedir(), ".tabby-client", "agent", "data.json");
var dataStore = isBrowser ? void 0 : new FileDataStore(dataFile);

// src/utils.ts
var levenshtein = __toESM(require("fast-levenshtein"));
function splitLines(input) {
  const lines = input.match(/.*(?:$|\r?\n)/g)?.filter(Boolean) ?? [];
  if (lines.length > 0 && lines[lines.length - 1]?.endsWith("\n")) {
    lines.push("");
  }
  return lines;
}
function isBlank(input) {
  return input.trim().length === 0;
}
function getIndentationLevel(line, indentation) {
  if (indentation === void 0) {
    return line.match(/^[ \t]*/)?.[0]?.length ?? 0;
  } else if (indentation === "	") {
    return line.match(/^\t*/)?.[0].length ?? 0;
  } else if (indentation.match(/^ *$/)) {
    const spaces = line.match(/^ */)?.[0].length ?? 0;
    return spaces / indentation.length;
  } else {
    throw new Error(`Invalid indentation: ${indentation}`);
  }
}
function isBlockOpeningLine(lines, index) {
  if (index < 0 || index >= lines.length - 1) {
    return false;
  }
  return getIndentationLevel(lines[index]) < getIndentationLevel(lines[index + 1]);
}
function isBlockClosingLine(lines, index) {
  if (index <= 0 || index > lines.length - 1) {
    return false;
  }
  return getIndentationLevel(lines[index - 1]) > getIndentationLevel(lines[index]);
}
var autoClosingPairs = [
  {
    open: {
      chars: "(",
      reg: /\(/
    },
    close: {
      chars: ")",
      reg: /\)/
    }
  },
  {
    open: {
      chars: "[",
      reg: /\[/
    },
    close: {
      chars: "]",
      reg: /\]/
    }
  },
  {
    open: {
      chars: "{",
      reg: /\{/
    },
    close: {
      chars: "}",
      reg: /\}/
    }
  },
  {
    open: {
      chars: "<",
      reg: /<(?=\w)/
    },
    close: {
      chars: "/>",
      reg: /\/>/
    }
  },
  {
    open: {
      chars: "<",
      reg: /<(?=[/\w])/
    },
    close: {
      chars: ">",
      reg: />/
    }
  },
  {
    openOrClose: {
      chars: '"',
      reg: /"/
    }
  },
  {
    openOrClose: {
      chars: "'",
      reg: /'/
    }
  },
  {
    openOrClose: {
      chars: "`",
      reg: /`/
    }
  }
];
var regOnlyAutoClosingCloseChars = /^([)\]}>"'`]|(\/>))*$/g;
function findUnpairedAutoClosingChars(input) {
  const stack = [];
  let index = 0;
  while (index < input.length) {
    const remain = input.slice(index);
    let nextFound = {
      index: remain.length,
      found: void 0
    };
    autoClosingPairs.forEach((pair) => {
      Object.entries(pair).forEach(([pos, pattern]) => {
        const match = remain.match(pattern.reg);
        if (match && match.index !== void 0 && match.index < nextFound.index) {
          nextFound = {
            index: match.index,
            found: { pair, pos, pattern }
          };
        }
      });
    });
    if (!nextFound.found) {
      break;
    }
    switch (nextFound.found.pos) {
      case "openOrClose": {
        const chars = nextFound.found.pattern.chars;
        if (stack.length > 0 && stack.includes(chars)) {
          stack.splice(stack.lastIndexOf(chars), stack.length - stack.lastIndexOf(chars));
        } else {
          stack.push(chars);
        }
        break;
      }
      case "open": {
        stack.push(nextFound.found.pattern.chars);
        break;
      }
      case "close": {
        const pair = nextFound.found.pair;
        if (stack.length > 0 && "open" in pair && stack[stack.length - 1] === pair.open.chars) {
          stack.pop();
        } else {
          stack.push(nextFound.found.pattern.chars);
        }
        break;
      }
    }
    index += nextFound.index + nextFound.found.pattern.chars.length;
  }
  return stack;
}
function calcDistance(a, b) {
  return levenshtein.get(a, b);
}
function abortSignalFromAnyOf(signals) {
  const controller = new AbortController();
  for (const signal of signals) {
    if (signal?.aborted) {
      controller.abort(signal.reason);
      return signal;
    }
    signal?.addEventListener("abort", () => controller.abort(signal.reason), {
      signal: controller.signal
    });
  }
  return controller.signal;
}
var HttpError = class extends Error {
  constructor(response) {
    super(`${response.status} ${response.statusText}`);
    this.name = "HttpError";
    this.status = response.status;
    this.statusText = response.statusText;
    this.response = response;
  }
};
function isTimeoutError(error) {
  return error instanceof Error && error.name === "TimeoutError" || error instanceof HttpError && [408, 499].includes(error.status);
}
function isCanceledError(error) {
  return error instanceof Error && error.name === "AbortError";
}
function isUnauthorizedError(error) {
  return error instanceof HttpError && [401, 403].includes(error.status);
}
function errorToString(error) {
  let message = error.message || error.toString();
  if (error.cause) {
    message += "\nCaused by: " + errorToString(error.cause);
  }
  return message;
}
async function* readChatStream(response) {
  const streamReader = response.body?.getReader();
  const textDecoder = new TextDecoder("utf8");
  let streamClosed = false;
  while (streamReader && !streamClosed) {
    const { done, value } = await streamReader.read();
    if (value) {
      const raw = textDecoder.decode(Buffer.from(value));
      const header = "data: ";
      if (raw.startsWith(header)) {
        const data = JSON.parse(raw.slice(header.length));
        streamClosed ||= !!data.choices[0]?.finish_reason;
        const delta = data.choices[0]?.delta.content;
        if (typeof delta === "string") {
          yield delta;
        }
      }
    }
    streamClosed ||= done;
  }
}
async function parseChatResponse(response, signal) {
  const tokens = [];
  for await (const token of readChatStream(response)) {
    if (signal?.aborted) {
      break;
    }
    tokens.push(token);
  }
  return tokens.join("");
}

// src/Auth.ts
var import_events3 = require("events");
var import_jwt_decode = __toESM(require("jwt-decode"));
var import_deep_equal2 = __toESM(require("deep-equal"));
var import_openapi_fetch = __toESM(require("openapi-fetch"));

// src/logger.ts
var import_path2 = __toESM(require("path"));
var import_os2 = __toESM(require("os"));
var import_events2 = __toESM(require("events"));
var import_pino = __toESM(require("pino"));
var FileStreamRotator = __toESM(require("file-stream-rotator"));
var LogFileStream = class {
  write(data) {
    if (!this.stream) {
      this.stream = FileStreamRotator.getStream({
        // Rotating file locate at `~/.tabby-client/agent/logs/`.
        filename: import_path2.default.join(import_os2.default.homedir(), ".tabby-client", "agent", "logs", "%DATE%"),
        frequency: "daily",
        size: "10M",
        max_logs: "30d",
        extension: ".log",
        create_symlink: true
      });
    }
    this.stream.write(data);
  }
};
var TaggedLogger = class {
  constructor(baseLogger, tag) {
    this.baseLogger = baseLogger;
    this.tag = tag;
  }
  tagMsg(msg) {
    return `[${this.tag}] ${msg}`;
  }
  error(msg, error) {
    this.baseLogger.error(this.tagMsg(msg), { error });
  }
  warn(msg) {
    this.baseLogger.warn(this.tagMsg(msg));
  }
  info(msg) {
    this.baseLogger.info(this.tagMsg(msg));
  }
  debug(msg) {
    this.baseLogger.debug(this.tagMsg(msg));
  }
  trace(msg, verbose) {
    this.baseLogger.trace(this.tagMsg(msg), verbose);
  }
};
var JsonLineLogger = class _JsonLineLogger {
  constructor(baseLogger) {
    this.baseLogger = baseLogger;
    this.childLoggers = [];
    this.baseLogger.onChild = (child) => {
      this.childLoggers.push(child);
    };
  }
  get level() {
    return this.baseLogger.level;
  }
  set level(level) {
    this.baseLogger.level = level;
    this.childLoggers.forEach((child) => {
      child.level = level;
    });
  }
  child(tag) {
    return new _JsonLineLogger(this.baseLogger.child({ tag }));
  }
  error(msg, error) {
    this.baseLogger.error({ error }, msg);
  }
  warn(msg) {
    this.baseLogger.warn(msg);
  }
  info(msg) {
    this.baseLogger.info(msg);
  }
  debug(msg) {
    this.baseLogger.debug(msg);
  }
  trace(msg, verbose) {
    this.baseLogger.trace(verbose, msg);
  }
};
var Destinations = class extends import_events2.default {
  constructor(destinations = []) {
    super();
    this.destinations = destinations;
  }
  attach(...destinations) {
    this.destinations.push(...destinations);
    this.emit("newAttached", destinations);
  }
};
var MultiDestinationLogger = class {
  constructor(destinations, tag) {
    this.destinations = destinations;
    this.tag = tag;
    this.loggers = [];
    this.loggers.push(...destinations.destinations.map((destination) => this.createTaggedLogger(destination)));
    destinations.on("newAttached", (destinations2) => {
      this.loggers.push(...destinations2.map((destination) => this.createTaggedLogger(destination)));
    });
  }
  createTaggedLogger(destination) {
    if (!this.tag) {
      return destination;
    }
    if (destination instanceof JsonLineLogger) {
      return destination.child(this.tag);
    }
    return new TaggedLogger(destination, this.tag);
  }
  error(msg, error) {
    this.loggers.forEach((logger3) => logger3.error(msg, error));
  }
  warn(msg) {
    this.loggers.forEach((logger3) => logger3.warn(msg));
  }
  info(msg) {
    this.loggers.forEach((logger3) => logger3.info(msg));
  }
  debug(msg) {
    this.loggers.forEach((logger3) => logger3.debug(msg));
  }
  trace(msg, verbose) {
    this.loggers.forEach((logger3) => logger3.trace(msg, verbose));
  }
};
var logDestinations = new Destinations();
var fileLogger = isBrowser || isTest ? void 0 : new JsonLineLogger((0, import_pino.default)({ serializers: { error: import_pino.default.stdSerializers.err } }, new LogFileStream()));
if (fileLogger) {
  logDestinations.attach(fileLogger);
}
function getLogger(tag) {
  return new MultiDestinationLogger(logDestinations, tag);
}

// src/Auth.ts
var RetryLimitReachedError = class extends Error {
  constructor(cause) {
    super();
    this.cause = cause;
    this.name = "RetryLimitReachedError";
  }
};
var Auth = class _Auth extends import_events3.EventEmitter {
  constructor(endpoint) {
    super();
    this.endpoint = endpoint;
    this.logger = getLogger("Auth");
    this.authApi = (0, import_openapi_fetch.default)({ baseUrl: "https://app.tabbyml.com/api" });
  }
  static {
    this.authPageUrl = "https://app.tabbyml.com/account/device-token";
  }
  static {
    this.tokenStrategy = {
      polling: {
        // polling token after auth url generated
        interval: 5e3,
        // polling token every 5 seconds
        timeout: 5 * 60 * 1e3
        // stop polling after trying for 5 min
      },
      refresh: {
        // check token every 15 min, refresh token if it expires in 30 min
        interval: 15 * 60 * 1e3,
        beforeExpire: 30 * 60 * 1e3,
        whenLoaded: {
          // after token loaded from data store, refresh token if it is about to expire or has expired
          maxTry: 5,
          // keep loading time not too long
          retryDelay: 1e3
          // retry after 1 seconds
        },
        whenScheduled: {
          // if running until token is about to expire, refresh token as scheduled
          maxTry: 60,
          retryDelay: 30 * 1e3
          // retry after 30 seconds
        }
      }
    };
  }
  async init(options) {
    this.dataStore = options?.dataStore;
    if (this.dataStore instanceof import_events3.EventEmitter) {
      this.dataStore.on("updated", async () => {
        const oldJwt = this.jwt;
        await this.load();
        if (!(0, import_deep_equal2.default)(oldJwt, this.jwt)) {
          super.emit("updated", this.jwt);
        }
      });
    }
    this.scheduleRefreshToken();
    await this.load();
  }
  get token() {
    return this.jwt?.token;
  }
  get user() {
    return this.jwt?.payload.email;
  }
  async load() {
    if (!this.dataStore) {
      return;
    }
    try {
      await this.dataStore.load();
      const storedJwt = this.dataStore.data.auth?.[this.endpoint]?.jwt;
      if (typeof storedJwt === "string" && this.jwt?.token !== storedJwt) {
        this.logger.debug("Loaded auth data from data store.");
        const jwt = {
          token: storedJwt,
          payload: (0, import_jwt_decode.default)(storedJwt)
        };
        if (jwt.payload.exp * 1e3 - Date.now() < _Auth.tokenStrategy.refresh.beforeExpire) {
          this.jwt = await this.refreshToken(jwt, _Auth.tokenStrategy.refresh.whenLoaded);
          await this.save();
        } else {
          this.jwt = jwt;
        }
      }
    } catch (error) {
      this.logger.debug("Failed to load auth data from data store.");
    }
  }
  async save() {
    if (!this.dataStore) {
      return;
    }
    try {
      if (this.jwt) {
        if (this.dataStore.data.auth?.[this.endpoint]?.jwt === this.jwt.token) {
          return;
        }
        this.dataStore.data.auth = { ...this.dataStore.data.auth, [this.endpoint]: { jwt: this.jwt.token } };
      } else {
        if (typeof this.dataStore.data.auth?.[this.endpoint] === "undefined") {
          return;
        }
        delete this.dataStore.data.auth[this.endpoint];
      }
      await this.dataStore.save();
      this.logger.debug("Saved auth data to data store.");
    } catch (error) {
      this.logger.error("Failed to save auth data to data store.", error);
    }
  }
  async reset() {
    if (this.jwt) {
      this.jwt = void 0;
      await this.save();
    }
  }
  async requestAuthUrl(options) {
    try {
      await this.reset();
      if (options?.signal?.aborted) {
        throw options.signal.reason;
      }
      this.logger.debug("Requesting device token...");
      const response = await this.authApi.POST("/device-token", {
        body: { auth_url: this.endpoint },
        signal: options?.signal
      });
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      const deviceToken = response.data;
      const authUrl = new URL(_Auth.authPageUrl);
      authUrl.searchParams.append("code", deviceToken.data.code);
      return { authUrl: authUrl.toString(), code: deviceToken.data.code };
    } catch (error) {
      this.logger.error("Failed to request device token", error);
      throw error;
    }
  }
  async pollingToken(code, options) {
    return new Promise((resolve, reject) => {
      const signal = abortSignalFromAnyOf([AbortSignal.timeout(_Auth.tokenStrategy.polling.timeout), options?.signal]);
      const timer = setInterval(async () => {
        try {
          this.logger.debug("Polling auth token...");
          const response = await this.authApi.POST("/device-token/accept", { params: { query: { code } }, signal });
          if (response.error || !response.response.ok) {
            throw new HttpError(response.response);
          }
          const result = response.data;
          this.jwt = {
            token: result.data.jwt,
            payload: (0, import_jwt_decode.default)(result.data.jwt)
          };
          super.emit("updated", this.jwt);
          await this.save();
          clearInterval(timer);
          resolve(true);
        } catch (error) {
          if (error instanceof HttpError && [400, 401, 403, 405].includes(error.status)) {
            this.logger.error("Failed due to unknown error when polling auth token", error);
          }
        }
      }, _Auth.tokenStrategy.polling.interval);
      if (signal.aborted) {
        clearInterval(timer);
        reject(signal.reason);
      } else {
        signal.addEventListener("abort", () => {
          clearInterval(timer);
          reject(signal.reason);
        });
      }
    });
  }
  async refreshToken(jwt, options = { maxTry: 1, retryDelay: 1e3 }, retry = 0) {
    try {
      this.logger.debug("Refreshing auth token...");
      const response = await this.authApi.POST("/device-token/refresh", {
        headers: { Authorization: `Bearer ${jwt.token}` }
      });
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      const refreshedJwt = response.data;
      return {
        token: refreshedJwt.data.jwt,
        payload: (0, import_jwt_decode.default)(refreshedJwt.data.jwt)
      };
    } catch (error) {
      if (error instanceof HttpError && [400, 401, 403, 405].includes(error.status)) {
        this.logger.error("Failed due to unknown error when refreshing auth token.", error);
        if (retry < options.maxTry) {
          this.logger.debug(`Retry refreshing auth token after ${options.retryDelay}ms`);
          await new Promise((resolve) => setTimeout(resolve, options.retryDelay));
          return this.refreshToken(jwt, options, retry + 1);
        }
      }
      throw new RetryLimitReachedError(error);
    }
  }
  scheduleRefreshToken() {
    setInterval(async () => {
      if (!this.jwt) {
        return;
      }
      this.logger.debug("Checking auth token...");
      if (this.jwt.payload.exp * 1e3 - Date.now() < _Auth.tokenStrategy.refresh.beforeExpire) {
        try {
          this.jwt = await this.refreshToken(this.jwt, _Auth.tokenStrategy.refresh.whenScheduled);
          super.emit("updated", this.jwt);
          await this.save();
        } catch (error) {
          this.logger.error("Failed to refresh auth token.", error);
        }
      } else {
        this.logger.debug("Auth token is still valid.");
      }
    }, _Auth.tokenStrategy.refresh.interval);
  }
};

// src/AgentConfig.ts
var defaultAgentConfig = {
  server: {
    endpoint: "http://localhost:8080",
    token: "",
    requestHeaders: {},
    requestTimeout: 2 * 60 * 1e3
    // 2 minutes
  },
  completion: {
    prompt: {
      maxPrefixLines: 20,
      maxSuffixLines: 20,
      fillDeclarations: {
        enabled: true,
        maxSnippets: 5,
        maxCharsPerSnippet: 500
      },
      collectSnippetsFromRecentChangedFiles: {
        enabled: true,
        maxSnippets: 3,
        indexing: {
          checkingChangesInterval: 500,
          changesDebouncingInterval: 1e3,
          prefixLines: 20,
          suffixLines: 20,
          maxChunks: 100,
          chunkSize: 500,
          overlapLines: 1
        }
      },
      clipboard: {
        minChars: 3,
        maxChars: 2e3
      }
    },
    debounce: {
      mode: "adaptive",
      interval: 250
      // ms
    },
    solution: {
      maxItems: 3,
      maxTries: 6,
      temperature: 0.8
    }
  },
  postprocess: {
    limitScope: {},
    calculateReplaceRange: {}
  },
  experimentalChat: {
    generateCommitMessage: {
      maxDiffLength: 3600,
      promptTemplate: "Generate a commit message based on the given diff. \nYou should only reply with the commit message, and the commit message should be in the following format: \n`<type>(<scope>): <description>` \nexamples: \n * feat(chat): add support for chat. \n * fix(ui): fix homepage links. \nThe diff is: \n\n```diff \n{{diff}} \n``` \n"
    }
  },
  logs: {
    level: "silent"
  },
  tls: {
    caCerts: "system"
  },
  anonymousUsageTracking: {
    disable: false
  }
};

// src/configFile.ts
var import_events4 = require("events");
var import_path3 = __toESM(require("path"));
var import_os3 = __toESM(require("os"));
var import_fs_extra2 = __toESM(require("fs-extra"));
var import_toml = __toESM(require("toml"));
var import_chokidar2 = __toESM(require("chokidar"));
var import_deep_equal3 = __toESM(require("deep-equal"));
var import_dot_prop = require("dot-prop");
var configTomlTemplate = `## Tabby agent configuration file

## Online documentation: https://tabby.tabbyml.com/docs/extensions/configurations
## You can uncomment and edit the values below to change the default settings.
## Configurations in this file have lower priority than the IDE settings.

## Server
## You can set the server endpoint here and an optional authentication token if required.
# [server]
# endpoint = "http://localhost:8080" # http or https URL
# token = "your-token-here" # if token is set, request header Authorization = "Bearer $token" will be added automatically

## You can add custom request headers.
# [server.requestHeaders]
# Header1 = "Value1" # list your custom headers here
# Header2 = "Value2" # values can be strings, numbers or booleans

## Logs
## You can set the log level here. The log file is located at ~/.tabby-client/agent/logs/.
# [logs]
# level = "silent" # "silent" or "error" or "debug"

## Anonymous usage tracking
## Tabby collects anonymous usage data and sends it to the Tabby team to help improve our products.
## Your code, generated completions, or any sensitive information is never tracked or sent.
## For more details on data collection, see https://tabby.tabbyml.com/docs/extensions/configurations#usage-collection
## Your contribution is greatly appreciated. However, if you prefer not to participate, you can disable anonymous usage tracking here.
# [anonymousUsageTracking]
# disable = false # set to true to disable

`;
var typeCheckSchema = {
  server: "object",
  "server.endpoint": "string",
  "server.token": "string",
  "server.requestHeaders": "object",
  "server.requestTimeout": "number",
  completion: "object",
  "completion.prompt": "object",
  "completion.prompt.maxPrefixLines": "number",
  "completion.prompt.maxSuffixLines": "number",
  "completion.prompt.fillDeclarations": "object",
  "completion.prompt.fillDeclarations.enabled": "boolean",
  "completion.prompt.fillDeclarations.maxSnippets": "number",
  "completion.prompt.fillDeclarations.maxChars": "number",
  "completion.prompt.collectSnippetsFromRecentChangedFiles": "object",
  "completion.prompt.collectSnippetsFromRecentChangedFiles.enabled": "boolean",
  "completion.prompt.collectSnippetsFromRecentChangedFiles.maxSnippets": "number",
  "completion.prompt.collectSnippetsFromRecentChangedFiles.indexing": "object",
  "completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.checkingChangesInterval": "number",
  "completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.changesDebouncingInterval": "number",
  "completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.prefixLines": "number",
  "completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.suffixLines": "number",
  "completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.maxChunks": "number",
  "completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.chunkSize": "number",
  "completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.overlapLines": "number",
  "completion.prompt.clipboard": "object",
  "completion.prompt.clipboard.minChars": "number",
  "completion.prompt.clipboard.maxChars": "number",
  "completion.debounce": "object",
  "completion.debounce.mode": "string",
  "completion.debounce.interval": "number",
  "completion.solution": "object",
  "completion.solution.maxItems": "number",
  "completion.solution.maxTries": "number",
  "completion.solution.temperature": "number",
  experimentalChat: "object",
  "experimentalChat.generateCommitMessage": "object",
  "experimentalChat.generateCommitMessage.maxDiffLength": "number",
  "experimentalChat.generateCommitMessage.promptTemplate": "string",
  logs: "object",
  "logs.level": "string",
  tls: "object",
  "tls.caCerts": "string",
  anonymousUsageTracking: "object",
  "anonymousUsageTracking.disable": "boolean"
};
function validateConfig(config) {
  for (const [key, type] of Object.entries(typeCheckSchema)) {
    if (typeof (0, import_dot_prop.getProperty)(config, key) !== type) {
      (0, import_dot_prop.deleteProperty)(config, key);
    }
  }
  return config;
}
var ConfigFile = class extends import_events4.EventEmitter {
  constructor(filepath) {
    super();
    this.filepath = filepath;
    this.data = {};
    this.logger = getLogger("ConfigFile");
  }
  get config() {
    return this.data;
  }
  async load() {
    try {
      const fileContent = await import_fs_extra2.default.readFile(this.filepath, "utf8");
      const data = import_toml.default.parse(fileContent);
      if (Object.keys(data).length === 0 && fileContent.trim() !== configTomlTemplate.trim()) {
        await this.createTemplate();
        return;
      }
      this.data = validateConfig(data);
    } catch (error) {
      if (error instanceof Error && "code" in error && error.code === "ENOENT") {
        await this.createTemplate();
      } else {
        this.logger.error("Failed to load config file.", error);
      }
    }
  }
  watch() {
    this.watcher = import_chokidar2.default.watch(this.filepath, {
      interval: 1e3
    });
    const onChanged = async () => {
      const oldData = this.data;
      await this.load();
      if (!(0, import_deep_equal3.default)(oldData, this.data)) {
        super.emit("updated", this.data);
      }
    };
    this.watcher.on("add", onChanged);
    this.watcher.on("change", onChanged);
  }
  async createTemplate() {
    try {
      await import_fs_extra2.default.outputFile(this.filepath, configTomlTemplate);
    } catch (error) {
      this.logger.error("Failed to create config template file.", error);
    }
  }
};
var configFilePath = import_path3.default.join(import_os3.default.homedir(), ".tabby-client", "agent", "config.toml");
var configFile = isBrowser ? void 0 : new ConfigFile(configFilePath);

// src/CompletionCache.ts
var import_lru_cache = require("lru-cache");

// src/CompletionSolution.ts
var emptyInlineCompletionList = {
  isIncomplete: true,
  items: []
};
var CompletionItem = class _CompletionItem {
  // whether the item is a blank line.
  constructor(context, fullText, replacePrefix = "", replaceSuffix = "", eventId) {
    this.context = context;
    this.fullText = fullText;
    this.replacePrefix = replacePrefix;
    this.replaceSuffix = replaceSuffix;
    this.eventId = eventId;
    this.text = fullText.substring(replacePrefix.length);
    this.lines = splitLines(this.text);
    this.currentLine = this.lines[0] ?? "";
    this.isBlank = isBlank(this.text);
  }
  static createBlankItem(context) {
    return new _CompletionItem(context, "");
  }
  static createFromResponse(context, response, index = 0) {
    return new _CompletionItem(context, response.choices[index]?.text ?? "", "", "", {
      completionId: response.id,
      choiceIndex: response.choices[index]?.index ?? index
    });
  }
  // Generate a CompletionItem based on this CompletionItem with modified `fullText`.
  withFullText(fullText) {
    return new _CompletionItem(this.context, fullText, this.replacePrefix, this.replaceSuffix, this.eventId);
  }
  // Generate a CompletionItem based on this CompletionItem with modified `text`.
  withText(text) {
    return new _CompletionItem(
      this.context,
      this.replacePrefix + text,
      this.replacePrefix,
      this.replaceSuffix,
      this.eventId
    );
  }
  // Generate a CompletionItem based on this CompletionItem with modified `replaceSuffix`.
  withSuffix(replaceSuffix) {
    return new _CompletionItem(this.context, this.fullText, this.replacePrefix, replaceSuffix, this.eventId);
  }
  // Generate a CompletionItem by trying to apply this CompletionItem to the new context.
  withContext(context) {
    if (context.hash === this.context.hash) {
      return new _CompletionItem(context, this.fullText, this.replacePrefix, this.replaceSuffix, this.eventId);
    } else {
      return _CompletionItem.createBlankItem(context);
    }
  }
  // Generate a CompletionItem based on this CompletionItem.
  // Simulate as if the user typed over the same text as the completion.
  forward(chars) {
    if (chars <= 0)
      return this;
    const delta = this.text.substring(0, chars);
    if (chars < this.currentLine.length) {
      return new _CompletionItem(
        this.context.forward(delta),
        this.fullText,
        this.replacePrefix + delta,
        this.replaceSuffix,
        this.eventId
      );
    }
    const lastLineStart = delta.lastIndexOf("\n") + 1;
    const lastLine = delta.substring(lastLineStart);
    let whiteSpaces = lastLine.search(/\S/);
    if (whiteSpaces < 0) {
      whiteSpaces = lastLine.length;
    }
    const lastLineNonSpaceStart = lastLineStart + whiteSpaces;
    const fullText = this.text.substring(lastLineNonSpaceStart);
    const lastLineNonSpace = delta.substring(lastLineNonSpaceStart);
    return new _CompletionItem(
      this.context.forward(delta),
      fullText,
      lastLineNonSpace,
      this.replaceSuffix,
      this.eventId
    );
  }
  isSameWith(other) {
    return this.context.hash === other.context.hash && this.text === other.text;
  }
  toInlineCompletionItem() {
    return {
      insertText: this.fullText,
      range: {
        start: this.context.currentLinePrefix.endsWith(this.replacePrefix) ? this.context.position - this.replacePrefix.length : this.context.position,
        end: this.context.currentLineSuffix.startsWith(this.replaceSuffix) ? this.context.position + this.replaceSuffix.length : this.context.position
      },
      data: { eventId: this.eventId }
    };
  }
};
var CompletionSolution = class _CompletionSolution {
  constructor(context, items = [], isCompleted = false) {
    this.context = context;
    this.items = [];
    this.isCompleted = false;
    this.add(...items);
    this.isCompleted = isCompleted;
  }
  static merge(base, addition) {
    if (base.context.hash === addition.context.hash) {
      return new _CompletionSolution(
        base.context,
        [...base.items, ...addition.items],
        base.isCompleted || addition.isCompleted
      );
    } else {
      return base;
    }
  }
  add(...items) {
    this.items.push(
      ...items.map((item) => item.withContext(this.context)).filter((item, index, arr) => {
        return !item.isBlank && // deduplicate
        arr.findIndex((i) => i.isSameWith(item)) === index && this.items.findIndex((i) => i.isSameWith(item)) === -1;
      })
    );
  }
  // Generate a CompletionSolution by trying to apply this CompletionSolution to the new context.
  withContext(context) {
    if (context.hash === this.context.hash) {
      return new _CompletionSolution(context, this.items, this.isCompleted);
    } else {
      return new _CompletionSolution(context);
    }
  }
  // Generate a CompletionSolution by replacing all items.
  withItems(...items) {
    return new _CompletionSolution(this.context, items, this.isCompleted);
  }
  toInlineCompletionList() {
    return {
      isIncomplete: !this.isCompleted,
      items: this.items.map((item) => item.toInlineCompletionItem())
    };
  }
};

// src/CompletionCache.ts
var CompletionCache = class {
  constructor() {
    this.logger = getLogger("CompletionCache");
    this.config = {
      maxCount: 1e3,
      forwardCachingChars: 50
    };
    this.cache = new import_lru_cache.LRUCache({
      max: this.config.maxCount
    });
  }
  has(key) {
    return this.cache.has(key);
  }
  update(value) {
    this.logger.debug(`Updating completion cache, cache number before updating: ${this.cache.size}`);
    const solutions = [value, ...this.generateForwardSolutions(value)];
    solutions.forEach((solution) => {
      const cachedSolution = this.cache.get(solution.context.hash);
      if (cachedSolution) {
        this.cache.set(solution.context.hash, CompletionSolution.merge(cachedSolution, solution));
      } else {
        this.cache.set(solution.context.hash, solution);
      }
    });
    this.logger.debug(`Updated entries number: ${solutions.length}`);
    this.logger.debug(`Completion cache updated, cache number: ${this.cache.size}`);
  }
  get(key) {
    return this.cache.get(key);
  }
  generateForwardSolutions(solution) {
    const forwardSolutions = [];
    const pushForwardSolution = (item) => {
      const existSolution = forwardSolutions.find((solution2) => solution2.context.hash === item.context.hash);
      if (existSolution) {
        existSolution.add(item);
      } else {
        forwardSolutions.push(new CompletionSolution(item.context, [item]));
      }
    };
    for (const item of solution.items) {
      for (let chars = 1; chars < Math.min(this.config.forwardCachingChars, item.currentLine.length); chars++) {
        pushForwardSolution(item.forward(chars));
      }
      if (item.lines.length > 2) {
        pushForwardSolution(item.forward(item.currentLine.length - 1));
        pushForwardSolution(item.forward(item.currentLine.length));
        const nextLine = item.lines[1];
        let spaces = nextLine.search(/\S/);
        if (spaces < 0) {
          spaces = nextLine.length - 1;
        }
        pushForwardSolution(item.forward(item.currentLine.length + spaces));
      }
    }
    return forwardSolutions;
  }
};

// src/CompletionDebounce.ts
function clamp(min, max, value) {
  return Math.max(min, Math.min(max, value));
}
var CompletionDebounce = class {
  constructor() {
    this.lastCalledTimeStamp = 0;
    this.baseInterval = 200;
    // ms
    this.calledIntervalHistory = [];
    this.options = {
      baseIntervalSlideWindowAvg: {
        minSize: 20,
        maxSize: 100,
        min: 100,
        max: 400
      },
      adaptiveRate: {
        min: 1.5,
        max: 3
      },
      contextScoreWeights: {
        triggerCharacter: 0.5,
        noSuffixInCurrentLine: 0.4,
        noSuffix: 0.1
      },
      requestDelay: {
        min: 100,
        // ms
        max: 1e3
      }
    };
  }
  async debounce(context, options) {
    const { request, config, responseTime } = context;
    if (request.manually) {
      return this.sleep(0, options);
    }
    if (config.mode === "fixed") {
      return this.sleep(config.interval, options);
    }
    const now = Date.now();
    this.updateBaseInterval(now - this.lastCalledTimeStamp);
    this.lastCalledTimeStamp = now;
    const contextScore = this.calcContextScore(request);
    const adaptiveRate = this.options.adaptiveRate.max - (this.options.adaptiveRate.max - this.options.adaptiveRate.min) * contextScore;
    const expectedLatency = adaptiveRate * this.baseInterval;
    const delay = clamp(this.options.requestDelay.min, this.options.requestDelay.max, expectedLatency - responseTime);
    return this.sleep(delay, options);
  }
  async sleep(delay, options) {
    return new Promise((resolve, reject) => {
      const timer = setTimeout(resolve, Math.min(delay, 2147483647));
      const signal = options?.signal;
      if (signal) {
        if (signal.aborted) {
          clearTimeout(timer);
          reject(signal.reason);
        } else {
          signal.addEventListener("abort", () => {
            clearTimeout(timer);
            reject(signal.reason);
          });
        }
      }
    });
  }
  updateBaseInterval(interval) {
    if (interval > this.options.baseIntervalSlideWindowAvg.max) {
      return;
    }
    this.calledIntervalHistory.push(interval);
    if (this.calledIntervalHistory.length > this.options.baseIntervalSlideWindowAvg.maxSize) {
      this.calledIntervalHistory.shift();
    }
    if (this.calledIntervalHistory.length > this.options.baseIntervalSlideWindowAvg.minSize) {
      const avg = this.calledIntervalHistory.reduce((a, b) => a + b, 0) / this.calledIntervalHistory.length;
      this.baseInterval = clamp(
        this.options.baseIntervalSlideWindowAvg.min,
        this.options.baseIntervalSlideWindowAvg.max,
        avg
      );
    }
  }
  // return score in [0, 1], 1 means the context has a high chance to accept the completion
  calcContextScore(request) {
    let score = 0;
    const weights = this.options.contextScoreWeights;
    const triggerCharacter = request.text[request.position - 1] ?? "";
    score += triggerCharacter.match(/^\W*$/) ? weights.triggerCharacter : 0;
    const suffix = request.text.slice(request.position) ?? "";
    const currentLineInSuffix = splitLines(suffix)[0] ?? "";
    score += currentLineInSuffix.match(/^\W*$/) ? weights.noSuffixInCurrentLine : 0;
    score += suffix.match(/^\W*$/) ? weights.noSuffix : 0;
    score = clamp(0, 1, score);
    return score;
  }
};

// src/CompletionStats.ts
var import_stats_logscale = require("stats-logscale");
var CompletionStats = class {
  constructor() {
    this.autoCompletionCount = 0;
    this.manualCompletionCount = 0;
    this.eventMap = /* @__PURE__ */ new Map();
    this.completionRequestLatencyStats = new import_stats_logscale.Univariate();
    this.completionRequestCanceledCount = 0;
    this.completionRequestTimeoutCount = 0;
  }
  addProviderStatsEntry(value) {
    const { triggerMode } = value;
    if (triggerMode === "auto") {
      this.autoCompletionCount += 1;
    } else {
      this.manualCompletionCount += 1;
    }
  }
  addRequestStatsEntry(value) {
    const { canceled, timeout, latency } = value;
    if (canceled) {
      this.completionRequestCanceledCount += 1;
    } else if (timeout) {
      this.completionRequestTimeoutCount += 1;
    } else {
      this.completionRequestLatencyStats.add(latency);
    }
  }
  addEvent(event) {
    const count = this.eventMap.get(event) || 0;
    this.eventMap.set(event, count + 1);
  }
  reset() {
    this.autoCompletionCount = 0;
    this.manualCompletionCount = 0;
    this.eventMap = /* @__PURE__ */ new Map();
    this.completionRequestLatencyStats = new import_stats_logscale.Univariate();
    this.completionRequestCanceledCount = 0;
    this.completionRequestTimeoutCount = 0;
  }
  // stats for anonymous usage report
  stats() {
    const eventCount = Object.fromEntries(
      Array.from(this.eventMap.entries()).map(([key, value]) => ["count_" + key, value])
    );
    return {
      completion: {
        count_auto: this.autoCompletionCount,
        count_manual: this.manualCompletionCount,
        ...eventCount
      },
      completion_request: {
        count: this.completionRequestLatencyStats.count(),
        latency_avg: this.completionRequestLatencyStats.mean(),
        latency_p50: this.completionRequestLatencyStats.percentile(50),
        latency_p95: this.completionRequestLatencyStats.percentile(95),
        latency_p99: this.completionRequestLatencyStats.percentile(99)
      },
      completion_request_canceled: {
        count: this.completionRequestCanceledCount
      },
      completion_request_timeout: {
        count: this.completionRequestTimeoutCount
      }
    };
  }
};
var LastN = class {
  constructor(maxSize) {
    this.maxSize = maxSize;
    this.values = [];
  }
  add(value) {
    this.values.push(value);
    if (this.values.length > this.maxSize) {
      this.values.shift();
    }
  }
  getValues() {
    return this.values;
  }
};
var RequestStats = class _RequestStats {
  constructor() {
    this.latencies = new LastN(_RequestStats.config.windowSize);
  }
  static {
    this.config = {
      windowSize: 10,
      checks: {
        disable: false,
        // Mark status as healthy if the latency is less than the threshold for each latest windowSize requests.
        healthy: { windowSize: 1, latency: 3e3 },
        // If there is at least {count} requests, and the average response time is higher than the {latency}, show warning
        slowResponseTime: { latency: 5e3, count: 1 },
        // If there is at least {count} timeouts, and the timeout rate is higher than the {rate}, show warning
        highTimeoutRate: { rate: 0.5, count: 1 }
      }
    };
  }
  static check(result) {
    if (this.config.checks.disable) {
      return null;
    }
    const config = this.config.checks;
    const {
      values: latencies,
      stats: { total, timeouts, responses, averageResponseTime }
    } = result;
    if (latencies.slice(-Math.min(this.config.windowSize, config.healthy.windowSize)).every((latency) => latency < config.healthy.latency)) {
      return "healthy";
    }
    if (timeouts / total > config.highTimeoutRate.rate && timeouts >= config.highTimeoutRate.count) {
      return "highTimeoutRate";
    }
    if (averageResponseTime > config.slowResponseTime.latency && responses >= config.slowResponseTime.count) {
      return "slowResponseTime";
    }
    return null;
  }
  add(entry) {
    this.latencies.add(entry);
  }
  reset() {
    this.latencies = new LastN(_RequestStats.config.windowSize);
  }
  // stats for "highTimeoutRate" | "slowResponseTime" warning
  stats() {
    const latencies = this.latencies.getValues();
    const timeouts = latencies.filter((latency) => Number.isNaN(latency));
    const responses = latencies.filter((latency) => !Number.isNaN(latency));
    const averageResponseTime = responses.reduce((acc, latency) => acc + latency, 0) / responses.length;
    return {
      values: latencies,
      stats: {
        total: latencies.length,
        timeouts: timeouts.length,
        responses: responses.length,
        averageResponseTime
      }
    };
  }
};

// src/CompletionContext.ts
var import_path4 = __toESM(require("path"));
var import_object_hash = __toESM(require("object-hash"));
function isAtLineEndExcludingAutoClosedChar(suffix) {
  return suffix.trimEnd().match(regOnlyAutoClosingCloseChars);
}
var CompletionContext = class _CompletionContext {
  constructor(request) {
    this.filepath = request.filepath;
    this.language = request.language;
    this.text = request.text;
    this.position = request.position;
    this.indentation = request.indentation;
    this.prefix = request.text.slice(0, request.position);
    this.suffix = request.text.slice(request.position);
    this.prefixLines = splitLines(this.prefix);
    this.suffixLines = splitLines(this.suffix);
    this.currentLinePrefix = this.prefixLines[this.prefixLines.length - 1] ?? "";
    this.currentLineSuffix = this.suffixLines[0] ?? "";
    this.clipboard = request.clipboard?.trim() ?? "";
    this.workspace = request.workspace;
    this.git = request.git;
    this.declarations = request.declarations;
    this.relevantSnippetsFromChangedFiles = request.relevantSnippetsFromChangedFiles;
    const lineEnd = isAtLineEndExcludingAutoClosedChar(this.currentLineSuffix);
    this.mode = lineEnd ? "default" : "fill-in-line";
    this.hash = (0, import_object_hash.default)({
      filepath: this.filepath,
      language: this.language,
      prefix: this.prefix,
      currentLineSuffix: lineEnd ? "" : this.currentLineSuffix,
      nextLines: this.suffixLines.slice(1).join(""),
      position: this.position,
      clipboard: this.clipboard,
      declarations: this.declarations,
      relevantSnippetsFromChangedFiles: this.relevantSnippetsFromChangedFiles
    });
  }
  // is valid for completion.
  isValid() {
    return !isBlank(this.prefix);
  }
  // Generate a CompletionContext based on this CompletionContext.
  // Simulate as if the user input new text based on this CompletionContext.
  forward(delta) {
    return new _CompletionContext({
      filepath: this.filepath,
      language: this.language,
      text: this.text.substring(0, this.position) + delta + this.text.substring(this.position),
      position: this.position + delta.length,
      indentation: this.indentation,
      workspace: this.workspace,
      git: this.git,
      declarations: this.declarations,
      relevantSnippetsFromChangedFiles: this.relevantSnippetsFromChangedFiles
    });
  }
  // Build segments for TabbyApi
  buildSegments(config) {
    const prefix = this.prefixLines.slice(Math.max(this.prefixLines.length - config.maxPrefixLines, 0)).join("");
    const suffix = this.suffixLines.slice(0, config.maxSuffixLines).join("");
    let relativeFilepathRoot = void 0;
    let filepath = void 0;
    let gitUrl = void 0;
    if (this.git && this.git.remotes.length > 0) {
      const remote = this.git.remotes.find((remote2) => remote2.name === "origin") || this.git.remotes.find((remote2) => remote2.name === "upstream") || this.git.remotes[0];
      if (remote) {
        relativeFilepathRoot = this.git.root;
        gitUrl = remote.url;
      }
    }
    if (!relativeFilepathRoot && this.workspace) {
      relativeFilepathRoot = this.workspace;
    }
    if (relativeFilepathRoot) {
      filepath = import_path4.default.relative(relativeFilepathRoot, this.filepath);
    }
    const declarations = this.declarations?.map((declaration) => {
      let declarationFilepath = declaration.filepath;
      if (relativeFilepathRoot && declarationFilepath.startsWith(relativeFilepathRoot)) {
        declarationFilepath = import_path4.default.relative(relativeFilepathRoot, declarationFilepath);
      }
      return {
        filepath: declarationFilepath,
        body: declaration.text
      };
    });
    const relevantSnippetsFromChangedFiles = this.relevantSnippetsFromChangedFiles?.filter(
      (snippet) => (
        // Remove snippet if find a declaration from the same file and range is overlapping
        !this.declarations?.find((declaration) => {
          return declaration.filepath === snippet.filepath && // Is range overlapping
          Math.max(declaration.offset, snippet.offset) <= Math.min(declaration.offset + declaration.text.length, snippet.offset + snippet.text.length);
        })
      )
    ).map((snippet) => {
      let snippetFilepath = snippet.filepath;
      if (relativeFilepathRoot && snippetFilepath.startsWith(relativeFilepathRoot)) {
        snippetFilepath = import_path4.default.relative(relativeFilepathRoot, snippetFilepath);
      }
      return {
        filepath: snippetFilepath,
        body: snippet.text,
        score: snippet.score
      };
    }).sort((a, b) => b.score - a.score);
    let clipboard = void 0;
    if (this.clipboard.length >= config.clipboard.minChars && this.clipboard.length <= config.clipboard.maxChars) {
      clipboard = this.clipboard;
    }
    return {
      prefix,
      suffix,
      filepath,
      git_url: gitUrl,
      declarations,
      relevant_snippets_from_changed_files: relevantSnippetsFromChangedFiles,
      clipboard
    };
  }
};

// src/ArrayExt.ts
if (!Array.prototype.distinct) {
  Array.prototype.distinct = function(identity) {
    return [...new Map(this.map((item) => [identity?.(item) ?? item, item])).values()];
  };
}
if (!Array.prototype.mapAsync) {
  Array.prototype.mapAsync = async function(callbackfn, thisArg) {
    return await Promise.all(this.map((item, index) => callbackfn.call(thisArg, item, index, this)));
  };
}

// src/postprocess/base.ts
var logger = getLogger("Postprocess");

// src/postprocess/removeRepetitiveBlocks.ts
function blockSplitter(_) {
  return /\n(\s*)\n/g;
}
function removeRepetitiveBlocks() {
  return (item) => {
    const context = item.context;
    const inputBlocks = item.text.split(blockSplitter(context.language));
    let repetitionCount = 0;
    const repetitionThreshold = 2;
    let index = inputBlocks.length - 2;
    while (index >= 1) {
      if (isBlank(inputBlocks[index])) {
        index--;
        continue;
      }
      let prev = index - 1;
      while (prev >= 0 && isBlank(inputBlocks[prev])) {
        prev--;
      }
      if (prev < 0)
        break;
      const currentBlock = inputBlocks[index].trim();
      const previousBlock = inputBlocks[prev].trim();
      const threshold = Math.max(0.1 * currentBlock.length, 0.1 * previousBlock.length);
      const distance = calcDistance(currentBlock, previousBlock);
      if (distance <= threshold) {
        repetitionCount++;
        index--;
      } else {
        break;
      }
    }
    if (repetitionCount >= repetitionThreshold) {
      logger.trace("Remove repetitive blocks.", {
        inputBlocks,
        repetitionCount
      });
      return item.withText(
        inputBlocks.slice(0, index + 1).join("").trimEnd()
      );
    }
    return item;
  };
}

// src/postprocess/removeRepetitiveLines.ts
function removeRepetitiveLines() {
  return (item) => {
    const inputLines = item.lines;
    let repetitionCount = 0;
    const repetitionThreshold = 5;
    let index = inputLines.length - 2;
    while (index >= 1) {
      if (isBlank(inputLines[index])) {
        index--;
        continue;
      }
      let prev = index - 1;
      while (prev >= 0 && isBlank(inputLines[prev])) {
        prev--;
      }
      if (prev < 0)
        break;
      const currentLine = inputLines[index].trim();
      const previousLine = inputLines[prev].trim();
      const threshold = Math.max(0.1 * currentLine.length, 0.1 * previousLine.length);
      const distance = calcDistance(currentLine, previousLine);
      if (distance <= threshold) {
        repetitionCount++;
        index = prev;
      } else {
        break;
      }
    }
    logger.trace("No Remove repetitive lines.", {
      inputLines,
      repetitionCount
    });
    if (repetitionCount >= repetitionThreshold) {
      logger.trace("Remove repetitive lines.", {
        inputLines,
        repetitionCount
      });
      return item.withText(
        inputLines.slice(0, index + 1).join("").trimEnd()
      );
    }
    return item;
  };
}

// src/postprocess/removeLineEndsWithRepetition.ts
var repetitionTests = [
  /(.{3,}?)\1{5,}$/g,
  // match a 3+ characters pattern repeating 5+ times
  /(.{10,}?)\1{3,}$/g
  // match a 10+ characters pattern repeating 3+ times
];
function removeLineEndsWithRepetition() {
  return (item) => {
    const context = item.context;
    const inputLines = item.lines;
    let index = inputLines.length - 1;
    while (index >= 0 && isBlank(inputLines[index])) {
      index--;
    }
    if (index < 0) {
      return item;
    }
    for (const test of repetitionTests) {
      const match = inputLines[index].match(test);
      if (match) {
        logger.trace("Remove line ends with repetition.", {
          inputLines,
          lineNumber: index,
          match
        });
        if (index < 1) {
          return CompletionItem.createBlankItem(context);
        }
        return item.withText(inputLines.slice(0, index).join("").trimEnd());
      }
    }
    return item;
  };
}

// src/postprocess/removeDuplicatedBlockClosingLine.ts
function removeDuplicatedBlockClosingLine() {
  return (item) => {
    const context = item.context;
    const { suffixLines, currentLinePrefix } = context;
    const inputLines = item.lines;
    if (inputLines.length < 2) {
      return item;
    }
    const inputLinesForDetection = inputLines.map((line, index) => {
      return index === 0 ? currentLinePrefix + line : line;
    });
    if (!isBlockClosingLine(inputLinesForDetection, inputLines.length - 1)) {
      return item;
    }
    const inputEndingLine = inputLines[inputLines.length - 1];
    let suffixBeginningIndex = 1;
    while (suffixBeginningIndex < suffixLines.length && isBlank(suffixLines[suffixBeginningIndex])) {
      suffixBeginningIndex++;
    }
    if (suffixBeginningIndex >= suffixLines.length) {
      return item;
    }
    const suffixBeginningLine = suffixLines[suffixBeginningIndex];
    if (inputEndingLine.startsWith(suffixBeginningLine.trimEnd()) || suffixBeginningLine.startsWith(inputEndingLine.trimEnd())) {
      logger.trace("Remove duplicated block closing line.", { inputLines, suffixLines });
      return item.withText(
        inputLines.slice(0, inputLines.length - 1).join("").trimEnd()
      );
    }
    return item;
  };
}

// src/postprocess/limitScopeByIndentation.ts
function parseIndentationContext(inputLines, inputLinesForDetection, context) {
  const result = {
    indentLevelLimit: 0,
    allowClosingLine: true
  };
  const { prefixLines, suffixLines, currentLinePrefix } = context;
  if (inputLines.length == 0 || prefixLines.length == 0) {
    return result;
  }
  const isCurrentLineInPrefixBlank = isBlank(currentLinePrefix);
  let referenceLineInPrefixIndex = prefixLines.length - 1;
  while (referenceLineInPrefixIndex >= 0 && isBlank(prefixLines[referenceLineInPrefixIndex])) {
    referenceLineInPrefixIndex--;
  }
  if (referenceLineInPrefixIndex < 0) {
    return result;
  }
  const referenceLineInPrefix = prefixLines[referenceLineInPrefixIndex];
  const referenceLineInPrefixIndent = getIndentationLevel(referenceLineInPrefix);
  const currentLineInCompletion = inputLines[0];
  const isCurrentLineInCompletionBlank = isBlank(currentLineInCompletion);
  let referenceLineInCompletionIndex = 0;
  while (referenceLineInCompletionIndex < inputLines.length && isBlank(inputLines[referenceLineInCompletionIndex])) {
    referenceLineInCompletionIndex++;
  }
  if (referenceLineInCompletionIndex >= inputLines.length) {
    return result;
  }
  const referenceLineInCompletion = inputLines[referenceLineInCompletionIndex];
  let referenceLineInCompletionIndent;
  if (isCurrentLineInCompletionBlank) {
    referenceLineInCompletionIndent = getIndentationLevel(referenceLineInCompletion);
  } else {
    referenceLineInCompletionIndent = getIndentationLevel(currentLinePrefix + referenceLineInCompletion);
  }
  if (!isCurrentLineInCompletionBlank && !isCurrentLineInPrefixBlank) {
    result.indentLevelLimit = referenceLineInPrefixIndent + 1;
    result.allowClosingLine &&= isBlockOpeningLine(inputLinesForDetection, 0);
  } else if (referenceLineInCompletionIndent > referenceLineInPrefixIndent) {
    result.indentLevelLimit = referenceLineInPrefixIndent + 1;
  } else if (referenceLineInCompletionIndent < referenceLineInPrefixIndent) {
    result.indentLevelLimit = referenceLineInPrefixIndent;
  } else {
    result.indentLevelLimit = referenceLineInPrefixIndent;
  }
  let firstNonBlankLineInSuffix = 1;
  while (firstNonBlankLineInSuffix < suffixLines.length && isBlank(suffixLines[firstNonBlankLineInSuffix])) {
    firstNonBlankLineInSuffix++;
  }
  if (firstNonBlankLineInSuffix < suffixLines.length) {
    const firstNonBlankLineInSuffixText = suffixLines[firstNonBlankLineInSuffix];
    result.allowClosingLine &&= getIndentationLevel(firstNonBlankLineInSuffixText) < result.indentLevelLimit;
  }
  return result;
}
function limitScopeByIndentation() {
  return (item) => {
    const { context, lines: inputLines } = item;
    const { prefixLines, suffixLines, currentLinePrefix } = context;
    const inputLinesForDetection = inputLines.map((line, index2) => {
      return index2 === 0 ? currentLinePrefix + line : line;
    });
    const indentContext = parseIndentationContext(inputLines, inputLinesForDetection, context);
    let index = 1;
    while (index < inputLines.length) {
      const line = inputLines[index];
      const prevLine = inputLines[index - 1];
      if (isBlank(line)) {
        index++;
        continue;
      }
      const indentLevel = getIndentationLevel(line);
      if (indentLevel < indentContext.indentLevelLimit) {
        if (isBlockClosingLine(inputLinesForDetection, index) && isBlockOpeningLine(inputLinesForDetection, index)) {
          index++;
          continue;
        }
        if (indentContext.allowClosingLine && (context.language !== "python" || !isBlank(prevLine))) {
          index++;
        }
        break;
      }
      index++;
    }
    if (index < inputLines.length) {
      logger.trace("Remove content out of indent scope.", {
        inputLines,
        prefixLines,
        suffixLines,
        trimAtInputLine: index
      });
      return item.withText(inputLines.slice(0, index).join("").trimEnd());
    }
    return item;
  };
}

// src/postprocess/limitScope.ts
function limitScope() {
  return async (item) => {
    return limitScopeByIndentation()(item);
  };
}

// src/postprocess/formatIndentation.ts
function detectIndentation(lines) {
  const matches = {
    "	": 0,
    "  ": 0,
    "    ": 0
  };
  for (const line of lines) {
    if (line.match(/^\t/)) {
      matches["	"]++;
    } else {
      const spaces = line.match(/^ */)?.[0].length ?? 0;
      if (spaces > 0) {
        if (spaces % 4 === 0) {
          matches["    "]++;
        }
        if (spaces % 2 === 0) {
          matches["  "]++;
        }
      }
    }
  }
  if (matches["	"] > 0) {
    return "	";
  }
  if (matches["  "] > matches["    "]) {
    return "  ";
  }
  if (matches["    "] > 0) {
    return "    ";
  }
  return null;
}
function getIndentLevel(line, indentation) {
  if (indentation === "	") {
    return line.match(/^\t*/)?.[0].length ?? 0;
  } else {
    const spaces = line.match(/^ */)?.[0].length ?? 0;
    return spaces / indentation.length;
  }
}
function formatIndentation() {
  return (item) => {
    const context = item.context;
    const { prefixLines, suffixLines, currentLinePrefix, indentation } = context;
    const inputLines = item.lines;
    if (!indentation) {
      return item;
    }
    const prefixLinesForDetection = isBlank(currentLinePrefix) ? prefixLines.slice(0, prefixLines.length - 1) : prefixLines;
    if (prefixLines.length > 1 && detectIndentation(prefixLinesForDetection) !== null) {
      return item;
    }
    const suffixLinesForDetection = suffixLines.slice(1);
    if (suffixLines.length > 1 && detectIndentation(suffixLinesForDetection) !== null) {
      return item;
    }
    const inputLinesForDetection = inputLines.map((line, index) => {
      return index === 0 ? currentLinePrefix + line : line;
    });
    const inputIndentation = detectIndentation(inputLinesForDetection);
    if (inputIndentation === null || inputIndentation === indentation) {
      return item;
    }
    const formatted = inputLinesForDetection.map((line, index) => {
      const level = getIndentLevel(line, inputIndentation);
      if (level === 0) {
        return inputLines[index];
      }
      const rest = line.slice(inputIndentation.length * level);
      if (index === 0) {
        if (!isBlank(currentLinePrefix)) {
          return inputLines[0];
        } else {
          return indentation.repeat(level).slice(currentLinePrefix.length) + rest;
        }
      } else {
        return indentation.repeat(level) + rest;
      }
    });
    logger.trace("Format indentation.", { inputLines, formatted });
    return item.withText(formatted.join(""));
  };
}

// src/postprocess/trimSpace.ts
function trimSpace() {
  return (item) => {
    const context = item.context;
    const { currentLinePrefix, currentLineSuffix } = context;
    let trimmedInput = item.text;
    if (!isBlank(currentLinePrefix) && currentLinePrefix.match(/\s$/)) {
      trimmedInput = trimmedInput.trimStart();
    }
    if (isBlank(currentLineSuffix) || !isBlank(currentLineSuffix) && currentLineSuffix.match(/^\s/)) {
      trimmedInput = trimmedInput.trimEnd();
    }
    if (trimmedInput !== item.text) {
      return item.withText(trimmedInput);
    }
    return item;
  };
}

// src/postprocess/trimMultiLineInSingleLineMode.ts
function trimMultiLineInSingleLineMode() {
  return (item) => {
    const context = item.context;
    const inputLines = item.lines;
    if (context.mode === "fill-in-line" && inputLines.length > 1) {
      const suffix = context.currentLineSuffix.trimEnd();
      const inputLine = inputLines[0].trimEnd();
      if (inputLine.endsWith(suffix)) {
        const trimmedInputLine = inputLine.slice(0, -suffix.length);
        if (trimmedInputLine.length > 0) {
          logger.trace("Trim content with multiple lines.", { inputLines, trimmedInputLine });
          return item.withText(trimmedInputLine);
        }
      }
      logger.trace("Drop content with multiple lines.", { inputLines });
      return CompletionItem.createBlankItem(context);
    }
    return item;
  };
}

// src/postprocess/dropDuplicated.ts
function dropDuplicated() {
  return (item) => {
    const context = item.context;
    const { suffixLines } = context;
    const inputLines = item.lines;
    let inputIndex = 0;
    while (inputIndex < inputLines.length && isBlank(inputLines[inputIndex])) {
      inputIndex++;
    }
    let suffixIndex = 0;
    while (suffixIndex < suffixLines.length && isBlank(suffixLines[suffixIndex])) {
      suffixIndex++;
    }
    const lineCount = Math.min(3, inputLines.length - inputIndex, suffixLines.length - suffixIndex);
    if (lineCount < 1) {
      return item;
    }
    const inputToCompare = inputLines.slice(inputIndex, inputIndex + lineCount).join("").trim();
    const suffixToCompare = suffixLines.slice(suffixIndex, suffixIndex + lineCount).join("").trim();
    const threshold = Math.max(1, 0.05 * inputToCompare.length, 0.05 * suffixToCompare.length);
    const distance = calcDistance(inputToCompare, suffixToCompare);
    if (distance <= threshold) {
      logger.trace("Drop completion due to duplicated.", { inputToCompare, suffixToCompare, distance, threshold });
      return CompletionItem.createBlankItem(context);
    }
    return item;
  };
}

// src/postprocess/dropBlank.ts
function dropBlank() {
  return (item) => {
    if (isBlank(item.fullText) || isBlank(item.text)) {
      return CompletionItem.createBlankItem(item.context);
    }
    return item;
  };
}

// src/postprocess/calculateReplaceRangeByBracketStack.ts
function calculateReplaceRangeByBracketStack(item) {
  const context = item.context;
  const { currentLineSuffix } = context;
  const suffixText = currentLineSuffix.trimEnd();
  if (isBlank(suffixText)) {
    return item;
  }
  const unpaired = findUnpairedAutoClosingChars(item.text).join("");
  if (isBlank(unpaired)) {
    return item;
  }
  let modified = void 0;
  if (suffixText.startsWith(unpaired)) {
    modified = item.withSuffix(unpaired);
  } else if (unpaired.startsWith(suffixText)) {
    modified = item.withSuffix(suffixText);
  }
  if (modified) {
    logger.trace("Adjust replace range by bracket stack.", {
      position: context.position,
      currentLineSuffix,
      completionText: item.text,
      unpaired,
      replaceSuffix: item.replaceSuffix
    });
    return modified;
  }
  return item;
}

// src/postprocess/calculateReplaceRange.ts
function calculateReplaceRange() {
  return async (item) => {
    return calculateReplaceRangeByBracketStack(item);
  };
}

// src/postprocess/index.ts
function createListFilter(filterFactory, config) {
  const filter = filterFactory(config);
  return async (items) => {
    return await items.mapAsync(filter);
  };
}
async function preCacheProcess(items, _config) {
  const applyFilter = (filterFactory) => {
    return createListFilter(filterFactory, _config);
  };
  return Promise.resolve(items).then(applyFilter(trimMultiLineInSingleLineMode)).then(applyFilter(removeLineEndsWithRepetition)).then(applyFilter(dropDuplicated)).then(applyFilter(trimSpace)).then(applyFilter(dropBlank));
}
async function postCacheProcess(items, _config) {
  const applyFilter = (filterFactory) => {
    return createListFilter(filterFactory, _config);
  };
  return Promise.resolve(items).then(applyFilter(removeRepetitiveBlocks)).then(applyFilter(removeRepetitiveLines)).then(applyFilter(limitScope)).then(applyFilter(removeDuplicatedBlockClosingLine)).then(applyFilter(formatIndentation)).then(applyFilter(dropDuplicated)).then(applyFilter(trimSpace)).then(applyFilter(dropBlank)).then(applyFilter(calculateReplaceRange));
}

// src/AnonymousUsageLogger.ts
var import_os4 = __toESM(require("os"));
var import_openapi_fetch2 = __toESM(require("openapi-fetch"));
var import_dot_prop2 = require("dot-prop");
var import_uuid = require("uuid");

// package.json
var name = "tabby-agent";
var version = "1.6.0-dev";

// src/AnonymousUsageLogger.ts
var AnonymousUsageLogger = class {
  constructor() {
    this.anonymousUsageTrackingApi = (0, import_openapi_fetch2.default)({ baseUrl: "https://app.tabbyml.com/api" });
    this.logger = getLogger("AnonymousUsage");
    this.systemData = {
      agent: `${name}, ${version}`,
      browser: isBrowser ? navigator?.userAgent || "browser" : void 0,
      node: isBrowser ? void 0 : `${process.version} ${process.platform} ${import_os4.default.arch()} ${import_os4.default.release()}`
    };
    this.sessionProperties = {};
    this.userProperties = {};
    this.userPropertiesUpdated = false;
    this.emittedUniqueEvent = [];
    this.disabled = false;
  }
  async init(options) {
    this.dataStore = options?.dataStore;
    if (this.dataStore) {
      if (typeof this.dataStore.data["anonymousId"] === "string") {
        this.anonymousId = this.dataStore.data["anonymousId"];
      } else {
        this.anonymousId = (0, import_uuid.v4)();
        this.dataStore.data["anonymousId"] = this.anonymousId;
        try {
          await this.dataStore.save();
        } catch (error) {
          this.logger.error("Failed to save anonymous Id.", error);
        }
      }
    } else {
      this.anonymousId = (0, import_uuid.v4)();
    }
  }
  /**
   * Set properties to be sent with every event in this session.
   */
  setSessionProperties(key, value) {
    (0, import_dot_prop2.setProperty)(this.sessionProperties, key, value);
  }
  /**
   * Set properties which will be bind to the user.
   */
  setUserProperties(key, value) {
    (0, import_dot_prop2.setProperty)(this.userProperties, key, value);
    this.userPropertiesUpdated = true;
  }
  async uniqueEvent(event, data = {}) {
    await this.event(event, data, true);
  }
  async event(event, data = {}, unique = false) {
    if (this.disabled || !this.anonymousId) {
      return;
    }
    if (unique && this.emittedUniqueEvent.includes(event)) {
      return;
    }
    if (unique) {
      this.emittedUniqueEvent.push(event);
    }
    const properties = {
      ...this.systemData,
      ...this.sessionProperties,
      ...data
    };
    if (this.userPropertiesUpdated) {
      (0, import_dot_prop2.setProperty)(properties, "$set", this.userProperties);
      this.userPropertiesUpdated = false;
    }
    try {
      await this.anonymousUsageTrackingApi.POST("/usage", {
        body: {
          distinctId: this.anonymousId,
          event,
          properties
        }
      });
    } catch (error) {
      this.logger.error("Failed to send anonymous usage data.", error);
    }
  }
};

// src/loadCaCerts.ts
var import_tls = __toESM(require("tls"));
var import_path5 = __toESM(require("path"));
var import_fs_extra3 = __toESM(require("fs-extra"));
var import_api = __toESM(require("win-ca/api"));
var macCa = __toESM(require("mac-ca"));
var logger2 = getLogger("CaCert");
var extraCaCerts = [];
var originalCreateSecureContext = void 0;
function appendCaCerts(certs) {
  if (!originalCreateSecureContext) {
    originalCreateSecureContext = import_tls.default.createSecureContext;
  }
  const filtered = certs.filter((cert) => {
    if (typeof cert === "string") {
      return cert.trim().length > 0;
    }
    return true;
  });
  const merged = [...extraCaCerts, ...filtered].distinct();
  logger2.debug(`Loaded ${merged.length - extraCaCerts.length} extra certs.`);
  extraCaCerts = merged;
  import_tls.default.createSecureContext = (options) => {
    const secureContext = originalCreateSecureContext(options);
    extraCaCerts.forEach((cert) => {
      secureContext.context.addCACert(cert);
    });
    return secureContext;
  };
}
async function loadFromFiles(files) {
  logger2.debug(`Loading extra certs from ${files}.`);
  const certs = (await files.split(import_path5.default.delimiter).mapAsync(async (cert) => {
    try {
      return (await import_fs_extra3.default.readFile(cert)).toString();
    } catch (err) {
      return null;
    }
  })).join("\n").split(/(?=-----BEGIN\sCERTIFICATE-----)/g).distinct();
  appendCaCerts(certs);
}
async function loadTlsCaCerts(options) {
  if (isBrowser) {
    return;
  }
  if (options.caCerts === "bundled") {
    return;
  } else if (options.caCerts === "system") {
    if (process.platform === "win32") {
      logger2.debug(`Loading extra certs from win-ca.`);
      import_api.default.exe(import_path5.default.join("win-ca", "roots.exe"));
      (0, import_api.default)({
        fallback: true,
        inject: "+"
      });
    } else if (process.platform === "darwin") {
      logger2.debug(`Loading extra certs from mac-ca.`);
      const certs = macCa.get();
      appendCaCerts(certs);
    } else {
      await loadFromFiles(import_path5.default.join("/etc/ssl/certs/ca-certificates.crt"));
    }
  } else if (options.caCerts) {
    await loadFromFiles(options.caCerts);
  }
}

// src/TabbyAgent.ts
var TabbyAgent = class _TabbyAgent extends import_events5.EventEmitter {
  constructor() {
    super();
    this.logger = getLogger("TabbyAgent");
    this.anonymousUsageLogger = new AnonymousUsageLogger();
    this.config = defaultAgentConfig;
    this.userConfig = {};
    // config from `~/.tabby-client/agent/config.toml`
    this.clientConfig = {};
    // config from `initialize` and `updateConfig` method
    this.serverProvidedConfig = {};
    // config fetched from server and saved in dataStore
    this.status = "notInitialized";
    this.issues = [];
    this.completionCache = new CompletionCache();
    this.completionDebounce = new CompletionDebounce();
    this.completionStats = new CompletionStats();
    this.completionRequestStats = new RequestStats();
    this.tryingConnectTimer = setInterval(async () => {
      if (this.status === "disconnected") {
        this.logger.debug("Trying to connect...");
        await this.healthCheck();
      }
    }, _TabbyAgent.tryConnectInterval);
    this.submitStatsTimer = setInterval(async () => {
      await this.submitStats();
    }, _TabbyAgent.submitStatsInterval);
  }
  static {
    this.tryConnectInterval = 1e3 * 30;
  }
  static {
    this.submitStatsInterval = 1e3 * 60 * 60 * 24;
  }
  async applyConfig() {
    this.logger.info("Applying updated config...");
    const oldConfig = this.config;
    const oldStatus = this.status;
    this.config = (0, import_deepmerge_ts.deepmerge)(
      defaultAgentConfig,
      this.userConfig,
      this.clientConfig,
      this.serverProvidedConfig
    );
    this.logger.trace("Updated config:", this.config);
    if (fileLogger) {
      fileLogger.level = this.config.logs.level;
    }
    this.anonymousUsageLogger.disabled = this.config.anonymousUsageTracking.disable;
    await loadTlsCaCerts(this.config.tls);
    if (isBlank(this.config.server.token) && this.config.server.requestHeaders["Authorization"] === void 0) {
      if (this.config.server.endpoint !== this.auth?.endpoint) {
        this.auth = new Auth(this.config.server.endpoint);
        await this.auth.init({ dataStore: this.dataStore });
        this.auth.on("updated", () => {
          this.setupApi();
        });
      }
    } else {
      this.auth = void 0;
    }
    if (!(0, import_deep_equal4.default)(oldConfig.server, this.config.server)) {
      this.serverHealthState = void 0;
      this.completionRequestStats.reset();
      this.popIssue("slowCompletionResponseTime");
      this.popIssue("highCompletionTimeoutRate");
      this.popIssue("connectionFailed");
      this.connectionErrorMessage = void 0;
    }
    if (!this.api || !(0, import_deep_equal4.default)(oldConfig.server, this.config.server)) {
      await this.setupApi();
    }
    this.logger.info("Completed applying updated config.");
    const event = { event: "configUpdated", config: this.config };
    super.emit("configUpdated", event);
    if (!(0, import_deep_equal4.default)(oldConfig.server, this.config.server) && oldStatus === "unauthorized" && this.status === "unauthorized") {
      this.emitAuthRequired();
    }
  }
  async setupApi() {
    const auth = !isBlank(this.config.server.token) ? `Bearer ${this.config.server.token}` : this.auth?.token ? `Bearer ${this.auth.token}` : void 0;
    this.api = (0, import_openapi_fetch3.default)({
      baseUrl: this.config.server.endpoint.replace(/\/+$/, ""),
      // remove trailing slash
      headers: {
        Authorization: auth,
        ...this.config.server.requestHeaders
      }
    });
    await this.healthCheck();
  }
  changeStatus(status) {
    if (this.status != status) {
      this.status = status;
      this.logger.info(`Status changed: ${status}.`);
      const event = { event: "statusChanged", status };
      super.emit("statusChanged", event);
      if (this.status === "unauthorized") {
        this.emitAuthRequired();
      }
    }
  }
  issueFromName(issueName) {
    switch (issueName) {
      case "highCompletionTimeoutRate":
        return {
          name: "highCompletionTimeoutRate",
          completionResponseStats: this.completionRequestStats.stats().stats
        };
      case "slowCompletionResponseTime":
        return {
          name: "slowCompletionResponseTime",
          completionResponseStats: this.completionRequestStats.stats().stats
        };
      case "connectionFailed":
        return {
          name: "connectionFailed",
          message: this.connectionErrorMessage
        };
    }
  }
  pushIssue(issue) {
    if (!this.issues.includes(issue)) {
      this.issues.push(issue);
      this.logger.info(`Issue created: ${issue}.`);
      this.emitIssueUpdated();
    }
  }
  popIssue(issue) {
    const index = this.issues.indexOf(issue);
    if (index >= 0) {
      this.issues.splice(index, 1);
      this.logger.info(`Issue removed: ${issue}.`);
      this.emitIssueUpdated();
    }
  }
  emitAuthRequired() {
    const event = { event: "authRequired", server: this.config.server };
    super.emit("authRequired", event);
  }
  emitIssueUpdated() {
    const event = { event: "issuesUpdated", issues: this.issues };
    super.emit("issuesUpdated", event);
  }
  async submitStats() {
    const stats = this.completionStats.stats();
    if (stats["completion_request"]["count"] > 0) {
      await this.anonymousUsageLogger.event("AgentStats", { stats });
      this.completionStats.reset();
    }
  }
  createAbortSignal(options) {
    const timeout = Math.min(2147483647, options?.timeout || this.config.server.requestTimeout);
    return abortSignalFromAnyOf([AbortSignal.timeout(timeout), options?.signal]);
  }
  async healthCheck(options) {
    const requestId = (0, import_uuid2.v4)();
    const requestPath = "/v1/health";
    const requestDescription = `${options?.method || "GET"} ${this.config.server.endpoint + requestPath}`;
    const requestOptions = {
      signal: this.createAbortSignal({ signal: options?.signal })
    };
    try {
      if (!this.api) {
        throw new Error("http client not initialized");
      }
      this.logger.debug(`Health check request: ${requestDescription}. [${requestId}]`);
      let response;
      if (options?.method === "POST") {
        response = await this.api.POST(requestPath, requestOptions);
      } else {
        response = await this.api.GET(requestPath, requestOptions);
      }
      this.logger.debug(`Health check response status: ${response.response.status}. [${requestId}]`);
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      this.logger.trace(`Health check response data: [${requestId}]`, response.data);
      const healthState = response.data;
      this.popIssue("connectionFailed");
      this.connectionErrorMessage = void 0;
      if (typeof healthState === "object" && healthState["model"] !== void 0 && healthState["device"] !== void 0) {
        this.serverHealthState = healthState;
        this.anonymousUsageLogger.uniqueEvent("AgentConnected", healthState);
        this.fetchServerProvidedConfig();
      }
      this.changeStatus("ready");
    } catch (error) {
      this.serverHealthState = void 0;
      if (error instanceof HttpError && error.status == 405 && options?.method !== "POST") {
        return await this.healthCheck({ method: "POST" });
      } else if (isUnauthorizedError(error)) {
        this.changeStatus("unauthorized");
      } else {
        if (isCanceledError(error)) {
          this.logger.debug(`Health check request canceled. [${requestId}]`);
          this.connectionErrorMessage = `${requestDescription} canceled.`;
        } else if (isTimeoutError(error)) {
          this.logger.error(`Health check request timed out. [${requestId}]`, error);
          this.connectionErrorMessage = `${requestDescription} timed out.`;
        } else {
          this.logger.error(`Health check request failed. [${requestId}]`, error);
          const message = error instanceof Error ? errorToString(error) : JSON.stringify(error);
          this.connectionErrorMessage = `${requestDescription} failed: 
${message}`;
        }
        this.pushIssue("connectionFailed");
        this.changeStatus("disconnected");
      }
    }
  }
  async fetchServerProvidedConfig() {
    const serverVersion = semver.coerce(this.serverHealthState?.version.git_describe);
    if (serverVersion && semver.lt(serverVersion, "0.9.0")) {
      this.logger.debug(`Skip fetching server provided config due to server version: ${serverVersion}.`);
      return;
    }
    const requestId = (0, import_uuid2.v4)();
    try {
      if (!this.api) {
        throw new Error("http client not initialized");
      }
      const requestPath = "/v1beta/server_setting";
      const requestDescription = `GET ${this.config.server.endpoint + requestPath}`;
      this.logger.debug(`Fetch server provided config request: ${requestDescription}. [${requestId}]`);
      const response = await this.api.GET(requestPath);
      this.logger.debug(`Fetch server provided config response status: ${response.response.status}. [${requestId}]`);
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      this.logger.trace(`Fetch server provided config response data: [${requestId}]`, response.data);
      const fetchedConfig = response.data;
      const serverProvidedConfig = {};
      if (fetchedConfig.disable_client_side_telemetry) {
        serverProvidedConfig.anonymousUsageTracking = {
          disable: true
        };
      }
      if (!(0, import_deep_equal4.default)(serverProvidedConfig, this.serverProvidedConfig)) {
        this.serverProvidedConfig = serverProvidedConfig;
        await this.applyConfig();
        if (this.dataStore) {
          if (!this.dataStore.data.serverConfig) {
            this.dataStore.data.serverConfig = {};
          }
          this.dataStore.data.serverConfig[this.config.server.endpoint] = this.serverProvidedConfig;
          try {
            await this.dataStore.save();
          } catch (error) {
            this.logger.error("Failed to save server provided config.", error);
          }
        }
      }
    } catch (error) {
      if (isUnauthorizedError(error)) {
        this.logger.debug(`Fetch server provided config request failed due to unauthorized. [${requestId}]`);
      } else if (error instanceof HttpError) {
        this.logger.error(`Fetch server provided config request failed. [${requestId}]`, error);
      }
    }
  }
  async initialize(options) {
    this.logger.info("Initializing...");
    this.logger.trace("Initialization options:", options);
    if (options.loggers) {
      logDestinations.attach(...options.loggers);
    }
    this.dataStore = options.dataStore ?? dataStore;
    if (this.dataStore) {
      try {
        await this.dataStore.load();
        if ("watch" in this.dataStore && typeof this.dataStore.watch === "function") {
          this.dataStore.watch();
        }
      } catch (error) {
        this.logger.error("Failed to load stored data.", error);
      }
    }
    await this.anonymousUsageLogger.init({ dataStore: this.dataStore });
    if (options.clientProperties) {
      if (options.clientProperties.session) {
        Object.entries(options.clientProperties.session).forEach(([key, value]) => {
          this.anonymousUsageLogger.setSessionProperties(key, value);
        });
      }
      if (options.clientProperties.user) {
        Object.entries(options.clientProperties.user).forEach(([key, value]) => {
          this.anonymousUsageLogger.setUserProperties(key, value);
        });
      }
    }
    if (configFile) {
      await configFile.load();
      this.userConfig = configFile.config;
      configFile.on("updated", async (config) => {
        this.userConfig = config;
        await this.applyConfig();
      });
      configFile.watch();
    }
    if (options.config) {
      this.clientConfig = options.config;
    }
    if (this.dataStore) {
      const localConfig = (0, import_deepmerge_ts.deepmerge)(defaultAgentConfig, this.userConfig, this.clientConfig);
      this.serverProvidedConfig = this.dataStore?.data.serverConfig?.[localConfig.server.endpoint] ?? {};
      if (this.dataStore instanceof import_events5.EventEmitter) {
        this.dataStore.on("updated", async () => {
          const localConfig2 = (0, import_deepmerge_ts.deepmerge)(defaultAgentConfig, this.userConfig, this.clientConfig);
          const storedServerConfig = dataStore?.data.serverConfig?.[localConfig2.server.endpoint];
          if (!(0, import_deep_equal4.default)(storedServerConfig, this.serverProvidedConfig)) {
            this.serverProvidedConfig = storedServerConfig ?? {};
            await this.applyConfig();
          }
        });
      }
    }
    await this.applyConfig();
    await this.anonymousUsageLogger.uniqueEvent("AgentInitialized");
    this.logger.info("Initialized.");
    return this.status !== "notInitialized";
  }
  async finalize() {
    if (this.status === "finalized") {
      return false;
    }
    this.logger.info(`Finalizing...`);
    await this.submitStats();
    if (this.tryingConnectTimer) {
      clearInterval(this.tryingConnectTimer);
    }
    if (this.submitStatsTimer) {
      clearInterval(this.submitStatsTimer);
    }
    this.changeStatus("finalized");
    this.logger.info(`Finalized.`);
    return true;
  }
  async updateClientProperties(type, key, value) {
    this.logger.trace(`Client properties updated.`, { type, key, value });
    switch (type) {
      case "session":
        this.anonymousUsageLogger.setSessionProperties(key, value);
        break;
      case "user":
        this.anonymousUsageLogger.setUserProperties(key, value);
        break;
    }
    return true;
  }
  async updateConfig(key, value) {
    this.logger.trace(`Config updated.`, { key, value });
    const current = (0, import_dot_prop3.getProperty)(this.clientConfig, key);
    if (!(0, import_deep_equal4.default)(current, value)) {
      if (value === void 0) {
        (0, import_dot_prop3.deleteProperty)(this.clientConfig, key);
      } else {
        (0, import_dot_prop3.setProperty)(this.clientConfig, key, value);
      }
      await this.applyConfig();
    }
    return true;
  }
  async clearConfig(key) {
    return await this.updateConfig(key, void 0);
  }
  getConfig() {
    return this.config;
  }
  getStatus() {
    return this.status;
  }
  getIssues() {
    return this.issues;
  }
  getIssueDetail(options) {
    const issues = this.getIssues();
    if (options.index !== void 0 && options.index < issues.length) {
      return this.issueFromName(issues[options.index]);
    } else if (options.name !== void 0 && this.issues.includes(options.name)) {
      return this.issueFromName(options.name);
    } else {
      return null;
    }
  }
  getServerHealthState() {
    return this.serverHealthState ?? null;
  }
  // @deprecated Tabby Cloud auth
  async requestAuthUrl(options) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    await this.healthCheck(options);
    if (this.status !== "unauthorized" || !this.auth) {
      return null;
    } else {
      return await this.auth.requestAuthUrl(options);
    }
  }
  // @deprecated Tabby Cloud auth
  async waitForAuthToken(code, options) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    if (this.status !== "unauthorized" || !this.auth) {
      return;
    }
    await this.auth.pollingToken(code, options);
    await this.setupApi();
  }
  async provideCompletions(request, options) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    this.logger.debug("Function providedCompletions called.");
    if (this.completionMutexAbortController) {
      const reason = new Error("Aborted due to new request.");
      reason.name = "AbortError";
      this.completionMutexAbortController.abort(reason);
    }
    this.completionMutexAbortController = new AbortController();
    const signal = abortSignalFromAnyOf([this.completionMutexAbortController.signal, options?.signal]);
    const context = new CompletionContext(request);
    if (!context.isValid()) {
      return emptyInlineCompletionList;
    }
    let solution = void 0;
    let cachedSolution = void 0;
    if (this.completionCache.has(context.hash)) {
      cachedSolution = this.completionCache.get(context.hash);
    }
    try {
      if (cachedSolution && (!request.manually || cachedSolution.isCompleted)) {
        await this.completionDebounce.debounce(
          {
            request,
            config: this.config.completion.debounce,
            responseTime: 0
          },
          { signal }
        );
        solution = cachedSolution.withContext(context);
        this.logger.info("Completion cache hit.");
      } else if (!request.manually) {
        await this.completionDebounce.debounce(
          {
            request,
            config: this.config.completion.debounce,
            responseTime: this.completionRequestStats.stats().stats.averageResponseTime
          },
          { signal }
        );
        solution = new CompletionSolution(context);
        this.logger.info(`Fetching completion...`);
        try {
          const response = await this.fetchCompletion(
            context.language,
            context.buildSegments(this.config.completion.prompt),
            void 0,
            signal
          );
          const completionItem = CompletionItem.createFromResponse(context, response);
          solution.add(...await preCacheProcess([completionItem], this.config.postprocess));
        } catch (error) {
          if (isCanceledError(error)) {
            this.logger.info(`Fetching completion canceled.`);
            solution = void 0;
          }
        }
      } else {
        solution = cachedSolution?.withContext(context) ?? new CompletionSolution(context);
        this.logger.info(`Fetching more completions...`);
        try {
          let tries = 0;
          while (solution.items.length < this.config.completion.solution.maxItems && tries < this.config.completion.solution.maxTries) {
            tries++;
            const response = await this.fetchCompletion(
              context.language,
              context.buildSegments(this.config.completion.prompt),
              this.config.completion.solution.temperature,
              signal
            );
            const completionItem = CompletionItem.createFromResponse(context, response);
            solution.add(...await preCacheProcess([completionItem], this.config.postprocess));
            if (signal.aborted) {
              throw signal.reason;
            }
          }
          solution.isCompleted = true;
        } catch (error) {
          if (isCanceledError(error)) {
            this.logger.info(`Fetching completion canceled.`);
            solution = void 0;
          }
        }
      }
      if (solution) {
        this.completionCache.update(solution);
        solution = solution.withItems(...await postCacheProcess(solution.items, this.config.postprocess));
        if (signal.aborted) {
          throw signal.reason;
        }
      }
    } catch (error) {
      if (!isCanceledError(error)) {
        this.logger.error(`Providing completions failed.`, error);
      }
    }
    if (solution) {
      const result = solution.toInlineCompletionList();
      this.logger.info(`Completed processing completions, choices returned: ${result.items.length}.`);
      this.logger.trace("Completion solution:", { result });
      return result;
    }
    return emptyInlineCompletionList;
  }
  async fetchCompletion(language, segments, temperature, signal) {
    const requestId = (0, import_uuid2.v4)();
    const stats = {
      latency: NaN,
      canceled: false,
      timeout: false,
      notAvailable: false
    };
    const requestStartedAt = performance.now();
    try {
      if (!this.api) {
        throw new Error("http client not initialized");
      }
      const requestPath = "/v1/completions";
      const requestOptions = {
        body: {
          language,
          segments,
          temperature
        },
        signal: this.createAbortSignal({ signal })
      };
      const requestDescription = `POST ${this.config.server.endpoint + requestPath}`;
      this.logger.debug(`Completion request: ${requestDescription}. [${requestId}]`);
      this.logger.trace(`Completion request body: [${requestId}]`, requestOptions.body);
      const response = await this.api.POST(requestPath, requestOptions);
      this.logger.debug(`Completion response status: ${response.response.status}. [${requestId}]`);
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      this.logger.trace(`Completion response data: [${requestId}]`, response.data);
      stats.latency = performance.now() - requestStartedAt;
      return response.data;
    } catch (error) {
      if (isCanceledError(error)) {
        this.logger.debug(`Completion request canceled. [${requestId}]`);
        stats.canceled = true;
      } else if (isTimeoutError(error)) {
        this.logger.debug(`Completion request timed out. [${requestId}]`);
        stats.timeout = true;
      } else if (isUnauthorizedError(error)) {
        this.logger.debug(`Completion request failed due to unauthorized. [${requestId}]`);
        stats.notAvailable = true;
        this.healthCheck();
      } else {
        this.logger.error(`Completion request failed. [${requestId}]`, error);
        stats.notAvailable = true;
        this.healthCheck();
      }
      throw error;
    } finally {
      if (!stats.notAvailable) {
        this.completionStats.addRequestStatsEntry(stats);
      }
      if (!stats.notAvailable && !stats.canceled) {
        this.completionRequestStats.add(stats.latency);
        const statsResult = this.completionRequestStats.stats();
        const checkResult = RequestStats.check(statsResult);
        switch (checkResult) {
          case "healthy":
            this.popIssue("slowCompletionResponseTime");
            this.popIssue("highCompletionTimeoutRate");
            break;
          case "highTimeoutRate":
            this.popIssue("slowCompletionResponseTime");
            this.pushIssue("highCompletionTimeoutRate");
            break;
          case "slowResponseTime":
            this.popIssue("highCompletionTimeoutRate");
            this.pushIssue("slowCompletionResponseTime");
            break;
        }
      }
    }
  }
  async postEvent(request, options) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    this.completionStats.addEvent(request.type);
    const requestId = (0, import_uuid2.v4)();
    try {
      if (!this.api) {
        throw new Error("http client not initialized");
      }
      const requestPath = "/v1/events";
      const requestOptions = {
        body: request,
        params: {
          query: {
            select_kind: request.select_kind
          }
        },
        signal: this.createAbortSignal(options),
        parseAs: "text"
      };
      const requestDescription = `POST ${this.config.server.endpoint + requestPath}`;
      this.logger.debug(`Event request: ${requestDescription}. [${requestId}]`);
      this.logger.trace(`Event request body: [${requestId}]`, requestOptions.body);
      const response = await this.api.POST(requestPath, requestOptions);
      this.logger.debug(`Event response status: ${response.response.status}. [${requestId}]`);
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      this.logger.trace(`Event response data: [${requestId}]`, response.data);
      return true;
    } catch (error) {
      if (isUnauthorizedError(error)) {
        this.logger.debug(`Completion request failed due to unauthorized. [${requestId}]`);
      } else {
        this.logger.error(`Event request failed. [${requestId}]`, error);
      }
      this.healthCheck();
      return false;
    }
  }
  async generateCommitMessage(diff, options) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    const { maxDiffLength, promptTemplate } = this.config.experimentalChat.generateCommitMessage;
    let splitDiffs;
    if (typeof diff === "string") {
      splitDiffs = diff.split(/\n(?=diff)/);
    } else {
      splitDiffs = diff;
    }
    let selectedDiff = "";
    for (const item of splitDiffs) {
      if (selectedDiff.length + item.length < maxDiffLength) {
        selectedDiff += item + "\n";
      }
    }
    if (isBlank(selectedDiff)) {
      if (typeof diff === "string") {
        selectedDiff = diff.substring(0, maxDiffLength);
      } else {
        selectedDiff = diff.join("\n").substring(0, maxDiffLength);
      }
    }
    if (isBlank(selectedDiff)) {
      return "";
    }
    const requestId = (0, import_uuid2.v4)();
    try {
      if (!this.api) {
        throw new Error("http client not initialized");
      }
      const requestPath = options?.useBetaVersion ? "/v1beta/chat/completions" : "/v1/chat/completions";
      const messages = [
        {
          role: "user",
          content: promptTemplate.replace("{{diff}}", selectedDiff)
        }
      ];
      const requestOptions = {
        body: { messages },
        signal: this.createAbortSignal(options),
        parseAs: "stream"
      };
      const requestDescription = `POST ${this.config.server.endpoint + requestPath}`;
      this.logger.debug(`Chat request: ${requestDescription}. [${requestId}]`);
      this.logger.trace(`Chat request body: [${requestId}]`, requestOptions.body);
      const response = await this.api.POST(requestPath, requestOptions);
      this.logger.debug(`Chat response status: ${response.response.status}. [${requestId}]`);
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      const responseMessage = await parseChatResponse(response.response, requestOptions.signal);
      this.logger.trace(`Chat response message: [${requestId}]`, { responseMessage });
      return responseMessage.trim();
    } catch (error) {
      if (error instanceof HttpError && error.status == 404 && !options?.useBetaVersion) {
        return await this.generateCommitMessage(diff, { ...options, useBetaVersion: true });
      }
      if (isUnauthorizedError(error)) {
        this.logger.debug(`Chat request failed due to unauthorized. [${requestId}]`);
      } else {
        this.logger.error(`Chat request failed. [${requestId}]`, error);
      }
      this.healthCheck();
    }
    return "";
  }
};

// src/Agent.ts
var agentEventNames = [
  "statusChanged",
  "configUpdated",
  "authRequired",
  "issuesUpdated"
];
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TabbyAgent,
  agentEventNames
});
//# sourceMappingURL=index.js.map