#!/usr/bin/env node
'use strict';

var HJ = require('events');
var P5 = require('crypto');
var Zy = require('path');
var xN = require('os');
var oq = require('tls');
var Cne = require('readline');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var HJ__default = /*#__PURE__*/_interopDefault(HJ);
var P5__default = /*#__PURE__*/_interopDefault(P5);
var Zy__default = /*#__PURE__*/_interopDefault(Zy);
var xN__default = /*#__PURE__*/_interopDefault(xN);
var oq__default = /*#__PURE__*/_interopDefault(oq);
var Cne__default = /*#__PURE__*/_interopDefault(Cne);

/**
 * Tabby Agent
 * https://github.com/tabbyml/tabby/tree/main/clients/tabby-agent
 * Copyright (c) 2023-2024 TabbyML, Inc.
 * Licensed under the Apache License 2.0.
 */
var w5=Object.create;var il=Object.defineProperty;var _5=Object.getOwnPropertyDescriptor;var T5=Object.getOwnPropertyNames;var A5=Object.getPrototypeOf,R5=Object.prototype.hasOwnProperty;var he=(e=>typeof require<"u"?require:typeof Proxy<"u"?new Proxy(e,{get:(t,r)=>(typeof require<"u"?require:t)[r]}):e)(function(e){if(typeof require<"u")return require.apply(this,arguments);throw Error('Dynamic require of "'+e+'" is not supported')}),pE=e=>t=>{var r=e[t];if(r)return r();throw new Error("Module not found in bundle: "+t)};var gE=(e,t)=>()=>(e&&(t=e(e=0)),t);var A=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),I5=(e,t)=>{for(var r in t)il(e,r,{get:t[r],enumerable:!0});},mE=(e,t,r,n)=>{if(t&&typeof t=="object"||typeof t=="function")for(let i of T5(t))!R5.call(e,i)&&i!==r&&il(e,i,{get:()=>t[i],enumerable:!(n=_5(t,i))||n.enumerable});return e};var cr=(e,t,r)=>(r=e!=null?w5(A5(e)):{},mE(t||!e||!e.__esModule?il(r,"default",{value:e,enumerable:!0}):r,e)),D5=e=>mE(il({},"__esModule",{value:!0}),e);var qp=A((roe,SE)=>{var vE=Object.prototype.toString;SE.exports=function(t){var r=vE.call(t),n=r==="[object Arguments]";return n||(n=r!=="[object Array]"&&t!==null&&typeof t=="object"&&typeof t.length=="number"&&t.length>=0&&vE.call(t.callee)==="[object Function]"),n};});var RE=A((noe,AE)=>{var TE;Object.keys||(uu=Object.prototype.hasOwnProperty,Fp=Object.prototype.toString,bE=qp(),Mp=Object.prototype.propertyIsEnumerable,CE=!Mp.call({toString:null},"toString"),EE=Mp.call(function(){},"prototype"),cu=["toString","toLocaleString","valueOf","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","constructor"],al=function(e){var t=e.constructor;return t&&t.prototype===e},xE={$applicationCache:!0,$console:!0,$external:!0,$frame:!0,$frameElement:!0,$frames:!0,$innerHeight:!0,$innerWidth:!0,$onmozfullscreenchange:!0,$onmozfullscreenerror:!0,$outerHeight:!0,$outerWidth:!0,$pageXOffset:!0,$pageYOffset:!0,$parent:!0,$scrollLeft:!0,$scrollTop:!0,$scrollX:!0,$scrollY:!0,$self:!0,$webkitIndexedDB:!0,$webkitStorageInfo:!0,$window:!0},wE=function(){if(typeof window>"u")return !1;for(var e in window)try{if(!xE["$"+e]&&uu.call(window,e)&&window[e]!==null&&typeof window[e]=="object")try{al(window[e]);}catch{return !0}}catch{return !0}return !1}(),_E=function(e){if(typeof window>"u"||!wE)return al(e);try{return al(e)}catch{return !1}},TE=function(t){var r=t!==null&&typeof t=="object",n=Fp.call(t)==="[object Function]",i=bE(t),s=r&&Fp.call(t)==="[object String]",o=[];if(!r&&!n&&!i)throw new TypeError("Object.keys called on a non-object");var a=EE&&n;if(s&&t.length>0&&!uu.call(t,0))for(var c=0;c<t.length;++c)o.push(String(c));if(i&&t.length>0)for(var l=0;l<t.length;++l)o.push(String(l));else for(var u in t)!(a&&u==="prototype")&&uu.call(t,u)&&o.push(String(u));if(CE)for(var f=_E(t),d=0;d<cu.length;++d)!(f&&cu[d]==="constructor")&&uu.call(t,cu[d])&&o.push(cu[d]);return o});var uu,Fp,bE,Mp,CE,EE,cu,al,xE,wE,_E;AE.exports=TE;});var cl=A((ioe,PE)=>{var L5=Array.prototype.slice,O5=qp(),IE=Object.keys,ul=IE?function(t){return IE(t)}:RE(),DE=Object.keys;ul.shim=function(){if(Object.keys){var t=function(){var r=Object.keys(arguments);return r&&r.length===arguments.length}(1,2);t||(Object.keys=function(n){return O5(n)?DE(L5.call(n)):DE(n)});}else Object.keys=ul;return Object.keys||ul};PE.exports=ul;});var ll=A((soe,kE)=>{kE.exports=function(){if(typeof Symbol!="function"||typeof Object.getOwnPropertySymbols!="function")return !1;if(typeof Symbol.iterator=="symbol")return !0;var t={},r=Symbol("test"),n=Object(r);if(typeof r=="string"||Object.prototype.toString.call(r)!=="[object Symbol]"||Object.prototype.toString.call(n)!=="[object Symbol]")return !1;var i=42;t[r]=i;for(r in t)return !1;if(typeof Object.keys=="function"&&Object.keys(t).length!==0||typeof Object.getOwnPropertyNames=="function"&&Object.getOwnPropertyNames(t).length!==0)return !1;var s=Object.getOwnPropertySymbols(t);if(s.length!==1||s[0]!==r||!Object.prototype.propertyIsEnumerable.call(t,r))return !1;if(typeof Object.getOwnPropertyDescriptor=="function"){var o=Object.getOwnPropertyDescriptor(t,r);if(o.value!==i||o.enumerable!==!0)return !1}return !0};});var Up=A((ooe,LE)=>{var NE=typeof Symbol<"u"&&Symbol,B5=ll();LE.exports=function(){return typeof NE!="function"||typeof Symbol!="function"||typeof NE("foo")!="symbol"||typeof Symbol("bar")!="symbol"?!1:B5()};});var qE=A((aoe,BE)=>{var OE={foo:{}},q5=Object;BE.exports=function(){return {__proto__:OE}.foo===OE.foo&&!({__proto__:null}instanceof q5)};});var UE=A((uoe,ME)=>{var F5="Function.prototype.bind called on incompatible ",M5=Object.prototype.toString,U5=Math.max,$5="[object Function]",FE=function(t,r){for(var n=[],i=0;i<t.length;i+=1)n[i]=t[i];for(var s=0;s<r.length;s+=1)n[s+t.length]=r[s];return n},j5=function(t,r){for(var n=[],i=r||0,s=0;i<t.length;i+=1,s+=1)n[s]=t[i];return n},V5=function(e,t){for(var r="",n=0;n<e.length;n+=1)r+=e[n],n+1<e.length&&(r+=t);return r};ME.exports=function(t){var r=this;if(typeof r!="function"||M5.apply(r)!==$5)throw new TypeError(F5+r);for(var n=j5(arguments,1),i,s=function(){if(this instanceof i){var u=r.apply(this,FE(n,arguments));return Object(u)===u?u:this}return r.apply(t,FE(n,arguments))},o=U5(0,r.length-n.length),a=[],c=0;c<o;c++)a[c]="$"+c;if(i=Function("binder","return function ("+V5(a,",")+"){ return binder.apply(this,arguments); }")(s),r.prototype){var l=function(){};l.prototype=r.prototype,i.prototype=new l,l.prototype=null;}return i};});var fl=A((coe,$E)=>{var H5=UE();$E.exports=Function.prototype.bind||H5;});var VE=A((loe,jE)=>{var W5=Function.prototype.call,K5=Object.prototype.hasOwnProperty,z5=fl();jE.exports=z5.call(W5,K5);});var Gn=A((foe,GE)=>{var lt,jo=SyntaxError,zE=Function,$o=TypeError,$p=function(e){try{return zE('"use strict"; return ('+e+").constructor;")()}catch{}},zs=Object.getOwnPropertyDescriptor;var jp=function(){throw new $o},G5=zs?function(){try{return jp}catch{try{return zs(arguments,"callee").get}catch{return jp}}}():jp,Mo=Up()(),Y5=qE()(),fr=Object.getPrototypeOf||(Y5?function(e){return e.__proto__}:null),Uo={},Q5=typeof Uint8Array>"u"||!fr?lt:fr(Uint8Array),Gs={"%AggregateError%":typeof AggregateError>"u"?lt:AggregateError,"%Array%":Array,"%ArrayBuffer%":typeof ArrayBuffer>"u"?lt:ArrayBuffer,"%ArrayIteratorPrototype%":Mo&&fr?fr([][Symbol.iterator]()):lt,"%AsyncFromSyncIteratorPrototype%":lt,"%AsyncFunction%":Uo,"%AsyncGenerator%":Uo,"%AsyncGeneratorFunction%":Uo,"%AsyncIteratorPrototype%":Uo,"%Atomics%":typeof Atomics>"u"?lt:Atomics,"%BigInt%":typeof BigInt>"u"?lt:BigInt,"%BigInt64Array%":typeof BigInt64Array>"u"?lt:BigInt64Array,"%BigUint64Array%":typeof BigUint64Array>"u"?lt:BigUint64Array,"%Boolean%":Boolean,"%DataView%":typeof DataView>"u"?lt:DataView,"%Date%":Date,"%decodeURI%":decodeURI,"%decodeURIComponent%":decodeURIComponent,"%encodeURI%":encodeURI,"%encodeURIComponent%":encodeURIComponent,"%Error%":Error,"%eval%":eval,"%EvalError%":EvalError,"%Float32Array%":typeof Float32Array>"u"?lt:Float32Array,"%Float64Array%":typeof Float64Array>"u"?lt:Float64Array,"%FinalizationRegistry%":typeof FinalizationRegistry>"u"?lt:FinalizationRegistry,"%Function%":zE,"%GeneratorFunction%":Uo,"%Int8Array%":typeof Int8Array>"u"?lt:Int8Array,"%Int16Array%":typeof Int16Array>"u"?lt:Int16Array,"%Int32Array%":typeof Int32Array>"u"?lt:Int32Array,"%isFinite%":isFinite,"%isNaN%":isNaN,"%IteratorPrototype%":Mo&&fr?fr(fr([][Symbol.iterator]())):lt,"%JSON%":typeof JSON=="object"?JSON:lt,"%Map%":typeof Map>"u"?lt:Map,"%MapIteratorPrototype%":typeof Map>"u"||!Mo||!fr?lt:fr(new Map()[Symbol.iterator]()),"%Math%":Math,"%Number%":Number,"%Object%":Object,"%parseFloat%":parseFloat,"%parseInt%":parseInt,"%Promise%":typeof Promise>"u"?lt:Promise,"%Proxy%":typeof Proxy>"u"?lt:Proxy,"%RangeError%":RangeError,"%ReferenceError%":ReferenceError,"%Reflect%":typeof Reflect>"u"?lt:Reflect,"%RegExp%":RegExp,"%Set%":typeof Set>"u"?lt:Set,"%SetIteratorPrototype%":typeof Set>"u"||!Mo||!fr?lt:fr(new Set()[Symbol.iterator]()),"%SharedArrayBuffer%":typeof SharedArrayBuffer>"u"?lt:SharedArrayBuffer,"%String%":String,"%StringIteratorPrototype%":Mo&&fr?fr(""[Symbol.iterator]()):lt,"%Symbol%":Mo?Symbol:lt,"%SyntaxError%":jo,"%ThrowTypeError%":G5,"%TypedArray%":Q5,"%TypeError%":$o,"%Uint8Array%":typeof Uint8Array>"u"?lt:Uint8Array,"%Uint8ClampedArray%":typeof Uint8ClampedArray>"u"?lt:Uint8ClampedArray,"%Uint16Array%":typeof Uint16Array>"u"?lt:Uint16Array,"%Uint32Array%":typeof Uint32Array>"u"?lt:Uint32Array,"%URIError%":URIError,"%WeakMap%":typeof WeakMap>"u"?lt:WeakMap,"%WeakRef%":typeof WeakRef>"u"?lt:WeakRef,"%WeakSet%":typeof WeakSet>"u"?lt:WeakSet};var X5=function e(t){var r;if(t==="%AsyncFunction%")r=$p("async function () {}");else if(t==="%GeneratorFunction%")r=$p("function* () {}");else if(t==="%AsyncGeneratorFunction%")r=$p("async function* () {}");else if(t==="%AsyncGenerator%"){var n=e("%AsyncGeneratorFunction%");n&&(r=n.prototype);}else if(t==="%AsyncIteratorPrototype%"){var i=e("%AsyncGenerator%");i&&fr&&(r=fr(i.prototype));}return Gs[t]=r,r},WE={"%ArrayBufferPrototype%":["ArrayBuffer","prototype"],"%ArrayPrototype%":["Array","prototype"],"%ArrayProto_entries%":["Array","prototype","entries"],"%ArrayProto_forEach%":["Array","prototype","forEach"],"%ArrayProto_keys%":["Array","prototype","keys"],"%ArrayProto_values%":["Array","prototype","values"],"%AsyncFunctionPrototype%":["AsyncFunction","prototype"],"%AsyncGenerator%":["AsyncGeneratorFunction","prototype"],"%AsyncGeneratorPrototype%":["AsyncGeneratorFunction","prototype","prototype"],"%BooleanPrototype%":["Boolean","prototype"],"%DataViewPrototype%":["DataView","prototype"],"%DatePrototype%":["Date","prototype"],"%ErrorPrototype%":["Error","prototype"],"%EvalErrorPrototype%":["EvalError","prototype"],"%Float32ArrayPrototype%":["Float32Array","prototype"],"%Float64ArrayPrototype%":["Float64Array","prototype"],"%FunctionPrototype%":["Function","prototype"],"%Generator%":["GeneratorFunction","prototype"],"%GeneratorPrototype%":["GeneratorFunction","prototype","prototype"],"%Int8ArrayPrototype%":["Int8Array","prototype"],"%Int16ArrayPrototype%":["Int16Array","prototype"],"%Int32ArrayPrototype%":["Int32Array","prototype"],"%JSONParse%":["JSON","parse"],"%JSONStringify%":["JSON","stringify"],"%MapPrototype%":["Map","prototype"],"%NumberPrototype%":["Number","prototype"],"%ObjectPrototype%":["Object","prototype"],"%ObjProto_toString%":["Object","prototype","toString"],"%ObjProto_valueOf%":["Object","prototype","valueOf"],"%PromisePrototype%":["Promise","prototype"],"%PromiseProto_then%":["Promise","prototype","then"],"%Promise_all%":["Promise","all"],"%Promise_reject%":["Promise","reject"],"%Promise_resolve%":["Promise","resolve"],"%RangeErrorPrototype%":["RangeError","prototype"],"%ReferenceErrorPrototype%":["ReferenceError","prototype"],"%RegExpPrototype%":["RegExp","prototype"],"%SetPrototype%":["Set","prototype"],"%SharedArrayBufferPrototype%":["SharedArrayBuffer","prototype"],"%StringPrototype%":["String","prototype"],"%SymbolPrototype%":["Symbol","prototype"],"%SyntaxErrorPrototype%":["SyntaxError","prototype"],"%TypedArrayPrototype%":["TypedArray","prototype"],"%TypeErrorPrototype%":["TypeError","prototype"],"%Uint8ArrayPrototype%":["Uint8Array","prototype"],"%Uint8ClampedArrayPrototype%":["Uint8ClampedArray","prototype"],"%Uint16ArrayPrototype%":["Uint16Array","prototype"],"%Uint32ArrayPrototype%":["Uint32Array","prototype"],"%URIErrorPrototype%":["URIError","prototype"],"%WeakMapPrototype%":["WeakMap","prototype"],"%WeakSetPrototype%":["WeakSet","prototype"]},lu=fl(),hl=VE(),J5=lu.call(Function.call,Array.prototype.concat),Z5=lu.call(Function.apply,Array.prototype.splice),KE=lu.call(Function.call,String.prototype.replace),dl=lu.call(Function.call,String.prototype.slice),e8=lu.call(Function.call,RegExp.prototype.exec),t8=/[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g,r8=/\\(\\)?/g,n8=function(t){var r=dl(t,0,1),n=dl(t,-1);if(r==="%"&&n!=="%")throw new jo("invalid intrinsic syntax, expected closing `%`");if(n==="%"&&r!=="%")throw new jo("invalid intrinsic syntax, expected opening `%`");var i=[];return KE(t,t8,function(s,o,a,c){i[i.length]=a?KE(c,r8,"$1"):o||s;}),i},i8=function(t,r){var n=t,i;if(hl(WE,n)&&(i=WE[n],n="%"+i[0]+"%"),hl(Gs,n)){var s=Gs[n];if(s===Uo&&(s=X5(n)),typeof s>"u"&&!r)throw new $o("intrinsic "+t+" exists, but is not available. Please file an issue!");return {alias:i,name:n,value:s}}throw new jo("intrinsic "+t+" does not exist!")};GE.exports=function(t,r){if(typeof t!="string"||t.length===0)throw new $o("intrinsic name must be a non-empty string");if(arguments.length>1&&typeof r!="boolean")throw new $o('"allowMissing" argument must be a boolean');if(e8(/^%?[^%]*%?$/,t)===null)throw new jo("`%` may not be present anywhere but at the beginning and end of the intrinsic name");var n=n8(t),i=n.length>0?n[0]:"",s=i8("%"+i+"%",r),o=s.name,a=s.value,c=!1,l=s.alias;l&&(i=l[0],Z5(n,J5([0,1],l)));for(var u=1,f=!0;u<n.length;u+=1){var d=n[u],p=dl(d,0,1),m=dl(d,-1);if((p==='"'||p==="'"||p==="`"||m==='"'||m==="'"||m==="`")&&p!==m)throw new jo("property names with quotes must have matching quotes");if((d==="constructor"||!f)&&(c=!0),i+="."+d,o="%"+i+"%",hl(Gs,o))a=Gs[o];else if(a!=null){if(!(d in a)){if(!r)throw new $o("base intrinsic for "+t+" exists, but the property is not available.");return}if(zs&&u+1>=n.length){var S=zs(a,d);f=!!S,f&&"get"in S&&!("originalValue"in S.get)?a=S.get:a=a[d];}else f=hl(a,d),a=a[d];f&&!c&&(Gs[o]=a);}}return a};});var fu=A((hoe,YE)=>{var s8=Gn(),Vp=s8("%Object.defineProperty%",!0),Hp=function(){if(Vp)try{return Vp({},"a",{value:1}),!0}catch{return !1}return !1};Hp.hasArrayLengthDefineBug=function(){if(!Hp())return null;try{return Vp([],"length",{value:1}).length!==1}catch{return !0}};YE.exports=Hp;});var gl=A((doe,QE)=>{var o8=Gn(),pl=o8("%Object.getOwnPropertyDescriptor%",!0);if(pl)try{pl([],"length");}catch{pl=null;}QE.exports=pl;});var ml=A((poe,JE)=>{var a8=fu()(),Wp=Gn(),hu=a8&&Wp("%Object.defineProperty%",!0);if(hu)try{hu({},"a",{value:1});}catch{hu=!1;}var u8=Wp("%SyntaxError%"),Vo=Wp("%TypeError%"),XE=gl();JE.exports=function(t,r,n){if(!t||typeof t!="object"&&typeof t!="function")throw new Vo("`obj` must be an object or a function`");if(typeof r!="string"&&typeof r!="symbol")throw new Vo("`property` must be a string or a symbol`");if(arguments.length>3&&typeof arguments[3]!="boolean"&&arguments[3]!==null)throw new Vo("`nonEnumerable`, if provided, must be a boolean or null");if(arguments.length>4&&typeof arguments[4]!="boolean"&&arguments[4]!==null)throw new Vo("`nonWritable`, if provided, must be a boolean or null");if(arguments.length>5&&typeof arguments[5]!="boolean"&&arguments[5]!==null)throw new Vo("`nonConfigurable`, if provided, must be a boolean or null");if(arguments.length>6&&typeof arguments[6]!="boolean")throw new Vo("`loose`, if provided, must be a boolean");var i=arguments.length>3?arguments[3]:null,s=arguments.length>4?arguments[4]:null,o=arguments.length>5?arguments[5]:null,a=arguments.length>6?arguments[6]:!1,c=!!XE&&XE(t,r);if(hu)hu(t,r,{configurable:o===null&&c?c.configurable:!o,enumerable:i===null&&c?c.enumerable:!i,value:n,writable:s===null&&c?c.writable:!s});else if(a||!i&&!s&&!o)t[r]=n;else throw new u8("This environment does not support defining a property as non-configurable, non-writable, or non-enumerable.")};});var ns=A((goe,r1)=>{var c8=cl(),l8=typeof Symbol=="function"&&typeof Symbol("foo")=="symbol",f8=Object.prototype.toString,h8=Array.prototype.concat,ZE=ml(),d8=function(e){return typeof e=="function"&&f8.call(e)==="[object Function]"},e1=fu()(),p8=function(e,t,r,n){if(t in e){if(n===!0){if(e[t]===r)return}else if(!d8(n)||!n())return}e1?ZE(e,t,r,!0):ZE(e,t,r);},t1=function(e,t){var r=arguments.length>2?arguments[2]:{},n=c8(t);l8&&(n=h8.call(n,Object.getOwnPropertySymbols(t)));for(var i=0;i<n.length;i+=1)p8(e,n[i],t[n[i]],r[n[i]]);};t1.supportsDescriptors=!!e1;r1.exports=t1;});var u1=A((moe,a1)=>{var o1=Gn(),n1=ml(),g8=fu()(),i1=gl(),s1=o1("%TypeError%"),m8=o1("%Math.floor%");a1.exports=function(t,r){if(typeof t!="function")throw new s1("`fn` is not a function");if(typeof r!="number"||r<0||r>4294967295||m8(r)!==r)throw new s1("`length` must be a positive 32-bit integer");var n=arguments.length>2&&!!arguments[2],i=!0,s=!0;if("length"in t&&i1){var o=i1(t,"length");o&&!o.configurable&&(i=!1),o&&!o.writable&&(s=!1);}return (i||s||!n)&&(g8?n1(t,"length",r,!0,!0):n1(t,"length",r)),t};});var Ys=A((yoe,yl)=>{var Kp=fl(),Ho=Gn(),y8=u1(),v8=Ho("%TypeError%"),l1=Ho("%Function.prototype.apply%"),f1=Ho("%Function.prototype.call%"),h1=Ho("%Reflect.apply%",!0)||Kp.call(f1,l1),du=Ho("%Object.defineProperty%",!0),S8=Ho("%Math.max%");if(du)try{du({},"a",{value:1});}catch{du=null;}yl.exports=function(t){if(typeof t!="function")throw new v8("a function is required");var r=h1(Kp,f1,arguments);return y8(r,1+S8(0,t.length-(arguments.length-1)),!0)};var c1=function(){return h1(Kp,l1,arguments)};du?du(yl.exports,"apply",{value:c1}):yl.exports.apply=c1;});var In=A((voe,g1)=>{var d1=Gn(),p1=Ys(),b8=p1(d1("String.prototype.indexOf"));g1.exports=function(t,r){var n=d1(t,!!r);return typeof n=="function"&&b8(t,".prototype.")>-1?p1(n):n};});var zp=A((Soe,b1)=>{var C8=cl(),v1=ll()(),S1=In(),m1=Object,E8=S1("Array.prototype.push"),y1=S1("Object.prototype.propertyIsEnumerable"),x8=v1?Object.getOwnPropertySymbols:null;b1.exports=function(t,r){if(t==null)throw new TypeError("target must be an object");var n=m1(t);if(arguments.length===1)return n;for(var i=1;i<arguments.length;++i){var s=m1(arguments[i]),o=C8(s),a=v1&&(Object.getOwnPropertySymbols||x8);if(a)for(var c=a(s),l=0;l<c.length;++l){var u=c[l];y1(s,u)&&E8(o,u);}for(var f=0;f<o.length;++f){var d=o[f];if(y1(s,d)){var p=s[d];n[d]=p;}}}return n};});var Yp=A((boe,C1)=>{var Gp=zp(),w8=function(){if(!Object.assign)return !1;for(var e="abcdefghijklmnopqrst",t=e.split(""),r={},n=0;n<t.length;++n)r[t[n]]=t[n];var i=Object.assign({},r),s="";for(var o in i)s+=o;return e!==s},_8=function(){if(!Object.assign||!Object.preventExtensions)return !1;var e=Object.preventExtensions({1:2});try{Object.assign(e,"xy");}catch{return e[1]==="y"}return !1};C1.exports=function(){return !Object.assign||w8()||_8()?Gp:Object.assign};});var x1=A((Coe,E1)=>{var T8=ns(),A8=Yp();E1.exports=function(){var t=A8();return T8(Object,{assign:t},{assign:function(){return Object.assign!==t}}),t};});var A1=A((Eoe,T1)=>{var R8=ns(),I8=Ys(),D8=zp(),w1=Yp(),P8=x1(),k8=I8.apply(w1()),_1=function(t,r){return k8(Object,arguments)};R8(_1,{getPolyfill:w1,implementation:D8,shim:P8});T1.exports=_1;});var I1=A((xoe,R1)=>{var gu=function(){return typeof function(){}.name=="string"},pu=Object.getOwnPropertyDescriptor;gu.functionsHaveConfigurableNames=function(){if(!gu()||!pu)return !1;var t=pu(function(){},"name");return !!t&&!!t.configurable};var N8=Function.prototype.bind;gu.boundFunctionsHaveNames=function(){return gu()&&typeof N8=="function"&&function(){}.bind().name!==""};R1.exports=gu;});var k1=A((woe,P1)=>{var D1=ml(),L8=fu()(),O8=I1().functionsHaveConfigurableNames(),B8=TypeError;P1.exports=function(t,r){if(typeof t!="function")throw new B8("`fn` is not a function");var n=arguments.length>2&&!!arguments[2];return (!n||O8)&&(L8?D1(t,"name",r,!0,!0):D1(t,"name",r)),t};});var Qp=A((_oe,N1)=>{var q8=k1(),F8=Object,M8=TypeError;N1.exports=q8(function(){if(this!=null&&this!==F8(this))throw new M8("RegExp.prototype.flags getter called on non-object");var t="";return this.hasIndices&&(t+="d"),this.global&&(t+="g"),this.ignoreCase&&(t+="i"),this.multiline&&(t+="m"),this.dotAll&&(t+="s"),this.unicode&&(t+="u"),this.unicodeSets&&(t+="v"),this.sticky&&(t+="y"),t},"get flags",!0);});var Xp=A((Toe,L1)=>{var U8=Qp(),$8=ns().supportsDescriptors,j8=Object.getOwnPropertyDescriptor;L1.exports=function(){if($8&&/a/mig.flags==="gim"){var t=j8(RegExp.prototype,"flags");if(t&&typeof t.get=="function"&&typeof RegExp.prototype.dotAll=="boolean"&&typeof RegExp.prototype.hasIndices=="boolean"){var r="",n={};if(Object.defineProperty(n,"hasIndices",{get:function(){r+="d";}}),Object.defineProperty(n,"sticky",{get:function(){r+="y";}}),r==="dy")return t.get}}return U8};});var q1=A((Aoe,B1)=>{var V8=ns().supportsDescriptors,H8=Xp(),W8=Object.getOwnPropertyDescriptor,K8=Object.defineProperty,z8=TypeError,O1=Object.getPrototypeOf,G8=/a/;B1.exports=function(){if(!V8||!O1)throw new z8("RegExp.prototype.flags requires a true ES5 environment that supports property descriptors");var t=H8(),r=O1(G8),n=W8(r,"flags");return (!n||n.get!==t)&&K8(r,"flags",{configurable:!0,enumerable:!1,get:t}),t};});var $1=A((Roe,U1)=>{var Y8=ns(),Q8=Ys(),X8=Qp(),F1=Xp(),J8=q1(),M1=Q8(F1());Y8(M1,{getPolyfill:F1,implementation:X8,shim:J8});U1.exports=M1;});var H1=A((Ioe,V1)=>{var j1=Symbol.iterator;V1.exports=function(t){if(t!=null&&typeof t[j1]<"u")return t[j1]()};});var K1=A((Doe,W1)=>{W1.exports=he("util").inspect;});var hx=A((Poe,fx)=>{var ag=typeof Map=="function"&&Map.prototype,Jp=Object.getOwnPropertyDescriptor&&ag?Object.getOwnPropertyDescriptor(Map.prototype,"size"):null,Sl=ag&&Jp&&typeof Jp.get=="function"?Jp.get:null,z1=ag&&Map.prototype.forEach,ug=typeof Set=="function"&&Set.prototype,Zp=Object.getOwnPropertyDescriptor&&ug?Object.getOwnPropertyDescriptor(Set.prototype,"size"):null,bl=ug&&Zp&&typeof Zp.get=="function"?Zp.get:null,G1=ug&&Set.prototype.forEach,Z8=typeof WeakMap=="function"&&WeakMap.prototype,yu=Z8?WeakMap.prototype.has:null,eU=typeof WeakSet=="function"&&WeakSet.prototype,vu=eU?WeakSet.prototype.has:null,tU=typeof WeakRef=="function"&&WeakRef.prototype,Y1=tU?WeakRef.prototype.deref:null,rU=Boolean.prototype.valueOf,nU=Object.prototype.toString,iU=Function.prototype.toString,sU=String.prototype.match,cg=String.prototype.slice,ss=String.prototype.replace,oU=String.prototype.toUpperCase,Q1=String.prototype.toLowerCase,sx=RegExp.prototype.test,X1=Array.prototype.concat,ci=Array.prototype.join,aU=Array.prototype.slice,J1=Math.floor,rg=typeof BigInt=="function"?BigInt.prototype.valueOf:null,eg=Object.getOwnPropertySymbols,ng=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?Symbol.prototype.toString:null,Wo=typeof Symbol=="function"&&typeof Symbol.iterator=="object",kr=typeof Symbol=="function"&&Symbol.toStringTag&&(typeof Symbol.toStringTag===Wo||!0)?Symbol.toStringTag:null,ox=Object.prototype.propertyIsEnumerable,Z1=(typeof Reflect=="function"?Reflect.getPrototypeOf:Object.getPrototypeOf)||([].__proto__===Array.prototype?function(e){return e.__proto__}:null);function ex(e,t){if(e===1/0||e===-1/0||e!==e||e&&e>-1e3&&e<1e3||sx.call(/e/,t))return t;var r=/[0-9](?=(?:[0-9]{3})+(?![0-9]))/g;if(typeof e=="number"){var n=e<0?-J1(-e):J1(e);if(n!==e){var i=String(n),s=cg.call(t,i.length+1);return ss.call(i,r,"$&_")+"."+ss.call(ss.call(s,/([0-9]{3})/g,"$&_"),/_$/,"")}}return ss.call(t,r,"$&_")}var ig=K1(),tx=ig.custom,rx=ux(tx)?tx:null;fx.exports=function e(t,r,n,i){var s=r||{};if(is(s,"quoteStyle")&&s.quoteStyle!=="single"&&s.quoteStyle!=="double")throw new TypeError('option "quoteStyle" must be "single" or "double"');if(is(s,"maxStringLength")&&(typeof s.maxStringLength=="number"?s.maxStringLength<0&&s.maxStringLength!==1/0:s.maxStringLength!==null))throw new TypeError('option "maxStringLength", if provided, must be a positive integer, Infinity, or `null`');var o=is(s,"customInspect")?s.customInspect:!0;if(typeof o!="boolean"&&o!=="symbol")throw new TypeError("option \"customInspect\", if provided, must be `true`, `false`, or `'symbol'`");if(is(s,"indent")&&s.indent!==null&&s.indent!=="	"&&!(parseInt(s.indent,10)===s.indent&&s.indent>0))throw new TypeError('option "indent" must be "\\t", an integer > 0, or `null`');if(is(s,"numericSeparator")&&typeof s.numericSeparator!="boolean")throw new TypeError('option "numericSeparator", if provided, must be `true` or `false`');var a=s.numericSeparator;if(typeof t>"u")return "undefined";if(t===null)return "null";if(typeof t=="boolean")return t?"true":"false";if(typeof t=="string")return lx(t,s);if(typeof t=="number"){if(t===0)return 1/0/t>0?"0":"-0";var c=String(t);return a?ex(t,c):c}if(typeof t=="bigint"){var l=String(t)+"n";return a?ex(t,l):l}var u=typeof s.depth>"u"?5:s.depth;if(typeof n>"u"&&(n=0),n>=u&&u>0&&typeof t=="object")return sg(t)?"[Array]":"[Object]";var f=_U(s,n);if(typeof i>"u")i=[];else if(cx(i,t)>=0)return "[Circular]";function d(me,Le,H){if(Le&&(i=aU.call(i),i.push(Le)),H){var W={depth:s.depth};return is(s,"quoteStyle")&&(W.quoteStyle=s.quoteStyle),e(me,W,n+1,i)}return e(me,s,n+1,i)}if(typeof t=="function"&&!nx(t)){var p=mU(t),m=vl(t,d);return "[Function"+(p?": "+p:" (anonymous)")+"]"+(m.length>0?" { "+ci.call(m,", ")+" }":"")}if(ux(t)){var S=Wo?ss.call(String(t),/^(Symbol\(.*\))_[^)]*$/,"$1"):ng.call(t);return typeof t=="object"&&!Wo?mu(S):S}if(EU(t)){for(var x="<"+Q1.call(String(t.nodeName)),I=t.attributes||[],v=0;v<I.length;v++)x+=" "+I[v].name+"="+ax(uU(I[v].value),"double",s);return x+=">",t.childNodes&&t.childNodes.length&&(x+="..."),x+="</"+Q1.call(String(t.nodeName))+">",x}if(sg(t)){if(t.length===0)return "[]";var b=vl(t,d);return f&&!wU(b)?"["+og(b,f)+"]":"[ "+ci.call(b,", ")+" ]"}if(lU(t)){var D=vl(t,d);return !("cause"in Error.prototype)&&"cause"in t&&!ox.call(t,"cause")?"{ ["+String(t)+"] "+ci.call(X1.call("[cause]: "+d(t.cause),D),", ")+" }":D.length===0?"["+String(t)+"]":"{ ["+String(t)+"] "+ci.call(D,", ")+" }"}if(typeof t=="object"&&o){if(rx&&typeof t[rx]=="function"&&ig)return ig(t,{depth:u-n});if(o!=="symbol"&&typeof t.inspect=="function")return t.inspect()}if(yU(t)){var L=[];return z1&&z1.call(t,function(me,Le){L.push(d(Le,t,!0)+" => "+d(me,t));}),ix("Map",Sl.call(t),L,f)}if(bU(t)){var j=[];return G1&&G1.call(t,function(me){j.push(d(me,t));}),ix("Set",bl.call(t),j,f)}if(vU(t))return tg("WeakMap");if(CU(t))return tg("WeakSet");if(SU(t))return tg("WeakRef");if(hU(t))return mu(d(Number(t)));if(pU(t))return mu(d(rg.call(t)));if(dU(t))return mu(rU.call(t));if(fU(t))return mu(d(String(t)));if(typeof window<"u"&&t===window)return "{ [object Window] }";if(t===global)return "{ [object globalThis] }";if(!cU(t)&&!nx(t)){var J=vl(t,d),K=Z1?Z1(t)===Object.prototype:t instanceof Object||t.constructor===Object,G=t instanceof Object?"":"null prototype",ee=!K&&kr&&Object(t)===t&&kr in t?cg.call(os(t),8,-1):G?"Object":"",M=K||typeof t.constructor!="function"?"":t.constructor.name?t.constructor.name+" ":"",ae=M+(ee||G?"["+ci.call(X1.call([],ee||[],G||[]),": ")+"] ":"");return J.length===0?ae+"{}":f?ae+"{"+og(J,f)+"}":ae+"{ "+ci.call(J,", ")+" }"}return String(t)};function ax(e,t,r){var n=(r.quoteStyle||t)==="double"?'"':"'";return n+e+n}function uU(e){return ss.call(String(e),/"/g,"&quot;")}function sg(e){return os(e)==="[object Array]"&&(!kr||!(typeof e=="object"&&kr in e))}function cU(e){return os(e)==="[object Date]"&&(!kr||!(typeof e=="object"&&kr in e))}function nx(e){return os(e)==="[object RegExp]"&&(!kr||!(typeof e=="object"&&kr in e))}function lU(e){return os(e)==="[object Error]"&&(!kr||!(typeof e=="object"&&kr in e))}function fU(e){return os(e)==="[object String]"&&(!kr||!(typeof e=="object"&&kr in e))}function hU(e){return os(e)==="[object Number]"&&(!kr||!(typeof e=="object"&&kr in e))}function dU(e){return os(e)==="[object Boolean]"&&(!kr||!(typeof e=="object"&&kr in e))}function ux(e){if(Wo)return e&&typeof e=="object"&&e instanceof Symbol;if(typeof e=="symbol")return !0;if(!e||typeof e!="object"||!ng)return !1;try{return ng.call(e),!0}catch{}return !1}function pU(e){if(!e||typeof e!="object"||!rg)return !1;try{return rg.call(e),!0}catch{}return !1}var gU=Object.prototype.hasOwnProperty||function(e){return e in this};function is(e,t){return gU.call(e,t)}function os(e){return nU.call(e)}function mU(e){if(e.name)return e.name;var t=sU.call(iU.call(e),/^function\s*([\w$]+)/);return t?t[1]:null}function cx(e,t){if(e.indexOf)return e.indexOf(t);for(var r=0,n=e.length;r<n;r++)if(e[r]===t)return r;return -1}function yU(e){if(!Sl||!e||typeof e!="object")return !1;try{Sl.call(e);try{bl.call(e);}catch{return !0}return e instanceof Map}catch{}return !1}function vU(e){if(!yu||!e||typeof e!="object")return !1;try{yu.call(e,yu);try{vu.call(e,vu);}catch{return !0}return e instanceof WeakMap}catch{}return !1}function SU(e){if(!Y1||!e||typeof e!="object")return !1;try{return Y1.call(e),!0}catch{}return !1}function bU(e){if(!bl||!e||typeof e!="object")return !1;try{bl.call(e);try{Sl.call(e);}catch{return !0}return e instanceof Set}catch{}return !1}function CU(e){if(!vu||!e||typeof e!="object")return !1;try{vu.call(e,vu);try{yu.call(e,yu);}catch{return !0}return e instanceof WeakSet}catch{}return !1}function EU(e){return !e||typeof e!="object"?!1:typeof HTMLElement<"u"&&e instanceof HTMLElement?!0:typeof e.nodeName=="string"&&typeof e.getAttribute=="function"}function lx(e,t){if(e.length>t.maxStringLength){var r=e.length-t.maxStringLength,n="... "+r+" more character"+(r>1?"s":"");return lx(cg.call(e,0,t.maxStringLength),t)+n}var i=ss.call(ss.call(e,/(['\\])/g,"\\$1"),/[\x00-\x1f]/g,xU);return ax(i,"single",t)}function xU(e){var t=e.charCodeAt(0),r={8:"b",9:"t",10:"n",12:"f",13:"r"}[t];return r?"\\"+r:"\\x"+(t<16?"0":"")+oU.call(t.toString(16))}function mu(e){return "Object("+e+")"}function tg(e){return e+" { ? }"}function ix(e,t,r,n){var i=n?og(r,n):ci.call(r,", ");return e+" ("+t+") {"+i+"}"}function wU(e){for(var t=0;t<e.length;t++)if(cx(e[t],`
`)>=0)return !1;return !0}function _U(e,t){var r;if(e.indent==="	")r="	";else if(typeof e.indent=="number"&&e.indent>0)r=ci.call(Array(e.indent+1)," ");else return null;return {base:r,prev:ci.call(Array(t+1),r)}}function og(e,t){if(e.length===0)return "";var r=`
`+t.prev+t.base;return r+ci.call(e,","+r)+`
`+t.prev}function vl(e,t){var r=sg(e),n=[];if(r){n.length=e.length;for(var i=0;i<e.length;i++)n[i]=is(e,i)?t(e[i],e):"";}var s=typeof eg=="function"?eg(e):[],o;if(Wo){o={};for(var a=0;a<s.length;a++)o["$"+s[a]]=s[a];}for(var c in e)is(e,c)&&(r&&String(Number(c))===c&&c<e.length||Wo&&o["$"+c]instanceof Symbol||(sx.call(/[^\w$]/,c)?n.push(t(c,e)+": "+t(e[c],e)):n.push(c+": "+t(e[c],e))));if(typeof eg=="function")for(var l=0;l<s.length;l++)ox.call(e,s[l])&&n.push("["+t(s[l])+"]: "+t(e[s[l]],e));return n}});var px=A((koe,dx)=>{var lg=Gn(),Ko=In(),TU=hx(),AU=lg("%TypeError%"),Cl=lg("%WeakMap%",!0),El=lg("%Map%",!0),RU=Ko("WeakMap.prototype.get",!0),IU=Ko("WeakMap.prototype.set",!0),DU=Ko("WeakMap.prototype.has",!0),PU=Ko("Map.prototype.get",!0),kU=Ko("Map.prototype.set",!0),NU=Ko("Map.prototype.has",!0),fg=function(e,t){for(var r=e,n;(n=r.next)!==null;r=n)if(n.key===t)return r.next=n.next,n.next=e.next,e.next=n,n},LU=function(e,t){var r=fg(e,t);return r&&r.value},OU=function(e,t,r){var n=fg(e,t);n?n.value=r:e.next={key:t,next:e.next,value:r};},BU=function(e,t){return !!fg(e,t)};dx.exports=function(){var t,r,n,i={assert:function(s){if(!i.has(s))throw new AU("Side channel does not contain "+TU(s))},get:function(s){if(Cl&&s&&(typeof s=="object"||typeof s=="function")){if(t)return RU(t,s)}else if(El){if(r)return PU(r,s)}else if(n)return LU(n,s)},has:function(s){if(Cl&&s&&(typeof s=="object"||typeof s=="function")){if(t)return DU(t,s)}else if(El){if(r)return NU(r,s)}else if(n)return BU(n,s);return !1},set:function(s,o){Cl&&s&&(typeof s=="object"||typeof s=="function")?(t||(t=new Cl),IU(t,s,o)):El?(r||(r=new El),kU(r,s,o)):(n||(n={key:{},next:null}),OU(n,s,o));}};return i};});var hg=A((Noe,mx)=>{var gx=function(e){return e!==e};mx.exports=function(t,r){return t===0&&r===0?1/t===1/r:!!(t===r||gx(t)&&gx(r))};});var dg=A((Loe,yx)=>{var qU=hg();yx.exports=function(){return typeof Object.is=="function"?Object.is:qU};});var Sx=A((Ooe,vx)=>{var FU=dg(),MU=ns();vx.exports=function(){var t=FU();return MU(Object,{is:t},{is:function(){return Object.is!==t}}),t};});var xx=A((Boe,Ex)=>{var UU=ns(),$U=Ys(),jU=hg(),bx=dg(),VU=Sx(),Cx=$U(bx(),Object);UU(Cx,{getPolyfill:bx,implementation:jU,shim:VU});Ex.exports=Cx;});var as=A((qoe,wx)=>{var HU=ll();wx.exports=function(){return HU()&&!!Symbol.toStringTag};});var Ax=A((Foe,Tx)=>{var WU=as()(),KU=In(),pg=KU("Object.prototype.toString"),xl=function(t){return WU&&t&&typeof t=="object"&&Symbol.toStringTag in t?!1:pg(t)==="[object Arguments]"},_x=function(t){return xl(t)?!0:t!==null&&typeof t=="object"&&typeof t.length=="number"&&t.length>=0&&pg(t)!=="[object Array]"&&pg(t.callee)==="[object Function]"},zU=function(){return xl(arguments)}();xl.isLegacyArguments=_x;Tx.exports=zU?xl:_x;});var Ix=A((Moe,Rx)=>{var GU={}.toString;Rx.exports=Array.isArray||function(e){return GU.call(e)=="[object Array]"};});var Nx=A((Uoe,kx)=>{var Px=Function.prototype.toString,zo=typeof Reflect=="object"&&Reflect!==null&&Reflect.apply,mg,wl;if(typeof zo=="function"&&typeof Object.defineProperty=="function")try{mg=Object.defineProperty({},"length",{get:function(){throw wl}}),wl={},zo(function(){throw 42},null,mg);}catch(e){e!==wl&&(zo=null);}else zo=null;var YU=/^\s*class\b/,yg=function(t){try{var r=Px.call(t);return YU.test(r)}catch{return !1}},gg=function(t){try{return yg(t)?!1:(Px.call(t),!0)}catch{return !1}},_l=Object.prototype.toString,QU="[object Object]",XU="[object Function]",JU="[object GeneratorFunction]",ZU="[object HTMLAllCollection]",e6="[object HTML document.all class]",t6="[object HTMLCollection]",r6=typeof Symbol=="function"&&!!Symbol.toStringTag,n6=!(0 in[,]),vg=function(){return !1};typeof document=="object"&&(Dx=document.all,_l.call(Dx)===_l.call(document.all)&&(vg=function(t){if((n6||!t)&&(typeof t>"u"||typeof t=="object"))try{var r=_l.call(t);return (r===ZU||r===e6||r===t6||r===QU)&&t("")==null}catch{}return !1}));var Dx;kx.exports=zo?function(t){if(vg(t))return !0;if(!t||typeof t!="function"&&typeof t!="object")return !1;try{zo(t,null,mg);}catch(r){if(r!==wl)return !1}return !yg(t)&&gg(t)}:function(t){if(vg(t))return !0;if(!t||typeof t!="function"&&typeof t!="object")return !1;if(r6)return gg(t);if(yg(t))return !1;var r=_l.call(t);return r!==XU&&r!==JU&&!/^\[object HTML/.test(r)?!1:gg(t)};});var Bx=A(($oe,Ox)=>{var i6=Nx(),s6=Object.prototype.toString,Lx=Object.prototype.hasOwnProperty,o6=function(t,r,n){for(var i=0,s=t.length;i<s;i++)Lx.call(t,i)&&(n==null?r(t[i],i,t):r.call(n,t[i],i,t));},a6=function(t,r,n){for(var i=0,s=t.length;i<s;i++)n==null?r(t.charAt(i),i,t):r.call(n,t.charAt(i),i,t);},u6=function(t,r,n){for(var i in t)Lx.call(t,i)&&(n==null?r(t[i],i,t):r.call(n,t[i],i,t));},c6=function(t,r,n){if(!i6(r))throw new TypeError("iterator must be a function");var i;arguments.length>=3&&(i=n),s6.call(t)==="[object Array]"?o6(t,r,i):typeof t=="string"?a6(t,r,i):u6(t,r,i);};Ox.exports=c6;});var Fx=A((joe,qx)=>{var Sg=["BigInt64Array","BigUint64Array","Float32Array","Float64Array","Int16Array","Int32Array","Int8Array","Uint16Array","Uint32Array","Uint8Array","Uint8ClampedArray"],l6=typeof globalThis>"u"?global:globalThis;qx.exports=function(){for(var t=[],r=0;r<Sg.length;r++)typeof l6[Sg[r]]=="function"&&(t[t.length]=Sg[r]);return t};});var wg=A((Voe,jx)=>{var Al=Bx(),f6=Fx(),Mx=Ys(),Eg=In(),Tl=gl(),h6=Eg("Object.prototype.toString"),$x=as()(),Ux=typeof globalThis>"u"?global:globalThis,Cg=f6(),xg=Eg("String.prototype.slice"),bg=Object.getPrototypeOf,d6=Eg("Array.prototype.indexOf",!0)||function(t,r){for(var n=0;n<t.length;n+=1)if(t[n]===r)return n;return -1},Rl={__proto__:null};$x&&Tl&&bg?Al(Cg,function(e){var t=new Ux[e];if(Symbol.toStringTag in t){var r=bg(t),n=Tl(r,Symbol.toStringTag);if(!n){var i=bg(r);n=Tl(i,Symbol.toStringTag);}Rl["$"+e]=Mx(n.get);}}):Al(Cg,function(e){var t=new Ux[e],r=t.slice||t.set;r&&(Rl["$"+e]=Mx(r));});var p6=function(t){var r=!1;return Al(Rl,function(n,i){if(!r)try{"$"+n(t)===i&&(r=xg(i,1));}catch{}}),r},g6=function(t){var r=!1;return Al(Rl,function(n,i){if(!r)try{n(t),r=xg(i,1);}catch{}}),r};jx.exports=function(t){if(!t||typeof t!="object")return !1;if(!$x){var r=xg(h6(t),8,-1);return d6(Cg,r)>-1?r:r!=="Object"?!1:g6(t)}return Tl?p6(t):null};});var Hx=A((Hoe,Vx)=>{var m6=wg();Vx.exports=function(t){return !!m6(t)};});var _g=A((Woe,Qx)=>{var y6=Ys(),v6=In(),Yx=Gn(),S6=Hx(),Wx=Yx("ArrayBuffer",!0),Kx=Yx("Float32Array",!0),Il=v6("ArrayBuffer.prototype.byteLength",!0),zx=Wx&&!Il&&new Wx().slice,Gx=zx&&y6(zx);Qx.exports=Il||Gx?function(t){if(!t||typeof t!="object")return !1;try{return Il?Il(t):Gx(t,0),!0}catch{return !1}}:Kx?function(t){try{return new Kx(t).buffer===t&&!S6(t)}catch(r){return typeof t=="object"&&r.name==="RangeError"}}:function(t){return !1};});var Jx=A((Koe,Xx)=>{var b6=Date.prototype.getDay,C6=function(t){try{return b6.call(t),!0}catch{return !1}},E6=Object.prototype.toString,x6="[object Date]",w6=as()();Xx.exports=function(t){return typeof t!="object"||t===null?!1:w6?C6(t):E6.call(t)===x6};});var nw=A((zoe,rw)=>{var Tg=In(),Zx=as()(),ew,tw,Ag,Rg;Zx&&(ew=Tg("Object.prototype.hasOwnProperty"),tw=Tg("RegExp.prototype.exec"),Ag={},Dl=function(){throw Ag},Rg={toString:Dl,valueOf:Dl},typeof Symbol.toPrimitive=="symbol"&&(Rg[Symbol.toPrimitive]=Dl));var Dl,_6=Tg("Object.prototype.toString"),T6=Object.getOwnPropertyDescriptor,A6="[object RegExp]";rw.exports=Zx?function(t){if(!t||typeof t!="object")return !1;var r=T6(t,"lastIndex"),n=r&&ew(r,"value");if(!n)return !1;try{tw(t,Rg);}catch(i){return i===Ag}}:function(t){return !t||typeof t!="object"&&typeof t!="function"?!1:_6(t)===A6};});var ow=A((Goe,sw)=>{var R6=In(),iw=R6("SharedArrayBuffer.prototype.byteLength",!0);sw.exports=iw?function(t){if(!t||typeof t!="object")return !1;try{return iw(t),!0}catch{return !1}}:function(t){return !1};});var uw=A((Yoe,aw)=>{var I6=String.prototype.valueOf,D6=function(t){try{return I6.call(t),!0}catch{return !1}},P6=Object.prototype.toString,k6="[object String]",N6=as()();aw.exports=function(t){return typeof t=="string"?!0:typeof t!="object"?!1:N6?D6(t):P6.call(t)===k6};});var lw=A((Qoe,cw)=>{var L6=Number.prototype.toString,O6=function(t){try{return L6.call(t),!0}catch{return !1}},B6=Object.prototype.toString,q6="[object Number]",F6=as()();cw.exports=function(t){return typeof t=="number"?!0:typeof t!="object"?!1:F6?O6(t):B6.call(t)===q6};});var dw=A((Xoe,hw)=>{var fw=In(),M6=fw("Boolean.prototype.toString"),U6=fw("Object.prototype.toString"),$6=function(t){try{return M6(t),!0}catch{return !1}},j6="[object Boolean]",V6=as()();hw.exports=function(t){return typeof t=="boolean"?!0:t===null||typeof t!="object"?!1:V6&&Symbol.toStringTag in t?$6(t):U6(t)===j6};});var yw=A((Joe,Ig)=>{var H6=Object.prototype.toString,W6=Up()();W6?(pw=Symbol.prototype.toString,gw=/^Symbol\(.*\)$/,mw=function(t){return typeof t.valueOf()!="symbol"?!1:gw.test(pw.call(t))},Ig.exports=function(t){if(typeof t=="symbol")return !0;if(H6.call(t)!=="[object Symbol]")return !1;try{return mw(t)}catch{return !1}}):Ig.exports=function(t){return !1};var pw,gw,mw;});var bw=A((Zoe,Sw)=>{var vw=typeof BigInt<"u"&&BigInt;Sw.exports=function(){return typeof vw=="function"&&typeof BigInt=="function"&&typeof vw(42)=="bigint"&&typeof BigInt(42)=="bigint"};});var xw=A((eae,Dg)=>{var K6=bw()();K6?(Cw=BigInt.prototype.valueOf,Ew=function(t){try{return Cw.call(t),!0}catch{}return !1},Dg.exports=function(t){return t===null||typeof t>"u"||typeof t=="boolean"||typeof t=="string"||typeof t=="number"||typeof t=="symbol"||typeof t=="function"?!1:typeof t=="bigint"?!0:Ew(t)}):Dg.exports=function(t){return !1};var Cw,Ew;});var _w=A((tae,ww)=>{var z6=uw(),G6=lw(),Y6=dw(),Q6=yw(),X6=xw();ww.exports=function(t){if(t==null||typeof t!="object"&&typeof t!="function")return null;if(z6(t))return "String";if(G6(t))return "Number";if(Y6(t))return "Boolean";if(Q6(t))return "Symbol";if(X6(t))return "BigInt"};});var Iw=A((rae,Rw)=>{var Pg=typeof Map=="function"&&Map.prototype?Map:null,J6=typeof Set=="function"&&Set.prototype?Set:null,Pl;Pg||(Pl=function(t){return !1});var Aw=Pg?Map.prototype.has:null,Tw=J6?Set.prototype.has:null;!Pl&&!Aw&&(Pl=function(t){return !1});Rw.exports=Pl||function(t){if(!t||typeof t!="object")return !1;try{if(Aw.call(t),Tw)try{Tw.call(t);}catch{return !0}return t instanceof Pg}catch{}return !1};});var Nw=A((nae,kw)=>{var Z6=typeof Map=="function"&&Map.prototype?Map:null,kg=typeof Set=="function"&&Set.prototype?Set:null,kl;kg||(kl=function(t){return !1});var Dw=Z6?Map.prototype.has:null,Pw=kg?Set.prototype.has:null;!kl&&!Pw&&(kl=function(t){return !1});kw.exports=kl||function(t){if(!t||typeof t!="object")return !1;try{if(Pw.call(t),Dw)try{Dw.call(t);}catch{return !0}return t instanceof kg}catch{}return !1};});var Bw=A((iae,Ow)=>{var Nl=typeof WeakMap=="function"&&WeakMap.prototype?WeakMap:null,Lw=typeof WeakSet=="function"&&WeakSet.prototype?WeakSet:null,Ll;Nl||(Ll=function(t){return !1});var Lg=Nl?Nl.prototype.has:null,Ng=Lw?Lw.prototype.has:null;!Ll&&!Lg&&(Ll=function(t){return !1});Ow.exports=Ll||function(t){if(!t||typeof t!="object")return !1;try{if(Lg.call(t,Lg),Ng)try{Ng.call(t,Ng);}catch{return !0}return t instanceof Nl}catch{}return !1};});var Fw=A((sae,Bg)=>{var e$=Gn(),qw=In(),t$=e$("%WeakSet%",!0),Og=qw("WeakSet.prototype.has",!0);Og?(Ol=qw("WeakMap.prototype.has",!0),Bg.exports=function(t){if(!t||typeof t!="object")return !1;try{if(Og(t,Og),Ol)try{Ol(t,Ol);}catch{return !0}return t instanceof t$}catch{}return !1}):Bg.exports=function(t){return !1};var Ol;});var Uw=A((oae,Mw)=>{var r$=Iw(),n$=Nw(),i$=Bw(),s$=Fw();Mw.exports=function(t){if(t&&typeof t=="object"){if(r$(t))return "Map";if(n$(t))return "Set";if(i$(t))return "WeakMap";if(s$(t))return "WeakSet"}return !1};});var Vw=A((aae,jw)=>{var o$=In(),$w=o$("ArrayBuffer.prototype.byteLength",!0),a$=_g();jw.exports=function(t){return a$(t)?$w?$w(t):t.byteLength:NaN};});var Su=A((uae,d_)=>{var l_=A1(),li=In(),Hw=$1(),u$=Gn(),Go=H1(),c$=px(),Ww=xx(),Kw=Ax(),zw=Ix(),Gw=_g(),Yw=Jx(),Qw=nw(),Xw=ow(),Jw=cl(),Zw=_w(),e_=Uw(),t_=wg(),r_=Vw(),n_=li("SharedArrayBuffer.prototype.byteLength",!0),i_=li("Date.prototype.getTime"),qg=Object.getPrototypeOf,s_=li("Object.prototype.toString"),ql=u$("%Set%",!0),Fg=li("Map.prototype.has",!0),Fl=li("Map.prototype.get",!0),o_=li("Map.prototype.size",!0),Ml=li("Set.prototype.add",!0),f_=li("Set.prototype.delete",!0),Ul=li("Set.prototype.has",!0),Bl=li("Set.prototype.size",!0);function a_(e,t,r,n){for(var i=Go(e),s;(s=i.next())&&!s.done;)if(Yn(t,s.value,r,n))return f_(e,s.value),!0;return !1}function h_(e){if(typeof e>"u")return null;if(typeof e!="object")return typeof e=="symbol"?!1:typeof e=="string"||typeof e=="number"?+e==+e:!0}function l$(e,t,r,n,i,s){var o=h_(r);if(o!=null)return o;var a=Fl(t,o),c=l_({},i,{strict:!1});return typeof a>"u"&&!Fg(t,o)||!Yn(n,a,c,s)?!1:!Fg(e,o)&&Yn(n,a,c,s)}function f$(e,t,r){var n=h_(r);return n??(Ul(t,n)&&!Ul(e,n))}function u_(e,t,r,n,i,s){for(var o=Go(e),a,c;(a=o.next())&&!a.done;)if(c=a.value,Yn(r,c,i,s)&&Yn(n,Fl(t,c),i,s))return f_(e,c),!0;return !1}function Yn(e,t,r,n){var i=r||{};if(i.strict?Ww(e,t):e===t)return !0;var s=Zw(e),o=Zw(t);if(s!==o)return !1;if(!e||!t||typeof e!="object"&&typeof t!="object")return i.strict?Ww(e,t):e==t;var a=n.has(e),c=n.has(t),l;if(a&&c){if(n.get(e)===n.get(t))return !0}else l={};return a||n.set(e,l),c||n.set(t,l),p$(e,t,i,n)}function c_(e){return !e||typeof e!="object"||typeof e.length!="number"||typeof e.copy!="function"||typeof e.slice!="function"||e.length>0&&typeof e[0]!="number"?!1:!!(e.constructor&&e.constructor.isBuffer&&e.constructor.isBuffer(e))}function h$(e,t,r,n){if(Bl(e)!==Bl(t))return !1;for(var i=Go(e),s=Go(t),o,a,c;(o=i.next())&&!o.done;)if(o.value&&typeof o.value=="object")c||(c=new ql),Ml(c,o.value);else if(!Ul(t,o.value)){if(r.strict||!f$(e,t,o.value))return !1;c||(c=new ql),Ml(c,o.value);}if(c){for(;(a=s.next())&&!a.done;)if(a.value&&typeof a.value=="object"){if(!a_(c,a.value,r.strict,n))return !1}else if(!r.strict&&!Ul(e,a.value)&&!a_(c,a.value,r.strict,n))return !1;return Bl(c)===0}return !0}function d$(e,t,r,n){if(o_(e)!==o_(t))return !1;for(var i=Go(e),s=Go(t),o,a,c,l,u,f;(o=i.next())&&!o.done;)if(l=o.value[0],u=o.value[1],l&&typeof l=="object")c||(c=new ql),Ml(c,l);else if(f=Fl(t,l),typeof f>"u"&&!Fg(t,l)||!Yn(u,f,r,n)){if(r.strict||!l$(e,t,l,u,r,n))return !1;c||(c=new ql),Ml(c,l);}if(c){for(;(a=s.next())&&!a.done;)if(l=a.value[0],f=a.value[1],l&&typeof l=="object"){if(!u_(c,e,l,f,r,n))return !1}else if(!r.strict&&(!e.has(l)||!Yn(Fl(e,l),f,r,n))&&!u_(c,e,l,f,l_({},r,{strict:!1}),n))return !1;return Bl(c)===0}return !0}function p$(e,t,r,n){var i,s;if(typeof e!=typeof t||e==null||t==null||s_(e)!==s_(t)||Kw(e)!==Kw(t))return !1;var o=zw(e),a=zw(t);if(o!==a)return !1;var c=e instanceof Error,l=t instanceof Error;if(c!==l||(c||l)&&(e.name!==t.name||e.message!==t.message))return !1;var u=Qw(e),f=Qw(t);if(u!==f||(u||f)&&(e.source!==t.source||Hw(e)!==Hw(t)))return !1;var d=Yw(e),p=Yw(t);if(d!==p||(d||p)&&i_(e)!==i_(t)||r.strict&&qg&&qg(e)!==qg(t))return !1;var m=t_(e),S=t_(t);if(m!==S)return !1;if(m||S){if(e.length!==t.length)return !1;for(i=0;i<e.length;i++)if(e[i]!==t[i])return !1;return !0}var x=c_(e),I=c_(t);if(x!==I)return !1;if(x||I){if(e.length!==t.length)return !1;for(i=0;i<e.length;i++)if(e[i]!==t[i])return !1;return !0}var v=Gw(e),b=Gw(t);if(v!==b)return !1;if(v||b)return r_(e)!==r_(t)?!1:typeof Uint8Array=="function"&&Yn(new Uint8Array(e),new Uint8Array(t),r,n);var D=Xw(e),L=Xw(t);if(D!==L)return !1;if(D||L)return n_(e)!==n_(t)?!1:typeof Uint8Array=="function"&&Yn(new Uint8Array(e),new Uint8Array(t),r,n);if(typeof e!=typeof t)return !1;var j=Jw(e),J=Jw(t);if(j.length!==J.length)return !1;for(j.sort(),J.sort(),i=j.length-1;i>=0;i--)if(j[i]!=J[i])return !1;for(i=j.length-1;i>=0;i--)if(s=j[i],!Yn(e[s],t[s],r,n))return !1;var K=e_(e),G=e_(t);return K!==G?!1:K==="Set"||G==="Set"?h$(e,t,r,n):K==="Map"?d$(e,t,r,n):!0}d_.exports=function(t,r,n){return Yn(t,r,n,c$())};});var Cu=A((dae,C_)=>{var O$="2.0.0",B$=Number.MAX_SAFE_INTEGER||9007199254740991,q$=16,F$=250,M$=["major","premajor","minor","preminor","patch","prepatch","prerelease"];C_.exports={MAX_LENGTH:256,MAX_SAFE_COMPONENT_LENGTH:q$,MAX_SAFE_BUILD_LENGTH:F$,MAX_SAFE_INTEGER:B$,RELEASE_TYPES:M$,SEMVER_SPEC_VERSION:O$,FLAG_INCLUDE_PRERELEASE:1,FLAG_LOOSE:2};});var Eu=A((pae,E_)=>{var U$=typeof process=="object"&&process.env&&process.env.NODE_DEBUG&&/\bsemver\b/i.test(process.env.NODE_DEBUG)?(...e)=>console.error("SEMVER",...e):()=>{};E_.exports=U$;});var Qo=A((Li,x_)=>{var{MAX_SAFE_COMPONENT_LENGTH:Vg,MAX_SAFE_BUILD_LENGTH:$$,MAX_LENGTH:j$}=Cu(),V$=Eu();Li=x_.exports={};var H$=Li.re=[],W$=Li.safeRe=[],Ie=Li.src=[],De=Li.t={},K$=0,Hg="[a-zA-Z0-9-]",z$=[["\\s",1],["\\d",j$],[Hg,$$]],G$=e=>{for(let[t,r]of z$)e=e.split(`${t}*`).join(`${t}{0,${r}}`).split(`${t}+`).join(`${t}{1,${r}}`);return e},Xe=(e,t,r)=>{let n=G$(t),i=K$++;V$(e,i,t),De[e]=i,Ie[i]=t,H$[i]=new RegExp(t,r?"g":void 0),W$[i]=new RegExp(n,r?"g":void 0);};Xe("NUMERICIDENTIFIER","0|[1-9]\\d*");Xe("NUMERICIDENTIFIERLOOSE","\\d+");Xe("NONNUMERICIDENTIFIER",`\\d*[a-zA-Z-]${Hg}*`);Xe("MAINVERSION",`(${Ie[De.NUMERICIDENTIFIER]})\\.(${Ie[De.NUMERICIDENTIFIER]})\\.(${Ie[De.NUMERICIDENTIFIER]})`);Xe("MAINVERSIONLOOSE",`(${Ie[De.NUMERICIDENTIFIERLOOSE]})\\.(${Ie[De.NUMERICIDENTIFIERLOOSE]})\\.(${Ie[De.NUMERICIDENTIFIERLOOSE]})`);Xe("PRERELEASEIDENTIFIER",`(?:${Ie[De.NUMERICIDENTIFIER]}|${Ie[De.NONNUMERICIDENTIFIER]})`);Xe("PRERELEASEIDENTIFIERLOOSE",`(?:${Ie[De.NUMERICIDENTIFIERLOOSE]}|${Ie[De.NONNUMERICIDENTIFIER]})`);Xe("PRERELEASE",`(?:-(${Ie[De.PRERELEASEIDENTIFIER]}(?:\\.${Ie[De.PRERELEASEIDENTIFIER]})*))`);Xe("PRERELEASELOOSE",`(?:-?(${Ie[De.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${Ie[De.PRERELEASEIDENTIFIERLOOSE]})*))`);Xe("BUILDIDENTIFIER",`${Hg}+`);Xe("BUILD",`(?:\\+(${Ie[De.BUILDIDENTIFIER]}(?:\\.${Ie[De.BUILDIDENTIFIER]})*))`);Xe("FULLPLAIN",`v?${Ie[De.MAINVERSION]}${Ie[De.PRERELEASE]}?${Ie[De.BUILD]}?`);Xe("FULL",`^${Ie[De.FULLPLAIN]}$`);Xe("LOOSEPLAIN",`[v=\\s]*${Ie[De.MAINVERSIONLOOSE]}${Ie[De.PRERELEASELOOSE]}?${Ie[De.BUILD]}?`);Xe("LOOSE",`^${Ie[De.LOOSEPLAIN]}$`);Xe("GTLT","((?:<|>)?=?)");Xe("XRANGEIDENTIFIERLOOSE",`${Ie[De.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);Xe("XRANGEIDENTIFIER",`${Ie[De.NUMERICIDENTIFIER]}|x|X|\\*`);Xe("XRANGEPLAIN",`[v=\\s]*(${Ie[De.XRANGEIDENTIFIER]})(?:\\.(${Ie[De.XRANGEIDENTIFIER]})(?:\\.(${Ie[De.XRANGEIDENTIFIER]})(?:${Ie[De.PRERELEASE]})?${Ie[De.BUILD]}?)?)?`);Xe("XRANGEPLAINLOOSE",`[v=\\s]*(${Ie[De.XRANGEIDENTIFIERLOOSE]})(?:\\.(${Ie[De.XRANGEIDENTIFIERLOOSE]})(?:\\.(${Ie[De.XRANGEIDENTIFIERLOOSE]})(?:${Ie[De.PRERELEASELOOSE]})?${Ie[De.BUILD]}?)?)?`);Xe("XRANGE",`^${Ie[De.GTLT]}\\s*${Ie[De.XRANGEPLAIN]}$`);Xe("XRANGELOOSE",`^${Ie[De.GTLT]}\\s*${Ie[De.XRANGEPLAINLOOSE]}$`);Xe("COERCEPLAIN",`(^|[^\\d])(\\d{1,${Vg}})(?:\\.(\\d{1,${Vg}}))?(?:\\.(\\d{1,${Vg}}))?`);Xe("COERCE",`${Ie[De.COERCEPLAIN]}(?:$|[^\\d])`);Xe("COERCEFULL",Ie[De.COERCEPLAIN]+`(?:${Ie[De.PRERELEASE]})?(?:${Ie[De.BUILD]})?(?:$|[^\\d])`);Xe("COERCERTL",Ie[De.COERCE],!0);Xe("COERCERTLFULL",Ie[De.COERCEFULL],!0);Xe("LONETILDE","(?:~>?)");Xe("TILDETRIM",`(\\s*)${Ie[De.LONETILDE]}\\s+`,!0);Li.tildeTrimReplace="$1~";Xe("TILDE",`^${Ie[De.LONETILDE]}${Ie[De.XRANGEPLAIN]}$`);Xe("TILDELOOSE",`^${Ie[De.LONETILDE]}${Ie[De.XRANGEPLAINLOOSE]}$`);Xe("LONECARET","(?:\\^)");Xe("CARETTRIM",`(\\s*)${Ie[De.LONECARET]}\\s+`,!0);Li.caretTrimReplace="$1^";Xe("CARET",`^${Ie[De.LONECARET]}${Ie[De.XRANGEPLAIN]}$`);Xe("CARETLOOSE",`^${Ie[De.LONECARET]}${Ie[De.XRANGEPLAINLOOSE]}$`);Xe("COMPARATORLOOSE",`^${Ie[De.GTLT]}\\s*(${Ie[De.LOOSEPLAIN]})$|^$`);Xe("COMPARATOR",`^${Ie[De.GTLT]}\\s*(${Ie[De.FULLPLAIN]})$|^$`);Xe("COMPARATORTRIM",`(\\s*)${Ie[De.GTLT]}\\s*(${Ie[De.LOOSEPLAIN]}|${Ie[De.XRANGEPLAIN]})`,!0);Li.comparatorTrimReplace="$1$2$3";Xe("HYPHENRANGE",`^\\s*(${Ie[De.XRANGEPLAIN]})\\s+-\\s+(${Ie[De.XRANGEPLAIN]})\\s*$`);Xe("HYPHENRANGELOOSE",`^\\s*(${Ie[De.XRANGEPLAINLOOSE]})\\s+-\\s+(${Ie[De.XRANGEPLAINLOOSE]})\\s*$`);Xe("STAR","(<|>)?=?\\s*\\*");Xe("GTE0","^\\s*>=\\s*0\\.0\\.0\\s*$");Xe("GTE0PRE","^\\s*>=\\s*0\\.0\\.0-0\\s*$");});var Hl=A((gae,w_)=>{var Y$=Object.freeze({loose:!0}),Q$=Object.freeze({}),X$=e=>e?typeof e!="object"?Y$:e:Q$;w_.exports=X$;});var Wg=A((mae,A_)=>{var __=/^[0-9]+$/,T_=(e,t)=>{let r=__.test(e),n=__.test(t);return r&&n&&(e=+e,t=+t),e===t?0:r&&!n?-1:n&&!r?1:e<t?-1:1},J$=(e,t)=>T_(t,e);A_.exports={compareIdentifiers:T_,rcompareIdentifiers:J$};});var Nr=A((yae,P_)=>{var Wl=Eu(),{MAX_LENGTH:R_,MAX_SAFE_INTEGER:Kl}=Cu(),{safeRe:I_,t:D_}=Qo(),Z$=Hl(),{compareIdentifiers:Xo}=Wg(),Kg=class e{constructor(t,r){if(r=Z$(r),t instanceof e){if(t.loose===!!r.loose&&t.includePrerelease===!!r.includePrerelease)return t;t=t.version;}else if(typeof t!="string")throw new TypeError(`Invalid version. Must be a string. Got type "${typeof t}".`);if(t.length>R_)throw new TypeError(`version is longer than ${R_} characters`);Wl("SemVer",t,r),this.options=r,this.loose=!!r.loose,this.includePrerelease=!!r.includePrerelease;let n=t.trim().match(r.loose?I_[D_.LOOSE]:I_[D_.FULL]);if(!n)throw new TypeError(`Invalid Version: ${t}`);if(this.raw=t,this.major=+n[1],this.minor=+n[2],this.patch=+n[3],this.major>Kl||this.major<0)throw new TypeError("Invalid major version");if(this.minor>Kl||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>Kl||this.patch<0)throw new TypeError("Invalid patch version");n[4]?this.prerelease=n[4].split(".").map(i=>{if(/^[0-9]+$/.test(i)){let s=+i;if(s>=0&&s<Kl)return s}return i}):this.prerelease=[],this.build=n[5]?n[5].split("."):[],this.format();}format(){return this.version=`${this.major}.${this.minor}.${this.patch}`,this.prerelease.length&&(this.version+=`-${this.prerelease.join(".")}`),this.version}toString(){return this.version}compare(t){if(Wl("SemVer.compare",this.version,this.options,t),!(t instanceof e)){if(typeof t=="string"&&t===this.version)return 0;t=new e(t,this.options);}return t.version===this.version?0:this.compareMain(t)||this.comparePre(t)}compareMain(t){return t instanceof e||(t=new e(t,this.options)),Xo(this.major,t.major)||Xo(this.minor,t.minor)||Xo(this.patch,t.patch)}comparePre(t){if(t instanceof e||(t=new e(t,this.options)),this.prerelease.length&&!t.prerelease.length)return -1;if(!this.prerelease.length&&t.prerelease.length)return 1;if(!this.prerelease.length&&!t.prerelease.length)return 0;let r=0;do{let n=this.prerelease[r],i=t.prerelease[r];if(Wl("prerelease compare",r,n,i),n===void 0&&i===void 0)return 0;if(i===void 0)return 1;if(n===void 0)return -1;if(n===i)continue;return Xo(n,i)}while(++r)}compareBuild(t){t instanceof e||(t=new e(t,this.options));let r=0;do{let n=this.build[r],i=t.build[r];if(Wl("prerelease compare",r,n,i),n===void 0&&i===void 0)return 0;if(i===void 0)return 1;if(n===void 0)return -1;if(n===i)continue;return Xo(n,i)}while(++r)}inc(t,r,n){switch(t){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",r,n);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",r,n);break;case"prepatch":this.prerelease.length=0,this.inc("patch",r,n),this.inc("pre",r,n);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",r,n),this.inc("pre",r,n);break;case"major":(this.minor!==0||this.patch!==0||this.prerelease.length===0)&&this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":(this.patch!==0||this.prerelease.length===0)&&this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":{let i=Number(n)?1:0;if(!r&&n===!1)throw new Error("invalid increment argument: identifier is empty");if(this.prerelease.length===0)this.prerelease=[i];else {let s=this.prerelease.length;for(;--s>=0;)typeof this.prerelease[s]=="number"&&(this.prerelease[s]++,s=-2);if(s===-1){if(r===this.prerelease.join(".")&&n===!1)throw new Error("invalid increment argument: identifier already exists");this.prerelease.push(i);}}if(r){let s=[r,i];n===!1&&(s=[r]),Xo(this.prerelease[0],r)===0?isNaN(this.prerelease[1])&&(this.prerelease=s):this.prerelease=s;}break}default:throw new Error(`invalid increment argument: ${t}`)}return this.raw=this.format(),this.build.length&&(this.raw+=`+${this.build.join(".")}`),this}};P_.exports=Kg;});var Xs=A((vae,N_)=>{var k_=Nr(),ej=(e,t,r=!1)=>{if(e instanceof k_)return e;try{return new k_(e,t)}catch(n){if(!r)return null;throw n}};N_.exports=ej;});var O_=A((Sae,L_)=>{var tj=Xs(),rj=(e,t)=>{let r=tj(e,t);return r?r.version:null};L_.exports=rj;});var q_=A((bae,B_)=>{var nj=Xs(),ij=(e,t)=>{let r=nj(e.trim().replace(/^[=v]+/,""),t);return r?r.version:null};B_.exports=ij;});var U_=A((Cae,M_)=>{var F_=Nr(),sj=(e,t,r,n,i)=>{typeof r=="string"&&(i=n,n=r,r=void 0);try{return new F_(e instanceof F_?e.version:e,r).inc(t,n,i).version}catch{return null}};M_.exports=sj;});var V_=A((Eae,j_)=>{var $_=Xs(),oj=(e,t)=>{let r=$_(e,null,!0),n=$_(t,null,!0),i=r.compare(n);if(i===0)return null;let s=i>0,o=s?r:n,a=s?n:r,c=!!o.prerelease.length;if(!!a.prerelease.length&&!c)return !a.patch&&!a.minor?"major":o.patch?"patch":o.minor?"minor":"major";let u=c?"pre":"";return r.major!==n.major?u+"major":r.minor!==n.minor?u+"minor":r.patch!==n.patch?u+"patch":"prerelease"};j_.exports=oj;});var W_=A((xae,H_)=>{var aj=Nr(),uj=(e,t)=>new aj(e,t).major;H_.exports=uj;});var z_=A((wae,K_)=>{var cj=Nr(),lj=(e,t)=>new cj(e,t).minor;K_.exports=lj;});var Y_=A((_ae,G_)=>{var fj=Nr(),hj=(e,t)=>new fj(e,t).patch;G_.exports=hj;});var X_=A((Tae,Q_)=>{var dj=Xs(),pj=(e,t)=>{let r=dj(e,t);return r&&r.prerelease.length?r.prerelease:null};Q_.exports=pj;});var Dn=A((Aae,Z_)=>{var J_=Nr(),gj=(e,t,r)=>new J_(e,r).compare(new J_(t,r));Z_.exports=gj;});var tT=A((Rae,eT)=>{var mj=Dn(),yj=(e,t,r)=>mj(t,e,r);eT.exports=yj;});var nT=A((Iae,rT)=>{var vj=Dn(),Sj=(e,t)=>vj(e,t,!0);rT.exports=Sj;});var zl=A((Dae,sT)=>{var iT=Nr(),bj=(e,t,r)=>{let n=new iT(e,r),i=new iT(t,r);return n.compare(i)||n.compareBuild(i)};sT.exports=bj;});var aT=A((Pae,oT)=>{var Cj=zl(),Ej=(e,t)=>e.sort((r,n)=>Cj(r,n,t));oT.exports=Ej;});var cT=A((kae,uT)=>{var xj=zl(),wj=(e,t)=>e.sort((r,n)=>xj(n,r,t));uT.exports=wj;});var xu=A((Nae,lT)=>{var _j=Dn(),Tj=(e,t,r)=>_j(e,t,r)>0;lT.exports=Tj;});var Gl=A((Lae,fT)=>{var Aj=Dn(),Rj=(e,t,r)=>Aj(e,t,r)<0;fT.exports=Rj;});var zg=A((Oae,hT)=>{var Ij=Dn(),Dj=(e,t,r)=>Ij(e,t,r)===0;hT.exports=Dj;});var Gg=A((Bae,dT)=>{var Pj=Dn(),kj=(e,t,r)=>Pj(e,t,r)!==0;dT.exports=kj;});var Yl=A((qae,pT)=>{var Nj=Dn(),Lj=(e,t,r)=>Nj(e,t,r)>=0;pT.exports=Lj;});var Ql=A((Fae,gT)=>{var Oj=Dn(),Bj=(e,t,r)=>Oj(e,t,r)<=0;gT.exports=Bj;});var Yg=A((Mae,mT)=>{var qj=zg(),Fj=Gg(),Mj=xu(),Uj=Yl(),$j=Gl(),jj=Ql(),Vj=(e,t,r,n)=>{switch(t){case"===":return typeof e=="object"&&(e=e.version),typeof r=="object"&&(r=r.version),e===r;case"!==":return typeof e=="object"&&(e=e.version),typeof r=="object"&&(r=r.version),e!==r;case"":case"=":case"==":return qj(e,r,n);case"!=":return Fj(e,r,n);case">":return Mj(e,r,n);case">=":return Uj(e,r,n);case"<":return $j(e,r,n);case"<=":return jj(e,r,n);default:throw new TypeError(`Invalid operator: ${t}`)}};mT.exports=Vj;});var vT=A((Uae,yT)=>{var Hj=Nr(),Wj=Xs(),{safeRe:Xl,t:Jl}=Qo(),Kj=(e,t)=>{if(e instanceof Hj)return e;if(typeof e=="number"&&(e=String(e)),typeof e!="string")return null;t=t||{};let r=null;if(!t.rtl)r=e.match(t.includePrerelease?Xl[Jl.COERCEFULL]:Xl[Jl.COERCE]);else {let c=t.includePrerelease?Xl[Jl.COERCERTLFULL]:Xl[Jl.COERCERTL],l;for(;(l=c.exec(e))&&(!r||r.index+r[0].length!==e.length);)(!r||l.index+l[0].length!==r.index+r[0].length)&&(r=l),c.lastIndex=l.index+l[1].length+l[2].length;c.lastIndex=-1;}if(r===null)return null;let n=r[2],i=r[3]||"0",s=r[4]||"0",o=t.includePrerelease&&r[5]?`-${r[5]}`:"",a=t.includePrerelease&&r[6]?`+${r[6]}`:"";return Wj(`${n}.${i}.${s}${o}${a}`,t)};yT.exports=Kj;});var bT=A(($ae,ST)=>{ST.exports=function(e){e.prototype[Symbol.iterator]=function*(){for(let t=this.head;t;t=t.next)yield t.value;};};});var ET=A((jae,CT)=>{CT.exports=Ct;Ct.Node=Js;Ct.create=Ct;function Ct(e){var t=this;if(t instanceof Ct||(t=new Ct),t.tail=null,t.head=null,t.length=0,e&&typeof e.forEach=="function")e.forEach(function(i){t.push(i);});else if(arguments.length>0)for(var r=0,n=arguments.length;r<n;r++)t.push(arguments[r]);return t}Ct.prototype.removeNode=function(e){if(e.list!==this)throw new Error("removing node which does not belong to this list");var t=e.next,r=e.prev;return t&&(t.prev=r),r&&(r.next=t),e===this.head&&(this.head=t),e===this.tail&&(this.tail=r),e.list.length--,e.next=null,e.prev=null,e.list=null,t};Ct.prototype.unshiftNode=function(e){if(e!==this.head){e.list&&e.list.removeNode(e);var t=this.head;e.list=this,e.next=t,t&&(t.prev=e),this.head=e,this.tail||(this.tail=e),this.length++;}};Ct.prototype.pushNode=function(e){if(e!==this.tail){e.list&&e.list.removeNode(e);var t=this.tail;e.list=this,e.prev=t,t&&(t.next=e),this.tail=e,this.head||(this.head=e),this.length++;}};Ct.prototype.push=function(){for(var e=0,t=arguments.length;e<t;e++)Gj(this,arguments[e]);return this.length};Ct.prototype.unshift=function(){for(var e=0,t=arguments.length;e<t;e++)Yj(this,arguments[e]);return this.length};Ct.prototype.pop=function(){if(this.tail){var e=this.tail.value;return this.tail=this.tail.prev,this.tail?this.tail.next=null:this.head=null,this.length--,e}};Ct.prototype.shift=function(){if(this.head){var e=this.head.value;return this.head=this.head.next,this.head?this.head.prev=null:this.tail=null,this.length--,e}};Ct.prototype.forEach=function(e,t){t=t||this;for(var r=this.head,n=0;r!==null;n++)e.call(t,r.value,n,this),r=r.next;};Ct.prototype.forEachReverse=function(e,t){t=t||this;for(var r=this.tail,n=this.length-1;r!==null;n--)e.call(t,r.value,n,this),r=r.prev;};Ct.prototype.get=function(e){for(var t=0,r=this.head;r!==null&&t<e;t++)r=r.next;if(t===e&&r!==null)return r.value};Ct.prototype.getReverse=function(e){for(var t=0,r=this.tail;r!==null&&t<e;t++)r=r.prev;if(t===e&&r!==null)return r.value};Ct.prototype.map=function(e,t){t=t||this;for(var r=new Ct,n=this.head;n!==null;)r.push(e.call(t,n.value,this)),n=n.next;return r};Ct.prototype.mapReverse=function(e,t){t=t||this;for(var r=new Ct,n=this.tail;n!==null;)r.push(e.call(t,n.value,this)),n=n.prev;return r};Ct.prototype.reduce=function(e,t){var r,n=this.head;if(arguments.length>1)r=t;else if(this.head)n=this.head.next,r=this.head.value;else throw new TypeError("Reduce of empty list with no initial value");for(var i=0;n!==null;i++)r=e(r,n.value,i),n=n.next;return r};Ct.prototype.reduceReverse=function(e,t){var r,n=this.tail;if(arguments.length>1)r=t;else if(this.tail)n=this.tail.prev,r=this.tail.value;else throw new TypeError("Reduce of empty list with no initial value");for(var i=this.length-1;n!==null;i--)r=e(r,n.value,i),n=n.prev;return r};Ct.prototype.toArray=function(){for(var e=new Array(this.length),t=0,r=this.head;r!==null;t++)e[t]=r.value,r=r.next;return e};Ct.prototype.toArrayReverse=function(){for(var e=new Array(this.length),t=0,r=this.tail;r!==null;t++)e[t]=r.value,r=r.prev;return e};Ct.prototype.slice=function(e,t){t=t||this.length,t<0&&(t+=this.length),e=e||0,e<0&&(e+=this.length);var r=new Ct;if(t<e||t<0)return r;e<0&&(e=0),t>this.length&&(t=this.length);for(var n=0,i=this.head;i!==null&&n<e;n++)i=i.next;for(;i!==null&&n<t;n++,i=i.next)r.push(i.value);return r};Ct.prototype.sliceReverse=function(e,t){t=t||this.length,t<0&&(t+=this.length),e=e||0,e<0&&(e+=this.length);var r=new Ct;if(t<e||t<0)return r;e<0&&(e=0),t>this.length&&(t=this.length);for(var n=this.length,i=this.tail;i!==null&&n>t;n--)i=i.prev;for(;i!==null&&n>e;n--,i=i.prev)r.push(i.value);return r};Ct.prototype.splice=function(e,t,...r){e>this.length&&(e=this.length-1),e<0&&(e=this.length+e);for(var n=0,i=this.head;i!==null&&n<e;n++)i=i.next;for(var s=[],n=0;i&&n<t;n++)s.push(i.value),i=this.removeNode(i);i===null&&(i=this.tail),i!==this.head&&i!==this.tail&&(i=i.prev);for(var n=0;n<r.length;n++)i=zj(this,i,r[n]);return s};Ct.prototype.reverse=function(){for(var e=this.head,t=this.tail,r=e;r!==null;r=r.prev){var n=r.prev;r.prev=r.next,r.next=n;}return this.head=t,this.tail=e,this};function zj(e,t,r){var n=t===e.head?new Js(r,null,t,e):new Js(r,t,t.next,e);return n.next===null&&(e.tail=n),n.prev===null&&(e.head=n),e.length++,n}function Gj(e,t){e.tail=new Js(t,e.tail,null,e),e.head||(e.head=e.tail),e.length++;}function Yj(e,t){e.head=new Js(t,null,e.head,e),e.tail||(e.tail=e.head),e.length++;}function Js(e,t,r,n){if(!(this instanceof Js))return new Js(e,t,r,n);this.list=n,this.value=e,t?(t.next=this,this.prev=t):this.prev=null,r?(r.prev=this,this.next=r):this.next=null;}try{bT()(Ct);}catch{}});var AT=A((Vae,TT)=>{var Qj=ET(),Zs=Symbol("max"),Bi=Symbol("length"),Jo=Symbol("lengthCalculator"),_u=Symbol("allowStale"),eo=Symbol("maxAge"),Oi=Symbol("dispose"),xT=Symbol("noDisposeOnSet"),hr=Symbol("lruList"),Qn=Symbol("cache"),_T=Symbol("updateAgeOnGet"),Qg=()=>1,Jg=class{constructor(t){if(typeof t=="number"&&(t={max:t}),t||(t={}),t.max&&(typeof t.max!="number"||t.max<0))throw new TypeError("max must be a non-negative number");this[Zs]=t.max||1/0;let n=t.length||Qg;if(this[Jo]=typeof n!="function"?Qg:n,this[_u]=t.stale||!1,t.maxAge&&typeof t.maxAge!="number")throw new TypeError("maxAge must be a number");this[eo]=t.maxAge||0,this[Oi]=t.dispose,this[xT]=t.noDisposeOnSet||!1,this[_T]=t.updateAgeOnGet||!1,this.reset();}set max(t){if(typeof t!="number"||t<0)throw new TypeError("max must be a non-negative number");this[Zs]=t||1/0,wu(this);}get max(){return this[Zs]}set allowStale(t){this[_u]=!!t;}get allowStale(){return this[_u]}set maxAge(t){if(typeof t!="number")throw new TypeError("maxAge must be a non-negative number");this[eo]=t,wu(this);}get maxAge(){return this[eo]}set lengthCalculator(t){typeof t!="function"&&(t=Qg),t!==this[Jo]&&(this[Jo]=t,this[Bi]=0,this[hr].forEach(r=>{r.length=this[Jo](r.value,r.key),this[Bi]+=r.length;})),wu(this);}get lengthCalculator(){return this[Jo]}get length(){return this[Bi]}get itemCount(){return this[hr].length}rforEach(t,r){r=r||this;for(let n=this[hr].tail;n!==null;){let i=n.prev;wT(this,t,n,r),n=i;}}forEach(t,r){r=r||this;for(let n=this[hr].head;n!==null;){let i=n.next;wT(this,t,n,r),n=i;}}keys(){return this[hr].toArray().map(t=>t.key)}values(){return this[hr].toArray().map(t=>t.value)}reset(){this[Oi]&&this[hr]&&this[hr].length&&this[hr].forEach(t=>this[Oi](t.key,t.value)),this[Qn]=new Map,this[hr]=new Qj,this[Bi]=0;}dump(){return this[hr].map(t=>Zl(this,t)?!1:{k:t.key,v:t.value,e:t.now+(t.maxAge||0)}).toArray().filter(t=>t)}dumpLru(){return this[hr]}set(t,r,n){if(n=n||this[eo],n&&typeof n!="number")throw new TypeError("maxAge must be a number");let i=n?Date.now():0,s=this[Jo](r,t);if(this[Qn].has(t)){if(s>this[Zs])return Zo(this,this[Qn].get(t)),!1;let c=this[Qn].get(t).value;return this[Oi]&&(this[xT]||this[Oi](t,c.value)),c.now=i,c.maxAge=n,c.value=r,this[Bi]+=s-c.length,c.length=s,this.get(t),wu(this),!0}let o=new Zg(t,r,s,i,n);return o.length>this[Zs]?(this[Oi]&&this[Oi](t,r),!1):(this[Bi]+=o.length,this[hr].unshift(o),this[Qn].set(t,this[hr].head),wu(this),!0)}has(t){if(!this[Qn].has(t))return !1;let r=this[Qn].get(t).value;return !Zl(this,r)}get(t){return Xg(this,t,!0)}peek(t){return Xg(this,t,!1)}pop(){let t=this[hr].tail;return t?(Zo(this,t),t.value):null}del(t){Zo(this,this[Qn].get(t));}load(t){this.reset();let r=Date.now();for(let n=t.length-1;n>=0;n--){let i=t[n],s=i.e||0;if(s===0)this.set(i.k,i.v);else {let o=s-r;o>0&&this.set(i.k,i.v,o);}}}prune(){this[Qn].forEach((t,r)=>Xg(this,r,!1));}},Xg=(e,t,r)=>{let n=e[Qn].get(t);if(n){let i=n.value;if(Zl(e,i)){if(Zo(e,n),!e[_u])return}else r&&(e[_T]&&(n.value.now=Date.now()),e[hr].unshiftNode(n));return i.value}},Zl=(e,t)=>{if(!t||!t.maxAge&&!e[eo])return !1;let r=Date.now()-t.now;return t.maxAge?r>t.maxAge:e[eo]&&r>e[eo]},wu=e=>{if(e[Bi]>e[Zs])for(let t=e[hr].tail;e[Bi]>e[Zs]&&t!==null;){let r=t.prev;Zo(e,t),t=r;}},Zo=(e,t)=>{if(t){let r=t.value;e[Oi]&&e[Oi](r.key,r.value),e[Bi]-=r.length,e[Qn].delete(r.key),e[hr].removeNode(t);}},Zg=class{constructor(t,r,n,i,s){this.key=t,this.value=r,this.length=n,this.now=i,this.maxAge=s||0;}},wT=(e,t,r,n)=>{let i=r.value;Zl(e,i)&&(Zo(e,r),e[_u]||(i=void 0)),i&&t.call(n,i.value,i.key,e);};TT.exports=Jg;});var Pn=A((Hae,PT)=>{var e0=class e{constructor(t,r){if(r=Jj(r),t instanceof e)return t.loose===!!r.loose&&t.includePrerelease===!!r.includePrerelease?t:new e(t.raw,r);if(t instanceof t0)return this.raw=t.value,this.set=[[t]],this.format(),this;if(this.options=r,this.loose=!!r.loose,this.includePrerelease=!!r.includePrerelease,this.raw=t.trim().split(/\s+/).join(" "),this.set=this.raw.split("||").map(n=>this.parseRange(n.trim())).filter(n=>n.length),!this.set.length)throw new TypeError(`Invalid SemVer Range: ${this.raw}`);if(this.set.length>1){let n=this.set[0];if(this.set=this.set.filter(i=>!IT(i[0])),this.set.length===0)this.set=[n];else if(this.set.length>1){for(let i of this.set)if(i.length===1&&sV(i[0])){this.set=[i];break}}}this.format();}format(){return this.range=this.set.map(t=>t.join(" ").trim()).join("||").trim(),this.range}toString(){return this.range}parseRange(t){let n=((this.options.includePrerelease&&nV)|(this.options.loose&&iV))+":"+t,i=RT.get(n);if(i)return i;let s=this.options.loose,o=s?en[jr.HYPHENRANGELOOSE]:en[jr.HYPHENRANGE];t=t.replace(o,gV(this.options.includePrerelease)),$t("hyphen replace",t),t=t.replace(en[jr.COMPARATORTRIM],eV),$t("comparator trim",t),t=t.replace(en[jr.TILDETRIM],tV),$t("tilde trim",t),t=t.replace(en[jr.CARETTRIM],rV),$t("caret trim",t);let a=t.split(" ").map(f=>oV(f,this.options)).join(" ").split(/\s+/).map(f=>pV(f,this.options));s&&(a=a.filter(f=>($t("loose invalid filter",f,this.options),!!f.match(en[jr.COMPARATORLOOSE])))),$t("range list",a);let c=new Map,l=a.map(f=>new t0(f,this.options));for(let f of l){if(IT(f))return [f];c.set(f.value,f);}c.size>1&&c.has("")&&c.delete("");let u=[...c.values()];return RT.set(n,u),u}intersects(t,r){if(!(t instanceof e))throw new TypeError("a Range is required");return this.set.some(n=>DT(n,r)&&t.set.some(i=>DT(i,r)&&n.every(s=>i.every(o=>s.intersects(o,r)))))}test(t){if(!t)return !1;if(typeof t=="string")try{t=new Zj(t,this.options);}catch{return !1}for(let r=0;r<this.set.length;r++)if(mV(this.set[r],t,this.options))return !0;return !1}};PT.exports=e0;var Xj=AT(),RT=new Xj({max:1e3}),Jj=Hl(),t0=Tu(),$t=Eu(),Zj=Nr(),{safeRe:en,t:jr,comparatorTrimReplace:eV,tildeTrimReplace:tV,caretTrimReplace:rV}=Qo(),{FLAG_INCLUDE_PRERELEASE:nV,FLAG_LOOSE:iV}=Cu(),IT=e=>e.value==="<0.0.0-0",sV=e=>e.value==="",DT=(e,t)=>{let r=!0,n=e.slice(),i=n.pop();for(;r&&n.length;)r=n.every(s=>i.intersects(s,t)),i=n.pop();return r},oV=(e,t)=>($t("comp",e,t),e=cV(e,t),$t("caret",e),e=aV(e,t),$t("tildes",e),e=fV(e,t),$t("xrange",e),e=dV(e,t),$t("stars",e),e),Vr=e=>!e||e.toLowerCase()==="x"||e==="*",aV=(e,t)=>e.trim().split(/\s+/).map(r=>uV(r,t)).join(" "),uV=(e,t)=>{let r=t.loose?en[jr.TILDELOOSE]:en[jr.TILDE];return e.replace(r,(n,i,s,o,a)=>{$t("tilde",e,n,i,s,o,a);let c;return Vr(i)?c="":Vr(s)?c=`>=${i}.0.0 <${+i+1}.0.0-0`:Vr(o)?c=`>=${i}.${s}.0 <${i}.${+s+1}.0-0`:a?($t("replaceTilde pr",a),c=`>=${i}.${s}.${o}-${a} <${i}.${+s+1}.0-0`):c=`>=${i}.${s}.${o} <${i}.${+s+1}.0-0`,$t("tilde return",c),c})},cV=(e,t)=>e.trim().split(/\s+/).map(r=>lV(r,t)).join(" "),lV=(e,t)=>{$t("caret",e,t);let r=t.loose?en[jr.CARETLOOSE]:en[jr.CARET],n=t.includePrerelease?"-0":"";return e.replace(r,(i,s,o,a,c)=>{$t("caret",e,i,s,o,a,c);let l;return Vr(s)?l="":Vr(o)?l=`>=${s}.0.0${n} <${+s+1}.0.0-0`:Vr(a)?s==="0"?l=`>=${s}.${o}.0${n} <${s}.${+o+1}.0-0`:l=`>=${s}.${o}.0${n} <${+s+1}.0.0-0`:c?($t("replaceCaret pr",c),s==="0"?o==="0"?l=`>=${s}.${o}.${a}-${c} <${s}.${o}.${+a+1}-0`:l=`>=${s}.${o}.${a}-${c} <${s}.${+o+1}.0-0`:l=`>=${s}.${o}.${a}-${c} <${+s+1}.0.0-0`):($t("no pr"),s==="0"?o==="0"?l=`>=${s}.${o}.${a}${n} <${s}.${o}.${+a+1}-0`:l=`>=${s}.${o}.${a}${n} <${s}.${+o+1}.0-0`:l=`>=${s}.${o}.${a} <${+s+1}.0.0-0`),$t("caret return",l),l})},fV=(e,t)=>($t("replaceXRanges",e,t),e.split(/\s+/).map(r=>hV(r,t)).join(" ")),hV=(e,t)=>{e=e.trim();let r=t.loose?en[jr.XRANGELOOSE]:en[jr.XRANGE];return e.replace(r,(n,i,s,o,a,c)=>{$t("xRange",e,n,i,s,o,a,c);let l=Vr(s),u=l||Vr(o),f=u||Vr(a),d=f;return i==="="&&d&&(i=""),c=t.includePrerelease?"-0":"",l?i===">"||i==="<"?n="<0.0.0-0":n="*":i&&d?(u&&(o=0),a=0,i===">"?(i=">=",u?(s=+s+1,o=0,a=0):(o=+o+1,a=0)):i==="<="&&(i="<",u?s=+s+1:o=+o+1),i==="<"&&(c="-0"),n=`${i+s}.${o}.${a}${c}`):u?n=`>=${s}.0.0${c} <${+s+1}.0.0-0`:f&&(n=`>=${s}.${o}.0${c} <${s}.${+o+1}.0-0`),$t("xRange return",n),n})},dV=(e,t)=>($t("replaceStars",e,t),e.trim().replace(en[jr.STAR],"")),pV=(e,t)=>($t("replaceGTE0",e,t),e.trim().replace(en[t.includePrerelease?jr.GTE0PRE:jr.GTE0],"")),gV=e=>(t,r,n,i,s,o,a,c,l,u,f,d,p)=>(Vr(n)?r="":Vr(i)?r=`>=${n}.0.0${e?"-0":""}`:Vr(s)?r=`>=${n}.${i}.0${e?"-0":""}`:o?r=`>=${r}`:r=`>=${r}${e?"-0":""}`,Vr(l)?c="":Vr(u)?c=`<${+l+1}.0.0-0`:Vr(f)?c=`<${l}.${+u+1}.0-0`:d?c=`<=${l}.${u}.${f}-${d}`:e?c=`<${l}.${u}.${+f+1}-0`:c=`<=${c}`,`${r} ${c}`.trim()),mV=(e,t,r)=>{for(let n=0;n<e.length;n++)if(!e[n].test(t))return !1;if(t.prerelease.length&&!r.includePrerelease){for(let n=0;n<e.length;n++)if($t(e[n].semver),e[n].semver!==t0.ANY&&e[n].semver.prerelease.length>0){let i=e[n].semver;if(i.major===t.major&&i.minor===t.minor&&i.patch===t.patch)return !0}return !1}return !0};});var Tu=A((Wae,qT)=>{var Au=Symbol("SemVer ANY"),i0=class e{static get ANY(){return Au}constructor(t,r){if(r=kT(r),t instanceof e){if(t.loose===!!r.loose)return t;t=t.value;}t=t.trim().split(/\s+/).join(" "),n0("comparator",t,r),this.options=r,this.loose=!!r.loose,this.parse(t),this.semver===Au?this.value="":this.value=this.operator+this.semver.version,n0("comp",this);}parse(t){let r=this.options.loose?NT[LT.COMPARATORLOOSE]:NT[LT.COMPARATOR],n=t.match(r);if(!n)throw new TypeError(`Invalid comparator: ${t}`);this.operator=n[1]!==void 0?n[1]:"",this.operator==="="&&(this.operator=""),n[2]?this.semver=new OT(n[2],this.options.loose):this.semver=Au;}toString(){return this.value}test(t){if(n0("Comparator.test",t,this.options.loose),this.semver===Au||t===Au)return !0;if(typeof t=="string")try{t=new OT(t,this.options);}catch{return !1}return r0(t,this.operator,this.semver,this.options)}intersects(t,r){if(!(t instanceof e))throw new TypeError("a Comparator is required");return this.operator===""?this.value===""?!0:new BT(t.value,r).test(this.value):t.operator===""?t.value===""?!0:new BT(this.value,r).test(t.semver):(r=kT(r),r.includePrerelease&&(this.value==="<0.0.0-0"||t.value==="<0.0.0-0")||!r.includePrerelease&&(this.value.startsWith("<0.0.0")||t.value.startsWith("<0.0.0"))?!1:!!(this.operator.startsWith(">")&&t.operator.startsWith(">")||this.operator.startsWith("<")&&t.operator.startsWith("<")||this.semver.version===t.semver.version&&this.operator.includes("=")&&t.operator.includes("=")||r0(this.semver,"<",t.semver,r)&&this.operator.startsWith(">")&&t.operator.startsWith("<")||r0(this.semver,">",t.semver,r)&&this.operator.startsWith("<")&&t.operator.startsWith(">")))}};qT.exports=i0;var kT=Hl(),{safeRe:NT,t:LT}=Qo(),r0=Yg(),n0=Eu(),OT=Nr(),BT=Pn();});var Ru=A((Kae,FT)=>{var yV=Pn(),vV=(e,t,r)=>{try{t=new yV(t,r);}catch{return !1}return t.test(e)};FT.exports=vV;});var UT=A((zae,MT)=>{var SV=Pn(),bV=(e,t)=>new SV(e,t).set.map(r=>r.map(n=>n.value).join(" ").trim().split(" "));MT.exports=bV;});var jT=A((Gae,$T)=>{var CV=Nr(),EV=Pn(),xV=(e,t,r)=>{let n=null,i=null,s=null;try{s=new EV(t,r);}catch{return null}return e.forEach(o=>{s.test(o)&&(!n||i.compare(o)===-1)&&(n=o,i=new CV(n,r));}),n};$T.exports=xV;});var HT=A((Yae,VT)=>{var wV=Nr(),_V=Pn(),TV=(e,t,r)=>{let n=null,i=null,s=null;try{s=new _V(t,r);}catch{return null}return e.forEach(o=>{s.test(o)&&(!n||i.compare(o)===1)&&(n=o,i=new wV(n,r));}),n};VT.exports=TV;});var zT=A((Qae,KT)=>{var s0=Nr(),AV=Pn(),WT=xu(),RV=(e,t)=>{e=new AV(e,t);let r=new s0("0.0.0");if(e.test(r)||(r=new s0("0.0.0-0"),e.test(r)))return r;r=null;for(let n=0;n<e.set.length;++n){let i=e.set[n],s=null;i.forEach(o=>{let a=new s0(o.semver.version);switch(o.operator){case">":a.prerelease.length===0?a.patch++:a.prerelease.push(0),a.raw=a.format();case"":case">=":(!s||WT(a,s))&&(s=a);break;case"<":case"<=":break;default:throw new Error(`Unexpected operation: ${o.operator}`)}}),s&&(!r||WT(r,s))&&(r=s);}return r&&e.test(r)?r:null};KT.exports=RV;});var YT=A((Xae,GT)=>{var IV=Pn(),DV=(e,t)=>{try{return new IV(e,t).range||"*"}catch{return null}};GT.exports=DV;});var ef=A((Jae,ZT)=>{var PV=Nr(),JT=Tu(),{ANY:kV}=JT,NV=Pn(),LV=Ru(),QT=xu(),XT=Gl(),OV=Ql(),BV=Yl(),qV=(e,t,r,n)=>{e=new PV(e,n),t=new NV(t,n);let i,s,o,a,c;switch(r){case">":i=QT,s=OV,o=XT,a=">",c=">=";break;case"<":i=XT,s=BV,o=QT,a="<",c="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(LV(e,t,n))return !1;for(let l=0;l<t.set.length;++l){let u=t.set[l],f=null,d=null;if(u.forEach(p=>{p.semver===kV&&(p=new JT(">=0.0.0")),f=f||p,d=d||p,i(p.semver,f.semver,n)?f=p:o(p.semver,d.semver,n)&&(d=p);}),f.operator===a||f.operator===c||(!d.operator||d.operator===a)&&s(e,d.semver))return !1;if(d.operator===c&&o(e,d.semver))return !1}return !0};ZT.exports=qV;});var tA=A((Zae,eA)=>{var FV=ef(),MV=(e,t,r)=>FV(e,t,">",r);eA.exports=MV;});var nA=A((eue,rA)=>{var UV=ef(),$V=(e,t,r)=>UV(e,t,"<",r);rA.exports=$V;});var oA=A((tue,sA)=>{var iA=Pn(),jV=(e,t,r)=>(e=new iA(e,r),t=new iA(t,r),e.intersects(t,r));sA.exports=jV;});var uA=A((rue,aA)=>{var VV=Ru(),HV=Dn();aA.exports=(e,t,r)=>{let n=[],i=null,s=null,o=e.sort((u,f)=>HV(u,f,r));for(let u of o)VV(u,t,r)?(s=u,i||(i=u)):(s&&n.push([i,s]),s=null,i=null);i&&n.push([i,null]);let a=[];for(let[u,f]of n)u===f?a.push(u):!f&&u===o[0]?a.push("*"):f?u===o[0]?a.push(`<=${f}`):a.push(`${u} - ${f}`):a.push(`>=${u}`);let c=a.join(" || "),l=typeof t.raw=="string"?t.raw:String(t);return c.length<l.length?c:t};});var pA=A((nue,dA)=>{var cA=Pn(),a0=Tu(),{ANY:o0}=a0,Iu=Ru(),u0=Dn(),WV=(e,t,r={})=>{if(e===t)return !0;e=new cA(e,r),t=new cA(t,r);let n=!1;e:for(let i of e.set){for(let s of t.set){let o=zV(i,s,r);if(n=n||o!==null,o)continue e}if(n)return !1}return !0},KV=[new a0(">=0.0.0-0")],lA=[new a0(">=0.0.0")],zV=(e,t,r)=>{if(e===t)return !0;if(e.length===1&&e[0].semver===o0){if(t.length===1&&t[0].semver===o0)return !0;r.includePrerelease?e=KV:e=lA;}if(t.length===1&&t[0].semver===o0){if(r.includePrerelease)return !0;t=lA;}let n=new Set,i,s;for(let p of e)p.operator===">"||p.operator===">="?i=fA(i,p,r):p.operator==="<"||p.operator==="<="?s=hA(s,p,r):n.add(p.semver);if(n.size>1)return null;let o;if(i&&s){if(o=u0(i.semver,s.semver,r),o>0)return null;if(o===0&&(i.operator!==">="||s.operator!=="<="))return null}for(let p of n){if(i&&!Iu(p,String(i),r)||s&&!Iu(p,String(s),r))return null;for(let m of t)if(!Iu(p,String(m),r))return !1;return !0}let a,c,l,u,f=s&&!r.includePrerelease&&s.semver.prerelease.length?s.semver:!1,d=i&&!r.includePrerelease&&i.semver.prerelease.length?i.semver:!1;f&&f.prerelease.length===1&&s.operator==="<"&&f.prerelease[0]===0&&(f=!1);for(let p of t){if(u=u||p.operator===">"||p.operator===">=",l=l||p.operator==="<"||p.operator==="<=",i){if(d&&p.semver.prerelease&&p.semver.prerelease.length&&p.semver.major===d.major&&p.semver.minor===d.minor&&p.semver.patch===d.patch&&(d=!1),p.operator===">"||p.operator===">="){if(a=fA(i,p,r),a===p&&a!==i)return !1}else if(i.operator===">="&&!Iu(i.semver,String(p),r))return !1}if(s){if(f&&p.semver.prerelease&&p.semver.prerelease.length&&p.semver.major===f.major&&p.semver.minor===f.minor&&p.semver.patch===f.patch&&(f=!1),p.operator==="<"||p.operator==="<="){if(c=hA(s,p,r),c===p&&c!==s)return !1}else if(s.operator==="<="&&!Iu(s.semver,String(p),r))return !1}if(!p.operator&&(s||i)&&o!==0)return !1}return !(i&&l&&!s&&o!==0||s&&u&&!i&&o!==0||d||f)},fA=(e,t,r)=>{if(!e)return t;let n=u0(e.semver,t.semver,r);return n>0?e:n<0||t.operator===">"&&e.operator===">="?t:e},hA=(e,t,r)=>{if(!e)return t;let n=u0(e.semver,t.semver,r);return n<0?e:n>0||t.operator==="<"&&e.operator==="<="?t:e};dA.exports=WV;});var vA=A((iue,yA)=>{var c0=Qo(),gA=Cu(),GV=Nr(),mA=Wg(),YV=Xs(),QV=O_(),XV=q_(),JV=U_(),ZV=V_(),eH=W_(),tH=z_(),rH=Y_(),nH=X_(),iH=Dn(),sH=tT(),oH=nT(),aH=zl(),uH=aT(),cH=cT(),lH=xu(),fH=Gl(),hH=zg(),dH=Gg(),pH=Yl(),gH=Ql(),mH=Yg(),yH=vT(),vH=Tu(),SH=Pn(),bH=Ru(),CH=UT(),EH=jT(),xH=HT(),wH=zT(),_H=YT(),TH=ef(),AH=tA(),RH=nA(),IH=oA(),DH=uA(),PH=pA();yA.exports={parse:YV,valid:QV,clean:XV,inc:JV,diff:ZV,major:eH,minor:tH,patch:rH,prerelease:nH,compare:iH,rcompare:sH,compareLoose:oH,compareBuild:aH,sort:uH,rsort:cH,gt:lH,lt:fH,eq:hH,neq:dH,gte:pH,lte:gH,cmp:mH,coerce:yH,Comparator:vH,Range:SH,satisfies:bH,toComparators:CH,maxSatisfying:EH,minSatisfying:xH,minVersion:wH,validRange:_H,outside:TH,gtr:AH,ltr:RH,intersects:IH,simplifyRange:DH,subset:PH,SemVer:GV,re:c0.re,src:c0.src,tokens:c0.t,SEMVER_SPEC_VERSION:gA.SEMVER_SPEC_VERSION,RELEASE_TYPES:gA.RELEASE_TYPES,compareIdentifiers:mA.compareIdentifiers,rcompareIdentifiers:mA.rcompareIdentifiers};});var dr=A(l0=>{l0.fromCallback=function(e){return Object.defineProperty(function(...t){if(typeof t[t.length-1]=="function")e.apply(this,t);else return new Promise((r,n)=>{t.push((i,s)=>i!=null?n(i):r(s)),e.apply(this,t);})},"name",{value:e.name})};l0.fromPromise=function(e){return Object.defineProperty(function(...t){let r=t[t.length-1];if(typeof r!="function")return e.apply(this,t);t.pop(),e.apply(this,t).then(n=>r(null,n),r);},"name",{value:e.name})};});var bA=A((oue,SA)=>{var cs=he("constants"),kH=process.cwd,tf=null,NH=process.env.GRACEFUL_FS_PLATFORM||process.platform;process.cwd=function(){return tf||(tf=kH.call(process)),tf};try{process.cwd();}catch{}typeof process.chdir=="function"&&(f0=process.chdir,process.chdir=function(e){tf=null,f0.call(process,e);},Object.setPrototypeOf&&Object.setPrototypeOf(process.chdir,f0));var f0;SA.exports=LH;function LH(e){cs.hasOwnProperty("O_SYMLINK")&&process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)&&t(e),e.lutimes||r(e),e.chown=s(e.chown),e.fchown=s(e.fchown),e.lchown=s(e.lchown),e.chmod=n(e.chmod),e.fchmod=n(e.fchmod),e.lchmod=n(e.lchmod),e.chownSync=o(e.chownSync),e.fchownSync=o(e.fchownSync),e.lchownSync=o(e.lchownSync),e.chmodSync=i(e.chmodSync),e.fchmodSync=i(e.fchmodSync),e.lchmodSync=i(e.lchmodSync),e.stat=a(e.stat),e.fstat=a(e.fstat),e.lstat=a(e.lstat),e.statSync=c(e.statSync),e.fstatSync=c(e.fstatSync),e.lstatSync=c(e.lstatSync),e.chmod&&!e.lchmod&&(e.lchmod=function(u,f,d){d&&process.nextTick(d);},e.lchmodSync=function(){}),e.chown&&!e.lchown&&(e.lchown=function(u,f,d,p){p&&process.nextTick(p);},e.lchownSync=function(){}),NH==="win32"&&(e.rename=typeof e.rename!="function"?e.rename:function(u){function f(d,p,m){var S=Date.now(),x=0;u(d,p,function I(v){if(v&&(v.code==="EACCES"||v.code==="EPERM"||v.code==="EBUSY")&&Date.now()-S<6e4){setTimeout(function(){e.stat(p,function(b,D){b&&b.code==="ENOENT"?u(d,p,I):m(v);});},x),x<100&&(x+=10);return}m&&m(v);});}return Object.setPrototypeOf&&Object.setPrototypeOf(f,u),f}(e.rename)),e.read=typeof e.read!="function"?e.read:function(u){function f(d,p,m,S,x,I){var v;if(I&&typeof I=="function"){var b=0;v=function(D,L,j){if(D&&D.code==="EAGAIN"&&b<10)return b++,u.call(e,d,p,m,S,x,v);I.apply(this,arguments);};}return u.call(e,d,p,m,S,x,v)}return Object.setPrototypeOf&&Object.setPrototypeOf(f,u),f}(e.read),e.readSync=typeof e.readSync!="function"?e.readSync:function(u){return function(f,d,p,m,S){for(var x=0;;)try{return u.call(e,f,d,p,m,S)}catch(I){if(I.code==="EAGAIN"&&x<10){x++;continue}throw I}}}(e.readSync);function t(u){u.lchmod=function(f,d,p){u.open(f,cs.O_WRONLY|cs.O_SYMLINK,d,function(m,S){if(m){p&&p(m);return}u.fchmod(S,d,function(x){u.close(S,function(I){p&&p(x||I);});});});},u.lchmodSync=function(f,d){var p=u.openSync(f,cs.O_WRONLY|cs.O_SYMLINK,d),m=!0,S;try{S=u.fchmodSync(p,d),m=!1;}finally{if(m)try{u.closeSync(p);}catch{}else u.closeSync(p);}return S};}function r(u){cs.hasOwnProperty("O_SYMLINK")&&u.futimes?(u.lutimes=function(f,d,p,m){u.open(f,cs.O_SYMLINK,function(S,x){if(S){m&&m(S);return}u.futimes(x,d,p,function(I){u.close(x,function(v){m&&m(I||v);});});});},u.lutimesSync=function(f,d,p){var m=u.openSync(f,cs.O_SYMLINK),S,x=!0;try{S=u.futimesSync(m,d,p),x=!1;}finally{if(x)try{u.closeSync(m);}catch{}else u.closeSync(m);}return S}):u.futimes&&(u.lutimes=function(f,d,p,m){m&&process.nextTick(m);},u.lutimesSync=function(){});}function n(u){return u&&function(f,d,p){return u.call(e,f,d,function(m){l(m)&&(m=null),p&&p.apply(this,arguments);})}}function i(u){return u&&function(f,d){try{return u.call(e,f,d)}catch(p){if(!l(p))throw p}}}function s(u){return u&&function(f,d,p,m){return u.call(e,f,d,p,function(S){l(S)&&(S=null),m&&m.apply(this,arguments);})}}function o(u){return u&&function(f,d,p){try{return u.call(e,f,d,p)}catch(m){if(!l(m))throw m}}}function a(u){return u&&function(f,d,p){typeof d=="function"&&(p=d,d=null);function m(S,x){x&&(x.uid<0&&(x.uid+=4294967296),x.gid<0&&(x.gid+=4294967296)),p&&p.apply(this,arguments);}return d?u.call(e,f,d,m):u.call(e,f,m)}}function c(u){return u&&function(f,d){var p=d?u.call(e,f,d):u.call(e,f);return p&&(p.uid<0&&(p.uid+=4294967296),p.gid<0&&(p.gid+=4294967296)),p}}function l(u){if(!u||u.code==="ENOSYS")return !0;var f=!process.getuid||process.getuid()!==0;return !!(f&&(u.code==="EINVAL"||u.code==="EPERM"))}}});var xA=A((aue,EA)=>{var CA=he("stream").Stream;EA.exports=OH;function OH(e){return {ReadStream:t,WriteStream:r};function t(n,i){if(!(this instanceof t))return new t(n,i);CA.call(this);var s=this;this.path=n,this.fd=null,this.readable=!0,this.paused=!1,this.flags="r",this.mode=438,this.bufferSize=64*1024,i=i||{};for(var o=Object.keys(i),a=0,c=o.length;a<c;a++){var l=o[a];this[l]=i[l];}if(this.encoding&&this.setEncoding(this.encoding),this.start!==void 0){if(typeof this.start!="number")throw TypeError("start must be a Number");if(this.end===void 0)this.end=1/0;else if(typeof this.end!="number")throw TypeError("end must be a Number");if(this.start>this.end)throw new Error("start must be <= end");this.pos=this.start;}if(this.fd!==null){process.nextTick(function(){s._read();});return}e.open(this.path,this.flags,this.mode,function(u,f){if(u){s.emit("error",u),s.readable=!1;return}s.fd=f,s.emit("open",f),s._read();});}function r(n,i){if(!(this instanceof r))return new r(n,i);CA.call(this),this.path=n,this.fd=null,this.writable=!0,this.flags="w",this.encoding="binary",this.mode=438,this.bytesWritten=0,i=i||{};for(var s=Object.keys(i),o=0,a=s.length;o<a;o++){var c=s[o];this[c]=i[c];}if(this.start!==void 0){if(typeof this.start!="number")throw TypeError("start must be a Number");if(this.start<0)throw new Error("start must be >= zero");this.pos=this.start;}this.busy=!1,this._queue=[],this.fd===null&&(this._open=e.open,this._queue.push([this._open,this.path,this.flags,this.mode,void 0]),this.flush());}}});var _A=A((uue,wA)=>{wA.exports=qH;var BH=Object.getPrototypeOf||function(e){return e.__proto__};function qH(e){if(e===null||typeof e!="object")return e;if(e instanceof Object)var t={__proto__:BH(e)};else var t=Object.create(null);return Object.getOwnPropertyNames(e).forEach(function(r){Object.defineProperty(t,r,Object.getOwnPropertyDescriptor(e,r));}),t}});var ta=A((cue,p0)=>{var Qt=he("fs"),FH=bA(),MH=xA(),UH=_A(),rf=he("util"),Ar,sf;typeof Symbol=="function"&&typeof Symbol.for=="function"?(Ar=Symbol.for("graceful-fs.queue"),sf=Symbol.for("graceful-fs.previous")):(Ar="___graceful-fs.queue",sf="___graceful-fs.previous");function $H(){}function RA(e,t){Object.defineProperty(e,Ar,{get:function(){return t}});}var to=$H;rf.debuglog?to=rf.debuglog("gfs4"):/\bgfs4\b/i.test(process.env.NODE_DEBUG||"")&&(to=function(){var e=rf.format.apply(rf,arguments);e="GFS4: "+e.split(/\n/).join(`
GFS4: `),console.error(e);});Qt[Ar]||(TA=global[Ar]||[],RA(Qt,TA),Qt.close=function(e){function t(r,n){return e.call(Qt,r,function(i){i||AA(),typeof n=="function"&&n.apply(this,arguments);})}return Object.defineProperty(t,sf,{value:e}),t}(Qt.close),Qt.closeSync=function(e){function t(r){e.apply(Qt,arguments),AA();}return Object.defineProperty(t,sf,{value:e}),t}(Qt.closeSync),/\bgfs4\b/i.test(process.env.NODE_DEBUG||"")&&process.on("exit",function(){to(Qt[Ar]),he("assert").equal(Qt[Ar].length,0);}));var TA;global[Ar]||RA(global,Qt[Ar]);p0.exports=h0(UH(Qt));process.env.TEST_GRACEFUL_FS_GLOBAL_PATCH&&!Qt.__patched&&(p0.exports=h0(Qt),Qt.__patched=!0);function h0(e){FH(e),e.gracefulify=h0,e.createReadStream=L,e.createWriteStream=j;var t=e.readFile;e.readFile=r;function r(G,ee,M){return typeof ee=="function"&&(M=ee,ee=null),ae(G,ee,M);function ae(me,Le,H,W){return t(me,Le,function(se){se&&(se.code==="EMFILE"||se.code==="ENFILE")?ea([ae,[me,Le,H],se,W||Date.now(),Date.now()]):typeof H=="function"&&H.apply(this,arguments);})}}var n=e.writeFile;e.writeFile=i;function i(G,ee,M,ae){return typeof M=="function"&&(ae=M,M=null),me(G,ee,M,ae);function me(Le,H,W,se,Te){return n(Le,H,W,function(Fe){Fe&&(Fe.code==="EMFILE"||Fe.code==="ENFILE")?ea([me,[Le,H,W,se],Fe,Te||Date.now(),Date.now()]):typeof se=="function"&&se.apply(this,arguments);})}}var s=e.appendFile;s&&(e.appendFile=o);function o(G,ee,M,ae){return typeof M=="function"&&(ae=M,M=null),me(G,ee,M,ae);function me(Le,H,W,se,Te){return s(Le,H,W,function(Fe){Fe&&(Fe.code==="EMFILE"||Fe.code==="ENFILE")?ea([me,[Le,H,W,se],Fe,Te||Date.now(),Date.now()]):typeof se=="function"&&se.apply(this,arguments);})}}var a=e.copyFile;a&&(e.copyFile=c);function c(G,ee,M,ae){return typeof M=="function"&&(ae=M,M=0),me(G,ee,M,ae);function me(Le,H,W,se,Te){return a(Le,H,W,function(Fe){Fe&&(Fe.code==="EMFILE"||Fe.code==="ENFILE")?ea([me,[Le,H,W,se],Fe,Te||Date.now(),Date.now()]):typeof se=="function"&&se.apply(this,arguments);})}}var l=e.readdir;e.readdir=f;var u=/^v[0-5]\./;function f(G,ee,M){typeof ee=="function"&&(M=ee,ee=null);var ae=u.test(process.version)?function(H,W,se,Te){return l(H,me(H,W,se,Te))}:function(H,W,se,Te){return l(H,W,me(H,W,se,Te))};return ae(G,ee,M);function me(Le,H,W,se){return function(Te,Fe){Te&&(Te.code==="EMFILE"||Te.code==="ENFILE")?ea([ae,[Le,H,W],Te,se||Date.now(),Date.now()]):(Fe&&Fe.sort&&Fe.sort(),typeof W=="function"&&W.call(this,Te,Fe));}}}if(process.version.substr(0,4)==="v0.8"){var d=MH(e);I=d.ReadStream,b=d.WriteStream;}var p=e.ReadStream;p&&(I.prototype=Object.create(p.prototype),I.prototype.open=v);var m=e.WriteStream;m&&(b.prototype=Object.create(m.prototype),b.prototype.open=D),Object.defineProperty(e,"ReadStream",{get:function(){return I},set:function(G){I=G;},enumerable:!0,configurable:!0}),Object.defineProperty(e,"WriteStream",{get:function(){return b},set:function(G){b=G;},enumerable:!0,configurable:!0});var S=I;Object.defineProperty(e,"FileReadStream",{get:function(){return S},set:function(G){S=G;},enumerable:!0,configurable:!0});var x=b;Object.defineProperty(e,"FileWriteStream",{get:function(){return x},set:function(G){x=G;},enumerable:!0,configurable:!0});function I(G,ee){return this instanceof I?(p.apply(this,arguments),this):I.apply(Object.create(I.prototype),arguments)}function v(){var G=this;K(G.path,G.flags,G.mode,function(ee,M){ee?(G.autoClose&&G.destroy(),G.emit("error",ee)):(G.fd=M,G.emit("open",M),G.read());});}function b(G,ee){return this instanceof b?(m.apply(this,arguments),this):b.apply(Object.create(b.prototype),arguments)}function D(){var G=this;K(G.path,G.flags,G.mode,function(ee,M){ee?(G.destroy(),G.emit("error",ee)):(G.fd=M,G.emit("open",M));});}function L(G,ee){return new e.ReadStream(G,ee)}function j(G,ee){return new e.WriteStream(G,ee)}var J=e.open;e.open=K;function K(G,ee,M,ae){return typeof M=="function"&&(ae=M,M=null),me(G,ee,M,ae);function me(Le,H,W,se,Te){return J(Le,H,W,function(Fe,ze){Fe&&(Fe.code==="EMFILE"||Fe.code==="ENFILE")?ea([me,[Le,H,W,se],Fe,Te||Date.now(),Date.now()]):typeof se=="function"&&se.apply(this,arguments);})}}return e}function ea(e){to("ENQUEUE",e[0].name,e[1]),Qt[Ar].push(e),d0();}var nf;function AA(){for(var e=Date.now(),t=0;t<Qt[Ar].length;++t)Qt[Ar][t].length>2&&(Qt[Ar][t][3]=e,Qt[Ar][t][4]=e);d0();}function d0(){if(clearTimeout(nf),nf=void 0,Qt[Ar].length!==0){var e=Qt[Ar].shift(),t=e[0],r=e[1],n=e[2],i=e[3],s=e[4];if(i===void 0)to("RETRY",t.name,r),t.apply(null,r);else if(Date.now()-i>=6e4){to("TIMEOUT",t.name,r);var o=r.pop();typeof o=="function"&&o.call(null,n);}else {var a=Date.now()-s,c=Math.max(s-i,1),l=Math.min(c*1.2,100);a>=l?(to("RETRY",t.name,r),t.apply(null,r.concat([i]))):Qt[Ar].push(e);}nf===void 0&&(nf=setTimeout(d0,0));}}});var Wr=A(qi=>{var IA=dr().fromCallback,Hr=ta(),jH=["access","appendFile","chmod","chown","close","copyFile","fchmod","fchown","fdatasync","fstat","fsync","ftruncate","futimes","lchmod","lchown","link","lstat","mkdir","mkdtemp","open","opendir","readdir","readFile","readlink","realpath","rename","rm","rmdir","stat","symlink","truncate","unlink","utimes","writeFile"].filter(e=>typeof Hr[e]=="function");Object.assign(qi,Hr);jH.forEach(e=>{qi[e]=IA(Hr[e]);});qi.exists=function(e,t){return typeof t=="function"?Hr.exists(e,t):new Promise(r=>Hr.exists(e,r))};qi.read=function(e,t,r,n,i,s){return typeof s=="function"?Hr.read(e,t,r,n,i,s):new Promise((o,a)=>{Hr.read(e,t,r,n,i,(c,l,u)=>{if(c)return a(c);o({bytesRead:l,buffer:u});});})};qi.write=function(e,t,...r){return typeof r[r.length-1]=="function"?Hr.write(e,t,...r):new Promise((n,i)=>{Hr.write(e,t,...r,(s,o,a)=>{if(s)return i(s);n({bytesWritten:o,buffer:a});});})};qi.readv=function(e,t,...r){return typeof r[r.length-1]=="function"?Hr.readv(e,t,...r):new Promise((n,i)=>{Hr.readv(e,t,...r,(s,o,a)=>{if(s)return i(s);n({bytesRead:o,buffers:a});});})};qi.writev=function(e,t,...r){return typeof r[r.length-1]=="function"?Hr.writev(e,t,...r):new Promise((n,i)=>{Hr.writev(e,t,...r,(s,o,a)=>{if(s)return i(s);n({bytesWritten:o,buffers:a});});})};typeof Hr.realpath.native=="function"?qi.realpath.native=IA(Hr.realpath.native):process.emitWarning("fs.realpath.native is not a function. Is fs being monkey-patched?","Warning","fs-extra-WARN0003");});var PA=A((fue,DA)=>{var VH=he("path");DA.exports.checkPath=function(t){if(process.platform==="win32"&&/[<>:"|?*]/.test(t.replace(VH.parse(t).root,""))){let n=new Error(`Path contains invalid characters: ${t}`);throw n.code="EINVAL",n}};});var OA=A((hue,g0)=>{var kA=Wr(),{checkPath:NA}=PA(),LA=e=>{let t={mode:511};return typeof e=="number"?e:{...t,...e}.mode};g0.exports.makeDir=async(e,t)=>(NA(e),kA.mkdir(e,{mode:LA(t),recursive:!0}));g0.exports.makeDirSync=(e,t)=>(NA(e),kA.mkdirSync(e,{mode:LA(t),recursive:!0}));});var Xn=A((due,BA)=>{var HH=dr().fromPromise,{makeDir:WH,makeDirSync:m0}=OA(),y0=HH(WH);BA.exports={mkdirs:y0,mkdirsSync:m0,mkdirp:y0,mkdirpSync:m0,ensureDir:y0,ensureDirSync:m0};});var ls=A((pue,FA)=>{var KH=dr().fromPromise,qA=Wr();function zH(e){return qA.access(e).then(()=>!0).catch(()=>!1)}FA.exports={pathExists:KH(zH),pathExistsSync:qA.existsSync};});var v0=A((gue,MA)=>{var ra=Wr(),GH=dr().fromPromise;async function YH(e,t,r){let n=await ra.open(e,"r+"),i=null;try{await ra.futimes(n,t,r);}finally{try{await ra.close(n);}catch(s){i=s;}}if(i)throw i}function QH(e,t,r){let n=ra.openSync(e,"r+");return ra.futimesSync(n,t,r),ra.closeSync(n)}MA.exports={utimesMillis:GH(YH),utimesMillisSync:QH};});var ro=A((mue,VA)=>{var na=Wr(),pr=he("path"),UA=dr().fromPromise;function XH(e,t,r){let n=r.dereference?i=>na.stat(i,{bigint:!0}):i=>na.lstat(i,{bigint:!0});return Promise.all([n(e),n(t).catch(i=>{if(i.code==="ENOENT")return null;throw i})]).then(([i,s])=>({srcStat:i,destStat:s}))}function JH(e,t,r){let n,i=r.dereference?o=>na.statSync(o,{bigint:!0}):o=>na.lstatSync(o,{bigint:!0}),s=i(e);try{n=i(t);}catch(o){if(o.code==="ENOENT")return {srcStat:s,destStat:null};throw o}return {srcStat:s,destStat:n}}async function ZH(e,t,r,n){let{srcStat:i,destStat:s}=await XH(e,t,n);if(s){if(Du(i,s)){let o=pr.basename(e),a=pr.basename(t);if(r==="move"&&o!==a&&o.toLowerCase()===a.toLowerCase())return {srcStat:i,destStat:s,isChangingCase:!0};throw new Error("Source and destination must not be the same.")}if(i.isDirectory()&&!s.isDirectory())throw new Error(`Cannot overwrite non-directory '${t}' with directory '${e}'.`);if(!i.isDirectory()&&s.isDirectory())throw new Error(`Cannot overwrite directory '${t}' with non-directory '${e}'.`)}if(i.isDirectory()&&S0(e,t))throw new Error(of(e,t,r));return {srcStat:i,destStat:s}}function e9(e,t,r,n){let{srcStat:i,destStat:s}=JH(e,t,n);if(s){if(Du(i,s)){let o=pr.basename(e),a=pr.basename(t);if(r==="move"&&o!==a&&o.toLowerCase()===a.toLowerCase())return {srcStat:i,destStat:s,isChangingCase:!0};throw new Error("Source and destination must not be the same.")}if(i.isDirectory()&&!s.isDirectory())throw new Error(`Cannot overwrite non-directory '${t}' with directory '${e}'.`);if(!i.isDirectory()&&s.isDirectory())throw new Error(`Cannot overwrite directory '${t}' with non-directory '${e}'.`)}if(i.isDirectory()&&S0(e,t))throw new Error(of(e,t,r));return {srcStat:i,destStat:s}}async function $A(e,t,r,n){let i=pr.resolve(pr.dirname(e)),s=pr.resolve(pr.dirname(r));if(s===i||s===pr.parse(s).root)return;let o;try{o=await na.stat(s,{bigint:!0});}catch(a){if(a.code==="ENOENT")return;throw a}if(Du(t,o))throw new Error(of(e,r,n));return $A(e,t,s,n)}function jA(e,t,r,n){let i=pr.resolve(pr.dirname(e)),s=pr.resolve(pr.dirname(r));if(s===i||s===pr.parse(s).root)return;let o;try{o=na.statSync(s,{bigint:!0});}catch(a){if(a.code==="ENOENT")return;throw a}if(Du(t,o))throw new Error(of(e,r,n));return jA(e,t,s,n)}function Du(e,t){return t.ino&&t.dev&&t.ino===e.ino&&t.dev===e.dev}function S0(e,t){let r=pr.resolve(e).split(pr.sep).filter(i=>i),n=pr.resolve(t).split(pr.sep).filter(i=>i);return r.every((i,s)=>n[s]===i)}function of(e,t,r){return `Cannot ${r} '${e}' to a subdirectory of itself, '${t}'.`}VA.exports={checkPaths:UA(ZH),checkPathsSync:e9,checkParentPaths:UA($A),checkParentPathsSync:jA,isSrcSubdir:S0,areIdentical:Du};});var GA=A((yue,zA)=>{var Lr=Wr(),Pu=he("path"),{mkdirs:t9}=Xn(),{pathExists:r9}=ls(),{utimesMillis:n9}=v0(),ku=ro();async function i9(e,t,r={}){typeof r=="function"&&(r={filter:r}),r.clobber="clobber"in r?!!r.clobber:!0,r.overwrite="overwrite"in r?!!r.overwrite:r.clobber,r.preserveTimestamps&&process.arch==="ia32"&&process.emitWarning(`Using the preserveTimestamps option in 32-bit node is not recommended;

	see https://github.com/jprichardson/node-fs-extra/issues/269`,"Warning","fs-extra-WARN0001");let{srcStat:n,destStat:i}=await ku.checkPaths(e,t,"copy",r);if(await ku.checkParentPaths(e,n,t,"copy"),!await WA(e,t,r))return;let o=Pu.dirname(t);await r9(o)||await t9(o),await KA(i,e,t,r);}async function WA(e,t,r){return r.filter?r.filter(e,t):!0}async function KA(e,t,r,n){let s=await(n.dereference?Lr.stat:Lr.lstat)(t);if(s.isDirectory())return u9(s,e,t,r,n);if(s.isFile()||s.isCharacterDevice()||s.isBlockDevice())return s9(s,e,t,r,n);if(s.isSymbolicLink())return c9(e,t,r,n);throw s.isSocket()?new Error(`Cannot copy a socket file: ${t}`):s.isFIFO()?new Error(`Cannot copy a FIFO pipe: ${t}`):new Error(`Unknown file: ${t}`)}async function s9(e,t,r,n,i){if(!t)return HA(e,r,n,i);if(i.overwrite)return await Lr.unlink(n),HA(e,r,n,i);if(i.errorOnExist)throw new Error(`'${n}' already exists`)}async function HA(e,t,r,n){if(await Lr.copyFile(t,r),n.preserveTimestamps){o9(e.mode)&&await a9(r,e.mode);let i=await Lr.stat(t);await n9(r,i.atime,i.mtime);}return Lr.chmod(r,e.mode)}function o9(e){return (e&128)===0}function a9(e,t){return Lr.chmod(e,t|128)}async function u9(e,t,r,n,i){t||await Lr.mkdir(n);let s=await Lr.readdir(r);await Promise.all(s.map(async o=>{let a=Pu.join(r,o),c=Pu.join(n,o);if(!await WA(a,c,i))return;let{destStat:u}=await ku.checkPaths(a,c,"copy",i);return KA(u,a,c,i)})),t||await Lr.chmod(n,e.mode);}async function c9(e,t,r,n){let i=await Lr.readlink(t);if(n.dereference&&(i=Pu.resolve(process.cwd(),i)),!e)return Lr.symlink(i,r);let s=null;try{s=await Lr.readlink(r);}catch(o){if(o.code==="EINVAL"||o.code==="UNKNOWN")return Lr.symlink(i,r);throw o}if(n.dereference&&(s=Pu.resolve(process.cwd(),s)),ku.isSrcSubdir(i,s))throw new Error(`Cannot copy '${i}' to a subdirectory of itself, '${s}'.`);if(ku.isSrcSubdir(s,i))throw new Error(`Cannot overwrite '${s}' with '${i}'.`);return await Lr.unlink(r),Lr.symlink(i,r)}zA.exports=i9;});var ZA=A((vue,JA)=>{var Kr=ta(),Nu=he("path"),l9=Xn().mkdirsSync,f9=v0().utimesMillisSync,Lu=ro();function h9(e,t,r){typeof r=="function"&&(r={filter:r}),r=r||{},r.clobber="clobber"in r?!!r.clobber:!0,r.overwrite="overwrite"in r?!!r.overwrite:r.clobber,r.preserveTimestamps&&process.arch==="ia32"&&process.emitWarning(`Using the preserveTimestamps option in 32-bit node is not recommended;

	see https://github.com/jprichardson/node-fs-extra/issues/269`,"Warning","fs-extra-WARN0002");let{srcStat:n,destStat:i}=Lu.checkPathsSync(e,t,"copy",r);if(Lu.checkParentPathsSync(e,n,t,"copy"),r.filter&&!r.filter(e,t))return;let s=Nu.dirname(t);return Kr.existsSync(s)||l9(s),YA(i,e,t,r)}function YA(e,t,r,n){let s=(n.dereference?Kr.statSync:Kr.lstatSync)(t);if(s.isDirectory())return S9(s,e,t,r,n);if(s.isFile()||s.isCharacterDevice()||s.isBlockDevice())return d9(s,e,t,r,n);if(s.isSymbolicLink())return E9(e,t,r,n);throw s.isSocket()?new Error(`Cannot copy a socket file: ${t}`):s.isFIFO()?new Error(`Cannot copy a FIFO pipe: ${t}`):new Error(`Unknown file: ${t}`)}function d9(e,t,r,n,i){return t?p9(e,r,n,i):QA(e,r,n,i)}function p9(e,t,r,n){if(n.overwrite)return Kr.unlinkSync(r),QA(e,t,r,n);if(n.errorOnExist)throw new Error(`'${r}' already exists`)}function QA(e,t,r,n){return Kr.copyFileSync(t,r),n.preserveTimestamps&&g9(e.mode,t,r),b0(r,e.mode)}function g9(e,t,r){return m9(e)&&y9(r,e),v9(t,r)}function m9(e){return (e&128)===0}function y9(e,t){return b0(e,t|128)}function b0(e,t){return Kr.chmodSync(e,t)}function v9(e,t){let r=Kr.statSync(e);return f9(t,r.atime,r.mtime)}function S9(e,t,r,n,i){return t?XA(r,n,i):b9(e.mode,r,n,i)}function b9(e,t,r,n){return Kr.mkdirSync(r),XA(t,r,n),b0(r,e)}function XA(e,t,r){Kr.readdirSync(e).forEach(n=>C9(n,e,t,r));}function C9(e,t,r,n){let i=Nu.join(t,e),s=Nu.join(r,e);if(n.filter&&!n.filter(i,s))return;let{destStat:o}=Lu.checkPathsSync(i,s,"copy",n);return YA(o,i,s,n)}function E9(e,t,r,n){let i=Kr.readlinkSync(t);if(n.dereference&&(i=Nu.resolve(process.cwd(),i)),e){let s;try{s=Kr.readlinkSync(r);}catch(o){if(o.code==="EINVAL"||o.code==="UNKNOWN")return Kr.symlinkSync(i,r);throw o}if(n.dereference&&(s=Nu.resolve(process.cwd(),s)),Lu.isSrcSubdir(i,s))throw new Error(`Cannot copy '${i}' to a subdirectory of itself, '${s}'.`);if(Lu.isSrcSubdir(s,i))throw new Error(`Cannot overwrite '${s}' with '${i}'.`);return x9(i,r)}else return Kr.symlinkSync(i,r)}function x9(e,t){return Kr.unlinkSync(t),Kr.symlinkSync(e,t)}JA.exports=h9;});var af=A((Sue,eR)=>{var w9=dr().fromPromise;eR.exports={copy:w9(GA()),copySync:ZA()};});var Ou=A((bue,rR)=>{var tR=ta(),_9=dr().fromCallback;function T9(e,t){tR.rm(e,{recursive:!0,force:!0},t);}function A9(e){tR.rmSync(e,{recursive:!0,force:!0});}rR.exports={remove:_9(T9),removeSync:A9};});var lR=A((Cue,cR)=>{var R9=dr().fromPromise,sR=Wr(),oR=he("path"),aR=Xn(),uR=Ou(),nR=R9(async function(t){let r;try{r=await sR.readdir(t);}catch{return aR.mkdirs(t)}return Promise.all(r.map(n=>uR.remove(oR.join(t,n))))});function iR(e){let t;try{t=sR.readdirSync(e);}catch{return aR.mkdirsSync(e)}t.forEach(r=>{r=oR.join(e,r),uR.removeSync(r);});}cR.exports={emptyDirSync:iR,emptydirSync:iR,emptyDir:nR,emptydir:nR};});var pR=A((Eue,dR)=>{var I9=dr().fromPromise,fR=he("path"),Fi=Wr(),hR=Xn();async function D9(e){let t;try{t=await Fi.stat(e);}catch{}if(t&&t.isFile())return;let r=fR.dirname(e),n=null;try{n=await Fi.stat(r);}catch(i){if(i.code==="ENOENT"){await hR.mkdirs(r),await Fi.writeFile(e,"");return}else throw i}n.isDirectory()?await Fi.writeFile(e,""):await Fi.readdir(r);}function P9(e){let t;try{t=Fi.statSync(e);}catch{}if(t&&t.isFile())return;let r=fR.dirname(e);try{Fi.statSync(r).isDirectory()||Fi.readdirSync(r);}catch(n){if(n&&n.code==="ENOENT")hR.mkdirsSync(r);else throw n}Fi.writeFileSync(e,"");}dR.exports={createFile:I9(D9),createFileSync:P9};});var SR=A((xue,vR)=>{var k9=dr().fromPromise,gR=he("path"),fs=Wr(),mR=Xn(),{pathExists:N9}=ls(),{areIdentical:yR}=ro();async function L9(e,t){let r;try{r=await fs.lstat(t);}catch{}let n;try{n=await fs.lstat(e);}catch(o){throw o.message=o.message.replace("lstat","ensureLink"),o}if(r&&yR(n,r))return;let i=gR.dirname(t);await N9(i)||await mR.mkdirs(i),await fs.link(e,t);}function O9(e,t){let r;try{r=fs.lstatSync(t);}catch{}try{let s=fs.lstatSync(e);if(r&&yR(s,r))return}catch(s){throw s.message=s.message.replace("lstat","ensureLink"),s}let n=gR.dirname(t);return fs.existsSync(n)||mR.mkdirsSync(n),fs.linkSync(e,t)}vR.exports={createLink:k9(L9),createLinkSync:O9};});var CR=A((wue,bR)=>{var hs=he("path"),Bu=Wr(),{pathExists:B9}=ls(),q9=dr().fromPromise;async function F9(e,t){if(hs.isAbsolute(e)){try{await Bu.lstat(e);}catch(s){throw s.message=s.message.replace("lstat","ensureSymlink"),s}return {toCwd:e,toDst:e}}let r=hs.dirname(t),n=hs.join(r,e);if(await B9(n))return {toCwd:n,toDst:e};try{await Bu.lstat(e);}catch(s){throw s.message=s.message.replace("lstat","ensureSymlink"),s}return {toCwd:e,toDst:hs.relative(r,e)}}function M9(e,t){if(hs.isAbsolute(e)){if(!Bu.existsSync(e))throw new Error("absolute srcpath does not exist");return {toCwd:e,toDst:e}}let r=hs.dirname(t),n=hs.join(r,e);if(Bu.existsSync(n))return {toCwd:n,toDst:e};if(!Bu.existsSync(e))throw new Error("relative srcpath does not exist");return {toCwd:e,toDst:hs.relative(r,e)}}bR.exports={symlinkPaths:q9(F9),symlinkPathsSync:M9};});var wR=A((_ue,xR)=>{var ER=Wr(),U9=dr().fromPromise;async function $9(e,t){if(t)return t;let r;try{r=await ER.lstat(e);}catch{return "file"}return r&&r.isDirectory()?"dir":"file"}function j9(e,t){if(t)return t;let r;try{r=ER.lstatSync(e);}catch{return "file"}return r&&r.isDirectory()?"dir":"file"}xR.exports={symlinkType:U9($9),symlinkTypeSync:j9};});var RR=A((Tue,AR)=>{var V9=dr().fromPromise,_R=he("path"),fi=Wr(),{mkdirs:H9,mkdirsSync:W9}=Xn(),{symlinkPaths:K9,symlinkPathsSync:z9}=CR(),{symlinkType:G9,symlinkTypeSync:Y9}=wR(),{pathExists:Q9}=ls(),{areIdentical:TR}=ro();async function X9(e,t,r){let n;try{n=await fi.lstat(t);}catch{}if(n&&n.isSymbolicLink()){let[a,c]=await Promise.all([fi.stat(e),fi.stat(t)]);if(TR(a,c))return}let i=await K9(e,t);e=i.toDst;let s=await G9(i.toCwd,r),o=_R.dirname(t);return await Q9(o)||await H9(o),fi.symlink(e,t,s)}function J9(e,t,r){let n;try{n=fi.lstatSync(t);}catch{}if(n&&n.isSymbolicLink()){let a=fi.statSync(e),c=fi.statSync(t);if(TR(a,c))return}let i=z9(e,t);e=i.toDst,r=Y9(i.toCwd,r);let s=_R.dirname(t);return fi.existsSync(s)||W9(s),fi.symlinkSync(e,t,r)}AR.exports={createSymlink:V9(X9),createSymlinkSync:J9};});var BR=A((Aue,OR)=>{var{createFile:IR,createFileSync:DR}=pR(),{createLink:PR,createLinkSync:kR}=SR(),{createSymlink:NR,createSymlinkSync:LR}=RR();OR.exports={createFile:IR,createFileSync:DR,ensureFile:IR,ensureFileSync:DR,createLink:PR,createLinkSync:kR,ensureLink:PR,ensureLinkSync:kR,createSymlink:NR,createSymlinkSync:LR,ensureSymlink:NR,ensureSymlinkSync:LR};});var uf=A((Rue,qR)=>{function Z9(e,{EOL:t=`
`,finalEOL:r=!0,replacer:n=null,spaces:i}={}){let s=r?t:"";return JSON.stringify(e,n,i).replace(/\n/g,t)+s}function eW(e){return Buffer.isBuffer(e)&&(e=e.toString("utf8")),e.replace(/^\uFEFF/,"")}qR.exports={stringify:Z9,stripBom:eW};});var $R=A((Iue,UR)=>{var ia;try{ia=ta();}catch{ia=he("fs");}var cf=dr(),{stringify:FR,stripBom:MR}=uf();async function tW(e,t={}){typeof t=="string"&&(t={encoding:t});let r=t.fs||ia,n="throws"in t?t.throws:!0,i=await cf.fromCallback(r.readFile)(e,t);i=MR(i);let s;try{s=JSON.parse(i,t?t.reviver:null);}catch(o){if(n)throw o.message=`${e}: ${o.message}`,o;return null}return s}var rW=cf.fromPromise(tW);function nW(e,t={}){typeof t=="string"&&(t={encoding:t});let r=t.fs||ia,n="throws"in t?t.throws:!0;try{let i=r.readFileSync(e,t);return i=MR(i),JSON.parse(i,t.reviver)}catch(i){if(n)throw i.message=`${e}: ${i.message}`,i;return null}}async function iW(e,t,r={}){let n=r.fs||ia,i=FR(t,r);await cf.fromCallback(n.writeFile)(e,i,r);}var sW=cf.fromPromise(iW);function oW(e,t,r={}){let n=r.fs||ia,i=FR(t,r);return n.writeFileSync(e,i,r)}var aW={readFile:rW,readFileSync:nW,writeFile:sW,writeFileSync:oW};UR.exports=aW;});var VR=A((Due,jR)=>{var lf=$R();jR.exports={readJson:lf.readFile,readJsonSync:lf.readFileSync,writeJson:lf.writeFile,writeJsonSync:lf.writeFileSync};});var ff=A((Pue,KR)=>{var uW=dr().fromPromise,C0=Wr(),HR=he("path"),WR=Xn(),cW=ls().pathExists;async function lW(e,t,r="utf-8"){let n=HR.dirname(e);return await cW(n)||await WR.mkdirs(n),C0.writeFile(e,t,r)}function fW(e,...t){let r=HR.dirname(e);C0.existsSync(r)||WR.mkdirsSync(r),C0.writeFileSync(e,...t);}KR.exports={outputFile:uW(lW),outputFileSync:fW};});var GR=A((kue,zR)=>{var{stringify:hW}=uf(),{outputFile:dW}=ff();async function pW(e,t,r={}){let n=hW(t,r);await dW(e,n,r);}zR.exports=pW;});var QR=A((Nue,YR)=>{var{stringify:gW}=uf(),{outputFileSync:mW}=ff();function yW(e,t,r){let n=gW(t,r);mW(e,n,r);}YR.exports=yW;});var JR=A((Lue,XR)=>{var vW=dr().fromPromise,zr=VR();zr.outputJson=vW(GR());zr.outputJsonSync=QR();zr.outputJSON=zr.outputJson;zr.outputJSONSync=zr.outputJsonSync;zr.writeJSON=zr.writeJson;zr.writeJSONSync=zr.writeJsonSync;zr.readJSON=zr.readJson;zr.readJSONSync=zr.readJsonSync;XR.exports=zr;});var nI=A((Oue,rI)=>{var SW=Wr(),ZR=he("path"),{copy:bW}=af(),{remove:tI}=Ou(),{mkdirp:CW}=Xn(),{pathExists:EW}=ls(),eI=ro();async function xW(e,t,r={}){let n=r.overwrite||r.clobber||!1,{srcStat:i,isChangingCase:s=!1}=await eI.checkPaths(e,t,"move",r);await eI.checkParentPaths(e,i,t,"move");let o=ZR.dirname(t);return ZR.parse(o).root!==o&&await CW(o),wW(e,t,n,s)}async function wW(e,t,r,n){if(!n){if(r)await tI(t);else if(await EW(t))throw new Error("dest already exists.")}try{await SW.rename(e,t);}catch(i){if(i.code!=="EXDEV")throw i;await _W(e,t,r);}}async function _W(e,t,r){return await bW(e,t,{overwrite:r,errorOnExist:!0,preserveTimestamps:!0}),tI(e)}rI.exports=xW;});var uI=A((Bue,aI)=>{var sI=ta(),x0=he("path"),TW=af().copySync,oI=Ou().removeSync,AW=Xn().mkdirpSync,iI=ro();function RW(e,t,r){r=r||{};let n=r.overwrite||r.clobber||!1,{srcStat:i,isChangingCase:s=!1}=iI.checkPathsSync(e,t,"move",r);return iI.checkParentPathsSync(e,i,t,"move"),IW(t)||AW(x0.dirname(t)),DW(e,t,n,s)}function IW(e){let t=x0.dirname(e);return x0.parse(t).root===t}function DW(e,t,r,n){if(n)return E0(e,t,r);if(r)return oI(t),E0(e,t,r);if(sI.existsSync(t))throw new Error("dest already exists.");return E0(e,t,r)}function E0(e,t,r){try{sI.renameSync(e,t);}catch(n){if(n.code!=="EXDEV")throw n;return PW(e,t,r)}}function PW(e,t,r){return TW(e,t,{overwrite:r,errorOnExist:!0,preserveTimestamps:!0}),oI(e)}aI.exports=RW;});var lI=A((que,cI)=>{var kW=dr().fromPromise;cI.exports={move:kW(nI()),moveSync:uI()};});var hf=A((Fue,fI)=>{fI.exports={...Wr(),...af(),...lR(),...BR(),...JR(),...Xn(),...lI(),...ff(),...ls(),...Ou()};});var qu=A((Mue,mI)=>{var NW=he("path"),hi="\\\\/",hI=`[^${hi}]`,Mi="\\.",LW="\\+",OW="\\?",df="\\/",BW="(?=.)",dI="[^/]",w0=`(?:${df}|$)`,pI=`(?:^|${df})`,_0=`${Mi}{1,2}${w0}`,qW=`(?!${Mi})`,FW=`(?!${pI}${_0})`,MW=`(?!${Mi}{0,1}${w0})`,UW=`(?!${_0})`,$W=`[^.${df}]`,jW=`${dI}*?`,gI={DOT_LITERAL:Mi,PLUS_LITERAL:LW,QMARK_LITERAL:OW,SLASH_LITERAL:df,ONE_CHAR:BW,QMARK:dI,END_ANCHOR:w0,DOTS_SLASH:_0,NO_DOT:qW,NO_DOTS:FW,NO_DOT_SLASH:MW,NO_DOTS_SLASH:UW,QMARK_NO_DOT:$W,STAR:jW,START_ANCHOR:pI},VW={...gI,SLASH_LITERAL:`[${hi}]`,QMARK:hI,STAR:`${hI}*?`,DOTS_SLASH:`${Mi}{1,2}(?:[${hi}]|$)`,NO_DOT:`(?!${Mi})`,NO_DOTS:`(?!(?:^|[${hi}])${Mi}{1,2}(?:[${hi}]|$))`,NO_DOT_SLASH:`(?!${Mi}{0,1}(?:[${hi}]|$))`,NO_DOTS_SLASH:`(?!${Mi}{1,2}(?:[${hi}]|$))`,QMARK_NO_DOT:`[^.${hi}]`,START_ANCHOR:`(?:^|[${hi}])`,END_ANCHOR:`(?:[${hi}]|$)`},HW={alnum:"a-zA-Z0-9",alpha:"a-zA-Z",ascii:"\\x00-\\x7F",blank:" \\t",cntrl:"\\x00-\\x1F\\x7F",digit:"0-9",graph:"\\x21-\\x7E",lower:"a-z",print:"\\x20-\\x7E ",punct:"\\-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",space:" \\t\\r\\n\\v\\f",upper:"A-Z",word:"A-Za-z0-9_",xdigit:"A-Fa-f0-9"};mI.exports={MAX_LENGTH:1024*64,POSIX_REGEX_SOURCE:HW,REGEX_BACKSLASH:/\\(?![*+?^${}(|)[\]])/g,REGEX_NON_SPECIAL_CHARS:/^[^@![\].,$*+?^{}()|\\/]+/,REGEX_SPECIAL_CHARS:/[-*+?.^${}(|)[\]]/,REGEX_SPECIAL_CHARS_BACKREF:/(\\?)((\W)(\3*))/g,REGEX_SPECIAL_CHARS_GLOBAL:/([-*+?.^${}(|)[\]])/g,REGEX_REMOVE_BACKSLASH:/(?:\[.*?[^\\]\]|\\(?=.))/g,REPLACEMENTS:{"***":"*","**/**":"**","**/**/**":"**"},CHAR_0:48,CHAR_9:57,CHAR_UPPERCASE_A:65,CHAR_LOWERCASE_A:97,CHAR_UPPERCASE_Z:90,CHAR_LOWERCASE_Z:122,CHAR_LEFT_PARENTHESES:40,CHAR_RIGHT_PARENTHESES:41,CHAR_ASTERISK:42,CHAR_AMPERSAND:38,CHAR_AT:64,CHAR_BACKWARD_SLASH:92,CHAR_CARRIAGE_RETURN:13,CHAR_CIRCUMFLEX_ACCENT:94,CHAR_COLON:58,CHAR_COMMA:44,CHAR_DOT:46,CHAR_DOUBLE_QUOTE:34,CHAR_EQUAL:61,CHAR_EXCLAMATION_MARK:33,CHAR_FORM_FEED:12,CHAR_FORWARD_SLASH:47,CHAR_GRAVE_ACCENT:96,CHAR_HASH:35,CHAR_HYPHEN_MINUS:45,CHAR_LEFT_ANGLE_BRACKET:60,CHAR_LEFT_CURLY_BRACE:123,CHAR_LEFT_SQUARE_BRACKET:91,CHAR_LINE_FEED:10,CHAR_NO_BREAK_SPACE:160,CHAR_PERCENT:37,CHAR_PLUS:43,CHAR_QUESTION_MARK:63,CHAR_RIGHT_ANGLE_BRACKET:62,CHAR_RIGHT_CURLY_BRACE:125,CHAR_RIGHT_SQUARE_BRACKET:93,CHAR_SEMICOLON:59,CHAR_SINGLE_QUOTE:39,CHAR_SPACE:32,CHAR_TAB:9,CHAR_UNDERSCORE:95,CHAR_VERTICAL_LINE:124,CHAR_ZERO_WIDTH_NOBREAK_SPACE:65279,SEP:NW.sep,extglobChars(e){return {"!":{type:"negate",open:"(?:(?!(?:",close:`))${e.STAR})`},"?":{type:"qmark",open:"(?:",close:")?"},"+":{type:"plus",open:"(?:",close:")+"},"*":{type:"star",open:"(?:",close:")*"},"@":{type:"at",open:"(?:",close:")"}}},globChars(e){return e===!0?VW:gI}};});var pf=A(tn=>{var WW=he("path"),KW=process.platform==="win32",{REGEX_BACKSLASH:zW,REGEX_REMOVE_BACKSLASH:GW,REGEX_SPECIAL_CHARS:YW,REGEX_SPECIAL_CHARS_GLOBAL:QW}=qu();tn.isObject=e=>e!==null&&typeof e=="object"&&!Array.isArray(e);tn.hasRegexChars=e=>YW.test(e);tn.isRegexChar=e=>e.length===1&&tn.hasRegexChars(e);tn.escapeRegex=e=>e.replace(QW,"\\$1");tn.toPosixSlashes=e=>e.replace(zW,"/");tn.removeBackslashes=e=>e.replace(GW,t=>t==="\\"?"":t);tn.supportsLookbehinds=()=>{let e=process.version.slice(1).split(".").map(Number);return e.length===3&&e[0]>=9||e[0]===8&&e[1]>=10};tn.isWindows=e=>e&&typeof e.windows=="boolean"?e.windows:KW===!0||WW.sep==="\\";tn.escapeLast=(e,t,r)=>{let n=e.lastIndexOf(t,r);return n===-1?e:e[n-1]==="\\"?tn.escapeLast(e,t,n-1):`${e.slice(0,n)}\\${e.slice(n)}`};tn.removePrefix=(e,t={})=>{let r=e;return r.startsWith("./")&&(r=r.slice(2),t.prefix="./"),r};tn.wrapOutput=(e,t={},r={})=>{let n=r.contains?"":"^",i=r.contains?"":"$",s=`${n}(?:${e})${i}`;return t.negated===!0&&(s=`(?:^(?!${s}).*$)`),s};});var wI=A(($ue,xI)=>{var yI=pf(),{CHAR_ASTERISK:T0,CHAR_AT:XW,CHAR_BACKWARD_SLASH:Fu,CHAR_COMMA:JW,CHAR_DOT:A0,CHAR_EXCLAMATION_MARK:R0,CHAR_FORWARD_SLASH:EI,CHAR_LEFT_CURLY_BRACE:I0,CHAR_LEFT_PARENTHESES:D0,CHAR_LEFT_SQUARE_BRACKET:ZW,CHAR_PLUS:eK,CHAR_QUESTION_MARK:vI,CHAR_RIGHT_CURLY_BRACE:tK,CHAR_RIGHT_PARENTHESES:SI,CHAR_RIGHT_SQUARE_BRACKET:rK}=qu(),bI=e=>e===EI||e===Fu,CI=e=>{e.isPrefix!==!0&&(e.depth=e.isGlobstar?1/0:1);},nK=(e,t)=>{let r=t||{},n=e.length-1,i=r.parts===!0||r.scanToEnd===!0,s=[],o=[],a=[],c=e,l=-1,u=0,f=0,d=!1,p=!1,m=!1,S=!1,x=!1,I=!1,v=!1,b=!1,D=!1,L=!1,j=0,J,K,G={value:"",depth:0,isGlob:!1},ee=()=>l>=n,M=()=>c.charCodeAt(l+1),ae=()=>(J=K,c.charCodeAt(++l));for(;l<n;){K=ae();let se;if(K===Fu){v=G.backslashes=!0,K=ae(),K===I0&&(I=!0);continue}if(I===!0||K===I0){for(j++;ee()!==!0&&(K=ae());){if(K===Fu){v=G.backslashes=!0,ae();continue}if(K===I0){j++;continue}if(I!==!0&&K===A0&&(K=ae())===A0){if(d=G.isBrace=!0,m=G.isGlob=!0,L=!0,i===!0)continue;break}if(I!==!0&&K===JW){if(d=G.isBrace=!0,m=G.isGlob=!0,L=!0,i===!0)continue;break}if(K===tK&&(j--,j===0)){I=!1,d=G.isBrace=!0,L=!0;break}}if(i===!0)continue;break}if(K===EI){if(s.push(l),o.push(G),G={value:"",depth:0,isGlob:!1},L===!0)continue;if(J===A0&&l===u+1){u+=2;continue}f=l+1;continue}if(r.noext!==!0&&(K===eK||K===XW||K===T0||K===vI||K===R0)===!0&&M()===D0){if(m=G.isGlob=!0,S=G.isExtglob=!0,L=!0,K===R0&&l===u&&(D=!0),i===!0){for(;ee()!==!0&&(K=ae());){if(K===Fu){v=G.backslashes=!0,K=ae();continue}if(K===SI){m=G.isGlob=!0,L=!0;break}}continue}break}if(K===T0){if(J===T0&&(x=G.isGlobstar=!0),m=G.isGlob=!0,L=!0,i===!0)continue;break}if(K===vI){if(m=G.isGlob=!0,L=!0,i===!0)continue;break}if(K===ZW){for(;ee()!==!0&&(se=ae());){if(se===Fu){v=G.backslashes=!0,ae();continue}if(se===rK){p=G.isBracket=!0,m=G.isGlob=!0,L=!0;break}}if(i===!0)continue;break}if(r.nonegate!==!0&&K===R0&&l===u){b=G.negated=!0,u++;continue}if(r.noparen!==!0&&K===D0){if(m=G.isGlob=!0,i===!0){for(;ee()!==!0&&(K=ae());){if(K===D0){v=G.backslashes=!0,K=ae();continue}if(K===SI){L=!0;break}}continue}break}if(m===!0){if(L=!0,i===!0)continue;break}}r.noext===!0&&(S=!1,m=!1);let me=c,Le="",H="";u>0&&(Le=c.slice(0,u),c=c.slice(u),f-=u),me&&m===!0&&f>0?(me=c.slice(0,f),H=c.slice(f)):m===!0?(me="",H=c):me=c,me&&me!==""&&me!=="/"&&me!==c&&bI(me.charCodeAt(me.length-1))&&(me=me.slice(0,-1)),r.unescape===!0&&(H&&(H=yI.removeBackslashes(H)),me&&v===!0&&(me=yI.removeBackslashes(me)));let W={prefix:Le,input:e,start:u,base:me,glob:H,isBrace:d,isBracket:p,isGlob:m,isExtglob:S,isGlobstar:x,negated:b,negatedExtglob:D};if(r.tokens===!0&&(W.maxDepth=0,bI(K)||o.push(G),W.tokens=o),r.parts===!0||r.tokens===!0){let se;for(let Te=0;Te<s.length;Te++){let Fe=se?se+1:u,ze=s[Te],He=e.slice(Fe,ze);r.tokens&&(Te===0&&u!==0?(o[Te].isPrefix=!0,o[Te].value=Le):o[Te].value=He,CI(o[Te]),W.maxDepth+=o[Te].depth),(Te!==0||He!=="")&&a.push(He),se=ze;}if(se&&se+1<e.length){let Te=e.slice(se+1);a.push(Te),r.tokens&&(o[o.length-1].value=Te,CI(o[o.length-1]),W.maxDepth+=o[o.length-1].depth);}W.slashes=s,W.parts=a;}return W};xI.exports=nK;});var AI=A((jue,TI)=>{var gf=qu(),yn=pf(),{MAX_LENGTH:mf,POSIX_REGEX_SOURCE:iK,REGEX_NON_SPECIAL_CHARS:sK,REGEX_SPECIAL_CHARS_BACKREF:oK,REPLACEMENTS:_I}=gf,aK=(e,t)=>{if(typeof t.expandRange=="function")return t.expandRange(...e,t);e.sort();let r=`[${e.join("-")}]`;return r},sa=(e,t)=>`Missing ${e}: "${t}" - use "\\\\${t}" to match literal characters`,P0=(e,t)=>{if(typeof e!="string")throw new TypeError("Expected a string");e=_I[e]||e;let r={...t},n=typeof r.maxLength=="number"?Math.min(mf,r.maxLength):mf,i=e.length;if(i>n)throw new SyntaxError(`Input length: ${i}, exceeds maximum allowed length: ${n}`);let s={type:"bos",value:"",output:r.prepend||""},o=[s],a=r.capture?"":"?:",c=yn.isWindows(t),l=gf.globChars(c),u=gf.extglobChars(l),{DOT_LITERAL:f,PLUS_LITERAL:d,SLASH_LITERAL:p,ONE_CHAR:m,DOTS_SLASH:S,NO_DOT:x,NO_DOT_SLASH:I,NO_DOTS_SLASH:v,QMARK:b,QMARK_NO_DOT:D,STAR:L,START_ANCHOR:j}=l,J=ge=>`(${a}(?:(?!${j}${ge.dot?S:f}).)*?)`,K=r.dot?"":x,G=r.dot?b:D,ee=r.bash===!0?J(r):L;r.capture&&(ee=`(${ee})`),typeof r.noext=="boolean"&&(r.noextglob=r.noext);let M={input:e,index:-1,start:0,dot:r.dot===!0,consumed:"",output:"",prefix:"",backtrack:!1,negated:!1,brackets:0,braces:0,parens:0,quotes:0,globstar:!1,tokens:o};e=yn.removePrefix(e,M),i=e.length;let ae=[],me=[],Le=[],H=s,W,se=()=>M.index===i-1,Te=M.peek=(ge=1)=>e[M.index+ge],Fe=M.advance=()=>e[++M.index]||"",ze=()=>e.slice(M.index+1),He=(ge="",je=0)=>{M.consumed+=ge,M.index+=je;},ct=ge=>{M.output+=ge.output!=null?ge.output:ge.value,He(ge.value);},Lt=()=>{let ge=1;for(;Te()==="!"&&(Te(2)!=="("||Te(3)==="?");)Fe(),M.start++,ge++;return ge%2===0?!1:(M.negated=!0,M.start++,!0)},xt=ge=>{M[ge]++,Le.push(ge);},dt=ge=>{M[ge]--,Le.pop();},Oe=ge=>{if(H.type==="globstar"){let je=M.braces>0&&(ge.type==="comma"||ge.type==="brace"),ce=ge.extglob===!0||ae.length&&(ge.type==="pipe"||ge.type==="paren");ge.type!=="slash"&&ge.type!=="paren"&&!je&&!ce&&(M.output=M.output.slice(0,-H.output.length),H.type="star",H.value="*",H.output=ee,M.output+=H.output);}if(ae.length&&ge.type!=="paren"&&(ae[ae.length-1].inner+=ge.value),(ge.value||ge.output)&&ct(ge),H&&H.type==="text"&&ge.type==="text"){H.value+=ge.value,H.output=(H.output||"")+ge.value;return}ge.prev=H,o.push(ge),H=ge;},Pt=(ge,je)=>{let ce={...u[je],conditions:1,inner:""};ce.prev=H,ce.parens=M.parens,ce.output=M.output;let Re=(r.capture?"(":"")+ce.open;xt("parens"),Oe({type:ge,value:je,output:M.output?"":m}),Oe({type:"paren",extglob:!0,value:Fe(),output:Re}),ae.push(ce);},Ut=ge=>{let je=ge.close+(r.capture?")":""),ce;if(ge.type==="negate"){let Re=ee;if(ge.inner&&ge.inner.length>1&&ge.inner.includes("/")&&(Re=J(r)),(Re!==ee||se()||/^\)+$/.test(ze()))&&(je=ge.close=`)$))${Re}`),ge.inner.includes("*")&&(ce=ze())&&/^\.[^\\/.]+$/.test(ce)){let We=P0(ce,{...t,fastpaths:!1}).output;je=ge.close=`)${We})${Re})`;}ge.prev.type==="bos"&&(M.negatedExtglob=!0);}Oe({type:"paren",extglob:!0,value:W,output:je}),dt("parens");};if(r.fastpaths!==!1&&!/(^[*!]|[/()[\]{}"])/.test(e)){let ge=!1,je=e.replace(oK,(ce,Re,We,nt,Ge,_n)=>nt==="\\"?(ge=!0,ce):nt==="?"?Re?Re+nt+(Ge?b.repeat(Ge.length):""):_n===0?G+(Ge?b.repeat(Ge.length):""):b.repeat(We.length):nt==="."?f.repeat(We.length):nt==="*"?Re?Re+nt+(Ge?ee:""):ee:Re?ce:`\\${ce}`);return ge===!0&&(r.unescape===!0?je=je.replace(/\\/g,""):je=je.replace(/\\+/g,ce=>ce.length%2===0?"\\\\":ce?"\\":"")),je===e&&r.contains===!0?(M.output=e,M):(M.output=yn.wrapOutput(je,M,t),M)}for(;!se();){if(W=Fe(),W==="\0")continue;if(W==="\\"){let ce=Te();if(ce==="/"&&r.bash!==!0||ce==="."||ce===";")continue;if(!ce){W+="\\",Oe({type:"text",value:W});continue}let Re=/^\\+/.exec(ze()),We=0;if(Re&&Re[0].length>2&&(We=Re[0].length,M.index+=We,We%2!==0&&(W+="\\")),r.unescape===!0?W=Fe():W+=Fe(),M.brackets===0){Oe({type:"text",value:W});continue}}if(M.brackets>0&&(W!=="]"||H.value==="["||H.value==="[^")){if(r.posix!==!1&&W===":"){let ce=H.value.slice(1);if(ce.includes("[")&&(H.posix=!0,ce.includes(":"))){let Re=H.value.lastIndexOf("["),We=H.value.slice(0,Re),nt=H.value.slice(Re+2),Ge=iK[nt];if(Ge){H.value=We+Ge,M.backtrack=!0,Fe(),!s.output&&o.indexOf(H)===1&&(s.output=m);continue}}}(W==="["&&Te()!==":"||W==="-"&&Te()==="]")&&(W=`\\${W}`),W==="]"&&(H.value==="["||H.value==="[^")&&(W=`\\${W}`),r.posix===!0&&W==="!"&&H.value==="["&&(W="^"),H.value+=W,ct({value:W});continue}if(M.quotes===1&&W!=='"'){W=yn.escapeRegex(W),H.value+=W,ct({value:W});continue}if(W==='"'){M.quotes=M.quotes===1?0:1,r.keepQuotes===!0&&Oe({type:"text",value:W});continue}if(W==="("){xt("parens"),Oe({type:"paren",value:W});continue}if(W===")"){if(M.parens===0&&r.strictBrackets===!0)throw new SyntaxError(sa("opening","("));let ce=ae[ae.length-1];if(ce&&M.parens===ce.parens+1){Ut(ae.pop());continue}Oe({type:"paren",value:W,output:M.parens?")":"\\)"}),dt("parens");continue}if(W==="["){if(r.nobracket===!0||!ze().includes("]")){if(r.nobracket!==!0&&r.strictBrackets===!0)throw new SyntaxError(sa("closing","]"));W=`\\${W}`;}else xt("brackets");Oe({type:"bracket",value:W});continue}if(W==="]"){if(r.nobracket===!0||H&&H.type==="bracket"&&H.value.length===1){Oe({type:"text",value:W,output:`\\${W}`});continue}if(M.brackets===0){if(r.strictBrackets===!0)throw new SyntaxError(sa("opening","["));Oe({type:"text",value:W,output:`\\${W}`});continue}dt("brackets");let ce=H.value.slice(1);if(H.posix!==!0&&ce[0]==="^"&&!ce.includes("/")&&(W=`/${W}`),H.value+=W,ct({value:W}),r.literalBrackets===!1||yn.hasRegexChars(ce))continue;let Re=yn.escapeRegex(H.value);if(M.output=M.output.slice(0,-H.value.length),r.literalBrackets===!0){M.output+=Re,H.value=Re;continue}H.value=`(${a}${Re}|${H.value})`,M.output+=H.value;continue}if(W==="{"&&r.nobrace!==!0){xt("braces");let ce={type:"brace",value:W,output:"(",outputIndex:M.output.length,tokensIndex:M.tokens.length};me.push(ce),Oe(ce);continue}if(W==="}"){let ce=me[me.length-1];if(r.nobrace===!0||!ce){Oe({type:"text",value:W,output:W});continue}let Re=")";if(ce.dots===!0){let We=o.slice(),nt=[];for(let Ge=We.length-1;Ge>=0&&(o.pop(),We[Ge].type!=="brace");Ge--)We[Ge].type!=="dots"&&nt.unshift(We[Ge].value);Re=aK(nt,r),M.backtrack=!0;}if(ce.comma!==!0&&ce.dots!==!0){let We=M.output.slice(0,ce.outputIndex),nt=M.tokens.slice(ce.tokensIndex);ce.value=ce.output="\\{",W=Re="\\}",M.output=We;for(let Ge of nt)M.output+=Ge.output||Ge.value;}Oe({type:"brace",value:W,output:Re}),dt("braces"),me.pop();continue}if(W==="|"){ae.length>0&&ae[ae.length-1].conditions++,Oe({type:"text",value:W});continue}if(W===","){let ce=W,Re=me[me.length-1];Re&&Le[Le.length-1]==="braces"&&(Re.comma=!0,ce="|"),Oe({type:"comma",value:W,output:ce});continue}if(W==="/"){if(H.type==="dot"&&M.index===M.start+1){M.start=M.index+1,M.consumed="",M.output="",o.pop(),H=s;continue}Oe({type:"slash",value:W,output:p});continue}if(W==="."){if(M.braces>0&&H.type==="dot"){H.value==="."&&(H.output=f);let ce=me[me.length-1];H.type="dots",H.output+=W,H.value+=W,ce.dots=!0;continue}if(M.braces+M.parens===0&&H.type!=="bos"&&H.type!=="slash"){Oe({type:"text",value:W,output:f});continue}Oe({type:"dot",value:W,output:f});continue}if(W==="?"){if(!(H&&H.value==="(")&&r.noextglob!==!0&&Te()==="("&&Te(2)!=="?"){Pt("qmark",W);continue}if(H&&H.type==="paren"){let Re=Te(),We=W;if(Re==="<"&&!yn.supportsLookbehinds())throw new Error("Node.js v10 or higher is required for regex lookbehinds");(H.value==="("&&!/[!=<:]/.test(Re)||Re==="<"&&!/<([!=]|\w+>)/.test(ze()))&&(We=`\\${W}`),Oe({type:"text",value:W,output:We});continue}if(r.dot!==!0&&(H.type==="slash"||H.type==="bos")){Oe({type:"qmark",value:W,output:D});continue}Oe({type:"qmark",value:W,output:b});continue}if(W==="!"){if(r.noextglob!==!0&&Te()==="("&&(Te(2)!=="?"||!/[!=<:]/.test(Te(3)))){Pt("negate",W);continue}if(r.nonegate!==!0&&M.index===0){Lt();continue}}if(W==="+"){if(r.noextglob!==!0&&Te()==="("&&Te(2)!=="?"){Pt("plus",W);continue}if(H&&H.value==="("||r.regex===!1){Oe({type:"plus",value:W,output:d});continue}if(H&&(H.type==="bracket"||H.type==="paren"||H.type==="brace")||M.parens>0){Oe({type:"plus",value:W});continue}Oe({type:"plus",value:d});continue}if(W==="@"){if(r.noextglob!==!0&&Te()==="("&&Te(2)!=="?"){Oe({type:"at",extglob:!0,value:W,output:""});continue}Oe({type:"text",value:W});continue}if(W!=="*"){(W==="$"||W==="^")&&(W=`\\${W}`);let ce=sK.exec(ze());ce&&(W+=ce[0],M.index+=ce[0].length),Oe({type:"text",value:W});continue}if(H&&(H.type==="globstar"||H.star===!0)){H.type="star",H.star=!0,H.value+=W,H.output=ee,M.backtrack=!0,M.globstar=!0,He(W);continue}let ge=ze();if(r.noextglob!==!0&&/^\([^?]/.test(ge)){Pt("star",W);continue}if(H.type==="star"){if(r.noglobstar===!0){He(W);continue}let ce=H.prev,Re=ce.prev,We=ce.type==="slash"||ce.type==="bos",nt=Re&&(Re.type==="star"||Re.type==="globstar");if(r.bash===!0&&(!We||ge[0]&&ge[0]!=="/")){Oe({type:"star",value:W,output:""});continue}let Ge=M.braces>0&&(ce.type==="comma"||ce.type==="brace"),_n=ae.length&&(ce.type==="pipe"||ce.type==="paren");if(!We&&ce.type!=="paren"&&!Ge&&!_n){Oe({type:"star",value:W,output:""});continue}for(;ge.slice(0,3)==="/**";){let Mr=e[M.index+4];if(Mr&&Mr!=="/")break;ge=ge.slice(3),He("/**",3);}if(ce.type==="bos"&&se()){H.type="globstar",H.value+=W,H.output=J(r),M.output=H.output,M.globstar=!0,He(W);continue}if(ce.type==="slash"&&ce.prev.type!=="bos"&&!nt&&se()){M.output=M.output.slice(0,-(ce.output+H.output).length),ce.output=`(?:${ce.output}`,H.type="globstar",H.output=J(r)+(r.strictSlashes?")":"|$)"),H.value+=W,M.globstar=!0,M.output+=ce.output+H.output,He(W);continue}if(ce.type==="slash"&&ce.prev.type!=="bos"&&ge[0]==="/"){let Mr=ge[1]!==void 0?"|$":"";M.output=M.output.slice(0,-(ce.output+H.output).length),ce.output=`(?:${ce.output}`,H.type="globstar",H.output=`${J(r)}${p}|${p}${Mr})`,H.value+=W,M.output+=ce.output+H.output,M.globstar=!0,He(W+Fe()),Oe({type:"slash",value:"/",output:""});continue}if(ce.type==="bos"&&ge[0]==="/"){H.type="globstar",H.value+=W,H.output=`(?:^|${p}|${J(r)}${p})`,M.output=H.output,M.globstar=!0,He(W+Fe()),Oe({type:"slash",value:"/",output:""});continue}M.output=M.output.slice(0,-H.output.length),H.type="globstar",H.output=J(r),H.value+=W,M.output+=H.output,M.globstar=!0,He(W);continue}let je={type:"star",value:W,output:ee};if(r.bash===!0){je.output=".*?",(H.type==="bos"||H.type==="slash")&&(je.output=K+je.output),Oe(je);continue}if(H&&(H.type==="bracket"||H.type==="paren")&&r.regex===!0){je.output=W,Oe(je);continue}(M.index===M.start||H.type==="slash"||H.type==="dot")&&(H.type==="dot"?(M.output+=I,H.output+=I):r.dot===!0?(M.output+=v,H.output+=v):(M.output+=K,H.output+=K),Te()!=="*"&&(M.output+=m,H.output+=m)),Oe(je);}for(;M.brackets>0;){if(r.strictBrackets===!0)throw new SyntaxError(sa("closing","]"));M.output=yn.escapeLast(M.output,"["),dt("brackets");}for(;M.parens>0;){if(r.strictBrackets===!0)throw new SyntaxError(sa("closing",")"));M.output=yn.escapeLast(M.output,"("),dt("parens");}for(;M.braces>0;){if(r.strictBrackets===!0)throw new SyntaxError(sa("closing","}"));M.output=yn.escapeLast(M.output,"{"),dt("braces");}if(r.strictSlashes!==!0&&(H.type==="star"||H.type==="bracket")&&Oe({type:"maybe_slash",value:"",output:`${p}?`}),M.backtrack===!0){M.output="";for(let ge of M.tokens)M.output+=ge.output!=null?ge.output:ge.value,ge.suffix&&(M.output+=ge.suffix);}return M};P0.fastpaths=(e,t)=>{let r={...t},n=typeof r.maxLength=="number"?Math.min(mf,r.maxLength):mf,i=e.length;if(i>n)throw new SyntaxError(`Input length: ${i}, exceeds maximum allowed length: ${n}`);e=_I[e]||e;let s=yn.isWindows(t),{DOT_LITERAL:o,SLASH_LITERAL:a,ONE_CHAR:c,DOTS_SLASH:l,NO_DOT:u,NO_DOTS:f,NO_DOTS_SLASH:d,STAR:p,START_ANCHOR:m}=gf.globChars(s),S=r.dot?f:u,x=r.dot?d:u,I=r.capture?"":"?:",v={negated:!1,prefix:""},b=r.bash===!0?".*?":p;r.capture&&(b=`(${b})`);let D=K=>K.noglobstar===!0?b:`(${I}(?:(?!${m}${K.dot?l:o}).)*?)`,L=K=>{switch(K){case"*":return `${S}${c}${b}`;case".*":return `${o}${c}${b}`;case"*.*":return `${S}${b}${o}${c}${b}`;case"*/*":return `${S}${b}${a}${c}${x}${b}`;case"**":return S+D(r);case"**/*":return `(?:${S}${D(r)}${a})?${x}${c}${b}`;case"**/*.*":return `(?:${S}${D(r)}${a})?${x}${b}${o}${c}${b}`;case"**/.*":return `(?:${S}${D(r)}${a})?${o}${c}${b}`;default:{let G=/^(.*?)\.(\w+)$/.exec(K);if(!G)return;let ee=L(G[1]);return ee?ee+o+G[2]:void 0}}},j=yn.removePrefix(e,v),J=L(j);return J&&r.strictSlashes!==!0&&(J+=`${a}?`),J};TI.exports=P0;});var II=A((Vue,RI)=>{var uK=he("path"),cK=wI(),k0=AI(),N0=pf(),lK=qu(),fK=e=>e&&typeof e=="object"&&!Array.isArray(e),rr=(e,t,r=!1)=>{if(Array.isArray(e)){let u=e.map(d=>rr(d,t,r));return d=>{for(let p of u){let m=p(d);if(m)return m}return !1}}let n=fK(e)&&e.tokens&&e.input;if(e===""||typeof e!="string"&&!n)throw new TypeError("Expected pattern to be a non-empty string");let i=t||{},s=N0.isWindows(t),o=n?rr.compileRe(e,t):rr.makeRe(e,t,!1,!0),a=o.state;delete o.state;let c=()=>!1;if(i.ignore){let u={...t,ignore:null,onMatch:null,onResult:null};c=rr(i.ignore,u,r);}let l=(u,f=!1)=>{let{isMatch:d,match:p,output:m}=rr.test(u,o,t,{glob:e,posix:s}),S={glob:e,state:a,regex:o,posix:s,input:u,output:m,match:p,isMatch:d};return typeof i.onResult=="function"&&i.onResult(S),d===!1?(S.isMatch=!1,f?S:!1):c(u)?(typeof i.onIgnore=="function"&&i.onIgnore(S),S.isMatch=!1,f?S:!1):(typeof i.onMatch=="function"&&i.onMatch(S),f?S:!0)};return r&&(l.state=a),l};rr.test=(e,t,r,{glob:n,posix:i}={})=>{if(typeof e!="string")throw new TypeError("Expected input to be a string");if(e==="")return {isMatch:!1,output:""};let s=r||{},o=s.format||(i?N0.toPosixSlashes:null),a=e===n,c=a&&o?o(e):e;return a===!1&&(c=o?o(e):e,a=c===n),(a===!1||s.capture===!0)&&(s.matchBase===!0||s.basename===!0?a=rr.matchBase(e,t,r,i):a=t.exec(c)),{isMatch:!!a,match:a,output:c}};rr.matchBase=(e,t,r,n=N0.isWindows(r))=>(t instanceof RegExp?t:rr.makeRe(t,r)).test(uK.basename(e));rr.isMatch=(e,t,r)=>rr(t,r)(e);rr.parse=(e,t)=>Array.isArray(e)?e.map(r=>rr.parse(r,t)):k0(e,{...t,fastpaths:!1});rr.scan=(e,t)=>cK(e,t);rr.compileRe=(e,t,r=!1,n=!1)=>{if(r===!0)return e.output;let i=t||{},s=i.contains?"":"^",o=i.contains?"":"$",a=`${s}(?:${e.output})${o}`;e&&e.negated===!0&&(a=`^(?!${a}).*$`);let c=rr.toRegex(a,t);return n===!0&&(c.state=e),c};rr.makeRe=(e,t={},r=!1,n=!1)=>{if(!e||typeof e!="string")throw new TypeError("Expected a non-empty string");let i={negated:!1,fastpaths:!0};return t.fastpaths!==!1&&(e[0]==="."||e[0]==="*")&&(i.output=k0.fastpaths(e,t)),i.output||(i=k0(e,t)),rr.compileRe(i,t,r,n)};rr.toRegex=(e,t)=>{try{let r=t||{};return new RegExp(e,r.flags||(r.nocase?"i":""))}catch(r){if(t&&t.debug===!0)throw r;return /$^/}};rr.constants=lK;RI.exports=rr;});var L0=A((Hue,DI)=>{DI.exports=II();});var FI=A((Wue,qI)=>{var Uu=he("fs"),{Readable:hK}=he("stream"),Mu=he("path"),{promisify:bf}=he("util"),O0=L0(),dK=bf(Uu.readdir),pK=bf(Uu.stat),PI=bf(Uu.lstat),gK=bf(Uu.realpath),mK="!",OI="READDIRP_RECURSIVE_ERROR",yK=new Set(["ENOENT","EPERM","EACCES","ELOOP",OI]),B0="files",BI="directories",vf="files_directories",yf="all",kI=[B0,BI,vf,yf],vK=e=>yK.has(e.code),[NI,SK]=process.versions.node.split(".").slice(0,2).map(e=>Number.parseInt(e,10)),bK=process.platform==="win32"&&(NI>10||NI===10&&SK>=5),LI=e=>{if(e!==void 0){if(typeof e=="function")return e;if(typeof e=="string"){let t=O0(e.trim());return r=>t(r.basename)}if(Array.isArray(e)){let t=[],r=[];for(let n of e){let i=n.trim();i.charAt(0)===mK?r.push(O0(i.slice(1))):t.push(O0(i));}return r.length>0?t.length>0?n=>t.some(i=>i(n.basename))&&!r.some(i=>i(n.basename)):n=>!r.some(i=>i(n.basename)):n=>t.some(i=>i(n.basename))}}},Sf=class e extends hK{static get defaultOptions(){return {root:".",fileFilter:t=>!0,directoryFilter:t=>!0,type:B0,lstat:!1,depth:2147483648,alwaysStat:!1}}constructor(t={}){super({objectMode:!0,autoDestroy:!0,highWaterMark:t.highWaterMark||4096});let r={...e.defaultOptions,...t},{root:n,type:i}=r;this._fileFilter=LI(r.fileFilter),this._directoryFilter=LI(r.directoryFilter);let s=r.lstat?PI:pK;bK?this._stat=o=>s(o,{bigint:!0}):this._stat=s,this._maxDepth=r.depth,this._wantsDir=[BI,vf,yf].includes(i),this._wantsFile=[B0,vf,yf].includes(i),this._wantsEverything=i===yf,this._root=Mu.resolve(n),this._isDirent="Dirent"in Uu&&!r.alwaysStat,this._statsProp=this._isDirent?"dirent":"stats",this._rdOptions={encoding:"utf8",withFileTypes:this._isDirent},this.parents=[this._exploreDir(n,1)],this.reading=!1,this.parent=void 0;}async _read(t){if(!this.reading){this.reading=!0;try{for(;!this.destroyed&&t>0;){let{path:r,depth:n,files:i=[]}=this.parent||{};if(i.length>0){let s=i.splice(0,t).map(o=>this._formatEntry(o,r));for(let o of await Promise.all(s)){if(this.destroyed)return;let a=await this._getEntryType(o);a==="directory"&&this._directoryFilter(o)?(n<=this._maxDepth&&this.parents.push(this._exploreDir(o.fullPath,n+1)),this._wantsDir&&(this.push(o),t--)):(a==="file"||this._includeAsFile(o))&&this._fileFilter(o)&&this._wantsFile&&(this.push(o),t--);}}else {let s=this.parents.pop();if(!s){this.push(null);break}if(this.parent=await s,this.destroyed)return}}}catch(r){this.destroy(r);}finally{this.reading=!1;}}}async _exploreDir(t,r){let n;try{n=await dK(t,this._rdOptions);}catch(i){this._onError(i);}return {files:n,depth:r,path:t}}async _formatEntry(t,r){let n;try{let i=this._isDirent?t.name:t,s=Mu.resolve(Mu.join(r,i));n={path:Mu.relative(this._root,s),fullPath:s,basename:i},n[this._statsProp]=this._isDirent?t:await this._stat(s);}catch(i){this._onError(i);}return n}_onError(t){vK(t)&&!this.destroyed?this.emit("warn",t):this.destroy(t);}async _getEntryType(t){let r=t&&t[this._statsProp];if(r){if(r.isFile())return "file";if(r.isDirectory())return "directory";if(r&&r.isSymbolicLink()){let n=t.fullPath;try{let i=await gK(n),s=await PI(i);if(s.isFile())return "file";if(s.isDirectory()){let o=i.length;if(n.startsWith(i)&&n.substr(o,1)===Mu.sep){let a=new Error(`Circular symlink detected: "${n}" points to "${i}"`);return a.code=OI,this._onError(a)}return "directory"}}catch(i){this._onError(i);}}}}_includeAsFile(t){let r=t&&t[this._statsProp];return r&&this._wantsEverything&&!r.isDirectory()}},oa=(e,t={})=>{let r=t.entryType||t.type;if(r==="both"&&(r=vf),r&&(t.type=r),e){if(typeof e!="string")throw new TypeError("readdirp: root argument must be a string. Usage: readdirp(root, options)");if(r&&!kI.includes(r))throw new Error(`readdirp: Invalid type passed. Use one of ${kI.join(", ")}`)}else throw new Error("readdirp: root argument is required. Usage: readdirp(root, options)");return t.root=e,new Sf(t)},CK=(e,t={})=>new Promise((r,n)=>{let i=[];oa(e,t).on("data",s=>i.push(s)).on("end",()=>r(i)).on("error",s=>n(s));});oa.promise=CK;oa.ReaddirpStream=Sf;oa.default=oa;qI.exports=oa;});var q0=A((Kue,MI)=>{MI.exports=function(e,t){if(typeof e!="string")throw new TypeError("expected path to be a string");if(e==="\\"||e==="/")return "/";var r=e.length;if(r<=1)return e;var n="";if(r>4&&e[3]==="\\"){var i=e[2];(i==="?"||i===".")&&e.slice(0,2)==="\\\\"&&(e=e.slice(2),n="//");}var s=e.split(/[/\\]+/);return t!==!1&&s[s.length-1]===""&&s.pop(),n+s.join("/")};});var WI=A((VI,HI)=>{Object.defineProperty(VI,"__esModule",{value:!0});var jI=L0(),EK=q0(),UI="!",xK={returnIndex:!1},wK=e=>Array.isArray(e)?e:[e],_K=(e,t)=>{if(typeof e=="function")return e;if(typeof e=="string"){let r=jI(e,t);return n=>e===n||r(n)}return e instanceof RegExp?r=>e.test(r):r=>!1},$I=(e,t,r,n)=>{let i=Array.isArray(r),s=i?r[0]:r;if(!i&&typeof s!="string")throw new TypeError("anymatch: second argument must be a string: got "+Object.prototype.toString.call(s));let o=EK(s,!1);for(let c=0;c<t.length;c++){let l=t[c];if(l(o))return n?-1:!1}let a=i&&[o].concat(r.slice(1));for(let c=0;c<e.length;c++){let l=e[c];if(i?l(...a):l(o))return n?c:!0}return n?-1:!1},F0=(e,t,r=xK)=>{if(e==null)throw new TypeError("anymatch: specify first argument");let n=typeof r=="boolean"?{returnIndex:r}:r,i=n.returnIndex||!1,s=wK(e),o=s.filter(c=>typeof c=="string"&&c.charAt(0)===UI).map(c=>c.slice(1)).map(c=>jI(c,n)),a=s.filter(c=>typeof c!="string"||typeof c=="string"&&c.charAt(0)!==UI).map(c=>_K(c,n));return t==null?(c,l=!1)=>$I(a,o,c,typeof l=="boolean"?l:!1):$I(a,o,t,i)};F0.default=F0;HI.exports=F0;});var zI=A((zue,KI)=>{KI.exports=function(t){if(typeof t!="string"||t==="")return !1;for(var r;r=/(\\).|([@?!+*]\(.*\))/g.exec(t);){if(r[2])return !0;t=t.slice(r.index+r[0].length);}return !1};});var M0=A((Gue,YI)=>{var TK=zI(),GI={"{":"}","(":")","[":"]"},AK=function(e){if(e[0]==="!")return !0;for(var t=0,r=-2,n=-2,i=-2,s=-2,o=-2;t<e.length;){if(e[t]==="*"||e[t+1]==="?"&&/[\].+)]/.test(e[t])||n!==-1&&e[t]==="["&&e[t+1]!=="]"&&(n<t&&(n=e.indexOf("]",t)),n>t&&(o===-1||o>n||(o=e.indexOf("\\",t),o===-1||o>n)))||i!==-1&&e[t]==="{"&&e[t+1]!=="}"&&(i=e.indexOf("}",t),i>t&&(o=e.indexOf("\\",t),o===-1||o>i))||s!==-1&&e[t]==="("&&e[t+1]==="?"&&/[:!=]/.test(e[t+2])&&e[t+3]!==")"&&(s=e.indexOf(")",t),s>t&&(o=e.indexOf("\\",t),o===-1||o>s))||r!==-1&&e[t]==="("&&e[t+1]!=="|"&&(r<t&&(r=e.indexOf("|",t)),r!==-1&&e[r+1]!==")"&&(s=e.indexOf(")",r),s>r&&(o=e.indexOf("\\",r),o===-1||o>s))))return !0;if(e[t]==="\\"){var a=e[t+1];t+=2;var c=GI[a];if(c){var l=e.indexOf(c,t);l!==-1&&(t=l+1);}if(e[t]==="!")return !0}else t++;}return !1},RK=function(e){if(e[0]==="!")return !0;for(var t=0;t<e.length;){if(/[*?{}()[\]]/.test(e[t]))return !0;if(e[t]==="\\"){var r=e[t+1];t+=2;var n=GI[r];if(n){var i=e.indexOf(n,t);i!==-1&&(t=i+1);}if(e[t]==="!")return !0}else t++;}return !1};YI.exports=function(t,r){if(typeof t!="string"||t==="")return !1;if(TK(t))return !0;var n=AK;return r&&r.strict===!1&&(n=RK),n(t)};});var XI=A((Yue,QI)=>{var IK=M0(),DK=he("path").posix.dirname,PK=he("os").platform()==="win32",U0="/",kK=/\\/g,NK=/[\{\[].*[\}\]]$/,LK=/(^|[^\\])([\{\[]|\([^\)]+$)/,OK=/\\([\!\*\?\|\[\]\(\)\{\}])/g;QI.exports=function(t,r){var n=Object.assign({flipBackslashes:!0},r);n.flipBackslashes&&PK&&t.indexOf(U0)<0&&(t=t.replace(kK,U0)),NK.test(t)&&(t+=U0),t+="a";do t=DK(t);while(IK(t)||LK.test(t));return t.replace(OK,"$1")};});var Cf=A(kn=>{kn.isInteger=e=>typeof e=="number"?Number.isInteger(e):typeof e=="string"&&e.trim()!==""?Number.isInteger(Number(e)):!1;kn.find=(e,t)=>e.nodes.find(r=>r.type===t);kn.exceedsLimit=(e,t,r=1,n)=>n===!1||!kn.isInteger(e)||!kn.isInteger(t)?!1:(Number(t)-Number(e))/Number(r)>=n;kn.escapeNode=(e,t=0,r)=>{let n=e.nodes[t];n&&(r&&n.type===r||n.type==="open"||n.type==="close")&&n.escaped!==!0&&(n.value="\\"+n.value,n.escaped=!0);};kn.encloseBrace=e=>e.type!=="brace"||e.commas>>0+e.ranges>>0?!1:(e.invalid=!0,!0);kn.isInvalidBrace=e=>e.type!=="brace"?!1:e.invalid===!0||e.dollar?!0:!(e.commas>>0+e.ranges>>0)||e.open!==!0||e.close!==!0?(e.invalid=!0,!0):!1;kn.isOpenOrClose=e=>e.type==="open"||e.type==="close"?!0:e.open===!0||e.close===!0;kn.reduce=e=>e.reduce((t,r)=>(r.type==="text"&&t.push(r.value),r.type==="range"&&(r.type="text"),t),[]);kn.flatten=(...e)=>{let t=[],r=n=>{for(let i=0;i<n.length;i++){let s=n[i];Array.isArray(s)?r(s):s!==void 0&&t.push(s);}return t};return r(e),t};});var Ef=A((Xue,ZI)=>{var JI=Cf();ZI.exports=(e,t={})=>{let r=(n,i={})=>{let s=t.escapeInvalid&&JI.isInvalidBrace(i),o=n.invalid===!0&&t.escapeInvalid===!0,a="";if(n.value)return (s||o)&&JI.isOpenOrClose(n)?"\\"+n.value:n.value;if(n.value)return n.value;if(n.nodes)for(let c of n.nodes)a+=r(c);return a};return r(e)};});var t2=A((Jue,e2)=>{e2.exports=function(e){return typeof e=="number"?e-e===0:typeof e=="string"&&e.trim()!==""?Number.isFinite?Number.isFinite(+e):isFinite(+e):!1};});var l2=A((Zue,c2)=>{var r2=t2(),no=(e,t,r)=>{if(r2(e)===!1)throw new TypeError("toRegexRange: expected the first argument to be a number");if(t===void 0||e===t)return String(e);if(r2(t)===!1)throw new TypeError("toRegexRange: expected the second argument to be a number.");let n={relaxZeros:!0,...r};typeof n.strictZeros=="boolean"&&(n.relaxZeros=n.strictZeros===!1);let i=String(n.relaxZeros),s=String(n.shorthand),o=String(n.capture),a=String(n.wrap),c=e+":"+t+"="+i+s+o+a;if(no.cache.hasOwnProperty(c))return no.cache[c].result;let l=Math.min(e,t),u=Math.max(e,t);if(Math.abs(l-u)===1){let S=e+"|"+t;return n.capture?`(${S})`:n.wrap===!1?S:`(?:${S})`}let f=u2(e)||u2(t),d={min:e,max:t,a:l,b:u},p=[],m=[];if(f&&(d.isPadded=f,d.maxLen=String(d.max).length),l<0){let S=u<0?Math.abs(u):1;m=n2(S,Math.abs(l),d,n),l=d.a=0;}return u>=0&&(p=n2(l,u,d,n)),d.negatives=m,d.positives=p,d.result=BK(m,p),n.capture===!0?d.result=`(${d.result})`:n.wrap!==!1&&p.length+m.length>1&&(d.result=`(?:${d.result})`),no.cache[c]=d,d.result};function BK(e,t,r){let n=$0(e,t,"-",!1)||[],i=$0(t,e,"",!1)||[],s=$0(e,t,"-?",!0)||[];return n.concat(s).concat(i).join("|")}function qK(e,t){let r=1,n=1,i=s2(e,r),s=new Set([t]);for(;e<=i&&i<=t;)s.add(i),r+=1,i=s2(e,r);for(i=o2(t+1,n)-1;e<i&&i<=t;)s.add(i),n+=1,i=o2(t+1,n)-1;return s=[...s],s.sort(UK),s}function FK(e,t,r){if(e===t)return {pattern:e,count:[],digits:0};let n=MK(e,t),i=n.length,s="",o=0;for(let a=0;a<i;a++){let[c,l]=n[a];c===l?s+=c:c!=="0"||l!=="9"?s+=$K(c,l):o++;}return o&&(s+=r.shorthand===!0?"\\d":"[0-9]"),{pattern:s,count:[o],digits:i}}function n2(e,t,r,n){let i=qK(e,t),s=[],o=e,a;for(let c=0;c<i.length;c++){let l=i[c],u=FK(String(o),String(l),n),f="";if(!r.isPadded&&a&&a.pattern===u.pattern){a.count.length>1&&a.count.pop(),a.count.push(u.count[0]),a.string=a.pattern+a2(a.count),o=l+1;continue}r.isPadded&&(f=jK(l,r,n)),u.string=f+u.pattern+a2(u.count),s.push(u),o=l+1,a=u;}return s}function $0(e,t,r,n,i){let s=[];for(let o of e){let{string:a}=o;!n&&!i2(t,"string",a)&&s.push(r+a),n&&i2(t,"string",a)&&s.push(r+a);}return s}function MK(e,t){let r=[];for(let n=0;n<e.length;n++)r.push([e[n],t[n]]);return r}function UK(e,t){return e>t?1:t>e?-1:0}function i2(e,t,r){return e.some(n=>n[t]===r)}function s2(e,t){return Number(String(e).slice(0,-t)+"9".repeat(t))}function o2(e,t){return e-e%Math.pow(10,t)}function a2(e){let[t=0,r=""]=e;return r||t>1?`{${t+(r?","+r:"")}}`:""}function $K(e,t,r){return `[${e}${t-e===1?"":"-"}${t}]`}function u2(e){return /^-?(0+)\d/.test(e)}function jK(e,t,r){if(!t.isPadded)return e;let n=Math.abs(t.maxLen-String(e).length),i=r.relaxZeros!==!1;switch(n){case 0:return "";case 1:return i?"0?":"0";case 2:return i?"0{0,2}":"00";default:return i?`0{0,${n}}`:`0{${n}}`}}no.cache={};no.clearCache=()=>no.cache={};c2.exports=no;});var H0=A((ece,v2)=>{var VK=he("util"),d2=l2(),f2=e=>e!==null&&typeof e=="object"&&!Array.isArray(e),HK=e=>t=>e===!0?Number(t):String(t),j0=e=>typeof e=="number"||typeof e=="string"&&e!=="",$u=e=>Number.isInteger(+e),V0=e=>{let t=`${e}`,r=-1;if(t[0]==="-"&&(t=t.slice(1)),t==="0")return !1;for(;t[++r]==="0";);return r>0},WK=(e,t,r)=>typeof e=="string"||typeof t=="string"?!0:r.stringify===!0,KK=(e,t,r)=>{if(t>0){let n=e[0]==="-"?"-":"";n&&(e=e.slice(1)),e=n+e.padStart(n?t-1:t,"0");}return r===!1?String(e):e},h2=(e,t)=>{let r=e[0]==="-"?"-":"";for(r&&(e=e.slice(1),t--);e.length<t;)e="0"+e;return r?"-"+e:e},zK=(e,t)=>{e.negatives.sort((o,a)=>o<a?-1:o>a?1:0),e.positives.sort((o,a)=>o<a?-1:o>a?1:0);let r=t.capture?"":"?:",n="",i="",s;return e.positives.length&&(n=e.positives.join("|")),e.negatives.length&&(i=`-(${r}${e.negatives.join("|")})`),n&&i?s=`${n}|${i}`:s=n||i,t.wrap?`(${r}${s})`:s},p2=(e,t,r,n)=>{if(r)return d2(e,t,{wrap:!1,...n});let i=String.fromCharCode(e);if(e===t)return i;let s=String.fromCharCode(t);return `[${i}-${s}]`},g2=(e,t,r)=>{if(Array.isArray(e)){let n=r.wrap===!0,i=r.capture?"":"?:";return n?`(${i}${e.join("|")})`:e.join("|")}return d2(e,t,r)},m2=(...e)=>new RangeError("Invalid range arguments: "+VK.inspect(...e)),y2=(e,t,r)=>{if(r.strictRanges===!0)throw m2([e,t]);return []},GK=(e,t)=>{if(t.strictRanges===!0)throw new TypeError(`Expected step "${e}" to be a number`);return []},YK=(e,t,r=1,n={})=>{let i=Number(e),s=Number(t);if(!Number.isInteger(i)||!Number.isInteger(s)){if(n.strictRanges===!0)throw m2([e,t]);return []}i===0&&(i=0),s===0&&(s=0);let o=i>s,a=String(e),c=String(t),l=String(r);r=Math.max(Math.abs(r),1);let u=V0(a)||V0(c)||V0(l),f=u?Math.max(a.length,c.length,l.length):0,d=u===!1&&WK(e,t,n)===!1,p=n.transform||HK(d);if(n.toRegex&&r===1)return p2(h2(e,f),h2(t,f),!0,n);let m={negatives:[],positives:[]},S=v=>m[v<0?"negatives":"positives"].push(Math.abs(v)),x=[],I=0;for(;o?i>=s:i<=s;)n.toRegex===!0&&r>1?S(i):x.push(KK(p(i,I),f,d)),i=o?i-r:i+r,I++;return n.toRegex===!0?r>1?zK(m,n):g2(x,null,{wrap:!1,...n}):x},QK=(e,t,r=1,n={})=>{if(!$u(e)&&e.length>1||!$u(t)&&t.length>1)return y2(e,t,n);let i=n.transform||(d=>String.fromCharCode(d)),s=`${e}`.charCodeAt(0),o=`${t}`.charCodeAt(0),a=s>o,c=Math.min(s,o),l=Math.max(s,o);if(n.toRegex&&r===1)return p2(c,l,!1,n);let u=[],f=0;for(;a?s>=o:s<=o;)u.push(i(s,f)),s=a?s-r:s+r,f++;return n.toRegex===!0?g2(u,null,{wrap:!1,options:n}):u},xf=(e,t,r,n={})=>{if(t==null&&j0(e))return [e];if(!j0(e)||!j0(t))return y2(e,t,n);if(typeof r=="function")return xf(e,t,1,{transform:r});if(f2(r))return xf(e,t,0,r);let i={...n};return i.capture===!0&&(i.wrap=!0),r=r||i.step||1,$u(r)?$u(e)&&$u(t)?YK(e,t,r,i):QK(e,t,Math.max(Math.abs(r),1),i):r!=null&&!f2(r)?GK(r,i):xf(e,t,1,r)};v2.exports=xf;});var C2=A((tce,b2)=>{var XK=H0(),S2=Cf(),JK=(e,t={})=>{let r=(n,i={})=>{let s=S2.isInvalidBrace(i),o=n.invalid===!0&&t.escapeInvalid===!0,a=s===!0||o===!0,c=t.escapeInvalid===!0?"\\":"",l="";if(n.isOpen===!0||n.isClose===!0)return c+n.value;if(n.type==="open")return a?c+n.value:"(";if(n.type==="close")return a?c+n.value:")";if(n.type==="comma")return n.prev.type==="comma"?"":a?n.value:"|";if(n.value)return n.value;if(n.nodes&&n.ranges>0){let u=S2.reduce(n.nodes),f=XK(...u,{...t,wrap:!1,toRegex:!0});if(f.length!==0)return u.length>1&&f.length>1?`(${f})`:f}if(n.nodes)for(let u of n.nodes)l+=r(u,n);return l};return r(e)};b2.exports=JK;});var w2=A((rce,x2)=>{var ZK=H0(),E2=Ef(),aa=Cf(),io=(e="",t="",r=!1)=>{let n=[];if(e=[].concat(e),t=[].concat(t),!t.length)return e;if(!e.length)return r?aa.flatten(t).map(i=>`{${i}}`):t;for(let i of e)if(Array.isArray(i))for(let s of i)n.push(io(s,t,r));else for(let s of t)r===!0&&typeof s=="string"&&(s=`{${s}}`),n.push(Array.isArray(s)?io(i,s,r):i+s);return aa.flatten(n)},e7=(e,t={})=>{let r=t.rangeLimit===void 0?1e3:t.rangeLimit,n=(i,s={})=>{i.queue=[];let o=s,a=s.queue;for(;o.type!=="brace"&&o.type!=="root"&&o.parent;)o=o.parent,a=o.queue;if(i.invalid||i.dollar){a.push(io(a.pop(),E2(i,t)));return}if(i.type==="brace"&&i.invalid!==!0&&i.nodes.length===2){a.push(io(a.pop(),["{}"]));return}if(i.nodes&&i.ranges>0){let f=aa.reduce(i.nodes);if(aa.exceedsLimit(...f,t.step,r))throw new RangeError("expanded array length exceeds range limit. Use options.rangeLimit to increase or disable the limit.");let d=ZK(...f,t);d.length===0&&(d=E2(i,t)),a.push(io(a.pop(),d)),i.nodes=[];return}let c=aa.encloseBrace(i),l=i.queue,u=i;for(;u.type!=="brace"&&u.type!=="root"&&u.parent;)u=u.parent,l=u.queue;for(let f=0;f<i.nodes.length;f++){let d=i.nodes[f];if(d.type==="comma"&&i.type==="brace"){f===1&&l.push(""),l.push("");continue}if(d.type==="close"){a.push(io(a.pop(),l,c));continue}if(d.value&&d.type!=="open"){l.push(io(l.pop(),d.value));continue}d.nodes&&n(d,i);}return l};return aa.flatten(n(e))};x2.exports=e7;});var T2=A((nce,_2)=>{_2.exports={MAX_LENGTH:1024*64,CHAR_0:"0",CHAR_9:"9",CHAR_UPPERCASE_A:"A",CHAR_LOWERCASE_A:"a",CHAR_UPPERCASE_Z:"Z",CHAR_LOWERCASE_Z:"z",CHAR_LEFT_PARENTHESES:"(",CHAR_RIGHT_PARENTHESES:")",CHAR_ASTERISK:"*",CHAR_AMPERSAND:"&",CHAR_AT:"@",CHAR_BACKSLASH:"\\",CHAR_BACKTICK:"`",CHAR_CARRIAGE_RETURN:"\r",CHAR_CIRCUMFLEX_ACCENT:"^",CHAR_COLON:":",CHAR_COMMA:",",CHAR_DOLLAR:"$",CHAR_DOT:".",CHAR_DOUBLE_QUOTE:'"',CHAR_EQUAL:"=",CHAR_EXCLAMATION_MARK:"!",CHAR_FORM_FEED:"\f",CHAR_FORWARD_SLASH:"/",CHAR_HASH:"#",CHAR_HYPHEN_MINUS:"-",CHAR_LEFT_ANGLE_BRACKET:"<",CHAR_LEFT_CURLY_BRACE:"{",CHAR_LEFT_SQUARE_BRACKET:"[",CHAR_LINE_FEED:`
`,CHAR_NO_BREAK_SPACE:"\xA0",CHAR_PERCENT:"%",CHAR_PLUS:"+",CHAR_QUESTION_MARK:"?",CHAR_RIGHT_ANGLE_BRACKET:">",CHAR_RIGHT_CURLY_BRACE:"}",CHAR_RIGHT_SQUARE_BRACKET:"]",CHAR_SEMICOLON:";",CHAR_SINGLE_QUOTE:"'",CHAR_SPACE:" ",CHAR_TAB:"	",CHAR_UNDERSCORE:"_",CHAR_VERTICAL_LINE:"|",CHAR_ZERO_WIDTH_NOBREAK_SPACE:"\uFEFF"};});var P2=A((ice,D2)=>{var t7=Ef(),{MAX_LENGTH:A2,CHAR_BACKSLASH:W0,CHAR_BACKTICK:r7,CHAR_COMMA:n7,CHAR_DOT:i7,CHAR_LEFT_PARENTHESES:s7,CHAR_RIGHT_PARENTHESES:o7,CHAR_LEFT_CURLY_BRACE:a7,CHAR_RIGHT_CURLY_BRACE:u7,CHAR_LEFT_SQUARE_BRACKET:R2,CHAR_RIGHT_SQUARE_BRACKET:I2,CHAR_DOUBLE_QUOTE:c7,CHAR_SINGLE_QUOTE:l7,CHAR_NO_BREAK_SPACE:f7,CHAR_ZERO_WIDTH_NOBREAK_SPACE:h7}=T2(),d7=(e,t={})=>{if(typeof e!="string")throw new TypeError("Expected a string");let r=t||{},n=typeof r.maxLength=="number"?Math.min(A2,r.maxLength):A2;if(e.length>n)throw new SyntaxError(`Input length (${e.length}), exceeds max characters (${n})`);let i={type:"root",input:e,nodes:[]},s=[i],o=i,a=i,c=0,l=e.length,u=0,f=0,d,m=()=>e[u++],S=x=>{if(x.type==="text"&&a.type==="dot"&&(a.type="text"),a&&a.type==="text"&&x.type==="text"){a.value+=x.value;return}return o.nodes.push(x),x.parent=o,x.prev=a,a=x,x};for(S({type:"bos"});u<l;)if(o=s[s.length-1],d=m(),!(d===h7||d===f7)){if(d===W0){S({type:"text",value:(t.keepEscaping?d:"")+m()});continue}if(d===I2){S({type:"text",value:"\\"+d});continue}if(d===R2){c++;let I;for(;u<l&&(I=m());){if(d+=I,I===R2){c++;continue}if(I===W0){d+=m();continue}if(I===I2&&(c--,c===0))break}S({type:"text",value:d});continue}if(d===s7){o=S({type:"paren",nodes:[]}),s.push(o),S({type:"text",value:d});continue}if(d===o7){if(o.type!=="paren"){S({type:"text",value:d});continue}o=s.pop(),S({type:"text",value:d}),o=s[s.length-1];continue}if(d===c7||d===l7||d===r7){let x=d,I;for(t.keepQuotes!==!0&&(d="");u<l&&(I=m());){if(I===W0){d+=I+m();continue}if(I===x){t.keepQuotes===!0&&(d+=I);break}d+=I;}S({type:"text",value:d});continue}if(d===a7){f++;let I={type:"brace",open:!0,close:!1,dollar:a.value&&a.value.slice(-1)==="$"||o.dollar===!0,depth:f,commas:0,ranges:0,nodes:[]};o=S(I),s.push(o),S({type:"open",value:d});continue}if(d===u7){if(o.type!=="brace"){S({type:"text",value:d});continue}let x="close";o=s.pop(),o.close=!0,S({type:x,value:d}),f--,o=s[s.length-1];continue}if(d===n7&&f>0){if(o.ranges>0){o.ranges=0;let x=o.nodes.shift();o.nodes=[x,{type:"text",value:t7(o)}];}S({type:"comma",value:d}),o.commas++;continue}if(d===i7&&f>0&&o.commas===0){let x=o.nodes;if(f===0||x.length===0){S({type:"text",value:d});continue}if(a.type==="dot"){if(o.range=[],a.value+=d,a.type="range",o.nodes.length!==3&&o.nodes.length!==5){o.invalid=!0,o.ranges=0,a.type="text";continue}o.ranges++,o.args=[];continue}if(a.type==="range"){x.pop();let I=x[x.length-1];I.value+=a.value+d,a=I,o.ranges--;continue}S({type:"dot",value:d});continue}S({type:"text",value:d});}do if(o=s.pop(),o.type!=="root"){o.nodes.forEach(v=>{v.nodes||(v.type==="open"&&(v.isOpen=!0),v.type==="close"&&(v.isClose=!0),v.nodes||(v.type="text"),v.invalid=!0);});let x=s[s.length-1],I=x.nodes.indexOf(o);x.nodes.splice(I,1,...o.nodes);}while(s.length>0);return S({type:"eos"}),i};D2.exports=d7;});var L2=A((sce,N2)=>{var k2=Ef(),p7=C2(),g7=w2(),m7=P2(),vn=(e,t={})=>{let r=[];if(Array.isArray(e))for(let n of e){let i=vn.create(n,t);Array.isArray(i)?r.push(...i):r.push(i);}else r=[].concat(vn.create(e,t));return t&&t.expand===!0&&t.nodupes===!0&&(r=[...new Set(r)]),r};vn.parse=(e,t={})=>m7(e,t);vn.stringify=(e,t={})=>k2(typeof e=="string"?vn.parse(e,t):e,t);vn.compile=(e,t={})=>(typeof e=="string"&&(e=vn.parse(e,t)),p7(e,t));vn.expand=(e,t={})=>{typeof e=="string"&&(e=vn.parse(e,t));let r=g7(e,t);return t.noempty===!0&&(r=r.filter(Boolean)),t.nodupes===!0&&(r=[...new Set(r)]),r};vn.create=(e,t={})=>e===""||e.length<3?[e]:t.expand!==!0?vn.compile(e,t):vn.expand(e,t);N2.exports=vn;});var O2=A((oce,y7)=>{y7.exports=["3dm","3ds","3g2","3gp","7z","a","aac","adp","ai","aif","aiff","alz","ape","apk","appimage","ar","arj","asf","au","avi","bak","baml","bh","bin","bk","bmp","btif","bz2","bzip2","cab","caf","cgm","class","cmx","cpio","cr2","cur","dat","dcm","deb","dex","djvu","dll","dmg","dng","doc","docm","docx","dot","dotm","dra","DS_Store","dsk","dts","dtshd","dvb","dwg","dxf","ecelp4800","ecelp7470","ecelp9600","egg","eol","eot","epub","exe","f4v","fbs","fh","fla","flac","flatpak","fli","flv","fpx","fst","fvt","g3","gh","gif","graffle","gz","gzip","h261","h263","h264","icns","ico","ief","img","ipa","iso","jar","jpeg","jpg","jpgv","jpm","jxr","key","ktx","lha","lib","lvp","lz","lzh","lzma","lzo","m3u","m4a","m4v","mar","mdi","mht","mid","midi","mj2","mka","mkv","mmr","mng","mobi","mov","movie","mp3","mp4","mp4a","mpeg","mpg","mpga","mxu","nef","npx","numbers","nupkg","o","odp","ods","odt","oga","ogg","ogv","otf","ott","pages","pbm","pcx","pdb","pdf","pea","pgm","pic","png","pnm","pot","potm","potx","ppa","ppam","ppm","pps","ppsm","ppsx","ppt","pptm","pptx","psd","pya","pyc","pyo","pyv","qt","rar","ras","raw","resources","rgb","rip","rlc","rmf","rmvb","rpm","rtf","rz","s3m","s7z","scpt","sgi","shar","snap","sil","sketch","slk","smv","snk","so","stl","suo","sub","swf","tar","tbz","tbz2","tga","tgz","thmx","tif","tiff","tlz","ttc","ttf","txz","udf","uvh","uvi","uvm","uvp","uvs","uvu","viv","vob","war","wav","wax","wbmp","wdp","weba","webm","webp","whl","wim","wm","wma","wmv","wmx","woff","woff2","wrm","wvx","xbm","xif","xla","xlam","xls","xlsb","xlsm","xlsx","xlt","xltm","xltx","xm","xmind","xpi","xpm","xwd","xz","z","zip","zipx"];});var q2=A((ace,B2)=>{B2.exports=O2();});var M2=A((uce,F2)=>{var v7=he("path"),S7=q2(),b7=new Set(S7);F2.exports=e=>b7.has(v7.extname(e).slice(1).toLowerCase());});var wf=A(Be=>{var{sep:C7}=he("path"),{platform:K0}=process,E7=he("os");Be.EV_ALL="all";Be.EV_READY="ready";Be.EV_ADD="add";Be.EV_CHANGE="change";Be.EV_ADD_DIR="addDir";Be.EV_UNLINK="unlink";Be.EV_UNLINK_DIR="unlinkDir";Be.EV_RAW="raw";Be.EV_ERROR="error";Be.STR_DATA="data";Be.STR_END="end";Be.STR_CLOSE="close";Be.FSEVENT_CREATED="created";Be.FSEVENT_MODIFIED="modified";Be.FSEVENT_DELETED="deleted";Be.FSEVENT_MOVED="moved";Be.FSEVENT_CLONED="cloned";Be.FSEVENT_UNKNOWN="unknown";Be.FSEVENT_TYPE_FILE="file";Be.FSEVENT_TYPE_DIRECTORY="directory";Be.FSEVENT_TYPE_SYMLINK="symlink";Be.KEY_LISTENERS="listeners";Be.KEY_ERR="errHandlers";Be.KEY_RAW="rawEmitters";Be.HANDLER_KEYS=[Be.KEY_LISTENERS,Be.KEY_ERR,Be.KEY_RAW];Be.DOT_SLASH=`.${C7}`;Be.BACK_SLASH_RE=/\\/g;Be.DOUBLE_SLASH_RE=/\/\//;Be.SLASH_OR_BACK_SLASH_RE=/[/\\]/;Be.DOT_RE=/\..*\.(sw[px])$|~$|\.subl.*\.tmp/;Be.REPLACER_RE=/^\.[/\\]/;Be.SLASH="/";Be.SLASH_SLASH="//";Be.BRACE_START="{";Be.BANG="!";Be.ONE_DOT=".";Be.TWO_DOTS="..";Be.STAR="*";Be.GLOBSTAR="**";Be.ROOT_GLOBSTAR="/**/*";Be.SLASH_GLOBSTAR="/**";Be.DIR_SUFFIX="Dir";Be.ANYMATCH_OPTS={dot:!0};Be.STRING_TYPE="string";Be.FUNCTION_TYPE="function";Be.EMPTY_STR="";Be.EMPTY_FN=()=>{};Be.IDENTITY_FN=e=>e;Be.isWindows=K0==="win32";Be.isMacos=K0==="darwin";Be.isLinux=K0==="linux";Be.isIBMi=E7.type()==="OS400";});var W2=A((lce,H2)=>{var Ui=he("fs"),gr=he("path"),{promisify:Wu}=he("util"),x7=M2(),{isWindows:w7,isLinux:_7,EMPTY_FN:T7,EMPTY_STR:A7,KEY_LISTENERS:ua,KEY_ERR:z0,KEY_RAW:ju,HANDLER_KEYS:R7,EV_CHANGE:Tf,EV_ADD:_f,EV_ADD_DIR:I7,EV_ERROR:$2,STR_DATA:D7,STR_END:P7,BRACE_START:k7,STAR:N7}=wf(),L7="watch",O7=Wu(Ui.open),j2=Wu(Ui.stat),B7=Wu(Ui.lstat),q7=Wu(Ui.close),G0=Wu(Ui.realpath),F7={lstat:B7,stat:j2},Q0=(e,t)=>{e instanceof Set?e.forEach(t):t(e);},Vu=(e,t,r)=>{let n=e[t];n instanceof Set||(e[t]=n=new Set([n])),n.add(r);},M7=e=>t=>{let r=e[t];r instanceof Set?r.clear():delete e[t];},Hu=(e,t,r)=>{let n=e[t];n instanceof Set?n.delete(r):n===r&&delete e[t];},V2=e=>e instanceof Set?e.size===0:!e,Af=new Map;function U2(e,t,r,n,i){let s=(o,a)=>{r(e),i(o,a,{watchedPath:e}),a&&e!==a&&Rf(gr.resolve(e,a),ua,gr.join(e,a));};try{return Ui.watch(e,t,s)}catch(o){n(o);}}var Rf=(e,t,r,n,i)=>{let s=Af.get(e);s&&Q0(s[t],o=>{o(r,n,i);});},U7=(e,t,r,n)=>{let{listener:i,errHandler:s,rawEmitter:o}=n,a=Af.get(t),c;if(!r.persistent)return c=U2(e,r,i,s,o),c.close.bind(c);if(a)Vu(a,ua,i),Vu(a,z0,s),Vu(a,ju,o);else {if(c=U2(e,r,Rf.bind(null,t,ua),s,Rf.bind(null,t,ju)),!c)return;c.on($2,async l=>{let u=Rf.bind(null,t,z0);if(a.watcherUnusable=!0,w7&&l.code==="EPERM")try{let f=await O7(e,"r");await q7(f),u(l);}catch{}else u(l);}),a={listeners:i,errHandlers:s,rawEmitters:o,watcher:c},Af.set(t,a);}return ()=>{Hu(a,ua,i),Hu(a,z0,s),Hu(a,ju,o),V2(a.listeners)&&(a.watcher.close(),Af.delete(t),R7.forEach(M7(a)),a.watcher=void 0,Object.freeze(a));}},Y0=new Map,$7=(e,t,r,n)=>{let {listener:i,rawEmitter:s}=n,o=Y0.get(t),l=o&&o.options;return l&&(l.persistent<r.persistent||l.interval>r.interval)&&(Ui.unwatchFile(t),o=void 0),o?(Vu(o,ua,i),Vu(o,ju,s)):(o={listeners:i,rawEmitters:s,options:r,watcher:Ui.watchFile(t,r,(u,f)=>{Q0(o.rawEmitters,p=>{p(Tf,t,{curr:u,prev:f});});let d=u.mtimeMs;(u.size!==f.size||d>f.mtimeMs||d===0)&&Q0(o.listeners,p=>p(e,u));})},Y0.set(t,o)),()=>{Hu(o,ua,i),Hu(o,ju,s),V2(o.listeners)&&(Y0.delete(t),Ui.unwatchFile(t),o.options=o.watcher=void 0,Object.freeze(o));}},X0=class{constructor(t){this.fsw=t,this._boundHandleError=r=>t._handleError(r);}_watchWithNodeFs(t,r){let n=this.fsw.options,i=gr.dirname(t),s=gr.basename(t);this.fsw._getWatchedDir(i).add(s);let a=gr.resolve(t),c={persistent:n.persistent};r||(r=T7);let l;return n.usePolling?(c.interval=n.enableBinaryInterval&&x7(s)?n.binaryInterval:n.interval,l=$7(t,a,c,{listener:r,rawEmitter:this.fsw._emitRaw})):l=U7(t,a,c,{listener:r,errHandler:this._boundHandleError,rawEmitter:this.fsw._emitRaw}),l}_handleFile(t,r,n){if(this.fsw.closed)return;let i=gr.dirname(t),s=gr.basename(t),o=this.fsw._getWatchedDir(i),a=r;if(o.has(s))return;let c=async(u,f)=>{if(this.fsw._throttle(L7,t,5)){if(!f||f.mtimeMs===0)try{let d=await j2(t);if(this.fsw.closed)return;let p=d.atimeMs,m=d.mtimeMs;(!p||p<=m||m!==a.mtimeMs)&&this.fsw._emit(Tf,t,d),_7&&a.ino!==d.ino?(this.fsw._closeFile(u),a=d,this.fsw._addPathCloser(u,this._watchWithNodeFs(t,c))):a=d;}catch{this.fsw._remove(i,s);}else if(o.has(s)){let d=f.atimeMs,p=f.mtimeMs;(!d||d<=p||p!==a.mtimeMs)&&this.fsw._emit(Tf,t,f),a=f;}}},l=this._watchWithNodeFs(t,c);if(!(n&&this.fsw.options.ignoreInitial)&&this.fsw._isntIgnored(t)){if(!this.fsw._throttle(_f,t,0))return;this.fsw._emit(_f,t,r);}return l}async _handleSymlink(t,r,n,i){if(this.fsw.closed)return;let s=t.fullPath,o=this.fsw._getWatchedDir(r);if(!this.fsw.options.followSymlinks){this.fsw._incrReadyCount();let a;try{a=await G0(n);}catch{return this.fsw._emitReady(),!0}return this.fsw.closed?void 0:(o.has(i)?this.fsw._symlinkPaths.get(s)!==a&&(this.fsw._symlinkPaths.set(s,a),this.fsw._emit(Tf,n,t.stats)):(o.add(i),this.fsw._symlinkPaths.set(s,a),this.fsw._emit(_f,n,t.stats)),this.fsw._emitReady(),!0)}if(this.fsw._symlinkPaths.has(s))return !0;this.fsw._symlinkPaths.set(s,!0);}_handleRead(t,r,n,i,s,o,a){if(t=gr.join(t,A7),!n.hasGlob&&(a=this.fsw._throttle("readdir",t,1e3),!a))return;let c=this.fsw._getWatchedDir(n.path),l=new Set,u=this.fsw._readdirp(t,{fileFilter:f=>n.filterPath(f),directoryFilter:f=>n.filterDir(f),depth:0}).on(D7,async f=>{if(this.fsw.closed){u=void 0;return}let d=f.path,p=gr.join(t,d);if(l.add(d),!(f.stats.isSymbolicLink()&&await this._handleSymlink(f,t,p,d))){if(this.fsw.closed){u=void 0;return}(d===i||!i&&!c.has(d))&&(this.fsw._incrReadyCount(),p=gr.join(s,gr.relative(s,p)),this._addToNodeFs(p,r,n,o+1));}}).on($2,this._boundHandleError);return new Promise(f=>u.once(P7,()=>{if(this.fsw.closed){u=void 0;return}let d=a?a.clear():!1;f(),c.getChildren().filter(p=>p!==t&&!l.has(p)&&(!n.hasGlob||n.filterPath({fullPath:gr.resolve(t,p)}))).forEach(p=>{this.fsw._remove(t,p);}),u=void 0,d&&this._handleRead(t,!1,n,i,s,o,a);}))}async _handleDir(t,r,n,i,s,o,a){let c=this.fsw._getWatchedDir(gr.dirname(t)),l=c.has(gr.basename(t));!(n&&this.fsw.options.ignoreInitial)&&!s&&!l&&(!o.hasGlob||o.globFilter(t))&&this.fsw._emit(I7,t,r),c.add(gr.basename(t)),this.fsw._getWatchedDir(t);let u,f,d=this.fsw.options.depth;if((d==null||i<=d)&&!this.fsw._symlinkPaths.has(a)){if(!s&&(await this._handleRead(t,n,o,s,t,i,u),this.fsw.closed))return;f=this._watchWithNodeFs(t,(p,m)=>{m&&m.mtimeMs===0||this._handleRead(p,!1,o,s,t,i,u);});}return f}async _addToNodeFs(t,r,n,i,s){let o=this.fsw._emitReady;if(this.fsw._isIgnored(t)||this.fsw.closed)return o(),!1;let a=this.fsw._getWatchHelpers(t,i);!a.hasGlob&&n&&(a.hasGlob=n.hasGlob,a.globFilter=n.globFilter,a.filterPath=c=>n.filterPath(c),a.filterDir=c=>n.filterDir(c));try{let c=await F7[a.statMethod](a.watchPath);if(this.fsw.closed)return;if(this.fsw._isIgnored(a.watchPath,c))return o(),!1;let l=this.fsw.options.followSymlinks&&!t.includes(N7)&&!t.includes(k7),u;if(c.isDirectory()){let f=gr.resolve(t),d=l?await G0(t):t;if(this.fsw.closed||(u=await this._handleDir(a.watchPath,c,r,i,s,a,d),this.fsw.closed))return;f!==d&&d!==void 0&&this.fsw._symlinkPaths.set(f,d);}else if(c.isSymbolicLink()){let f=l?await G0(t):t;if(this.fsw.closed)return;let d=gr.dirname(a.watchPath);if(this.fsw._getWatchedDir(d).add(a.watchPath),this.fsw._emit(_f,a.watchPath,c),u=await this._handleDir(d,c,r,i,t,a,f),this.fsw.closed)return;f!==void 0&&this.fsw._symlinkPaths.set(gr.resolve(t),f);}else u=this._handleFile(a.watchPath,c,r);return o(),this.fsw._addPathCloser(t,u),!1}catch(c){if(this.fsw._handleError(c))return o(),t}}};H2.exports=X0;});var J2=A((fce,sm)=>{var nm=he("fs"),mr=he("path"),{promisify:im}=he("util"),ca;try{ca=he("fsevents");}catch(e){process.env.CHOKIDAR_PRINT_FSEVENTS_REQUIRE_ERROR&&console.error(e);}if(ca){let e=process.version.match(/v(\d+)\.(\d+)/);if(e&&e[1]&&e[2]){let t=Number.parseInt(e[1],10),r=Number.parseInt(e[2],10);t===8&&r<16&&(ca=void 0);}}var{EV_ADD:J0,EV_CHANGE:j7,EV_ADD_DIR:K2,EV_UNLINK:If,EV_ERROR:V7,STR_DATA:H7,STR_END:W7,FSEVENT_CREATED:K7,FSEVENT_MODIFIED:z7,FSEVENT_DELETED:G7,FSEVENT_MOVED:Y7,FSEVENT_UNKNOWN:Q7,FSEVENT_TYPE_FILE:X7,FSEVENT_TYPE_DIRECTORY:Ku,FSEVENT_TYPE_SYMLINK:X2,ROOT_GLOBSTAR:z2,DIR_SUFFIX:J7,DOT_SLASH:G2,FUNCTION_TYPE:Z0,EMPTY_FN:Z7,IDENTITY_FN:ez}=wf(),tz=e=>isNaN(e)?{}:{depth:e},tm=im(nm.stat),rz=im(nm.lstat),Y2=im(nm.realpath),nz={stat:tm,lstat:rz},so=new Map,iz=10,sz=new Set([69888,70400,71424,72704,73472,131328,131840,262912]),oz=(e,t)=>({stop:ca.watch(e,t)});function az(e,t,r,n){let i=mr.extname(t)?mr.dirname(t):t,s=mr.dirname(i),o=so.get(i);uz(s)&&(i=s);let a=mr.resolve(e),c=a!==t,l=(f,d,p)=>{c&&(f=f.replace(t,a)),(f===a||!f.indexOf(a+mr.sep))&&r(f,d,p);},u=!1;for(let f of so.keys())if(t.indexOf(mr.resolve(f)+mr.sep)===0){i=f,o=so.get(i),u=!0;break}return o||u?o.listeners.add(l):(o={listeners:new Set([l]),rawEmitter:n,watcher:oz(i,(f,d)=>{if(!o.listeners.size)return;let p=ca.getInfo(f,d);o.listeners.forEach(m=>{m(f,d,p);}),o.rawEmitter(p.event,f,p);})},so.set(i,o)),()=>{let f=o.listeners;if(f.delete(l),!f.size&&(so.delete(i),o.watcher))return o.watcher.stop().then(()=>{o.rawEmitter=o.watcher=void 0,Object.freeze(o);})}}var uz=e=>{let t=0;for(let r of so.keys())if(r.indexOf(e)===0&&(t++,t>=iz))return !0;return !1},cz=()=>ca&&so.size<128,em=(e,t)=>{let r=0;for(;!e.indexOf(t)&&(e=mr.dirname(e))!==t;)r++;return r},Q2=(e,t)=>e.type===Ku&&t.isDirectory()||e.type===X2&&t.isSymbolicLink()||e.type===X7&&t.isFile(),rm=class{constructor(t){this.fsw=t;}checkIgnored(t,r){let n=this.fsw._ignoredPaths;if(this.fsw._isIgnored(t,r))return n.add(t),r&&r.isDirectory()&&n.add(t+z2),!0;n.delete(t),n.delete(t+z2);}addOrChange(t,r,n,i,s,o,a,c){let l=s.has(o)?j7:J0;this.handleEvent(l,t,r,n,i,s,o,a,c);}async checkExists(t,r,n,i,s,o,a,c){try{let l=await tm(t);if(this.fsw.closed)return;Q2(a,l)?this.addOrChange(t,r,n,i,s,o,a,c):this.handleEvent(If,t,r,n,i,s,o,a,c);}catch(l){l.code==="EACCES"?this.addOrChange(t,r,n,i,s,o,a,c):this.handleEvent(If,t,r,n,i,s,o,a,c);}}handleEvent(t,r,n,i,s,o,a,c,l){if(!(this.fsw.closed||this.checkIgnored(r)))if(t===If){let u=c.type===Ku;(u||o.has(a))&&this.fsw._remove(s,a,u);}else {if(t===J0){if(c.type===Ku&&this.fsw._getWatchedDir(r),c.type===X2&&l.followSymlinks){let f=l.depth===void 0?void 0:em(n,i)+1;return this._addToFsEvents(r,!1,!0,f)}this.fsw._getWatchedDir(s).add(a);}let u=c.type===Ku?t+J7:t;this.fsw._emit(u,r),u===K2&&this._addToFsEvents(r,!1,!0);}}_watchWithFsEvents(t,r,n,i){if(this.fsw.closed||this.fsw._isIgnored(t))return;let s=this.fsw.options,a=az(t,r,async(c,l,u)=>{if(this.fsw.closed||s.depth!==void 0&&em(c,r)>s.depth)return;let f=n(mr.join(t,mr.relative(t,c)));if(i&&!i(f))return;let d=mr.dirname(f),p=mr.basename(f),m=this.fsw._getWatchedDir(u.type===Ku?f:d);if(sz.has(l)||u.event===Q7)if(typeof s.ignored===Z0){let S;try{S=await tm(f);}catch{}if(this.fsw.closed||this.checkIgnored(f,S))return;Q2(u,S)?this.addOrChange(f,c,r,d,m,p,u,s):this.handleEvent(If,f,c,r,d,m,p,u,s);}else this.checkExists(f,c,r,d,m,p,u,s);else switch(u.event){case K7:case z7:return this.addOrChange(f,c,r,d,m,p,u,s);case G7:case Y7:return this.checkExists(f,c,r,d,m,p,u,s)}},this.fsw._emitRaw);return this.fsw._emitReady(),a}async _handleFsEventsSymlink(t,r,n,i){if(!(this.fsw.closed||this.fsw._symlinkPaths.has(r))){this.fsw._symlinkPaths.set(r,!0),this.fsw._incrReadyCount();try{let s=await Y2(t);if(this.fsw.closed)return;if(this.fsw._isIgnored(s))return this.fsw._emitReady();this.fsw._incrReadyCount(),this._addToFsEvents(s||t,o=>{let a=t;return s&&s!==G2?a=o.replace(s,t):o!==G2&&(a=mr.join(t,o)),n(a)},!1,i);}catch(s){if(this.fsw._handleError(s))return this.fsw._emitReady()}}}emitAdd(t,r,n,i,s){let o=n(t),a=r.isDirectory(),c=this.fsw._getWatchedDir(mr.dirname(o)),l=mr.basename(o);a&&this.fsw._getWatchedDir(o),!c.has(l)&&(c.add(l),(!i.ignoreInitial||s===!0)&&this.fsw._emit(a?K2:J0,o,r));}initWatch(t,r,n,i){if(this.fsw.closed)return;let s=this._watchWithFsEvents(n.watchPath,mr.resolve(t||n.watchPath),i,n.globFilter);this.fsw._addPathCloser(r,s);}async _addToFsEvents(t,r,n,i){if(this.fsw.closed)return;let s=this.fsw.options,o=typeof r===Z0?r:ez,a=this.fsw._getWatchHelpers(t);try{let c=await nz[a.statMethod](a.watchPath);if(this.fsw.closed)return;if(this.fsw._isIgnored(a.watchPath,c))throw null;if(c.isDirectory()){if(a.globFilter||this.emitAdd(o(t),c,o,s,n),i&&i>s.depth)return;this.fsw._readdirp(a.watchPath,{fileFilter:l=>a.filterPath(l),directoryFilter:l=>a.filterDir(l),...tz(s.depth-(i||0))}).on(H7,l=>{if(this.fsw.closed||l.stats.isDirectory()&&!a.filterPath(l))return;let u=mr.join(a.watchPath,l.path),{fullPath:f}=l;if(a.followSymlinks&&l.stats.isSymbolicLink()){let d=s.depth===void 0?void 0:em(u,mr.resolve(a.watchPath))+1;this._handleFsEventsSymlink(u,f,o,d);}else this.emitAdd(u,l.stats,o,s,n);}).on(V7,Z7).on(W7,()=>{this.fsw._emitReady();});}else this.emitAdd(a.watchPath,c,o,s,n),this.fsw._emitReady();}catch(c){(!c||this.fsw._handleError(c))&&(this.fsw._emitReady(),this.fsw._emitReady());}if(s.persistent&&n!==!0)if(typeof r===Z0)this.initWatch(void 0,t,a,o);else {let c;try{c=await Y2(a.watchPath);}catch{}this.initWatch(c,t,a,o);}}};sm.exports=rm;sm.exports.canUse=cz;});var Cm=A(bm=>{var{EventEmitter:lz}=he("events"),vm=he("fs"),Dt=he("path"),{promisify:sD}=he("util"),fz=FI(),fm=WI().default,hz=XI(),om=M0(),dz=L2(),pz=q0(),gz=W2(),Z2=J2(),{EV_ALL:am,EV_READY:mz,EV_ADD:Df,EV_CHANGE:zu,EV_UNLINK:eD,EV_ADD_DIR:yz,EV_UNLINK_DIR:vz,EV_RAW:Sz,EV_ERROR:um,STR_CLOSE:bz,STR_END:Cz,BACK_SLASH_RE:Ez,DOUBLE_SLASH_RE:tD,SLASH_OR_BACK_SLASH_RE:xz,DOT_RE:wz,REPLACER_RE:_z,SLASH:cm,SLASH_SLASH:Tz,BRACE_START:Az,BANG:hm,ONE_DOT:oD,TWO_DOTS:Rz,GLOBSTAR:Iz,SLASH_GLOBSTAR:lm,ANYMATCH_OPTS:dm,STRING_TYPE:Sm,FUNCTION_TYPE:Dz,EMPTY_STR:pm,EMPTY_FN:Pz,isWindows:kz,isMacos:Nz,isIBMi:Lz}=wf(),Oz=sD(vm.stat),Bz=sD(vm.readdir),gm=(e=[])=>Array.isArray(e)?e:[e],aD=(e,t=[])=>(e.forEach(r=>{Array.isArray(r)?aD(r,t):t.push(r);}),t),rD=e=>{let t=aD(gm(e));if(!t.every(r=>typeof r===Sm))throw new TypeError(`Non-string provided as watch path: ${t}`);return t.map(uD)},nD=e=>{let t=e.replace(Ez,cm),r=!1;for(t.startsWith(Tz)&&(r=!0);t.match(tD);)t=t.replace(tD,cm);return r&&(t=cm+t),t},uD=e=>nD(Dt.normalize(nD(e))),iD=(e=pm)=>t=>typeof t!==Sm?t:uD(Dt.isAbsolute(t)?t:Dt.join(e,t)),qz=(e,t)=>Dt.isAbsolute(e)?e:e.startsWith(hm)?hm+Dt.join(t,e.slice(1)):Dt.join(t,e),Jn=(e,t)=>e[t]===void 0,mm=class{constructor(t,r){this.path=t,this._removeWatcher=r,this.items=new Set;}add(t){let{items:r}=this;r&&t!==oD&&t!==Rz&&r.add(t);}async remove(t){let{items:r}=this;if(!r||(r.delete(t),r.size>0))return;let n=this.path;try{await Bz(n);}catch{this._removeWatcher&&this._removeWatcher(Dt.dirname(n),Dt.basename(n));}}has(t){let{items:r}=this;if(r)return r.has(t)}getChildren(){let{items:t}=this;if(t)return [...t.values()]}dispose(){this.items.clear(),delete this.path,delete this._removeWatcher,delete this.items,Object.freeze(this);}},Fz="stat",Mz="lstat",ym=class{constructor(t,r,n,i){this.fsw=i,this.path=t=t.replace(_z,pm),this.watchPath=r,this.fullWatchPath=Dt.resolve(r),this.hasGlob=r!==t,t===pm&&(this.hasGlob=!1),this.globSymlink=this.hasGlob&&n?void 0:!1,this.globFilter=this.hasGlob?fm(t,void 0,dm):!1,this.dirParts=this.getDirParts(t),this.dirParts.forEach(s=>{s.length>1&&s.pop();}),this.followSymlinks=n,this.statMethod=n?Fz:Mz;}checkGlobSymlink(t){return this.globSymlink===void 0&&(this.globSymlink=t.fullParentDir===this.fullWatchPath?!1:{realPath:t.fullParentDir,linkPath:this.fullWatchPath}),this.globSymlink?t.fullPath.replace(this.globSymlink.realPath,this.globSymlink.linkPath):t.fullPath}entryPath(t){return Dt.join(this.watchPath,Dt.relative(this.watchPath,this.checkGlobSymlink(t)))}filterPath(t){let{stats:r}=t;if(r&&r.isSymbolicLink())return this.filterDir(t);let n=this.entryPath(t);return (this.hasGlob&&typeof this.globFilter===Dz?this.globFilter(n):!0)&&this.fsw._isntIgnored(n,r)&&this.fsw._hasReadPermissions(r)}getDirParts(t){if(!this.hasGlob)return [];let r=[];return (t.includes(Az)?dz.expand(t):[t]).forEach(i=>{r.push(Dt.relative(this.watchPath,i).split(xz));}),r}filterDir(t){if(this.hasGlob){let r=this.getDirParts(this.checkGlobSymlink(t)),n=!1;this.unmatchedGlob=!this.dirParts.some(i=>i.every((s,o)=>(s===Iz&&(n=!0),n||!r[0][o]||fm(s,r[0][o],dm))));}return !this.unmatchedGlob&&this.fsw._isntIgnored(this.entryPath(t),t.stats)}},Pf=class extends lz{constructor(t){super();let r={};t&&Object.assign(r,t),this._watched=new Map,this._closers=new Map,this._ignoredPaths=new Set,this._throttled=new Map,this._symlinkPaths=new Map,this._streams=new Set,this.closed=!1,Jn(r,"persistent")&&(r.persistent=!0),Jn(r,"ignoreInitial")&&(r.ignoreInitial=!1),Jn(r,"ignorePermissionErrors")&&(r.ignorePermissionErrors=!1),Jn(r,"interval")&&(r.interval=100),Jn(r,"binaryInterval")&&(r.binaryInterval=300),Jn(r,"disableGlobbing")&&(r.disableGlobbing=!1),r.enableBinaryInterval=r.binaryInterval!==r.interval,Jn(r,"useFsEvents")&&(r.useFsEvents=!r.usePolling),Z2.canUse()||(r.useFsEvents=!1),Jn(r,"usePolling")&&!r.useFsEvents&&(r.usePolling=Nz),Lz&&(r.usePolling=!0);let i=process.env.CHOKIDAR_USEPOLLING;if(i!==void 0){let c=i.toLowerCase();c==="false"||c==="0"?r.usePolling=!1:c==="true"||c==="1"?r.usePolling=!0:r.usePolling=!!c;}let s=process.env.CHOKIDAR_INTERVAL;s&&(r.interval=Number.parseInt(s,10)),Jn(r,"atomic")&&(r.atomic=!r.usePolling&&!r.useFsEvents),r.atomic&&(this._pendingUnlinks=new Map),Jn(r,"followSymlinks")&&(r.followSymlinks=!0),Jn(r,"awaitWriteFinish")&&(r.awaitWriteFinish=!1),r.awaitWriteFinish===!0&&(r.awaitWriteFinish={});let o=r.awaitWriteFinish;o&&(o.stabilityThreshold||(o.stabilityThreshold=2e3),o.pollInterval||(o.pollInterval=100),this._pendingWrites=new Map),r.ignored&&(r.ignored=gm(r.ignored));let a=0;this._emitReady=()=>{a++,a>=this._readyCount&&(this._emitReady=Pz,this._readyEmitted=!0,process.nextTick(()=>this.emit(mz)));},this._emitRaw=(...c)=>this.emit(Sz,...c),this._readyEmitted=!1,this.options=r,r.useFsEvents?this._fsEventsHandler=new Z2(this):this._nodeFsHandler=new gz(this),Object.freeze(r);}add(t,r,n){let{cwd:i,disableGlobbing:s}=this.options;this.closed=!1;let o=rD(t);return i&&(o=o.map(a=>{let c=qz(a,i);return s||!om(a)?c:pz(c)})),o=o.filter(a=>a.startsWith(hm)?(this._ignoredPaths.add(a.slice(1)),!1):(this._ignoredPaths.delete(a),this._ignoredPaths.delete(a+lm),this._userIgnored=void 0,!0)),this.options.useFsEvents&&this._fsEventsHandler?(this._readyCount||(this._readyCount=o.length),this.options.persistent&&(this._readyCount*=2),o.forEach(a=>this._fsEventsHandler._addToFsEvents(a))):(this._readyCount||(this._readyCount=0),this._readyCount+=o.length,Promise.all(o.map(async a=>{let c=await this._nodeFsHandler._addToNodeFs(a,!n,0,0,r);return c&&this._emitReady(),c})).then(a=>{this.closed||a.filter(c=>c).forEach(c=>{this.add(Dt.dirname(c),Dt.basename(r||c));});})),this}unwatch(t){if(this.closed)return this;let r=rD(t),{cwd:n}=this.options;return r.forEach(i=>{!Dt.isAbsolute(i)&&!this._closers.has(i)&&(n&&(i=Dt.join(n,i)),i=Dt.resolve(i)),this._closePath(i),this._ignoredPaths.add(i),this._watched.has(i)&&this._ignoredPaths.add(i+lm),this._userIgnored=void 0;}),this}close(){if(this.closed)return this._closePromise;this.closed=!0,this.removeAllListeners();let t=[];return this._closers.forEach(r=>r.forEach(n=>{let i=n();i instanceof Promise&&t.push(i);})),this._streams.forEach(r=>r.destroy()),this._userIgnored=void 0,this._readyCount=0,this._readyEmitted=!1,this._watched.forEach(r=>r.dispose()),["closers","watched","streams","symlinkPaths","throttled"].forEach(r=>{this[`_${r}`].clear();}),this._closePromise=t.length?Promise.all(t).then(()=>{}):Promise.resolve(),this._closePromise}getWatched(){let t={};return this._watched.forEach((r,n)=>{let i=this.options.cwd?Dt.relative(this.options.cwd,n):n;t[i||oD]=r.getChildren().sort();}),t}emitWithAll(t,r){this.emit(...r),t!==um&&this.emit(am,...r);}async _emit(t,r,n,i,s){if(this.closed)return;let o=this.options;kz&&(r=Dt.normalize(r)),o.cwd&&(r=Dt.relative(o.cwd,r));let a=[t,r];s!==void 0?a.push(n,i,s):i!==void 0?a.push(n,i):n!==void 0&&a.push(n);let c=o.awaitWriteFinish,l;if(c&&(l=this._pendingWrites.get(r)))return l.lastChange=new Date,this;if(o.atomic){if(t===eD)return this._pendingUnlinks.set(r,a),setTimeout(()=>{this._pendingUnlinks.forEach((u,f)=>{this.emit(...u),this.emit(am,...u),this._pendingUnlinks.delete(f);});},typeof o.atomic=="number"?o.atomic:100),this;t===Df&&this._pendingUnlinks.has(r)&&(t=a[0]=zu,this._pendingUnlinks.delete(r));}if(c&&(t===Df||t===zu)&&this._readyEmitted){let u=(f,d)=>{f?(t=a[0]=um,a[1]=f,this.emitWithAll(t,a)):d&&(a.length>2?a[2]=d:a.push(d),this.emitWithAll(t,a));};return this._awaitWriteFinish(r,c.stabilityThreshold,t,u),this}if(t===zu&&!this._throttle(zu,r,50))return this;if(o.alwaysStat&&n===void 0&&(t===Df||t===yz||t===zu)){let u=o.cwd?Dt.join(o.cwd,r):r,f;try{f=await Oz(u);}catch{}if(!f||this.closed)return;a.push(f);}return this.emitWithAll(t,a),this}_handleError(t){let r=t&&t.code;return t&&r!=="ENOENT"&&r!=="ENOTDIR"&&(!this.options.ignorePermissionErrors||r!=="EPERM"&&r!=="EACCES")&&this.emit(um,t),t||this.closed}_throttle(t,r,n){this._throttled.has(t)||this._throttled.set(t,new Map);let i=this._throttled.get(t),s=i.get(r);if(s)return s.count++,!1;let o,a=()=>{let l=i.get(r),u=l?l.count:0;return i.delete(r),clearTimeout(o),l&&clearTimeout(l.timeoutObject),u};o=setTimeout(a,n);let c={timeoutObject:o,clear:a,count:0};return i.set(r,c),c}_incrReadyCount(){return this._readyCount++}_awaitWriteFinish(t,r,n,i){let s,o=t;this.options.cwd&&!Dt.isAbsolute(t)&&(o=Dt.join(this.options.cwd,t));let a=new Date,c=l=>{vm.stat(o,(u,f)=>{if(u||!this._pendingWrites.has(t)){u&&u.code!=="ENOENT"&&i(u);return}let d=Number(new Date);l&&f.size!==l.size&&(this._pendingWrites.get(t).lastChange=d);let p=this._pendingWrites.get(t);d-p.lastChange>=r?(this._pendingWrites.delete(t),i(void 0,f)):s=setTimeout(c,this.options.awaitWriteFinish.pollInterval,f);});};this._pendingWrites.has(t)||(this._pendingWrites.set(t,{lastChange:a,cancelWait:()=>(this._pendingWrites.delete(t),clearTimeout(s),n)}),s=setTimeout(c,this.options.awaitWriteFinish.pollInterval));}_getGlobIgnored(){return [...this._ignoredPaths.values()]}_isIgnored(t,r){if(this.options.atomic&&wz.test(t))return !0;if(!this._userIgnored){let{cwd:n}=this.options,i=this.options.ignored,s=i&&i.map(iD(n)),o=gm(s).filter(c=>typeof c===Sm&&!om(c)).map(c=>c+lm),a=this._getGlobIgnored().map(iD(n)).concat(s,o);this._userIgnored=fm(a,void 0,dm);}return this._userIgnored([t,r])}_isntIgnored(t,r){return !this._isIgnored(t,r)}_getWatchHelpers(t,r){let n=r||this.options.disableGlobbing||!om(t)?t:hz(t),i=this.options.followSymlinks;return new ym(t,n,i,this)}_getWatchedDir(t){this._boundRemove||(this._boundRemove=this._remove.bind(this));let r=Dt.resolve(t);return this._watched.has(r)||this._watched.set(r,new mm(r,this._boundRemove)),this._watched.get(r)}_hasReadPermissions(t){if(this.options.ignorePermissionErrors)return !0;let n=(t&&Number.parseInt(t.mode,10))&511;return !!(4&Number.parseInt(n.toString(8)[0],10))}_remove(t,r,n){let i=Dt.join(t,r),s=Dt.resolve(i);if(n=n??(this._watched.has(i)||this._watched.has(s)),!this._throttle("remove",i,100))return;!n&&!this.options.useFsEvents&&this._watched.size===1&&this.add(t,r,!0),this._getWatchedDir(i).getChildren().forEach(d=>this._remove(i,d));let c=this._getWatchedDir(t),l=c.has(r);c.remove(r),this._symlinkPaths.has(s)&&this._symlinkPaths.delete(s);let u=i;if(this.options.cwd&&(u=Dt.relative(this.options.cwd,i)),this.options.awaitWriteFinish&&this._pendingWrites.has(u)&&this._pendingWrites.get(u).cancelWait()===Df)return;this._watched.delete(i),this._watched.delete(s);let f=n?vz:eD;l&&!this._isIgnored(i)&&this._emit(f,i),this.options.useFsEvents||this._closePath(i);}_closePath(t){this._closeFile(t);let r=Dt.dirname(t);this._getWatchedDir(r).remove(Dt.basename(t));}_closeFile(t){let r=this._closers.get(t);r&&(r.forEach(n=>n()),this._closers.delete(t));}_addPathCloser(t,r){if(!r)return;let n=this._closers.get(t);n||(n=[],this._closers.set(t,n)),n.push(r);}_readdirp(t,r){if(this.closed)return;let n={type:am,alwaysStat:!0,lstat:!0,...r},i=fz(t,n);return this._streams.add(i),i.once(bz,()=>{i=void 0;}),i.once(Cz,()=>{i&&(this._streams.delete(i),i=void 0);}),i}};bm.FSWatcher=Pf;var Uz=(e,t)=>{let r=new Pf(t);return r.add(e),r};bm.watch=Uz;});var hD={};I5(hD,{closest:()=>Kz,distance:()=>fD});var $i,Hz,Wz,fD,Kz,dD=gE(()=>{$i=new Uint32Array(65536),Hz=(e,t)=>{let r=e.length,n=t.length,i=1<<r-1,s=-1,o=0,a=r,c=r;for(;c--;)$i[e.charCodeAt(c)]|=1<<c;for(c=0;c<n;c++){let l=$i[t.charCodeAt(c)],u=l|o;l|=(l&s)+s^s,o|=~(l|s),s&=l,o&i&&a++,s&i&&a--,o=o<<1|1,s=s<<1|~(u|o),o&=u;}for(c=r;c--;)$i[e.charCodeAt(c)]=0;return a},Wz=(e,t)=>{let r=t.length,n=e.length,i=[],s=[],o=Math.ceil(r/32),a=Math.ceil(n/32);for(let m=0;m<o;m++)s[m]=-1,i[m]=0;let c=0;for(;c<a-1;c++){let m=0,S=-1,x=c*32,I=Math.min(32,n)+x;for(let v=x;v<I;v++)$i[e.charCodeAt(v)]|=1<<v;for(let v=0;v<r;v++){let b=$i[t.charCodeAt(v)],D=s[v/32|0]>>>v&1,L=i[v/32|0]>>>v&1,j=b|m,J=((b|L)&S)+S^S|b|L,K=m|~(J|S),G=S&J;K>>>31^D&&(s[v/32|0]^=1<<v),G>>>31^L&&(i[v/32|0]^=1<<v),K=K<<1|D,G=G<<1|L,S=G|~(j|K),m=K&j;}for(let v=x;v<I;v++)$i[e.charCodeAt(v)]=0;}let l=0,u=-1,f=c*32,d=Math.min(32,n-f)+f;for(let m=f;m<d;m++)$i[e.charCodeAt(m)]|=1<<m;let p=n;for(let m=0;m<r;m++){let S=$i[t.charCodeAt(m)],x=s[m/32|0]>>>m&1,I=i[m/32|0]>>>m&1,v=S|l,b=((S|I)&u)+u^u|S|I,D=l|~(b|u),L=u&b;p+=D>>>n-1&1,p-=L>>>n-1&1,D>>>31^x&&(s[m/32|0]^=1<<m),L>>>31^I&&(i[m/32|0]^=1<<m),D=D<<1|x,L=L<<1|I,u=L|~(v|D),l=D&v;}for(let m=f;m<d;m++)$i[e.charCodeAt(m)]=0;return p},fD=(e,t)=>{if(e.length<t.length){let r=t;t=e,e=r;}return t.length===0?e.length:e.length<=32?Hz(e,t):Wz(e,t)},Kz=(e,t)=>{let r=1/0,n=0;for(let i=0;i<t.length;i++){let s=fD(e,t[i]);s<r&&(r=s,n=i);}return t[n]};});var pD=A((Tm,Gu)=>{(function(){var e;try{e=typeof Intl<"u"&&typeof Intl.Collator<"u"?Intl.Collator("generic",{sensitivity:"base"}):null;}catch{console.log("Collator could not be initialized and wouldn't be used");}var t=(dD(),D5(hD)),r=[],n=[],i={get:function(s,o,a){var c=a&&e&&a.useCollator;if(c){var l=s.length,u=o.length;if(l===0)return u;if(u===0)return l;var f,d,p,m,S;for(p=0;p<u;++p)r[p]=p,n[p]=o.charCodeAt(p);r[u]=u;var x;for(p=0;p<l;++p){for(d=p+1,m=0;m<u;++m)f=d,x=e.compare(s.charAt(p),String.fromCharCode(n[m]))===0,d=r[m]+(x?0:1),S=f+1,d>S&&(d=S),S=r[m+1]+1,d>S&&(d=S),r[m]=f;r[m]=d;}return d}return t.distance(s,o)}};typeof define<"u"&&define!==null&&define.amd?define(function(){return i}):typeof Gu<"u"&&Gu!==null&&typeof Tm<"u"&&Gu.exports===Tm?Gu.exports=i:typeof self<"u"&&typeof self.postMessage=="function"&&typeof self.importScripts=="function"?self.Levenshtein=i:typeof window<"u"&&window!==null&&(window.Levenshtein=i);})();});var km=A((Cce,ED)=>{var Qu=e=>e&&typeof e.message=="string",Pm=e=>{if(!e)return;let t=e.cause;if(typeof t=="function"){let r=e.cause();return Qu(r)?r:void 0}else return Qu(t)?t:void 0},bD=(e,t)=>{if(!Qu(e))return "";let r=e.stack||"";if(t.has(e))return r+`
causes have become circular...`;let n=Pm(e);return n?(t.add(e),r+`
caused by: `+bD(n,t)):r},Xz=e=>bD(e,new Set),CD=(e,t,r)=>{if(!Qu(e))return "";let n=r?"":e.message||"";if(t.has(e))return n+": ...";let i=Pm(e);if(i){t.add(e);let s=typeof e.cause=="function";return n+(s?"":": ")+CD(i,t,s)}else return n},Jz=e=>CD(e,new Set);ED.exports={isErrorLike:Qu,getErrorCause:Pm,stackWithCauses:Xz,messageWithCauses:Jz};});var Nm=A((Ece,wD)=>{var Zz=Symbol("circular-ref-tag"),Of=Symbol("pino-raw-err-ref"),xD=Object.create({},{type:{enumerable:!0,writable:!0,value:void 0},message:{enumerable:!0,writable:!0,value:void 0},stack:{enumerable:!0,writable:!0,value:void 0},aggregateErrors:{enumerable:!0,writable:!0,value:void 0},raw:{enumerable:!1,get:function(){return this[Of]},set:function(e){this[Of]=e;}}});Object.defineProperty(xD,Of,{writable:!0,value:{}});wD.exports={pinoErrProto:xD,pinoErrorSymbols:{seen:Zz,rawSymbol:Of}};});var AD=A((xce,TD)=>{TD.exports=Om;var{messageWithCauses:eG,stackWithCauses:tG,isErrorLike:_D}=km(),{pinoErrProto:rG,pinoErrorSymbols:nG}=Nm(),{seen:Lm}=nG,{toString:iG}=Object.prototype;function Om(e){if(!_D(e))return e;e[Lm]=void 0;let t=Object.create(rG);t.type=iG.call(e.constructor)==="[object Function]"?e.constructor.name:e.name,t.message=eG(e),t.stack=tG(e),Array.isArray(e.errors)&&(t.aggregateErrors=e.errors.map(r=>Om(r)));for(let r in e)if(t[r]===void 0){let n=e[r];_D(n)?r!=="cause"&&!Object.prototype.hasOwnProperty.call(n,Lm)&&(t[r]=Om(n)):t[r]=n;}return delete e[Lm],t.raw=e,t}});var ID=A((wce,RD)=>{RD.exports=qf;var{isErrorLike:Bm}=km(),{pinoErrProto:sG,pinoErrorSymbols:oG}=Nm(),{seen:Bf}=oG,{toString:aG}=Object.prototype;function qf(e){if(!Bm(e))return e;e[Bf]=void 0;let t=Object.create(sG);t.type=aG.call(e.constructor)==="[object Function]"?e.constructor.name:e.name,t.message=e.message,t.stack=e.stack,Array.isArray(e.errors)&&(t.aggregateErrors=e.errors.map(r=>qf(r))),Bm(e.cause)&&!Object.prototype.hasOwnProperty.call(e.cause,Bf)&&(t.cause=qf(e.cause));for(let r in e)if(t[r]===void 0){let n=e[r];Bm(n)?Object.prototype.hasOwnProperty.call(n,Bf)||(t[r]=qf(n)):t[r]=n;}return delete e[Bf],t.raw=e,t}});var ND=A((_ce,kD)=>{kD.exports={mapHttpRequest:uG,reqSerializer:PD};var qm=Symbol("pino-raw-req-ref"),DD=Object.create({},{id:{enumerable:!0,writable:!0,value:""},method:{enumerable:!0,writable:!0,value:""},url:{enumerable:!0,writable:!0,value:""},query:{enumerable:!0,writable:!0,value:""},params:{enumerable:!0,writable:!0,value:""},headers:{enumerable:!0,writable:!0,value:{}},remoteAddress:{enumerable:!0,writable:!0,value:""},remotePort:{enumerable:!0,writable:!0,value:""},raw:{enumerable:!1,get:function(){return this[qm]},set:function(e){this[qm]=e;}}});Object.defineProperty(DD,qm,{writable:!0,value:{}});function PD(e){let t=e.info||e.socket,r=Object.create(DD);if(r.id=typeof e.id=="function"?e.id():e.id||(e.info?e.info.id:void 0),r.method=e.method,e.originalUrl)r.url=e.originalUrl;else {let n=e.path;r.url=typeof n=="string"?n:e.url?e.url.path||e.url:void 0;}return e.query&&(r.query=e.query),e.params&&(r.params=e.params),r.headers=e.headers,r.remoteAddress=t&&t.remoteAddress,r.remotePort=t&&t.remotePort,r.raw=e.raw||e,r}function uG(e){return {req:PD(e)}}});var qD=A((Tce,BD)=>{BD.exports={mapHttpResponse:cG,resSerializer:OD};var Fm=Symbol("pino-raw-res-ref"),LD=Object.create({},{statusCode:{enumerable:!0,writable:!0,value:0},headers:{enumerable:!0,writable:!0,value:""},raw:{enumerable:!1,get:function(){return this[Fm]},set:function(e){this[Fm]=e;}}});Object.defineProperty(LD,Fm,{writable:!0,value:{}});function OD(e){let t=Object.create(LD);return t.statusCode=e.headersSent?e.statusCode:null,t.headers=e.getHeaders?e.getHeaders():e._headers,t.raw=e,t}function cG(e){return {res:OD(e)}}});var Um=A((Ace,FD)=>{var Mm=AD(),lG=ID(),Ff=ND(),Mf=qD();FD.exports={err:Mm,errWithCause:lG,mapHttpRequest:Ff.mapHttpRequest,mapHttpResponse:Mf.mapHttpResponse,req:Ff.reqSerializer,res:Mf.resSerializer,wrapErrorSerializer:function(t){return t===Mm?t:function(n){return t(Mm(n))}},wrapRequestSerializer:function(t){return t===Ff.reqSerializer?t:function(n){return t(Ff.reqSerializer(n))}},wrapResponseSerializer:function(t){return t===Mf.resSerializer?t:function(n){return t(Mf.resSerializer(n))}}};});var $m=A((Rce,MD)=>{function fG(e,t){return t}MD.exports=function(){let t=Error.prepareStackTrace;Error.prepareStackTrace=fG;let r=new Error().stack;if(Error.prepareStackTrace=t,!Array.isArray(r))return;let n=r.slice(2),i=[];for(let s of n)s&&i.push(s.getFileName());return i};});var $D=A((Ice,UD)=>{UD.exports=hG;function hG(e={}){let{ERR_PATHS_MUST_BE_STRINGS:t=()=>"fast-redact - Paths must be (non-empty) strings",ERR_INVALID_PATH:r=n=>`fast-redact \u2013 Invalid path (${n})`}=e;return function({paths:i}){i.forEach(s=>{if(typeof s!="string")throw Error(t());try{if(/〇/.test(s))throw Error();let o=(s[0]==="["?"":".")+s.replace(/^\*/,"\u3007").replace(/\.\*/g,".\u3007").replace(/\[\*\]/g,"[\u3007]");if(/\n|\r|;/.test(o)||/\/\*/.test(o))throw Error();Function(`
            'use strict'
            const o = new Proxy({}, { get: () => o, set: () => { throw Error() } });
            const \u3007 = null;
            o${o}
            if ([o${o}].length !== 1) throw Error()`)();}catch{throw Error(r(s))}});}}});var Uf=A((Dce,jD)=>{jD.exports=/[^.[\]]+|\[((?:.)*?)\]/g;});var HD=A((Pce,VD)=>{var dG=Uf();VD.exports=pG;function pG({paths:e}){let t=[];var r=0;let n=e.reduce(function(i,s,o){var a=s.match(dG).map(u=>u.replace(/'|"|`/g,""));let c=s[0]==="[";a=a.map(u=>u[0]==="["?u.substr(1,u.length-2):u);let l=a.indexOf("*");if(l>-1){let u=a.slice(0,l),f=u.join("."),d=a.slice(l+1,a.length),p=d.length>0;r++,t.push({before:u,beforeStr:f,after:d,nested:p});}else i[s]={path:a,val:void 0,precensored:!1,circle:"",escPath:JSON.stringify(s),leadingBracket:c};return i},{});return {wildcards:t,wcLen:r,secret:n}}});var KD=A((kce,WD)=>{var gG=Uf();WD.exports=mG;function mG({secret:e,serialize:t,wcLen:r,strict:n,isCensorFct:i,censorFctTakesPath:s},o){let a=Function("o",`
    if (typeof o !== 'object' || o == null) {
      ${bG(n,t)}
    }
    const { censor, secret } = this
    ${yG(e,i,s)}
    this.compileRestore()
    ${vG(r>0,i,s)}
    ${SG(t)}
  `).bind(o);return t===!1&&(a.restore=c=>o.restore(c)),a}function yG(e,t,r){return Object.keys(e).map(n=>{let{escPath:i,leadingBracket:s,path:o}=e[n],a=s?1:0,c=s?"":".",l=[];for(var u;(u=gG.exec(n))!==null;){let[,m]=u,{index:S,input:x}=u;S>a&&l.push(x.substring(0,S-(m?0:1)));}var f=l.map(m=>`o${c}${m}`).join(" && ");f.length===0?f+=`o${c}${n} != null`:f+=` && o${c}${n} != null`;let d=`
      switch (true) {
        ${l.reverse().map(m=>`
          case o${c}${m} === censor:
            secret[${i}].circle = ${JSON.stringify(m)}
            break
        `).join(`
`)}
      }
    `,p=r?`val, ${JSON.stringify(o)}`:"val";return `
      if (${f}) {
        const val = o${c}${n}
        if (val === censor) {
          secret[${i}].precensored = true
        } else {
          secret[${i}].val = val
          o${c}${n} = ${t?`censor(${p})`:"censor"}
          ${d}
        }
      }
    `}).join(`
`)}function vG(e,t,r){return e===!0?`
    {
      const { wildcards, wcLen, groupRedact, nestedRedact } = this
      for (var i = 0; i < wcLen; i++) {
        const { before, beforeStr, after, nested } = wildcards[i]
        if (nested === true) {
          secret[beforeStr] = secret[beforeStr] || []
          nestedRedact(secret[beforeStr], o, before, after, censor, ${t}, ${r})
        } else secret[beforeStr] = groupRedact(o, before, censor, ${t}, ${r})
      }
    }
  `:""}function SG(e){return e===!1?"return o":`
    var s = this.serialize(o)
    this.restore(o)
    return s
  `}function bG(e,t){return e===!0?"throw Error('fast-redact: primitives cannot be redacted')":t===!1?"return o":"return this.serialize(o)"}});var Vm=A((Nce,YD)=>{YD.exports={groupRedact:EG,groupRestore:CG,nestedRedact:wG,nestedRestore:xG};function CG({keys:e,values:t,target:r}){if(r==null)return;let n=e.length;for(var i=0;i<n;i++){let s=e[i];r[s]=t[i];}}function EG(e,t,r,n,i){let s=zD(e,t);if(s==null)return {keys:null,values:null,target:null,flat:!0};let o=Object.keys(s),a=o.length,c=t.length,l=i?[...t]:void 0,u=new Array(a);for(var f=0;f<a;f++){let d=o[f];u[f]=s[d],i?(l[c]=d,s[d]=r(s[d],l)):n?s[d]=r(s[d]):s[d]=r;}return {keys:o,values:u,target:s,flat:!0}}function xG(e){for(let t=0;t<e.length;t++){let{target:r,path:n,value:i}=e[t],s=r;for(let o=n.length-1;o>0;o--)s=s[n[o]];s[n[0]]=i;}}function wG(e,t,r,n,i,s,o){let a=zD(t,r);if(a==null)return;let c=Object.keys(a),l=c.length;for(var u=0;u<l;u++){let f=c[u];_G(e,a,f,r,n,i,s,o);}return e}function jm(e,t){return e!=null?"hasOwn"in Object?Object.hasOwn(e,t):Object.prototype.hasOwnProperty.call(e,t):!1}function _G(e,t,r,n,i,s,o,a){let c=i.length,l=c-1,u=r;var f=-1,d,p,m,x=null,I,v,b=!1,D=0,L=0,j=TG();if(m=d=t[r],typeof d=="object"){for(;d!=null&&++f<c&&(L+=1,r=i[f],!(r!=="*"&&!x&&!(typeof d=="object"&&r in d)));)if(!(r==="*"&&(x==="*"&&(b=!0),x=r,f!==l))){if(x){let K=Object.keys(d);for(var J=0;J<K.length;J++){let G=K[J];if(v=d[G],I=r==="*",b)j=Vi(j,G,L),D=f,m=GD(v,D-1,r,n,i,s,o,a,u,d,p,m,I,G,f,l,j,e,t[u],L+1);else if(I||typeof v=="object"&&v!==null&&r in v){if(I?m=v:m=v[r],p=f!==l?m:o?a?s(m,[...n,u,...i]):s(m):s,I){let ee=Xu(Vi(j,G,L),m,t[u]);e.push(ee),d[G]=p;}else if(v[r]!==p)if(p===void 0&&s!==void 0||jm(v,r)&&p===m)j=Vi(j,G,L);else {j=Vi(j,G,L);let ee=Xu(Vi(j,r,L+1),m,t[u]);e.push(ee),v[r]=p;}}}x=null;}else {if(m=d[r],j=Vi(j,r,L),p=f!==l?m:o?a?s(m,[...n,u,...i]):s(m):s,!(jm(d,r)&&p===m||p===void 0&&s!==void 0)){let K=Xu(j,m,t[u]);e.push(K),d[r]=p;}d=d[r];}if(typeof d!="object")break}}}function zD(e,t){for(var r=-1,n=t.length,i=e;i!=null&&++r<n;)i=i[t[r]];return i}function GD(e,t,r,n,i,s,o,a,c,l,u,f,d,p,m,S,x,I,v,b){if(t===0&&(d||typeof e=="object"&&e!==null&&r in e)){if(d?f=e:f=e[r],u=m!==S?f:o?a?s(f,[...n,c,...i]):s(f):s,d){let D=Xu(x,f,v);I.push(D),l[p]=u;}else if(e[r]!==u){if(!(u===void 0&&s!==void 0||jm(e,r)&&u===f)){let D=Xu(Vi(x,r,b+1),f,v);I.push(D),e[r]=u;}}}for(let D in e)typeof e[D]=="object"&&(x=Vi(x,D,b),GD(e[D],t-1,r,n,i,s,o,a,c,l,u,f,d,p,m,S,x,I,v,b+1));}function TG(){return {parent:null,key:null,children:[],depth:0}}function Vi(e,t,r){if(e.depth===r)return Vi(e.parent,t,r);var n={parent:e,key:t,depth:r,children:[]};return e.children.push(n),n}function Xu(e,t,r){let n=e,i=[];do i.push(n.key),n=n.parent;while(n.parent!=null);return {path:i,value:t,target:r}}});var XD=A((Lce,QD)=>{var{groupRestore:AG,nestedRestore:RG}=Vm();QD.exports=IG;function IG({secret:e,wcLen:t}){return function(){if(this.restore)return;let n=Object.keys(e),i=DG(e,n),s=t>0,o=s?{secret:e,groupRestore:AG,nestedRestore:RG}:{secret:e};this.restore=Function("o",PG(i,n,s)).bind(o);}}function DG(e,t){return t.map(r=>{let{circle:n,escPath:i,leadingBracket:s}=e[r],a=n?`o.${n} = secret[${i}].val`:`o${s?"":"."}${r} = secret[${i}].val`,c=`secret[${i}].val = undefined`;return `
      if (secret[${i}].val !== undefined) {
        try { ${a} } catch (e) {}
        ${c}
      }
    `}).join("")}function PG(e,t,r){return `
    const secret = this.secret
    ${r===!0?`
    const keys = Object.keys(secret)
    const len = keys.length
    for (var i = len - 1; i >= ${t.length}; i--) {
      const k = keys[i]
      const o = secret[k]
      if (o.flat === true) this.groupRestore(o)
      else this.nestedRestore(o)
      secret[k] = null
    }
  `:""}
    ${e}
    return o
  `}});var ZD=A((Oce,JD)=>{JD.exports=kG;function kG(e){let{secret:t,censor:r,compileRestore:n,serialize:i,groupRedact:s,nestedRedact:o,wildcards:a,wcLen:c}=e,l=[{secret:t,censor:r,compileRestore:n}];return i!==!1&&l.push({serialize:i}),c>0&&l.push({groupRedact:s,nestedRedact:o,wildcards:a,wcLen:c}),Object.assign(...l)}});var rP=A((Bce,tP)=>{var eP=$D(),NG=HD(),LG=KD(),OG=XD(),{groupRedact:BG,nestedRedact:qG}=Vm(),FG=ZD(),MG=Uf(),UG=eP(),Hm=e=>e;Hm.restore=Hm;var $G="[REDACTED]";Wm.rx=MG;Wm.validator=eP;tP.exports=Wm;function Wm(e={}){let t=Array.from(new Set(e.paths||[])),r="serialize"in e&&(e.serialize===!1||typeof e.serialize=="function")?e.serialize:JSON.stringify,n=e.remove;if(n===!0&&r!==JSON.stringify)throw Error("fast-redact \u2013 remove option may only be set when serializer is JSON.stringify");let i=n===!0?void 0:"censor"in e?e.censor:$G,s=typeof i=="function",o=s&&i.length>1;if(t.length===0)return r||Hm;UG({paths:t,serialize:r,censor:i});let{wildcards:a,wcLen:c,secret:l}=NG({paths:t,censor:i}),u=OG({secret:l,wcLen:c}),f="strict"in e?e.strict:!0;return LG({secret:l,wcLen:c,serialize:r,strict:f,isCensorFct:s,censorFctTakesPath:o},FG({secret:l,censor:i,compileRestore:u,serialize:r,groupRedact:BG,nestedRedact:qG,wildcards:a,wcLen:c}))}});var ha=A((qce,nP)=>{var jG=Symbol("pino.setLevel"),VG=Symbol("pino.getLevel"),HG=Symbol("pino.levelVal"),WG=Symbol("pino.useLevelLabels"),KG=Symbol("pino.useOnlyCustomLevels"),zG=Symbol("pino.mixin"),GG=Symbol("pino.lsCache"),YG=Symbol("pino.chindings"),QG=Symbol("pino.asJson"),XG=Symbol("pino.write"),JG=Symbol("pino.redactFmt"),ZG=Symbol("pino.time"),eY=Symbol("pino.timeSliceIndex"),tY=Symbol("pino.stream"),rY=Symbol("pino.stringify"),nY=Symbol("pino.stringifySafe"),iY=Symbol("pino.stringifiers"),sY=Symbol("pino.end"),oY=Symbol("pino.formatOpts"),aY=Symbol("pino.messageKey"),uY=Symbol("pino.errorKey"),cY=Symbol("pino.nestedKey"),lY=Symbol("pino.nestedKeyStr"),fY=Symbol("pino.mixinMergeStrategy"),hY=Symbol("pino.msgPrefix"),dY=Symbol("pino.wildcardFirst"),pY=Symbol.for("pino.serializers"),gY=Symbol.for("pino.formatters"),mY=Symbol.for("pino.hooks"),yY=Symbol.for("pino.metadata");nP.exports={setLevelSym:jG,getLevelSym:VG,levelValSym:HG,useLevelLabelsSym:WG,mixinSym:zG,lsCacheSym:GG,chindingsSym:YG,asJsonSym:QG,writeSym:XG,serializersSym:pY,redactFmtSym:JG,timeSym:ZG,timeSliceIndexSym:eY,streamSym:tY,stringifySym:rY,stringifySafeSym:nY,stringifiersSym:iY,endSym:sY,formatOptsSym:oY,messageKeySym:aY,errorKeySym:uY,nestedKeySym:cY,wildcardFirstSym:dY,needsMetadataGsym:yY,useOnlyCustomLevelsSym:KG,formattersSym:gY,hooksSym:mY,nestedKeyStrSym:lY,mixinMergeStrategySym:fY,msgPrefixSym:hY};});var Gm=A((Fce,aP)=>{var zm=rP(),{redactFmtSym:vY,wildcardFirstSym:$f}=ha(),{rx:Km,validator:SY}=zm,iP=SY({ERR_PATHS_MUST_BE_STRINGS:()=>"pino \u2013 redacted paths must be strings",ERR_INVALID_PATH:e=>`pino \u2013 redact paths array contains an invalid path (${e})`}),sP="[Redacted]",oP=!1;function bY(e,t){let{paths:r,censor:n}=CY(e),i=r.reduce((a,c)=>{Km.lastIndex=0;let l=Km.exec(c),u=Km.exec(c),f=l[1]!==void 0?l[1].replace(/^(?:"|'|`)(.*)(?:"|'|`)$/,"$1"):l[0];if(f==="*"&&(f=$f),u===null)return a[f]=null,a;if(a[f]===null)return a;let{index:d}=u,p=`${c.substr(d,c.length-1)}`;return a[f]=a[f]||[],f!==$f&&a[f].length===0&&a[f].push(...a[$f]||[]),f===$f&&Object.keys(a).forEach(function(m){a[m]&&a[m].push(p);}),a[f].push(p),a},{}),s={[vY]:zm({paths:r,censor:n,serialize:t,strict:oP})},o=(...a)=>t(typeof n=="function"?n(...a):n);return [...Object.keys(i),...Object.getOwnPropertySymbols(i)].reduce((a,c)=>{if(i[c]===null)a[c]=l=>o(l,[c]);else {let l=typeof n=="function"?(u,f)=>n(u,[c,...f]):n;a[c]=zm({paths:i[c],censor:l,serialize:t,strict:oP});}return a},s)}function CY(e){if(Array.isArray(e))return e={paths:e,censor:sP},iP(e),e;let{paths:t,censor:r=sP,remove:n}=e;if(Array.isArray(t)===!1)throw Error("pino \u2013 redact must contain an array of strings");return n===!0&&(r=void 0),iP({paths:t,censor:r}),{paths:t,censor:r}}aP.exports=bY;});var cP=A((Mce,uP)=>{var EY=()=>"",xY=()=>`,"time":${Date.now()}`,wY=()=>`,"time":${Math.round(Date.now()/1e3)}`,_Y=()=>`,"time":"${new Date(Date.now()).toISOString()}"`;uP.exports={nullTime:EY,epochTime:xY,unixTime:wY,isoTime:_Y};});var fP=A((Uce,lP)=>{function TY(e){try{return JSON.stringify(e)}catch{return '"[Circular]"'}}lP.exports=AY;function AY(e,t,r){var n=r&&r.stringify||TY,i=1;if(typeof e=="object"&&e!==null){var s=t.length+i;if(s===1)return e;var o=new Array(s);o[0]=n(e);for(var a=1;a<s;a++)o[a]=n(t[a]);return o.join(" ")}if(typeof e!="string")return e;var c=t.length;if(c===0)return e;for(var l="",u=1-i,f=-1,d=e&&e.length||0,p=0;p<d;){if(e.charCodeAt(p)===37&&p+1<d){switch(f=f>-1?f:0,e.charCodeAt(p+1)){case 100:case 102:if(u>=c||t[u]==null)break;f<p&&(l+=e.slice(f,p)),l+=Number(t[u]),f=p+2,p++;break;case 105:if(u>=c||t[u]==null)break;f<p&&(l+=e.slice(f,p)),l+=Math.floor(Number(t[u])),f=p+2,p++;break;case 79:case 111:case 106:if(u>=c||t[u]===void 0)break;f<p&&(l+=e.slice(f,p));var m=typeof t[u];if(m==="string"){l+="'"+t[u]+"'",f=p+2,p++;break}if(m==="function"){l+=t[u].name||"<anonymous>",f=p+2,p++;break}l+=n(t[u]),f=p+2,p++;break;case 115:if(u>=c)break;f<p&&(l+=e.slice(f,p)),l+=String(t[u]),f=p+2,p++;break;case 37:f<p&&(l+=e.slice(f,p)),l+="%",f=p+2,p++,u--;break}++u;}++p;}return f===-1?e:(f<d&&(l+=e.slice(f)),l)}});var Qm=A(($ce,Ym)=>{if(typeof SharedArrayBuffer<"u"&&typeof Atomics<"u"){let t=function(r){if((r>0&&r<1/0)===!1)throw typeof r!="number"&&typeof r!="bigint"?TypeError("sleep: ms must be a number"):RangeError("sleep: ms must be a number that is greater than 0 but less than Infinity");Atomics.wait(e,0,0,Number(r));},e=new Int32Array(new SharedArrayBuffer(4));Ym.exports=t;}else {let e=function(t){if((t>0&&t<1/0)===!1)throw typeof t!="number"&&typeof t!="bigint"?TypeError("sleep: ms must be a number"):RangeError("sleep: ms must be a number that is greater than 0 but less than Infinity");};Ym.exports=e;}});var SP=A((jce,vP)=>{var nr=he("fs"),RY=he("events"),IY=he("util").inherits,hP=he("path"),Xm=Qm(),jf=100,Vf=Buffer.allocUnsafe(0),DY=16*1024,dP="buffer",pP="utf8";function gP(e,t){t._opening=!0,t._writing=!0,t._asyncDrainScheduled=!1;function r(s,o){if(s){t._reopening=!1,t._writing=!1,t._opening=!1,t.sync?process.nextTick(()=>{t.listenerCount("error")>0&&t.emit("error",s);}):t.emit("error",s);return}t.fd=o,t.file=e,t._reopening=!1,t._opening=!1,t._writing=!1,t.sync?process.nextTick(()=>t.emit("ready")):t.emit("ready"),!(t._reopening||t.destroyed)&&(!t._writing&&t._len>t.minLength||t._flushPending)&&t._actualWrite();}let n=t.append?"a":"w",i=t.mode;if(t.sync)try{t.mkdir&&nr.mkdirSync(hP.dirname(e),{recursive:!0});let s=nr.openSync(e,n,i);r(null,s);}catch(s){throw r(s),s}else t.mkdir?nr.mkdir(hP.dirname(e),{recursive:!0},s=>{if(s)return r(s);nr.open(e,n,i,r);}):nr.open(e,n,i,r);}function Zn(e){if(!(this instanceof Zn))return new Zn(e);let{fd:t,dest:r,minLength:n,maxLength:i,maxWrite:s,sync:o,append:a=!0,mkdir:c,retryEAGAIN:l,fsync:u,contentMode:f,mode:d}=e||{};t=t||r,this._len=0,this.fd=-1,this._bufs=[],this._lens=[],this._writing=!1,this._ending=!1,this._reopening=!1,this._asyncDrainScheduled=!1,this._flushPending=!1,this._hwm=Math.max(n||0,16387),this.file=null,this.destroyed=!1,this.minLength=n||0,this.maxLength=i||0,this.maxWrite=s||DY,this.sync=o||!1,this.writable=!0,this._fsync=u||!1,this.append=a||!1,this.mode=d,this.retryEAGAIN=l||(()=>!0),this.mkdir=c||!1;let p,m;if(f===dP)this._writingBuf=Vf,this.write=NY,this.flush=OY,this.flushSync=qY,this._actualWrite=MY,p=()=>nr.writeSync(this.fd,this._writingBuf),m=()=>nr.write(this.fd,this._writingBuf,this.release);else if(f===void 0||f===pP)this._writingBuf="",this.write=kY,this.flush=LY,this.flushSync=BY,this._actualWrite=FY,p=()=>nr.writeSync(this.fd,this._writingBuf,"utf8"),m=()=>nr.write(this.fd,this._writingBuf,"utf8",this.release);else throw new Error(`SonicBoom supports "${pP}" and "${dP}", but passed ${f}`);if(typeof t=="number")this.fd=t,process.nextTick(()=>this.emit("ready"));else if(typeof t=="string")gP(t,this);else throw new Error("SonicBoom supports only file descriptors and files");if(this.minLength>=this.maxWrite)throw new Error(`minLength should be smaller than maxWrite (${this.maxWrite})`);this.release=(S,x)=>{if(S){if((S.code==="EAGAIN"||S.code==="EBUSY")&&this.retryEAGAIN(S,this._writingBuf.length,this._len-this._writingBuf.length))if(this.sync)try{Xm(jf),this.release(void 0,0);}catch(v){this.release(v);}else setTimeout(m,jf);else this._writing=!1,this.emit("error",S);return}if(this.emit("write",x),this._len-=x,this._len<0&&(this._len=0),this._writingBuf=this._writingBuf.slice(x),this._writingBuf.length){if(!this.sync){m();return}try{do{let v=p();this._len-=v,this._writingBuf=this._writingBuf.slice(v);}while(this._writingBuf.length)}catch(v){this.release(v);return}}this._fsync&&nr.fsyncSync(this.fd);let I=this._len;this._reopening?(this._writing=!1,this._reopening=!1,this.reopen()):I>this.minLength?this._actualWrite():this._ending?I>0?this._actualWrite():(this._writing=!1,Hf(this)):(this._writing=!1,this.sync?this._asyncDrainScheduled||(this._asyncDrainScheduled=!0,process.nextTick(PY,this)):this.emit("drain"));},this.on("newListener",function(S){S==="drain"&&(this._asyncDrainScheduled=!1);});}function PY(e){e.listenerCount("drain")>0&&(e._asyncDrainScheduled=!1,e.emit("drain"));}IY(Zn,RY);function mP(e,t){return e.length===0?Vf:e.length===1?e[0]:Buffer.concat(e,t)}function kY(e){if(this.destroyed)throw new Error("SonicBoom destroyed");let t=this._len+e.length,r=this._bufs;return this.maxLength&&t>this.maxLength?(this.emit("drop",e),this._len<this._hwm):(r.length===0||r[r.length-1].length+e.length>this.maxWrite?r.push(""+e):r[r.length-1]+=e,this._len=t,!this._writing&&this._len>=this.minLength&&this._actualWrite(),this._len<this._hwm)}function NY(e){if(this.destroyed)throw new Error("SonicBoom destroyed");let t=this._len+e.length,r=this._bufs,n=this._lens;return this.maxLength&&t>this.maxLength?(this.emit("drop",e),this._len<this._hwm):(r.length===0||n[n.length-1]+e.length>this.maxWrite?(r.push([e]),n.push(e.length)):(r[r.length-1].push(e),n[n.length-1]+=e.length),this._len=t,!this._writing&&this._len>=this.minLength&&this._actualWrite(),this._len<this._hwm)}function yP(e){this._flushPending=!0;let t=()=>{this._fsync?(this._flushPending=!1,e()):nr.fsync(this.fd,n=>{this._flushPending=!1,e(n);}),this.off("error",r);},r=n=>{this._flushPending=!1,e(n),this.off("drain",t);};this.once("drain",t),this.once("error",r);}function LY(e){if(e!=null&&typeof e!="function")throw new Error("flush cb must be a function");if(this.destroyed){let t=new Error("SonicBoom destroyed");if(e){e(t);return}throw t}if(this.minLength<=0){e?.();return}e&&yP.call(this,e),!this._writing&&(this._bufs.length===0&&this._bufs.push(""),this._actualWrite());}function OY(e){if(e!=null&&typeof e!="function")throw new Error("flush cb must be a function");if(this.destroyed){let t=new Error("SonicBoom destroyed");if(e){e(t);return}throw t}if(this.minLength<=0){e?.();return}e&&yP.call(this,e),!this._writing&&(this._bufs.length===0&&(this._bufs.push([]),this._lens.push(0)),this._actualWrite());}Zn.prototype.reopen=function(e){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this._opening){this.once("ready",()=>{this.reopen(e);});return}if(this._ending)return;if(!this.file)throw new Error("Unable to reopen a file descriptor, you must pass a file to SonicBoom");if(this._reopening=!0,this._writing)return;let t=this.fd;this.once("ready",()=>{t!==this.fd&&nr.close(t,r=>{if(r)return this.emit("error",r)});}),gP(e||this.file,this);};Zn.prototype.end=function(){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this._opening){this.once("ready",()=>{this.end();});return}this._ending||(this._ending=!0,!this._writing&&(this._len>0&&this.fd>=0?this._actualWrite():Hf(this)));};function BY(){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this.fd<0)throw new Error("sonic boom is not ready yet");!this._writing&&this._writingBuf.length>0&&(this._bufs.unshift(this._writingBuf),this._writingBuf="");let e="";for(;this._bufs.length||e;){e.length<=0&&(e=this._bufs[0]);try{let t=nr.writeSync(this.fd,e,"utf8");e=e.slice(t),this._len=Math.max(this._len-t,0),e.length<=0&&this._bufs.shift();}catch(t){if((t.code==="EAGAIN"||t.code==="EBUSY")&&!this.retryEAGAIN(t,e.length,this._len-e.length))throw t;Xm(jf);}}try{nr.fsyncSync(this.fd);}catch{}}function qY(){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this.fd<0)throw new Error("sonic boom is not ready yet");!this._writing&&this._writingBuf.length>0&&(this._bufs.unshift([this._writingBuf]),this._writingBuf=Vf);let e=Vf;for(;this._bufs.length||e.length;){e.length<=0&&(e=mP(this._bufs[0],this._lens[0]));try{let t=nr.writeSync(this.fd,e);e=e.subarray(t),this._len=Math.max(this._len-t,0),e.length<=0&&(this._bufs.shift(),this._lens.shift());}catch(t){if((t.code==="EAGAIN"||t.code==="EBUSY")&&!this.retryEAGAIN(t,e.length,this._len-e.length))throw t;Xm(jf);}}}Zn.prototype.destroy=function(){this.destroyed||Hf(this);};function FY(){let e=this.release;if(this._writing=!0,this._writingBuf=this._writingBuf||this._bufs.shift()||"",this.sync)try{let t=nr.writeSync(this.fd,this._writingBuf,"utf8");e(null,t);}catch(t){e(t);}else nr.write(this.fd,this._writingBuf,"utf8",e);}function MY(){let e=this.release;if(this._writing=!0,this._writingBuf=this._writingBuf.length?this._writingBuf:mP(this._bufs.shift(),this._lens.shift()),this.sync)try{let t=nr.writeSync(this.fd,this._writingBuf);e(null,t);}catch(t){e(t);}else nr.write(this.fd,this._writingBuf,e);}function Hf(e){if(e.fd===-1){e.once("ready",Hf.bind(null,e));return}e.destroyed=!0,e._bufs=[],e._lens=[],nr.fsync(e.fd,t);function t(){e.fd!==1&&e.fd!==2?nr.close(e.fd,r):r();}function r(n){if(n){e.emit("error",n);return}e._ending&&!e._writing&&e.emit("finish"),e.emit("close");}}Zn.SonicBoom=Zn;Zn.default=Zn;vP.exports=Zn;});var Jm=A((Vce,wP)=>{var ei={exit:[],beforeExit:[]},bP={exit:jY,beforeExit:VY},da;function UY(){da===void 0&&(da=new FinalizationRegistry(HY));}function $Y(e){ei[e].length>0||process.on(e,bP[e]);}function CP(e){ei[e].length>0||(process.removeListener(e,bP[e]),ei.exit.length===0&&ei.beforeExit.length===0&&(da=void 0));}function jY(){EP("exit");}function VY(){EP("beforeExit");}function EP(e){for(let t of ei[e]){let r=t.deref(),n=t.fn;r!==void 0&&n(r,e);}ei[e]=[];}function HY(e){for(let t of ["exit","beforeExit"]){let r=ei[t].indexOf(e);ei[t].splice(r,r+1),CP(t);}}function xP(e,t,r){if(t===void 0)throw new Error("the object can't be undefined");$Y(e);let n=new WeakRef(t);n.fn=r,UY(),da.register(t,n),ei[e].push(n);}function WY(e,t){xP("exit",e,t);}function KY(e,t){xP("beforeExit",e,t);}function zY(e){if(da!==void 0){da.unregister(e);for(let t of ["exit","beforeExit"])ei[t]=ei[t].filter(r=>{let n=r.deref();return n&&n!==e}),CP(t);}}wP.exports={register:WY,registerBeforeExit:KY,unregister:zY};});var _P=A((Hce,GY)=>{GY.exports={name:"thread-stream",version:"2.4.1",description:"A streaming way to send data to a Node.js Worker Thread",main:"index.js",types:"index.d.ts",dependencies:{"real-require":"^0.2.0"},devDependencies:{"@types/node":"^20.1.0","@types/tap":"^15.0.0",desm:"^1.3.0",fastbench:"^1.0.1",husky:"^8.0.1","pino-elasticsearch":"^6.0.0","sonic-boom":"^3.0.0",standard:"^17.0.0",tap:"^16.2.0","ts-node":"^10.8.0",typescript:"^4.7.2","why-is-node-running":"^2.2.2"},scripts:{test:"standard && npm run transpile && tap test/*.test.*js && tap --ts test/*.test.*ts","test:ci":"standard && npm run transpile && npm run test:ci:js && npm run test:ci:ts","test:ci:js":'tap --no-check-coverage --coverage-report=lcovonly "test/**/*.test.*js"',"test:ci:ts":'tap --ts --no-check-coverage --coverage-report=lcovonly "test/**/*.test.*ts"',"test:yarn":'npm run transpile && tap "test/**/*.test.js" --no-check-coverage',transpile:"sh ./test/ts/transpile.sh",prepare:"husky install"},standard:{ignore:["test/ts/**/*"]},repository:{type:"git",url:"git+https://github.com/mcollina/thread-stream.git"},keywords:["worker","thread","threads","stream"],author:"Matteo Collina <hello@matteocollina.com>",license:"MIT",bugs:{url:"https://github.com/mcollina/thread-stream/issues"},homepage:"https://github.com/mcollina/thread-stream#readme"};});var AP=A((Wce,TP)=>{function YY(e,t,r,n,i){let s=Date.now()+n,o=Atomics.load(e,t);if(o===r){i(null,"ok");return}let a=o,c=l=>{Date.now()>s?i(null,"timed-out"):setTimeout(()=>{a=o,o=Atomics.load(e,t),o===a?c(l>=1e3?1e3:l*2):o===r?i(null,"ok"):i(null,"not-equal");},l);};c(1);}function QY(e,t,r,n,i){let s=Date.now()+n,o=Atomics.load(e,t);if(o!==r){i(null,"ok");return}let a=c=>{Date.now()>s?i(null,"timed-out"):setTimeout(()=>{o=Atomics.load(e,t),o!==r?i(null,"ok"):a(c>=1e3?1e3:c*2);},c);};a(1);}TP.exports={wait:YY,waitDiff:QY};});var IP=A((Kce,RP)=>{RP.exports={WRITE_INDEX:4,READ_INDEX:8};});var LP=A((zce,NP)=>{var{version:XY}=_P(),{EventEmitter:JY}=he("events"),{Worker:ZY}=he("worker_threads"),{join:eQ}=he("path"),{pathToFileURL:tQ}=he("url"),{wait:rQ}=AP(),{WRITE_INDEX:rn,READ_INDEX:mi}=IP(),nQ=he("buffer"),iQ=he("assert"),oe=Symbol("kImpl"),sQ=nQ.constants.MAX_STRING_LENGTH,Ju=class{constructor(t){this._value=t;}deref(){return this._value}},Kf=class{register(){}unregister(){}},oQ=process.env.NODE_V8_COVERAGE?Kf:global.FinalizationRegistry||Kf,aQ=process.env.NODE_V8_COVERAGE?Ju:global.WeakRef||Ju,DP=new oQ(e=>{e.exited||e.terminate();});function uQ(e,t){let{filename:r,workerData:n}=t,s=("__bundlerPathsOverrides"in globalThis?globalThis.__bundlerPathsOverrides:{})["thread-stream-worker"]||eQ(__dirname,"lib","worker.js"),o=new ZY(s,{...t.workerOpts,trackUnmanagedFds:!1,workerData:{filename:r.indexOf("file://")===0?r:tQ(r).href,dataBuf:e[oe].dataBuf,stateBuf:e[oe].stateBuf,workerData:{$context:{threadStreamVersion:XY},...n}}});return o.stream=new Ju(e),o.on("message",cQ),o.on("exit",kP),DP.register(e,o),o}function PP(e){iQ(!e[oe].sync),e[oe].needDrain&&(e[oe].needDrain=!1,e.emit("drain"));}function Wf(e){let t=Atomics.load(e[oe].state,rn),r=e[oe].data.length-t;if(r>0){if(e[oe].buf.length===0){e[oe].flushing=!1,e[oe].ending?ny(e):e[oe].needDrain&&process.nextTick(PP,e);return}let n=e[oe].buf.slice(0,r),i=Buffer.byteLength(n);i<=r?(e[oe].buf=e[oe].buf.slice(r),zf(e,n,Wf.bind(null,e))):e.flush(()=>{if(!e.destroyed){for(Atomics.store(e[oe].state,mi,0),Atomics.store(e[oe].state,rn,0);i>e[oe].data.length;)r=r/2,n=e[oe].buf.slice(0,r),i=Buffer.byteLength(n);e[oe].buf=e[oe].buf.slice(r),zf(e,n,Wf.bind(null,e));}});}else if(r===0){if(t===0&&e[oe].buf.length===0)return;e.flush(()=>{Atomics.store(e[oe].state,mi,0),Atomics.store(e[oe].state,rn,0),Wf(e);});}else yi(e,new Error("overwritten"));}function cQ(e){let t=this.stream.deref();if(t===void 0){this.exited=!0,this.terminate();return}switch(e.code){case"READY":this.stream=new aQ(t),t.flush(()=>{t[oe].ready=!0,t.emit("ready");});break;case"ERROR":yi(t,e.err);break;case"EVENT":Array.isArray(e.args)?t.emit(e.name,...e.args):t.emit(e.name,e.args);break;case"WARNING":process.emitWarning(e.err);break;default:yi(t,new Error("this should not happen: "+e.code));}}function kP(e){let t=this.stream.deref();t!==void 0&&(DP.unregister(t),t.worker.exited=!0,t.worker.off("exit",kP),yi(t,e!==0?new Error("the worker thread exited"):null));}var ey=class extends JY{constructor(t={}){if(super(),t.bufferSize<4)throw new Error("bufferSize must at least fit a 4-byte utf-8 char");this[oe]={},this[oe].stateBuf=new SharedArrayBuffer(128),this[oe].state=new Int32Array(this[oe].stateBuf),this[oe].dataBuf=new SharedArrayBuffer(t.bufferSize||4*1024*1024),this[oe].data=Buffer.from(this[oe].dataBuf),this[oe].sync=t.sync||!1,this[oe].ending=!1,this[oe].ended=!1,this[oe].needDrain=!1,this[oe].destroyed=!1,this[oe].flushing=!1,this[oe].ready=!1,this[oe].finished=!1,this[oe].errored=null,this[oe].closed=!1,this[oe].buf="",this.worker=uQ(this,t);}write(t){if(this[oe].destroyed)return ty(this,new Error("the worker has exited")),!1;if(this[oe].ending)return ty(this,new Error("the worker is ending")),!1;if(this[oe].flushing&&this[oe].buf.length+t.length>=sQ)try{Zm(this),this[oe].flushing=!0;}catch(r){return yi(this,r),!1}if(this[oe].buf+=t,this[oe].sync)try{return Zm(this),!0}catch(r){return yi(this,r),!1}return this[oe].flushing||(this[oe].flushing=!0,setImmediate(Wf,this)),this[oe].needDrain=this[oe].data.length-this[oe].buf.length-Atomics.load(this[oe].state,rn)<=0,!this[oe].needDrain}end(){this[oe].destroyed||(this[oe].ending=!0,ny(this));}flush(t){if(this[oe].destroyed){typeof t=="function"&&process.nextTick(t,new Error("the worker has exited"));return}let r=Atomics.load(this[oe].state,rn);rQ(this[oe].state,mi,r,1/0,(n,i)=>{if(n){yi(this,n),process.nextTick(t,n);return}if(i==="not-equal"){this.flush(t);return}process.nextTick(t);});}flushSync(){this[oe].destroyed||(Zm(this),ry(this));}unref(){this.worker.unref();}ref(){this.worker.ref();}get ready(){return this[oe].ready}get destroyed(){return this[oe].destroyed}get closed(){return this[oe].closed}get writable(){return !this[oe].destroyed&&!this[oe].ending}get writableEnded(){return this[oe].ending}get writableFinished(){return this[oe].finished}get writableNeedDrain(){return this[oe].needDrain}get writableObjectMode(){return !1}get writableErrored(){return this[oe].errored}};function ty(e,t){setImmediate(()=>{e.emit("error",t);});}function yi(e,t){e[oe].destroyed||(e[oe].destroyed=!0,t&&(e[oe].errored=t,ty(e,t)),e.worker.exited?setImmediate(()=>{e[oe].closed=!0,e.emit("close");}):e.worker.terminate().catch(()=>{}).then(()=>{e[oe].closed=!0,e.emit("close");}));}function zf(e,t,r){let n=Atomics.load(e[oe].state,rn),i=Buffer.byteLength(t);return e[oe].data.write(t,n),Atomics.store(e[oe].state,rn,n+i),Atomics.notify(e[oe].state,rn),r(),!0}function ny(e){if(!(e[oe].ended||!e[oe].ending||e[oe].flushing)){e[oe].ended=!0;try{e.flushSync();let t=Atomics.load(e[oe].state,mi);Atomics.store(e[oe].state,rn,-1),Atomics.notify(e[oe].state,rn);let r=0;for(;t!==-1;){if(Atomics.wait(e[oe].state,mi,t,1e3),t=Atomics.load(e[oe].state,mi),t===-2){yi(e,new Error("end() failed"));return}if(++r===10){yi(e,new Error("end() took too long (10s)"));return}}process.nextTick(()=>{e[oe].finished=!0,e.emit("finish");});}catch(t){yi(e,t);}}}function Zm(e){let t=()=>{e[oe].ending?ny(e):e[oe].needDrain&&process.nextTick(PP,e);};for(e[oe].flushing=!1;e[oe].buf.length!==0;){let r=Atomics.load(e[oe].state,rn),n=e[oe].data.length-r;if(n===0){ry(e),Atomics.store(e[oe].state,mi,0),Atomics.store(e[oe].state,rn,0);continue}else if(n<0)throw new Error("overwritten");let i=e[oe].buf.slice(0,n),s=Buffer.byteLength(i);if(s<=n)e[oe].buf=e[oe].buf.slice(n),zf(e,i,t);else {for(ry(e),Atomics.store(e[oe].state,mi,0),Atomics.store(e[oe].state,rn,0);s>e[oe].buf.length;)n=n/2,i=e[oe].buf.slice(0,n),s=Buffer.byteLength(i);e[oe].buf=e[oe].buf.slice(n),zf(e,i,t);}}}function ry(e){if(e[oe].flushing)throw new Error("unable to flush while flushing");let t=Atomics.load(e[oe].state,rn),r=0;for(;;){let n=Atomics.load(e[oe].state,mi);if(n===-2)throw Error("_flushSync failed");if(n!==t)Atomics.wait(e[oe].state,mi,n,1e3);else break;if(++r===10)throw new Error("_flushSync took too long (10s)")}}NP.exports=ey;});var oy=A((Gce,OP)=>{var{createRequire:lQ}=he("module"),fQ=$m(),{join:iy,isAbsolute:hQ,sep:dQ}=he("path"),pQ=Qm(),sy=Jm(),gQ=LP();function mQ(e){sy.register(e,vQ),sy.registerBeforeExit(e,SQ),e.on("close",function(){sy.unregister(e);});}function yQ(e,t,r){let n=new gQ({filename:e,workerData:t,workerOpts:r});n.on("ready",i),n.on("close",function(){process.removeListener("exit",s);}),process.on("exit",s);function i(){process.removeListener("exit",s),n.unref(),r.autoEnd!==!1&&mQ(n);}function s(){n.closed||(n.flushSync(),pQ(100),n.end());}return n}function vQ(e){e.ref(),e.flushSync(),e.end(),e.once("close",function(){e.unref();});}function SQ(e){e.flushSync();}function bQ(e){let{pipeline:t,targets:r,levels:n,dedupe:i,options:s={},worker:o={},caller:a=fQ()}=e,c=typeof a=="string"?[a]:a,l="__bundlerPathsOverrides"in globalThis?globalThis.__bundlerPathsOverrides:{},u=e.target;if(u&&r)throw new Error("only one of target or targets can be specified");return r?(u=l["pino-worker"]||iy(__dirname,"worker.js"),s.targets=r.map(d=>({...d,target:f(d.target)}))):t&&(u=l["pino-pipeline-worker"]||iy(__dirname,"worker-pipeline.js"),s.targets=t.map(d=>({...d,target:f(d.target)}))),n&&(s.levels=n),i&&(s.dedupe=i),yQ(f(u),s,o);function f(d){if(d=l[d]||d,hQ(d)||d.indexOf("file://")===0)return d;if(d==="pino/file")return iy(__dirname,"..","file.js");let p;for(let m of c)try{let S=m==="node:repl"?process.cwd()+dQ:m;p=lQ(S).resolve(d);break}catch{continue}if(!p)throw new Error(`unable to determine transport target for "${d}"`);return p}}OP.exports=bQ;});var Qf=A((Yce,KP)=>{var BP=fP(),{mapHttpRequest:CQ,mapHttpResponse:EQ}=Um(),uy=SP(),qP=Jm(),{lsCacheSym:xQ,chindingsSym:UP,writeSym:FP,serializersSym:$P,formatOptsSym:MP,endSym:wQ,stringifiersSym:jP,stringifySym:VP,stringifySafeSym:cy,wildcardFirstSym:HP,nestedKeySym:_Q,formattersSym:WP,messageKeySym:TQ,errorKeySym:AQ,nestedKeyStrSym:RQ,msgPrefixSym:Gf}=ha(),{isMainThread:IQ}=he("worker_threads"),DQ=oy();function pa(){}function PQ(e,t){if(!t)return r;return function(...i){t.call(this,i,r,e);};function r(n,...i){if(typeof n=="object"){let s=n;n!==null&&(n.method&&n.headers&&n.socket?n=CQ(n):typeof n.setHeader=="function"&&(n=EQ(n)));let o;s===null&&i.length===0?o=[null]:(s=i.shift(),o=i),typeof this[Gf]=="string"&&s!==void 0&&s!==null&&(s=this[Gf]+s),this[FP](n,BP(s,o,this[MP]),e);}else {let s=n===void 0?i.shift():n;typeof this[Gf]=="string"&&s!==void 0&&s!==null&&(s=this[Gf]+s),this[FP](null,BP(s,i,this[MP]),e);}}}function ay(e){let t="",r=0,n=!1,i=255,s=e.length;if(s>100)return JSON.stringify(e);for(var o=0;o<s&&i>=32;o++)i=e.charCodeAt(o),(i===34||i===92)&&(t+=e.slice(r,o)+"\\",r=o,n=!0);return n?t+=e.slice(r):t=e,i<32?JSON.stringify(e):'"'+t+'"'}function kQ(e,t,r,n){let i=this[VP],s=this[cy],o=this[jP],a=this[wQ],c=this[UP],l=this[$P],u=this[WP],f=this[TQ],d=this[AQ],p=this[xQ][r]+n;p=p+c;let m;u.log&&(e=u.log(e));let S=o[HP],x="";for(let v in e)if(m=e[v],Object.prototype.hasOwnProperty.call(e,v)&&m!==void 0){l[v]?m=l[v](m):v===d&&l.err&&(m=l.err(m));let b=o[v]||S;switch(typeof m){case"undefined":case"function":continue;case"number":Number.isFinite(m)===!1&&(m=null);case"boolean":b&&(m=b(m));break;case"string":m=(b||ay)(m);break;default:m=(b||i)(m,s);}if(m===void 0)continue;let D=ay(v);x+=","+D+":"+m;}let I="";if(t!==void 0){m=l[f]?l[f](t):t;let v=o[f]||S;switch(typeof m){case"function":break;case"number":Number.isFinite(m)===!1&&(m=null);case"boolean":v&&(m=v(m)),I=',"'+f+'":'+m;break;case"string":m=(v||ay)(m),I=',"'+f+'":'+m;break;default:m=(v||i)(m,s),I=',"'+f+'":'+m;}}return this[_Q]&&x?p+this[RQ]+x.slice(1)+"}"+I+a:p+x+I+a}function NQ(e,t){let r,n=e[UP],i=e[VP],s=e[cy],o=e[jP],a=o[HP],c=e[$P],l=e[WP].bindings;t=l(t);for(let u in t)if(r=t[u],(u!=="level"&&u!=="serializers"&&u!=="formatters"&&u!=="customLevels"&&t.hasOwnProperty(u)&&r!==void 0)===!0){if(r=c[u]?c[u](r):r,r=(o[u]||a||i)(r,s),r===void 0)continue;n+=',"'+u+'":'+r;}return n}function LQ(e){return e.write!==e.constructor.prototype.write}var OQ=process.env.NODE_V8_COVERAGE||process.env.V8_COVERAGE;function Yf(e){let t=new uy(e);return t.on("error",r),!OQ&&!e.sync&&IQ&&(qP.register(t,BQ),t.on("close",function(){qP.unregister(t);})),t;function r(n){if(n.code==="EPIPE"){t.write=pa,t.end=pa,t.flushSync=pa,t.destroy=pa;return}t.removeListener("error",r),t.emit("error",n);}}function BQ(e,t){e.destroyed||(t==="beforeExit"?(e.flush(),e.on("drain",function(){e.end();})):e.flushSync());}function qQ(e){return function(r,n,i={},s){if(typeof i=="string")s=Yf({dest:i}),i={};else if(typeof s=="string"){if(i&&i.transport)throw Error("only one of option.transport or stream can be specified");s=Yf({dest:s});}else if(i instanceof uy||i.writable||i._writableState)s=i,i={};else if(i.transport){if(i.transport instanceof uy||i.transport.writable||i.transport._writableState)throw Error("option.transport do not allow stream, please pass to option directly. e.g. pino(transport)");if(i.transport.targets&&i.transport.targets.length&&i.formatters&&typeof i.formatters.level=="function")throw Error("option.transport.targets do not allow custom level formatters");let c;i.customLevels&&(c=i.useOnlyCustomLevels?i.customLevels:Object.assign({},i.levels,i.customLevels)),s=DQ({caller:n,...i.transport,levels:c});}if(i=Object.assign({},e,i),i.serializers=Object.assign({},e.serializers,i.serializers),i.formatters=Object.assign({},e.formatters,i.formatters),i.prettyPrint)throw new Error("prettyPrint option is no longer supported, see the pino-pretty package (https://github.com/pinojs/pino-pretty)");let{enabled:o,onChild:a}=i;return o===!1&&(i.level="silent"),a||(i.onChild=pa),s||(LQ(process.stdout)?s=process.stdout:s=Yf({fd:process.stdout.fd||1})),{opts:i,stream:s}}}function FQ(e,t){try{return JSON.stringify(e)}catch{try{return (t||this[cy])(e)}catch{return '"[unable to serialize, circular reference is too complex to analyze]"'}}}function MQ(e,t,r){return {level:e,bindings:t,log:r}}function UQ(e){let t=Number(e);return typeof e=="string"&&Number.isFinite(t)?t:e===void 0?1:e}KP.exports={noop:pa,buildSafeSonicBoom:Yf,asChindings:NQ,asJson:kQ,genLog:PQ,createArgsNormalizer:qQ,stringify:FQ,buildFormatters:MQ,normalizeDestFileDescriptor:UQ};});var Xf=A((Qce,GP)=>{var{lsCacheSym:$Q,levelValSym:ly,useOnlyCustomLevelsSym:jQ,streamSym:VQ,formattersSym:HQ,hooksSym:WQ}=ha(),{noop:KQ,genLog:oo}=Qf(),ti={trace:10,debug:20,info:30,warn:40,error:50,fatal:60},zP={fatal:e=>{let t=oo(ti.fatal,e);return function(...r){let n=this[VQ];if(t.call(this,...r),typeof n.flushSync=="function")try{n.flushSync();}catch{}}},error:e=>oo(ti.error,e),warn:e=>oo(ti.warn,e),info:e=>oo(ti.info,e),debug:e=>oo(ti.debug,e),trace:e=>oo(ti.trace,e)},fy=Object.keys(ti).reduce((e,t)=>(e[ti[t]]=t,e),{}),zQ=Object.keys(fy).reduce((e,t)=>(e[t]='{"level":'+Number(t),e),{});function GQ(e){let t=e[HQ].level,{labels:r}=e.levels,n={};for(let i in r){let s=t(r[i],Number(i));n[i]=JSON.stringify(s).slice(0,-1);}return e[$Q]=n,e}function YQ(e,t){if(t)return !1;switch(e){case"fatal":case"error":case"warn":case"info":case"debug":case"trace":return !0;default:return !1}}function QQ(e){let{labels:t,values:r}=this.levels;if(typeof e=="number"){if(t[e]===void 0)throw Error("unknown level value"+e);e=t[e];}if(r[e]===void 0)throw Error("unknown level "+e);let n=this[ly],i=this[ly]=r[e],s=this[jQ],o=this[WQ].logMethod;for(let a in r){if(i>r[a]){this[a]=KQ;continue}this[a]=YQ(a,s)?zP[a](o):oo(r[a],o);}this.emit("level-change",e,i,t[n],n,this);}function XQ(e){let{levels:t,levelVal:r}=this;return t&&t.labels?t.labels[r]:""}function JQ(e){let{values:t}=this.levels,r=t[e];return r!==void 0&&r>=this[ly]}function ZQ(e=null,t=!1){let r=e?Object.keys(e).reduce((s,o)=>(s[e[o]]=o,s),{}):null,n=Object.assign(Object.create(Object.prototype,{Infinity:{value:"silent"}}),t?null:fy,r),i=Object.assign(Object.create(Object.prototype,{silent:{value:1/0}}),t?null:ti,e);return {labels:n,values:i}}function eX(e,t,r){if(typeof e=="number"){if(![].concat(Object.keys(t||{}).map(s=>t[s]),r?[]:Object.keys(fy).map(s=>+s),1/0).includes(e))throw Error(`default level:${e} must be included in custom levels`);return}let n=Object.assign(Object.create(Object.prototype,{silent:{value:1/0}}),r?null:ti,t);if(!(e in n))throw Error(`default level:${e} must be included in custom levels`)}function tX(e,t){let{labels:r,values:n}=e;for(let i in t){if(i in n)throw Error("levels cannot be overridden");if(t[i]in r)throw Error("pre-existing level values cannot be used for new levels")}}GP.exports={initialLsCache:zQ,genLsCache:GQ,levelMethods:zP,getLevel:XQ,setLevel:QQ,isLevelEnabled:JQ,mappings:ZQ,levels:ti,assertNoLevelCollisions:tX,assertDefaultLevelFound:eX};});var hy=A((Xce,YP)=>{YP.exports={version:"8.17.1"};});var ok=A((Zce,sk)=>{var{EventEmitter:rX}=he("events"),{lsCacheSym:nX,levelValSym:iX,setLevelSym:py,getLevelSym:QP,chindingsSym:gy,parsedChindingsSym:sX,mixinSym:oX,asJsonSym:tk,writeSym:aX,mixinMergeStrategySym:uX,timeSym:cX,timeSliceIndexSym:lX,streamSym:rk,serializersSym:ao,formattersSym:dy,errorKeySym:fX,messageKeySym:hX,useOnlyCustomLevelsSym:dX,needsMetadataGsym:pX,redactFmtSym:gX,stringifySym:mX,formatOptsSym:yX,stringifiersSym:vX,msgPrefixSym:XP}=ha(),{getLevel:SX,setLevel:bX,isLevelEnabled:CX,mappings:EX,initialLsCache:xX,genLsCache:wX,assertNoLevelCollisions:_X}=Xf(),{asChindings:nk,asJson:TX,buildFormatters:JP,stringify:ZP}=Qf(),{version:AX}=hy(),RX=Gm(),IX=class{},ik={constructor:IX,child:DX,bindings:PX,setBindings:kX,flush:BX,isLevelEnabled:CX,version:AX,get level(){return this[QP]()},set level(e){this[py](e);},get levelVal(){return this[iX]},set levelVal(e){throw Error("levelVal is read-only")},[nX]:xX,[aX]:LX,[tk]:TX,[QP]:SX,[py]:bX};Object.setPrototypeOf(ik,rX.prototype);sk.exports=function(){return Object.create(ik)};var ek=e=>e;function DX(e,t){if(!e)throw Error("missing bindings for child Pino");t=t||{};let r=this[ao],n=this[dy],i=Object.create(this);if(t.hasOwnProperty("serializers")===!0){i[ao]=Object.create(null);for(let u in r)i[ao][u]=r[u];let c=Object.getOwnPropertySymbols(r);for(var s=0;s<c.length;s++){let u=c[s];i[ao][u]=r[u];}for(let u in t.serializers)i[ao][u]=t.serializers[u];let l=Object.getOwnPropertySymbols(t.serializers);for(var o=0;o<l.length;o++){let u=l[o];i[ao][u]=t.serializers[u];}}else i[ao]=r;if(t.hasOwnProperty("formatters")){let{level:c,bindings:l,log:u}=t.formatters;i[dy]=JP(c||n.level,l||ek,u||n.log);}else i[dy]=JP(n.level,ek,n.log);if(t.hasOwnProperty("customLevels")===!0&&(_X(this.levels,t.customLevels),i.levels=EX(t.customLevels,i[dX]),wX(i)),typeof t.redact=="object"&&t.redact!==null||Array.isArray(t.redact)){i.redact=t.redact;let c=RX(i.redact,ZP),l={stringify:c[gX]};i[mX]=ZP,i[vX]=c,i[yX]=l;}typeof t.msgPrefix=="string"&&(i[XP]=(this[XP]||"")+t.msgPrefix),i[gy]=nk(i,e);let a=t.level||this.level;return i[py](a),this.onChild(i),i}function PX(){let t=`{${this[gy].substr(1)}}`,r=JSON.parse(t);return delete r.pid,delete r.hostname,r}function kX(e){let t=nk(this,e);this[gy]=t,delete this[sX];}function NX(e,t){return Object.assign(t,e)}function LX(e,t,r){let n=this[cX](),i=this[oX],s=this[fX],o=this[hX],a=this[uX]||NX,c;e==null?c={}:e instanceof Error?(c={[s]:e},t===void 0&&(t=e.message)):(c=e,t===void 0&&e[o]===void 0&&e[s]&&(t=e[s].message)),i&&(c=a(c,i(c,r,this)));let l=this[tk](c,t,r,n),u=this[rk];u[pX]===!0&&(u.lastLevel=r,u.lastObj=c,u.lastMsg=t,u.lastTime=n.slice(this[lX]),u.lastLogger=this),u.write(l);}function OX(){}function BX(e){if(e!=null&&typeof e!="function")throw Error("callback must be a function");let t=this[rk];typeof t.flush=="function"?t.flush(e||OX):e&&e();}});var fk=A((Sy,lk)=>{var{hasOwnProperty:Jf}=Object.prototype,co=vy();co.configure=vy;co.stringify=co;co.default=co;Sy.stringify=co;Sy.configure=vy;lk.exports=co;var qX=/[\u0000-\u001f\u0022\u005c\ud800-\udfff]|[\ud800-\udbff](?![\udc00-\udfff])|(?:[^\ud800-\udbff]|^)[\udc00-\udfff]/;function ds(e){return e.length<5e3&&!qX.test(e)?`"${e}"`:JSON.stringify(e)}function my(e){if(e.length>200)return e.sort();for(let t=1;t<e.length;t++){let r=e[t],n=t;for(;n!==0&&e[n-1]>r;)e[n]=e[n-1],n--;e[n]=r;}return e}var FX=Object.getOwnPropertyDescriptor(Object.getPrototypeOf(Object.getPrototypeOf(new Int8Array)),Symbol.toStringTag).get;function yy(e){return FX.call(e)!==void 0&&e.length!==0}function ak(e,t,r){e.length<r&&(r=e.length);let n=t===","?"":" ",i=`"0":${n}${e[0]}`;for(let s=1;s<r;s++)i+=`${t}"${s}":${n}${e[s]}`;return i}function MX(e){if(Jf.call(e,"circularValue")){let t=e.circularValue;if(typeof t=="string")return `"${t}"`;if(t==null)return t;if(t===Error||t===TypeError)return {toString(){throw new TypeError("Converting circular structure to JSON")}};throw new TypeError('The "circularValue" argument must be of type string or the value null or undefined')}return '"[Circular]"'}function uk(e,t){let r;if(Jf.call(e,t)&&(r=e[t],typeof r!="boolean"))throw new TypeError(`The "${t}" argument must be of type boolean`);return r===void 0?!0:r}function ck(e,t){let r;if(Jf.call(e,t)){if(r=e[t],typeof r!="number")throw new TypeError(`The "${t}" argument must be of type number`);if(!Number.isInteger(r))throw new TypeError(`The "${t}" argument must be an integer`);if(r<1)throw new RangeError(`The "${t}" argument must be >= 1`)}return r===void 0?1/0:r}function uo(e){return e===1?"1 item":`${e} items`}function UX(e){let t=new Set;for(let r of e)(typeof r=="string"||typeof r=="number")&&t.add(String(r));return t}function $X(e){if(Jf.call(e,"strict")){let t=e.strict;if(typeof t!="boolean")throw new TypeError('The "strict" argument must be of type boolean');if(t)return r=>{let n=`Object can not safely be stringified. Received type ${typeof r}`;throw typeof r!="function"&&(n+=` (${r.toString()})`),new Error(n)}}}function vy(e){e={...e};let t=$X(e);t&&(e.bigint===void 0&&(e.bigint=!1),"circularValue"in e||(e.circularValue=Error));let r=MX(e),n=uk(e,"bigint"),i=uk(e,"deterministic"),s=ck(e,"maximumDepth"),o=ck(e,"maximumBreadth");function a(d,p,m,S,x,I){let v=p[d];switch(typeof v=="object"&&v!==null&&typeof v.toJSON=="function"&&(v=v.toJSON(d)),v=S.call(p,d,v),typeof v){case"string":return ds(v);case"object":{if(v===null)return "null";if(m.indexOf(v)!==-1)return r;let b="",D=",",L=I;if(Array.isArray(v)){if(v.length===0)return "[]";if(s<m.length+1)return '"[Array]"';m.push(v),x!==""&&(I+=x,b+=`
${I}`,D=`,
${I}`);let M=Math.min(v.length,o),ae=0;for(;ae<M-1;ae++){let Le=a(String(ae),v,m,S,x,I);b+=Le!==void 0?Le:"null",b+=D;}let me=a(String(ae),v,m,S,x,I);if(b+=me!==void 0?me:"null",v.length-1>o){let Le=v.length-o-1;b+=`${D}"... ${uo(Le)} not stringified"`;}return x!==""&&(b+=`
${L}`),m.pop(),`[${b}]`}let j=Object.keys(v),J=j.length;if(J===0)return "{}";if(s<m.length+1)return '"[Object]"';let K="",G="";x!==""&&(I+=x,D=`,
${I}`,K=" ");let ee=Math.min(J,o);i&&!yy(v)&&(j=my(j)),m.push(v);for(let M=0;M<ee;M++){let ae=j[M],me=a(ae,v,m,S,x,I);me!==void 0&&(b+=`${G}${ds(ae)}:${K}${me}`,G=D);}if(J>o){let M=J-o;b+=`${G}"...":${K}"${uo(M)} not stringified"`,G=D;}return x!==""&&G.length>1&&(b=`
${I}${b}
${L}`),m.pop(),`{${b}}`}case"number":return isFinite(v)?String(v):t?t(v):"null";case"boolean":return v===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(v);default:return t?t(v):void 0}}function c(d,p,m,S,x,I){switch(typeof p=="object"&&p!==null&&typeof p.toJSON=="function"&&(p=p.toJSON(d)),typeof p){case"string":return ds(p);case"object":{if(p===null)return "null";if(m.indexOf(p)!==-1)return r;let v=I,b="",D=",";if(Array.isArray(p)){if(p.length===0)return "[]";if(s<m.length+1)return '"[Array]"';m.push(p),x!==""&&(I+=x,b+=`
${I}`,D=`,
${I}`);let J=Math.min(p.length,o),K=0;for(;K<J-1;K++){let ee=c(String(K),p[K],m,S,x,I);b+=ee!==void 0?ee:"null",b+=D;}let G=c(String(K),p[K],m,S,x,I);if(b+=G!==void 0?G:"null",p.length-1>o){let ee=p.length-o-1;b+=`${D}"... ${uo(ee)} not stringified"`;}return x!==""&&(b+=`
${v}`),m.pop(),`[${b}]`}m.push(p);let L="";x!==""&&(I+=x,D=`,
${I}`,L=" ");let j="";for(let J of S){let K=c(J,p[J],m,S,x,I);K!==void 0&&(b+=`${j}${ds(J)}:${L}${K}`,j=D);}return x!==""&&j.length>1&&(b=`
${I}${b}
${v}`),m.pop(),`{${b}}`}case"number":return isFinite(p)?String(p):t?t(p):"null";case"boolean":return p===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(p);default:return t?t(p):void 0}}function l(d,p,m,S,x){switch(typeof p){case"string":return ds(p);case"object":{if(p===null)return "null";if(typeof p.toJSON=="function"){if(p=p.toJSON(d),typeof p!="object")return l(d,p,m,S,x);if(p===null)return "null"}if(m.indexOf(p)!==-1)return r;let I=x;if(Array.isArray(p)){if(p.length===0)return "[]";if(s<m.length+1)return '"[Array]"';m.push(p),x+=S;let K=`
${x}`,G=`,
${x}`,ee=Math.min(p.length,o),M=0;for(;M<ee-1;M++){let me=l(String(M),p[M],m,S,x);K+=me!==void 0?me:"null",K+=G;}let ae=l(String(M),p[M],m,S,x);if(K+=ae!==void 0?ae:"null",p.length-1>o){let me=p.length-o-1;K+=`${G}"... ${uo(me)} not stringified"`;}return K+=`
${I}`,m.pop(),`[${K}]`}let v=Object.keys(p),b=v.length;if(b===0)return "{}";if(s<m.length+1)return '"[Object]"';x+=S;let D=`,
${x}`,L="",j="",J=Math.min(b,o);yy(p)&&(L+=ak(p,D,o),v=v.slice(p.length),J-=p.length,j=D),i&&(v=my(v)),m.push(p);for(let K=0;K<J;K++){let G=v[K],ee=l(G,p[G],m,S,x);ee!==void 0&&(L+=`${j}${ds(G)}: ${ee}`,j=D);}if(b>o){let K=b-o;L+=`${j}"...": "${uo(K)} not stringified"`,j=D;}return j!==""&&(L=`
${x}${L}
${I}`),m.pop(),`{${L}}`}case"number":return isFinite(p)?String(p):t?t(p):"null";case"boolean":return p===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(p);default:return t?t(p):void 0}}function u(d,p,m){switch(typeof p){case"string":return ds(p);case"object":{if(p===null)return "null";if(typeof p.toJSON=="function"){if(p=p.toJSON(d),typeof p!="object")return u(d,p,m);if(p===null)return "null"}if(m.indexOf(p)!==-1)return r;let S="";if(Array.isArray(p)){if(p.length===0)return "[]";if(s<m.length+1)return '"[Array]"';m.push(p);let D=Math.min(p.length,o),L=0;for(;L<D-1;L++){let J=u(String(L),p[L],m);S+=J!==void 0?J:"null",S+=",";}let j=u(String(L),p[L],m);if(S+=j!==void 0?j:"null",p.length-1>o){let J=p.length-o-1;S+=`,"... ${uo(J)} not stringified"`;}return m.pop(),`[${S}]`}let x=Object.keys(p),I=x.length;if(I===0)return "{}";if(s<m.length+1)return '"[Object]"';let v="",b=Math.min(I,o);yy(p)&&(S+=ak(p,",",o),x=x.slice(p.length),b-=p.length,v=","),i&&(x=my(x)),m.push(p);for(let D=0;D<b;D++){let L=x[D],j=u(L,p[L],m);j!==void 0&&(S+=`${v}${ds(L)}:${j}`,v=",");}if(I>o){let D=I-o;S+=`${v}"...":"${uo(D)} not stringified"`;}return m.pop(),`{${S}}`}case"number":return isFinite(p)?String(p):t?t(p):"null";case"boolean":return p===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(p);default:return t?t(p):void 0}}function f(d,p,m){if(arguments.length>1){let S="";if(typeof m=="number"?S=" ".repeat(Math.min(m,10)):typeof m=="string"&&(S=m.slice(0,10)),p!=null){if(typeof p=="function")return a("",{"":d},[],p,S,"");if(Array.isArray(p))return c("",d,[],UX(p),S,"")}if(S.length!==0)return l("",d,[],S,"")}return u("",d,[])}return f}});var pk=A((ele,dk)=>{var by=Symbol.for("pino.metadata"),{levels:hk}=Xf(),jX=hk.info;function VX(e,t){let r=0;e=e||[],t=t||{dedupe:!1};let n=Object.create(hk);n.silent=1/0,t.levels&&typeof t.levels=="object"&&Object.keys(t.levels).forEach(u=>{n[u]=t.levels[u];});let i={write:s,add:a,flushSync:o,end:c,minLevel:0,streams:[],clone:l,[by]:!0,streamLevels:n};return Array.isArray(e)?e.forEach(a,i):a.call(i,e),e=null,i;function s(u){let f,d=this.lastLevel,{streams:p}=this,m=0,S;for(let x=WX(p.length,t.dedupe);zX(x,p.length,t.dedupe);x=KX(x,t.dedupe))if(f=p[x],f.level<=d){if(m!==0&&m!==f.level)break;if(S=f.stream,S[by]){let{lastTime:I,lastMsg:v,lastObj:b,lastLogger:D}=this;S.lastLevel=d,S.lastTime=I,S.lastMsg=v,S.lastObj=b,S.lastLogger=D;}S.write(u),t.dedupe&&(m=f.level);}else if(!t.dedupe)break}function o(){for(let{stream:u}of this.streams)typeof u.flushSync=="function"&&u.flushSync();}function a(u){if(!u)return i;let f=typeof u.write=="function"||u.stream,d=u.write?u:u.stream;if(!f)throw Error("stream object needs to implement either StreamEntry or DestinationStream interface");let{streams:p,streamLevels:m}=this,S;typeof u.levelVal=="number"?S=u.levelVal:typeof u.level=="string"?S=m[u.level]:typeof u.level=="number"?S=u.level:S=jX;let x={stream:d,level:S,levelVal:void 0,id:r++};return p.unshift(x),p.sort(HX),this.minLevel=p[0].level,i}function c(){for(let{stream:u}of this.streams)typeof u.flushSync=="function"&&u.flushSync(),u.end();}function l(u){let f=new Array(this.streams.length);for(let d=0;d<f.length;d++)f[d]={level:u,stream:this.streams[d].stream};return {write:s,add:a,minLevel:u,streams:f,clone:l,flushSync:o,[by]:!0}}}function HX(e,t){return e.level-t.level}function WX(e,t){return t?e-1:0}function KX(e,t){return t?e-1:e+1}function zX(e,t,r){return r?e>=0:e<t}dk.exports=VX;});var Ak=A((tle,Nn)=>{var GX=he("os"),Ek=Um(),YX=$m(),QX=Gm(),xk=cP(),XX=ok(),wk=ha(),{configure:JX}=fk(),{assertDefaultLevelFound:ZX,mappings:_k,genLsCache:eJ,levels:tJ}=Xf(),{createArgsNormalizer:rJ,asChindings:nJ,buildSafeSonicBoom:gk,buildFormatters:iJ,stringify:Cy,normalizeDestFileDescriptor:mk,noop:sJ}=Qf(),{version:oJ}=hy(),{chindingsSym:yk,redactFmtSym:aJ,serializersSym:vk,timeSym:uJ,timeSliceIndexSym:cJ,streamSym:lJ,stringifySym:Sk,stringifySafeSym:Ey,stringifiersSym:bk,setLevelSym:fJ,endSym:hJ,formatOptsSym:dJ,messageKeySym:pJ,errorKeySym:gJ,nestedKeySym:mJ,mixinSym:yJ,useOnlyCustomLevelsSym:vJ,formattersSym:Ck,hooksSym:SJ,nestedKeyStrSym:bJ,mixinMergeStrategySym:CJ,msgPrefixSym:EJ}=wk,{epochTime:Tk,nullTime:xJ}=xk,{pid:wJ}=process,_J=GX.hostname(),TJ=Ek.err,AJ={level:"info",levels:tJ,messageKey:"msg",errorKey:"err",nestedKey:null,enabled:!0,base:{pid:wJ,hostname:_J},serializers:Object.assign(Object.create(null),{err:TJ}),formatters:Object.assign(Object.create(null),{bindings(e){return e},level(e,t){return {level:t}}}),hooks:{logMethod:void 0},timestamp:Tk,name:void 0,redact:null,customLevels:null,useOnlyCustomLevels:!1,depthLimit:5,edgeLimit:100},RJ=rJ(AJ),IJ=Object.assign(Object.create(null),Ek);function xy(...e){let t={},{opts:r,stream:n}=RJ(t,YX(),...e),{redact:i,crlf:s,serializers:o,timestamp:a,messageKey:c,errorKey:l,nestedKey:u,base:f,name:d,level:p,customLevels:m,mixin:S,mixinMergeStrategy:x,useOnlyCustomLevels:I,formatters:v,hooks:b,depthLimit:D,edgeLimit:L,onChild:j,msgPrefix:J}=r,K=JX({maximumDepth:D,maximumBreadth:L}),G=iJ(v.level,v.bindings,v.log),ee=Cy.bind({[Ey]:K}),M=i?QX(i,ee):{},ae=i?{stringify:M[aJ]}:{stringify:ee},me="}"+(s?`\r
`:`
`),Le=nJ.bind(null,{[yk]:"",[vk]:o,[bk]:M,[Sk]:Cy,[Ey]:K,[Ck]:G}),H="";f!==null&&(d===void 0?H=Le(f):H=Le(Object.assign({},f,{name:d})));let W=a instanceof Function?a:a?Tk:xJ,se=W().indexOf(":")+1;if(I&&!m)throw Error("customLevels is required if useOnlyCustomLevels is set true");if(S&&typeof S!="function")throw Error(`Unknown mixin type "${typeof S}" - expected "function"`);if(J&&typeof J!="string")throw Error(`Unknown msgPrefix type "${typeof J}" - expected "string"`);ZX(p,m,I);let Te=_k(m,I);return Object.assign(t,{levels:Te,[vJ]:I,[lJ]:n,[uJ]:W,[cJ]:se,[Sk]:Cy,[Ey]:K,[bk]:M,[hJ]:me,[dJ]:ae,[pJ]:c,[gJ]:l,[mJ]:u,[bJ]:u?`,${JSON.stringify(u)}:{`:"",[vk]:o,[yJ]:S,[CJ]:x,[yk]:H,[Ck]:G,[SJ]:b,silent:sJ,onChild:j,[EJ]:J}),Object.setPrototypeOf(t,XX()),eJ(t),t[fJ](p),t}Nn.exports=xy;Nn.exports.destination=(e=process.stdout.fd)=>typeof e=="object"?(e.dest=mk(e.dest||process.stdout.fd),gk(e)):gk({dest:mk(e),minLength:0});Nn.exports.transport=oy();Nn.exports.multistream=pk();Nn.exports.levels=_k();Nn.exports.stdSerializers=IJ;Nn.exports.stdTimeFunctions=Object.assign({},xk);Nn.exports.symbols=wk;Nn.exports.version=oJ;Nn.exports.default=xy;Nn.exports.pino=xy;});var Zu=A(ps=>{Object.defineProperty(ps,"__esModule",{value:!0});ps.Frequency=ps.KeepLogFiles=void 0;(function(e){e[e.days=1]="days",e[e.fileCount=2]="fileCount";})(ps.KeepLogFiles||(ps.KeepLogFiles={}));(function(e){e[e.daily=1]="daily",e[e.minutes=2]="minutes",e[e.hours=3]="hours",e[e.date=4]="date",e[e.none=5]="none";})(ps.Frequency||(ps.Frequency={}));});var Ik=A(_y=>{Object.defineProperty(_y,"__esModule",{value:!0});var Rk=Zu(),wy=class{static fileStreamRotatorOptions(t){return Object.assign(Object.assign({},{filename:"",verbose:!1,end_stream:!1,utc:!1,create_symlink:!1,symlink_name:"current.log"}),t)}static fileOptions(t){return Object.assign(Object.assign({},{flags:"a"}),t)}static auditSettings(t){let r={keepSettings:{type:Rk.KeepLogFiles.fileCount,amount:10},auditFilename:"audit.json",hashType:"md5",extension:"",files:[]};return Object.assign(Object.assign({},r),t)}static rotationSettings(t){let r={filename:"",frequency:Rk.Frequency.none,utc:!1};return Object.assign(Object.assign({},r),t)}static extractParam(t,r=!0){let n=t.toString().match(/(\w)$/),i={number:0};n?.length==2&&(i.letter=n[1].toLowerCase());let s=t.toString().match(/^(\d+)/);return s?.length==2&&(i.number=Number(s[1])),i}};_y.default=wy;});var Zf=A(ga=>{Object.defineProperty(ga,"__esModule",{value:!0});ga.Logger=ga.makeDirectory=void 0;var kJ=he("fs"),NJ=he("path");function LJ(e){if(e.trim()!==""){var t=NJ.dirname(e);try{kJ.mkdirSync(t,{recursive:!0});}catch(r){if(r.code!=="EEXIST")throw r}}}ga.makeDirectory=LJ;var Ty=class e{constructor(){this.isVerbose=!1,this.allowDebug=!1;}static getInstance(t,r){return e.instance||(e.instance=new e,e.instance.isVerbose=t??!1,e.instance.allowDebug=r??!1),e.instance}static verbose(...t){e.getInstance().isVerbose&&console.log.apply(null,[new Date,"[FileStreamRotator:VERBOSE]",...t]);}static log(...t){console.log.apply(null,[new Date,"[FileStreamRotator]",...t]);}static debug(...t){e.getInstance().allowDebug&&console.debug.apply(null,[new Date,"[FileStreamRotator:DEBUG]",...t]);}};ga.Logger=Ty;});var Pk=A(Ry=>{Object.defineProperty(Ry,"__esModule",{value:!0});var Dk=he("fs"),Sn=Zu(),lo=Zf(),Ay=class e{constructor(t,r){var n;switch(this.currentSize=0,this.lastDate="",this.fileIndx=0,this.settings=t,this.settings.frequency){case Sn.Frequency.hours:this.settings.amount&&this.settings.amount<13?this.settings.amount&&this.settings.amount>0||(this.settings.amount=1):this.settings.amount=12,this.isFormatValidForHour()||(lo.Logger.log("Date format not suitable for X hours rotation. Changing date format to 'YMDHm'"),this.settings.format="YMDHm");break;case Sn.Frequency.minutes:this.settings.amount&&this.settings.amount<31?this.settings.amount&&this.settings.amount>0||(this.settings.amount=1):this.settings.amount=30,this.isFormatValidForMinutes()||(this.settings.format="YMDHm",lo.Logger.log("Date format not suitable for X minutes rotation. Changing date format to 'YMDHm'"));break;case Sn.Frequency.daily:this.isFormatValidForDaily()||(this.settings.format="YMD",lo.Logger.log("Date format not suitable for daily rotation. Changing date format to 'YMD'"));break}if(this.settings.frequency!==Sn.Frequency.none&&!this.settings.filename.match("%DATE%")&&(this.settings.filename+=".%DATE%",lo.Logger.log("Appending date to the end of the filename")),this.lastDate=this.getDateString(),this.settings.maxSize&&r){let s=new Date(r.date),o=(n=this.settings.extension)!==null&&n!==void 0?n:"";if(lo.Logger.debug(this.getDateString(s)==this.getDateString(new Date),this.getDateString(s),this.getDateString(new Date)),this.getDateString(s)==this.getDateString(new Date)){let a=r.name.match(RegExp("(\\d+)"+o.replace(/[.*+?^${}()|[\]\\]/g,"\\$&")));a&&(this.fileIndx=Number(a[1]));var i=this.getSizeForFile(this.getNewFilename());i&&(this.currentSize=i),this.lastDate=this.getDateString(s),lo.Logger.debug("LOADED LAST ENTRY",this.currentSize,this.lastDate,this.fileIndx);}else {var i=this.getSizeForFile(this.getNewFilename());i&&(this.currentSize=i),lo.Logger.debug("CURRENT FILE:",this.getNewFilename(),this.currentSize);}}}getSizeForFile(t){try{if(Dk.existsSync(t)){var r=Dk.statSync(this.getNewFilename());if(r)return r.size}}catch{return}}hasMaxSizeReached(){return this.settings.maxSize?this.currentSize>this.settings.maxSize:!1}shouldRotate(){let t=this.hasMaxSizeReached();switch(this.settings.frequency){case Sn.Frequency.none:return t;case Sn.Frequency.hours:case Sn.Frequency.minutes:case Sn.Frequency.date:case Sn.Frequency.daily:default:let r=this.getDateString();return this.lastDate!=r?!0:t}}isFormatValidForDaily(){let t=new Date(2022,2,20,1,2,3),r=new Date(2022,2,20,23,55,45),n=new Date(2022,2,21,2,55,45);return this.getDateString(t)===this.getDateString(r)&&this.getDateString(t)!==this.getDateString(n)}isFormatValidForHour(){if(!this.settings.amount||this.settings.frequency!=Sn.Frequency.hours)return !1;let t=new Date(2022,2,20,1,2,3),r=new Date(2022,2,20,2+this.settings.amount,55,45);return this.getDateString(t)!==this.getDateString(r)}isFormatValidForMinutes(){if(!this.settings.amount||this.settings.frequency!=Sn.Frequency.minutes)return !1;let t=new Date(2022,2,20,1,2,3),r=new Date(2022,2,20,1,2+this.settings.amount,45);return this.getDateString(t)!==this.getDateString(r)}getDateString(t){let r=t||new Date,n=e.getDateComponents(r,this.settings.utc),i=this.settings.format;if(i){switch(this.settings.frequency){case Sn.Frequency.hours:if(this.settings.amount){var s=Math.floor(n.hour/this.settings.amount)*this.settings.amount;n.hour=s,n.minute=0,n.second=0;}case Sn.Frequency.minutes:if(this.settings.amount){var o=Math.floor(n.minute/this.settings.amount)*this.settings.amount;n.minute=o,n.second=0;}}return i?.replace(/D+/,n.day.toString().padStart(2,"0")).replace(/M+/,n.month.toString().padStart(2,"0")).replace(/Y+/,n.year.toString()).replace(/H+/,n.hour.toString().padStart(2,"0")).replace(/m+/,n.minute.toString().padStart(2,"0")).replace(/s+/,n.second.toString().padStart(2,"0")).replace(/A+/,n.hour>11?"PM":"AM")}return ""}getFilename(t,r){return t.replace("%DATE%",this.lastDate)+(this.settings.maxSize||this.fileIndx>0?"."+this.fileIndx:"")+(r||"")}getNewFilename(){return this.getFilename(this.settings.filename,this.settings.extension)}addBytes(t){this.currentSize+=t;}rotate(t=!1){return t?(this.fileIndx+=1,this.currentSize=0,this.lastDate=this.getDateString()):this.shouldRotate()&&(this.hasMaxSizeReached()?this.fileIndx+=1:this.fileIndx=0,this.currentSize=0,this.lastDate=this.getDateString()),this.getNewFilename()}static getDateComponents(t,r){return r?{day:t.getUTCDate(),month:t.getUTCMonth()+1,year:t.getUTCFullYear(),hour:t.getUTCHours(),minute:t.getUTCMinutes(),second:t.getUTCSeconds(),utc:r,source:t}:{day:t.getDate(),month:t.getMonth()+1,year:t.getFullYear(),hour:t.getHours(),minute:t.getMinutes(),second:t.getSeconds(),utc:r,source:t}}static createDate(t,r){return new Date(t.year,t.month,t.day,t.hour,t.minute,t.second)}};Ry.default=Ay;});var kk=A(Py=>{Object.defineProperty(Py,"__esModule",{value:!0});var eh=he("fs"),OJ=he("path"),BJ=Zu(),vi=Zf(),Iy=he("crypto"),Dy=class{constructor(t,r){this.config=t,this.emitter=r,this.loadLog();}loadLog(){var t;if(!this.config.keepSettings||((t=this.config.keepSettings)===null||t===void 0?void 0:t.amount)==0||!this.config.auditFilename||this.config.auditFilename==""){vi.Logger.verbose("no existing audit settings found",this.config);return}try{let r=OJ.resolve(this.config.auditFilename),n=JSON.parse(eh.readFileSync(r,{encoding:"utf-8"}));this.config.files=n.files;}catch(r){if(r.code!=="ENOENT"){vi.Logger.log("Failed to load config file",r);return}}}writeLog(){if(this.config.auditFilename)try{(0, vi.makeDirectory)(this.config.auditFilename),eh.writeFileSync(this.config.auditFilename,JSON.stringify(this.config,null,4));}catch(t){vi.Logger.verbose("ERROR: Failed to store log audit",t);}}addLog(t){var r;if(!this.config.keepSettings||((r=this.config.keepSettings)===null||r===void 0?void 0:r.amount)==0||!this.config.auditFilename||this.config.auditFilename==""){vi.Logger.verbose("audit log missing");return}if(this.config.files.findIndex(s=>s.name===t)!==-1){vi.Logger.debug("file already in the log",t);return}var n=Date.now();if(this.config.files.push({date:n,name:t,hash:Iy.createHash(this.config.hashType).update(t+"LOG_FILE"+n).digest("hex")}),vi.Logger.debug(`added file ${t} to log`),this.config.keepSettings&&this.config.keepSettings.amount){if(this.config.keepSettings.type==BJ.KeepLogFiles.days){let s=Date.now()-86400*this.config.keepSettings.amount*1e3,o=this.config.files.filter(a=>{if(a.date>=s)return !0;this.removeLog(a);});this.config.files=o;}else if(this.config.files.length>this.config.keepSettings.amount){var i=this.config.files.splice(-this.config.keepSettings.amount);this.config.files.length>0&&this.config.files.filter(s=>(this.removeLog(s),!1)),this.config.files=i;}}this.writeLog();}removeLog(t){if(t.hash===Iy.createHash(this.config.hashType).update(t.name+"LOG_FILE"+t.date).digest("hex"))try{eh.existsSync(t.name)&&(vi.Logger.debug("removing log file",t.name),eh.unlinkSync(t.name),this.emitter.emit("logRemoved",t.name));}catch{vi.Logger.verbose("Could not remove old log file: ",t.name);}else vi.Logger.debug("incorrect hash",t.name,t.hash,Iy.createHash(this.config.hashType).update(t.name+"LOG_FILE"+t.date).digest("hex"));}};Py.default=Dy;});var Lk=A(Ly=>{Object.defineProperty(Ly,"__esModule",{value:!0});var qJ=he("stream"),ma=he("fs"),ky=he("path"),Hi=Zu(),Wi=Ik(),Nk=Pk(),FJ=kk(),ec=Zf(),Ny=class e extends qJ.EventEmitter{constructor(t,r=!1){var n,i;super(),this.config={},this.config=this.parseOptions(t),ec.Logger.getInstance(t.verbose,r),this.auditManager=new FJ.default((n=this.config.auditSettings)!==null&&n!==void 0?n:Wi.default.auditSettings({}),this);let s=this.auditManager.config.files.slice(-1).shift();this.rotator=new Nk.default((i=this.config.rotationSettings)!==null&&i!==void 0?i:Wi.default.rotationSettings({}),s),this.rotate();}static getStream(t){return new e(t)}parseOptions(t){var r,n,i,s;let o={};o.options=Wi.default.fileStreamRotatorOptions(t),o.fileOptions=Wi.default.fileOptions((r=t.file_options)!==null&&r!==void 0?r:{});let a=Wi.default.auditSettings({});if(t.audit_file&&(a.auditFilename=t.audit_file),t.audit_hash_type&&(a.hashType=t.audit_hash_type),t.extension&&(a.extension=t.extension),t.max_logs){let l=Wi.default.extractParam(t.max_logs);a.keepSettings={type:((n=l.letter)===null||n===void 0?void 0:n.toLowerCase())=="d"?Hi.KeepLogFiles.days:Hi.KeepLogFiles.fileCount,amount:l.number};}switch(o.auditSettings=a,o.rotationSettings=Wi.default.rotationSettings({filename:t.filename,extension:t.extension}),t.date_format&&!t.frequency?o.rotationSettings.frequency=Hi.Frequency.date:o.rotationSettings.frequency=Hi.Frequency.none,t.date_format&&(o.rotationSettings.format=t.date_format),o.rotationSettings.utc=(i=t.utc)!==null&&i!==void 0?i:!1,t.frequency){case"daily":o.rotationSettings.frequency=Hi.Frequency.daily;break;case"custom":case"date":o.rotationSettings.frequency=Hi.Frequency.date;break;case"test":o.rotationSettings.frequency=Hi.Frequency.minutes,o.rotationSettings.amount=1;break;default:if(t.frequency){let l=Wi.default.extractParam(t.frequency);!((s=l.letter)===null||s===void 0)&&s.match(/^([mh])$/)&&(o.rotationSettings.frequency=l.letter=="h"?Hi.Frequency.hours:Hi.Frequency.minutes,o.rotationSettings.amount=l.number);}}if(t.size){let l=Wi.default.extractParam(t.size);switch(l.letter){case"k":o.rotationSettings.maxSize=l.number*1024;break;case"m":o.rotationSettings.maxSize=l.number*1024*1024;break;case"g":o.rotationSettings.maxSize=l.number*1024*1024*1024;break}}this.rotator=new Nk.default(o.rotationSettings);this.rotator.getNewFilename();return o}rotate(t=!1){var r;let n=this.currentFile;this.rotator.rotate(t),this.currentFile=this.rotator.getNewFilename(),this.currentFile!=n&&(this.fs&&(((r=this.config.options)===null||r===void 0?void 0:r.end_stream)===!0?this.fs.end():this.fs.destroy()),n&&this.auditManager.addLog(n),this.createNewLog(this.currentFile),this.emit("new",this.currentFile),this.emit("rotate",n,this.currentFile,t));}createNewLog(t){var r;(0, ec.makeDirectory)(t),this.auditManager.addLog(t);let n={};this.config.fileOptions&&(n=this.config.fileOptions),this.fs=ma.createWriteStream(t,n),this.bubbleEvents(this.fs,t),!((r=this.config.options)===null||r===void 0)&&r.create_symlink&&this.createCurrentSymLink(t);}write(t,r){this.fs&&(this.rotator.shouldRotate()&&this.rotate(),this.fs.write(t,r??"utf8"),this.rotator.addBytes(Buffer.byteLength(t,r)),this.rotator.hasMaxSizeReached()&&this.rotate());}end(t){this.fs&&(this.fs.end(t),this.fs=void 0);}bubbleEvents(t,r){t.on("close",()=>{this.emit("close");}),t.on("finish",()=>{this.emit("finish");}),t.on("error",n=>{this.emit("error",n);}),t.on("open",n=>{this.emit("open",r);});}createCurrentSymLink(t){var r,n;if(!t)return;let i=(n=(r=this.config.options)===null||r===void 0?void 0:r.symlink_name)!==null&&n!==void 0?n:"current.log",s=ky.dirname(t),o=ky.basename(t),a=s+ky.sep+i;try{if(ma.existsSync(a)){if(ma.lstatSync(a).isSymbolicLink()){ma.unlinkSync(a),ma.symlinkSync(o,a);return}ec.Logger.verbose("Could not create symlink file as file with the same name exists: ",a);}else ma.symlinkSync(o,a);}catch(c){ec.Logger.verbose("[Could not create symlink file: ",a," -> ",o),ec.Logger.debug("error creating sym link",a,c);}}test(){return {config:this.config,rotator:this.rotator}}};Ly.default=Ny;});var Ok=A(th=>{Object.defineProperty(th,"__esModule",{value:!0});th.getStream=void 0;var MJ=Lk();function UJ(e){return new MJ.default(e)}th.getStream=UJ;});var Uk=A((Cle,Mk)=>{Mk.exports=function(){function e(n,i){function s(){this.constructor=n;}s.prototype=i.prototype,n.prototype=new s;}function t(n,i,s,o,a,c){this.message=n,this.expected=i,this.found=s,this.offset=o,this.line=a,this.column=c,this.name="SyntaxError";}e(t,Error);function r(n){var i=arguments.length>1?arguments[1]:{},s={},o={start:zC},a=zC,l=function(){return hE},u=s,f="#",d={type:"literal",value:"#",description:'"#"'},p=void 0,m={type:"any",description:"any character"},S="[",x={type:"literal",value:"[",description:'"["'},I="]",v={type:"literal",value:"]",description:'"]"'},b=function(h){Np(_r("ObjectPath",h,xr,wr));},D=function(h){Np(_r("ArrayPath",h,xr,wr));},L=function(h,y){return h.concat(y)},j=function(h){return [h]},J=function(h){return h},K=".",G={type:"literal",value:".",description:'"."'},ee="=",M={type:"literal",value:"=",description:'"="'},ae=function(h,y){Np(_r("Assign",y,xr,wr,h));},me=function(h){return h.join("")},Le=function(h){return h.value},H='"""',W={type:"literal",value:'"""',description:'"\\"\\"\\""'},se=null,Te=function(h){return _r("String",h.join(""),xr,wr)},Fe='"',ze={type:"literal",value:'"',description:'"\\""'},He="'''",ct={type:"literal",value:"'''",description:`"'''"`},Lt="'",xt={type:"literal",value:"'",description:`"'"`},dt=function(h){return h},Oe=function(h){return h},Pt="\\",Ut={type:"literal",value:"\\",description:'"\\\\"'},ge=function(){return ""},je="e",ce={type:"literal",value:"e",description:'"e"'},Re="E",We={type:"literal",value:"E",description:'"E"'},nt=function(h,y){return _r("Float",parseFloat(h+"e"+y),xr,wr)},Ge=function(h){return _r("Float",parseFloat(h),xr,wr)},_n="+",Mr={type:"literal",value:"+",description:'"+"'},js=function(h){return h.join("")},Ur="-",Zr={type:"literal",value:"-",description:'"-"'},Vs=function(h){return "-"+h.join("")},Lo=function(h){return _r("Integer",parseInt(h,10),xr,wr)},hn="true",Hs={type:"literal",value:"true",description:'"true"'},Ws=function(){return _r("Boolean",!0,xr,wr)},Ni="false",Ks={type:"literal",value:"false",description:'"false"'},Kn=function(){return _r("Boolean",!1,xr,wr)},q=function(){return _r("Array",[],xr,wr)},ne=function(h){return _r("Array",h?[h]:[],xr,wr)},be=function(h){return _r("Array",h,xr,wr)},Pe=function(h,y){return _r("Array",h.concat(y),xr,wr)},wt=function(h){return h},yt=",",kt={type:"literal",value:",",description:'","'},Bt="{",it={type:"literal",value:"{",description:'"{"'},Rt="}",pt={type:"literal",value:"}",description:'"}"'},Wt=function(h){return _r("InlineTable",h,xr,wr)},er=function(h,y){return _r("InlineTableValue",y,xr,wr,h)},$r=function(h){return "."+h},Oo=function(h){return h.join("")},Zi=":",es={type:"literal",value:":",description:'":"'},nu=function(h){return h.join("")},iu="T",Xc={type:"literal",value:"T",description:'"T"'},Q="Z",_={type:"literal",value:"Z",description:'"Z"'},F=function(h,y){return _r("Date",new Date(h+"T"+y+"Z"),xr,wr)},U=function(h,y){return _r("Date",new Date(h+"T"+y),xr,wr)},P=/^[ \t]/,C={type:"class",value:"[ \\t]",description:"[ \\t]"},z=`
`,ie={type:"literal",value:`
`,description:'"\\n"'},Ye="\r",Kt={type:"literal",value:"\r",description:'"\\r"'},Nt=/^[0-9a-f]/i,dn={type:"class",value:"[0-9a-f]i",description:"[0-9a-f]i"},pn=/^[0-9]/,zn={type:"class",value:"[0-9]",description:"[0-9]"},st="_",ts={type:"literal",value:"_",description:'"_"'},Bo=function(){return ""},Jc=/^[A-Za-z0-9_\-]/,UM={type:"class",value:"[A-Za-z0-9_\\-]",description:"[A-Za-z0-9_\\-]"},$M=function(h){return h.join("")},qC='\\"',jM={type:"literal",value:'\\"',description:'"\\\\\\""'},VM=function(){return '"'},FC="\\\\",HM={type:"literal",value:"\\\\",description:'"\\\\\\\\"'},WM=function(){return "\\"},MC="\\b",KM={type:"literal",value:"\\b",description:'"\\\\b"'},zM=function(){return "\b"},UC="\\t",GM={type:"literal",value:"\\t",description:'"\\\\t"'},YM=function(){return "	"},$C="\\n",QM={type:"literal",value:"\\n",description:'"\\\\n"'},XM=function(){return `
`},jC="\\f",JM={type:"literal",value:"\\f",description:'"\\\\f"'},ZM=function(){return "\f"},VC="\\r",e5={type:"literal",value:"\\r",description:'"\\\\r"'},t5=function(){return "\r"},HC="\\U",r5={type:"literal",value:"\\U",description:'"\\\\U"'},WC=function(h){return E5(h.join(""))},KC="\\u",n5={type:"literal",value:"\\u",description:'"\\\\u"'},g=0,ke=0,su=0,Ap={line:1,column:1,seenCR:!1},Zc=0,Rp=[],ue=0,de={},el;if("startRule"in i){if(!(i.startRule in o))throw new Error(`Can't start parsing from rule "`+i.startRule+'".');a=o[i.startRule];}function xr(){return Ip(ke).line}function wr(){return Ip(ke).column}function Ip(h){function y(E,k,O){var X,re;for(X=k;X<O;X++)re=n.charAt(X),re===`
`?(E.seenCR||E.line++,E.column=1,E.seenCR=!1):re==="\r"||re==="\u2028"||re==="\u2029"?(E.line++,E.column=1,E.seenCR=!0):(E.column++,E.seenCR=!1);}return su!==h&&(su>h&&(su=0,Ap={line:1,column:1,seenCR:!1}),y(Ap,su,h),su=h),Ap}function ye(h){g<Zc||(g>Zc&&(Zc=g,Rp=[]),Rp.push(h));}function Dp(h,y,E){function k(_e){var Ke=1;for(_e.sort(function(It,bt){return It.description<bt.description?-1:It.description>bt.description?1:0});Ke<_e.length;)_e[Ke-1]===_e[Ke]?_e.splice(Ke,1):Ke++;}function O(_e,Ke){function It(Fo){function rs(mn){return mn.charCodeAt(0).toString(16).toUpperCase()}return Fo.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(mn){return "\\x0"+rs(mn)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(mn){return "\\x"+rs(mn)}).replace(/[\u0180-\u0FFF]/g,function(mn){return "\\u0"+rs(mn)}).replace(/[\u1080-\uFFFF]/g,function(mn){return "\\u"+rs(mn)})}var bt=new Array(_e.length),Yt,tr,gn;for(gn=0;gn<_e.length;gn++)bt[gn]=_e[gn].description;return Yt=_e.length>1?bt.slice(0,-1).join(", ")+" or "+bt[_e.length-1]:bt[0],tr=Ke?'"'+It(Ke)+'"':"end of input","Expected "+Yt+" but "+tr+" found."}var X=Ip(E),re=E<n.length?n.charAt(E):null;return y!==null&&k(y),new t(h!==null?h:O(y,re),y,re,E,X.line,X.column)}function zC(){var h,y,E,k=g*49+0,O=de[k];if(O)return g=O.nextPos,O.result;for(h=g,y=[],E=GC();E!==s;)y.push(E),E=GC();return y!==s&&(ke=h,y=l()),h=y,de[k]={nextPos:g,result:h},h}function GC(){var h,y,E,k,O,X,re,_e=g*49+1,Ke=de[_e];if(Ke)return g=Ke.nextPos,Ke.result;for(h=g,y=[],E=Ne();E!==s;)y.push(E),E=Ne();if(y!==s)if(E=i5(),E!==s){for(k=[],O=Ne();O!==s;)k.push(O),O=Ne();if(k!==s){for(O=[],X=tl();X!==s;)O.push(X),X=tl();if(O!==s){if(X=[],re=An(),re!==s)for(;re!==s;)X.push(re),re=An();else X=u;X===s&&(X=nl()),X!==s?(y=[y,E,k,O,X],h=y):(g=h,h=u);}else g=h,h=u;}else g=h,h=u;}else g=h,h=u;else g=h,h=u;if(h===s){if(h=g,y=[],E=Ne(),E!==s)for(;E!==s;)y.push(E),E=Ne();else y=u;if(y!==s){if(E=[],k=An(),k!==s)for(;k!==s;)E.push(k),k=An();else E=u;E===s&&(E=nl()),E!==s?(y=[y,E],h=y):(g=h,h=u);}else g=h,h=u;h===s&&(h=An());}return de[_e]={nextPos:g,result:h},h}function i5(){var h,y=g*49+2,E=de[y];return E?(g=E.nextPos,E.result):(h=tl(),h===s&&(h=s5(),h===s&&(h=o5(),h===s&&(h=a5()))),de[y]={nextPos:g,result:h},h)}function tl(){var h,y,E,k,O,X,re=g*49+3,_e=de[re];if(_e)return g=_e.nextPos,_e.result;if(h=g,n.charCodeAt(g)===35?(y=f,g++):(y=s,ue===0&&ye(d)),y!==s){for(E=[],k=g,O=g,ue++,X=An(),X===s&&(X=nl()),ue--,X===s?O=p:(g=O,O=u),O!==s?(n.length>g?(X=n.charAt(g),g++):(X=s,ue===0&&ye(m)),X!==s?(O=[O,X],k=O):(g=k,k=u)):(g=k,k=u);k!==s;)E.push(k),k=g,O=g,ue++,X=An(),X===s&&(X=nl()),ue--,X===s?O=p:(g=O,O=u),O!==s?(n.length>g?(X=n.charAt(g),g++):(X=s,ue===0&&ye(m)),X!==s?(O=[O,X],k=O):(g=k,k=u)):(g=k,k=u);E!==s?(y=[y,E],h=y):(g=h,h=u);}else g=h,h=u;return de[re]={nextPos:g,result:h},h}function s5(){var h,y,E,k,O,X,re=g*49+4,_e=de[re];if(_e)return g=_e.nextPos,_e.result;if(h=g,n.charCodeAt(g)===91?(y=S,g++):(y=s,ue===0&&ye(x)),y!==s){for(E=[],k=Ne();k!==s;)E.push(k),k=Ne();if(E!==s)if(k=YC(),k!==s){for(O=[],X=Ne();X!==s;)O.push(X),X=Ne();O!==s?(n.charCodeAt(g)===93?(X=I,g++):(X=s,ue===0&&ye(v)),X!==s?(ke=h,y=b(k),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;else g=h,h=u;}else g=h,h=u;return de[re]={nextPos:g,result:h},h}function o5(){var h,y,E,k,O,X,re,_e,Ke=g*49+5,It=de[Ke];if(It)return g=It.nextPos,It.result;if(h=g,n.charCodeAt(g)===91?(y=S,g++):(y=s,ue===0&&ye(x)),y!==s)if(n.charCodeAt(g)===91?(E=S,g++):(E=s,ue===0&&ye(x)),E!==s){for(k=[],O=Ne();O!==s;)k.push(O),O=Ne();if(k!==s)if(O=YC(),O!==s){for(X=[],re=Ne();re!==s;)X.push(re),re=Ne();X!==s?(n.charCodeAt(g)===93?(re=I,g++):(re=s,ue===0&&ye(v)),re!==s?(n.charCodeAt(g)===93?(_e=I,g++):(_e=s,ue===0&&ye(v)),_e!==s?(ke=h,y=D(O),h=y):(g=h,h=u)):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;else g=h,h=u;}else g=h,h=u;else g=h,h=u;return de[Ke]={nextPos:g,result:h},h}function YC(){var h,y,E,k=g*49+6,O=de[k];if(O)return g=O.nextPos,O.result;if(h=g,y=[],E=XC(),E!==s)for(;E!==s;)y.push(E),E=XC();else y=u;return y!==s?(E=QC(),E!==s?(ke=h,y=L(y,E),h=y):(g=h,h=u)):(g=h,h=u),h===s&&(h=g,y=QC(),y!==s&&(ke=h,y=j(y)),h=y),de[k]={nextPos:g,result:h},h}function QC(){var h,y,E,k,O,X=g*49+7,re=de[X];if(re)return g=re.nextPos,re.result;for(h=g,y=[],E=Ne();E!==s;)y.push(E),E=Ne();if(y!==s)if(E=ou(),E!==s){for(k=[],O=Ne();O!==s;)k.push(O),O=Ne();k!==s?(ke=h,y=J(E),h=y):(g=h,h=u);}else g=h,h=u;else g=h,h=u;if(h===s){for(h=g,y=[],E=Ne();E!==s;)y.push(E),E=Ne();if(y!==s)if(E=Pp(),E!==s){for(k=[],O=Ne();O!==s;)k.push(O),O=Ne();k!==s?(ke=h,y=J(E),h=y):(g=h,h=u);}else g=h,h=u;else g=h,h=u;}return de[X]={nextPos:g,result:h},h}function XC(){var h,y,E,k,O,X,re,_e=g*49+8,Ke=de[_e];if(Ke)return g=Ke.nextPos,Ke.result;for(h=g,y=[],E=Ne();E!==s;)y.push(E),E=Ne();if(y!==s)if(E=ou(),E!==s){for(k=[],O=Ne();O!==s;)k.push(O),O=Ne();if(k!==s)if(n.charCodeAt(g)===46?(O=K,g++):(O=s,ue===0&&ye(G)),O!==s){for(X=[],re=Ne();re!==s;)X.push(re),re=Ne();X!==s?(ke=h,y=J(E),h=y):(g=h,h=u);}else g=h,h=u;else g=h,h=u;}else g=h,h=u;else g=h,h=u;if(h===s){for(h=g,y=[],E=Ne();E!==s;)y.push(E),E=Ne();if(y!==s)if(E=Pp(),E!==s){for(k=[],O=Ne();O!==s;)k.push(O),O=Ne();if(k!==s)if(n.charCodeAt(g)===46?(O=K,g++):(O=s,ue===0&&ye(G)),O!==s){for(X=[],re=Ne();re!==s;)X.push(re),re=Ne();X!==s?(ke=h,y=J(E),h=y):(g=h,h=u);}else g=h,h=u;else g=h,h=u;}else g=h,h=u;else g=h,h=u;}return de[_e]={nextPos:g,result:h},h}function a5(){var h,y,E,k,O,X,re=g*49+9,_e=de[re];if(_e)return g=_e.nextPos,_e.result;if(h=g,y=ou(),y!==s){for(E=[],k=Ne();k!==s;)E.push(k),k=Ne();if(E!==s)if(n.charCodeAt(g)===61?(k=ee,g++):(k=s,ue===0&&ye(M)),k!==s){for(O=[],X=Ne();X!==s;)O.push(X),X=Ne();O!==s?(X=qo(),X!==s?(ke=h,y=ae(y,X),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;else g=h,h=u;}else g=h,h=u;if(h===s)if(h=g,y=Pp(),y!==s){for(E=[],k=Ne();k!==s;)E.push(k),k=Ne();if(E!==s)if(n.charCodeAt(g)===61?(k=ee,g++):(k=s,ue===0&&ye(M)),k!==s){for(O=[],X=Ne();X!==s;)O.push(X),X=Ne();O!==s?(X=qo(),X!==s?(ke=h,y=ae(y,X),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;else g=h,h=u;}else g=h,h=u;return de[re]={nextPos:g,result:h},h}function ou(){var h,y,E,k=g*49+10,O=de[k];if(O)return g=O.nextPos,O.result;if(h=g,y=[],E=lE(),E!==s)for(;E!==s;)y.push(E),E=lE();else y=u;return y!==s&&(ke=h,y=me(y)),h=y,de[k]={nextPos:g,result:h},h}function Pp(){var h,y,E=g*49+11,k=de[E];return k?(g=k.nextPos,k.result):(h=g,y=JC(),y!==s&&(ke=h,y=Le(y)),h=y,h===s&&(h=g,y=ZC(),y!==s&&(ke=h,y=Le(y)),h=y),de[E]={nextPos:g,result:h},h)}function qo(){var h,y=g*49+12,E=de[y];return E?(g=E.nextPos,E.result):(h=u5(),h===s&&(h=S5(),h===s&&(h=h5(),h===s&&(h=d5(),h===s&&(h=p5(),h===s&&(h=g5(),h===s&&(h=m5())))))),de[y]={nextPos:g,result:h},h)}function u5(){var h,y=g*49+13,E=de[y];return E?(g=E.nextPos,E.result):(h=c5(),h===s&&(h=JC(),h===s&&(h=l5(),h===s&&(h=ZC()))),de[y]={nextPos:g,result:h},h)}function c5(){var h,y,E,k,O,X=g*49+14,re=de[X];if(re)return g=re.nextPos,re.result;if(h=g,n.substr(g,3)===H?(y=H,g+=3):(y=s,ue===0&&ye(W)),y!==s)if(E=An(),E===s&&(E=se),E!==s){for(k=[],O=rE();O!==s;)k.push(O),O=rE();k!==s?(n.substr(g,3)===H?(O=H,g+=3):(O=s,ue===0&&ye(W)),O!==s?(ke=h,y=Te(k),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;else g=h,h=u;return de[X]={nextPos:g,result:h},h}function JC(){var h,y,E,k,O=g*49+15,X=de[O];if(X)return g=X.nextPos,X.result;if(h=g,n.charCodeAt(g)===34?(y=Fe,g++):(y=s,ue===0&&ye(ze)),y!==s){for(E=[],k=eE();k!==s;)E.push(k),k=eE();E!==s?(n.charCodeAt(g)===34?(k=Fe,g++):(k=s,ue===0&&ye(ze)),k!==s?(ke=h,y=Te(E),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;return de[O]={nextPos:g,result:h},h}function l5(){var h,y,E,k,O,X=g*49+16,re=de[X];if(re)return g=re.nextPos,re.result;if(h=g,n.substr(g,3)===He?(y=He,g+=3):(y=s,ue===0&&ye(ct)),y!==s)if(E=An(),E===s&&(E=se),E!==s){for(k=[],O=nE();O!==s;)k.push(O),O=nE();k!==s?(n.substr(g,3)===He?(O=He,g+=3):(O=s,ue===0&&ye(ct)),O!==s?(ke=h,y=Te(k),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;else g=h,h=u;return de[X]={nextPos:g,result:h},h}function ZC(){var h,y,E,k,O=g*49+17,X=de[O];if(X)return g=X.nextPos,X.result;if(h=g,n.charCodeAt(g)===39?(y=Lt,g++):(y=s,ue===0&&ye(xt)),y!==s){for(E=[],k=tE();k!==s;)E.push(k),k=tE();E!==s?(n.charCodeAt(g)===39?(k=Lt,g++):(k=s,ue===0&&ye(xt)),k!==s?(ke=h,y=Te(E),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;return de[O]={nextPos:g,result:h},h}function eE(){var h,y,E,k=g*49+18,O=de[k];return O?(g=O.nextPos,O.result):(h=fE(),h===s&&(h=g,y=g,ue++,n.charCodeAt(g)===34?(E=Fe,g++):(E=s,ue===0&&ye(ze)),ue--,E===s?y=p:(g=y,y=u),y!==s?(n.length>g?(E=n.charAt(g),g++):(E=s,ue===0&&ye(m)),E!==s?(ke=h,y=dt(E),h=y):(g=h,h=u)):(g=h,h=u)),de[k]={nextPos:g,result:h},h)}function tE(){var h,y,E,k=g*49+19,O=de[k];return O?(g=O.nextPos,O.result):(h=g,y=g,ue++,n.charCodeAt(g)===39?(E=Lt,g++):(E=s,ue===0&&ye(xt)),ue--,E===s?y=p:(g=y,y=u),y!==s?(n.length>g?(E=n.charAt(g),g++):(E=s,ue===0&&ye(m)),E!==s?(ke=h,y=dt(E),h=y):(g=h,h=u)):(g=h,h=u),de[k]={nextPos:g,result:h},h)}function rE(){var h,y,E,k=g*49+20,O=de[k];return O?(g=O.nextPos,O.result):(h=fE(),h===s&&(h=f5(),h===s&&(h=g,y=g,ue++,n.substr(g,3)===H?(E=H,g+=3):(E=s,ue===0&&ye(W)),ue--,E===s?y=p:(g=y,y=u),y!==s?(n.length>g?(E=n.charAt(g),g++):(E=s,ue===0&&ye(m)),E!==s?(ke=h,y=Oe(E),h=y):(g=h,h=u)):(g=h,h=u))),de[k]={nextPos:g,result:h},h)}function f5(){var h,y,E,k,O,X=g*49+21,re=de[X];if(re)return g=re.nextPos,re.result;if(h=g,n.charCodeAt(g)===92?(y=Pt,g++):(y=s,ue===0&&ye(Ut)),y!==s)if(E=An(),E!==s){for(k=[],O=cE();O!==s;)k.push(O),O=cE();k!==s?(ke=h,y=ge(),h=y):(g=h,h=u);}else g=h,h=u;else g=h,h=u;return de[X]={nextPos:g,result:h},h}function nE(){var h,y,E,k=g*49+22,O=de[k];return O?(g=O.nextPos,O.result):(h=g,y=g,ue++,n.substr(g,3)===He?(E=He,g+=3):(E=s,ue===0&&ye(ct)),ue--,E===s?y=p:(g=y,y=u),y!==s?(n.length>g?(E=n.charAt(g),g++):(E=s,ue===0&&ye(m)),E!==s?(ke=h,y=dt(E),h=y):(g=h,h=u)):(g=h,h=u),de[k]={nextPos:g,result:h},h)}function h5(){var h,y,E,k,O=g*49+23,X=de[O];return X?(g=X.nextPos,X.result):(h=g,y=iE(),y===s&&(y=kp()),y!==s?(n.charCodeAt(g)===101?(E=je,g++):(E=s,ue===0&&ye(ce)),E===s&&(n.charCodeAt(g)===69?(E=Re,g++):(E=s,ue===0&&ye(We))),E!==s?(k=kp(),k!==s?(ke=h,y=nt(y,k),h=y):(g=h,h=u)):(g=h,h=u)):(g=h,h=u),h===s&&(h=g,y=iE(),y!==s&&(ke=h,y=Ge(y)),h=y),de[O]={nextPos:g,result:h},h)}function iE(){var h,y,E,k,O,X,re=g*49+24,_e=de[re];return _e?(g=_e.nextPos,_e.result):(h=g,n.charCodeAt(g)===43?(y=_n,g++):(y=s,ue===0&&ye(Mr)),y===s&&(y=se),y!==s?(E=g,k=au(),k!==s?(n.charCodeAt(g)===46?(O=K,g++):(O=s,ue===0&&ye(G)),O!==s?(X=au(),X!==s?(k=[k,O,X],E=k):(g=E,E=u)):(g=E,E=u)):(g=E,E=u),E!==s?(ke=h,y=js(E),h=y):(g=h,h=u)):(g=h,h=u),h===s&&(h=g,n.charCodeAt(g)===45?(y=Ur,g++):(y=s,ue===0&&ye(Zr)),y!==s?(E=g,k=au(),k!==s?(n.charCodeAt(g)===46?(O=K,g++):(O=s,ue===0&&ye(G)),O!==s?(X=au(),X!==s?(k=[k,O,X],E=k):(g=E,E=u)):(g=E,E=u)):(g=E,E=u),E!==s?(ke=h,y=Vs(E),h=y):(g=h,h=u)):(g=h,h=u)),de[re]={nextPos:g,result:h},h)}function d5(){var h,y,E=g*49+25,k=de[E];return k?(g=k.nextPos,k.result):(h=g,y=kp(),y!==s&&(ke=h,y=Lo(y)),h=y,de[E]={nextPos:g,result:h},h)}function kp(){var h,y,E,k,O,X=g*49+26,re=de[X];if(re)return g=re.nextPos,re.result;if(h=g,n.charCodeAt(g)===43?(y=_n,g++):(y=s,ue===0&&ye(Mr)),y===s&&(y=se),y!==s){if(E=[],k=Tt(),k!==s)for(;k!==s;)E.push(k),k=Tt();else E=u;E!==s?(k=g,ue++,n.charCodeAt(g)===46?(O=K,g++):(O=s,ue===0&&ye(G)),ue--,O===s?k=p:(g=k,k=u),k!==s?(ke=h,y=js(E),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;if(h===s)if(h=g,n.charCodeAt(g)===45?(y=Ur,g++):(y=s,ue===0&&ye(Zr)),y!==s){if(E=[],k=Tt(),k!==s)for(;k!==s;)E.push(k),k=Tt();else E=u;E!==s?(k=g,ue++,n.charCodeAt(g)===46?(O=K,g++):(O=s,ue===0&&ye(G)),ue--,O===s?k=p:(g=k,k=u),k!==s?(ke=h,y=Vs(E),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;return de[X]={nextPos:g,result:h},h}function p5(){var h,y,E=g*49+27,k=de[E];return k?(g=k.nextPos,k.result):(h=g,n.substr(g,4)===hn?(y=hn,g+=4):(y=s,ue===0&&ye(Hs)),y!==s&&(ke=h,y=Ws()),h=y,h===s&&(h=g,n.substr(g,5)===Ni?(y=Ni,g+=5):(y=s,ue===0&&ye(Ks)),y!==s&&(ke=h,y=Kn()),h=y),de[E]={nextPos:g,result:h},h)}function g5(){var h,y,E,k,O,X=g*49+28,re=de[X];if(re)return g=re.nextPos,re.result;if(h=g,n.charCodeAt(g)===91?(y=S,g++):(y=s,ue===0&&ye(x)),y!==s){for(E=[],k=Tn();k!==s;)E.push(k),k=Tn();E!==s?(n.charCodeAt(g)===93?(k=I,g++):(k=s,ue===0&&ye(v)),k!==s?(ke=h,y=q(),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;if(h===s&&(h=g,n.charCodeAt(g)===91?(y=S,g++):(y=s,ue===0&&ye(x)),y!==s?(E=sE(),E===s&&(E=se),E!==s?(n.charCodeAt(g)===93?(k=I,g++):(k=s,ue===0&&ye(v)),k!==s?(ke=h,y=ne(E),h=y):(g=h,h=u)):(g=h,h=u)):(g=h,h=u),h===s)){if(h=g,n.charCodeAt(g)===91?(y=S,g++):(y=s,ue===0&&ye(x)),y!==s){if(E=[],k=rl(),k!==s)for(;k!==s;)E.push(k),k=rl();else E=u;E!==s?(n.charCodeAt(g)===93?(k=I,g++):(k=s,ue===0&&ye(v)),k!==s?(ke=h,y=be(E),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;if(h===s)if(h=g,n.charCodeAt(g)===91?(y=S,g++):(y=s,ue===0&&ye(x)),y!==s){if(E=[],k=rl(),k!==s)for(;k!==s;)E.push(k),k=rl();else E=u;E!==s?(k=sE(),k!==s?(n.charCodeAt(g)===93?(O=I,g++):(O=s,ue===0&&ye(v)),O!==s?(ke=h,y=Pe(E,k),h=y):(g=h,h=u)):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;}return de[X]={nextPos:g,result:h},h}function sE(){var h,y,E,k,O,X=g*49+29,re=de[X];if(re)return g=re.nextPos,re.result;for(h=g,y=[],E=Tn();E!==s;)y.push(E),E=Tn();if(y!==s)if(E=qo(),E!==s){for(k=[],O=Tn();O!==s;)k.push(O),O=Tn();k!==s?(ke=h,y=wt(E),h=y):(g=h,h=u);}else g=h,h=u;else g=h,h=u;return de[X]={nextPos:g,result:h},h}function rl(){var h,y,E,k,O,X,re,_e=g*49+30,Ke=de[_e];if(Ke)return g=Ke.nextPos,Ke.result;for(h=g,y=[],E=Tn();E!==s;)y.push(E),E=Tn();if(y!==s)if(E=qo(),E!==s){for(k=[],O=Tn();O!==s;)k.push(O),O=Tn();if(k!==s)if(n.charCodeAt(g)===44?(O=yt,g++):(O=s,ue===0&&ye(kt)),O!==s){for(X=[],re=Tn();re!==s;)X.push(re),re=Tn();X!==s?(ke=h,y=wt(E),h=y):(g=h,h=u);}else g=h,h=u;else g=h,h=u;}else g=h,h=u;else g=h,h=u;return de[_e]={nextPos:g,result:h},h}function Tn(){var h,y=g*49+31,E=de[y];return E?(g=E.nextPos,E.result):(h=Ne(),h===s&&(h=An(),h===s&&(h=tl())),de[y]={nextPos:g,result:h},h)}function m5(){var h,y,E,k,O,X,re=g*49+32,_e=de[re];if(_e)return g=_e.nextPos,_e.result;if(h=g,n.charCodeAt(g)===123?(y=Bt,g++):(y=s,ue===0&&ye(it)),y!==s){for(E=[],k=Ne();k!==s;)E.push(k),k=Ne();if(E!==s){for(k=[],O=oE();O!==s;)k.push(O),O=oE();if(k!==s){for(O=[],X=Ne();X!==s;)O.push(X),X=Ne();O!==s?(n.charCodeAt(g)===125?(X=Rt,g++):(X=s,ue===0&&ye(pt)),X!==s?(ke=h,y=Wt(k),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;}else g=h,h=u;}else g=h,h=u;return de[re]={nextPos:g,result:h},h}function oE(){var h,y,E,k,O,X,re,_e,Ke,It,bt,Yt=g*49+33,tr=de[Yt];if(tr)return g=tr.nextPos,tr.result;for(h=g,y=[],E=Ne();E!==s;)y.push(E),E=Ne();if(y!==s)if(E=ou(),E!==s){for(k=[],O=Ne();O!==s;)k.push(O),O=Ne();if(k!==s)if(n.charCodeAt(g)===61?(O=ee,g++):(O=s,ue===0&&ye(M)),O!==s){for(X=[],re=Ne();re!==s;)X.push(re),re=Ne();if(X!==s)if(re=qo(),re!==s){for(_e=[],Ke=Ne();Ke!==s;)_e.push(Ke),Ke=Ne();if(_e!==s)if(n.charCodeAt(g)===44?(Ke=yt,g++):(Ke=s,ue===0&&ye(kt)),Ke!==s){for(It=[],bt=Ne();bt!==s;)It.push(bt),bt=Ne();It!==s?(ke=h,y=er(E,re),h=y):(g=h,h=u);}else g=h,h=u;else g=h,h=u;}else g=h,h=u;else g=h,h=u;}else g=h,h=u;else g=h,h=u;}else g=h,h=u;else g=h,h=u;if(h===s){for(h=g,y=[],E=Ne();E!==s;)y.push(E),E=Ne();if(y!==s)if(E=ou(),E!==s){for(k=[],O=Ne();O!==s;)k.push(O),O=Ne();if(k!==s)if(n.charCodeAt(g)===61?(O=ee,g++):(O=s,ue===0&&ye(M)),O!==s){for(X=[],re=Ne();re!==s;)X.push(re),re=Ne();X!==s?(re=qo(),re!==s?(ke=h,y=er(E,re),h=y):(g=h,h=u)):(g=h,h=u);}else g=h,h=u;else g=h,h=u;}else g=h,h=u;else g=h,h=u;}return de[Yt]={nextPos:g,result:h},h}function aE(){var h,y,E,k=g*49+34,O=de[k];return O?(g=O.nextPos,O.result):(h=g,n.charCodeAt(g)===46?(y=K,g++):(y=s,ue===0&&ye(G)),y!==s?(E=au(),E!==s?(ke=h,y=$r(E),h=y):(g=h,h=u)):(g=h,h=u),de[k]={nextPos:g,result:h},h)}function uE(){var h,y,E,k,O,X,re,_e,Ke,It,bt,Yt,tr=g*49+35,gn=de[tr];return gn?(g=gn.nextPos,gn.result):(h=g,y=g,E=Tt(),E!==s?(k=Tt(),k!==s?(O=Tt(),O!==s?(X=Tt(),X!==s?(n.charCodeAt(g)===45?(re=Ur,g++):(re=s,ue===0&&ye(Zr)),re!==s?(_e=Tt(),_e!==s?(Ke=Tt(),Ke!==s?(n.charCodeAt(g)===45?(It=Ur,g++):(It=s,ue===0&&ye(Zr)),It!==s?(bt=Tt(),bt!==s?(Yt=Tt(),Yt!==s?(E=[E,k,O,X,re,_e,Ke,It,bt,Yt],y=E):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u),y!==s&&(ke=h,y=Oo(y)),h=y,de[tr]={nextPos:g,result:h},h)}function y5(){var h,y,E,k,O,X,re,_e,Ke,It,bt,Yt=g*49+36,tr=de[Yt];return tr?(g=tr.nextPos,tr.result):(h=g,y=g,E=Tt(),E!==s?(k=Tt(),k!==s?(n.charCodeAt(g)===58?(O=Zi,g++):(O=s,ue===0&&ye(es)),O!==s?(X=Tt(),X!==s?(re=Tt(),re!==s?(n.charCodeAt(g)===58?(_e=Zi,g++):(_e=s,ue===0&&ye(es)),_e!==s?(Ke=Tt(),Ke!==s?(It=Tt(),It!==s?(bt=aE(),bt===s&&(bt=se),bt!==s?(E=[E,k,O,X,re,_e,Ke,It,bt],y=E):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u),y!==s&&(ke=h,y=nu(y)),h=y,de[Yt]={nextPos:g,result:h},h)}function v5(){var h,y,E,k,O,X,re,_e,Ke,It,bt,Yt,tr,gn,Fo,rs,mn,dE=g*49+37,Lp=de[dE];return Lp?(g=Lp.nextPos,Lp.result):(h=g,y=g,E=Tt(),E!==s?(k=Tt(),k!==s?(n.charCodeAt(g)===58?(O=Zi,g++):(O=s,ue===0&&ye(es)),O!==s?(X=Tt(),X!==s?(re=Tt(),re!==s?(n.charCodeAt(g)===58?(_e=Zi,g++):(_e=s,ue===0&&ye(es)),_e!==s?(Ke=Tt(),Ke!==s?(It=Tt(),It!==s?(bt=aE(),bt===s&&(bt=se),bt!==s?(n.charCodeAt(g)===45?(Yt=Ur,g++):(Yt=s,ue===0&&ye(Zr)),Yt===s&&(n.charCodeAt(g)===43?(Yt=_n,g++):(Yt=s,ue===0&&ye(Mr))),Yt!==s?(tr=Tt(),tr!==s?(gn=Tt(),gn!==s?(n.charCodeAt(g)===58?(Fo=Zi,g++):(Fo=s,ue===0&&ye(es)),Fo!==s?(rs=Tt(),rs!==s?(mn=Tt(),mn!==s?(E=[E,k,O,X,re,_e,Ke,It,bt,Yt,tr,gn,Fo,rs,mn],y=E):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u)):(g=y,y=u),y!==s&&(ke=h,y=nu(y)),h=y,de[dE]={nextPos:g,result:h},h)}function S5(){var h,y,E,k,O,X=g*49+38,re=de[X];return re?(g=re.nextPos,re.result):(h=g,y=uE(),y!==s?(n.charCodeAt(g)===84?(E=iu,g++):(E=s,ue===0&&ye(Xc)),E!==s?(k=y5(),k!==s?(n.charCodeAt(g)===90?(O=Q,g++):(O=s,ue===0&&ye(_)),O!==s?(ke=h,y=F(y,k),h=y):(g=h,h=u)):(g=h,h=u)):(g=h,h=u)):(g=h,h=u),h===s&&(h=g,y=uE(),y!==s?(n.charCodeAt(g)===84?(E=iu,g++):(E=s,ue===0&&ye(Xc)),E!==s?(k=v5(),k!==s?(ke=h,y=U(y,k),h=y):(g=h,h=u)):(g=h,h=u)):(g=h,h=u)),de[X]={nextPos:g,result:h},h)}function Ne(){var h,y=g*49+39,E=de[y];return E?(g=E.nextPos,E.result):(P.test(n.charAt(g))?(h=n.charAt(g),g++):(h=s,ue===0&&ye(C)),de[y]={nextPos:g,result:h},h)}function An(){var h,y,E,k=g*49+40,O=de[k];return O?(g=O.nextPos,O.result):(n.charCodeAt(g)===10?(h=z,g++):(h=s,ue===0&&ye(ie)),h===s&&(h=g,n.charCodeAt(g)===13?(y=Ye,g++):(y=s,ue===0&&ye(Kt)),y!==s?(n.charCodeAt(g)===10?(E=z,g++):(E=s,ue===0&&ye(ie)),E!==s?(y=[y,E],h=y):(g=h,h=u)):(g=h,h=u)),de[k]={nextPos:g,result:h},h)}function cE(){var h,y=g*49+41,E=de[y];return E?(g=E.nextPos,E.result):(h=An(),h===s&&(h=Ne()),de[y]={nextPos:g,result:h},h)}function nl(){var h,y,E=g*49+42,k=de[E];return k?(g=k.nextPos,k.result):(h=g,ue++,n.length>g?(y=n.charAt(g),g++):(y=s,ue===0&&ye(m)),ue--,y===s?h=p:(g=h,h=u),de[E]={nextPos:g,result:h},h)}function Rn(){var h,y=g*49+43,E=de[y];return E?(g=E.nextPos,E.result):(Nt.test(n.charAt(g))?(h=n.charAt(g),g++):(h=s,ue===0&&ye(dn)),de[y]={nextPos:g,result:h},h)}function Tt(){var h,y,E=g*49+44,k=de[E];return k?(g=k.nextPos,k.result):(pn.test(n.charAt(g))?(h=n.charAt(g),g++):(h=s,ue===0&&ye(zn)),h===s&&(h=g,n.charCodeAt(g)===95?(y=st,g++):(y=s,ue===0&&ye(ts)),y!==s&&(ke=h,y=Bo()),h=y),de[E]={nextPos:g,result:h},h)}function lE(){var h,y=g*49+45,E=de[y];return E?(g=E.nextPos,E.result):(Jc.test(n.charAt(g))?(h=n.charAt(g),g++):(h=s,ue===0&&ye(UM)),de[y]={nextPos:g,result:h},h)}function au(){var h,y,E,k=g*49+46,O=de[k];if(O)return g=O.nextPos,O.result;if(h=g,y=[],E=Tt(),E!==s)for(;E!==s;)y.push(E),E=Tt();else y=u;return y!==s&&(ke=h,y=$M(y)),h=y,de[k]={nextPos:g,result:h},h}function fE(){var h,y,E=g*49+47,k=de[E];return k?(g=k.nextPos,k.result):(h=g,n.substr(g,2)===qC?(y=qC,g+=2):(y=s,ue===0&&ye(jM)),y!==s&&(ke=h,y=VM()),h=y,h===s&&(h=g,n.substr(g,2)===FC?(y=FC,g+=2):(y=s,ue===0&&ye(HM)),y!==s&&(ke=h,y=WM()),h=y,h===s&&(h=g,n.substr(g,2)===MC?(y=MC,g+=2):(y=s,ue===0&&ye(KM)),y!==s&&(ke=h,y=zM()),h=y,h===s&&(h=g,n.substr(g,2)===UC?(y=UC,g+=2):(y=s,ue===0&&ye(GM)),y!==s&&(ke=h,y=YM()),h=y,h===s&&(h=g,n.substr(g,2)===$C?(y=$C,g+=2):(y=s,ue===0&&ye(QM)),y!==s&&(ke=h,y=XM()),h=y,h===s&&(h=g,n.substr(g,2)===jC?(y=jC,g+=2):(y=s,ue===0&&ye(JM)),y!==s&&(ke=h,y=ZM()),h=y,h===s&&(h=g,n.substr(g,2)===VC?(y=VC,g+=2):(y=s,ue===0&&ye(e5)),y!==s&&(ke=h,y=t5()),h=y,h===s&&(h=b5()))))))),de[E]={nextPos:g,result:h},h)}function b5(){var h,y,E,k,O,X,re,_e,Ke,It,bt,Yt=g*49+48,tr=de[Yt];return tr?(g=tr.nextPos,tr.result):(h=g,n.substr(g,2)===HC?(y=HC,g+=2):(y=s,ue===0&&ye(r5)),y!==s?(E=g,k=Rn(),k!==s?(O=Rn(),O!==s?(X=Rn(),X!==s?(re=Rn(),re!==s?(_e=Rn(),_e!==s?(Ke=Rn(),Ke!==s?(It=Rn(),It!==s?(bt=Rn(),bt!==s?(k=[k,O,X,re,_e,Ke,It,bt],E=k):(g=E,E=u)):(g=E,E=u)):(g=E,E=u)):(g=E,E=u)):(g=E,E=u)):(g=E,E=u)):(g=E,E=u)):(g=E,E=u),E!==s?(ke=h,y=WC(E),h=y):(g=h,h=u)):(g=h,h=u),h===s&&(h=g,n.substr(g,2)===KC?(y=KC,g+=2):(y=s,ue===0&&ye(n5)),y!==s?(E=g,k=Rn(),k!==s?(O=Rn(),O!==s?(X=Rn(),X!==s?(re=Rn(),re!==s?(k=[k,O,X,re],E=k):(g=E,E=u)):(g=E,E=u)):(g=E,E=u)):(g=E,E=u),E!==s?(ke=h,y=WC(E),h=y):(g=h,h=u)):(g=h,h=u)),de[Yt]={nextPos:g,result:h},h)}var hE=[];function C5(h,y,E){var k=new Error(h);throw k.line=y,k.column=E,k}function Np(h){hE.push(h);}function _r(h,y,E,k,O){var X={type:h,value:y,line:E(),column:k()};return O&&(X.key=O),X}function E5(h,y,E){var k=parseInt("0x"+h);if(!isFinite(k)||Math.floor(k)!=k||k<0||k>1114111||k>55295&&k<57344)C5("Invalid Unicode escape code: "+h,y,E);else return x5(k)}function x5(){var h=16384,y=[],E,k,O=-1,X=arguments.length;if(!X)return "";for(var re="";++O<X;){var _e=Number(arguments[O]);_e<=65535?y.push(_e):(_e-=65536,E=(_e>>10)+55296,k=_e%1024+56320,y.push(E,k)),(O+1==X||y.length>h)&&(re+=String.fromCharCode.apply(null,y),y.length=0);}return re}if(el=a(),el!==s&&g===n.length)return el;throw el!==s&&g<n.length&&ye({type:"end",description:"end of input"}),Dp(null,Rp,Zc)}return {SyntaxError:t,parse:r}}();});var jk=A((Ele,$k)=>{function WJ(e){var t=[],r=[],n="",i=Object.create(null),s=i;return a(e);function a(v){for(var b,D=0;D<v.length;D++)switch(b=v[D],b.type){case"Assign":l(b);break;case"ObjectPath":p(b);break;case"ArrayPath":m(b);break}return i}function c(v,b,D){var L=new Error(v);throw L.line=b,L.column=D,L}function l(v){var b=v.key,D=v.value,L=v.line,j=v.column,J;n?J=n+"."+b:J=b,typeof s[b]<"u"&&c("Cannot redefine existing key '"+J+"'.",L,j),s[b]=f(D),u(J)||(t.push(J),r.push(J));}function u(v){return t.indexOf(v)!==-1}function f(v){return v.type==="Array"?x(v.value):v.type==="InlineTable"?d(v.value):v.value}function d(v){for(var b=Object.create(null),D=0;D<v.length;D++){var L=v[D];L.value.type==="InlineTable"?b[L.key]=d(L.value.value):L.type==="InlineTableValue"&&(b[L.key]=f(L.value));}return b}function p(v){var b=v.value,D=b.map(I).join("."),L=v.line,j=v.column;u(D)&&c("Cannot redefine existing key '"+b+"'.",L,j),t.push(D),s=S(i,b,Object.create(null),L,j),n=b;}function m(v){var b=v.value,D=b.map(I).join("."),L=v.line,j=v.column;if(u(D)||t.push(D),t=t.filter(function(K){return K.indexOf(D)!==0}),t.push(D),s=S(i,b,[],L,j),n=D,s instanceof Array){var J=Object.create(null);s.push(J),s=J;}else c("Cannot redefine existing key '"+b+"'.",L,j);}function S(v,b,D,L,j){for(var J=[],K="",G=b.join("."),ee=v,M=0;M<b.length;M++){var ae=b[M];J.push(ae),K=J.join("."),typeof ee[ae]>"u"?M===b.length-1?ee[ae]=D:ee[ae]=Object.create(null):M!==b.length-1&&r.indexOf(K)>-1&&c("Cannot redefine existing key '"+K+"'.",L,j),ee=ee[ae],ee instanceof Array&&ee.length&&M<b.length-1&&(ee=ee[ee.length-1]);}return ee}function x(v){for(var b=null,D=0;D<v.length;D++){var L=v[D];b===null?b=L.type:L.type!==b&&c("Cannot add value of type "+L.type+" to array of type "+b+".",L.line,L.column);}return v.map(f)}function I(v){return v.indexOf(".")>-1?'"'+v+'"':v}}$k.exports={compile:WJ};});var Hk=A((xle,Vk)=>{var KJ=Uk(),zJ=jk();Vk.exports={parse:function(e){var t=KJ.parse(e.toString());return zJ.compile(t)}};});var Gy=A((Hle,Zk)=>{var zy=class{constructor(t={}){let r=!t.flat&&t.base||1.001,n=t.precision??1e-9;if(!(n>0))throw new Error("precision must be a positive number");if(!(r>1)||!(r<1.5))throw new Error("base must be a number between 1 and 1.5");if(r+=1e-9,r=2**(1/Math.ceil(Math.log(2)/Math.log(r))),r===1)throw new Error("base too close to 1");n=Number.parseFloat(""+n);let i=Math.ceil(1/(r-1)),s=t.flat?1/0:n*i;t.flat?this._flat=!0:this._base=r,this._thresh=s,this._precision=n;}toJSON(){return this._flat?{precision:this._precision,flat:!0}:{precision:this._precision,base:this._base}}getBase(){return this._base}getPrecision(){return this._precision}round(t){if(typeof t!="number"&&(t=Number.parseFloat(t)),Number.isNaN(t))throw new Error("Attempt to round a non-numeric value: "+t);return t<0?-this.round(-t):t<this._thresh?Math.round(t/this._precision)*this._precision:this._thresh*this._base**Math.round(Math.log(t/this._thresh)/Math.log(this._base))}upper(t){return t<0?-this.lower(-t):(t=this.round(t),t<this._thresh?t+this._precision/2:t*Math.sqrt(this._base))}lower(t){return t<0?-this.upper(-t):(t=this.round(t),t<=this._thresh?t-this._precision/2:t/Math.sqrt(this._base))}shorten(t,r){return t===void 0?t:r===void 0?ic(this.lower(t),this.upper(t)):ic(t,r)}};function ic(e,t,r=10){if(e===t)return e;if(e*t<=0)return 0;if(t<0)return -ic(-t,-e,r);if(e>t)return ic(t,e,r);let n=-Math.floor(Math.log(t-e)/Math.log(r));for(;Math.ceil(e*r**n)<=Math.floor(t*r**n);)n--;return n++,n>=0?Math.ceil(e*r**n)/r**n:Math.ceil(e/r**-n)*r**-n}Zk.exports={Binning:zy,shorten:ic};});var tN=A((Wle,eN)=>{var{Binning:tZ}=Gy(),rZ="stats-logscale/univariate@1.0",sc=class e extends tZ{constructor(t={}){super(t),this.storage=new Map,this._count=0,this._cache={},this.neat=new oc(this),t.bins&&this.addWeighted(t.bins);}add(...t){return this._cache={},t.forEach(r=>{let n=this.round(r),i=this.storage.get(n)??0;this.storage.set(n,i+1),this._count++;}),this}addWeighted(t){return this._cache={},t.forEach(r=>{let n=r[0],i=Number.parseFloat(r[1]);if(Number.isNaN(i))throw new Error("Attempt to provide a non-numeric weight");let s=this.round(n),o=(this.storage.get(s)??0)+i;o<=0?(this.storage.delete(s),this._count+=i-o):(this.storage.set(s,o),this._count+=i);}),this}toJSON(){return {version:rZ,...super.toJSON(),bins:this.getBins()}}clone(t={}){let r=this.getBins(t);return t.transform&&(r=r.map(n=>[t.transform(n[0]),n[1]])),new e({...super.toJSON(),bins:r})}getBins(t){if(this._cache.data||(this._cache.data=[...this.storage].sort((a,c)=>a[0]-c[0])),!t)return this._cache.data;let r=Math.max(t.min??-1/0,this.percentile(t.ltrim??0)),n=Math.min(t.max??1/0,this.percentile(100-(t.rtrim??0)));if(!t.winsorize)return this._cache.data.filter(a=>a[0]>=r&&a[0]<=n);let i=[this.round(r),0],s=[this.round(n),0],o=[i];for(let[a,c]of this._cache.data)a<=i[0]?i[1]+=c:a>=s[0]?s[1]+=c:o.push([a,c]);return s[1]>0&&o.push(s),o}count(){return this._count}min(){let t=this.getBins();return this.lower(t[0][0])}max(){let t=this.getBins();return this.upper(t[t.length-1][0])}sumOf(t){let r=0;return [...this.storage].forEach(n=>{r+=n[1]*t(n[0]);}),r}E(t){return this._count?this.sumOf(t)/this._count:void 0}mean(){return this._count?this.sumOf(t=>t)/this._count:void 0}stdev(){if(this._count<2)return;let t=this.mean();return Math.sqrt(this.sumOf(r=>(r-t)*(r-t))/(this._count-1))}skewness(){let t=this.count();return t<3?void 0:t*t/((t-1)*(t-2))*this.momentStd(3)}kurtosis(){let t=this.count();if(t<4)return;let r=t*t*(t+1)/((t-1)*(t-2)*(t-3)),n=(t-1)*(t-1)/((t-2)*(t-3));return this.momentStd(4)*r-3*n}moment(t,r){if(!Number.isInteger(t))throw new Error("Cannot calculate non-integer moment (did you mean momentAbs?)");return r===void 0&&(r=this.mean()),this.E(n=>(n-r)**t)}momentAbs(t=1,r){return r===void 0&&(r=this.mean()),this.E(n=>Math.abs(n-r)**t)}momentStd(t){return this.moment(t)/this.stdev()**t}quantile(t){let r=t*this._count,n=this._cumulative(),i=0,s=n.length;for(;i+1<s;){let c=Math.floor((s+i)/2);n[c][1]>=r?s=c:i=c;}let o=this.lower(n[i][0]),a=this.upper(n[i][0])-o;return o+a*(r-n[i][1])/(n[i][2]-n[i][1])}percentile(t){return this.quantile(t/100)}median(){return this.quantile(.5)}cdf(t){return this._rawCdf(t)/this._count}_rawCdf(t){let r=this._cumulative(),n=this.round(t),i=0,s=r.length;for(;i<s;){let a=Math.floor((s+i)/2);r[a][0]<n?i=a+1:s=a;}if(i>=r.length)return this._count;let o=i>0?r[i-1][2]:0;if(n===r[i][0]){let a=this.upper(t)-this.lower(t),c=r[i][2]-r[i][1];o+=a>0?c*(t-this.lower(t))/a:c/2;}return o}histogram(t={}){if(!this._count)return [];let r=this.min(),n=this.max(),i=t.count||10,s=[],o=r,a=(n-r)/i;for(let c=0;c<i;c++)s.push([this._rawCdf(o+a),o,o+=a]);for(let c=s.length;c-- >1;)s[c][0]-=s[c-1][0];if(s[0][0]-=this._rawCdf(r),t.scale){let c=0;for(let l=0;l<s.length;l++)c<s[l][0]&&(c=s[l][0]);for(let l=0;l<s.length;l++)s[l][0]=s[l][0]*t.scale/c;}return s}_cumulative(){if(!this._cache.cumulative){let t=this.getBins(),r=[],n=0;for(let i=0;i<t.length;i++)r.push([t[i][0],n,n+=t[i][1]]);this._cache.cumulative=r;}return this._cache.cumulative}};["cdf+","kurtosis","max","mean","min","moment+","momentAbs+","momentStd+","quantile+","skewness","stdev"].forEach(e=>{let t=!!e.match(/\+/);t&&(e=e.replace("+",""));let r=sc.prototype[e];if(typeof r!="function")throw new Error('method "'+e+'" is cached but never defined');sc.prototype[e]=t?function(...n){if(this._count===0)return;this._cache[e]===void 0&&(this._cache[e]={});let i=n.join(":");return this._cache[e][i]===void 0&&(this._cache[e][i]=r.apply(this,n)),this._cache[e][i]}:function(){if(this._count!==0)return this._cache[e]===void 0&&(this._cache[e]=r.apply(this)),this._cache[e]};});var oc=class{constructor(t){this._main=t;}min(){if(!this._main._count)return;let t=this._main.getBins();return this._main.shorten(t[0][0])}max(){if(!this._main._count)return;let t=this._main.getBins();return this._main.shorten(t[t.length-1][0])}};["E","kurtosis","mean","median","moment","momentAbs","momentStd","percentile","quantile","skewness","stdev","sumOf"].forEach(e=>{oc.prototype[e]=function(t){return this._main.shorten(this._main[e](t))};});["cdf","count"].forEach(e=>{oc.prototype[e]=function(t){return this._main[e](t)};});eN.exports={Univariate:sc};});var rN=A((Kle,Yy)=>{(()=>{let{Binning:e}=Gy(),{Univariate:t}=tN(),r={Binning:e,Univariate:t};typeof window<"u"&&(window.logstat=r),typeof Yy=="object"&&(Yy.exports=r);})();});var uN=A((fo,aN)=>{var Xy=he("crypto");fo=aN.exports=uc;function uc(e,t){return t=sN(e,t),nZ(e,t)}fo.sha1=function(e){return uc(e)};fo.keys=function(e){return uc(e,{excludeValues:!0,algorithm:"sha1",encoding:"hex"})};fo.MD5=function(e){return uc(e,{algorithm:"md5",encoding:"hex"})};fo.keysMD5=function(e){return uc(e,{algorithm:"md5",encoding:"hex",excludeValues:!0})};var Sa=Xy.getHashes?Xy.getHashes().slice():["sha1","md5"];Sa.push("passthrough");var nN=["buffer","hex","binary","base64"];function sN(e,t){t=t||{};var r={};if(r.algorithm=t.algorithm||"sha1",r.encoding=t.encoding||"hex",r.excludeValues=!!t.excludeValues,r.algorithm=r.algorithm.toLowerCase(),r.encoding=r.encoding.toLowerCase(),r.ignoreUnknown=t.ignoreUnknown===!0,r.respectType=t.respectType!==!1,r.respectFunctionNames=t.respectFunctionNames!==!1,r.respectFunctionProperties=t.respectFunctionProperties!==!1,r.unorderedArrays=t.unorderedArrays===!0,r.unorderedSets=t.unorderedSets!==!1,r.unorderedObjects=t.unorderedObjects!==!1,r.replacer=t.replacer||void 0,r.excludeKeys=t.excludeKeys||void 0,typeof e>"u")throw new Error("Object argument required.");for(var n=0;n<Sa.length;++n)Sa[n].toLowerCase()===r.algorithm.toLowerCase()&&(r.algorithm=Sa[n]);if(Sa.indexOf(r.algorithm)===-1)throw new Error('Algorithm "'+r.algorithm+'"  not supported. supported values: '+Sa.join(", "));if(nN.indexOf(r.encoding)===-1&&r.algorithm!=="passthrough")throw new Error('Encoding "'+r.encoding+'"  not supported. supported values: '+nN.join(", "));return r}function iN(e){if(typeof e!="function")return !1;var t=/^function\s+\w*\s*\(\s*\)\s*{\s+\[native code\]\s+}$/i;return t.exec(Function.prototype.toString.call(e))!=null}function nZ(e,t){var r;t.algorithm!=="passthrough"?r=Xy.createHash(t.algorithm):r=new oN,typeof r.write>"u"&&(r.write=r.update,r.end=r.update);var n=Jy(t,r);if(n.dispatch(e),r.update||r.end(""),r.digest)return r.digest(t.encoding==="buffer"?void 0:t.encoding);var i=r.read();return t.encoding==="buffer"?i:i.toString(t.encoding)}fo.writeToStream=function(e,t,r){return typeof r>"u"&&(r=t,t={}),t=sN(e,t),Jy(t,r).dispatch(e)};function Jy(e,t,r){r=r||[];var n=function(i){return t.update?t.update(i,"utf8"):t.write(i,"utf8")};return {dispatch:function(i){e.replacer&&(i=e.replacer(i));var s=typeof i;return i===null&&(s="null"),this["_"+s](i)},_object:function(i){var s=/\[object (.*)\]/i,o=Object.prototype.toString.call(i),a=s.exec(o);a?a=a[1]:a="unknown:["+o+"]",a=a.toLowerCase();var c=null;if((c=r.indexOf(i))>=0)return this.dispatch("[CIRCULAR:"+c+"]");if(r.push(i),typeof Buffer<"u"&&Buffer.isBuffer&&Buffer.isBuffer(i))return n("buffer:"),n(i);if(a!=="object"&&a!=="function"&&a!=="asyncfunction")if(this["_"+a])this["_"+a](i);else {if(e.ignoreUnknown)return n("["+a+"]");throw new Error('Unknown object type "'+a+'"')}else {var l=Object.keys(i);e.unorderedObjects&&(l=l.sort()),e.respectType!==!1&&!iN(i)&&l.splice(0,0,"prototype","__proto__","constructor"),e.excludeKeys&&(l=l.filter(function(f){return !e.excludeKeys(f)})),n("object:"+l.length+":");var u=this;return l.forEach(function(f){u.dispatch(f),n(":"),e.excludeValues||u.dispatch(i[f]),n(",");})}},_array:function(i,s){s=typeof s<"u"?s:e.unorderedArrays!==!1;var o=this;if(n("array:"+i.length+":"),!s||i.length<=1)return i.forEach(function(l){return o.dispatch(l)});var a=[],c=i.map(function(l){var u=new oN,f=r.slice(),d=Jy(e,u,f);return d.dispatch(l),a=a.concat(f.slice(r.length)),u.read().toString()});return r=r.concat(a),c.sort(),this._array(c,!1)},_date:function(i){return n("date:"+i.toJSON())},_symbol:function(i){return n("symbol:"+i.toString())},_error:function(i){return n("error:"+i.toString())},_boolean:function(i){return n("bool:"+i.toString())},_string:function(i){n("string:"+i.length+":"),n(i.toString());},_function:function(i){n("fn:"),iN(i)?this.dispatch("[native]"):this.dispatch(i.toString()),e.respectFunctionNames!==!1&&this.dispatch("function-name:"+String(i.name)),e.respectFunctionProperties&&this._object(i);},_number:function(i){return n("number:"+i.toString())},_xml:function(i){return n("xml:"+i.toString())},_null:function(){return n("Null")},_undefined:function(){return n("Undefined")},_regexp:function(i){return n("regex:"+i.toString())},_uint8array:function(i){return n("uint8array:"),this.dispatch(Array.prototype.slice.call(i))},_uint8clampedarray:function(i){return n("uint8clampedarray:"),this.dispatch(Array.prototype.slice.call(i))},_int8array:function(i){return n("int8array:"),this.dispatch(Array.prototype.slice.call(i))},_uint16array:function(i){return n("uint16array:"),this.dispatch(Array.prototype.slice.call(i))},_int16array:function(i){return n("int16array:"),this.dispatch(Array.prototype.slice.call(i))},_uint32array:function(i){return n("uint32array:"),this.dispatch(Array.prototype.slice.call(i))},_int32array:function(i){return n("int32array:"),this.dispatch(Array.prototype.slice.call(i))},_float32array:function(i){return n("float32array:"),this.dispatch(Array.prototype.slice.call(i))},_float64array:function(i){return n("float64array:"),this.dispatch(Array.prototype.slice.call(i))},_arraybuffer:function(i){return n("arraybuffer:"),this.dispatch(new Uint8Array(i))},_url:function(i){return n("url:"+i.toString())},_map:function(i){n("map:");var s=Array.from(i);return this._array(s,e.unorderedSets!==!1)},_set:function(i){n("set:");var s=Array.from(i);return this._array(s,e.unorderedSets!==!1)},_file:function(i){return n("file:"),this.dispatch([i.name,i.size,i.type,i.lastModfied])},_blob:function(){if(e.ignoreUnknown)return n("[blob]");throw Error(`Hashing Blob objects is currently not supported
(see https://github.com/puleos/object-hash/issues/26)
Use "options.replacer" or "options.ignoreUnknown"
`)},_domwindow:function(){return n("domwindow")},_bigint:function(i){return n("bigint:"+i.toString())},_process:function(){return n("process")},_timer:function(){return n("timer")},_pipe:function(){return n("pipe")},_tcp:function(){return n("tcp")},_udp:function(){return n("udp")},_tty:function(){return n("tty")},_statwatcher:function(){return n("statwatcher")},_securecontext:function(){return n("securecontext")},_connection:function(){return n("connection")},_zlib:function(){return n("zlib")},_context:function(){return n("context")},_nodescript:function(){return n("nodescript")},_httpparser:function(){return n("httpparser")},_dataview:function(){return n("dataview")},_signal:function(){return n("signal")},_fsevent:function(){return n("fsevent")},_tlswrap:function(){return n("tlswrap")}}}function oN(){return {buf:"",write:function(e){this.buf+=e;},end:function(e){this.buf+=e;},read:function(){return this.buf}}}});var _N=A((phe,wN)=>{wN.exports=fc();});var AN=A((ghe,TN)=>{function cZ(){return !!(typeof window<"u"&&typeof window.process=="object"&&window.process.type==="renderer"||typeof process<"u"&&typeof process.versions=="object"&&process.versions.electron||typeof navigator=="object"&&typeof navigator.userAgent=="string"&&navigator.userAgent.indexOf("Electron")>=0)}TN.exports=cZ;});var rt=A((mhe,RN)=>{RN.exports={options:{usePureJavaScript:!1}};});var PN=A((yhe,DN)=>{var sv={};DN.exports=sv;var IN={};sv.encode=function(e,t,r){if(typeof t!="string")throw new TypeError('"alphabet" must be a string.');if(r!==void 0&&typeof r!="number")throw new TypeError('"maxline" must be a number.');var n="";if(!(e instanceof Uint8Array))n=lZ(e,t);else {var i=0,s=t.length,o=t.charAt(0),a=[0];for(i=0;i<e.length;++i){for(var c=0,l=e[i];c<a.length;++c)l+=a[c]<<8,a[c]=l%s,l=l/s|0;for(;l>0;)a.push(l%s),l=l/s|0;}for(i=0;e[i]===0&&i<e.length-1;++i)n+=o;for(i=a.length-1;i>=0;--i)n+=t[a[i]];}if(r){var u=new RegExp(".{1,"+r+"}","g");n=n.match(u).join(`\r
`);}return n};sv.decode=function(e,t){if(typeof e!="string")throw new TypeError('"input" must be a string.');if(typeof t!="string")throw new TypeError('"alphabet" must be a string.');var r=IN[t];if(!r){r=IN[t]=[];for(var n=0;n<t.length;++n)r[t.charCodeAt(n)]=n;}e=e.replace(/\s/g,"");for(var i=t.length,s=t.charAt(0),o=[0],n=0;n<e.length;n++){var a=r[e.charCodeAt(n)];if(a===void 0)return;for(var c=0,l=a;c<o.length;++c)l+=o[c]*i,o[c]=l&255,l>>=8;for(;l>0;)o.push(l&255),l>>=8;}for(var u=0;e[u]===s&&u<e.length-1;++u)o.push(0);return typeof Buffer<"u"?Buffer.from(o.reverse()):new Uint8Array(o.reverse())};function lZ(e,t){var r=0,n=t.length,i=t.charAt(0),s=[0];for(r=0;r<e.length();++r){for(var o=0,a=e.at(r);o<s.length;++o)a+=s[o]<<8,s[o]=a%n,a=a/n|0;for(;a>0;)s.push(a%n),a=a/n|0;}var c="";for(r=0;e.at(r)===0&&r<e.length()-1;++r)c+=i;for(r=s.length-1;r>=0;--r)c+=t[s[r]];return c}});var vt=A((vhe,ON)=>{var kN=rt(),NN=PN(),V=ON.exports=kN.util=kN.util||{};(function(){if(typeof process<"u"&&process.nextTick&&!process.browser){V.nextTick=process.nextTick,typeof setImmediate=="function"?V.setImmediate=setImmediate:V.setImmediate=V.nextTick;return}if(typeof setImmediate=="function"){V.setImmediate=function(){return setImmediate.apply(void 0,arguments)},V.nextTick=function(a){return setImmediate(a)};return}if(V.setImmediate=function(a){setTimeout(a,0);},typeof window<"u"&&typeof window.postMessage=="function"){let a=function(c){if(c.source===window&&c.data===e){c.stopPropagation();var l=t.slice();t.length=0,l.forEach(function(u){u();});}};var e="forge.setImmediate",t=[];V.setImmediate=function(c){t.push(c),t.length===1&&window.postMessage(e,"*");},window.addEventListener("message",a,!0);}if(typeof MutationObserver<"u"){var r=Date.now(),n=!0,i=document.createElement("div"),t=[];new MutationObserver(function(){var c=t.slice();t.length=0,c.forEach(function(l){l();});}).observe(i,{attributes:!0});var s=V.setImmediate;V.setImmediate=function(c){Date.now()-r>15?(r=Date.now(),s(c)):(t.push(c),t.length===1&&i.setAttribute("a",n=!n));};}V.nextTick=V.setImmediate;})();V.isNodejs=typeof process<"u"&&process.versions&&process.versions.node;V.globalScope=function(){return V.isNodejs?global:typeof self>"u"?window:self}();V.isArray=Array.isArray||function(e){return Object.prototype.toString.call(e)==="[object Array]"};V.isArrayBuffer=function(e){return typeof ArrayBuffer<"u"&&e instanceof ArrayBuffer};V.isArrayBufferView=function(e){return e&&V.isArrayBuffer(e.buffer)&&e.byteLength!==void 0};function hc(e){if(!(e===8||e===16||e===24||e===32))throw new Error("Only 8, 16, 24, or 32 bits supported: "+e)}V.ByteBuffer=ov;function ov(e){if(this.data="",this.read=0,typeof e=="string")this.data=e;else if(V.isArrayBuffer(e)||V.isArrayBufferView(e))if(typeof Buffer<"u"&&e instanceof Buffer)this.data=e.toString("binary");else {var t=new Uint8Array(e);try{this.data=String.fromCharCode.apply(null,t);}catch{for(var r=0;r<t.length;++r)this.putByte(t[r]);}}else (e instanceof ov||typeof e=="object"&&typeof e.data=="string"&&typeof e.read=="number")&&(this.data=e.data,this.read=e.read);this._constructedStringLength=0;}V.ByteStringBuffer=ov;var fZ=4096;V.ByteStringBuffer.prototype._optimizeConstructedString=function(e){this._constructedStringLength+=e,this._constructedStringLength>fZ&&(this.data.substr(0,1),this._constructedStringLength=0);};V.ByteStringBuffer.prototype.length=function(){return this.data.length-this.read};V.ByteStringBuffer.prototype.isEmpty=function(){return this.length()<=0};V.ByteStringBuffer.prototype.putByte=function(e){return this.putBytes(String.fromCharCode(e))};V.ByteStringBuffer.prototype.fillWithByte=function(e,t){e=String.fromCharCode(e);for(var r=this.data;t>0;)t&1&&(r+=e),t>>>=1,t>0&&(e+=e);return this.data=r,this._optimizeConstructedString(t),this};V.ByteStringBuffer.prototype.putBytes=function(e){return this.data+=e,this._optimizeConstructedString(e.length),this};V.ByteStringBuffer.prototype.putString=function(e){return this.putBytes(V.encodeUtf8(e))};V.ByteStringBuffer.prototype.putInt16=function(e){return this.putBytes(String.fromCharCode(e>>8&255)+String.fromCharCode(e&255))};V.ByteStringBuffer.prototype.putInt24=function(e){return this.putBytes(String.fromCharCode(e>>16&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e&255))};V.ByteStringBuffer.prototype.putInt32=function(e){return this.putBytes(String.fromCharCode(e>>24&255)+String.fromCharCode(e>>16&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e&255))};V.ByteStringBuffer.prototype.putInt16Le=function(e){return this.putBytes(String.fromCharCode(e&255)+String.fromCharCode(e>>8&255))};V.ByteStringBuffer.prototype.putInt24Le=function(e){return this.putBytes(String.fromCharCode(e&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e>>16&255))};V.ByteStringBuffer.prototype.putInt32Le=function(e){return this.putBytes(String.fromCharCode(e&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e>>16&255)+String.fromCharCode(e>>24&255))};V.ByteStringBuffer.prototype.putInt=function(e,t){hc(t);var r="";do t-=8,r+=String.fromCharCode(e>>t&255);while(t>0);return this.putBytes(r)};V.ByteStringBuffer.prototype.putSignedInt=function(e,t){return e<0&&(e+=2<<t-1),this.putInt(e,t)};V.ByteStringBuffer.prototype.putBuffer=function(e){return this.putBytes(e.getBytes())};V.ByteStringBuffer.prototype.getByte=function(){return this.data.charCodeAt(this.read++)};V.ByteStringBuffer.prototype.getInt16=function(){var e=this.data.charCodeAt(this.read)<<8^this.data.charCodeAt(this.read+1);return this.read+=2,e};V.ByteStringBuffer.prototype.getInt24=function(){var e=this.data.charCodeAt(this.read)<<16^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2);return this.read+=3,e};V.ByteStringBuffer.prototype.getInt32=function(){var e=this.data.charCodeAt(this.read)<<24^this.data.charCodeAt(this.read+1)<<16^this.data.charCodeAt(this.read+2)<<8^this.data.charCodeAt(this.read+3);return this.read+=4,e};V.ByteStringBuffer.prototype.getInt16Le=function(){var e=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8;return this.read+=2,e};V.ByteStringBuffer.prototype.getInt24Le=function(){var e=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2)<<16;return this.read+=3,e};V.ByteStringBuffer.prototype.getInt32Le=function(){var e=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2)<<16^this.data.charCodeAt(this.read+3)<<24;return this.read+=4,e};V.ByteStringBuffer.prototype.getInt=function(e){hc(e);var t=0;do t=(t<<8)+this.data.charCodeAt(this.read++),e-=8;while(e>0);return t};V.ByteStringBuffer.prototype.getSignedInt=function(e){var t=this.getInt(e),r=2<<e-2;return t>=r&&(t-=r<<1),t};V.ByteStringBuffer.prototype.getBytes=function(e){var t;return e?(e=Math.min(this.length(),e),t=this.data.slice(this.read,this.read+e),this.read+=e):e===0?t="":(t=this.read===0?this.data:this.data.slice(this.read),this.clear()),t};V.ByteStringBuffer.prototype.bytes=function(e){return typeof e>"u"?this.data.slice(this.read):this.data.slice(this.read,this.read+e)};V.ByteStringBuffer.prototype.at=function(e){return this.data.charCodeAt(this.read+e)};V.ByteStringBuffer.prototype.setAt=function(e,t){return this.data=this.data.substr(0,this.read+e)+String.fromCharCode(t)+this.data.substr(this.read+e+1),this};V.ByteStringBuffer.prototype.last=function(){return this.data.charCodeAt(this.data.length-1)};V.ByteStringBuffer.prototype.copy=function(){var e=V.createBuffer(this.data);return e.read=this.read,e};V.ByteStringBuffer.prototype.compact=function(){return this.read>0&&(this.data=this.data.slice(this.read),this.read=0),this};V.ByteStringBuffer.prototype.clear=function(){return this.data="",this.read=0,this};V.ByteStringBuffer.prototype.truncate=function(e){var t=Math.max(0,this.length()-e);return this.data=this.data.substr(this.read,t),this.read=0,this};V.ByteStringBuffer.prototype.toHex=function(){for(var e="",t=this.read;t<this.data.length;++t){var r=this.data.charCodeAt(t);r<16&&(e+="0"),e+=r.toString(16);}return e};V.ByteStringBuffer.prototype.toString=function(){return V.decodeUtf8(this.bytes())};function hZ(e,t){t=t||{},this.read=t.readOffset||0,this.growSize=t.growSize||1024;var r=V.isArrayBuffer(e),n=V.isArrayBufferView(e);if(r||n){r?this.data=new DataView(e):this.data=new DataView(e.buffer,e.byteOffset,e.byteLength),this.write="writeOffset"in t?t.writeOffset:this.data.byteLength;return}this.data=new DataView(new ArrayBuffer(0)),this.write=0,e!=null&&this.putBytes(e),"writeOffset"in t&&(this.write=t.writeOffset);}V.DataBuffer=hZ;V.DataBuffer.prototype.length=function(){return this.write-this.read};V.DataBuffer.prototype.isEmpty=function(){return this.length()<=0};V.DataBuffer.prototype.accommodate=function(e,t){if(this.length()>=e)return this;t=Math.max(t||this.growSize,e);var r=new Uint8Array(this.data.buffer,this.data.byteOffset,this.data.byteLength),n=new Uint8Array(this.length()+t);return n.set(r),this.data=new DataView(n.buffer),this};V.DataBuffer.prototype.putByte=function(e){return this.accommodate(1),this.data.setUint8(this.write++,e),this};V.DataBuffer.prototype.fillWithByte=function(e,t){this.accommodate(t);for(var r=0;r<t;++r)this.data.setUint8(e);return this};V.DataBuffer.prototype.putBytes=function(e,t){if(V.isArrayBufferView(e)){var r=new Uint8Array(e.buffer,e.byteOffset,e.byteLength),n=r.byteLength-r.byteOffset;this.accommodate(n);var i=new Uint8Array(this.data.buffer,this.write);return i.set(r),this.write+=n,this}if(V.isArrayBuffer(e)){var r=new Uint8Array(e);this.accommodate(r.byteLength);var i=new Uint8Array(this.data.buffer);return i.set(r,this.write),this.write+=r.byteLength,this}if(e instanceof V.DataBuffer||typeof e=="object"&&typeof e.read=="number"&&typeof e.write=="number"&&V.isArrayBufferView(e.data)){var r=new Uint8Array(e.data.byteLength,e.read,e.length());this.accommodate(r.byteLength);var i=new Uint8Array(e.data.byteLength,this.write);return i.set(r),this.write+=r.byteLength,this}if(e instanceof V.ByteStringBuffer&&(e=e.data,t="binary"),t=t||"binary",typeof e=="string"){var s;if(t==="hex")return this.accommodate(Math.ceil(e.length/2)),s=new Uint8Array(this.data.buffer,this.write),this.write+=V.binary.hex.decode(e,s,this.write),this;if(t==="base64")return this.accommodate(Math.ceil(e.length/4)*3),s=new Uint8Array(this.data.buffer,this.write),this.write+=V.binary.base64.decode(e,s,this.write),this;if(t==="utf8"&&(e=V.encodeUtf8(e),t="binary"),t==="binary"||t==="raw")return this.accommodate(e.length),s=new Uint8Array(this.data.buffer,this.write),this.write+=V.binary.raw.decode(s),this;if(t==="utf16")return this.accommodate(e.length*2),s=new Uint16Array(this.data.buffer,this.write),this.write+=V.text.utf16.encode(s),this;throw new Error("Invalid encoding: "+t)}throw Error("Invalid parameter: "+e)};V.DataBuffer.prototype.putBuffer=function(e){return this.putBytes(e),e.clear(),this};V.DataBuffer.prototype.putString=function(e){return this.putBytes(e,"utf16")};V.DataBuffer.prototype.putInt16=function(e){return this.accommodate(2),this.data.setInt16(this.write,e),this.write+=2,this};V.DataBuffer.prototype.putInt24=function(e){return this.accommodate(3),this.data.setInt16(this.write,e>>8&65535),this.data.setInt8(this.write,e>>16&255),this.write+=3,this};V.DataBuffer.prototype.putInt32=function(e){return this.accommodate(4),this.data.setInt32(this.write,e),this.write+=4,this};V.DataBuffer.prototype.putInt16Le=function(e){return this.accommodate(2),this.data.setInt16(this.write,e,!0),this.write+=2,this};V.DataBuffer.prototype.putInt24Le=function(e){return this.accommodate(3),this.data.setInt8(this.write,e>>16&255),this.data.setInt16(this.write,e>>8&65535,!0),this.write+=3,this};V.DataBuffer.prototype.putInt32Le=function(e){return this.accommodate(4),this.data.setInt32(this.write,e,!0),this.write+=4,this};V.DataBuffer.prototype.putInt=function(e,t){hc(t),this.accommodate(t/8);do t-=8,this.data.setInt8(this.write++,e>>t&255);while(t>0);return this};V.DataBuffer.prototype.putSignedInt=function(e,t){return hc(t),this.accommodate(t/8),e<0&&(e+=2<<t-1),this.putInt(e,t)};V.DataBuffer.prototype.getByte=function(){return this.data.getInt8(this.read++)};V.DataBuffer.prototype.getInt16=function(){var e=this.data.getInt16(this.read);return this.read+=2,e};V.DataBuffer.prototype.getInt24=function(){var e=this.data.getInt16(this.read)<<8^this.data.getInt8(this.read+2);return this.read+=3,e};V.DataBuffer.prototype.getInt32=function(){var e=this.data.getInt32(this.read);return this.read+=4,e};V.DataBuffer.prototype.getInt16Le=function(){var e=this.data.getInt16(this.read,!0);return this.read+=2,e};V.DataBuffer.prototype.getInt24Le=function(){var e=this.data.getInt8(this.read)^this.data.getInt16(this.read+1,!0)<<8;return this.read+=3,e};V.DataBuffer.prototype.getInt32Le=function(){var e=this.data.getInt32(this.read,!0);return this.read+=4,e};V.DataBuffer.prototype.getInt=function(e){hc(e);var t=0;do t=(t<<8)+this.data.getInt8(this.read++),e-=8;while(e>0);return t};V.DataBuffer.prototype.getSignedInt=function(e){var t=this.getInt(e),r=2<<e-2;return t>=r&&(t-=r<<1),t};V.DataBuffer.prototype.getBytes=function(e){var t;return e?(e=Math.min(this.length(),e),t=this.data.slice(this.read,this.read+e),this.read+=e):e===0?t="":(t=this.read===0?this.data:this.data.slice(this.read),this.clear()),t};V.DataBuffer.prototype.bytes=function(e){return typeof e>"u"?this.data.slice(this.read):this.data.slice(this.read,this.read+e)};V.DataBuffer.prototype.at=function(e){return this.data.getUint8(this.read+e)};V.DataBuffer.prototype.setAt=function(e,t){return this.data.setUint8(e,t),this};V.DataBuffer.prototype.last=function(){return this.data.getUint8(this.write-1)};V.DataBuffer.prototype.copy=function(){return new V.DataBuffer(this)};V.DataBuffer.prototype.compact=function(){if(this.read>0){var e=new Uint8Array(this.data.buffer,this.read),t=new Uint8Array(e.byteLength);t.set(e),this.data=new DataView(t),this.write-=this.read,this.read=0;}return this};V.DataBuffer.prototype.clear=function(){return this.data=new DataView(new ArrayBuffer(0)),this.read=this.write=0,this};V.DataBuffer.prototype.truncate=function(e){return this.write=Math.max(0,this.length()-e),this.read=Math.min(this.read,this.write),this};V.DataBuffer.prototype.toHex=function(){for(var e="",t=this.read;t<this.data.byteLength;++t){var r=this.data.getUint8(t);r<16&&(e+="0"),e+=r.toString(16);}return e};V.DataBuffer.prototype.toString=function(e){var t=new Uint8Array(this.data,this.read,this.length());if(e=e||"utf8",e==="binary"||e==="raw")return V.binary.raw.encode(t);if(e==="hex")return V.binary.hex.encode(t);if(e==="base64")return V.binary.base64.encode(t);if(e==="utf8")return V.text.utf8.decode(t);if(e==="utf16")return V.text.utf16.decode(t);throw new Error("Invalid encoding: "+e)};V.createBuffer=function(e,t){return t=t||"raw",e!==void 0&&t==="utf8"&&(e=V.encodeUtf8(e)),new V.ByteBuffer(e)};V.fillString=function(e,t){for(var r="";t>0;)t&1&&(r+=e),t>>>=1,t>0&&(e+=e);return r};V.xorBytes=function(e,t,r){for(var n="",i="",s="",o=0,a=0;r>0;--r,++o)i=e.charCodeAt(o)^t.charCodeAt(o),a>=10&&(n+=s,s="",a=0),s+=String.fromCharCode(i),++a;return n+=s,n};V.hexToBytes=function(e){var t="",r=0;for(e.length&!0&&(r=1,t+=String.fromCharCode(parseInt(e[0],16)));r<e.length;r+=2)t+=String.fromCharCode(parseInt(e.substr(r,2),16));return t};V.bytesToHex=function(e){return V.createBuffer(e).toHex()};V.int32ToBytes=function(e){return String.fromCharCode(e>>24&255)+String.fromCharCode(e>>16&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e&255)};var ys="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",vs=[62,-1,-1,-1,63,52,53,54,55,56,57,58,59,60,61,-1,-1,-1,64,-1,-1,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,-1,-1,-1,-1,-1,-1,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51],LN="123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz";V.encode64=function(e,t){for(var r="",n="",i,s,o,a=0;a<e.length;)i=e.charCodeAt(a++),s=e.charCodeAt(a++),o=e.charCodeAt(a++),r+=ys.charAt(i>>2),r+=ys.charAt((i&3)<<4|s>>4),isNaN(s)?r+="==":(r+=ys.charAt((s&15)<<2|o>>6),r+=isNaN(o)?"=":ys.charAt(o&63)),t&&r.length>t&&(n+=r.substr(0,t)+`\r
`,r=r.substr(t));return n+=r,n};V.decode64=function(e){e=e.replace(/[^A-Za-z0-9\+\/\=]/g,"");for(var t="",r,n,i,s,o=0;o<e.length;)r=vs[e.charCodeAt(o++)-43],n=vs[e.charCodeAt(o++)-43],i=vs[e.charCodeAt(o++)-43],s=vs[e.charCodeAt(o++)-43],t+=String.fromCharCode(r<<2|n>>4),i!==64&&(t+=String.fromCharCode((n&15)<<4|i>>2),s!==64&&(t+=String.fromCharCode((i&3)<<6|s)));return t};V.encodeUtf8=function(e){return unescape(encodeURIComponent(e))};V.decodeUtf8=function(e){return decodeURIComponent(escape(e))};V.binary={raw:{},hex:{},base64:{},base58:{},baseN:{encode:NN.encode,decode:NN.decode}};V.binary.raw.encode=function(e){return String.fromCharCode.apply(null,e)};V.binary.raw.decode=function(e,t,r){var n=t;n||(n=new Uint8Array(e.length)),r=r||0;for(var i=r,s=0;s<e.length;++s)n[i++]=e.charCodeAt(s);return t?i-r:n};V.binary.hex.encode=V.bytesToHex;V.binary.hex.decode=function(e,t,r){var n=t;n||(n=new Uint8Array(Math.ceil(e.length/2))),r=r||0;var i=0,s=r;for(e.length&1&&(i=1,n[s++]=parseInt(e[0],16));i<e.length;i+=2)n[s++]=parseInt(e.substr(i,2),16);return t?s-r:n};V.binary.base64.encode=function(e,t){for(var r="",n="",i,s,o,a=0;a<e.byteLength;)i=e[a++],s=e[a++],o=e[a++],r+=ys.charAt(i>>2),r+=ys.charAt((i&3)<<4|s>>4),isNaN(s)?r+="==":(r+=ys.charAt((s&15)<<2|o>>6),r+=isNaN(o)?"=":ys.charAt(o&63)),t&&r.length>t&&(n+=r.substr(0,t)+`\r
`,r=r.substr(t));return n+=r,n};V.binary.base64.decode=function(e,t,r){var n=t;n||(n=new Uint8Array(Math.ceil(e.length/4)*3)),e=e.replace(/[^A-Za-z0-9\+\/\=]/g,""),r=r||0;for(var i,s,o,a,c=0,l=r;c<e.length;)i=vs[e.charCodeAt(c++)-43],s=vs[e.charCodeAt(c++)-43],o=vs[e.charCodeAt(c++)-43],a=vs[e.charCodeAt(c++)-43],n[l++]=i<<2|s>>4,o!==64&&(n[l++]=(s&15)<<4|o>>2,a!==64&&(n[l++]=(o&3)<<6|a));return t?l-r:n.subarray(0,l)};V.binary.base58.encode=function(e,t){return V.binary.baseN.encode(e,LN,t)};V.binary.base58.decode=function(e,t){return V.binary.baseN.decode(e,LN,t)};V.text={utf8:{},utf16:{}};V.text.utf8.encode=function(e,t,r){e=V.encodeUtf8(e);var n=t;n||(n=new Uint8Array(e.length)),r=r||0;for(var i=r,s=0;s<e.length;++s)n[i++]=e.charCodeAt(s);return t?i-r:n};V.text.utf8.decode=function(e){return V.decodeUtf8(String.fromCharCode.apply(null,e))};V.text.utf16.encode=function(e,t,r){var n=t;n||(n=new Uint8Array(e.length*2));var i=new Uint16Array(n.buffer);r=r||0;for(var s=r,o=r,a=0;a<e.length;++a)i[o++]=e.charCodeAt(a),s+=2;return t?s-r:n};V.text.utf16.decode=function(e){return String.fromCharCode.apply(null,new Uint16Array(e.buffer))};V.deflate=function(e,t,r){if(t=V.decode64(e.deflate(V.encode64(t)).rval),r){var n=2,i=t.charCodeAt(1);i&32&&(n=6),t=t.substring(n,t.length-4);}return t};V.inflate=function(e,t,r){var n=e.inflate(V.encode64(t)).rval;return n===null?null:V.decode64(n)};var av=function(e,t,r){if(!e)throw new Error("WebStorage not available.");var n;if(r===null?n=e.removeItem(t):(r=V.encode64(JSON.stringify(r)),n=e.setItem(t,r)),typeof n<"u"&&n.rval!==!0){var i=new Error(n.error.message);throw i.id=n.error.id,i.name=n.error.name,i}},uv=function(e,t){if(!e)throw new Error("WebStorage not available.");var r=e.getItem(t);if(e.init)if(r.rval===null){if(r.error){var n=new Error(r.error.message);throw n.id=r.error.id,n.name=r.error.name,n}r=null;}else r=r.rval;return r!==null&&(r=JSON.parse(V.decode64(r))),r},dZ=function(e,t,r,n){var i=uv(e,t);i===null&&(i={}),i[r]=n,av(e,t,i);},pZ=function(e,t,r){var n=uv(e,t);return n!==null&&(n=r in n?n[r]:null),n},gZ=function(e,t,r){var n=uv(e,t);if(n!==null&&r in n){delete n[r];var i=!0;for(var s in n){i=!1;break}i&&(n=null),av(e,t,n);}},mZ=function(e,t){av(e,t,null);},dh=function(e,t,r){var n=null;typeof r>"u"&&(r=["web","flash"]);var i,s=!1,o=null;for(var a in r){i=r[a];try{if(i==="flash"||i==="both"){if(t[0]===null)throw new Error("Flash local storage not available.");n=e.apply(this,t),s=i==="flash";}(i==="web"||i==="both")&&(t[0]=localStorage,n=e.apply(this,t),s=!0);}catch(c){o=c;}if(s)break}if(!s)throw o;return n};V.setItem=function(e,t,r,n,i){dh(dZ,arguments,i);};V.getItem=function(e,t,r,n){return dh(pZ,arguments,n)};V.removeItem=function(e,t,r,n){dh(gZ,arguments,n);};V.clearItems=function(e,t,r){dh(mZ,arguments,r);};V.isEmpty=function(e){for(var t in e)if(e.hasOwnProperty(t))return !1;return !0};V.format=function(e){for(var t=/%./g,r,n,i=0,s=[],o=0;r=t.exec(e);){n=e.substring(o,t.lastIndex-2),n.length>0&&s.push(n),o=t.lastIndex;var a=r[0][1];switch(a){case"s":case"o":i<arguments.length?s.push(arguments[i+++1]):s.push("<?>");break;case"%":s.push("%");break;default:s.push("<%"+a+"?>");}}return s.push(e.substring(o)),s.join("")};V.formatNumber=function(e,t,r,n){var i=e,s=isNaN(t=Math.abs(t))?2:t,o=r===void 0?",":r,a=n===void 0?".":n,c=i<0?"-":"",l=parseInt(i=Math.abs(+i||0).toFixed(s),10)+"",u=l.length>3?l.length%3:0;return c+(u?l.substr(0,u)+a:"")+l.substr(u).replace(/(\d{3})(?=\d)/g,"$1"+a)+(s?o+Math.abs(i-l).toFixed(s).slice(2):"")};V.formatSize=function(e){return e>=1073741824?e=V.formatNumber(e/1073741824,2,".","")+" GiB":e>=1048576?e=V.formatNumber(e/1048576,2,".","")+" MiB":e>=1024?e=V.formatNumber(e/1024,0)+" KiB":e=V.formatNumber(e,0)+" bytes",e};V.bytesFromIP=function(e){return e.indexOf(".")!==-1?V.bytesFromIPv4(e):e.indexOf(":")!==-1?V.bytesFromIPv6(e):null};V.bytesFromIPv4=function(e){if(e=e.split("."),e.length!==4)return null;for(var t=V.createBuffer(),r=0;r<e.length;++r){var n=parseInt(e[r],10);if(isNaN(n))return null;t.putByte(n);}return t.getBytes()};V.bytesFromIPv6=function(e){var t=0;e=e.split(":").filter(function(o){return o.length===0&&++t,!0});for(var r=(8-e.length+t)*2,n=V.createBuffer(),i=0;i<8;++i){if(!e[i]||e[i].length===0){n.fillWithByte(0,r),r=0;continue}var s=V.hexToBytes(e[i]);s.length<2&&n.putByte(0),n.putBytes(s);}return n.getBytes()};V.bytesToIP=function(e){return e.length===4?V.bytesToIPv4(e):e.length===16?V.bytesToIPv6(e):null};V.bytesToIPv4=function(e){if(e.length!==4)return null;for(var t=[],r=0;r<e.length;++r)t.push(e.charCodeAt(r));return t.join(".")};V.bytesToIPv6=function(e){if(e.length!==16)return null;for(var t=[],r=[],n=0,i=0;i<e.length;i+=2){for(var s=V.bytesToHex(e[i]+e[i+1]);s[0]==="0"&&s!=="0";)s=s.substr(1);if(s==="0"){var o=r[r.length-1],a=t.length;!o||a!==o.end+1?r.push({start:a,end:a}):(o.end=a,o.end-o.start>r[n].end-r[n].start&&(n=r.length-1));}t.push(s);}if(r.length>0){var c=r[n];c.end-c.start>0&&(t.splice(c.start,c.end-c.start+1,""),c.start===0&&t.unshift(""),c.end===7&&t.push(""));}return t.join(":")};V.estimateCores=function(e,t){if(typeof e=="function"&&(t=e,e={}),e=e||{},"cores"in V&&!e.update)return t(null,V.cores);if(typeof navigator<"u"&&"hardwareConcurrency"in navigator&&navigator.hardwareConcurrency>0)return V.cores=navigator.hardwareConcurrency,t(null,V.cores);if(typeof Worker>"u")return V.cores=1,t(null,V.cores);if(typeof Blob>"u")return V.cores=2,t(null,V.cores);var r=URL.createObjectURL(new Blob(["(",function(){self.addEventListener("message",function(o){for(var a=Date.now(),c=a+4;Date.now()<c;);self.postMessage({st:a,et:c});});}.toString(),")()"],{type:"application/javascript"}));n([],5,16);function n(o,a,c){if(a===0){var l=Math.floor(o.reduce(function(u,f){return u+f},0)/o.length);return V.cores=Math.max(1,l),URL.revokeObjectURL(r),t(null,V.cores)}i(c,function(u,f){o.push(s(c,f)),n(o,a-1,c);});}function i(o,a){for(var c=[],l=[],u=0;u<o;++u){var f=new Worker(r);f.addEventListener("message",function(d){if(l.push(d.data),l.length===o){for(var p=0;p<o;++p)c[p].terminate();a(null,l);}}),c.push(f);}for(var u=0;u<o;++u)c[u].postMessage(u);}function s(o,a){for(var c=[],l=0;l<o;++l)for(var u=a[l],f=c[l]=[],d=0;d<o;++d)if(l!==d){var p=a[d];(u.st>p.st&&u.st<p.et||p.st>u.st&&p.st<u.et)&&f.push(d);}return c.reduce(function(m,S){return Math.max(m,S.length)},0)}};});var ph=A((She,BN)=>{var vr=rt();vt();BN.exports=vr.cipher=vr.cipher||{};vr.cipher.algorithms=vr.cipher.algorithms||{};vr.cipher.createCipher=function(e,t){var r=e;if(typeof r=="string"&&(r=vr.cipher.getAlgorithm(r),r&&(r=r())),!r)throw new Error("Unsupported algorithm: "+e);return new vr.cipher.BlockCipher({algorithm:r,key:t,decrypt:!1})};vr.cipher.createDecipher=function(e,t){var r=e;if(typeof r=="string"&&(r=vr.cipher.getAlgorithm(r),r&&(r=r())),!r)throw new Error("Unsupported algorithm: "+e);return new vr.cipher.BlockCipher({algorithm:r,key:t,decrypt:!0})};vr.cipher.registerAlgorithm=function(e,t){e=e.toUpperCase(),vr.cipher.algorithms[e]=t;};vr.cipher.getAlgorithm=function(e){return e=e.toUpperCase(),e in vr.cipher.algorithms?vr.cipher.algorithms[e]:null};var cv=vr.cipher.BlockCipher=function(e){this.algorithm=e.algorithm,this.mode=this.algorithm.mode,this.blockSize=this.mode.blockSize,this._finish=!1,this._input=null,this.output=null,this._op=e.decrypt?this.mode.decrypt:this.mode.encrypt,this._decrypt=e.decrypt,this.algorithm.initialize(e);};cv.prototype.start=function(e){e=e||{};var t={};for(var r in e)t[r]=e[r];t.decrypt=this._decrypt,this._finish=!1,this._input=vr.util.createBuffer(),this.output=e.output||vr.util.createBuffer(),this.mode.start(t);};cv.prototype.update=function(e){for(e&&this._input.putBuffer(e);!this._op.call(this.mode,this._input,this.output,this._finish)&&!this._finish;);this._input.compact();};cv.prototype.finish=function(e){e&&(this.mode.name==="ECB"||this.mode.name==="CBC")&&(this.mode.pad=function(r){return e(this.blockSize,r,!1)},this.mode.unpad=function(r){return e(this.blockSize,r,!0)});var t={};return t.decrypt=this._decrypt,t.overflow=this._input.length()%this.blockSize,!(!this._decrypt&&this.mode.pad&&!this.mode.pad(this._input,t)||(this._finish=!0,this.update(),this._decrypt&&this.mode.unpad&&!this.mode.unpad(this.output,t))||this.mode.afterFinish&&!this.mode.afterFinish(this.output,t))};});var fv=A((bhe,qN)=>{var Sr=rt();vt();Sr.cipher=Sr.cipher||{};var ot=qN.exports=Sr.cipher.modes=Sr.cipher.modes||{};ot.ecb=function(e){e=e||{},this.name="ECB",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=new Array(this._ints),this._outBlock=new Array(this._ints);};ot.ecb.prototype.start=function(e){};ot.ecb.prototype.encrypt=function(e,t,r){if(e.length()<this.blockSize&&!(r&&e.length()>0))return !0;for(var n=0;n<this._ints;++n)this._inBlock[n]=e.getInt32();this.cipher.encrypt(this._inBlock,this._outBlock);for(var n=0;n<this._ints;++n)t.putInt32(this._outBlock[n]);};ot.ecb.prototype.decrypt=function(e,t,r){if(e.length()<this.blockSize&&!(r&&e.length()>0))return !0;for(var n=0;n<this._ints;++n)this._inBlock[n]=e.getInt32();this.cipher.decrypt(this._inBlock,this._outBlock);for(var n=0;n<this._ints;++n)t.putInt32(this._outBlock[n]);};ot.ecb.prototype.pad=function(e,t){var r=e.length()===this.blockSize?this.blockSize:this.blockSize-e.length();return e.fillWithByte(r,r),!0};ot.ecb.prototype.unpad=function(e,t){if(t.overflow>0)return !1;var r=e.length(),n=e.at(r-1);return n>this.blockSize<<2?!1:(e.truncate(n),!0)};ot.cbc=function(e){e=e||{},this.name="CBC",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=new Array(this._ints),this._outBlock=new Array(this._ints);};ot.cbc.prototype.start=function(e){if(e.iv===null){if(!this._prev)throw new Error("Invalid IV parameter.");this._iv=this._prev.slice(0);}else if("iv"in e)this._iv=gh(e.iv,this.blockSize),this._prev=this._iv.slice(0);else throw new Error("Invalid IV parameter.")};ot.cbc.prototype.encrypt=function(e,t,r){if(e.length()<this.blockSize&&!(r&&e.length()>0))return !0;for(var n=0;n<this._ints;++n)this._inBlock[n]=this._prev[n]^e.getInt32();this.cipher.encrypt(this._inBlock,this._outBlock);for(var n=0;n<this._ints;++n)t.putInt32(this._outBlock[n]);this._prev=this._outBlock;};ot.cbc.prototype.decrypt=function(e,t,r){if(e.length()<this.blockSize&&!(r&&e.length()>0))return !0;for(var n=0;n<this._ints;++n)this._inBlock[n]=e.getInt32();this.cipher.decrypt(this._inBlock,this._outBlock);for(var n=0;n<this._ints;++n)t.putInt32(this._prev[n]^this._outBlock[n]);this._prev=this._inBlock.slice(0);};ot.cbc.prototype.pad=function(e,t){var r=e.length()===this.blockSize?this.blockSize:this.blockSize-e.length();return e.fillWithByte(r,r),!0};ot.cbc.prototype.unpad=function(e,t){if(t.overflow>0)return !1;var r=e.length(),n=e.at(r-1);return n>this.blockSize<<2?!1:(e.truncate(n),!0)};ot.cfb=function(e){e=e||{},this.name="CFB",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=null,this._outBlock=new Array(this._ints),this._partialBlock=new Array(this._ints),this._partialOutput=Sr.util.createBuffer(),this._partialBytes=0;};ot.cfb.prototype.start=function(e){if(!("iv"in e))throw new Error("Invalid IV parameter.");this._iv=gh(e.iv,this.blockSize),this._inBlock=this._iv.slice(0),this._partialBytes=0;};ot.cfb.prototype.encrypt=function(e,t,r){var n=e.length();if(n===0)return !0;if(this.cipher.encrypt(this._inBlock,this._outBlock),this._partialBytes===0&&n>=this.blockSize){for(var i=0;i<this._ints;++i)this._inBlock[i]=e.getInt32()^this._outBlock[i],t.putInt32(this._inBlock[i]);return}var s=(this.blockSize-n)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialBlock[i]=e.getInt32()^this._outBlock[i],this._partialOutput.putInt32(this._partialBlock[i]);if(s>0)e.read-=this.blockSize;else for(var i=0;i<this._ints;++i)this._inBlock[i]=this._partialBlock[i];if(this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes),s>0&&!r)return t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(n-this._partialBytes)),this._partialBytes=0;};ot.cfb.prototype.decrypt=function(e,t,r){var n=e.length();if(n===0)return !0;if(this.cipher.encrypt(this._inBlock,this._outBlock),this._partialBytes===0&&n>=this.blockSize){for(var i=0;i<this._ints;++i)this._inBlock[i]=e.getInt32(),t.putInt32(this._inBlock[i]^this._outBlock[i]);return}var s=(this.blockSize-n)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialBlock[i]=e.getInt32(),this._partialOutput.putInt32(this._partialBlock[i]^this._outBlock[i]);if(s>0)e.read-=this.blockSize;else for(var i=0;i<this._ints;++i)this._inBlock[i]=this._partialBlock[i];if(this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes),s>0&&!r)return t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(n-this._partialBytes)),this._partialBytes=0;};ot.ofb=function(e){e=e||{},this.name="OFB",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=null,this._outBlock=new Array(this._ints),this._partialOutput=Sr.util.createBuffer(),this._partialBytes=0;};ot.ofb.prototype.start=function(e){if(!("iv"in e))throw new Error("Invalid IV parameter.");this._iv=gh(e.iv,this.blockSize),this._inBlock=this._iv.slice(0),this._partialBytes=0;};ot.ofb.prototype.encrypt=function(e,t,r){var n=e.length();if(e.length()===0)return !0;if(this.cipher.encrypt(this._inBlock,this._outBlock),this._partialBytes===0&&n>=this.blockSize){for(var i=0;i<this._ints;++i)t.putInt32(e.getInt32()^this._outBlock[i]),this._inBlock[i]=this._outBlock[i];return}var s=(this.blockSize-n)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialOutput.putInt32(e.getInt32()^this._outBlock[i]);if(s>0)e.read-=this.blockSize;else for(var i=0;i<this._ints;++i)this._inBlock[i]=this._outBlock[i];if(this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes),s>0&&!r)return t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(n-this._partialBytes)),this._partialBytes=0;};ot.ofb.prototype.decrypt=ot.ofb.prototype.encrypt;ot.ctr=function(e){e=e||{},this.name="CTR",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=null,this._outBlock=new Array(this._ints),this._partialOutput=Sr.util.createBuffer(),this._partialBytes=0;};ot.ctr.prototype.start=function(e){if(!("iv"in e))throw new Error("Invalid IV parameter.");this._iv=gh(e.iv,this.blockSize),this._inBlock=this._iv.slice(0),this._partialBytes=0;};ot.ctr.prototype.encrypt=function(e,t,r){var n=e.length();if(n===0)return !0;if(this.cipher.encrypt(this._inBlock,this._outBlock),this._partialBytes===0&&n>=this.blockSize)for(var i=0;i<this._ints;++i)t.putInt32(e.getInt32()^this._outBlock[i]);else {var s=(this.blockSize-n)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialOutput.putInt32(e.getInt32()^this._outBlock[i]);if(s>0&&(e.read-=this.blockSize),this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes),s>0&&!r)return t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(n-this._partialBytes)),this._partialBytes=0;}mh(this._inBlock);};ot.ctr.prototype.decrypt=ot.ctr.prototype.encrypt;ot.gcm=function(e){e=e||{},this.name="GCM",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=new Array(this._ints),this._outBlock=new Array(this._ints),this._partialOutput=Sr.util.createBuffer(),this._partialBytes=0,this._R=3774873600;};ot.gcm.prototype.start=function(e){if(!("iv"in e))throw new Error("Invalid IV parameter.");var t=Sr.util.createBuffer(e.iv);this._cipherLength=0;var r;if("additionalData"in e?r=Sr.util.createBuffer(e.additionalData):r=Sr.util.createBuffer(),"tagLength"in e?this._tagLength=e.tagLength:this._tagLength=128,this._tag=null,e.decrypt&&(this._tag=Sr.util.createBuffer(e.tag).getBytes(),this._tag.length!==this._tagLength/8))throw new Error("Authentication tag does not match tag length.");this._hashBlock=new Array(this._ints),this.tag=null,this._hashSubkey=new Array(this._ints),this.cipher.encrypt([0,0,0,0],this._hashSubkey),this.componentBits=4,this._m=this.generateHashTable(this._hashSubkey,this.componentBits);var n=t.length();if(n===12)this._j0=[t.getInt32(),t.getInt32(),t.getInt32(),1];else {for(this._j0=[0,0,0,0];t.length()>0;)this._j0=this.ghash(this._hashSubkey,this._j0,[t.getInt32(),t.getInt32(),t.getInt32(),t.getInt32()]);this._j0=this.ghash(this._hashSubkey,this._j0,[0,0].concat(lv(n*8)));}this._inBlock=this._j0.slice(0),mh(this._inBlock),this._partialBytes=0,r=Sr.util.createBuffer(r),this._aDataLength=lv(r.length()*8);var i=r.length()%this.blockSize;for(i&&r.fillWithByte(0,this.blockSize-i),this._s=[0,0,0,0];r.length()>0;)this._s=this.ghash(this._hashSubkey,this._s,[r.getInt32(),r.getInt32(),r.getInt32(),r.getInt32()]);};ot.gcm.prototype.encrypt=function(e,t,r){var n=e.length();if(n===0)return !0;if(this.cipher.encrypt(this._inBlock,this._outBlock),this._partialBytes===0&&n>=this.blockSize){for(var i=0;i<this._ints;++i)t.putInt32(this._outBlock[i]^=e.getInt32());this._cipherLength+=this.blockSize;}else {var s=(this.blockSize-n)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialOutput.putInt32(e.getInt32()^this._outBlock[i]);if(s<=0||r){if(r){var o=n%this.blockSize;this._cipherLength+=o,this._partialOutput.truncate(this.blockSize-o);}else this._cipherLength+=this.blockSize;for(var i=0;i<this._ints;++i)this._outBlock[i]=this._partialOutput.getInt32();this._partialOutput.read-=this.blockSize;}if(this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes),s>0&&!r)return e.read-=this.blockSize,t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(n-this._partialBytes)),this._partialBytes=0;}this._s=this.ghash(this._hashSubkey,this._s,this._outBlock),mh(this._inBlock);};ot.gcm.prototype.decrypt=function(e,t,r){var n=e.length();if(n<this.blockSize&&!(r&&n>0))return !0;this.cipher.encrypt(this._inBlock,this._outBlock),mh(this._inBlock),this._hashBlock[0]=e.getInt32(),this._hashBlock[1]=e.getInt32(),this._hashBlock[2]=e.getInt32(),this._hashBlock[3]=e.getInt32(),this._s=this.ghash(this._hashSubkey,this._s,this._hashBlock);for(var i=0;i<this._ints;++i)t.putInt32(this._outBlock[i]^this._hashBlock[i]);n<this.blockSize?this._cipherLength+=n%this.blockSize:this._cipherLength+=this.blockSize;};ot.gcm.prototype.afterFinish=function(e,t){var r=!0;t.decrypt&&t.overflow&&e.truncate(this.blockSize-t.overflow),this.tag=Sr.util.createBuffer();var n=this._aDataLength.concat(lv(this._cipherLength*8));this._s=this.ghash(this._hashSubkey,this._s,n);var i=[];this.cipher.encrypt(this._j0,i);for(var s=0;s<this._ints;++s)this.tag.putInt32(this._s[s]^i[s]);return this.tag.truncate(this.tag.length()%(this._tagLength/8)),t.decrypt&&this.tag.bytes()!==this._tag&&(r=!1),r};ot.gcm.prototype.multiply=function(e,t){for(var r=[0,0,0,0],n=t.slice(0),i=0;i<128;++i){var s=e[i/32|0]&1<<31-i%32;s&&(r[0]^=n[0],r[1]^=n[1],r[2]^=n[2],r[3]^=n[3]),this.pow(n,n);}return r};ot.gcm.prototype.pow=function(e,t){for(var r=e[3]&1,n=3;n>0;--n)t[n]=e[n]>>>1|(e[n-1]&1)<<31;t[0]=e[0]>>>1,r&&(t[0]^=this._R);};ot.gcm.prototype.tableMultiply=function(e){for(var t=[0,0,0,0],r=0;r<32;++r){var n=r/8|0,i=e[n]>>>(7-r%8)*4&15,s=this._m[r][i];t[0]^=s[0],t[1]^=s[1],t[2]^=s[2],t[3]^=s[3];}return t};ot.gcm.prototype.ghash=function(e,t,r){return t[0]^=r[0],t[1]^=r[1],t[2]^=r[2],t[3]^=r[3],this.tableMultiply(t)};ot.gcm.prototype.generateHashTable=function(e,t){for(var r=8/t,n=4*r,i=16*r,s=new Array(i),o=0;o<i;++o){var a=[0,0,0,0],c=o/n|0,l=(n-1-o%n)*t;a[c]=1<<t-1<<l,s[o]=this.generateSubHashTable(this.multiply(a,e),t);}return s};ot.gcm.prototype.generateSubHashTable=function(e,t){var r=1<<t,n=r>>>1,i=new Array(r);i[n]=e.slice(0);for(var s=n>>>1;s>0;)this.pow(i[2*s],i[s]=[]),s>>=1;for(s=2;s<n;){for(var o=1;o<s;++o){var a=i[s],c=i[o];i[s+o]=[a[0]^c[0],a[1]^c[1],a[2]^c[2],a[3]^c[3]];}s*=2;}for(i[0]=[0,0,0,0],s=n+1;s<r;++s){var l=i[s^n];i[s]=[e[0]^l[0],e[1]^l[1],e[2]^l[2],e[3]^l[3]];}return i};function gh(e,t){if(typeof e=="string"&&(e=Sr.util.createBuffer(e)),Sr.util.isArray(e)&&e.length>4){var r=e;e=Sr.util.createBuffer();for(var n=0;n<r.length;++n)e.putByte(r[n]);}if(e.length()<t)throw new Error("Invalid IV length; got "+e.length()+" bytes and expected "+t+" bytes.");if(!Sr.util.isArray(e)){for(var i=[],s=t/4,n=0;n<s;++n)i.push(e.getInt32());e=i;}return e}function mh(e){e[e.length-1]=e[e.length-1]+1&4294967295;}function lv(e){return [e/4294967296|0,e&4294967295]}});var Ss=A((Che,$N)=>{var qt=rt();ph();fv();vt();$N.exports=qt.aes=qt.aes||{};qt.aes.startEncrypting=function(e,t,r,n){var i=yh({key:e,output:r,decrypt:!1,mode:n});return i.start(t),i};qt.aes.createEncryptionCipher=function(e,t){return yh({key:e,output:null,decrypt:!1,mode:t})};qt.aes.startDecrypting=function(e,t,r,n){var i=yh({key:e,output:r,decrypt:!0,mode:n});return i.start(t),i};qt.aes.createDecryptionCipher=function(e,t){return yh({key:e,output:null,decrypt:!0,mode:t})};qt.aes.Algorithm=function(e,t){pv||MN();var r=this;r.name=e,r.mode=new t({blockSize:16,cipher:{encrypt:function(n,i){return dv(r._w,n,i,!1)},decrypt:function(n,i){return dv(r._w,n,i,!0)}}}),r._init=!1;};qt.aes.Algorithm.prototype.initialize=function(e){if(!this._init){var t=e.key,r;if(typeof t=="string"&&(t.length===16||t.length===24||t.length===32))t=qt.util.createBuffer(t);else if(qt.util.isArray(t)&&(t.length===16||t.length===24||t.length===32)){r=t,t=qt.util.createBuffer();for(var n=0;n<r.length;++n)t.putByte(r[n]);}if(!qt.util.isArray(t)){r=t,t=[];var i=r.length();if(i===16||i===24||i===32){i=i>>>2;for(var n=0;n<i;++n)t.push(r.getInt32());}}if(!qt.util.isArray(t)||!(t.length===4||t.length===6||t.length===8))throw new Error("Invalid key parameter.");var s=this.mode.name,o=["CFB","OFB","CTR","GCM"].indexOf(s)!==-1;this._w=UN(t,e.decrypt&&!o),this._init=!0;}};qt.aes._expandKey=function(e,t){return pv||MN(),UN(e,t)};qt.aes._updateBlock=dv;Ca("AES-ECB",qt.cipher.modes.ecb);Ca("AES-CBC",qt.cipher.modes.cbc);Ca("AES-CFB",qt.cipher.modes.cfb);Ca("AES-OFB",qt.cipher.modes.ofb);Ca("AES-CTR",qt.cipher.modes.ctr);Ca("AES-GCM",qt.cipher.modes.gcm);function Ca(e,t){var r=function(){return new qt.aes.Algorithm(e,t)};qt.cipher.registerAlgorithm(e,r);}var pv=!1,ba=4,Gr,hv,FN,ho,ri;function MN(){pv=!0,FN=[0,1,2,4,8,16,32,64,128,27,54];for(var e=new Array(256),t=0;t<128;++t)e[t]=t<<1,e[t+128]=t+128<<1^283;Gr=new Array(256),hv=new Array(256),ho=new Array(4),ri=new Array(4);for(var t=0;t<4;++t)ho[t]=new Array(256),ri[t]=new Array(256);for(var r=0,n=0,i,s,o,a,c,l,u,t=0;t<256;++t){a=n^n<<1^n<<2^n<<3^n<<4,a=a>>8^a&255^99,Gr[r]=a,hv[a]=r,c=e[a],i=e[r],s=e[i],o=e[s],l=c<<24^a<<16^a<<8^(a^c),u=(i^s^o)<<24^(r^o)<<16^(r^s^o)<<8^(r^i^o);for(var f=0;f<4;++f)ho[f][r]=l,ri[f][a]=u,l=l<<24|l>>>8,u=u<<24|u>>>8;r===0?r=n=1:(r=i^e[e[e[i^o]]],n^=e[e[n]]);}}function UN(e,t){for(var r=e.slice(0),n,i=1,s=r.length,o=s+6+1,a=ba*o,c=s;c<a;++c)n=r[c-1],c%s===0?(n=Gr[n>>>16&255]<<24^Gr[n>>>8&255]<<16^Gr[n&255]<<8^Gr[n>>>24]^FN[i]<<24,i++):s>6&&c%s===4&&(n=Gr[n>>>24]<<24^Gr[n>>>16&255]<<16^Gr[n>>>8&255]<<8^Gr[n&255]),r[c]=r[c-s]^n;if(t){var l,u=ri[0],f=ri[1],d=ri[2],p=ri[3],m=r.slice(0);a=r.length;for(var c=0,S=a-ba;c<a;c+=ba,S-=ba)if(c===0||c===a-ba)m[c]=r[S],m[c+1]=r[S+3],m[c+2]=r[S+2],m[c+3]=r[S+1];else for(var x=0;x<ba;++x)l=r[S+x],m[c+(3&-x)]=u[Gr[l>>>24]]^f[Gr[l>>>16&255]]^d[Gr[l>>>8&255]]^p[Gr[l&255]];r=m;}return r}function dv(e,t,r,n){var i=e.length/4-1,s,o,a,c,l;n?(s=ri[0],o=ri[1],a=ri[2],c=ri[3],l=hv):(s=ho[0],o=ho[1],a=ho[2],c=ho[3],l=Gr);var u,f,d,p,m,S,x;u=t[0]^e[0],f=t[n?3:1]^e[1],d=t[2]^e[2],p=t[n?1:3]^e[3];for(var I=3,v=1;v<i;++v)m=s[u>>>24]^o[f>>>16&255]^a[d>>>8&255]^c[p&255]^e[++I],S=s[f>>>24]^o[d>>>16&255]^a[p>>>8&255]^c[u&255]^e[++I],x=s[d>>>24]^o[p>>>16&255]^a[u>>>8&255]^c[f&255]^e[++I],p=s[p>>>24]^o[u>>>16&255]^a[f>>>8&255]^c[d&255]^e[++I],u=m,f=S,d=x;r[0]=l[u>>>24]<<24^l[f>>>16&255]<<16^l[d>>>8&255]<<8^l[p&255]^e[++I],r[n?3:1]=l[f>>>24]<<24^l[d>>>16&255]<<16^l[p>>>8&255]<<8^l[u&255]^e[++I],r[2]=l[d>>>24]<<24^l[p>>>16&255]<<16^l[u>>>8&255]<<8^l[f&255]^e[++I],r[n?1:3]=l[p>>>24]<<24^l[u>>>16&255]<<16^l[f>>>8&255]<<8^l[d&255]^e[++I];}function yh(e){e=e||{};var t=(e.mode||"CBC").toUpperCase(),r="AES-"+t,n;e.decrypt?n=qt.cipher.createDecipher(r,e.key):n=qt.cipher.createCipher(r,e.key);var i=n.start;return n.start=function(s,o){var a=null;o instanceof qt.util.ByteBuffer&&(a=o,o={}),o=o||{},o.output=a,o.iv=s,i.call(n,o);},n}});var bs=A((Ehe,jN)=>{var dc=rt();dc.pki=dc.pki||{};var gv=jN.exports=dc.pki.oids=dc.oids=dc.oids||{};function pe(e,t){gv[e]=t,gv[t]=e;}function At(e,t){gv[e]=t;}pe("1.2.840.113549.1.1.1","rsaEncryption");pe("1.2.840.113549.1.1.4","md5WithRSAEncryption");pe("1.2.840.113549.1.1.5","sha1WithRSAEncryption");pe("1.2.840.113549.1.1.7","RSAES-OAEP");pe("1.2.840.113549.1.1.8","mgf1");pe("1.2.840.113549.1.1.9","pSpecified");pe("1.2.840.113549.1.1.10","RSASSA-PSS");pe("1.2.840.113549.1.1.11","sha256WithRSAEncryption");pe("1.2.840.113549.1.1.12","sha384WithRSAEncryption");pe("1.2.840.113549.1.1.13","sha512WithRSAEncryption");pe("1.3.101.112","EdDSA25519");pe("1.2.840.10040.4.3","dsa-with-sha1");pe("1.3.14.3.2.7","desCBC");pe("1.3.14.3.2.26","sha1");pe("1.3.14.3.2.29","sha1WithRSASignature");pe("2.16.840.1.101.3.4.2.1","sha256");pe("2.16.840.1.101.3.4.2.2","sha384");pe("2.16.840.1.101.3.4.2.3","sha512");pe("2.16.840.1.101.3.4.2.4","sha224");pe("2.16.840.1.101.3.4.2.5","sha512-224");pe("2.16.840.1.101.3.4.2.6","sha512-256");pe("1.2.840.113549.2.2","md2");pe("1.2.840.113549.2.5","md5");pe("1.2.840.113549.1.7.1","data");pe("1.2.840.113549.1.7.2","signedData");pe("1.2.840.113549.1.7.3","envelopedData");pe("1.2.840.113549.1.7.4","signedAndEnvelopedData");pe("1.2.840.113549.1.7.5","digestedData");pe("1.2.840.113549.1.7.6","encryptedData");pe("1.2.840.113549.1.9.1","emailAddress");pe("1.2.840.113549.1.9.2","unstructuredName");pe("1.2.840.113549.1.9.3","contentType");pe("1.2.840.113549.1.9.4","messageDigest");pe("1.2.840.113549.1.9.5","signingTime");pe("1.2.840.113549.1.9.6","counterSignature");pe("1.2.840.113549.1.9.7","challengePassword");pe("1.2.840.113549.1.9.8","unstructuredAddress");pe("1.2.840.113549.1.9.14","extensionRequest");pe("1.2.840.113549.1.9.20","friendlyName");pe("1.2.840.113549.1.9.21","localKeyId");pe("1.2.840.113549.1.9.22.1","x509Certificate");pe("1.2.840.113549.1.12.10.1.1","keyBag");pe("1.2.840.113549.1.12.10.1.2","pkcs8ShroudedKeyBag");pe("1.2.840.113549.1.12.10.1.3","certBag");pe("1.2.840.113549.1.12.10.1.4","crlBag");pe("1.2.840.113549.1.12.10.1.5","secretBag");pe("1.2.840.113549.1.12.10.1.6","safeContentsBag");pe("1.2.840.113549.1.5.13","pkcs5PBES2");pe("1.2.840.113549.1.5.12","pkcs5PBKDF2");pe("1.2.840.113549.1.12.1.1","pbeWithSHAAnd128BitRC4");pe("1.2.840.113549.1.12.1.2","pbeWithSHAAnd40BitRC4");pe("1.2.840.113549.1.12.1.3","pbeWithSHAAnd3-KeyTripleDES-CBC");pe("1.2.840.113549.1.12.1.4","pbeWithSHAAnd2-KeyTripleDES-CBC");pe("1.2.840.113549.1.12.1.5","pbeWithSHAAnd128BitRC2-CBC");pe("1.2.840.113549.1.12.1.6","pbewithSHAAnd40BitRC2-CBC");pe("1.2.840.113549.2.7","hmacWithSHA1");pe("1.2.840.113549.2.8","hmacWithSHA224");pe("1.2.840.113549.2.9","hmacWithSHA256");pe("1.2.840.113549.2.10","hmacWithSHA384");pe("1.2.840.113549.2.11","hmacWithSHA512");pe("1.2.840.113549.3.7","des-EDE3-CBC");pe("2.16.840.1.101.3.4.1.2","aes128-CBC");pe("2.16.840.1.101.3.4.1.22","aes192-CBC");pe("2.16.840.1.101.3.4.1.42","aes256-CBC");pe("2.5.4.3","commonName");pe("2.5.4.4","surname");pe("2.5.4.5","serialNumber");pe("2.5.4.6","countryName");pe("2.5.4.7","localityName");pe("2.5.4.8","stateOrProvinceName");pe("2.5.4.9","streetAddress");pe("2.5.4.10","organizationName");pe("2.5.4.11","organizationalUnitName");pe("2.5.4.12","title");pe("2.5.4.13","description");pe("2.5.4.15","businessCategory");pe("2.5.4.17","postalCode");pe("2.5.4.42","givenName");pe("1.3.6.1.4.1.311.60.2.1.2","jurisdictionOfIncorporationStateOrProvinceName");pe("1.3.6.1.4.1.311.60.2.1.3","jurisdictionOfIncorporationCountryName");pe("2.16.840.1.113730.1.1","nsCertType");pe("2.16.840.1.113730.1.13","nsComment");At("2.5.29.1","authorityKeyIdentifier");At("2.5.29.2","keyAttributes");At("2.5.29.3","certificatePolicies");At("2.5.29.4","keyUsageRestriction");At("2.5.29.5","policyMapping");At("2.5.29.6","subtreesConstraint");At("2.5.29.7","subjectAltName");At("2.5.29.8","issuerAltName");At("2.5.29.9","subjectDirectoryAttributes");At("2.5.29.10","basicConstraints");At("2.5.29.11","nameConstraints");At("2.5.29.12","policyConstraints");At("2.5.29.13","basicConstraints");pe("2.5.29.14","subjectKeyIdentifier");pe("2.5.29.15","keyUsage");At("2.5.29.16","privateKeyUsagePeriod");pe("2.5.29.17","subjectAltName");pe("2.5.29.18","issuerAltName");pe("2.5.29.19","basicConstraints");At("2.5.29.20","cRLNumber");At("2.5.29.21","cRLReason");At("2.5.29.22","expirationDate");At("2.5.29.23","instructionCode");At("2.5.29.24","invalidityDate");At("2.5.29.25","cRLDistributionPoints");At("2.5.29.26","issuingDistributionPoint");At("2.5.29.27","deltaCRLIndicator");At("2.5.29.28","issuingDistributionPoint");At("2.5.29.29","certificateIssuer");At("2.5.29.30","nameConstraints");pe("2.5.29.31","cRLDistributionPoints");pe("2.5.29.32","certificatePolicies");At("2.5.29.33","policyMappings");At("2.5.29.34","policyConstraints");pe("2.5.29.35","authorityKeyIdentifier");At("2.5.29.36","policyConstraints");pe("2.5.29.37","extKeyUsage");At("2.5.29.46","freshestCRL");At("2.5.29.54","inhibitAnyPolicy");pe("1.3.6.1.4.1.11129.2.4.2","timestampList");pe("1.3.6.1.5.5.7.1.1","authorityInfoAccess");pe("1.3.6.1.5.5.7.3.1","serverAuth");pe("1.3.6.1.5.5.7.3.2","clientAuth");pe("1.3.6.1.5.5.7.3.3","codeSigning");pe("1.3.6.1.5.5.7.3.4","emailProtection");pe("1.3.6.1.5.5.7.3.8","timeStamping");});var ni=A((xhe,HN)=>{var jt=rt();vt();bs();var xe=HN.exports=jt.asn1=jt.asn1||{};xe.Class={UNIVERSAL:0,APPLICATION:64,CONTEXT_SPECIFIC:128,PRIVATE:192};xe.Type={NONE:0,BOOLEAN:1,INTEGER:2,BITSTRING:3,OCTETSTRING:4,NULL:5,OID:6,ODESC:7,EXTERNAL:8,REAL:9,ENUMERATED:10,EMBEDDED:11,UTF8:12,ROID:13,SEQUENCE:16,SET:17,PRINTABLESTRING:19,IA5STRING:22,UTCTIME:23,GENERALIZEDTIME:24,BMPSTRING:30};xe.create=function(e,t,r,n,i){if(jt.util.isArray(n)){for(var s=[],o=0;o<n.length;++o)n[o]!==void 0&&s.push(n[o]);n=s;}var a={tagClass:e,type:t,constructed:r,composed:r||jt.util.isArray(n),value:n};return i&&"bitStringContents"in i&&(a.bitStringContents=i.bitStringContents,a.original=xe.copy(a)),a};xe.copy=function(e,t){var r;if(jt.util.isArray(e)){r=[];for(var n=0;n<e.length;++n)r.push(xe.copy(e[n],t));return r}return typeof e=="string"?e:(r={tagClass:e.tagClass,type:e.type,constructed:e.constructed,composed:e.composed,value:xe.copy(e.value,t)},t&&!t.excludeBitStringContents&&(r.bitStringContents=e.bitStringContents),r)};xe.equals=function(e,t,r){if(jt.util.isArray(e)){if(!jt.util.isArray(t)||e.length!==t.length)return !1;for(var n=0;n<e.length;++n)if(!xe.equals(e[n],t[n]))return !1;return !0}if(typeof e!=typeof t)return !1;if(typeof e=="string")return e===t;var i=e.tagClass===t.tagClass&&e.type===t.type&&e.constructed===t.constructed&&e.composed===t.composed&&xe.equals(e.value,t.value);return r&&r.includeBitStringContents&&(i=i&&e.bitStringContents===t.bitStringContents),i};xe.getBerValueLength=function(e){var t=e.getByte();if(t!==128){var r,n=t&128;return n?r=e.getInt((t&127)<<3):r=t,r}};function pc(e,t,r){if(r>t){var n=new Error("Too few bytes to parse DER.");throw n.available=e.length(),n.remaining=t,n.requested=r,n}}var yZ=function(e,t){var r=e.getByte();if(t--,r!==128){var n,i=r&128;if(!i)n=r;else {var s=r&127;pc(e,t,s),n=e.getInt(s<<3);}if(n<0)throw new Error("Negative length: "+n);return n}};xe.fromDer=function(e,t){t===void 0&&(t={strict:!0,parseAllBytes:!0,decodeBitStrings:!0}),typeof t=="boolean"&&(t={strict:t,parseAllBytes:!0,decodeBitStrings:!0}),"strict"in t||(t.strict=!0),"parseAllBytes"in t||(t.parseAllBytes=!0),"decodeBitStrings"in t||(t.decodeBitStrings=!0),typeof e=="string"&&(e=jt.util.createBuffer(e));var r=e.length(),n=vh(e,e.length(),0,t);if(t.parseAllBytes&&e.length()!==0){var i=new Error("Unparsed DER bytes remain after ASN.1 parsing.");throw i.byteCount=r,i.remaining=e.length(),i}return n};function vh(e,t,r,n){var i;pc(e,t,2);var s=e.getByte();t--;var o=s&192,a=s&31;i=e.length();var c=yZ(e,t);if(t-=i-e.length(),c!==void 0&&c>t){if(n.strict){var l=new Error("Too few bytes to read ASN.1 value.");throw l.available=e.length(),l.remaining=t,l.requested=c,l}c=t;}var u,f,d=(s&32)===32;if(d)if(u=[],c===void 0)for(;;){if(pc(e,t,2),e.bytes(2)==="\0\0"){e.getBytes(2),t-=2;break}i=e.length(),u.push(vh(e,t,r+1,n)),t-=i-e.length();}else for(;c>0;)i=e.length(),u.push(vh(e,c,r+1,n)),t-=i-e.length(),c-=i-e.length();if(u===void 0&&o===xe.Class.UNIVERSAL&&a===xe.Type.BITSTRING&&(f=e.bytes(c)),u===void 0&&n.decodeBitStrings&&o===xe.Class.UNIVERSAL&&a===xe.Type.BITSTRING&&c>1){var p=e.read,m=t,S=0;if(a===xe.Type.BITSTRING&&(pc(e,t,1),S=e.getByte(),t--),S===0)try{i=e.length();var x={strict:!0,decodeBitStrings:!0},I=vh(e,t,r+1,x),v=i-e.length();t-=v,a==xe.Type.BITSTRING&&v++;var b=I.tagClass;v===c&&(b===xe.Class.UNIVERSAL||b===xe.Class.CONTEXT_SPECIFIC)&&(u=[I]);}catch{}u===void 0&&(e.read=p,t=m);}if(u===void 0){if(c===void 0){if(n.strict)throw new Error("Non-constructed ASN.1 object of indefinite length.");c=t;}if(a===xe.Type.BMPSTRING)for(u="";c>0;c-=2)pc(e,t,2),u+=String.fromCharCode(e.getInt16()),t-=2;else u=e.getBytes(c),t-=c;}var D=f===void 0?null:{bitStringContents:f};return xe.create(o,a,d,u,D)}xe.toDer=function(e){var t=jt.util.createBuffer(),r=e.tagClass|e.type,n=jt.util.createBuffer(),i=!1;if("bitStringContents"in e&&(i=!0,e.original&&(i=xe.equals(e,e.original))),i)n.putBytes(e.bitStringContents);else if(e.composed){e.constructed?r|=32:n.putByte(0);for(var s=0;s<e.value.length;++s)e.value[s]!==void 0&&n.putBuffer(xe.toDer(e.value[s]));}else if(e.type===xe.Type.BMPSTRING)for(var s=0;s<e.value.length;++s)n.putInt16(e.value.charCodeAt(s));else e.type===xe.Type.INTEGER&&e.value.length>1&&(e.value.charCodeAt(0)===0&&!(e.value.charCodeAt(1)&128)||e.value.charCodeAt(0)===255&&(e.value.charCodeAt(1)&128)===128)?n.putBytes(e.value.substr(1)):n.putBytes(e.value);if(t.putByte(r),n.length()<=127)t.putByte(n.length()&127);else {var o=n.length(),a="";do a+=String.fromCharCode(o&255),o=o>>>8;while(o>0);t.putByte(a.length|128);for(var s=a.length-1;s>=0;--s)t.putByte(a.charCodeAt(s));}return t.putBuffer(n),t};xe.oidToDer=function(e){var t=e.split("."),r=jt.util.createBuffer();r.putByte(40*parseInt(t[0],10)+parseInt(t[1],10));for(var n,i,s,o,a=2;a<t.length;++a){n=!0,i=[],s=parseInt(t[a],10);do o=s&127,s=s>>>7,n||(o|=128),i.push(o),n=!1;while(s>0);for(var c=i.length-1;c>=0;--c)r.putByte(i[c]);}return r};xe.derToOid=function(e){var t;typeof e=="string"&&(e=jt.util.createBuffer(e));var r=e.getByte();t=Math.floor(r/40)+"."+r%40;for(var n=0;e.length()>0;)r=e.getByte(),n=n<<7,r&128?n+=r&127:(t+="."+(n+r),n=0);return t};xe.utcTimeToDate=function(e){var t=new Date,r=parseInt(e.substr(0,2),10);r=r>=50?1900+r:2e3+r;var n=parseInt(e.substr(2,2),10)-1,i=parseInt(e.substr(4,2),10),s=parseInt(e.substr(6,2),10),o=parseInt(e.substr(8,2),10),a=0;if(e.length>11){var c=e.charAt(10),l=10;c!=="+"&&c!=="-"&&(a=parseInt(e.substr(10,2),10),l+=2);}if(t.setUTCFullYear(r,n,i),t.setUTCHours(s,o,a,0),l&&(c=e.charAt(l),c==="+"||c==="-")){var u=parseInt(e.substr(l+1,2),10),f=parseInt(e.substr(l+4,2),10),d=u*60+f;d*=6e4,c==="+"?t.setTime(+t-d):t.setTime(+t+d);}return t};xe.generalizedTimeToDate=function(e){var t=new Date,r=parseInt(e.substr(0,4),10),n=parseInt(e.substr(4,2),10)-1,i=parseInt(e.substr(6,2),10),s=parseInt(e.substr(8,2),10),o=parseInt(e.substr(10,2),10),a=parseInt(e.substr(12,2),10),c=0,l=0,u=!1;e.charAt(e.length-1)==="Z"&&(u=!0);var f=e.length-5,d=e.charAt(f);if(d==="+"||d==="-"){var p=parseInt(e.substr(f+1,2),10),m=parseInt(e.substr(f+4,2),10);l=p*60+m,l*=6e4,d==="+"&&(l*=-1),u=!0;}return e.charAt(14)==="."&&(c=parseFloat(e.substr(14),10)*1e3),u?(t.setUTCFullYear(r,n,i),t.setUTCHours(s,o,a,c),t.setTime(+t+l)):(t.setFullYear(r,n,i),t.setHours(s,o,a,c)),t};xe.dateToUtcTime=function(e){if(typeof e=="string")return e;var t="",r=[];r.push((""+e.getUTCFullYear()).substr(2)),r.push(""+(e.getUTCMonth()+1)),r.push(""+e.getUTCDate()),r.push(""+e.getUTCHours()),r.push(""+e.getUTCMinutes()),r.push(""+e.getUTCSeconds());for(var n=0;n<r.length;++n)r[n].length<2&&(t+="0"),t+=r[n];return t+="Z",t};xe.dateToGeneralizedTime=function(e){if(typeof e=="string")return e;var t="",r=[];r.push(""+e.getUTCFullYear()),r.push(""+(e.getUTCMonth()+1)),r.push(""+e.getUTCDate()),r.push(""+e.getUTCHours()),r.push(""+e.getUTCMinutes()),r.push(""+e.getUTCSeconds());for(var n=0;n<r.length;++n)r[n].length<2&&(t+="0"),t+=r[n];return t+="Z",t};xe.integerToDer=function(e){var t=jt.util.createBuffer();if(e>=-128&&e<128)return t.putSignedInt(e,8);if(e>=-32768&&e<32768)return t.putSignedInt(e,16);if(e>=-8388608&&e<8388608)return t.putSignedInt(e,24);if(e>=-2147483648&&e<2147483648)return t.putSignedInt(e,32);var r=new Error("Integer too large; max is 32-bits.");throw r.integer=e,r};xe.derToInteger=function(e){typeof e=="string"&&(e=jt.util.createBuffer(e));var t=e.length()*8;if(t>32)throw new Error("Integer too large; max is 32-bits.");return e.getSignedInt(t)};xe.validate=function(e,t,r,n){var i=!1;if((e.tagClass===t.tagClass||typeof t.tagClass>"u")&&(e.type===t.type||typeof t.type>"u"))if(e.constructed===t.constructed||typeof t.constructed>"u"){if(i=!0,t.value&&jt.util.isArray(t.value))for(var s=0,o=0;i&&o<t.value.length;++o)i=t.value[o].optional||!1,e.value[s]&&(i=xe.validate(e.value[s],t.value[o],r,n),i?++s:t.value[o].optional&&(i=!0)),!i&&n&&n.push("["+t.name+'] Tag class "'+t.tagClass+'", type "'+t.type+'" expected value length "'+t.value.length+'", got "'+e.value.length+'"');if(i&&r&&(t.capture&&(r[t.capture]=e.value),t.captureAsn1&&(r[t.captureAsn1]=e),t.captureBitStringContents&&"bitStringContents"in e&&(r[t.captureBitStringContents]=e.bitStringContents),t.captureBitStringValue&&"bitStringContents"in e)){if(e.bitStringContents.length<2)r[t.captureBitStringValue]="";else {var c=e.bitStringContents.charCodeAt(0);if(c!==0)throw new Error("captureBitStringValue only supported for zero unused bits");r[t.captureBitStringValue]=e.bitStringContents.slice(1);}}}else n&&n.push("["+t.name+'] Expected constructed "'+t.constructed+'", got "'+e.constructed+'"');else n&&(e.tagClass!==t.tagClass&&n.push("["+t.name+'] Expected tag class "'+t.tagClass+'", got "'+e.tagClass+'"'),e.type!==t.type&&n.push("["+t.name+'] Expected type "'+t.type+'", got "'+e.type+'"'));return i};var VN=/[^\\u0000-\\u00ff]/;xe.prettyPrint=function(e,t,r){var n="";t=t||0,r=r||2,t>0&&(n+=`
`);for(var i="",s=0;s<t*r;++s)i+=" ";switch(n+=i+"Tag: ",e.tagClass){case xe.Class.UNIVERSAL:n+="Universal:";break;case xe.Class.APPLICATION:n+="Application:";break;case xe.Class.CONTEXT_SPECIFIC:n+="Context-Specific:";break;case xe.Class.PRIVATE:n+="Private:";break}if(e.tagClass===xe.Class.UNIVERSAL)switch(n+=e.type,e.type){case xe.Type.NONE:n+=" (None)";break;case xe.Type.BOOLEAN:n+=" (Boolean)";break;case xe.Type.INTEGER:n+=" (Integer)";break;case xe.Type.BITSTRING:n+=" (Bit string)";break;case xe.Type.OCTETSTRING:n+=" (Octet string)";break;case xe.Type.NULL:n+=" (Null)";break;case xe.Type.OID:n+=" (Object Identifier)";break;case xe.Type.ODESC:n+=" (Object Descriptor)";break;case xe.Type.EXTERNAL:n+=" (External or Instance of)";break;case xe.Type.REAL:n+=" (Real)";break;case xe.Type.ENUMERATED:n+=" (Enumerated)";break;case xe.Type.EMBEDDED:n+=" (Embedded PDV)";break;case xe.Type.UTF8:n+=" (UTF8)";break;case xe.Type.ROID:n+=" (Relative Object Identifier)";break;case xe.Type.SEQUENCE:n+=" (Sequence)";break;case xe.Type.SET:n+=" (Set)";break;case xe.Type.PRINTABLESTRING:n+=" (Printable String)";break;case xe.Type.IA5String:n+=" (IA5String (ASCII))";break;case xe.Type.UTCTIME:n+=" (UTC time)";break;case xe.Type.GENERALIZEDTIME:n+=" (Generalized time)";break;case xe.Type.BMPSTRING:n+=" (BMP String)";break}else n+=e.type;if(n+=`
`,n+=i+"Constructed: "+e.constructed+`
`,e.composed){for(var o=0,a="",s=0;s<e.value.length;++s)e.value[s]!==void 0&&(o+=1,a+=xe.prettyPrint(e.value[s],t+1,r),s+1<e.value.length&&(a+=","));n+=i+"Sub values: "+o+a;}else {if(n+=i+"Value: ",e.type===xe.Type.OID){var c=xe.derToOid(e.value);n+=c,jt.pki&&jt.pki.oids&&c in jt.pki.oids&&(n+=" ("+jt.pki.oids[c]+") ");}if(e.type===xe.Type.INTEGER)try{n+=xe.derToInteger(e.value);}catch{n+="0x"+jt.util.bytesToHex(e.value);}else if(e.type===xe.Type.BITSTRING){if(e.value.length>1?n+="0x"+jt.util.bytesToHex(e.value.slice(1)):n+="(none)",e.value.length>0){var l=e.value.charCodeAt(0);l==1?n+=" (1 unused bit shown)":l>1&&(n+=" ("+l+" unused bits shown)");}}else if(e.type===xe.Type.OCTETSTRING)VN.test(e.value)||(n+="("+e.value+") "),n+="0x"+jt.util.bytesToHex(e.value);else if(e.type===xe.Type.UTF8)try{n+=jt.util.decodeUtf8(e.value);}catch(u){if(u.message==="URI malformed")n+="0x"+jt.util.bytesToHex(e.value)+" (malformed UTF8)";else throw u}else e.type===xe.Type.PRINTABLESTRING||e.type===xe.Type.IA5String?n+=e.value:VN.test(e.value)?n+="0x"+jt.util.bytesToHex(e.value):e.value.length===0?n+="[null]":n+=e.value;}return n};});var Si=A((whe,WN)=>{var Sh=rt();WN.exports=Sh.md=Sh.md||{};Sh.md.algorithms=Sh.md.algorithms||{};});var Ea=A((_he,KN)=>{var Ki=rt();Si();vt();var vZ=KN.exports=Ki.hmac=Ki.hmac||{};vZ.create=function(){var e=null,t=null,r=null,n=null,i={};return i.start=function(s,o){if(s!==null)if(typeof s=="string")if(s=s.toLowerCase(),s in Ki.md.algorithms)t=Ki.md.algorithms[s].create();else throw new Error('Unknown hash algorithm "'+s+'"');else t=s;if(o===null)o=e;else {if(typeof o=="string")o=Ki.util.createBuffer(o);else if(Ki.util.isArray(o)){var a=o;o=Ki.util.createBuffer();for(var c=0;c<a.length;++c)o.putByte(a[c]);}var l=o.length();l>t.blockLength&&(t.start(),t.update(o.bytes()),o=t.digest()),r=Ki.util.createBuffer(),n=Ki.util.createBuffer(),l=o.length();for(var c=0;c<l;++c){var a=o.at(c);r.putByte(54^a),n.putByte(92^a);}if(l<t.blockLength)for(var a=t.blockLength-l,c=0;c<a;++c)r.putByte(54),n.putByte(92);e=o,r=r.bytes(),n=n.bytes();}t.start(),t.update(r);},i.update=function(s){t.update(s);},i.getMac=function(){var s=t.digest().bytes();return t.start(),t.update(n),t.update(s),t.digest()},i.digest=i.getMac,i};});var Ch=A((The,QN)=>{var bi=rt();Si();vt();var GN=QN.exports=bi.md5=bi.md5||{};bi.md.md5=bi.md.algorithms.md5=GN;GN.create=function(){YN||SZ();var e=null,t=bi.util.createBuffer(),r=new Array(16),n={algorithm:"md5",blockLength:64,digestLength:16,messageLength:0,fullMessageLength:null,messageLengthSize:8};return n.start=function(){n.messageLength=0,n.fullMessageLength=n.messageLength64=[];for(var i=n.messageLengthSize/4,s=0;s<i;++s)n.fullMessageLength.push(0);return t=bi.util.createBuffer(),e={h0:1732584193,h1:4023233417,h2:2562383102,h3:271733878},n},n.start(),n.update=function(i,s){s==="utf8"&&(i=bi.util.encodeUtf8(i));var o=i.length;n.messageLength+=o,o=[o/4294967296>>>0,o>>>0];for(var a=n.fullMessageLength.length-1;a>=0;--a)n.fullMessageLength[a]+=o[1],o[1]=o[0]+(n.fullMessageLength[a]/4294967296>>>0),n.fullMessageLength[a]=n.fullMessageLength[a]>>>0,o[0]=o[1]/4294967296>>>0;return t.putBytes(i),zN(e,r,t),(t.read>2048||t.length()===0)&&t.compact(),n},n.digest=function(){var i=bi.util.createBuffer();i.putBytes(t.bytes());var s=n.fullMessageLength[n.fullMessageLength.length-1]+n.messageLengthSize,o=s&n.blockLength-1;i.putBytes(mv.substr(0,n.blockLength-o));for(var a,c=0,l=n.fullMessageLength.length-1;l>=0;--l)a=n.fullMessageLength[l]*8+c,c=a/4294967296>>>0,i.putInt32Le(a>>>0);var u={h0:e.h0,h1:e.h1,h2:e.h2,h3:e.h3};zN(u,r,i);var f=bi.util.createBuffer();return f.putInt32Le(u.h0),f.putInt32Le(u.h1),f.putInt32Le(u.h2),f.putInt32Le(u.h3),f},n};var mv=null,bh=null,gc=null,xa=null,YN=!1;function SZ(){mv="\x80",mv+=bi.util.fillString("\0",64),bh=[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,1,6,11,0,5,10,15,4,9,14,3,8,13,2,7,12,5,8,11,14,1,4,7,10,13,0,3,6,9,12,15,2,0,7,14,5,12,3,10,1,8,15,6,13,4,11,2,9],gc=[7,12,17,22,7,12,17,22,7,12,17,22,7,12,17,22,5,9,14,20,5,9,14,20,5,9,14,20,5,9,14,20,4,11,16,23,4,11,16,23,4,11,16,23,4,11,16,23,6,10,15,21,6,10,15,21,6,10,15,21,6,10,15,21],xa=new Array(64);for(var e=0;e<64;++e)xa[e]=Math.floor(Math.abs(Math.sin(e+1))*4294967296);YN=!0;}function zN(e,t,r){for(var n,i,s,o,a,c,l,u,f=r.length();f>=64;){for(i=e.h0,s=e.h1,o=e.h2,a=e.h3,u=0;u<16;++u)t[u]=r.getInt32Le(),c=a^s&(o^a),n=i+c+xa[u]+t[u],l=gc[u],i=a,a=o,o=s,s+=n<<l|n>>>32-l;for(;u<32;++u)c=o^a&(s^o),n=i+c+xa[u]+t[bh[u]],l=gc[u],i=a,a=o,o=s,s+=n<<l|n>>>32-l;for(;u<48;++u)c=s^o^a,n=i+c+xa[u]+t[bh[u]],l=gc[u],i=a,a=o,o=s,s+=n<<l|n>>>32-l;for(;u<64;++u)c=o^(s|~a),n=i+c+xa[u]+t[bh[u]],l=gc[u],i=a,a=o,o=s,s+=n<<l|n>>>32-l;e.h0=e.h0+i|0,e.h1=e.h1+s|0,e.h2=e.h2+o|0,e.h3=e.h3+a|0,f-=64;}}});var po=A((Ahe,JN)=>{var xh=rt();vt();var XN=JN.exports=xh.pem=xh.pem||{};XN.encode=function(e,t){t=t||{};var r="-----BEGIN "+e.type+`-----\r
`,n;if(e.procType&&(n={name:"Proc-Type",values:[String(e.procType.version),e.procType.type]},r+=Eh(n)),e.contentDomain&&(n={name:"Content-Domain",values:[e.contentDomain]},r+=Eh(n)),e.dekInfo&&(n={name:"DEK-Info",values:[e.dekInfo.algorithm]},e.dekInfo.parameters&&n.values.push(e.dekInfo.parameters),r+=Eh(n)),e.headers)for(var i=0;i<e.headers.length;++i)r+=Eh(e.headers[i]);return e.procType&&(r+=`\r
`),r+=xh.util.encode64(e.body,t.maxline||64)+`\r
`,r+="-----END "+e.type+`-----\r
`,r};XN.decode=function(e){for(var t=[],r=/\s*-----BEGIN ([A-Z0-9- ]+)-----\r?\n?([\x21-\x7e\s]+?(?:\r?\n\r?\n))?([:A-Za-z0-9+\/=\s]+?)-----END \1-----/g,n=/([\x21-\x7e]+):\s*([\x21-\x7e\s^:]+)/,i=/\r?\n/,s;s=r.exec(e),!!s;){var o=s[1];o==="NEW CERTIFICATE REQUEST"&&(o="CERTIFICATE REQUEST");var a={type:o,procType:null,contentDomain:null,dekInfo:null,headers:[],body:xh.util.decode64(s[3])};if(t.push(a),!!s[2]){for(var c=s[2].split(i),l=0;s&&l<c.length;){for(var u=c[l].replace(/\s+$/,""),f=l+1;f<c.length;++f){var d=c[f];if(!/\s/.test(d[0]))break;u+=d,l=f;}if(s=u.match(n),s){for(var p={name:s[1],values:[]},m=s[2].split(","),S=0;S<m.length;++S)p.values.push(bZ(m[S]));if(a.procType)if(!a.contentDomain&&p.name==="Content-Domain")a.contentDomain=m[0]||"";else if(!a.dekInfo&&p.name==="DEK-Info"){if(p.values.length===0)throw new Error('Invalid PEM formatted message. The "DEK-Info" header must have at least one subfield.');a.dekInfo={algorithm:m[0],parameters:m[1]||null};}else a.headers.push(p);else {if(p.name!=="Proc-Type")throw new Error('Invalid PEM formatted message. The first encapsulated header must be "Proc-Type".');if(p.values.length!==2)throw new Error('Invalid PEM formatted message. The "Proc-Type" header must have two subfields.');a.procType={version:m[0],type:m[1]};}}++l;}if(a.procType==="ENCRYPTED"&&!a.dekInfo)throw new Error('Invalid PEM formatted message. The "DEK-Info" header must be present if "Proc-Type" is "ENCRYPTED".')}}if(t.length===0)throw new Error("Invalid PEM formatted message.");return t};function Eh(e){for(var t=e.name+": ",r=[],n=function(c,l){return " "+l},i=0;i<e.values.length;++i)r.push(e.values[i].replace(/^(\S+\r\n)/,n));t+=r.join(",")+`\r
`;for(var s=0,o=-1,i=0;i<t.length;++i,++s)if(s>65&&o!==-1){var a=t[o];a===","?(++o,t=t.substr(0,o)+`\r
 `+t.substr(o)):t=t.substr(0,o)+`\r
`+a+t.substr(o+1),s=i-o-1,o=-1,++i;}else (t[i]===" "||t[i]==="	"||t[i]===",")&&(o=i);return t}function bZ(e){return e.replace(/^\s+/,"")}});var mc=A((Rhe,eL)=>{var zt=rt();ph();fv();vt();eL.exports=zt.des=zt.des||{};zt.des.startEncrypting=function(e,t,r,n){var i=wh({key:e,output:r,decrypt:!1,mode:n||(t===null?"ECB":"CBC")});return i.start(t),i};zt.des.createEncryptionCipher=function(e,t){return wh({key:e,output:null,decrypt:!1,mode:t})};zt.des.startDecrypting=function(e,t,r,n){var i=wh({key:e,output:r,decrypt:!0,mode:n||(t===null?"ECB":"CBC")});return i.start(t),i};zt.des.createDecryptionCipher=function(e,t){return wh({key:e,output:null,decrypt:!0,mode:t})};zt.des.Algorithm=function(e,t){var r=this;r.name=e,r.mode=new t({blockSize:8,cipher:{encrypt:function(n,i){return ZN(r._keys,n,i,!1)},decrypt:function(n,i){return ZN(r._keys,n,i,!0)}}}),r._init=!1;};zt.des.Algorithm.prototype.initialize=function(e){if(!this._init){var t=zt.util.createBuffer(e.key);if(this.name.indexOf("3DES")===0&&t.length()!==24)throw new Error("Invalid Triple-DES key size: "+t.length()*8);this._keys=IZ(t),this._init=!0;}};Ci("DES-ECB",zt.cipher.modes.ecb);Ci("DES-CBC",zt.cipher.modes.cbc);Ci("DES-CFB",zt.cipher.modes.cfb);Ci("DES-OFB",zt.cipher.modes.ofb);Ci("DES-CTR",zt.cipher.modes.ctr);Ci("3DES-ECB",zt.cipher.modes.ecb);Ci("3DES-CBC",zt.cipher.modes.cbc);Ci("3DES-CFB",zt.cipher.modes.cfb);Ci("3DES-OFB",zt.cipher.modes.ofb);Ci("3DES-CTR",zt.cipher.modes.ctr);function Ci(e,t){var r=function(){return new zt.des.Algorithm(e,t)};zt.cipher.registerAlgorithm(e,r);}var CZ=[16843776,0,65536,16843780,16842756,66564,4,65536,1024,16843776,16843780,1024,16778244,16842756,16777216,4,1028,16778240,16778240,66560,66560,16842752,16842752,16778244,65540,16777220,16777220,65540,0,1028,66564,16777216,65536,16843780,4,16842752,16843776,16777216,16777216,1024,16842756,65536,66560,16777220,1024,4,16778244,66564,16843780,65540,16842752,16778244,16777220,1028,66564,16843776,1028,16778240,16778240,0,65540,66560,0,16842756],EZ=[-2146402272,-2147450880,32768,1081376,1048576,32,-2146435040,-2147450848,-2147483616,-2146402272,-2146402304,-2147483648,-2147450880,1048576,32,-2146435040,1081344,1048608,-2147450848,0,-2147483648,32768,1081376,-2146435072,1048608,-2147483616,0,1081344,32800,-2146402304,-2146435072,32800,0,1081376,-2146435040,1048576,-2147450848,-2146435072,-2146402304,32768,-2146435072,-2147450880,32,-2146402272,1081376,32,32768,-2147483648,32800,-2146402304,1048576,-2147483616,1048608,-2147450848,-2147483616,1048608,1081344,0,-2147450880,32800,-2147483648,-2146435040,-2146402272,1081344],xZ=[520,134349312,0,134348808,134218240,0,131592,134218240,131080,134217736,134217736,131072,134349320,131080,134348800,520,134217728,8,134349312,512,131584,134348800,134348808,131592,134218248,131584,131072,134218248,8,134349320,512,134217728,134349312,134217728,131080,520,131072,134349312,134218240,0,512,131080,134349320,134218240,134217736,512,0,134348808,134218248,131072,134217728,134349320,8,131592,131584,134217736,134348800,134218248,520,134348800,131592,8,134348808,131584],wZ=[8396801,8321,8321,128,8396928,8388737,8388609,8193,0,8396800,8396800,8396929,129,0,8388736,8388609,1,8192,8388608,8396801,128,8388608,8193,8320,8388737,1,8320,8388736,8192,8396928,8396929,129,8388736,8388609,8396800,8396929,129,0,0,8396800,8320,8388736,8388737,1,8396801,8321,8321,128,8396929,129,1,8192,8388609,8193,8396928,8388737,8193,8320,8388608,8396801,128,8388608,8192,8396928],_Z=[256,34078976,34078720,1107296512,524288,256,1073741824,34078720,1074266368,524288,33554688,1074266368,1107296512,1107820544,524544,1073741824,33554432,1074266112,1074266112,0,1073742080,1107820800,1107820800,33554688,1107820544,1073742080,0,1107296256,34078976,33554432,1107296256,524544,524288,1107296512,256,33554432,1073741824,34078720,1107296512,1074266368,33554688,1073741824,1107820544,34078976,1074266368,256,33554432,1107820544,1107820800,524544,1107296256,1107820800,34078720,0,1074266112,1107296256,524544,33554688,1073742080,524288,0,1074266112,34078976,1073742080],TZ=[536870928,541065216,16384,541081616,541065216,16,541081616,4194304,536887296,4210704,4194304,536870928,4194320,536887296,536870912,16400,0,4194320,536887312,16384,4210688,536887312,16,541065232,541065232,0,4210704,541081600,16400,4210688,541081600,536870912,536887296,16,541065232,4210688,541081616,4194304,16400,536870928,4194304,536887296,536870912,16400,536870928,541081616,4210688,541065216,4210704,541081600,0,541065232,16,16384,541065216,4210704,16384,4194320,536887312,0,541081600,536870912,4194320,536887312],AZ=[2097152,69206018,67110914,0,2048,67110914,2099202,69208064,69208066,2097152,0,67108866,2,67108864,69206018,2050,67110912,2099202,2097154,67110912,67108866,69206016,69208064,2097154,69206016,2048,2050,69208066,2099200,2,67108864,2099200,67108864,2099200,2097152,67110914,67110914,69206018,69206018,2,2097154,67108864,67110912,2097152,69208064,2050,2099202,69208064,2050,67108866,69208066,69206016,2099200,0,2,69208066,0,2099202,69206016,2048,67108866,67110912,2048,2097154],RZ=[268439616,4096,262144,268701760,268435456,268439616,64,268435456,262208,268697600,268701760,266240,268701696,266304,4096,64,268697600,268435520,268439552,4160,266240,262208,268697664,268701696,4160,0,0,268697664,268435520,268439552,266304,262144,266304,262144,268701696,4096,64,268697664,4096,266304,268439552,64,268435520,268697600,268697664,268435456,262144,268439616,0,268701760,262208,268435520,268697600,268439552,268439616,0,268701760,266240,266240,4160,4160,262208,268435456,268701696];function IZ(e){for(var t=[0,4,536870912,536870916,65536,65540,536936448,536936452,512,516,536871424,536871428,66048,66052,536936960,536936964],r=[0,1,1048576,1048577,67108864,67108865,68157440,68157441,256,257,1048832,1048833,67109120,67109121,68157696,68157697],n=[0,8,2048,2056,16777216,16777224,16779264,16779272,0,8,2048,2056,16777216,16777224,16779264,16779272],i=[0,2097152,134217728,136314880,8192,2105344,134225920,136323072,131072,2228224,134348800,136445952,139264,2236416,134356992,136454144],s=[0,262144,16,262160,0,262144,16,262160,4096,266240,4112,266256,4096,266240,4112,266256],o=[0,1024,32,1056,0,1024,32,1056,33554432,33555456,33554464,33555488,33554432,33555456,33554464,33555488],a=[0,268435456,524288,268959744,2,268435458,524290,268959746,0,268435456,524288,268959744,2,268435458,524290,268959746],c=[0,65536,2048,67584,536870912,536936448,536872960,536938496,131072,196608,133120,198656,537001984,537067520,537004032,537069568],l=[0,262144,0,262144,2,262146,2,262146,33554432,33816576,33554432,33816576,33554434,33816578,33554434,33816578],u=[0,268435456,8,268435464,0,268435456,8,268435464,1024,268436480,1032,268436488,1024,268436480,1032,268436488],f=[0,32,0,32,1048576,1048608,1048576,1048608,8192,8224,8192,8224,1056768,1056800,1056768,1056800],d=[0,16777216,512,16777728,2097152,18874368,2097664,18874880,67108864,83886080,67109376,83886592,69206016,85983232,69206528,85983744],p=[0,4096,134217728,134221824,524288,528384,134742016,134746112,16,4112,134217744,134221840,524304,528400,134742032,134746128],m=[0,4,256,260,0,4,256,260,1,5,257,261,1,5,257,261],S=e.length()>8?3:1,x=[],I=[0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,0],v=0,b,D=0;D<S;D++){var L=e.getInt32(),j=e.getInt32();b=(L>>>4^j)&252645135,j^=b,L^=b<<4,b=(j>>>-16^L)&65535,L^=b,j^=b<<-16,b=(L>>>2^j)&858993459,j^=b,L^=b<<2,b=(j>>>-16^L)&65535,L^=b,j^=b<<-16,b=(L>>>1^j)&1431655765,j^=b,L^=b<<1,b=(j>>>8^L)&16711935,L^=b,j^=b<<8,b=(L>>>1^j)&1431655765,j^=b,L^=b<<1,b=L<<8|j>>>20&240,L=j<<24|j<<8&16711680|j>>>8&65280|j>>>24&240,j=b;for(var J=0;J<I.length;++J){I[J]?(L=L<<2|L>>>26,j=j<<2|j>>>26):(L=L<<1|L>>>27,j=j<<1|j>>>27),L&=-15,j&=-15;var K=t[L>>>28]|r[L>>>24&15]|n[L>>>20&15]|i[L>>>16&15]|s[L>>>12&15]|o[L>>>8&15]|a[L>>>4&15],G=c[j>>>28]|l[j>>>24&15]|u[j>>>20&15]|f[j>>>16&15]|d[j>>>12&15]|p[j>>>8&15]|m[j>>>4&15];b=(G>>>16^K)&65535,x[v++]=K^b,x[v++]=G^b<<16;}}return x}function ZN(e,t,r,n){var i=e.length===32?3:9,s;i===3?s=n?[30,-2,-2]:[0,32,2]:s=n?[94,62,-2,32,64,2,30,-2,-2]:[0,32,2,62,30,-2,64,96,2];var o,a=t[0],c=t[1];o=(a>>>4^c)&252645135,c^=o,a^=o<<4,o=(a>>>16^c)&65535,c^=o,a^=o<<16,o=(c>>>2^a)&858993459,a^=o,c^=o<<2,o=(c>>>8^a)&16711935,a^=o,c^=o<<8,o=(a>>>1^c)&1431655765,c^=o,a^=o<<1,a=a<<1|a>>>31,c=c<<1|c>>>31;for(var l=0;l<i;l+=3){for(var u=s[l+1],f=s[l+2],d=s[l];d!=u;d+=f){var p=c^e[d],m=(c>>>4|c<<28)^e[d+1];o=a,a=c,c=o^(EZ[p>>>24&63]|wZ[p>>>16&63]|TZ[p>>>8&63]|RZ[p&63]|CZ[m>>>24&63]|xZ[m>>>16&63]|_Z[m>>>8&63]|AZ[m&63]);}o=a,a=c,c=o;}a=a>>>1|a<<31,c=c>>>1|c<<31,o=(a>>>1^c)&1431655765,c^=o,a^=o<<1,o=(c>>>8^a)&16711935,a^=o,c^=o<<8,o=(c>>>2^a)&858993459,a^=o,c^=o<<2,o=(a>>>16^c)&65535,c^=o,a^=o<<16,o=(a>>>4^c)&252645135,c^=o,a^=o<<4,r[0]=a,r[1]=c;}function wh(e){e=e||{};var t=(e.mode||"CBC").toUpperCase(),r="DES-"+t,n;e.decrypt?n=zt.cipher.createDecipher(r,e.key):n=zt.cipher.createCipher(r,e.key);var i=n.start;return n.start=function(s,o){var a=null;o instanceof zt.util.ByteBuffer&&(a=o,o={}),o=o||{},o.output=a,o.iv=s,i.call(n,o);},n}});var _h=A((Ihe,tL)=>{var Yr=rt();Ea();Si();vt();var DZ=Yr.pkcs5=Yr.pkcs5||{},zi;Yr.util.isNodejs&&!Yr.options.usePureJavaScript&&(zi=he("crypto"));tL.exports=Yr.pbkdf2=DZ.pbkdf2=function(e,t,r,n,i,s){if(typeof i=="function"&&(s=i,i=null),Yr.util.isNodejs&&!Yr.options.usePureJavaScript&&zi.pbkdf2&&(i===null||typeof i!="object")&&(zi.pbkdf2Sync.length>4||!i||i==="sha1"))return typeof i!="string"&&(i="sha1"),e=Buffer.from(e,"binary"),t=Buffer.from(t,"binary"),s?zi.pbkdf2Sync.length===4?zi.pbkdf2(e,t,r,n,function(b,D){if(b)return s(b);s(null,D.toString("binary"));}):zi.pbkdf2(e,t,r,n,i,function(b,D){if(b)return s(b);s(null,D.toString("binary"));}):zi.pbkdf2Sync.length===4?zi.pbkdf2Sync(e,t,r,n).toString("binary"):zi.pbkdf2Sync(e,t,r,n,i).toString("binary");if((typeof i>"u"||i===null)&&(i="sha1"),typeof i=="string"){if(!(i in Yr.md.algorithms))throw new Error("Unknown hash algorithm: "+i);i=Yr.md[i].create();}var o=i.digestLength;if(n>4294967295*o){var a=new Error("Derived key is too long.");if(s)return s(a);throw a}var c=Math.ceil(n/o),l=n-(c-1)*o,u=Yr.hmac.create();u.start(i,e);var f="",d,p,m;if(!s){for(var S=1;S<=c;++S){u.start(null,null),u.update(t),u.update(Yr.util.int32ToBytes(S)),d=m=u.digest().getBytes();for(var x=2;x<=r;++x)u.start(null,null),u.update(m),p=u.digest().getBytes(),d=Yr.util.xorBytes(d,p,o),m=p;f+=S<c?d:d.substr(0,l);}return f}var S=1,x;function I(){if(S>c)return s(null,f);u.start(null,null),u.update(t),u.update(Yr.util.int32ToBytes(S)),d=m=u.digest().getBytes(),x=2,v();}function v(){if(x<=r)return u.start(null,null),u.update(m),p=u.digest().getBytes(),d=Yr.util.xorBytes(d,p,o),m=p,++x,Yr.util.setImmediate(v);f+=S<c?d:d.substr(0,l),++S,I();}I();};});var vv=A((Dhe,oL)=>{var Ei=rt();Si();vt();var nL=oL.exports=Ei.sha256=Ei.sha256||{};Ei.md.sha256=Ei.md.algorithms.sha256=nL;nL.create=function(){iL||PZ();var e=null,t=Ei.util.createBuffer(),r=new Array(64),n={algorithm:"sha256",blockLength:64,digestLength:32,messageLength:0,fullMessageLength:null,messageLengthSize:8};return n.start=function(){n.messageLength=0,n.fullMessageLength=n.messageLength64=[];for(var i=n.messageLengthSize/4,s=0;s<i;++s)n.fullMessageLength.push(0);return t=Ei.util.createBuffer(),e={h0:1779033703,h1:3144134277,h2:1013904242,h3:2773480762,h4:1359893119,h5:2600822924,h6:528734635,h7:1541459225},n},n.start(),n.update=function(i,s){s==="utf8"&&(i=Ei.util.encodeUtf8(i));var o=i.length;n.messageLength+=o,o=[o/4294967296>>>0,o>>>0];for(var a=n.fullMessageLength.length-1;a>=0;--a)n.fullMessageLength[a]+=o[1],o[1]=o[0]+(n.fullMessageLength[a]/4294967296>>>0),n.fullMessageLength[a]=n.fullMessageLength[a]>>>0,o[0]=o[1]/4294967296>>>0;return t.putBytes(i),rL(e,r,t),(t.read>2048||t.length()===0)&&t.compact(),n},n.digest=function(){var i=Ei.util.createBuffer();i.putBytes(t.bytes());var s=n.fullMessageLength[n.fullMessageLength.length-1]+n.messageLengthSize,o=s&n.blockLength-1;i.putBytes(yv.substr(0,n.blockLength-o));for(var a,c,l=n.fullMessageLength[0]*8,u=0;u<n.fullMessageLength.length-1;++u)a=n.fullMessageLength[u+1]*8,c=a/4294967296>>>0,l+=c,i.putInt32(l>>>0),l=a>>>0;i.putInt32(l);var f={h0:e.h0,h1:e.h1,h2:e.h2,h3:e.h3,h4:e.h4,h5:e.h5,h6:e.h6,h7:e.h7};rL(f,r,i);var d=Ei.util.createBuffer();return d.putInt32(f.h0),d.putInt32(f.h1),d.putInt32(f.h2),d.putInt32(f.h3),d.putInt32(f.h4),d.putInt32(f.h5),d.putInt32(f.h6),d.putInt32(f.h7),d},n};var yv=null,iL=!1,sL=null;function PZ(){yv="\x80",yv+=Ei.util.fillString("\0",64),sL=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298],iL=!0;}function rL(e,t,r){for(var n,i,s,o,a,c,l,u,f,d,p,m,S,x,I,v=r.length();v>=64;){for(l=0;l<16;++l)t[l]=r.getInt32();for(;l<64;++l)n=t[l-2],n=(n>>>17|n<<15)^(n>>>19|n<<13)^n>>>10,i=t[l-15],i=(i>>>7|i<<25)^(i>>>18|i<<14)^i>>>3,t[l]=n+t[l-7]+i+t[l-16]|0;for(u=e.h0,f=e.h1,d=e.h2,p=e.h3,m=e.h4,S=e.h5,x=e.h6,I=e.h7,l=0;l<64;++l)o=(m>>>6|m<<26)^(m>>>11|m<<21)^(m>>>25|m<<7),a=x^m&(S^x),s=(u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10),c=u&f|d&(u^f),n=I+o+a+sL[l]+t[l],i=s+c,I=x,x=S,S=m,m=p+n>>>0,p=d,d=f,f=u,u=n+i>>>0;e.h0=e.h0+u|0,e.h1=e.h1+f|0,e.h2=e.h2+d|0,e.h3=e.h3+p|0,e.h4=e.h4+m|0,e.h5=e.h5+S|0,e.h6=e.h6+x|0,e.h7=e.h7+I|0,v-=64;}}});var Sv=A((Phe,aL)=>{var xi=rt();vt();var Th=null;xi.util.isNodejs&&!xi.options.usePureJavaScript&&!process.versions["node-webkit"]&&(Th=he("crypto"));var kZ=aL.exports=xi.prng=xi.prng||{};kZ.create=function(e){for(var t={plugin:e,key:null,seed:null,time:null,reseeds:0,generated:0,keyBytes:""},r=e.md,n=new Array(32),i=0;i<32;++i)n[i]=r.create();t.pools=n,t.pool=0,t.generate=function(l,u){if(!u)return t.generateSync(l);var f=t.plugin.cipher,d=t.plugin.increment,p=t.plugin.formatKey,m=t.plugin.formatSeed,S=xi.util.createBuffer();t.key=null,x();function x(I){if(I)return u(I);if(S.length()>=l)return u(null,S.getBytes(l));if(t.generated>1048575&&(t.key=null),t.key===null)return xi.util.nextTick(function(){s(x);});var v=f(t.key,t.seed);t.generated+=v.length,S.putBytes(v),t.key=p(f(t.key,d(t.seed))),t.seed=m(f(t.key,t.seed)),xi.util.setImmediate(x);}},t.generateSync=function(l){var u=t.plugin.cipher,f=t.plugin.increment,d=t.plugin.formatKey,p=t.plugin.formatSeed;t.key=null;for(var m=xi.util.createBuffer();m.length()<l;){t.generated>1048575&&(t.key=null),t.key===null&&o();var S=u(t.key,t.seed);t.generated+=S.length,m.putBytes(S),t.key=d(u(t.key,f(t.seed))),t.seed=p(u(t.key,t.seed));}return m.getBytes(l)};function s(l){if(t.pools[0].messageLength>=32)return a(),l();var u=32-t.pools[0].messageLength<<5;t.seedFile(u,function(f,d){if(f)return l(f);t.collect(d),a(),l();});}function o(){if(t.pools[0].messageLength>=32)return a();var l=32-t.pools[0].messageLength<<5;t.collect(t.seedFileSync(l)),a();}function a(){t.reseeds=t.reseeds===4294967295?0:t.reseeds+1;var l=t.plugin.md.create();l.update(t.keyBytes);for(var u=1,f=0;f<32;++f)t.reseeds%u===0&&(l.update(t.pools[f].digest().getBytes()),t.pools[f].start()),u=u<<1;t.keyBytes=l.digest().getBytes(),l.start(),l.update(t.keyBytes);var d=l.digest().getBytes();t.key=t.plugin.formatKey(t.keyBytes),t.seed=t.plugin.formatSeed(d),t.generated=0;}function c(l){var u=null,f=xi.util.globalScope,d=f.crypto||f.msCrypto;d&&d.getRandomValues&&(u=function(L){return d.getRandomValues(L)});var p=xi.util.createBuffer();if(u)for(;p.length()<l;){var m=Math.max(1,Math.min(l-p.length(),65536)/4),S=new Uint32Array(Math.floor(m));try{u(S);for(var x=0;x<S.length;++x)p.putInt32(S[x]);}catch(L){if(!(typeof QuotaExceededError<"u"&&L instanceof QuotaExceededError))throw L}}if(p.length()<l)for(var I,v,b,D=Math.floor(Math.random()*65536);p.length()<l;){v=16807*(D&65535),I=16807*(D>>16),v+=(I&32767)<<16,v+=I>>15,v=(v&2147483647)+(v>>31),D=v&4294967295;for(var x=0;x<3;++x)b=D>>>(x<<3),b^=Math.floor(Math.random()*256),p.putByte(b&255);}return p.getBytes(l)}return Th?(t.seedFile=function(l,u){Th.randomBytes(l,function(f,d){if(f)return u(f);u(null,d.toString());});},t.seedFileSync=function(l){return Th.randomBytes(l).toString()}):(t.seedFile=function(l,u){try{u(null,c(l));}catch(f){u(f);}},t.seedFileSync=c),t.collect=function(l){for(var u=l.length,f=0;f<u;++f)t.pools[t.pool].update(l.substr(f,1)),t.pool=t.pool===31?0:t.pool+1;},t.collectInt=function(l,u){for(var f="",d=0;d<u;d+=8)f+=String.fromCharCode(l>>d&255);t.collect(f);},t.registerWorker=function(l){if(l===self)t.seedFile=function(f,d){function p(m){var S=m.data;S.forge&&S.forge.prng&&(self.removeEventListener("message",p),d(S.forge.prng.err,S.forge.prng.bytes));}self.addEventListener("message",p),self.postMessage({forge:{prng:{needed:f}}});};else {var u=function(f){var d=f.data;d.forge&&d.forge.prng&&t.seedFile(d.forge.prng.needed,function(p,m){l.postMessage({forge:{prng:{err:p,bytes:m}}});});};l.addEventListener("message",u);}},t};});var Ln=A((khe,bv)=>{var br=rt();Ss();vv();Sv();vt();(function(){if(br.random&&br.random.getBytes){bv.exports=br.random;return}(function(e){var t={},r=new Array(4),n=br.util.createBuffer();t.formatKey=function(f){var d=br.util.createBuffer(f);return f=new Array(4),f[0]=d.getInt32(),f[1]=d.getInt32(),f[2]=d.getInt32(),f[3]=d.getInt32(),br.aes._expandKey(f,!1)},t.formatSeed=function(f){var d=br.util.createBuffer(f);return f=new Array(4),f[0]=d.getInt32(),f[1]=d.getInt32(),f[2]=d.getInt32(),f[3]=d.getInt32(),f},t.cipher=function(f,d){return br.aes._updateBlock(f,d,r,!1),n.putInt32(r[0]),n.putInt32(r[1]),n.putInt32(r[2]),n.putInt32(r[3]),n.getBytes()},t.increment=function(f){return ++f[3],f},t.md=br.md.sha256;function i(){var f=br.prng.create(t);return f.getBytes=function(d,p){return f.generate(d,p)},f.getBytesSync=function(d){return f.generate(d)},f}var s=i(),o=null,a=br.util.globalScope,c=a.crypto||a.msCrypto;if(c&&c.getRandomValues&&(o=function(f){return c.getRandomValues(f)}),br.options.usePureJavaScript||!br.util.isNodejs&&!o){if(s.collectInt(+new Date,32),typeof navigator<"u"){var l="";for(var u in navigator)try{typeof navigator[u]=="string"&&(l+=navigator[u]);}catch{}s.collect(l),l=null;}e&&(e().mousemove(function(f){s.collectInt(f.clientX,16),s.collectInt(f.clientY,16);}),e().keypress(function(f){s.collectInt(f.charCode,8);}));}if(!br.random)br.random=s;else for(var u in s)br.random[u]=s[u];br.random.createInstance=i,bv.exports=br.random;})(typeof jQuery<"u"?jQuery:null);})();});var Ev=A((Nhe,lL)=>{var nn=rt();vt();var Cv=[217,120,249,196,25,221,181,237,40,233,253,121,74,160,216,157,198,126,55,131,43,118,83,142,98,76,100,136,68,139,251,162,23,154,89,245,135,179,79,19,97,69,109,141,9,129,125,50,189,143,64,235,134,183,123,11,240,149,33,34,92,107,78,130,84,214,101,147,206,96,178,28,115,86,192,20,167,140,241,220,18,117,202,31,59,190,228,209,66,61,212,48,163,60,182,38,111,191,14,218,70,105,7,87,39,242,29,155,188,148,67,3,248,17,199,246,144,239,62,231,6,195,213,47,200,102,30,215,8,232,234,222,128,82,238,247,132,170,114,172,53,77,106,42,150,26,210,113,90,21,73,116,75,159,208,94,4,24,164,236,194,224,65,110,15,81,203,204,36,145,175,80,161,244,112,57,153,124,58,133,35,184,180,122,252,2,54,91,37,85,151,49,45,93,250,152,227,138,146,174,5,223,41,16,103,108,186,201,211,0,230,207,225,158,168,44,99,22,1,63,88,226,137,169,13,56,52,27,171,51,255,176,187,72,12,95,185,177,205,46,197,243,219,71,229,165,156,119,10,166,32,104,254,127,193,173],uL=[1,2,3,5],NZ=function(e,t){return e<<t&65535|(e&65535)>>16-t},LZ=function(e,t){return (e&65535)>>t|e<<16-t&65535};lL.exports=nn.rc2=nn.rc2||{};nn.rc2.expandKey=function(e,t){typeof e=="string"&&(e=nn.util.createBuffer(e)),t=t||128;var r=e,n=e.length(),i=t,s=Math.ceil(i/8),o=255>>(i&7),a;for(a=n;a<128;a++)r.putByte(Cv[r.at(a-1)+r.at(a-n)&255]);for(r.setAt(128-s,Cv[r.at(128-s)&o]),a=127-s;a>=0;a--)r.setAt(a,Cv[r.at(a+1)^r.at(a+s)]);return r};var cL=function(e,t,r){var n=!1,i=null,s=null,o=null,a,c,l,u,f=[];for(e=nn.rc2.expandKey(e,t),l=0;l<64;l++)f.push(e.getInt16Le());r?(a=function(m){for(l=0;l<4;l++)m[l]+=f[u]+(m[(l+3)%4]&m[(l+2)%4])+(~m[(l+3)%4]&m[(l+1)%4]),m[l]=NZ(m[l],uL[l]),u++;},c=function(m){for(l=0;l<4;l++)m[l]+=f[m[(l+3)%4]&63];}):(a=function(m){for(l=3;l>=0;l--)m[l]=LZ(m[l],uL[l]),m[l]-=f[u]+(m[(l+3)%4]&m[(l+2)%4])+(~m[(l+3)%4]&m[(l+1)%4]),u--;},c=function(m){for(l=3;l>=0;l--)m[l]-=f[m[(l+3)%4]&63];});var d=function(m){var S=[];for(l=0;l<4;l++){var x=i.getInt16Le();o!==null&&(r?x^=o.getInt16Le():o.putInt16Le(x)),S.push(x&65535);}u=r?0:63;for(var I=0;I<m.length;I++)for(var v=0;v<m[I][0];v++)m[I][1](S);for(l=0;l<4;l++)o!==null&&(r?o.putInt16Le(S[l]):S[l]^=o.getInt16Le()),s.putInt16Le(S[l]);},p=null;return p={start:function(m,S){m&&typeof m=="string"&&(m=nn.util.createBuffer(m)),n=!1,i=nn.util.createBuffer(),s=S||new nn.util.createBuffer,o=m,p.output=s;},update:function(m){for(n||i.putBuffer(m);i.length()>=8;)d([[5,a],[1,c],[6,a],[1,c],[5,a]]);},finish:function(m){var S=!0;if(r)if(m)S=m(8,i,!r);else {var x=i.length()===8?8:8-i.length();i.fillWithByte(x,x);}if(S&&(n=!0,p.update()),!r&&(S=i.length()===0,S))if(m)S=m(8,s,!r);else {var I=s.length(),v=s.at(I-1);v>I?S=!1:s.truncate(v);}return S}},p};nn.rc2.startEncrypting=function(e,t,r){var n=nn.rc2.createEncryptionCipher(e,128);return n.start(t,r),n};nn.rc2.createEncryptionCipher=function(e,t){return cL(e,t,!0)};nn.rc2.startDecrypting=function(e,t,r){var n=nn.rc2.createDecryptionCipher(e,128);return n.start(t,r),n};nn.rc2.createDecryptionCipher=function(e,t){return cL(e,t,!1)};});var vc=A((Lhe,vL)=>{var xv=rt();vL.exports=xv.jsbn=xv.jsbn||{};var Gi;function le(e,t,r){this.data=[],e!=null&&(typeof e=="number"?this.fromNumber(e,t,r):t==null&&typeof e!="string"?this.fromString(e,256):this.fromString(e,t));}xv.jsbn.BigInteger=le;function St(){return new le(null)}function BZ(e,t,r,n,i,s){for(;--s>=0;){var o=t*this.data[e++]+r.data[n]+i;i=Math.floor(o/67108864),r.data[n++]=o&67108863;}return i}function qZ(e,t,r,n,i,s){for(var o=t&32767,a=t>>15;--s>=0;){var c=this.data[e]&32767,l=this.data[e++]>>15,u=a*c+l*o;c=o*c+((u&32767)<<15)+r.data[n]+(i&1073741823),i=(c>>>30)+(u>>>15)+a*l+(i>>>30),r.data[n++]=c&1073741823;}return i}function hL(e,t,r,n,i,s){for(var o=t&16383,a=t>>14;--s>=0;){var c=this.data[e]&16383,l=this.data[e++]>>14,u=a*c+l*o;c=o*c+((u&16383)<<14)+r.data[n]+i,i=(c>>28)+(u>>14)+a*l,r.data[n++]=c&268435455;}return i}typeof navigator>"u"?(le.prototype.am=hL,Gi=28):navigator.appName=="Microsoft Internet Explorer"?(le.prototype.am=qZ,Gi=30):navigator.appName!="Netscape"?(le.prototype.am=BZ,Gi=26):(le.prototype.am=hL,Gi=28);le.prototype.DB=Gi;le.prototype.DM=(1<<Gi)-1;le.prototype.DV=1<<Gi;var wv=52;le.prototype.FV=Math.pow(2,wv);le.prototype.F1=wv-Gi;le.prototype.F2=2*Gi-wv;var FZ="0123456789abcdefghijklmnopqrstuvwxyz",Ah=new Array,wa,On;wa=48;for(On=0;On<=9;++On)Ah[wa++]=On;wa=97;for(On=10;On<36;++On)Ah[wa++]=On;wa=65;for(On=10;On<36;++On)Ah[wa++]=On;function dL(e){return FZ.charAt(e)}function pL(e,t){var r=Ah[e.charCodeAt(t)];return r??-1}function MZ(e){for(var t=this.t-1;t>=0;--t)e.data[t]=this.data[t];e.t=this.t,e.s=this.s;}function UZ(e){this.t=1,this.s=e<0?-1:0,e>0?this.data[0]=e:e<-1?this.data[0]=e+this.DV:this.t=0;}function Cs(e){var t=St();return t.fromInt(e),t}function $Z(e,t){var r;if(t==16)r=4;else if(t==8)r=3;else if(t==256)r=8;else if(t==2)r=1;else if(t==32)r=5;else if(t==4)r=2;else {this.fromRadix(e,t);return}this.t=0,this.s=0;for(var n=e.length,i=!1,s=0;--n>=0;){var o=r==8?e[n]&255:pL(e,n);if(o<0){e.charAt(n)=="-"&&(i=!0);continue}i=!1,s==0?this.data[this.t++]=o:s+r>this.DB?(this.data[this.t-1]|=(o&(1<<this.DB-s)-1)<<s,this.data[this.t++]=o>>this.DB-s):this.data[this.t-1]|=o<<s,s+=r,s>=this.DB&&(s-=this.DB);}r==8&&e[0]&128&&(this.s=-1,s>0&&(this.data[this.t-1]|=(1<<this.DB-s)-1<<s)),this.clamp(),i&&le.ZERO.subTo(this,this);}function jZ(){for(var e=this.s&this.DM;this.t>0&&this.data[this.t-1]==e;)--this.t;}function VZ(e){if(this.s<0)return "-"+this.negate().toString(e);var t;if(e==16)t=4;else if(e==8)t=3;else if(e==2)t=1;else if(e==32)t=5;else if(e==4)t=2;else return this.toRadix(e);var r=(1<<t)-1,n,i=!1,s="",o=this.t,a=this.DB-o*this.DB%t;if(o-- >0)for(a<this.DB&&(n=this.data[o]>>a)>0&&(i=!0,s=dL(n));o>=0;)a<t?(n=(this.data[o]&(1<<a)-1)<<t-a,n|=this.data[--o]>>(a+=this.DB-t)):(n=this.data[o]>>(a-=t)&r,a<=0&&(a+=this.DB,--o)),n>0&&(i=!0),i&&(s+=dL(n));return i?s:"0"}function HZ(){var e=St();return le.ZERO.subTo(this,e),e}function WZ(){return this.s<0?this.negate():this}function KZ(e){var t=this.s-e.s;if(t!=0)return t;var r=this.t;if(t=r-e.t,t!=0)return this.s<0?-t:t;for(;--r>=0;)if((t=this.data[r]-e.data[r])!=0)return t;return 0}function Rh(e){var t=1,r;return (r=e>>>16)!=0&&(e=r,t+=16),(r=e>>8)!=0&&(e=r,t+=8),(r=e>>4)!=0&&(e=r,t+=4),(r=e>>2)!=0&&(e=r,t+=2),(r=e>>1)!=0&&(e=r,t+=1),t}function zZ(){return this.t<=0?0:this.DB*(this.t-1)+Rh(this.data[this.t-1]^this.s&this.DM)}function GZ(e,t){var r;for(r=this.t-1;r>=0;--r)t.data[r+e]=this.data[r];for(r=e-1;r>=0;--r)t.data[r]=0;t.t=this.t+e,t.s=this.s;}function YZ(e,t){for(var r=e;r<this.t;++r)t.data[r-e]=this.data[r];t.t=Math.max(this.t-e,0),t.s=this.s;}function QZ(e,t){var r=e%this.DB,n=this.DB-r,i=(1<<n)-1,s=Math.floor(e/this.DB),o=this.s<<r&this.DM,a;for(a=this.t-1;a>=0;--a)t.data[a+s+1]=this.data[a]>>n|o,o=(this.data[a]&i)<<r;for(a=s-1;a>=0;--a)t.data[a]=0;t.data[s]=o,t.t=this.t+s+1,t.s=this.s,t.clamp();}function XZ(e,t){t.s=this.s;var r=Math.floor(e/this.DB);if(r>=this.t){t.t=0;return}var n=e%this.DB,i=this.DB-n,s=(1<<n)-1;t.data[0]=this.data[r]>>n;for(var o=r+1;o<this.t;++o)t.data[o-r-1]|=(this.data[o]&s)<<i,t.data[o-r]=this.data[o]>>n;n>0&&(t.data[this.t-r-1]|=(this.s&s)<<i),t.t=this.t-r,t.clamp();}function JZ(e,t){for(var r=0,n=0,i=Math.min(e.t,this.t);r<i;)n+=this.data[r]-e.data[r],t.data[r++]=n&this.DM,n>>=this.DB;if(e.t<this.t){for(n-=e.s;r<this.t;)n+=this.data[r],t.data[r++]=n&this.DM,n>>=this.DB;n+=this.s;}else {for(n+=this.s;r<e.t;)n-=e.data[r],t.data[r++]=n&this.DM,n>>=this.DB;n-=e.s;}t.s=n<0?-1:0,n<-1?t.data[r++]=this.DV+n:n>0&&(t.data[r++]=n),t.t=r,t.clamp();}function ZZ(e,t){var r=this.abs(),n=e.abs(),i=r.t;for(t.t=i+n.t;--i>=0;)t.data[i]=0;for(i=0;i<n.t;++i)t.data[i+r.t]=r.am(0,n.data[i],t,i,0,r.t);t.s=0,t.clamp(),this.s!=e.s&&le.ZERO.subTo(t,t);}function eee(e){for(var t=this.abs(),r=e.t=2*t.t;--r>=0;)e.data[r]=0;for(r=0;r<t.t-1;++r){var n=t.am(r,t.data[r],e,2*r,0,1);(e.data[r+t.t]+=t.am(r+1,2*t.data[r],e,2*r+1,n,t.t-r-1))>=t.DV&&(e.data[r+t.t]-=t.DV,e.data[r+t.t+1]=1);}e.t>0&&(e.data[e.t-1]+=t.am(r,t.data[r],e,2*r,0,1)),e.s=0,e.clamp();}function tee(e,t,r){var n=e.abs();if(!(n.t<=0)){var i=this.abs();if(i.t<n.t){t?.fromInt(0),r!=null&&this.copyTo(r);return}r==null&&(r=St());var s=St(),o=this.s,a=e.s,c=this.DB-Rh(n.data[n.t-1]);c>0?(n.lShiftTo(c,s),i.lShiftTo(c,r)):(n.copyTo(s),i.copyTo(r));var l=s.t,u=s.data[l-1];if(u!=0){var f=u*(1<<this.F1)+(l>1?s.data[l-2]>>this.F2:0),d=this.FV/f,p=(1<<this.F1)/f,m=1<<this.F2,S=r.t,x=S-l,I=t??St();for(s.dlShiftTo(x,I),r.compareTo(I)>=0&&(r.data[r.t++]=1,r.subTo(I,r)),le.ONE.dlShiftTo(l,I),I.subTo(s,s);s.t<l;)s.data[s.t++]=0;for(;--x>=0;){var v=r.data[--S]==u?this.DM:Math.floor(r.data[S]*d+(r.data[S-1]+m)*p);if((r.data[S]+=s.am(0,v,r,x,0,l))<v)for(s.dlShiftTo(x,I),r.subTo(I,r);r.data[S]<--v;)r.subTo(I,r);}t!=null&&(r.drShiftTo(l,t),o!=a&&le.ZERO.subTo(t,t)),r.t=l,r.clamp(),c>0&&r.rShiftTo(c,r),o<0&&le.ZERO.subTo(r,r);}}}function ree(e){var t=St();return this.abs().divRemTo(e,null,t),this.s<0&&t.compareTo(le.ZERO)>0&&e.subTo(t,t),t}function go(e){this.m=e;}function nee(e){return e.s<0||e.compareTo(this.m)>=0?e.mod(this.m):e}function iee(e){return e}function see(e){e.divRemTo(this.m,null,e);}function oee(e,t,r){e.multiplyTo(t,r),this.reduce(r);}function aee(e,t){e.squareTo(t),this.reduce(t);}go.prototype.convert=nee;go.prototype.revert=iee;go.prototype.reduce=see;go.prototype.mulTo=oee;go.prototype.sqrTo=aee;function uee(){if(this.t<1)return 0;var e=this.data[0];if(!(e&1))return 0;var t=e&3;return t=t*(2-(e&15)*t)&15,t=t*(2-(e&255)*t)&255,t=t*(2-((e&65535)*t&65535))&65535,t=t*(2-e*t%this.DV)%this.DV,t>0?this.DV-t:-t}function mo(e){this.m=e,this.mp=e.invDigit(),this.mpl=this.mp&32767,this.mph=this.mp>>15,this.um=(1<<e.DB-15)-1,this.mt2=2*e.t;}function cee(e){var t=St();return e.abs().dlShiftTo(this.m.t,t),t.divRemTo(this.m,null,t),e.s<0&&t.compareTo(le.ZERO)>0&&this.m.subTo(t,t),t}function lee(e){var t=St();return e.copyTo(t),this.reduce(t),t}function fee(e){for(;e.t<=this.mt2;)e.data[e.t++]=0;for(var t=0;t<this.m.t;++t){var r=e.data[t]&32767,n=r*this.mpl+((r*this.mph+(e.data[t]>>15)*this.mpl&this.um)<<15)&e.DM;for(r=t+this.m.t,e.data[r]+=this.m.am(0,n,e,t,0,this.m.t);e.data[r]>=e.DV;)e.data[r]-=e.DV,e.data[++r]++;}e.clamp(),e.drShiftTo(this.m.t,e),e.compareTo(this.m)>=0&&e.subTo(this.m,e);}function hee(e,t){e.squareTo(t),this.reduce(t);}function dee(e,t,r){e.multiplyTo(t,r),this.reduce(r);}mo.prototype.convert=cee;mo.prototype.revert=lee;mo.prototype.reduce=fee;mo.prototype.mulTo=dee;mo.prototype.sqrTo=hee;function pee(){return (this.t>0?this.data[0]&1:this.s)==0}function gee(e,t){if(e>4294967295||e<1)return le.ONE;var r=St(),n=St(),i=t.convert(this),s=Rh(e)-1;for(i.copyTo(r);--s>=0;)if(t.sqrTo(r,n),(e&1<<s)>0)t.mulTo(n,i,r);else {var o=r;r=n,n=o;}return t.revert(r)}function mee(e,t){var r;return e<256||t.isEven()?r=new go(t):r=new mo(t),this.exp(e,r)}le.prototype.copyTo=MZ;le.prototype.fromInt=UZ;le.prototype.fromString=$Z;le.prototype.clamp=jZ;le.prototype.dlShiftTo=GZ;le.prototype.drShiftTo=YZ;le.prototype.lShiftTo=QZ;le.prototype.rShiftTo=XZ;le.prototype.subTo=JZ;le.prototype.multiplyTo=ZZ;le.prototype.squareTo=eee;le.prototype.divRemTo=tee;le.prototype.invDigit=uee;le.prototype.isEven=pee;le.prototype.exp=gee;le.prototype.toString=VZ;le.prototype.negate=HZ;le.prototype.abs=WZ;le.prototype.compareTo=KZ;le.prototype.bitLength=zZ;le.prototype.mod=ree;le.prototype.modPowInt=mee;le.ZERO=Cs(0);le.ONE=Cs(1);function yee(){var e=St();return this.copyTo(e),e}function vee(){if(this.s<0){if(this.t==1)return this.data[0]-this.DV;if(this.t==0)return -1}else {if(this.t==1)return this.data[0];if(this.t==0)return 0}return (this.data[1]&(1<<32-this.DB)-1)<<this.DB|this.data[0]}function See(){return this.t==0?this.s:this.data[0]<<24>>24}function bee(){return this.t==0?this.s:this.data[0]<<16>>16}function Cee(e){return Math.floor(Math.LN2*this.DB/Math.log(e))}function Eee(){return this.s<0?-1:this.t<=0||this.t==1&&this.data[0]<=0?0:1}function xee(e){if(e==null&&(e=10),this.signum()==0||e<2||e>36)return "0";var t=this.chunkSize(e),r=Math.pow(e,t),n=Cs(r),i=St(),s=St(),o="";for(this.divRemTo(n,i,s);i.signum()>0;)o=(r+s.intValue()).toString(e).substr(1)+o,i.divRemTo(n,i,s);return s.intValue().toString(e)+o}function wee(e,t){this.fromInt(0),t==null&&(t=10);for(var r=this.chunkSize(t),n=Math.pow(t,r),i=!1,s=0,o=0,a=0;a<e.length;++a){var c=pL(e,a);if(c<0){e.charAt(a)=="-"&&this.signum()==0&&(i=!0);continue}o=t*o+c,++s>=r&&(this.dMultiply(n),this.dAddOffset(o,0),s=0,o=0);}s>0&&(this.dMultiply(Math.pow(t,s)),this.dAddOffset(o,0)),i&&le.ZERO.subTo(this,this);}function _ee(e,t,r){if(typeof t=="number")if(e<2)this.fromInt(1);else for(this.fromNumber(e,r),this.testBit(e-1)||this.bitwiseTo(le.ONE.shiftLeft(e-1),_v,this),this.isEven()&&this.dAddOffset(1,0);!this.isProbablePrime(t);)this.dAddOffset(2,0),this.bitLength()>e&&this.subTo(le.ONE.shiftLeft(e-1),this);else {var n=new Array,i=e&7;n.length=(e>>3)+1,t.nextBytes(n),i>0?n[0]&=(1<<i)-1:n[0]=0,this.fromString(n,256);}}function Tee(){var e=this.t,t=new Array;t[0]=this.s;var r=this.DB-e*this.DB%8,n,i=0;if(e-- >0)for(r<this.DB&&(n=this.data[e]>>r)!=(this.s&this.DM)>>r&&(t[i++]=n|this.s<<this.DB-r);e>=0;)r<8?(n=(this.data[e]&(1<<r)-1)<<8-r,n|=this.data[--e]>>(r+=this.DB-8)):(n=this.data[e]>>(r-=8)&255,r<=0&&(r+=this.DB,--e)),n&128&&(n|=-256),i==0&&(this.s&128)!=(n&128)&&++i,(i>0||n!=this.s)&&(t[i++]=n);return t}function Aee(e){return this.compareTo(e)==0}function Ree(e){return this.compareTo(e)<0?this:e}function Iee(e){return this.compareTo(e)>0?this:e}function Dee(e,t,r){var n,i,s=Math.min(e.t,this.t);for(n=0;n<s;++n)r.data[n]=t(this.data[n],e.data[n]);if(e.t<this.t){for(i=e.s&this.DM,n=s;n<this.t;++n)r.data[n]=t(this.data[n],i);r.t=this.t;}else {for(i=this.s&this.DM,n=s;n<e.t;++n)r.data[n]=t(i,e.data[n]);r.t=e.t;}r.s=t(this.s,e.s),r.clamp();}function Pee(e,t){return e&t}function kee(e){var t=St();return this.bitwiseTo(e,Pee,t),t}function _v(e,t){return e|t}function Nee(e){var t=St();return this.bitwiseTo(e,_v,t),t}function gL(e,t){return e^t}function Lee(e){var t=St();return this.bitwiseTo(e,gL,t),t}function mL(e,t){return e&~t}function Oee(e){var t=St();return this.bitwiseTo(e,mL,t),t}function Bee(){for(var e=St(),t=0;t<this.t;++t)e.data[t]=this.DM&~this.data[t];return e.t=this.t,e.s=~this.s,e}function qee(e){var t=St();return e<0?this.rShiftTo(-e,t):this.lShiftTo(e,t),t}function Fee(e){var t=St();return e<0?this.lShiftTo(-e,t):this.rShiftTo(e,t),t}function Mee(e){if(e==0)return -1;var t=0;return e&65535||(e>>=16,t+=16),e&255||(e>>=8,t+=8),e&15||(e>>=4,t+=4),e&3||(e>>=2,t+=2),e&1||++t,t}function Uee(){for(var e=0;e<this.t;++e)if(this.data[e]!=0)return e*this.DB+Mee(this.data[e]);return this.s<0?this.t*this.DB:-1}function $ee(e){for(var t=0;e!=0;)e&=e-1,++t;return t}function jee(){for(var e=0,t=this.s&this.DM,r=0;r<this.t;++r)e+=$ee(this.data[r]^t);return e}function Vee(e){var t=Math.floor(e/this.DB);return t>=this.t?this.s!=0:(this.data[t]&1<<e%this.DB)!=0}function Hee(e,t){var r=le.ONE.shiftLeft(e);return this.bitwiseTo(r,t,r),r}function Wee(e){return this.changeBit(e,_v)}function Kee(e){return this.changeBit(e,mL)}function zee(e){return this.changeBit(e,gL)}function Gee(e,t){for(var r=0,n=0,i=Math.min(e.t,this.t);r<i;)n+=this.data[r]+e.data[r],t.data[r++]=n&this.DM,n>>=this.DB;if(e.t<this.t){for(n+=e.s;r<this.t;)n+=this.data[r],t.data[r++]=n&this.DM,n>>=this.DB;n+=this.s;}else {for(n+=this.s;r<e.t;)n+=e.data[r],t.data[r++]=n&this.DM,n>>=this.DB;n+=e.s;}t.s=n<0?-1:0,n>0?t.data[r++]=n:n<-1&&(t.data[r++]=this.DV+n),t.t=r,t.clamp();}function Yee(e){var t=St();return this.addTo(e,t),t}function Qee(e){var t=St();return this.subTo(e,t),t}function Xee(e){var t=St();return this.multiplyTo(e,t),t}function Jee(e){var t=St();return this.divRemTo(e,t,null),t}function Zee(e){var t=St();return this.divRemTo(e,null,t),t}function ete(e){var t=St(),r=St();return this.divRemTo(e,t,r),new Array(t,r)}function tte(e){this.data[this.t]=this.am(0,e-1,this,0,0,this.t),++this.t,this.clamp();}function rte(e,t){if(e!=0){for(;this.t<=t;)this.data[this.t++]=0;for(this.data[t]+=e;this.data[t]>=this.DV;)this.data[t]-=this.DV,++t>=this.t&&(this.data[this.t++]=0),++this.data[t];}}function yc(){}function yL(e){return e}function nte(e,t,r){e.multiplyTo(t,r);}function ite(e,t){e.squareTo(t);}yc.prototype.convert=yL;yc.prototype.revert=yL;yc.prototype.mulTo=nte;yc.prototype.sqrTo=ite;function ste(e){return this.exp(e,new yc)}function ote(e,t,r){var n=Math.min(this.t+e.t,t);for(r.s=0,r.t=n;n>0;)r.data[--n]=0;var i;for(i=r.t-this.t;n<i;++n)r.data[n+this.t]=this.am(0,e.data[n],r,n,0,this.t);for(i=Math.min(e.t,t);n<i;++n)this.am(0,e.data[n],r,n,0,t-n);r.clamp();}function ate(e,t,r){--t;var n=r.t=this.t+e.t-t;for(r.s=0;--n>=0;)r.data[n]=0;for(n=Math.max(t-this.t,0);n<e.t;++n)r.data[this.t+n-t]=this.am(t-n,e.data[n],r,0,0,this.t+n-t);r.clamp(),r.drShiftTo(1,r);}function _a(e){this.r2=St(),this.q3=St(),le.ONE.dlShiftTo(2*e.t,this.r2),this.mu=this.r2.divide(e),this.m=e;}function ute(e){if(e.s<0||e.t>2*this.m.t)return e.mod(this.m);if(e.compareTo(this.m)<0)return e;var t=St();return e.copyTo(t),this.reduce(t),t}function cte(e){return e}function lte(e){for(e.drShiftTo(this.m.t-1,this.r2),e.t>this.m.t+1&&(e.t=this.m.t+1,e.clamp()),this.mu.multiplyUpperTo(this.r2,this.m.t+1,this.q3),this.m.multiplyLowerTo(this.q3,this.m.t+1,this.r2);e.compareTo(this.r2)<0;)e.dAddOffset(1,this.m.t+1);for(e.subTo(this.r2,e);e.compareTo(this.m)>=0;)e.subTo(this.m,e);}function fte(e,t){e.squareTo(t),this.reduce(t);}function hte(e,t,r){e.multiplyTo(t,r),this.reduce(r);}_a.prototype.convert=ute;_a.prototype.revert=cte;_a.prototype.reduce=lte;_a.prototype.mulTo=hte;_a.prototype.sqrTo=fte;function dte(e,t){var r=e.bitLength(),n,i=Cs(1),s;if(r<=0)return i;r<18?n=1:r<48?n=3:r<144?n=4:r<768?n=5:n=6,r<8?s=new go(t):t.isEven()?s=new _a(t):s=new mo(t);var o=new Array,a=3,c=n-1,l=(1<<n)-1;if(o[1]=s.convert(this),n>1){var u=St();for(s.sqrTo(o[1],u);a<=l;)o[a]=St(),s.mulTo(u,o[a-2],o[a]),a+=2;}var f=e.t-1,d,p=!0,m=St(),S;for(r=Rh(e.data[f])-1;f>=0;){for(r>=c?d=e.data[f]>>r-c&l:(d=(e.data[f]&(1<<r+1)-1)<<c-r,f>0&&(d|=e.data[f-1]>>this.DB+r-c)),a=n;!(d&1);)d>>=1,--a;if((r-=a)<0&&(r+=this.DB,--f),p)o[d].copyTo(i),p=!1;else {for(;a>1;)s.sqrTo(i,m),s.sqrTo(m,i),a-=2;a>0?s.sqrTo(i,m):(S=i,i=m,m=S),s.mulTo(m,o[d],i);}for(;f>=0&&!(e.data[f]&1<<r);)s.sqrTo(i,m),S=i,i=m,m=S,--r<0&&(r=this.DB-1,--f);}return s.revert(i)}function pte(e){var t=this.s<0?this.negate():this.clone(),r=e.s<0?e.negate():e.clone();if(t.compareTo(r)<0){var n=t;t=r,r=n;}var i=t.getLowestSetBit(),s=r.getLowestSetBit();if(s<0)return t;for(i<s&&(s=i),s>0&&(t.rShiftTo(s,t),r.rShiftTo(s,r));t.signum()>0;)(i=t.getLowestSetBit())>0&&t.rShiftTo(i,t),(i=r.getLowestSetBit())>0&&r.rShiftTo(i,r),t.compareTo(r)>=0?(t.subTo(r,t),t.rShiftTo(1,t)):(r.subTo(t,r),r.rShiftTo(1,r));return s>0&&r.lShiftTo(s,r),r}function gte(e){if(e<=0)return 0;var t=this.DV%e,r=this.s<0?e-1:0;if(this.t>0)if(t==0)r=this.data[0]%e;else for(var n=this.t-1;n>=0;--n)r=(t*r+this.data[n])%e;return r}function mte(e){var t=e.isEven();if(this.isEven()&&t||e.signum()==0)return le.ZERO;for(var r=e.clone(),n=this.clone(),i=Cs(1),s=Cs(0),o=Cs(0),a=Cs(1);r.signum()!=0;){for(;r.isEven();)r.rShiftTo(1,r),t?((!i.isEven()||!s.isEven())&&(i.addTo(this,i),s.subTo(e,s)),i.rShiftTo(1,i)):s.isEven()||s.subTo(e,s),s.rShiftTo(1,s);for(;n.isEven();)n.rShiftTo(1,n),t?((!o.isEven()||!a.isEven())&&(o.addTo(this,o),a.subTo(e,a)),o.rShiftTo(1,o)):a.isEven()||a.subTo(e,a),a.rShiftTo(1,a);r.compareTo(n)>=0?(r.subTo(n,r),t&&i.subTo(o,i),s.subTo(a,s)):(n.subTo(r,n),t&&o.subTo(i,o),a.subTo(s,a));}if(n.compareTo(le.ONE)!=0)return le.ZERO;if(a.compareTo(e)>=0)return a.subtract(e);if(a.signum()<0)a.addTo(e,a);else return a;return a.signum()<0?a.add(e):a}var ii=[2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,467,479,487,491,499,503,509],yte=(1<<26)/ii[ii.length-1];function vte(e){var t,r=this.abs();if(r.t==1&&r.data[0]<=ii[ii.length-1]){for(t=0;t<ii.length;++t)if(r.data[0]==ii[t])return !0;return !1}if(r.isEven())return !1;for(t=1;t<ii.length;){for(var n=ii[t],i=t+1;i<ii.length&&n<yte;)n*=ii[i++];for(n=r.modInt(n);t<i;)if(n%ii[t++]==0)return !1}return r.millerRabin(e)}function Ste(e){var t=this.subtract(le.ONE),r=t.getLowestSetBit();if(r<=0)return !1;for(var n=t.shiftRight(r),i=bte(),s,o=0;o<e;++o){do s=new le(this.bitLength(),i);while(s.compareTo(le.ONE)<=0||s.compareTo(t)>=0);var a=s.modPow(n,this);if(a.compareTo(le.ONE)!=0&&a.compareTo(t)!=0){for(var c=1;c++<r&&a.compareTo(t)!=0;)if(a=a.modPowInt(2,this),a.compareTo(le.ONE)==0)return !1;if(a.compareTo(t)!=0)return !1}}return !0}function bte(){return {nextBytes:function(e){for(var t=0;t<e.length;++t)e[t]=Math.floor(Math.random()*256);}}}le.prototype.chunkSize=Cee;le.prototype.toRadix=xee;le.prototype.fromRadix=wee;le.prototype.fromNumber=_ee;le.prototype.bitwiseTo=Dee;le.prototype.changeBit=Hee;le.prototype.addTo=Gee;le.prototype.dMultiply=tte;le.prototype.dAddOffset=rte;le.prototype.multiplyLowerTo=ote;le.prototype.multiplyUpperTo=ate;le.prototype.modInt=gte;le.prototype.millerRabin=Ste;le.prototype.clone=yee;le.prototype.intValue=vee;le.prototype.byteValue=See;le.prototype.shortValue=bee;le.prototype.signum=Eee;le.prototype.toByteArray=Tee;le.prototype.equals=Aee;le.prototype.min=Ree;le.prototype.max=Iee;le.prototype.and=kee;le.prototype.or=Nee;le.prototype.xor=Lee;le.prototype.andNot=Oee;le.prototype.not=Bee;le.prototype.shiftLeft=qee;le.prototype.shiftRight=Fee;le.prototype.getLowestSetBit=Uee;le.prototype.bitCount=jee;le.prototype.testBit=Vee;le.prototype.setBit=Wee;le.prototype.clearBit=Kee;le.prototype.flipBit=zee;le.prototype.add=Yee;le.prototype.subtract=Qee;le.prototype.multiply=Xee;le.prototype.divide=Jee;le.prototype.remainder=Zee;le.prototype.divideAndRemainder=ete;le.prototype.modPow=dte;le.prototype.modInverse=mte;le.prototype.pow=ste;le.prototype.gcd=pte;le.prototype.isProbablePrime=vte;});var Ta=A((Ohe,EL)=>{var wi=rt();Si();vt();var bL=EL.exports=wi.sha1=wi.sha1||{};wi.md.sha1=wi.md.algorithms.sha1=bL;bL.create=function(){CL||Cte();var e=null,t=wi.util.createBuffer(),r=new Array(80),n={algorithm:"sha1",blockLength:64,digestLength:20,messageLength:0,fullMessageLength:null,messageLengthSize:8};return n.start=function(){n.messageLength=0,n.fullMessageLength=n.messageLength64=[];for(var i=n.messageLengthSize/4,s=0;s<i;++s)n.fullMessageLength.push(0);return t=wi.util.createBuffer(),e={h0:1732584193,h1:4023233417,h2:2562383102,h3:271733878,h4:3285377520},n},n.start(),n.update=function(i,s){s==="utf8"&&(i=wi.util.encodeUtf8(i));var o=i.length;n.messageLength+=o,o=[o/4294967296>>>0,o>>>0];for(var a=n.fullMessageLength.length-1;a>=0;--a)n.fullMessageLength[a]+=o[1],o[1]=o[0]+(n.fullMessageLength[a]/4294967296>>>0),n.fullMessageLength[a]=n.fullMessageLength[a]>>>0,o[0]=o[1]/4294967296>>>0;return t.putBytes(i),SL(e,r,t),(t.read>2048||t.length()===0)&&t.compact(),n},n.digest=function(){var i=wi.util.createBuffer();i.putBytes(t.bytes());var s=n.fullMessageLength[n.fullMessageLength.length-1]+n.messageLengthSize,o=s&n.blockLength-1;i.putBytes(Tv.substr(0,n.blockLength-o));for(var a,c,l=n.fullMessageLength[0]*8,u=0;u<n.fullMessageLength.length-1;++u)a=n.fullMessageLength[u+1]*8,c=a/4294967296>>>0,l+=c,i.putInt32(l>>>0),l=a>>>0;i.putInt32(l);var f={h0:e.h0,h1:e.h1,h2:e.h2,h3:e.h3,h4:e.h4};SL(f,r,i);var d=wi.util.createBuffer();return d.putInt32(f.h0),d.putInt32(f.h1),d.putInt32(f.h2),d.putInt32(f.h3),d.putInt32(f.h4),d},n};var Tv=null,CL=!1;function Cte(){Tv="\x80",Tv+=wi.util.fillString("\0",64),CL=!0;}function SL(e,t,r){for(var n,i,s,o,a,c,l,u,f=r.length();f>=64;){for(i=e.h0,s=e.h1,o=e.h2,a=e.h3,c=e.h4,u=0;u<16;++u)n=r.getInt32(),t[u]=n,l=a^s&(o^a),n=(i<<5|i>>>27)+l+c+1518500249+n,c=a,a=o,o=(s<<30|s>>>2)>>>0,s=i,i=n;for(;u<20;++u)n=t[u-3]^t[u-8]^t[u-14]^t[u-16],n=n<<1|n>>>31,t[u]=n,l=a^s&(o^a),n=(i<<5|i>>>27)+l+c+1518500249+n,c=a,a=o,o=(s<<30|s>>>2)>>>0,s=i,i=n;for(;u<32;++u)n=t[u-3]^t[u-8]^t[u-14]^t[u-16],n=n<<1|n>>>31,t[u]=n,l=s^o^a,n=(i<<5|i>>>27)+l+c+1859775393+n,c=a,a=o,o=(s<<30|s>>>2)>>>0,s=i,i=n;for(;u<40;++u)n=t[u-6]^t[u-16]^t[u-28]^t[u-32],n=n<<2|n>>>30,t[u]=n,l=s^o^a,n=(i<<5|i>>>27)+l+c+1859775393+n,c=a,a=o,o=(s<<30|s>>>2)>>>0,s=i,i=n;for(;u<60;++u)n=t[u-6]^t[u-16]^t[u-28]^t[u-32],n=n<<2|n>>>30,t[u]=n,l=s&o|a&(s^o),n=(i<<5|i>>>27)+l+c+2400959708+n,c=a,a=o,o=(s<<30|s>>>2)>>>0,s=i,i=n;for(;u<80;++u)n=t[u-6]^t[u-16]^t[u-28]^t[u-32],n=n<<2|n>>>30,t[u]=n,l=s^o^a,n=(i<<5|i>>>27)+l+c+3395469782+n,c=a,a=o,o=(s<<30|s>>>2)>>>0,s=i,i=n;e.h0=e.h0+i|0,e.h1=e.h1+s|0,e.h2=e.h2+o|0,e.h3=e.h3+a|0,e.h4=e.h4+c|0,f-=64;}}});var Av=A((Bhe,wL)=>{var _i=rt();vt();Ln();Ta();var xL=wL.exports=_i.pkcs1=_i.pkcs1||{};xL.encode_rsa_oaep=function(e,t,r){var n,i,s,o;typeof r=="string"?(n=r,i=arguments[3]||void 0,s=arguments[4]||void 0):r&&(n=r.label||void 0,i=r.seed||void 0,s=r.md||void 0,r.mgf1&&r.mgf1.md&&(o=r.mgf1.md)),s?s.start():s=_i.md.sha1.create(),o||(o=s);var a=Math.ceil(e.n.bitLength()/8),c=a-2*s.digestLength-2;if(t.length>c){var l=new Error("RSAES-OAEP input message length is too long.");throw l.length=t.length,l.maxLength=c,l}n||(n=""),s.update(n,"raw");for(var u=s.digest(),f="",d=c-t.length,p=0;p<d;p++)f+="\0";var m=u.getBytes()+f+""+t;if(!i)i=_i.random.getBytes(s.digestLength);else if(i.length!==s.digestLength){var l=new Error("Invalid RSAES-OAEP seed. The seed length must match the digest length.");throw l.seedLength=i.length,l.digestLength=s.digestLength,l}var S=Ih(i,a-s.digestLength-1,o),x=_i.util.xorBytes(m,S,m.length),I=Ih(x,s.digestLength,o),v=_i.util.xorBytes(i,I,i.length);return "\0"+v+x};xL.decode_rsa_oaep=function(e,t,r){var n,i,s;typeof r=="string"?(n=r,i=arguments[3]||void 0):r&&(n=r.label||void 0,i=r.md||void 0,r.mgf1&&r.mgf1.md&&(s=r.mgf1.md));var o=Math.ceil(e.n.bitLength()/8);if(t.length!==o){var x=new Error("RSAES-OAEP encoded message length is invalid.");throw x.length=t.length,x.expectedLength=o,x}if(i===void 0?i=_i.md.sha1.create():i.start(),s||(s=i),o<2*i.digestLength+2)throw new Error("RSAES-OAEP key is too short for the hash function.");n||(n=""),i.update(n,"raw");for(var a=i.digest().getBytes(),c=t.charAt(0),l=t.substring(1,i.digestLength+1),u=t.substring(1+i.digestLength),f=Ih(u,i.digestLength,s),d=_i.util.xorBytes(l,f,l.length),p=Ih(d,o-i.digestLength-1,s),m=_i.util.xorBytes(u,p,u.length),S=m.substring(0,i.digestLength),x=c!=="\0",I=0;I<i.digestLength;++I)x|=a.charAt(I)!==S.charAt(I);for(var v=1,b=i.digestLength,D=i.digestLength;D<m.length;D++){var L=m.charCodeAt(D),j=L&1^1,J=v?65534:0;x|=L&J,v=v&j,b+=v;}if(x||m.charCodeAt(b)!==1)throw new Error("Invalid RSAES-OAEP padding.");return m.substring(b+1)};function Ih(e,t,r){r||(r=_i.md.sha1.create());for(var n="",i=Math.ceil(t/r.digestLength),s=0;s<i;++s){var o=String.fromCharCode(s>>24&255,s>>16&255,s>>8&255,s&255);r.start(),r.update(e+o),n+=r.digest().getBytes();}return n.substring(0,t)}});var Iv=A((qhe,Rv)=>{var Es=rt();vt();vc();Ln();(function(){if(Es.prime){Rv.exports=Es.prime;return}var e=Rv.exports=Es.prime=Es.prime||{},t=Es.jsbn.BigInteger,r=[6,4,2,4,2,4,6,2],n=new t(null);n.fromInt(30);var i=function(f,d){return f|d};e.generateProbablePrime=function(f,d,p){typeof d=="function"&&(p=d,d={}),d=d||{};var m=d.algorithm||"PRIMEINC";typeof m=="string"&&(m={name:m}),m.options=m.options||{};var S=d.prng||Es.random,x={nextBytes:function(I){for(var v=S.getBytesSync(I.length),b=0;b<I.length;++b)I[b]=v.charCodeAt(b);}};if(m.name==="PRIMEINC")return s(f,x,m.options,p);throw new Error("Invalid prime generation algorithm: "+m.name)};function s(f,d,p,m){return "workers"in p?c(f,d,p,m):o(f,d,p,m)}function o(f,d,p,m){var S=l(f,d),x=0,I=u(S.bitLength());"millerRabinTests"in p&&(I=p.millerRabinTests);var v=10;"maxBlockTime"in p&&(v=p.maxBlockTime),a(S,f,d,x,I,v,m);}function a(f,d,p,m,S,x,I){var v=+new Date;do{if(f.bitLength()>d&&(f=l(d,p)),f.isProbablePrime(S))return I(null,f);f.dAddOffset(r[m++%8],0);}while(x<0||+new Date-v<x);Es.util.setImmediate(function(){a(f,d,p,m,S,x,I);});}function c(f,d,p,m){if(typeof Worker>"u")return o(f,d,p,m);var S=l(f,d),x=p.workers,I=p.workLoad||100,v=I*30/8,b=p.workerScript||"forge/prime.worker.js";if(x===-1)return Es.util.estimateCores(function(L,j){L&&(j=2),x=j-1,D();});D();function D(){x=Math.max(1,x);for(var L=[],j=0;j<x;++j)L[j]=new Worker(b);for(var J=x,j=0;j<x;++j)L[j].addEventListener("message",G);var K=!1;function G(ee){if(!K){--J;var M=ee.data;if(M.found){for(var ae=0;ae<L.length;++ae)L[ae].terminate();return K=!0,m(null,new t(M.prime,16))}S.bitLength()>f&&(S=l(f,d));var me=S.toString(16);ee.target.postMessage({hex:me,workLoad:I}),S.dAddOffset(v,0);}}}}function l(f,d){var p=new t(f,d),m=f-1;return p.testBit(m)||p.bitwiseTo(t.ONE.shiftLeft(m),i,p),p.dAddOffset(31-p.mod(n).byteValue(),0),p}function u(f){return f<=100?27:f<=150?18:f<=200?15:f<=250?12:f<=300?9:f<=350?8:f<=400?7:f<=500?6:f<=600?5:f<=800?4:f<=1250?3:2}})();});var Sc=A((Fhe,PL)=>{var Me=rt();ni();vc();bs();Av();Iv();Ln();vt();typeof gt>"u"&&(gt=Me.jsbn.BigInteger);var gt,Dv=Me.util.isNodejs?he("crypto"):null,Y=Me.asn1,Bn=Me.util;Me.pki=Me.pki||{};PL.exports=Me.pki.rsa=Me.rsa=Me.rsa||{};var Ze=Me.pki,Ete=[6,4,2,4,2,4,6,2],xte={name:"PrivateKeyInfo",tagClass:Y.Class.UNIVERSAL,type:Y.Type.SEQUENCE,constructed:!0,value:[{name:"PrivateKeyInfo.version",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"privateKeyVersion"},{name:"PrivateKeyInfo.privateKeyAlgorithm",tagClass:Y.Class.UNIVERSAL,type:Y.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:Y.Class.UNIVERSAL,type:Y.Type.OID,constructed:!1,capture:"privateKeyOid"}]},{name:"PrivateKeyInfo",tagClass:Y.Class.UNIVERSAL,type:Y.Type.OCTETSTRING,constructed:!1,capture:"privateKey"}]},wte={name:"RSAPrivateKey",tagClass:Y.Class.UNIVERSAL,type:Y.Type.SEQUENCE,constructed:!0,value:[{name:"RSAPrivateKey.version",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"privateKeyVersion"},{name:"RSAPrivateKey.modulus",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"privateKeyModulus"},{name:"RSAPrivateKey.publicExponent",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"privateKeyPublicExponent"},{name:"RSAPrivateKey.privateExponent",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"privateKeyPrivateExponent"},{name:"RSAPrivateKey.prime1",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"privateKeyPrime1"},{name:"RSAPrivateKey.prime2",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"privateKeyPrime2"},{name:"RSAPrivateKey.exponent1",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"privateKeyExponent1"},{name:"RSAPrivateKey.exponent2",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"privateKeyExponent2"},{name:"RSAPrivateKey.coefficient",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"privateKeyCoefficient"}]},_te={name:"RSAPublicKey",tagClass:Y.Class.UNIVERSAL,type:Y.Type.SEQUENCE,constructed:!0,value:[{name:"RSAPublicKey.modulus",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"publicKeyModulus"},{name:"RSAPublicKey.exponent",tagClass:Y.Class.UNIVERSAL,type:Y.Type.INTEGER,constructed:!1,capture:"publicKeyExponent"}]},Tte=Me.pki.rsa.publicKeyValidator={name:"SubjectPublicKeyInfo",tagClass:Y.Class.UNIVERSAL,type:Y.Type.SEQUENCE,constructed:!0,captureAsn1:"subjectPublicKeyInfo",value:[{name:"SubjectPublicKeyInfo.AlgorithmIdentifier",tagClass:Y.Class.UNIVERSAL,type:Y.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:Y.Class.UNIVERSAL,type:Y.Type.OID,constructed:!1,capture:"publicKeyOid"}]},{name:"SubjectPublicKeyInfo.subjectPublicKey",tagClass:Y.Class.UNIVERSAL,type:Y.Type.BITSTRING,constructed:!1,value:[{name:"SubjectPublicKeyInfo.subjectPublicKey.RSAPublicKey",tagClass:Y.Class.UNIVERSAL,type:Y.Type.SEQUENCE,constructed:!0,optional:!0,captureAsn1:"rsaPublicKey"}]}]},Ate={name:"DigestInfo",tagClass:Y.Class.UNIVERSAL,type:Y.Type.SEQUENCE,constructed:!0,value:[{name:"DigestInfo.DigestAlgorithm",tagClass:Y.Class.UNIVERSAL,type:Y.Type.SEQUENCE,constructed:!0,value:[{name:"DigestInfo.DigestAlgorithm.algorithmIdentifier",tagClass:Y.Class.UNIVERSAL,type:Y.Type.OID,constructed:!1,capture:"algorithmIdentifier"},{name:"DigestInfo.DigestAlgorithm.parameters",tagClass:Y.Class.UNIVERSAL,type:Y.Type.NULL,capture:"parameters",optional:!0,constructed:!1}]},{name:"DigestInfo.digest",tagClass:Y.Class.UNIVERSAL,type:Y.Type.OCTETSTRING,constructed:!1,capture:"digest"}]},Rte=function(e){var t;if(e.algorithm in Ze.oids)t=Ze.oids[e.algorithm];else {var r=new Error("Unknown message digest algorithm.");throw r.algorithm=e.algorithm,r}var n=Y.oidToDer(t).getBytes(),i=Y.create(Y.Class.UNIVERSAL,Y.Type.SEQUENCE,!0,[]),s=Y.create(Y.Class.UNIVERSAL,Y.Type.SEQUENCE,!0,[]);s.value.push(Y.create(Y.Class.UNIVERSAL,Y.Type.OID,!1,n)),s.value.push(Y.create(Y.Class.UNIVERSAL,Y.Type.NULL,!1,""));var o=Y.create(Y.Class.UNIVERSAL,Y.Type.OCTETSTRING,!1,e.digest().getBytes());return i.value.push(s),i.value.push(o),Y.toDer(i).getBytes()},IL=function(e,t,r){if(r)return e.modPow(t.e,t.n);if(!t.p||!t.q)return e.modPow(t.d,t.n);t.dP||(t.dP=t.d.mod(t.p.subtract(gt.ONE))),t.dQ||(t.dQ=t.d.mod(t.q.subtract(gt.ONE))),t.qInv||(t.qInv=t.q.modInverse(t.p));var n;do n=new gt(Me.util.bytesToHex(Me.random.getBytes(t.n.bitLength()/8)),16);while(n.compareTo(t.n)>=0||!n.gcd(t.n).equals(gt.ONE));e=e.multiply(n.modPow(t.e,t.n)).mod(t.n);for(var i=e.mod(t.p).modPow(t.dP,t.p),s=e.mod(t.q).modPow(t.dQ,t.q);i.compareTo(s)<0;)i=i.add(t.p);var o=i.subtract(s).multiply(t.qInv).mod(t.p).multiply(t.q).add(s);return o=o.multiply(n.modInverse(t.n)).mod(t.n),o};Ze.rsa.encrypt=function(e,t,r){var n=r,i,s=Math.ceil(t.n.bitLength()/8);r!==!1&&r!==!0?(n=r===2,i=DL(e,t,r)):(i=Me.util.createBuffer(),i.putBytes(e));for(var o=new gt(i.toHex(),16),a=IL(o,t,n),c=a.toString(16),l=Me.util.createBuffer(),u=s-Math.ceil(c.length/2);u>0;)l.putByte(0),--u;return l.putBytes(Me.util.hexToBytes(c)),l.getBytes()};Ze.rsa.decrypt=function(e,t,r,n){var i=Math.ceil(t.n.bitLength()/8);if(e.length!==i){var s=new Error("Encrypted message length is invalid.");throw s.length=e.length,s.expected=i,s}var o=new gt(Me.util.createBuffer(e).toHex(),16);if(o.compareTo(t.n)>=0)throw new Error("Encrypted message is invalid.");for(var a=IL(o,t,r),c=a.toString(16),l=Me.util.createBuffer(),u=i-Math.ceil(c.length/2);u>0;)l.putByte(0),--u;return l.putBytes(Me.util.hexToBytes(c)),n!==!1?Dh(l.getBytes(),t,r):l.getBytes()};Ze.rsa.createKeyPairGenerationState=function(e,t,r){typeof e=="string"&&(e=parseInt(e,10)),e=e||2048,r=r||{};var n=r.prng||Me.random,i={nextBytes:function(a){for(var c=n.getBytesSync(a.length),l=0;l<a.length;++l)a[l]=c.charCodeAt(l);}},s=r.algorithm||"PRIMEINC",o;if(s==="PRIMEINC")o={algorithm:s,state:0,bits:e,rng:i,eInt:t||65537,e:new gt(null),p:null,q:null,qBits:e>>1,pBits:e-(e>>1),pqState:0,num:null,keys:null},o.e.fromInt(o.eInt);else throw new Error("Invalid key generation algorithm: "+s);return o};Ze.rsa.stepKeyPairGenerationState=function(e,t){"algorithm"in e||(e.algorithm="PRIMEINC");var r=new gt(null);r.fromInt(30);for(var n=0,i=function(f,d){return f|d},s=+new Date,o,a=0;e.keys===null&&(t<=0||a<t);){if(e.state===0){var c=e.p===null?e.pBits:e.qBits,l=c-1;e.pqState===0?(e.num=new gt(c,e.rng),e.num.testBit(l)||e.num.bitwiseTo(gt.ONE.shiftLeft(l),i,e.num),e.num.dAddOffset(31-e.num.mod(r).byteValue(),0),n=0,++e.pqState):e.pqState===1?e.num.bitLength()>c?e.pqState=0:e.num.isProbablePrime(Dte(e.num.bitLength()))?++e.pqState:e.num.dAddOffset(Ete[n++%8],0):e.pqState===2?e.pqState=e.num.subtract(gt.ONE).gcd(e.e).compareTo(gt.ONE)===0?3:0:e.pqState===3&&(e.pqState=0,e.p===null?e.p=e.num:e.q=e.num,e.p!==null&&e.q!==null&&++e.state,e.num=null);}else if(e.state===1)e.p.compareTo(e.q)<0&&(e.num=e.p,e.p=e.q,e.q=e.num),++e.state;else if(e.state===2)e.p1=e.p.subtract(gt.ONE),e.q1=e.q.subtract(gt.ONE),e.phi=e.p1.multiply(e.q1),++e.state;else if(e.state===3)e.phi.gcd(e.e).compareTo(gt.ONE)===0?++e.state:(e.p=null,e.q=null,e.state=0);else if(e.state===4)e.n=e.p.multiply(e.q),e.n.bitLength()===e.bits?++e.state:(e.q=null,e.state=0);else if(e.state===5){var u=e.e.modInverse(e.phi);e.keys={privateKey:Ze.rsa.setPrivateKey(e.n,e.e,u,e.p,e.q,u.mod(e.p1),u.mod(e.q1),e.q.modInverse(e.p)),publicKey:Ze.rsa.setPublicKey(e.n,e.e)};}o=+new Date,a+=o-s,s=o;}return e.keys!==null};Ze.rsa.generateKeyPair=function(e,t,r,n){if(arguments.length===1?typeof e=="object"?(r=e,e=void 0):typeof e=="function"&&(n=e,e=void 0):arguments.length===2?typeof e=="number"?typeof t=="function"?(n=t,t=void 0):typeof t!="number"&&(r=t,t=void 0):(r=e,n=t,e=void 0,t=void 0):arguments.length===3&&(typeof t=="number"?typeof r=="function"&&(n=r,r=void 0):(n=r,r=t,t=void 0)),r=r||{},e===void 0&&(e=r.bits||2048),t===void 0&&(t=r.e||65537),!Me.options.usePureJavaScript&&!r.prng&&e>=256&&e<=16384&&(t===65537||t===3)){if(n){if(_L("generateKeyPair"))return Dv.generateKeyPair("rsa",{modulusLength:e,publicExponent:t,publicKeyEncoding:{type:"spki",format:"pem"},privateKeyEncoding:{type:"pkcs8",format:"pem"}},function(a,c,l){if(a)return n(a);n(null,{privateKey:Ze.privateKeyFromPem(l),publicKey:Ze.publicKeyFromPem(c)});});if(TL("generateKey")&&TL("exportKey"))return Bn.globalScope.crypto.subtle.generateKey({name:"RSASSA-PKCS1-v1_5",modulusLength:e,publicExponent:RL(t),hash:{name:"SHA-256"}},!0,["sign","verify"]).then(function(a){return Bn.globalScope.crypto.subtle.exportKey("pkcs8",a.privateKey)}).then(void 0,function(a){n(a);}).then(function(a){if(a){var c=Ze.privateKeyFromAsn1(Y.fromDer(Me.util.createBuffer(a)));n(null,{privateKey:c,publicKey:Ze.setRsaPublicKey(c.n,c.e)});}});if(AL("generateKey")&&AL("exportKey")){var i=Bn.globalScope.msCrypto.subtle.generateKey({name:"RSASSA-PKCS1-v1_5",modulusLength:e,publicExponent:RL(t),hash:{name:"SHA-256"}},!0,["sign","verify"]);i.oncomplete=function(a){var c=a.target.result,l=Bn.globalScope.msCrypto.subtle.exportKey("pkcs8",c.privateKey);l.oncomplete=function(u){var f=u.target.result,d=Ze.privateKeyFromAsn1(Y.fromDer(Me.util.createBuffer(f)));n(null,{privateKey:d,publicKey:Ze.setRsaPublicKey(d.n,d.e)});},l.onerror=function(u){n(u);};},i.onerror=function(a){n(a);};return}}else if(_L("generateKeyPairSync")){var s=Dv.generateKeyPairSync("rsa",{modulusLength:e,publicExponent:t,publicKeyEncoding:{type:"spki",format:"pem"},privateKeyEncoding:{type:"pkcs8",format:"pem"}});return {privateKey:Ze.privateKeyFromPem(s.privateKey),publicKey:Ze.publicKeyFromPem(s.publicKey)}}}var o=Ze.rsa.createKeyPairGenerationState(e,t,r);if(!n)return Ze.rsa.stepKeyPairGenerationState(o,0),o.keys;Ite(o,r,n);};Ze.setRsaPublicKey=Ze.rsa.setPublicKey=function(e,t){var r={n:e,e:t};return r.encrypt=function(n,i,s){if(typeof i=="string"?i=i.toUpperCase():i===void 0&&(i="RSAES-PKCS1-V1_5"),i==="RSAES-PKCS1-V1_5")i={encode:function(a,c,l){return DL(a,c,2).getBytes()}};else if(i==="RSA-OAEP"||i==="RSAES-OAEP")i={encode:function(a,c){return Me.pkcs1.encode_rsa_oaep(c,a,s)}};else if(["RAW","NONE","NULL",null].indexOf(i)!==-1)i={encode:function(a){return a}};else if(typeof i=="string")throw new Error('Unsupported encryption scheme: "'+i+'".');var o=i.encode(n,r,!0);return Ze.rsa.encrypt(o,r,!0)},r.verify=function(n,i,s,o){typeof s=="string"?s=s.toUpperCase():s===void 0&&(s="RSASSA-PKCS1-V1_5"),o===void 0&&(o={_parseAllDigestBytes:!0}),"_parseAllDigestBytes"in o||(o._parseAllDigestBytes=!0),s==="RSASSA-PKCS1-V1_5"?s={verify:function(c,l){l=Dh(l,r,!0);var u=Y.fromDer(l,{parseAllBytes:o._parseAllDigestBytes}),f={},d=[];if(!Y.validate(u,Ate,f,d)){var p=new Error("ASN.1 object does not contain a valid RSASSA-PKCS1-v1_5 DigestInfo value.");throw p.errors=d,p}var m=Y.derToOid(f.algorithmIdentifier);if(!(m===Me.oids.md2||m===Me.oids.md5||m===Me.oids.sha1||m===Me.oids.sha224||m===Me.oids.sha256||m===Me.oids.sha384||m===Me.oids.sha512||m===Me.oids["sha512-224"]||m===Me.oids["sha512-256"])){var p=new Error("Unknown RSASSA-PKCS1-v1_5 DigestAlgorithm identifier.");throw p.oid=m,p}if((m===Me.oids.md2||m===Me.oids.md5)&&!("parameters"in f))throw new Error("ASN.1 object does not contain a valid RSASSA-PKCS1-v1_5 DigestInfo value. Missing algorithm identifer NULL parameters.");return c===f.digest}}:(s==="NONE"||s==="NULL"||s===null)&&(s={verify:function(c,l){return l=Dh(l,r,!0),c===l}});var a=Ze.rsa.decrypt(i,r,!0,!1);return s.verify(n,a,r.n.bitLength())},r};Ze.setRsaPrivateKey=Ze.rsa.setPrivateKey=function(e,t,r,n,i,s,o,a){var c={n:e,e:t,d:r,p:n,q:i,dP:s,dQ:o,qInv:a};return c.decrypt=function(l,u,f){typeof u=="string"?u=u.toUpperCase():u===void 0&&(u="RSAES-PKCS1-V1_5");var d=Ze.rsa.decrypt(l,c,!1,!1);if(u==="RSAES-PKCS1-V1_5")u={decode:Dh};else if(u==="RSA-OAEP"||u==="RSAES-OAEP")u={decode:function(p,m){return Me.pkcs1.decode_rsa_oaep(m,p,f)}};else if(["RAW","NONE","NULL",null].indexOf(u)!==-1)u={decode:function(p){return p}};else throw new Error('Unsupported encryption scheme: "'+u+'".');return u.decode(d,c,!1)},c.sign=function(l,u){var f=!1;typeof u=="string"&&(u=u.toUpperCase()),u===void 0||u==="RSASSA-PKCS1-V1_5"?(u={encode:Rte},f=1):(u==="NONE"||u==="NULL"||u===null)&&(u={encode:function(){return l}},f=1);var d=u.encode(l,c.n.bitLength());return Ze.rsa.encrypt(d,c,f)},c};Ze.wrapRsaPrivateKey=function(e){return Y.create(Y.Class.UNIVERSAL,Y.Type.SEQUENCE,!0,[Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Y.integerToDer(0).getBytes()),Y.create(Y.Class.UNIVERSAL,Y.Type.SEQUENCE,!0,[Y.create(Y.Class.UNIVERSAL,Y.Type.OID,!1,Y.oidToDer(Ze.oids.rsaEncryption).getBytes()),Y.create(Y.Class.UNIVERSAL,Y.Type.NULL,!1,"")]),Y.create(Y.Class.UNIVERSAL,Y.Type.OCTETSTRING,!1,Y.toDer(e).getBytes())])};Ze.privateKeyFromAsn1=function(e){var t={},r=[];if(Y.validate(e,xte,t,r)&&(e=Y.fromDer(Me.util.createBuffer(t.privateKey))),t={},r=[],!Y.validate(e,wte,t,r)){var n=new Error("Cannot read private key. ASN.1 object does not contain an RSAPrivateKey.");throw n.errors=r,n}var i,s,o,a,c,l,u,f;return i=Me.util.createBuffer(t.privateKeyModulus).toHex(),s=Me.util.createBuffer(t.privateKeyPublicExponent).toHex(),o=Me.util.createBuffer(t.privateKeyPrivateExponent).toHex(),a=Me.util.createBuffer(t.privateKeyPrime1).toHex(),c=Me.util.createBuffer(t.privateKeyPrime2).toHex(),l=Me.util.createBuffer(t.privateKeyExponent1).toHex(),u=Me.util.createBuffer(t.privateKeyExponent2).toHex(),f=Me.util.createBuffer(t.privateKeyCoefficient).toHex(),Ze.setRsaPrivateKey(new gt(i,16),new gt(s,16),new gt(o,16),new gt(a,16),new gt(c,16),new gt(l,16),new gt(u,16),new gt(f,16))};Ze.privateKeyToAsn1=Ze.privateKeyToRSAPrivateKey=function(e){return Y.create(Y.Class.UNIVERSAL,Y.Type.SEQUENCE,!0,[Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Y.integerToDer(0).getBytes()),Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Ti(e.n)),Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Ti(e.e)),Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Ti(e.d)),Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Ti(e.p)),Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Ti(e.q)),Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Ti(e.dP)),Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Ti(e.dQ)),Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Ti(e.qInv))])};Ze.publicKeyFromAsn1=function(e){var t={},r=[];if(Y.validate(e,Tte,t,r)){var n=Y.derToOid(t.publicKeyOid);if(n!==Ze.oids.rsaEncryption){var i=new Error("Cannot read public key. Unknown OID.");throw i.oid=n,i}e=t.rsaPublicKey;}if(r=[],!Y.validate(e,_te,t,r)){var i=new Error("Cannot read public key. ASN.1 object does not contain an RSAPublicKey.");throw i.errors=r,i}var s=Me.util.createBuffer(t.publicKeyModulus).toHex(),o=Me.util.createBuffer(t.publicKeyExponent).toHex();return Ze.setRsaPublicKey(new gt(s,16),new gt(o,16))};Ze.publicKeyToAsn1=Ze.publicKeyToSubjectPublicKeyInfo=function(e){return Y.create(Y.Class.UNIVERSAL,Y.Type.SEQUENCE,!0,[Y.create(Y.Class.UNIVERSAL,Y.Type.SEQUENCE,!0,[Y.create(Y.Class.UNIVERSAL,Y.Type.OID,!1,Y.oidToDer(Ze.oids.rsaEncryption).getBytes()),Y.create(Y.Class.UNIVERSAL,Y.Type.NULL,!1,"")]),Y.create(Y.Class.UNIVERSAL,Y.Type.BITSTRING,!1,[Ze.publicKeyToRSAPublicKey(e)])])};Ze.publicKeyToRSAPublicKey=function(e){return Y.create(Y.Class.UNIVERSAL,Y.Type.SEQUENCE,!0,[Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Ti(e.n)),Y.create(Y.Class.UNIVERSAL,Y.Type.INTEGER,!1,Ti(e.e))])};function DL(e,t,r){var n=Me.util.createBuffer(),i=Math.ceil(t.n.bitLength()/8);if(e.length>i-11){var s=new Error("Message is too long for PKCS#1 v1.5 padding.");throw s.length=e.length,s.max=i-11,s}n.putByte(0),n.putByte(r);var o=i-3-e.length,a;if(r===0||r===1){a=r===0?0:255;for(var c=0;c<o;++c)n.putByte(a);}else for(;o>0;){for(var l=0,u=Me.random.getBytes(o),c=0;c<o;++c)a=u.charCodeAt(c),a===0?++l:n.putByte(a);o=l;}return n.putByte(0),n.putBytes(e),n}function Dh(e,t,r,n){var i=Math.ceil(t.n.bitLength()/8),s=Me.util.createBuffer(e),o=s.getByte(),a=s.getByte();if(o!==0||r&&a!==0&&a!==1||!r&&a!=2||r&&a===0&&typeof n>"u")throw new Error("Encryption block is invalid.");var c=0;if(a===0){c=i-3-n;for(var l=0;l<c;++l)if(s.getByte()!==0)throw new Error("Encryption block is invalid.")}else if(a===1)for(c=0;s.length()>1;){if(s.getByte()!==255){--s.read;break}++c;}else if(a===2)for(c=0;s.length()>1;){if(s.getByte()===0){--s.read;break}++c;}var u=s.getByte();if(u!==0||c!==i-3-s.length())throw new Error("Encryption block is invalid.");return s.getBytes()}function Ite(e,t,r){typeof t=="function"&&(r=t,t={}),t=t||{};var n={algorithm:{name:t.algorithm||"PRIMEINC",options:{workers:t.workers||2,workLoad:t.workLoad||100,workerScript:t.workerScript}}};"prng"in t&&(n.prng=t.prng),i();function i(){s(e.pBits,function(a,c){if(a)return r(a);if(e.p=c,e.q!==null)return o(a,e.q);s(e.qBits,o);});}function s(a,c){Me.prime.generateProbablePrime(a,n,c);}function o(a,c){if(a)return r(a);if(e.q=c,e.p.compareTo(e.q)<0){var l=e.p;e.p=e.q,e.q=l;}if(e.p.subtract(gt.ONE).gcd(e.e).compareTo(gt.ONE)!==0){e.p=null,i();return}if(e.q.subtract(gt.ONE).gcd(e.e).compareTo(gt.ONE)!==0){e.q=null,s(e.qBits,o);return}if(e.p1=e.p.subtract(gt.ONE),e.q1=e.q.subtract(gt.ONE),e.phi=e.p1.multiply(e.q1),e.phi.gcd(e.e).compareTo(gt.ONE)!==0){e.p=e.q=null,i();return}if(e.n=e.p.multiply(e.q),e.n.bitLength()!==e.bits){e.q=null,s(e.qBits,o);return}var u=e.e.modInverse(e.phi);e.keys={privateKey:Ze.rsa.setPrivateKey(e.n,e.e,u,e.p,e.q,u.mod(e.p1),u.mod(e.q1),e.q.modInverse(e.p)),publicKey:Ze.rsa.setPublicKey(e.n,e.e)},r(null,e.keys);}}function Ti(e){var t=e.toString(16);t[0]>="8"&&(t="00"+t);var r=Me.util.hexToBytes(t);return r.length>1&&(r.charCodeAt(0)===0&&!(r.charCodeAt(1)&128)||r.charCodeAt(0)===255&&(r.charCodeAt(1)&128)===128)?r.substr(1):r}function Dte(e){return e<=100?27:e<=150?18:e<=200?15:e<=250?12:e<=300?9:e<=350?8:e<=400?7:e<=500?6:e<=600?5:e<=800?4:e<=1250?3:2}function _L(e){return Me.util.isNodejs&&typeof Dv[e]=="function"}function TL(e){return typeof Bn.globalScope<"u"&&typeof Bn.globalScope.crypto=="object"&&typeof Bn.globalScope.crypto.subtle=="object"&&typeof Bn.globalScope.crypto.subtle[e]=="function"}function AL(e){return typeof Bn.globalScope<"u"&&typeof Bn.globalScope.msCrypto=="object"&&typeof Bn.globalScope.msCrypto.subtle=="object"&&typeof Bn.globalScope.msCrypto.subtle[e]=="function"}function RL(e){for(var t=Me.util.hexToBytes(e.toString(16)),r=new Uint8Array(t.length),n=0;n<t.length;++n)r[n]=t.charCodeAt(n);return r}});var Pv=A((Mhe,BL)=>{var Ae=rt();Ss();ni();mc();Si();bs();_h();po();Ln();Ev();Sc();vt();var Z=Ae.asn1,tt=Ae.pki=Ae.pki||{};BL.exports=tt.pbe=Ae.pbe=Ae.pbe||{};var yo=tt.oids,Pte={name:"EncryptedPrivateKeyInfo",tagClass:Z.Class.UNIVERSAL,type:Z.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedPrivateKeyInfo.encryptionAlgorithm",tagClass:Z.Class.UNIVERSAL,type:Z.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:Z.Class.UNIVERSAL,type:Z.Type.OID,constructed:!1,capture:"encryptionOid"},{name:"AlgorithmIdentifier.parameters",tagClass:Z.Class.UNIVERSAL,type:Z.Type.SEQUENCE,constructed:!0,captureAsn1:"encryptionParams"}]},{name:"EncryptedPrivateKeyInfo.encryptedData",tagClass:Z.Class.UNIVERSAL,type:Z.Type.OCTETSTRING,constructed:!1,capture:"encryptedData"}]},kte={name:"PBES2Algorithms",tagClass:Z.Class.UNIVERSAL,type:Z.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.keyDerivationFunc",tagClass:Z.Class.UNIVERSAL,type:Z.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.keyDerivationFunc.oid",tagClass:Z.Class.UNIVERSAL,type:Z.Type.OID,constructed:!1,capture:"kdfOid"},{name:"PBES2Algorithms.params",tagClass:Z.Class.UNIVERSAL,type:Z.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.params.salt",tagClass:Z.Class.UNIVERSAL,type:Z.Type.OCTETSTRING,constructed:!1,capture:"kdfSalt"},{name:"PBES2Algorithms.params.iterationCount",tagClass:Z.Class.UNIVERSAL,type:Z.Type.INTEGER,constructed:!1,capture:"kdfIterationCount"},{name:"PBES2Algorithms.params.keyLength",tagClass:Z.Class.UNIVERSAL,type:Z.Type.INTEGER,constructed:!1,optional:!0,capture:"keyLength"},{name:"PBES2Algorithms.params.prf",tagClass:Z.Class.UNIVERSAL,type:Z.Type.SEQUENCE,constructed:!0,optional:!0,value:[{name:"PBES2Algorithms.params.prf.algorithm",tagClass:Z.Class.UNIVERSAL,type:Z.Type.OID,constructed:!1,capture:"prfOid"}]}]}]},{name:"PBES2Algorithms.encryptionScheme",tagClass:Z.Class.UNIVERSAL,type:Z.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.encryptionScheme.oid",tagClass:Z.Class.UNIVERSAL,type:Z.Type.OID,constructed:!1,capture:"encOid"},{name:"PBES2Algorithms.encryptionScheme.iv",tagClass:Z.Class.UNIVERSAL,type:Z.Type.OCTETSTRING,constructed:!1,capture:"encIv"}]}]},Nte={name:"pkcs-12PbeParams",tagClass:Z.Class.UNIVERSAL,type:Z.Type.SEQUENCE,constructed:!0,value:[{name:"pkcs-12PbeParams.salt",tagClass:Z.Class.UNIVERSAL,type:Z.Type.OCTETSTRING,constructed:!1,capture:"salt"},{name:"pkcs-12PbeParams.iterations",tagClass:Z.Class.UNIVERSAL,type:Z.Type.INTEGER,constructed:!1,capture:"iterations"}]};tt.encryptPrivateKeyInfo=function(e,t,r){r=r||{},r.saltSize=r.saltSize||8,r.count=r.count||2048,r.algorithm=r.algorithm||"aes128",r.prfAlgorithm=r.prfAlgorithm||"sha1";var n=Ae.random.getBytesSync(r.saltSize),i=r.count,s=Z.integerToDer(i),o,a,c;if(r.algorithm.indexOf("aes")===0||r.algorithm==="des"){var l,u,f;switch(r.algorithm){case"aes128":o=16,l=16,u=yo["aes128-CBC"],f=Ae.aes.createEncryptionCipher;break;case"aes192":o=24,l=16,u=yo["aes192-CBC"],f=Ae.aes.createEncryptionCipher;break;case"aes256":o=32,l=16,u=yo["aes256-CBC"],f=Ae.aes.createEncryptionCipher;break;case"des":o=8,l=8,u=yo.desCBC,f=Ae.des.createEncryptionCipher;break;default:var d=new Error("Cannot encrypt private key. Unknown encryption algorithm.");throw d.algorithm=r.algorithm,d}var p="hmacWith"+r.prfAlgorithm.toUpperCase(),m=OL(p),S=Ae.pkcs5.pbkdf2(t,n,i,o,m),x=Ae.random.getBytesSync(l),I=f(S);I.start(x),I.update(Z.toDer(e)),I.finish(),c=I.output.getBytes();var v=Lte(n,s,o,p);a=Z.create(Z.Class.UNIVERSAL,Z.Type.SEQUENCE,!0,[Z.create(Z.Class.UNIVERSAL,Z.Type.OID,!1,Z.oidToDer(yo.pkcs5PBES2).getBytes()),Z.create(Z.Class.UNIVERSAL,Z.Type.SEQUENCE,!0,[Z.create(Z.Class.UNIVERSAL,Z.Type.SEQUENCE,!0,[Z.create(Z.Class.UNIVERSAL,Z.Type.OID,!1,Z.oidToDer(yo.pkcs5PBKDF2).getBytes()),v]),Z.create(Z.Class.UNIVERSAL,Z.Type.SEQUENCE,!0,[Z.create(Z.Class.UNIVERSAL,Z.Type.OID,!1,Z.oidToDer(u).getBytes()),Z.create(Z.Class.UNIVERSAL,Z.Type.OCTETSTRING,!1,x)])])]);}else if(r.algorithm==="3des"){o=24;var b=new Ae.util.ByteBuffer(n),S=tt.pbe.generatePkcs12Key(t,b,1,i,o),x=tt.pbe.generatePkcs12Key(t,b,2,i,o),I=Ae.des.createEncryptionCipher(S);I.start(x),I.update(Z.toDer(e)),I.finish(),c=I.output.getBytes(),a=Z.create(Z.Class.UNIVERSAL,Z.Type.SEQUENCE,!0,[Z.create(Z.Class.UNIVERSAL,Z.Type.OID,!1,Z.oidToDer(yo["pbeWithSHAAnd3-KeyTripleDES-CBC"]).getBytes()),Z.create(Z.Class.UNIVERSAL,Z.Type.SEQUENCE,!0,[Z.create(Z.Class.UNIVERSAL,Z.Type.OCTETSTRING,!1,n),Z.create(Z.Class.UNIVERSAL,Z.Type.INTEGER,!1,s.getBytes())])]);}else {var d=new Error("Cannot encrypt private key. Unknown encryption algorithm.");throw d.algorithm=r.algorithm,d}var D=Z.create(Z.Class.UNIVERSAL,Z.Type.SEQUENCE,!0,[a,Z.create(Z.Class.UNIVERSAL,Z.Type.OCTETSTRING,!1,c)]);return D};tt.decryptPrivateKeyInfo=function(e,t){var r=null,n={},i=[];if(!Z.validate(e,Pte,n,i)){var s=new Error("Cannot read encrypted private key. ASN.1 object is not a supported EncryptedPrivateKeyInfo.");throw s.errors=i,s}var o=Z.derToOid(n.encryptionOid),a=tt.pbe.getCipher(o,n.encryptionParams,t),c=Ae.util.createBuffer(n.encryptedData);return a.update(c),a.finish()&&(r=Z.fromDer(a.output)),r};tt.encryptedPrivateKeyToPem=function(e,t){var r={type:"ENCRYPTED PRIVATE KEY",body:Z.toDer(e).getBytes()};return Ae.pem.encode(r,{maxline:t})};tt.encryptedPrivateKeyFromPem=function(e){var t=Ae.pem.decode(e)[0];if(t.type!=="ENCRYPTED PRIVATE KEY"){var r=new Error('Could not convert encrypted private key from PEM; PEM header type is "ENCRYPTED PRIVATE KEY".');throw r.headerType=t.type,r}if(t.procType&&t.procType.type==="ENCRYPTED")throw new Error("Could not convert encrypted private key from PEM; PEM is encrypted.");return Z.fromDer(t.body)};tt.encryptRsaPrivateKey=function(e,t,r){if(r=r||{},!r.legacy){var n=tt.wrapRsaPrivateKey(tt.privateKeyToAsn1(e));return n=tt.encryptPrivateKeyInfo(n,t,r),tt.encryptedPrivateKeyToPem(n)}var i,s,o,a;switch(r.algorithm){case"aes128":i="AES-128-CBC",o=16,s=Ae.random.getBytesSync(16),a=Ae.aes.createEncryptionCipher;break;case"aes192":i="AES-192-CBC",o=24,s=Ae.random.getBytesSync(16),a=Ae.aes.createEncryptionCipher;break;case"aes256":i="AES-256-CBC",o=32,s=Ae.random.getBytesSync(16),a=Ae.aes.createEncryptionCipher;break;case"3des":i="DES-EDE3-CBC",o=24,s=Ae.random.getBytesSync(8),a=Ae.des.createEncryptionCipher;break;case"des":i="DES-CBC",o=8,s=Ae.random.getBytesSync(8),a=Ae.des.createEncryptionCipher;break;default:var c=new Error('Could not encrypt RSA private key; unsupported encryption algorithm "'+r.algorithm+'".');throw c.algorithm=r.algorithm,c}var l=Ae.pbe.opensslDeriveBytes(t,s.substr(0,8),o),u=a(l);u.start(s),u.update(Z.toDer(tt.privateKeyToAsn1(e))),u.finish();var f={type:"RSA PRIVATE KEY",procType:{version:"4",type:"ENCRYPTED"},dekInfo:{algorithm:i,parameters:Ae.util.bytesToHex(s).toUpperCase()},body:u.output.getBytes()};return Ae.pem.encode(f)};tt.decryptRsaPrivateKey=function(e,t){var r=null,n=Ae.pem.decode(e)[0];if(n.type!=="ENCRYPTED PRIVATE KEY"&&n.type!=="PRIVATE KEY"&&n.type!=="RSA PRIVATE KEY"){var i=new Error('Could not convert private key from PEM; PEM header type is not "ENCRYPTED PRIVATE KEY", "PRIVATE KEY", or "RSA PRIVATE KEY".');throw i.headerType=i,i}if(n.procType&&n.procType.type==="ENCRYPTED"){var s,o;switch(n.dekInfo.algorithm){case"DES-CBC":s=8,o=Ae.des.createDecryptionCipher;break;case"DES-EDE3-CBC":s=24,o=Ae.des.createDecryptionCipher;break;case"AES-128-CBC":s=16,o=Ae.aes.createDecryptionCipher;break;case"AES-192-CBC":s=24,o=Ae.aes.createDecryptionCipher;break;case"AES-256-CBC":s=32,o=Ae.aes.createDecryptionCipher;break;case"RC2-40-CBC":s=5,o=function(f){return Ae.rc2.createDecryptionCipher(f,40)};break;case"RC2-64-CBC":s=8,o=function(f){return Ae.rc2.createDecryptionCipher(f,64)};break;case"RC2-128-CBC":s=16,o=function(f){return Ae.rc2.createDecryptionCipher(f,128)};break;default:var i=new Error('Could not decrypt private key; unsupported encryption algorithm "'+n.dekInfo.algorithm+'".');throw i.algorithm=n.dekInfo.algorithm,i}var a=Ae.util.hexToBytes(n.dekInfo.parameters),c=Ae.pbe.opensslDeriveBytes(t,a.substr(0,8),s),l=o(c);if(l.start(a),l.update(Ae.util.createBuffer(n.body)),l.finish())r=l.output.getBytes();else return r}else r=n.body;return n.type==="ENCRYPTED PRIVATE KEY"?r=tt.decryptPrivateKeyInfo(Z.fromDer(r),t):r=Z.fromDer(r),r!==null&&(r=tt.privateKeyFromAsn1(r)),r};tt.pbe.generatePkcs12Key=function(e,t,r,n,i,s){var o,a;if(typeof s>"u"||s===null){if(!("sha1"in Ae.md))throw new Error('"sha1" hash algorithm unavailable.');s=Ae.md.sha1.create();}var c=s.digestLength,l=s.blockLength,u=new Ae.util.ByteBuffer,f=new Ae.util.ByteBuffer;if(e!=null){for(a=0;a<e.length;a++)f.putInt16(e.charCodeAt(a));f.putInt16(0);}var d=f.length(),p=t.length(),m=new Ae.util.ByteBuffer;m.fillWithByte(r,l);var S=l*Math.ceil(p/l),x=new Ae.util.ByteBuffer;for(a=0;a<S;a++)x.putByte(t.at(a%p));var I=l*Math.ceil(d/l),v=new Ae.util.ByteBuffer;for(a=0;a<I;a++)v.putByte(f.at(a%d));var b=x;b.putBuffer(v);for(var D=Math.ceil(i/c),L=1;L<=D;L++){var j=new Ae.util.ByteBuffer;j.putBytes(m.bytes()),j.putBytes(b.bytes());for(var J=0;J<n;J++)s.start(),s.update(j.getBytes()),j=s.digest();var K=new Ae.util.ByteBuffer;for(a=0;a<l;a++)K.putByte(j.at(a%c));var G=Math.ceil(p/l)+Math.ceil(d/l),ee=new Ae.util.ByteBuffer;for(o=0;o<G;o++){var M=new Ae.util.ByteBuffer(b.getBytes(l)),ae=511;for(a=K.length()-1;a>=0;a--)ae=ae>>8,ae+=K.at(a)+M.at(a),M.setAt(a,ae&255);ee.putBuffer(M);}b=ee,u.putBuffer(j);}return u.truncate(u.length()-i),u};tt.pbe.getCipher=function(e,t,r){switch(e){case tt.oids.pkcs5PBES2:return tt.pbe.getCipherForPBES2(e,t,r);case tt.oids["pbeWithSHAAnd3-KeyTripleDES-CBC"]:case tt.oids["pbewithSHAAnd40BitRC2-CBC"]:return tt.pbe.getCipherForPKCS12PBE(e,t,r);default:var n=new Error("Cannot read encrypted PBE data block. Unsupported OID.");throw n.oid=e,n.supportedOids=["pkcs5PBES2","pbeWithSHAAnd3-KeyTripleDES-CBC","pbewithSHAAnd40BitRC2-CBC"],n}};tt.pbe.getCipherForPBES2=function(e,t,r){var n={},i=[];if(!Z.validate(t,kte,n,i)){var s=new Error("Cannot read password-based-encryption algorithm parameters. ASN.1 object is not a supported EncryptedPrivateKeyInfo.");throw s.errors=i,s}if(e=Z.derToOid(n.kdfOid),e!==tt.oids.pkcs5PBKDF2){var s=new Error("Cannot read encrypted private key. Unsupported key derivation function OID.");throw s.oid=e,s.supportedOids=["pkcs5PBKDF2"],s}if(e=Z.derToOid(n.encOid),e!==tt.oids["aes128-CBC"]&&e!==tt.oids["aes192-CBC"]&&e!==tt.oids["aes256-CBC"]&&e!==tt.oids["des-EDE3-CBC"]&&e!==tt.oids.desCBC){var s=new Error("Cannot read encrypted private key. Unsupported encryption scheme OID.");throw s.oid=e,s.supportedOids=["aes128-CBC","aes192-CBC","aes256-CBC","des-EDE3-CBC","desCBC"],s}var o=n.kdfSalt,a=Ae.util.createBuffer(n.kdfIterationCount);a=a.getInt(a.length()<<3);var c,l;switch(tt.oids[e]){case"aes128-CBC":c=16,l=Ae.aes.createDecryptionCipher;break;case"aes192-CBC":c=24,l=Ae.aes.createDecryptionCipher;break;case"aes256-CBC":c=32,l=Ae.aes.createDecryptionCipher;break;case"des-EDE3-CBC":c=24,l=Ae.des.createDecryptionCipher;break;case"desCBC":c=8,l=Ae.des.createDecryptionCipher;break}var u=LL(n.prfOid),f=Ae.pkcs5.pbkdf2(r,o,a,c,u),d=n.encIv,p=l(f);return p.start(d),p};tt.pbe.getCipherForPKCS12PBE=function(e,t,r){var n={},i=[];if(!Z.validate(t,Nte,n,i)){var s=new Error("Cannot read password-based-encryption algorithm parameters. ASN.1 object is not a supported EncryptedPrivateKeyInfo.");throw s.errors=i,s}var o=Ae.util.createBuffer(n.salt),a=Ae.util.createBuffer(n.iterations);a=a.getInt(a.length()<<3);var c,l,u;switch(e){case tt.oids["pbeWithSHAAnd3-KeyTripleDES-CBC"]:c=24,l=8,u=Ae.des.startDecrypting;break;case tt.oids["pbewithSHAAnd40BitRC2-CBC"]:c=5,l=8,u=function(S,x){var I=Ae.rc2.createDecryptionCipher(S,40);return I.start(x,null),I};break;default:var s=new Error("Cannot read PKCS #12 PBE data block. Unsupported OID.");throw s.oid=e,s}var f=LL(n.prfOid),d=tt.pbe.generatePkcs12Key(r,o,1,a,c,f);f.start();var p=tt.pbe.generatePkcs12Key(r,o,2,a,l,f);return u(d,p)};tt.pbe.opensslDeriveBytes=function(e,t,r,n){if(typeof n>"u"||n===null){if(!("md5"in Ae.md))throw new Error('"md5" hash algorithm unavailable.');n=Ae.md.md5.create();}t===null&&(t="");for(var i=[NL(n,e+t)],s=16,o=1;s<r;++o,s+=16)i.push(NL(n,i[o-1]+e+t));return i.join("").substr(0,r)};function NL(e,t){return e.start().update(t).digest().getBytes()}function LL(e){var t;if(!e)t="hmacWithSHA1";else if(t=tt.oids[Z.derToOid(e)],!t){var r=new Error("Unsupported PRF OID.");throw r.oid=e,r.supported=["hmacWithSHA1","hmacWithSHA224","hmacWithSHA256","hmacWithSHA384","hmacWithSHA512"],r}return OL(t)}function OL(e){var t=Ae.md;switch(e){case"hmacWithSHA224":t=Ae.md.sha512;case"hmacWithSHA1":case"hmacWithSHA256":case"hmacWithSHA384":case"hmacWithSHA512":e=e.substr(8).toLowerCase();break;default:var r=new Error("Unsupported PRF algorithm.");throw r.algorithm=e,r.supported=["hmacWithSHA1","hmacWithSHA224","hmacWithSHA256","hmacWithSHA384","hmacWithSHA512"],r}if(!t||!(e in t))throw new Error("Unknown hash algorithm: "+e);return t[e].create()}function Lte(e,t,r,n){var i=Z.create(Z.Class.UNIVERSAL,Z.Type.SEQUENCE,!0,[Z.create(Z.Class.UNIVERSAL,Z.Type.OCTETSTRING,!1,e),Z.create(Z.Class.UNIVERSAL,Z.Type.INTEGER,!1,t.getBytes())]);return n!=="hmacWithSHA1"&&i.value.push(Z.create(Z.Class.UNIVERSAL,Z.Type.INTEGER,!1,Ae.util.hexToBytes(r.toString(16))),Z.create(Z.Class.UNIVERSAL,Z.Type.SEQUENCE,!0,[Z.create(Z.Class.UNIVERSAL,Z.Type.OID,!1,Z.oidToDer(tt.oids[n]).getBytes()),Z.create(Z.Class.UNIVERSAL,Z.Type.NULL,!1,"")])),i}});var kv=A((Uhe,ML)=>{var Aa=rt();ni();vt();var we=Aa.asn1,Ra=ML.exports=Aa.pkcs7asn1=Aa.pkcs7asn1||{};Aa.pkcs7=Aa.pkcs7||{};Aa.pkcs7.asn1=Ra;var qL={name:"ContentInfo",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"ContentInfo.ContentType",tagClass:we.Class.UNIVERSAL,type:we.Type.OID,constructed:!1,capture:"contentType"},{name:"ContentInfo.content",tagClass:we.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,captureAsn1:"content"}]};Ra.contentInfoValidator=qL;var FL={name:"EncryptedContentInfo",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedContentInfo.contentType",tagClass:we.Class.UNIVERSAL,type:we.Type.OID,constructed:!1,capture:"contentType"},{name:"EncryptedContentInfo.contentEncryptionAlgorithm",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedContentInfo.contentEncryptionAlgorithm.algorithm",tagClass:we.Class.UNIVERSAL,type:we.Type.OID,constructed:!1,capture:"encAlgorithm"},{name:"EncryptedContentInfo.contentEncryptionAlgorithm.parameter",tagClass:we.Class.UNIVERSAL,captureAsn1:"encParameter"}]},{name:"EncryptedContentInfo.encryptedContent",tagClass:we.Class.CONTEXT_SPECIFIC,type:0,capture:"encryptedContent",captureAsn1:"encryptedContentAsn1"}]};Ra.envelopedDataValidator={name:"EnvelopedData",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"EnvelopedData.Version",tagClass:we.Class.UNIVERSAL,type:we.Type.INTEGER,constructed:!1,capture:"version"},{name:"EnvelopedData.RecipientInfos",tagClass:we.Class.UNIVERSAL,type:we.Type.SET,constructed:!0,captureAsn1:"recipientInfos"}].concat(FL)};Ra.encryptedDataValidator={name:"EncryptedData",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedData.Version",tagClass:we.Class.UNIVERSAL,type:we.Type.INTEGER,constructed:!1,capture:"version"}].concat(FL)};var Ote={name:"SignerInfo",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"SignerInfo.version",tagClass:we.Class.UNIVERSAL,type:we.Type.INTEGER,constructed:!1},{name:"SignerInfo.issuerAndSerialNumber",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"SignerInfo.issuerAndSerialNumber.issuer",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,captureAsn1:"issuer"},{name:"SignerInfo.issuerAndSerialNumber.serialNumber",tagClass:we.Class.UNIVERSAL,type:we.Type.INTEGER,constructed:!1,capture:"serial"}]},{name:"SignerInfo.digestAlgorithm",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"SignerInfo.digestAlgorithm.algorithm",tagClass:we.Class.UNIVERSAL,type:we.Type.OID,constructed:!1,capture:"digestAlgorithm"},{name:"SignerInfo.digestAlgorithm.parameter",tagClass:we.Class.UNIVERSAL,constructed:!1,captureAsn1:"digestParameter",optional:!0}]},{name:"SignerInfo.authenticatedAttributes",tagClass:we.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,capture:"authenticatedAttributes"},{name:"SignerInfo.digestEncryptionAlgorithm",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,capture:"signatureAlgorithm"},{name:"SignerInfo.encryptedDigest",tagClass:we.Class.UNIVERSAL,type:we.Type.OCTETSTRING,constructed:!1,capture:"signature"},{name:"SignerInfo.unauthenticatedAttributes",tagClass:we.Class.CONTEXT_SPECIFIC,type:1,constructed:!0,optional:!0,capture:"unauthenticatedAttributes"}]};Ra.signedDataValidator={name:"SignedData",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"SignedData.Version",tagClass:we.Class.UNIVERSAL,type:we.Type.INTEGER,constructed:!1,capture:"version"},{name:"SignedData.DigestAlgorithms",tagClass:we.Class.UNIVERSAL,type:we.Type.SET,constructed:!0,captureAsn1:"digestAlgorithms"},qL,{name:"SignedData.Certificates",tagClass:we.Class.CONTEXT_SPECIFIC,type:0,optional:!0,captureAsn1:"certificates"},{name:"SignedData.CertificateRevocationLists",tagClass:we.Class.CONTEXT_SPECIFIC,type:1,optional:!0,captureAsn1:"crls"},{name:"SignedData.SignerInfos",tagClass:we.Class.UNIVERSAL,type:we.Type.SET,capture:"signerInfos",optional:!0,value:[Ote]}]};Ra.recipientInfoValidator={name:"RecipientInfo",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"RecipientInfo.version",tagClass:we.Class.UNIVERSAL,type:we.Type.INTEGER,constructed:!1,capture:"version"},{name:"RecipientInfo.issuerAndSerial",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"RecipientInfo.issuerAndSerial.issuer",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,captureAsn1:"issuer"},{name:"RecipientInfo.issuerAndSerial.serialNumber",tagClass:we.Class.UNIVERSAL,type:we.Type.INTEGER,constructed:!1,capture:"serial"}]},{name:"RecipientInfo.keyEncryptionAlgorithm",tagClass:we.Class.UNIVERSAL,type:we.Type.SEQUENCE,constructed:!0,value:[{name:"RecipientInfo.keyEncryptionAlgorithm.algorithm",tagClass:we.Class.UNIVERSAL,type:we.Type.OID,constructed:!1,capture:"encAlgorithm"},{name:"RecipientInfo.keyEncryptionAlgorithm.parameter",tagClass:we.Class.UNIVERSAL,constructed:!1,captureAsn1:"encParameter",optional:!0}]},{name:"RecipientInfo.encryptedKey",tagClass:we.Class.UNIVERSAL,type:we.Type.OCTETSTRING,constructed:!1,capture:"encKey"}]};});var Nv=A(($he,UL)=>{var vo=rt();vt();vo.mgf=vo.mgf||{};var Bte=UL.exports=vo.mgf.mgf1=vo.mgf1=vo.mgf1||{};Bte.create=function(e){var t={generate:function(r,n){for(var i=new vo.util.ByteBuffer,s=Math.ceil(n/e.digestLength),o=0;o<s;o++){var a=new vo.util.ByteBuffer;a.putInt32(o),e.start(),e.update(r+a.getBytes()),i.putBuffer(e.digest());}return i.truncate(i.length()-n),i.getBytes()}};return t};});var jL=A((jhe,$L)=>{var Ph=rt();Nv();$L.exports=Ph.mgf=Ph.mgf||{};Ph.mgf.mgf1=Ph.mgf1;});var kh=A((Vhe,VL)=>{var So=rt();Ln();vt();var qte=VL.exports=So.pss=So.pss||{};qte.create=function(e){arguments.length===3&&(e={md:arguments[0],mgf:arguments[1],saltLength:arguments[2]});var t=e.md,r=e.mgf,n=t.digestLength,i=e.salt||null;typeof i=="string"&&(i=So.util.createBuffer(i));var s;if("saltLength"in e)s=e.saltLength;else if(i!==null)s=i.length();else throw new Error("Salt length not specified or specific salt not given.");if(i!==null&&i.length()!==s)throw new Error("Given salt length does not match length of given salt.");var o=e.prng||So.random,a={};return a.encode=function(c,l){var u,f=l-1,d=Math.ceil(f/8),p=c.digest().getBytes();if(d<n+s+2)throw new Error("Message is too long to encrypt.");var m;i===null?m=o.getBytesSync(s):m=i.bytes();var S=new So.util.ByteBuffer;S.fillWithByte(0,8),S.putBytes(p),S.putBytes(m),t.start(),t.update(S.getBytes());var x=t.digest().getBytes(),I=new So.util.ByteBuffer;I.fillWithByte(0,d-s-n-2),I.putByte(1),I.putBytes(m);var v=I.getBytes(),b=d-n-1,D=r.generate(x,b),L="";for(u=0;u<b;u++)L+=String.fromCharCode(v.charCodeAt(u)^D.charCodeAt(u));var j=65280>>8*d-f&255;return L=String.fromCharCode(L.charCodeAt(0)&~j)+L.substr(1),L+x+"\xBC"},a.verify=function(c,l,u){var f,d=u-1,p=Math.ceil(d/8);if(l=l.substr(-p),p<n+s+2)throw new Error("Inconsistent parameters to PSS signature verification.");if(l.charCodeAt(p-1)!==188)throw new Error("Encoded message does not end in 0xBC.");var m=p-n-1,S=l.substr(0,m),x=l.substr(m,n),I=65280>>8*p-d&255;if(S.charCodeAt(0)&I)throw new Error("Bits beyond keysize not zero as expected.");var v=r.generate(x,m),b="";for(f=0;f<m;f++)b+=String.fromCharCode(S.charCodeAt(f)^v.charCodeAt(f));b=String.fromCharCode(b.charCodeAt(0)&~I)+b.substr(1);var D=p-n-s-2;for(f=0;f<D;f++)if(b.charCodeAt(f)!==0)throw new Error("Leftmost octets not zero as expected");if(b.charCodeAt(D)!==1)throw new Error("Inconsistent PSS signature, 0x01 marker not found");var L=b.substr(-s),j=new So.util.ByteBuffer;j.fillWithByte(0,8),j.putBytes(c),j.putBytes(L),t.start(),t.update(j.getBytes());var J=t.digest().getBytes();return x===J},a};});var Oh=A((Hhe,GL)=>{var Ue=rt();Ss();ni();mc();Si();jL();bs();po();kh();Sc();vt();var w=Ue.asn1,Se=GL.exports=Ue.pki=Ue.pki||{},mt=Se.oids,Jt={};Jt.CN=mt.commonName;Jt.commonName="CN";Jt.C=mt.countryName;Jt.countryName="C";Jt.L=mt.localityName;Jt.localityName="L";Jt.ST=mt.stateOrProvinceName;Jt.stateOrProvinceName="ST";Jt.O=mt.organizationName;Jt.organizationName="O";Jt.OU=mt.organizationalUnitName;Jt.organizationalUnitName="OU";Jt.E=mt.emailAddress;Jt.emailAddress="E";var WL=Ue.pki.rsa.publicKeyValidator,Fte={name:"Certificate",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.TBSCertificate",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,captureAsn1:"tbsCertificate",value:[{name:"Certificate.TBSCertificate.version",tagClass:w.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,value:[{name:"Certificate.TBSCertificate.version.integer",tagClass:w.Class.UNIVERSAL,type:w.Type.INTEGER,constructed:!1,capture:"certVersion"}]},{name:"Certificate.TBSCertificate.serialNumber",tagClass:w.Class.UNIVERSAL,type:w.Type.INTEGER,constructed:!1,capture:"certSerialNumber"},{name:"Certificate.TBSCertificate.signature",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.TBSCertificate.signature.algorithm",tagClass:w.Class.UNIVERSAL,type:w.Type.OID,constructed:!1,capture:"certinfoSignatureOid"},{name:"Certificate.TBSCertificate.signature.parameters",tagClass:w.Class.UNIVERSAL,optional:!0,captureAsn1:"certinfoSignatureParams"}]},{name:"Certificate.TBSCertificate.issuer",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,captureAsn1:"certIssuer"},{name:"Certificate.TBSCertificate.validity",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.TBSCertificate.validity.notBefore (utc)",tagClass:w.Class.UNIVERSAL,type:w.Type.UTCTIME,constructed:!1,optional:!0,capture:"certValidity1UTCTime"},{name:"Certificate.TBSCertificate.validity.notBefore (generalized)",tagClass:w.Class.UNIVERSAL,type:w.Type.GENERALIZEDTIME,constructed:!1,optional:!0,capture:"certValidity2GeneralizedTime"},{name:"Certificate.TBSCertificate.validity.notAfter (utc)",tagClass:w.Class.UNIVERSAL,type:w.Type.UTCTIME,constructed:!1,optional:!0,capture:"certValidity3UTCTime"},{name:"Certificate.TBSCertificate.validity.notAfter (generalized)",tagClass:w.Class.UNIVERSAL,type:w.Type.GENERALIZEDTIME,constructed:!1,optional:!0,capture:"certValidity4GeneralizedTime"}]},{name:"Certificate.TBSCertificate.subject",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,captureAsn1:"certSubject"},WL,{name:"Certificate.TBSCertificate.issuerUniqueID",tagClass:w.Class.CONTEXT_SPECIFIC,type:1,constructed:!0,optional:!0,value:[{name:"Certificate.TBSCertificate.issuerUniqueID.id",tagClass:w.Class.UNIVERSAL,type:w.Type.BITSTRING,constructed:!1,captureBitStringValue:"certIssuerUniqueId"}]},{name:"Certificate.TBSCertificate.subjectUniqueID",tagClass:w.Class.CONTEXT_SPECIFIC,type:2,constructed:!0,optional:!0,value:[{name:"Certificate.TBSCertificate.subjectUniqueID.id",tagClass:w.Class.UNIVERSAL,type:w.Type.BITSTRING,constructed:!1,captureBitStringValue:"certSubjectUniqueId"}]},{name:"Certificate.TBSCertificate.extensions",tagClass:w.Class.CONTEXT_SPECIFIC,type:3,constructed:!0,captureAsn1:"certExtensions",optional:!0}]},{name:"Certificate.signatureAlgorithm",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.signatureAlgorithm.algorithm",tagClass:w.Class.UNIVERSAL,type:w.Type.OID,constructed:!1,capture:"certSignatureOid"},{name:"Certificate.TBSCertificate.signature.parameters",tagClass:w.Class.UNIVERSAL,optional:!0,captureAsn1:"certSignatureParams"}]},{name:"Certificate.signatureValue",tagClass:w.Class.UNIVERSAL,type:w.Type.BITSTRING,constructed:!1,captureBitStringValue:"certSignature"}]},Mte={name:"rsapss",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,value:[{name:"rsapss.hashAlgorithm",tagClass:w.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,value:[{name:"rsapss.hashAlgorithm.AlgorithmIdentifier",tagClass:w.Class.UNIVERSAL,type:w.Class.SEQUENCE,constructed:!0,optional:!0,value:[{name:"rsapss.hashAlgorithm.AlgorithmIdentifier.algorithm",tagClass:w.Class.UNIVERSAL,type:w.Type.OID,constructed:!1,capture:"hashOid"}]}]},{name:"rsapss.maskGenAlgorithm",tagClass:w.Class.CONTEXT_SPECIFIC,type:1,constructed:!0,value:[{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier",tagClass:w.Class.UNIVERSAL,type:w.Class.SEQUENCE,constructed:!0,optional:!0,value:[{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier.algorithm",tagClass:w.Class.UNIVERSAL,type:w.Type.OID,constructed:!1,capture:"maskGenOid"},{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier.params",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,value:[{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier.params.algorithm",tagClass:w.Class.UNIVERSAL,type:w.Type.OID,constructed:!1,capture:"maskGenHashOid"}]}]}]},{name:"rsapss.saltLength",tagClass:w.Class.CONTEXT_SPECIFIC,type:2,optional:!0,value:[{name:"rsapss.saltLength.saltLength",tagClass:w.Class.UNIVERSAL,type:w.Class.INTEGER,constructed:!1,capture:"saltLength"}]},{name:"rsapss.trailerField",tagClass:w.Class.CONTEXT_SPECIFIC,type:3,optional:!0,value:[{name:"rsapss.trailer.trailer",tagClass:w.Class.UNIVERSAL,type:w.Class.INTEGER,constructed:!1,capture:"trailer"}]}]},Ute={name:"CertificationRequestInfo",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,captureAsn1:"certificationRequestInfo",value:[{name:"CertificationRequestInfo.integer",tagClass:w.Class.UNIVERSAL,type:w.Type.INTEGER,constructed:!1,capture:"certificationRequestInfoVersion"},{name:"CertificationRequestInfo.subject",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,captureAsn1:"certificationRequestInfoSubject"},WL,{name:"CertificationRequestInfo.attributes",tagClass:w.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,capture:"certificationRequestInfoAttributes",value:[{name:"CertificationRequestInfo.attributes",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,value:[{name:"CertificationRequestInfo.attributes.type",tagClass:w.Class.UNIVERSAL,type:w.Type.OID,constructed:!1},{name:"CertificationRequestInfo.attributes.value",tagClass:w.Class.UNIVERSAL,type:w.Type.SET,constructed:!0}]}]}]},$te={name:"CertificationRequest",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,captureAsn1:"csr",value:[Ute,{name:"CertificationRequest.signatureAlgorithm",tagClass:w.Class.UNIVERSAL,type:w.Type.SEQUENCE,constructed:!0,value:[{name:"CertificationRequest.signatureAlgorithm.algorithm",tagClass:w.Class.UNIVERSAL,type:w.Type.OID,constructed:!1,capture:"csrSignatureOid"},{name:"CertificationRequest.signatureAlgorithm.parameters",tagClass:w.Class.UNIVERSAL,optional:!0,captureAsn1:"csrSignatureParams"}]},{name:"CertificationRequest.signature",tagClass:w.Class.UNIVERSAL,type:w.Type.BITSTRING,constructed:!1,captureBitStringValue:"csrSignature"}]};Se.RDNAttributesAsArray=function(e,t){for(var r=[],n,i,s,o=0;o<e.value.length;++o){n=e.value[o];for(var a=0;a<n.value.length;++a)s={},i=n.value[a],s.type=w.derToOid(i.value[0].value),s.value=i.value[1].value,s.valueTagClass=i.value[1].type,s.type in mt&&(s.name=mt[s.type],s.name in Jt&&(s.shortName=Jt[s.name])),t&&(t.update(s.type),t.update(s.value)),r.push(s);}return r};Se.CRIAttributesAsArray=function(e){for(var t=[],r=0;r<e.length;++r)for(var n=e[r],i=w.derToOid(n.value[0].value),s=n.value[1].value,o=0;o<s.length;++o){var a={};if(a.type=i,a.value=s[o].value,a.valueTagClass=s[o].type,a.type in mt&&(a.name=mt[a.type],a.name in Jt&&(a.shortName=Jt[a.name])),a.type===mt.extensionRequest){a.extensions=[];for(var c=0;c<a.value.length;++c)a.extensions.push(Se.certificateExtensionFromAsn1(a.value[c]));}t.push(a);}return t};function xs(e,t){typeof t=="string"&&(t={shortName:t});for(var r=null,n,i=0;r===null&&i<e.attributes.length;++i)n=e.attributes[i],(t.type&&t.type===n.type||t.name&&t.name===n.name||t.shortName&&t.shortName===n.shortName)&&(r=n);return r}var Nh=function(e,t,r){var n={};if(e!==mt["RSASSA-PSS"])return n;r&&(n={hash:{algorithmOid:mt.sha1},mgf:{algorithmOid:mt.mgf1,hash:{algorithmOid:mt.sha1}},saltLength:20});var i={},s=[];if(!w.validate(t,Mte,i,s)){var o=new Error("Cannot read RSASSA-PSS parameter block.");throw o.errors=s,o}return i.hashOid!==void 0&&(n.hash=n.hash||{},n.hash.algorithmOid=w.derToOid(i.hashOid)),i.maskGenOid!==void 0&&(n.mgf=n.mgf||{},n.mgf.algorithmOid=w.derToOid(i.maskGenOid),n.mgf.hash=n.mgf.hash||{},n.mgf.hash.algorithmOid=w.derToOid(i.maskGenHashOid)),i.saltLength!==void 0&&(n.saltLength=i.saltLength.charCodeAt(0)),n},Lh=function(e){switch(mt[e.signatureOid]){case"sha1WithRSAEncryption":case"sha1WithRSASignature":return Ue.md.sha1.create();case"md5WithRSAEncryption":return Ue.md.md5.create();case"sha256WithRSAEncryption":return Ue.md.sha256.create();case"sha384WithRSAEncryption":return Ue.md.sha384.create();case"sha512WithRSAEncryption":return Ue.md.sha512.create();case"RSASSA-PSS":return Ue.md.sha256.create();default:var t=new Error("Could not compute "+e.type+" digest. Unknown signature OID.");throw t.signatureOid=e.signatureOid,t}},KL=function(e){var t=e.certificate,r;switch(t.signatureOid){case mt.sha1WithRSAEncryption:case mt.sha1WithRSASignature:break;case mt["RSASSA-PSS"]:var n,i;if(n=mt[t.signatureParameters.mgf.hash.algorithmOid],n===void 0||Ue.md[n]===void 0){var s=new Error("Unsupported MGF hash function.");throw s.oid=t.signatureParameters.mgf.hash.algorithmOid,s.name=n,s}if(i=mt[t.signatureParameters.mgf.algorithmOid],i===void 0||Ue.mgf[i]===void 0){var s=new Error("Unsupported MGF function.");throw s.oid=t.signatureParameters.mgf.algorithmOid,s.name=i,s}if(i=Ue.mgf[i].create(Ue.md[n].create()),n=mt[t.signatureParameters.hash.algorithmOid],n===void 0||Ue.md[n]===void 0){var s=new Error("Unsupported RSASSA-PSS hash function.");throw s.oid=t.signatureParameters.hash.algorithmOid,s.name=n,s}r=Ue.pss.create(Ue.md[n].create(),i,t.signatureParameters.saltLength);break}return t.publicKey.verify(e.md.digest().getBytes(),e.signature,r)};Se.certificateFromPem=function(e,t,r){var n=Ue.pem.decode(e)[0];if(n.type!=="CERTIFICATE"&&n.type!=="X509 CERTIFICATE"&&n.type!=="TRUSTED CERTIFICATE"){var i=new Error('Could not convert certificate from PEM; PEM header type is not "CERTIFICATE", "X509 CERTIFICATE", or "TRUSTED CERTIFICATE".');throw i.headerType=n.type,i}if(n.procType&&n.procType.type==="ENCRYPTED")throw new Error("Could not convert certificate from PEM; PEM is encrypted.");var s=w.fromDer(n.body,r);return Se.certificateFromAsn1(s,t)};Se.certificateToPem=function(e,t){var r={type:"CERTIFICATE",body:w.toDer(Se.certificateToAsn1(e)).getBytes()};return Ue.pem.encode(r,{maxline:t})};Se.publicKeyFromPem=function(e){var t=Ue.pem.decode(e)[0];if(t.type!=="PUBLIC KEY"&&t.type!=="RSA PUBLIC KEY"){var r=new Error('Could not convert public key from PEM; PEM header type is not "PUBLIC KEY" or "RSA PUBLIC KEY".');throw r.headerType=t.type,r}if(t.procType&&t.procType.type==="ENCRYPTED")throw new Error("Could not convert public key from PEM; PEM is encrypted.");var n=w.fromDer(t.body);return Se.publicKeyFromAsn1(n)};Se.publicKeyToPem=function(e,t){var r={type:"PUBLIC KEY",body:w.toDer(Se.publicKeyToAsn1(e)).getBytes()};return Ue.pem.encode(r,{maxline:t})};Se.publicKeyToRSAPublicKeyPem=function(e,t){var r={type:"RSA PUBLIC KEY",body:w.toDer(Se.publicKeyToRSAPublicKey(e)).getBytes()};return Ue.pem.encode(r,{maxline:t})};Se.getPublicKeyFingerprint=function(e,t){t=t||{};var r=t.md||Ue.md.sha1.create(),n=t.type||"RSAPublicKey",i;switch(n){case"RSAPublicKey":i=w.toDer(Se.publicKeyToRSAPublicKey(e)).getBytes();break;case"SubjectPublicKeyInfo":i=w.toDer(Se.publicKeyToAsn1(e)).getBytes();break;default:throw new Error('Unknown fingerprint type "'+t.type+'".')}r.start(),r.update(i);var s=r.digest();if(t.encoding==="hex"){var o=s.toHex();return t.delimiter?o.match(/.{2}/g).join(t.delimiter):o}else {if(t.encoding==="binary")return s.getBytes();if(t.encoding)throw new Error('Unknown encoding "'+t.encoding+'".')}return s};Se.certificationRequestFromPem=function(e,t,r){var n=Ue.pem.decode(e)[0];if(n.type!=="CERTIFICATE REQUEST"){var i=new Error('Could not convert certification request from PEM; PEM header type is not "CERTIFICATE REQUEST".');throw i.headerType=n.type,i}if(n.procType&&n.procType.type==="ENCRYPTED")throw new Error("Could not convert certification request from PEM; PEM is encrypted.");var s=w.fromDer(n.body,r);return Se.certificationRequestFromAsn1(s,t)};Se.certificationRequestToPem=function(e,t){var r={type:"CERTIFICATE REQUEST",body:w.toDer(Se.certificationRequestToAsn1(e)).getBytes()};return Ue.pem.encode(r,{maxline:t})};Se.createCertificate=function(){var e={};return e.version=2,e.serialNumber="00",e.signatureOid=null,e.signature=null,e.siginfo={},e.siginfo.algorithmOid=null,e.validity={},e.validity.notBefore=new Date,e.validity.notAfter=new Date,e.issuer={},e.issuer.getField=function(t){return xs(e.issuer,t)},e.issuer.addField=function(t){qn([t]),e.issuer.attributes.push(t);},e.issuer.attributes=[],e.issuer.hash=null,e.subject={},e.subject.getField=function(t){return xs(e.subject,t)},e.subject.addField=function(t){qn([t]),e.subject.attributes.push(t);},e.subject.attributes=[],e.subject.hash=null,e.extensions=[],e.publicKey=null,e.md=null,e.setSubject=function(t,r){qn(t),e.subject.attributes=t,delete e.subject.uniqueId,r&&(e.subject.uniqueId=r),e.subject.hash=null;},e.setIssuer=function(t,r){qn(t),e.issuer.attributes=t,delete e.issuer.uniqueId,r&&(e.issuer.uniqueId=r),e.issuer.hash=null;},e.setExtensions=function(t){for(var r=0;r<t.length;++r)zL(t[r],{cert:e});e.extensions=t;},e.getExtension=function(t){typeof t=="string"&&(t={name:t});for(var r=null,n,i=0;r===null&&i<e.extensions.length;++i)n=e.extensions[i],(t.id&&n.id===t.id||t.name&&n.name===t.name)&&(r=n);return r},e.sign=function(t,r){e.md=r||Ue.md.sha1.create();var n=mt[e.md.algorithm+"WithRSAEncryption"];if(!n){var i=new Error("Could not compute certificate digest. Unknown message digest algorithm OID.");throw i.algorithm=e.md.algorithm,i}e.signatureOid=e.siginfo.algorithmOid=n,e.tbsCertificate=Se.getTBSCertificate(e);var s=w.toDer(e.tbsCertificate);e.md.update(s.getBytes()),e.signature=t.sign(e.md);},e.verify=function(t){var r=!1;if(!e.issued(t)){var n=t.issuer,i=e.subject,s=new Error("The parent certificate did not issue the given child certificate; the child certificate's issuer does not match the parent's subject.");throw s.expectedIssuer=i.attributes,s.actualIssuer=n.attributes,s}var o=t.md;if(o===null){o=Lh({signatureOid:t.signatureOid,type:"certificate"});var a=t.tbsCertificate||Se.getTBSCertificate(t),c=w.toDer(a);o.update(c.getBytes());}return o!==null&&(r=KL({certificate:e,md:o,signature:t.signature})),r},e.isIssuer=function(t){var r=!1,n=e.issuer,i=t.subject;if(n.hash&&i.hash)r=n.hash===i.hash;else if(n.attributes.length===i.attributes.length){r=!0;for(var s,o,a=0;r&&a<n.attributes.length;++a)s=n.attributes[a],o=i.attributes[a],(s.type!==o.type||s.value!==o.value)&&(r=!1);}return r},e.issued=function(t){return t.isIssuer(e)},e.generateSubjectKeyIdentifier=function(){return Se.getPublicKeyFingerprint(e.publicKey,{type:"RSAPublicKey"})},e.verifySubjectKeyIdentifier=function(){for(var t=mt.subjectKeyIdentifier,r=0;r<e.extensions.length;++r){var n=e.extensions[r];if(n.id===t){var i=e.generateSubjectKeyIdentifier().getBytes();return Ue.util.hexToBytes(n.subjectKeyIdentifier)===i}}return !1},e};Se.certificateFromAsn1=function(e,t){var r={},n=[];if(!w.validate(e,Fte,r,n)){var i=new Error("Cannot read X.509 certificate. ASN.1 object is not an X509v3 Certificate.");throw i.errors=n,i}var s=w.derToOid(r.publicKeyOid);if(s!==Se.oids.rsaEncryption)throw new Error("Cannot read public key. OID is not RSA.");var o=Se.createCertificate();o.version=r.certVersion?r.certVersion.charCodeAt(0):0;var a=Ue.util.createBuffer(r.certSerialNumber);o.serialNumber=a.toHex(),o.signatureOid=Ue.asn1.derToOid(r.certSignatureOid),o.signatureParameters=Nh(o.signatureOid,r.certSignatureParams,!0),o.siginfo.algorithmOid=Ue.asn1.derToOid(r.certinfoSignatureOid),o.siginfo.parameters=Nh(o.siginfo.algorithmOid,r.certinfoSignatureParams,!1),o.signature=r.certSignature;var c=[];if(r.certValidity1UTCTime!==void 0&&c.push(w.utcTimeToDate(r.certValidity1UTCTime)),r.certValidity2GeneralizedTime!==void 0&&c.push(w.generalizedTimeToDate(r.certValidity2GeneralizedTime)),r.certValidity3UTCTime!==void 0&&c.push(w.utcTimeToDate(r.certValidity3UTCTime)),r.certValidity4GeneralizedTime!==void 0&&c.push(w.generalizedTimeToDate(r.certValidity4GeneralizedTime)),c.length>2)throw new Error("Cannot read notBefore/notAfter validity times; more than two times were provided in the certificate.");if(c.length<2)throw new Error("Cannot read notBefore/notAfter validity times; they were not provided as either UTCTime or GeneralizedTime.");if(o.validity.notBefore=c[0],o.validity.notAfter=c[1],o.tbsCertificate=r.tbsCertificate,t){o.md=Lh({signatureOid:o.signatureOid,type:"certificate"});var l=w.toDer(o.tbsCertificate);o.md.update(l.getBytes());}var u=Ue.md.sha1.create(),f=w.toDer(r.certIssuer);u.update(f.getBytes()),o.issuer.getField=function(m){return xs(o.issuer,m)},o.issuer.addField=function(m){qn([m]),o.issuer.attributes.push(m);},o.issuer.attributes=Se.RDNAttributesAsArray(r.certIssuer),r.certIssuerUniqueId&&(o.issuer.uniqueId=r.certIssuerUniqueId),o.issuer.hash=u.digest().toHex();var d=Ue.md.sha1.create(),p=w.toDer(r.certSubject);return d.update(p.getBytes()),o.subject.getField=function(m){return xs(o.subject,m)},o.subject.addField=function(m){qn([m]),o.subject.attributes.push(m);},o.subject.attributes=Se.RDNAttributesAsArray(r.certSubject),r.certSubjectUniqueId&&(o.subject.uniqueId=r.certSubjectUniqueId),o.subject.hash=d.digest().toHex(),r.certExtensions?o.extensions=Se.certificateExtensionsFromAsn1(r.certExtensions):o.extensions=[],o.publicKey=Se.publicKeyFromAsn1(r.subjectPublicKeyInfo),o};Se.certificateExtensionsFromAsn1=function(e){for(var t=[],r=0;r<e.value.length;++r)for(var n=e.value[r],i=0;i<n.value.length;++i)t.push(Se.certificateExtensionFromAsn1(n.value[i]));return t};Se.certificateExtensionFromAsn1=function(e){var t={};if(t.id=w.derToOid(e.value[0].value),t.critical=!1,e.value[1].type===w.Type.BOOLEAN?(t.critical=e.value[1].value.charCodeAt(0)!==0,t.value=e.value[2].value):t.value=e.value[1].value,t.id in mt){if(t.name=mt[t.id],t.name==="keyUsage"){var r=w.fromDer(t.value),n=0,i=0;r.value.length>1&&(n=r.value.charCodeAt(1),i=r.value.length>2?r.value.charCodeAt(2):0),t.digitalSignature=(n&128)===128,t.nonRepudiation=(n&64)===64,t.keyEncipherment=(n&32)===32,t.dataEncipherment=(n&16)===16,t.keyAgreement=(n&8)===8,t.keyCertSign=(n&4)===4,t.cRLSign=(n&2)===2,t.encipherOnly=(n&1)===1,t.decipherOnly=(i&128)===128;}else if(t.name==="basicConstraints"){var r=w.fromDer(t.value);r.value.length>0&&r.value[0].type===w.Type.BOOLEAN?t.cA=r.value[0].value.charCodeAt(0)!==0:t.cA=!1;var s=null;r.value.length>0&&r.value[0].type===w.Type.INTEGER?s=r.value[0].value:r.value.length>1&&(s=r.value[1].value),s!==null&&(t.pathLenConstraint=w.derToInteger(s));}else if(t.name==="extKeyUsage")for(var r=w.fromDer(t.value),o=0;o<r.value.length;++o){var a=w.derToOid(r.value[o].value);a in mt?t[mt[a]]=!0:t[a]=!0;}else if(t.name==="nsCertType"){var r=w.fromDer(t.value),n=0;r.value.length>1&&(n=r.value.charCodeAt(1)),t.client=(n&128)===128,t.server=(n&64)===64,t.email=(n&32)===32,t.objsign=(n&16)===16,t.reserved=(n&8)===8,t.sslCA=(n&4)===4,t.emailCA=(n&2)===2,t.objCA=(n&1)===1;}else if(t.name==="subjectAltName"||t.name==="issuerAltName"){t.altNames=[];for(var c,r=w.fromDer(t.value),l=0;l<r.value.length;++l){c=r.value[l];var u={type:c.type,value:c.value};switch(t.altNames.push(u),c.type){case 1:case 2:case 6:break;case 7:u.ip=Ue.util.bytesToIP(c.value);break;case 8:u.oid=w.derToOid(c.value);break;}}}else if(t.name==="subjectKeyIdentifier"){var r=w.fromDer(t.value);t.subjectKeyIdentifier=Ue.util.bytesToHex(r.value);}}return t};Se.certificationRequestFromAsn1=function(e,t){var r={},n=[];if(!w.validate(e,$te,r,n)){var i=new Error("Cannot read PKCS#10 certificate request. ASN.1 object is not a PKCS#10 CertificationRequest.");throw i.errors=n,i}var s=w.derToOid(r.publicKeyOid);if(s!==Se.oids.rsaEncryption)throw new Error("Cannot read public key. OID is not RSA.");var o=Se.createCertificationRequest();if(o.version=r.csrVersion?r.csrVersion.charCodeAt(0):0,o.signatureOid=Ue.asn1.derToOid(r.csrSignatureOid),o.signatureParameters=Nh(o.signatureOid,r.csrSignatureParams,!0),o.siginfo.algorithmOid=Ue.asn1.derToOid(r.csrSignatureOid),o.siginfo.parameters=Nh(o.siginfo.algorithmOid,r.csrSignatureParams,!1),o.signature=r.csrSignature,o.certificationRequestInfo=r.certificationRequestInfo,t){o.md=Lh({signatureOid:o.signatureOid,type:"certification request"});var a=w.toDer(o.certificationRequestInfo);o.md.update(a.getBytes());}var c=Ue.md.sha1.create();return o.subject.getField=function(l){return xs(o.subject,l)},o.subject.addField=function(l){qn([l]),o.subject.attributes.push(l);},o.subject.attributes=Se.RDNAttributesAsArray(r.certificationRequestInfoSubject,c),o.subject.hash=c.digest().toHex(),o.publicKey=Se.publicKeyFromAsn1(r.subjectPublicKeyInfo),o.getAttribute=function(l){return xs(o,l)},o.addAttribute=function(l){qn([l]),o.attributes.push(l);},o.attributes=Se.CRIAttributesAsArray(r.certificationRequestInfoAttributes||[]),o};Se.createCertificationRequest=function(){var e={};return e.version=0,e.signatureOid=null,e.signature=null,e.siginfo={},e.siginfo.algorithmOid=null,e.subject={},e.subject.getField=function(t){return xs(e.subject,t)},e.subject.addField=function(t){qn([t]),e.subject.attributes.push(t);},e.subject.attributes=[],e.subject.hash=null,e.publicKey=null,e.attributes=[],e.getAttribute=function(t){return xs(e,t)},e.addAttribute=function(t){qn([t]),e.attributes.push(t);},e.md=null,e.setSubject=function(t){qn(t),e.subject.attributes=t,e.subject.hash=null;},e.setAttributes=function(t){qn(t),e.attributes=t;},e.sign=function(t,r){e.md=r||Ue.md.sha1.create();var n=mt[e.md.algorithm+"WithRSAEncryption"];if(!n){var i=new Error("Could not compute certification request digest. Unknown message digest algorithm OID.");throw i.algorithm=e.md.algorithm,i}e.signatureOid=e.siginfo.algorithmOid=n,e.certificationRequestInfo=Se.getCertificationRequestInfo(e);var s=w.toDer(e.certificationRequestInfo);e.md.update(s.getBytes()),e.signature=t.sign(e.md);},e.verify=function(){var t=!1,r=e.md;if(r===null){r=Lh({signatureOid:e.signatureOid,type:"certification request"});var n=e.certificationRequestInfo||Se.getCertificationRequestInfo(e),i=w.toDer(n);r.update(i.getBytes());}return r!==null&&(t=KL({certificate:e,md:r,signature:e.signature})),t},e};function Ia(e){for(var t=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[]),r,n,i=e.attributes,s=0;s<i.length;++s){r=i[s];var o=r.value,a=w.Type.PRINTABLESTRING;"valueTagClass"in r&&(a=r.valueTagClass,a===w.Type.UTF8&&(o=Ue.util.encodeUtf8(o))),n=w.create(w.Class.UNIVERSAL,w.Type.SET,!0,[w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[w.create(w.Class.UNIVERSAL,w.Type.OID,!1,w.oidToDer(r.type).getBytes()),w.create(w.Class.UNIVERSAL,a,!1,o)])]),t.value.push(n);}return t}function qn(e){for(var t,r=0;r<e.length;++r){if(t=e[r],typeof t.name>"u"&&(t.type&&t.type in Se.oids?t.name=Se.oids[t.type]:t.shortName&&t.shortName in Jt&&(t.name=Se.oids[Jt[t.shortName]])),typeof t.type>"u")if(t.name&&t.name in Se.oids)t.type=Se.oids[t.name];else {var n=new Error("Attribute type not specified.");throw n.attribute=t,n}if(typeof t.shortName>"u"&&t.name&&t.name in Jt&&(t.shortName=Jt[t.name]),t.type===mt.extensionRequest&&(t.valueConstructed=!0,t.valueTagClass=w.Type.SEQUENCE,!t.value&&t.extensions)){t.value=[];for(var i=0;i<t.extensions.length;++i)t.value.push(Se.certificateExtensionToAsn1(zL(t.extensions[i])));}if(typeof t.value>"u"){var n=new Error("Attribute value not specified.");throw n.attribute=t,n}}}function zL(e,t){if(t=t||{},typeof e.name>"u"&&e.id&&e.id in Se.oids&&(e.name=Se.oids[e.id]),typeof e.id>"u")if(e.name&&e.name in Se.oids)e.id=Se.oids[e.name];else {var r=new Error("Extension ID not specified.");throw r.extension=e,r}if(typeof e.value<"u")return e;if(e.name==="keyUsage"){var n=0,i=0,s=0;e.digitalSignature&&(i|=128,n=7),e.nonRepudiation&&(i|=64,n=6),e.keyEncipherment&&(i|=32,n=5),e.dataEncipherment&&(i|=16,n=4),e.keyAgreement&&(i|=8,n=3),e.keyCertSign&&(i|=4,n=2),e.cRLSign&&(i|=2,n=1),e.encipherOnly&&(i|=1,n=0),e.decipherOnly&&(s|=128,n=7);var o=String.fromCharCode(n);s!==0?o+=String.fromCharCode(i)+String.fromCharCode(s):i!==0&&(o+=String.fromCharCode(i)),e.value=w.create(w.Class.UNIVERSAL,w.Type.BITSTRING,!1,o);}else if(e.name==="basicConstraints")e.value=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[]),e.cA&&e.value.value.push(w.create(w.Class.UNIVERSAL,w.Type.BOOLEAN,!1,"\xFF")),"pathLenConstraint"in e&&e.value.value.push(w.create(w.Class.UNIVERSAL,w.Type.INTEGER,!1,w.integerToDer(e.pathLenConstraint).getBytes()));else if(e.name==="extKeyUsage"){e.value=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[]);var a=e.value.value;for(var c in e)e[c]===!0&&(c in mt?a.push(w.create(w.Class.UNIVERSAL,w.Type.OID,!1,w.oidToDer(mt[c]).getBytes())):c.indexOf(".")!==-1&&a.push(w.create(w.Class.UNIVERSAL,w.Type.OID,!1,w.oidToDer(c).getBytes())));}else if(e.name==="nsCertType"){var n=0,i=0;e.client&&(i|=128,n=7),e.server&&(i|=64,n=6),e.email&&(i|=32,n=5),e.objsign&&(i|=16,n=4),e.reserved&&(i|=8,n=3),e.sslCA&&(i|=4,n=2),e.emailCA&&(i|=2,n=1),e.objCA&&(i|=1,n=0);var o=String.fromCharCode(n);i!==0&&(o+=String.fromCharCode(i)),e.value=w.create(w.Class.UNIVERSAL,w.Type.BITSTRING,!1,o);}else if(e.name==="subjectAltName"||e.name==="issuerAltName"){e.value=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[]);for(var l,u=0;u<e.altNames.length;++u){l=e.altNames[u];var o=l.value;if(l.type===7&&l.ip){if(o=Ue.util.bytesFromIP(l.ip),o===null){var r=new Error('Extension "ip" value is not a valid IPv4 or IPv6 address.');throw r.extension=e,r}}else l.type===8&&(l.oid?o=w.oidToDer(w.oidToDer(l.oid)):o=w.oidToDer(o));e.value.value.push(w.create(w.Class.CONTEXT_SPECIFIC,l.type,!1,o));}}else if(e.name==="nsComment"&&t.cert){if(!/^[\x00-\x7F]*$/.test(e.comment)||e.comment.length<1||e.comment.length>128)throw new Error('Invalid "nsComment" content.');e.value=w.create(w.Class.UNIVERSAL,w.Type.IA5STRING,!1,e.comment);}else if(e.name==="subjectKeyIdentifier"&&t.cert){var f=t.cert.generateSubjectKeyIdentifier();e.subjectKeyIdentifier=f.toHex(),e.value=w.create(w.Class.UNIVERSAL,w.Type.OCTETSTRING,!1,f.getBytes());}else if(e.name==="authorityKeyIdentifier"&&t.cert){e.value=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[]);var a=e.value.value;if(e.keyIdentifier){var d=e.keyIdentifier===!0?t.cert.generateSubjectKeyIdentifier().getBytes():e.keyIdentifier;a.push(w.create(w.Class.CONTEXT_SPECIFIC,0,!1,d));}if(e.authorityCertIssuer){var p=[w.create(w.Class.CONTEXT_SPECIFIC,4,!0,[Ia(e.authorityCertIssuer===!0?t.cert.issuer:e.authorityCertIssuer)])];a.push(w.create(w.Class.CONTEXT_SPECIFIC,1,!0,p));}if(e.serialNumber){var m=Ue.util.hexToBytes(e.serialNumber===!0?t.cert.serialNumber:e.serialNumber);a.push(w.create(w.Class.CONTEXT_SPECIFIC,2,!1,m));}}else if(e.name==="cRLDistributionPoints"){e.value=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[]);for(var a=e.value.value,S=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[]),x=w.create(w.Class.CONTEXT_SPECIFIC,0,!0,[]),l,u=0;u<e.altNames.length;++u){l=e.altNames[u];var o=l.value;if(l.type===7&&l.ip){if(o=Ue.util.bytesFromIP(l.ip),o===null){var r=new Error('Extension "ip" value is not a valid IPv4 or IPv6 address.');throw r.extension=e,r}}else l.type===8&&(l.oid?o=w.oidToDer(w.oidToDer(l.oid)):o=w.oidToDer(o));x.value.push(w.create(w.Class.CONTEXT_SPECIFIC,l.type,!1,o));}S.value.push(w.create(w.Class.CONTEXT_SPECIFIC,0,!0,[x])),a.push(S);}if(typeof e.value>"u"){var r=new Error("Extension value not specified.");throw r.extension=e,r}return e}function Lv(e,t){switch(e){case mt["RSASSA-PSS"]:var r=[];return t.hash.algorithmOid!==void 0&&r.push(w.create(w.Class.CONTEXT_SPECIFIC,0,!0,[w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[w.create(w.Class.UNIVERSAL,w.Type.OID,!1,w.oidToDer(t.hash.algorithmOid).getBytes()),w.create(w.Class.UNIVERSAL,w.Type.NULL,!1,"")])])),t.mgf.algorithmOid!==void 0&&r.push(w.create(w.Class.CONTEXT_SPECIFIC,1,!0,[w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[w.create(w.Class.UNIVERSAL,w.Type.OID,!1,w.oidToDer(t.mgf.algorithmOid).getBytes()),w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[w.create(w.Class.UNIVERSAL,w.Type.OID,!1,w.oidToDer(t.mgf.hash.algorithmOid).getBytes()),w.create(w.Class.UNIVERSAL,w.Type.NULL,!1,"")])])])),t.saltLength!==void 0&&r.push(w.create(w.Class.CONTEXT_SPECIFIC,2,!0,[w.create(w.Class.UNIVERSAL,w.Type.INTEGER,!1,w.integerToDer(t.saltLength).getBytes())])),w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,r);default:return w.create(w.Class.UNIVERSAL,w.Type.NULL,!1,"")}}function jte(e){var t=w.create(w.Class.CONTEXT_SPECIFIC,0,!0,[]);if(e.attributes.length===0)return t;for(var r=e.attributes,n=0;n<r.length;++n){var i=r[n],s=i.value,o=w.Type.UTF8;"valueTagClass"in i&&(o=i.valueTagClass),o===w.Type.UTF8&&(s=Ue.util.encodeUtf8(s));var a=!1;"valueConstructed"in i&&(a=i.valueConstructed);var c=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[w.create(w.Class.UNIVERSAL,w.Type.OID,!1,w.oidToDer(i.type).getBytes()),w.create(w.Class.UNIVERSAL,w.Type.SET,!0,[w.create(w.Class.UNIVERSAL,o,a,s)])]);t.value.push(c);}return t}var Vte=new Date("1950-01-01T00:00:00Z"),Hte=new Date("2050-01-01T00:00:00Z");function HL(e){return e>=Vte&&e<Hte?w.create(w.Class.UNIVERSAL,w.Type.UTCTIME,!1,w.dateToUtcTime(e)):w.create(w.Class.UNIVERSAL,w.Type.GENERALIZEDTIME,!1,w.dateToGeneralizedTime(e))}Se.getTBSCertificate=function(e){var t=HL(e.validity.notBefore),r=HL(e.validity.notAfter),n=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[w.create(w.Class.CONTEXT_SPECIFIC,0,!0,[w.create(w.Class.UNIVERSAL,w.Type.INTEGER,!1,w.integerToDer(e.version).getBytes())]),w.create(w.Class.UNIVERSAL,w.Type.INTEGER,!1,Ue.util.hexToBytes(e.serialNumber)),w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[w.create(w.Class.UNIVERSAL,w.Type.OID,!1,w.oidToDer(e.siginfo.algorithmOid).getBytes()),Lv(e.siginfo.algorithmOid,e.siginfo.parameters)]),Ia(e.issuer),w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[t,r]),Ia(e.subject),Se.publicKeyToAsn1(e.publicKey)]);return e.issuer.uniqueId&&n.value.push(w.create(w.Class.CONTEXT_SPECIFIC,1,!0,[w.create(w.Class.UNIVERSAL,w.Type.BITSTRING,!1,"\0"+e.issuer.uniqueId)])),e.subject.uniqueId&&n.value.push(w.create(w.Class.CONTEXT_SPECIFIC,2,!0,[w.create(w.Class.UNIVERSAL,w.Type.BITSTRING,!1,"\0"+e.subject.uniqueId)])),e.extensions.length>0&&n.value.push(Se.certificateExtensionsToAsn1(e.extensions)),n};Se.getCertificationRequestInfo=function(e){var t=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[w.create(w.Class.UNIVERSAL,w.Type.INTEGER,!1,w.integerToDer(e.version).getBytes()),Ia(e.subject),Se.publicKeyToAsn1(e.publicKey),jte(e)]);return t};Se.distinguishedNameToAsn1=function(e){return Ia(e)};Se.certificateToAsn1=function(e){var t=e.tbsCertificate||Se.getTBSCertificate(e);return w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[t,w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[w.create(w.Class.UNIVERSAL,w.Type.OID,!1,w.oidToDer(e.signatureOid).getBytes()),Lv(e.signatureOid,e.signatureParameters)]),w.create(w.Class.UNIVERSAL,w.Type.BITSTRING,!1,"\0"+e.signature)])};Se.certificateExtensionsToAsn1=function(e){var t=w.create(w.Class.CONTEXT_SPECIFIC,3,!0,[]),r=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[]);t.value.push(r);for(var n=0;n<e.length;++n)r.value.push(Se.certificateExtensionToAsn1(e[n]));return t};Se.certificateExtensionToAsn1=function(e){var t=w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[]);t.value.push(w.create(w.Class.UNIVERSAL,w.Type.OID,!1,w.oidToDer(e.id).getBytes())),e.critical&&t.value.push(w.create(w.Class.UNIVERSAL,w.Type.BOOLEAN,!1,"\xFF"));var r=e.value;return typeof e.value!="string"&&(r=w.toDer(r).getBytes()),t.value.push(w.create(w.Class.UNIVERSAL,w.Type.OCTETSTRING,!1,r)),t};Se.certificationRequestToAsn1=function(e){var t=e.certificationRequestInfo||Se.getCertificationRequestInfo(e);return w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[t,w.create(w.Class.UNIVERSAL,w.Type.SEQUENCE,!0,[w.create(w.Class.UNIVERSAL,w.Type.OID,!1,w.oidToDer(e.signatureOid).getBytes()),Lv(e.signatureOid,e.signatureParameters)]),w.create(w.Class.UNIVERSAL,w.Type.BITSTRING,!1,"\0"+e.signature)])};Se.createCaStore=function(e){var t={certs:{}};t.getIssuer=function(o){var a=r(o.issuer);return a},t.addCertificate=function(o){if(typeof o=="string"&&(o=Ue.pki.certificateFromPem(o)),n(o.subject),!t.hasCertificate(o))if(o.subject.hash in t.certs){var a=t.certs[o.subject.hash];Ue.util.isArray(a)||(a=[a]),a.push(o),t.certs[o.subject.hash]=a;}else t.certs[o.subject.hash]=o;},t.hasCertificate=function(o){typeof o=="string"&&(o=Ue.pki.certificateFromPem(o));var a=r(o.subject);if(!a)return !1;Ue.util.isArray(a)||(a=[a]);for(var c=w.toDer(Se.certificateToAsn1(o)).getBytes(),l=0;l<a.length;++l){var u=w.toDer(Se.certificateToAsn1(a[l])).getBytes();if(c===u)return !0}return !1},t.listAllCertificates=function(){var o=[];for(var a in t.certs)if(t.certs.hasOwnProperty(a)){var c=t.certs[a];if(!Ue.util.isArray(c))o.push(c);else for(var l=0;l<c.length;++l)o.push(c[l]);}return o},t.removeCertificate=function(o){var a;if(typeof o=="string"&&(o=Ue.pki.certificateFromPem(o)),n(o.subject),!t.hasCertificate(o))return null;var c=r(o.subject);if(!Ue.util.isArray(c))return a=t.certs[o.subject.hash],delete t.certs[o.subject.hash],a;for(var l=w.toDer(Se.certificateToAsn1(o)).getBytes(),u=0;u<c.length;++u){var f=w.toDer(Se.certificateToAsn1(c[u])).getBytes();l===f&&(a=c[u],c.splice(u,1));}return c.length===0&&delete t.certs[o.subject.hash],a};function r(o){return n(o),t.certs[o.hash]||null}function n(o){if(!o.hash){var a=Ue.md.sha1.create();o.attributes=Se.RDNAttributesAsArray(Ia(o),a),o.hash=a.digest().toHex();}}if(e)for(var i=0;i<e.length;++i){var s=e[i];t.addCertificate(s);}return t};Se.certificateError={bad_certificate:"forge.pki.BadCertificate",unsupported_certificate:"forge.pki.UnsupportedCertificate",certificate_revoked:"forge.pki.CertificateRevoked",certificate_expired:"forge.pki.CertificateExpired",certificate_unknown:"forge.pki.CertificateUnknown",unknown_ca:"forge.pki.UnknownCertificateAuthority"};Se.verifyCertificateChain=function(e,t,r){typeof r=="function"&&(r={verify:r}),r=r||{},t=t.slice(0);var n=t.slice(0),i=r.validityCheckDate;typeof i>"u"&&(i=new Date);var s=!0,o=null,a=0;do{var c=t.shift(),l=null,u=!1;if(i&&(i<c.validity.notBefore||i>c.validity.notAfter)&&(o={message:"Certificate is not valid yet or has expired.",error:Se.certificateError.certificate_expired,notBefore:c.validity.notBefore,notAfter:c.validity.notAfter,now:i}),o===null){if(l=t[0]||e.getIssuer(c),l===null&&c.isIssuer(c)&&(u=!0,l=c),l){var f=l;Ue.util.isArray(f)||(f=[f]);for(var d=!1;!d&&f.length>0;){l=f.shift();try{d=l.verify(c);}catch{}}d||(o={message:"Certificate signature is invalid.",error:Se.certificateError.bad_certificate});}o===null&&(!l||u)&&!e.hasCertificate(c)&&(o={message:"Certificate is not trusted.",error:Se.certificateError.unknown_ca});}if(o===null&&l&&!c.isIssuer(l)&&(o={message:"Certificate issuer is invalid.",error:Se.certificateError.bad_certificate}),o===null)for(var p={keyUsage:!0,basicConstraints:!0},m=0;o===null&&m<c.extensions.length;++m){var S=c.extensions[m];S.critical&&!(S.name in p)&&(o={message:"Certificate has an unsupported critical extension.",error:Se.certificateError.unsupported_certificate});}if(o===null&&(!s||t.length===0&&(!l||u))){var x=c.getExtension("basicConstraints"),I=c.getExtension("keyUsage");if(I!==null&&(!I.keyCertSign||x===null)&&(o={message:"Certificate keyUsage or basicConstraints conflict or indicate that the certificate is not a CA. If the certificate is the only one in the chain or isn't the first then the certificate must be a valid CA.",error:Se.certificateError.bad_certificate}),o===null&&x!==null&&!x.cA&&(o={message:"Certificate basicConstraints indicates the certificate is not a CA.",error:Se.certificateError.bad_certificate}),o===null&&I!==null&&"pathLenConstraint"in x){var v=a-1;v>x.pathLenConstraint&&(o={message:"Certificate basicConstraints pathLenConstraint violated.",error:Se.certificateError.bad_certificate});}}var b=o===null?!0:o.error,D=r.verify?r.verify(b,a,n):b;if(D===!0)o=null;else throw b===!0&&(o={message:"The application rejected the certificate.",error:Se.certificateError.bad_certificate}),(D||D===0)&&(typeof D=="object"&&!Ue.util.isArray(D)?(D.message&&(o.message=D.message),D.error&&(o.error=D.error)):typeof D=="string"&&(o.error=D)),o;s=!1,++a;}while(t.length>0);return !0};});var Bv=A((Whe,QL)=>{var Ft=rt();ni();Ea();bs();kv();Pv();Ln();Sc();Ta();vt();Oh();var B=Ft.asn1,at=Ft.pki,Cc=QL.exports=Ft.pkcs12=Ft.pkcs12||{},YL={name:"ContentInfo",tagClass:B.Class.UNIVERSAL,type:B.Type.SEQUENCE,constructed:!0,value:[{name:"ContentInfo.contentType",tagClass:B.Class.UNIVERSAL,type:B.Type.OID,constructed:!1,capture:"contentType"},{name:"ContentInfo.content",tagClass:B.Class.CONTEXT_SPECIFIC,constructed:!0,captureAsn1:"content"}]},Wte={name:"PFX",tagClass:B.Class.UNIVERSAL,type:B.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.version",tagClass:B.Class.UNIVERSAL,type:B.Type.INTEGER,constructed:!1,capture:"version"},YL,{name:"PFX.macData",tagClass:B.Class.UNIVERSAL,type:B.Type.SEQUENCE,constructed:!0,optional:!0,captureAsn1:"mac",value:[{name:"PFX.macData.mac",tagClass:B.Class.UNIVERSAL,type:B.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.macData.mac.digestAlgorithm",tagClass:B.Class.UNIVERSAL,type:B.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.macData.mac.digestAlgorithm.algorithm",tagClass:B.Class.UNIVERSAL,type:B.Type.OID,constructed:!1,capture:"macAlgorithm"},{name:"PFX.macData.mac.digestAlgorithm.parameters",tagClass:B.Class.UNIVERSAL,captureAsn1:"macAlgorithmParameters"}]},{name:"PFX.macData.mac.digest",tagClass:B.Class.UNIVERSAL,type:B.Type.OCTETSTRING,constructed:!1,capture:"macDigest"}]},{name:"PFX.macData.macSalt",tagClass:B.Class.UNIVERSAL,type:B.Type.OCTETSTRING,constructed:!1,capture:"macSalt"},{name:"PFX.macData.iterations",tagClass:B.Class.UNIVERSAL,type:B.Type.INTEGER,constructed:!1,optional:!0,capture:"macIterations"}]}]},Kte={name:"SafeBag",tagClass:B.Class.UNIVERSAL,type:B.Type.SEQUENCE,constructed:!0,value:[{name:"SafeBag.bagId",tagClass:B.Class.UNIVERSAL,type:B.Type.OID,constructed:!1,capture:"bagId"},{name:"SafeBag.bagValue",tagClass:B.Class.CONTEXT_SPECIFIC,constructed:!0,captureAsn1:"bagValue"},{name:"SafeBag.bagAttributes",tagClass:B.Class.UNIVERSAL,type:B.Type.SET,constructed:!0,optional:!0,capture:"bagAttributes"}]},zte={name:"Attribute",tagClass:B.Class.UNIVERSAL,type:B.Type.SEQUENCE,constructed:!0,value:[{name:"Attribute.attrId",tagClass:B.Class.UNIVERSAL,type:B.Type.OID,constructed:!1,capture:"oid"},{name:"Attribute.attrValues",tagClass:B.Class.UNIVERSAL,type:B.Type.SET,constructed:!0,capture:"values"}]},Gte={name:"CertBag",tagClass:B.Class.UNIVERSAL,type:B.Type.SEQUENCE,constructed:!0,value:[{name:"CertBag.certId",tagClass:B.Class.UNIVERSAL,type:B.Type.OID,constructed:!1,capture:"certId"},{name:"CertBag.certValue",tagClass:B.Class.CONTEXT_SPECIFIC,constructed:!0,value:[{name:"CertBag.certValue[0]",tagClass:B.Class.UNIVERSAL,type:B.Class.OCTETSTRING,constructed:!1,capture:"cert"}]}]};function bc(e,t,r,n){for(var i=[],s=0;s<e.length;s++)for(var o=0;o<e[s].safeBags.length;o++){var a=e[s].safeBags[o];if(!(n!==void 0&&a.type!==n)){if(t===null){i.push(a);continue}a.attributes[t]!==void 0&&a.attributes[t].indexOf(r)>=0&&i.push(a);}}return i}Cc.pkcs12FromAsn1=function(e,t,r){typeof t=="string"?(r=t,t=!0):t===void 0&&(t=!0);var n={},i=[];if(!B.validate(e,Wte,n,i)){var s=new Error("Cannot read PKCS#12 PFX. ASN.1 object is not an PKCS#12 PFX.");throw s.errors=s,s}var o={version:n.version.charCodeAt(0),safeContents:[],getBags:function(x){var I={},v;return "localKeyId"in x?v=x.localKeyId:"localKeyIdHex"in x&&(v=Ft.util.hexToBytes(x.localKeyIdHex)),v===void 0&&!("friendlyName"in x)&&"bagType"in x&&(I[x.bagType]=bc(o.safeContents,null,null,x.bagType)),v!==void 0&&(I.localKeyId=bc(o.safeContents,"localKeyId",v,x.bagType)),"friendlyName"in x&&(I.friendlyName=bc(o.safeContents,"friendlyName",x.friendlyName,x.bagType)),I},getBagsByFriendlyName:function(x,I){return bc(o.safeContents,"friendlyName",x,I)},getBagsByLocalKeyId:function(x,I){return bc(o.safeContents,"localKeyId",x,I)}};if(n.version.charCodeAt(0)!==3){var s=new Error("PKCS#12 PFX of version other than 3 not supported.");throw s.version=n.version.charCodeAt(0),s}if(B.derToOid(n.contentType)!==at.oids.data){var s=new Error("Only PKCS#12 PFX in password integrity mode supported.");throw s.oid=B.derToOid(n.contentType),s}var a=n.content.value[0];if(a.tagClass!==B.Class.UNIVERSAL||a.type!==B.Type.OCTETSTRING)throw new Error("PKCS#12 authSafe content data is not an OCTET STRING.");if(a=Ov(a),n.mac){var c=null,l=0,u=B.derToOid(n.macAlgorithm);switch(u){case at.oids.sha1:c=Ft.md.sha1.create(),l=20;break;case at.oids.sha256:c=Ft.md.sha256.create(),l=32;break;case at.oids.sha384:c=Ft.md.sha384.create(),l=48;break;case at.oids.sha512:c=Ft.md.sha512.create(),l=64;break;case at.oids.md5:c=Ft.md.md5.create(),l=16;break}if(c===null)throw new Error("PKCS#12 uses unsupported MAC algorithm: "+u);var f=new Ft.util.ByteBuffer(n.macSalt),d="macIterations"in n?parseInt(Ft.util.bytesToHex(n.macIterations),16):1,p=Cc.generateKey(r,f,3,d,l,c),m=Ft.hmac.create();m.start(c,p),m.update(a.value);var S=m.getMac();if(S.getBytes()!==n.macDigest)throw new Error("PKCS#12 MAC could not be verified. Invalid password?")}return Yte(o,a.value,t,r),o};function Ov(e){if(e.composed||e.constructed){for(var t=Ft.util.createBuffer(),r=0;r<e.value.length;++r)t.putBytes(e.value[r].value);e.composed=e.constructed=!1,e.value=t.getBytes();}return e}function Yte(e,t,r,n){if(t=B.fromDer(t,r),t.tagClass!==B.Class.UNIVERSAL||t.type!==B.Type.SEQUENCE||t.constructed!==!0)throw new Error("PKCS#12 AuthenticatedSafe expected to be a SEQUENCE OF ContentInfo");for(var i=0;i<t.value.length;i++){var s=t.value[i],o={},a=[];if(!B.validate(s,YL,o,a)){var c=new Error("Cannot read ContentInfo.");throw c.errors=a,c}var l={encrypted:!1},u=null,f=o.content.value[0];switch(B.derToOid(o.contentType)){case at.oids.data:if(f.tagClass!==B.Class.UNIVERSAL||f.type!==B.Type.OCTETSTRING)throw new Error("PKCS#12 SafeContents Data is not an OCTET STRING.");u=Ov(f).value;break;case at.oids.encryptedData:u=Qte(f,n),l.encrypted=!0;break;default:var c=new Error("Unsupported PKCS#12 contentType.");throw c.contentType=B.derToOid(o.contentType),c}l.safeBags=Xte(u,r,n),e.safeContents.push(l);}}function Qte(e,t){var r={},n=[];if(!B.validate(e,Ft.pkcs7.asn1.encryptedDataValidator,r,n)){var i=new Error("Cannot read EncryptedContentInfo.");throw i.errors=n,i}var s=B.derToOid(r.contentType);if(s!==at.oids.data){var i=new Error("PKCS#12 EncryptedContentInfo ContentType is not Data.");throw i.oid=s,i}s=B.derToOid(r.encAlgorithm);var o=at.pbe.getCipher(s,r.encParameter,t),a=Ov(r.encryptedContentAsn1),c=Ft.util.createBuffer(a.value);if(o.update(c),!o.finish())throw new Error("Failed to decrypt PKCS#12 SafeContents.");return o.output.getBytes()}function Xte(e,t,r){if(!t&&e.length===0)return [];if(e=B.fromDer(e,t),e.tagClass!==B.Class.UNIVERSAL||e.type!==B.Type.SEQUENCE||e.constructed!==!0)throw new Error("PKCS#12 SafeContents expected to be a SEQUENCE OF SafeBag.");for(var n=[],i=0;i<e.value.length;i++){var s=e.value[i],o={},a=[];if(!B.validate(s,Kte,o,a)){var c=new Error("Cannot read SafeBag.");throw c.errors=a,c}var l={type:B.derToOid(o.bagId),attributes:Jte(o.bagAttributes)};n.push(l);var u,f,d=o.bagValue.value[0];switch(l.type){case at.oids.pkcs8ShroudedKeyBag:if(d=at.decryptPrivateKeyInfo(d,r),d===null)throw new Error("Unable to decrypt PKCS#8 ShroudedKeyBag, wrong password?");case at.oids.keyBag:try{l.key=at.privateKeyFromAsn1(d);}catch{l.key=null,l.asn1=d;}continue;case at.oids.certBag:u=Gte,f=function(){if(B.derToOid(o.certId)!==at.oids.x509Certificate){var m=new Error("Unsupported certificate type, only X.509 supported.");throw m.oid=B.derToOid(o.certId),m}var S=B.fromDer(o.cert,t);try{l.cert=at.certificateFromAsn1(S,!0);}catch{l.cert=null,l.asn1=S;}};break;default:var c=new Error("Unsupported PKCS#12 SafeBag type.");throw c.oid=l.type,c}if(u!==void 0&&!B.validate(d,u,o,a)){var c=new Error("Cannot read PKCS#12 "+u.name);throw c.errors=a,c}f();}return n}function Jte(e){var t={};if(e!==void 0)for(var r=0;r<e.length;++r){var n={},i=[];if(!B.validate(e[r],zte,n,i)){var s=new Error("Cannot read PKCS#12 BagAttribute.");throw s.errors=i,s}var o=B.derToOid(n.oid);if(at.oids[o]!==void 0){t[at.oids[o]]=[];for(var a=0;a<n.values.length;++a)t[at.oids[o]].push(n.values[a].value);}}return t}Cc.toPkcs12Asn1=function(e,t,r,n){n=n||{},n.saltSize=n.saltSize||8,n.count=n.count||2048,n.algorithm=n.algorithm||n.encAlgorithm||"aes128","useMac"in n||(n.useMac=!0),"localKeyId"in n||(n.localKeyId=null),"generateLocalKeyId"in n||(n.generateLocalKeyId=!0);var i=n.localKeyId,s;if(i!==null)i=Ft.util.hexToBytes(i);else if(n.generateLocalKeyId)if(t){var o=Ft.util.isArray(t)?t[0]:t;typeof o=="string"&&(o=at.certificateFromPem(o));var a=Ft.md.sha1.create();a.update(B.toDer(at.certificateToAsn1(o)).getBytes()),i=a.digest().getBytes();}else i=Ft.random.getBytes(20);var c=[];i!==null&&c.push(B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.OID,!1,B.oidToDer(at.oids.localKeyId).getBytes()),B.create(B.Class.UNIVERSAL,B.Type.SET,!0,[B.create(B.Class.UNIVERSAL,B.Type.OCTETSTRING,!1,i)])])),"friendlyName"in n&&c.push(B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.OID,!1,B.oidToDer(at.oids.friendlyName).getBytes()),B.create(B.Class.UNIVERSAL,B.Type.SET,!0,[B.create(B.Class.UNIVERSAL,B.Type.BMPSTRING,!1,n.friendlyName)])])),c.length>0&&(s=B.create(B.Class.UNIVERSAL,B.Type.SET,!0,c));var l=[],u=[];t!==null&&(Ft.util.isArray(t)?u=t:u=[t]);for(var f=[],d=0;d<u.length;++d){t=u[d],typeof t=="string"&&(t=at.certificateFromPem(t));var p=d===0?s:void 0,m=at.certificateToAsn1(t),S=B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.OID,!1,B.oidToDer(at.oids.certBag).getBytes()),B.create(B.Class.CONTEXT_SPECIFIC,0,!0,[B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.OID,!1,B.oidToDer(at.oids.x509Certificate).getBytes()),B.create(B.Class.CONTEXT_SPECIFIC,0,!0,[B.create(B.Class.UNIVERSAL,B.Type.OCTETSTRING,!1,B.toDer(m).getBytes())])])]),p]);f.push(S);}if(f.length>0){var x=B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,f),I=B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.OID,!1,B.oidToDer(at.oids.data).getBytes()),B.create(B.Class.CONTEXT_SPECIFIC,0,!0,[B.create(B.Class.UNIVERSAL,B.Type.OCTETSTRING,!1,B.toDer(x).getBytes())])]);l.push(I);}var v=null;if(e!==null){var b=at.wrapRsaPrivateKey(at.privateKeyToAsn1(e));r===null?v=B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.OID,!1,B.oidToDer(at.oids.keyBag).getBytes()),B.create(B.Class.CONTEXT_SPECIFIC,0,!0,[b]),s]):v=B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.OID,!1,B.oidToDer(at.oids.pkcs8ShroudedKeyBag).getBytes()),B.create(B.Class.CONTEXT_SPECIFIC,0,!0,[at.encryptPrivateKeyInfo(b,r,n)]),s]);var D=B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[v]),L=B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.OID,!1,B.oidToDer(at.oids.data).getBytes()),B.create(B.Class.CONTEXT_SPECIFIC,0,!0,[B.create(B.Class.UNIVERSAL,B.Type.OCTETSTRING,!1,B.toDer(D).getBytes())])]);l.push(L);}var j=B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,l),J;if(n.useMac){var a=Ft.md.sha1.create(),K=new Ft.util.ByteBuffer(Ft.random.getBytes(n.saltSize)),G=n.count,e=Cc.generateKey(r,K,3,G,20),ee=Ft.hmac.create();ee.start(a,e),ee.update(B.toDer(j).getBytes());var M=ee.getMac();J=B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.OID,!1,B.oidToDer(at.oids.sha1).getBytes()),B.create(B.Class.UNIVERSAL,B.Type.NULL,!1,"")]),B.create(B.Class.UNIVERSAL,B.Type.OCTETSTRING,!1,M.getBytes())]),B.create(B.Class.UNIVERSAL,B.Type.OCTETSTRING,!1,K.getBytes()),B.create(B.Class.UNIVERSAL,B.Type.INTEGER,!1,B.integerToDer(G).getBytes())]);}return B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.INTEGER,!1,B.integerToDer(3).getBytes()),B.create(B.Class.UNIVERSAL,B.Type.SEQUENCE,!0,[B.create(B.Class.UNIVERSAL,B.Type.OID,!1,B.oidToDer(at.oids.data).getBytes()),B.create(B.Class.CONTEXT_SPECIFIC,0,!0,[B.create(B.Class.UNIVERSAL,B.Type.OCTETSTRING,!1,B.toDer(j).getBytes())])]),J])};Cc.generateKey=Ft.pbe.generatePkcs12Key;});var Fv=A((Khe,XL)=>{var ws=rt();ni();bs();Pv();po();_h();Bv();kh();Sc();vt();Oh();var qv=ws.asn1,Da=XL.exports=ws.pki=ws.pki||{};Da.pemToDer=function(e){var t=ws.pem.decode(e)[0];if(t.procType&&t.procType.type==="ENCRYPTED")throw new Error("Could not convert PEM to DER; PEM is encrypted.");return ws.util.createBuffer(t.body)};Da.privateKeyFromPem=function(e){var t=ws.pem.decode(e)[0];if(t.type!=="PRIVATE KEY"&&t.type!=="RSA PRIVATE KEY"){var r=new Error('Could not convert private key from PEM; PEM header type is not "PRIVATE KEY" or "RSA PRIVATE KEY".');throw r.headerType=t.type,r}if(t.procType&&t.procType.type==="ENCRYPTED")throw new Error("Could not convert private key from PEM; PEM is encrypted.");var n=qv.fromDer(t.body);return Da.privateKeyFromAsn1(n)};Da.privateKeyToPem=function(e,t){var r={type:"RSA PRIVATE KEY",body:qv.toDer(Da.privateKeyToAsn1(e)).getBytes()};return ws.pem.encode(r,{maxline:t})};Da.privateKeyInfoToPem=function(e,t){var r={type:"PRIVATE KEY",body:qv.toDer(e).getBytes()};return ws.pem.encode(r,{maxline:t})};});var Hv=A((zhe,sO)=>{var fe=rt();ni();Ea();Ch();po();Fv();Ln();Ta();vt();var Mh=function(e,t,r,n){var i=fe.util.createBuffer(),s=e.length>>1,o=s+(e.length&1),a=e.substr(0,o),c=e.substr(s,o),l=fe.util.createBuffer(),u=fe.hmac.create();r=t+r;var f=Math.ceil(n/16),d=Math.ceil(n/20);u.start("MD5",a);var p=fe.util.createBuffer();l.putBytes(r);for(var m=0;m<f;++m)u.start(null,null),u.update(l.getBytes()),l.putBuffer(u.digest()),u.start(null,null),u.update(l.bytes()+r),p.putBuffer(u.digest());u.start("SHA1",c);var S=fe.util.createBuffer();l.clear(),l.putBytes(r);for(var m=0;m<d;++m)u.start(null,null),u.update(l.getBytes()),l.putBuffer(u.digest()),u.start(null,null),u.update(l.bytes()+r),S.putBuffer(u.digest());return i.putBytes(fe.util.xorBytes(p.getBytes(),S.getBytes(),n)),i},Zte=function(e,t,r){var n=fe.hmac.create();n.start("SHA1",e);var i=fe.util.createBuffer();return i.putInt32(t[0]),i.putInt32(t[1]),i.putByte(r.type),i.putByte(r.version.major),i.putByte(r.version.minor),i.putInt16(r.length),i.putBytes(r.fragment.bytes()),n.update(i.getBytes()),n.digest().getBytes()},ere=function(e,t,r){var n=!1;try{var i=e.deflate(t.fragment.getBytes());t.fragment=fe.util.createBuffer(i),t.length=i.length,n=!0;}catch{}return n},tre=function(e,t,r){var n=!1;try{var i=e.inflate(t.fragment.getBytes());t.fragment=fe.util.createBuffer(i),t.length=i.length,n=!0;}catch{}return n},Cn=function(e,t){var r=0;switch(t){case 1:r=e.getByte();break;case 2:r=e.getInt16();break;case 3:r=e.getInt24();break;case 4:r=e.getInt32();break}return fe.util.createBuffer(e.getBytes(r))},Fn=function(e,t,r){e.putInt(r.length(),t<<3),e.putBuffer(r);},R={};R.Versions={TLS_1_0:{major:3,minor:1},TLS_1_1:{major:3,minor:2},TLS_1_2:{major:3,minor:3}};R.SupportedVersions=[R.Versions.TLS_1_1,R.Versions.TLS_1_0];R.Version=R.SupportedVersions[0];R.MaxFragment=15360;R.ConnectionEnd={server:0,client:1};R.PRFAlgorithm={tls_prf_sha256:0};R.BulkCipherAlgorithm={none:null,rc4:0,des3:1,aes:2};R.CipherType={stream:0,block:1,aead:2};R.MACAlgorithm={none:null,hmac_md5:0,hmac_sha1:1,hmac_sha256:2,hmac_sha384:3,hmac_sha512:4};R.CompressionMethod={none:0,deflate:1};R.ContentType={change_cipher_spec:20,alert:21,handshake:22,application_data:23,heartbeat:24};R.HandshakeType={hello_request:0,client_hello:1,server_hello:2,certificate:11,server_key_exchange:12,certificate_request:13,server_hello_done:14,certificate_verify:15,client_key_exchange:16,finished:20};R.Alert={};R.Alert.Level={warning:1,fatal:2};R.Alert.Description={close_notify:0,unexpected_message:10,bad_record_mac:20,decryption_failed:21,record_overflow:22,decompression_failure:30,handshake_failure:40,bad_certificate:42,unsupported_certificate:43,certificate_revoked:44,certificate_expired:45,certificate_unknown:46,illegal_parameter:47,unknown_ca:48,access_denied:49,decode_error:50,decrypt_error:51,export_restriction:60,protocol_version:70,insufficient_security:71,internal_error:80,user_canceled:90,no_renegotiation:100};R.HeartbeatMessageType={heartbeat_request:1,heartbeat_response:2};R.CipherSuites={};R.getCipherSuite=function(e){var t=null;for(var r in R.CipherSuites){var n=R.CipherSuites[r];if(n.id[0]===e.charCodeAt(0)&&n.id[1]===e.charCodeAt(1)){t=n;break}}return t};R.handleUnexpected=function(e,t){var r=!e.open&&e.entity===R.ConnectionEnd.client;r||e.error(e,{message:"Unexpected message. Received TLS record out of order.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.unexpected_message}});};R.handleHelloRequest=function(e,t,r){!e.handshaking&&e.handshakes>0&&(R.queue(e,R.createAlert(e,{level:R.Alert.Level.warning,description:R.Alert.Description.no_renegotiation})),R.flush(e)),e.process();};R.parseHelloMessage=function(e,t,r){var n=null,i=e.entity===R.ConnectionEnd.client;if(r<38)e.error(e,{message:i?"Invalid ServerHello message. Message too short.":"Invalid ClientHello message. Message too short.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.illegal_parameter}});else {var s=t.fragment,o=s.length();if(n={version:{major:s.getByte(),minor:s.getByte()},random:fe.util.createBuffer(s.getBytes(32)),session_id:Cn(s,1),extensions:[]},i?(n.cipher_suite=s.getBytes(2),n.compression_method=s.getByte()):(n.cipher_suites=Cn(s,2),n.compression_methods=Cn(s,1)),o=r-(o-s.length()),o>0){for(var a=Cn(s,2);a.length()>0;)n.extensions.push({type:[a.getByte(),a.getByte()],data:Cn(a,2)});if(!i)for(var c=0;c<n.extensions.length;++c){var l=n.extensions[c];if(l.type[0]===0&&l.type[1]===0)for(var u=Cn(l.data,2);u.length()>0;){var f=u.getByte();if(f!==0)break;e.session.extensions.server_name.serverNameList.push(Cn(u,2).getBytes());}}}if(e.session.version&&(n.version.major!==e.session.version.major||n.version.minor!==e.session.version.minor))return e.error(e,{message:"TLS version change is disallowed during renegotiation.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.protocol_version}});if(i)e.session.cipherSuite=R.getCipherSuite(n.cipher_suite);else for(var d=fe.util.createBuffer(n.cipher_suites.bytes());d.length()>0&&(e.session.cipherSuite=R.getCipherSuite(d.getBytes(2)),e.session.cipherSuite===null););if(e.session.cipherSuite===null)return e.error(e,{message:"No cipher suites in common.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.handshake_failure},cipherSuite:fe.util.bytesToHex(n.cipher_suite)});i?e.session.compressionMethod=n.compression_method:e.session.compressionMethod=R.CompressionMethod.none;}return n};R.createSecurityParameters=function(e,t){var r=e.entity===R.ConnectionEnd.client,n=t.random.bytes(),i=r?e.session.sp.client_random:n,s=r?n:R.createRandom().getBytes();e.session.sp={entity:e.entity,prf_algorithm:R.PRFAlgorithm.tls_prf_sha256,bulk_cipher_algorithm:null,cipher_type:null,enc_key_length:null,block_length:null,fixed_iv_length:null,record_iv_length:null,mac_algorithm:null,mac_length:null,mac_key_length:null,compression_algorithm:e.session.compressionMethod,pre_master_secret:null,master_secret:null,client_random:i,server_random:s};};R.handleServerHello=function(e,t,r){var n=R.parseHelloMessage(e,t,r);if(!e.fail){if(n.version.minor<=e.version.minor)e.version.minor=n.version.minor;else return e.error(e,{message:"Incompatible TLS version.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.protocol_version}});e.session.version=e.version;var i=n.session_id.bytes();i.length>0&&i===e.session.id?(e.expect=eO,e.session.resuming=!0,e.session.sp.server_random=n.random.bytes()):(e.expect=nre,e.session.resuming=!1,R.createSecurityParameters(e,n)),e.session.id=i,e.process();}};R.handleClientHello=function(e,t,r){var n=R.parseHelloMessage(e,t,r);if(!e.fail){var i=n.session_id.bytes(),s=null;if(e.sessionCache&&(s=e.sessionCache.getSession(i),s===null?i="":(s.version.major!==n.version.major||s.version.minor>n.version.minor)&&(s=null,i="")),i.length===0&&(i=fe.random.getBytes(32)),e.session.id=i,e.session.clientHelloVersion=n.version,e.session.sp={},s)e.version=e.session.version=s.version,e.session.sp=s.sp;else {for(var o,a=1;a<R.SupportedVersions.length&&(o=R.SupportedVersions[a],!(o.minor<=n.version.minor));++a);e.version={major:o.major,minor:o.minor},e.session.version=e.version;}s!==null?(e.expect=jv,e.session.resuming=!0,e.session.sp.client_random=n.random.bytes()):(e.expect=e.verifyClient!==!1?lre:$v,e.session.resuming=!1,R.createSecurityParameters(e,n)),e.open=!0,R.queue(e,R.createRecord(e,{type:R.ContentType.handshake,data:R.createServerHello(e)})),e.session.resuming?(R.queue(e,R.createRecord(e,{type:R.ContentType.change_cipher_spec,data:R.createChangeCipherSpec()})),e.state.pending=R.createConnectionState(e),e.state.current.write=e.state.pending.write,R.queue(e,R.createRecord(e,{type:R.ContentType.handshake,data:R.createFinished(e)}))):(R.queue(e,R.createRecord(e,{type:R.ContentType.handshake,data:R.createCertificate(e)})),e.fail||(R.queue(e,R.createRecord(e,{type:R.ContentType.handshake,data:R.createServerKeyExchange(e)})),e.verifyClient!==!1&&R.queue(e,R.createRecord(e,{type:R.ContentType.handshake,data:R.createCertificateRequest(e)})),R.queue(e,R.createRecord(e,{type:R.ContentType.handshake,data:R.createServerHelloDone(e)})))),R.flush(e),e.process();}};R.handleCertificate=function(e,t,r){if(r<3)return e.error(e,{message:"Invalid Certificate message. Message too short.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.illegal_parameter}});var n=t.fragment,i={certificate_list:Cn(n,3)},s,o,a=[];try{for(;i.certificate_list.length()>0;)s=Cn(i.certificate_list,3),o=fe.asn1.fromDer(s),s=fe.pki.certificateFromAsn1(o,!0),a.push(s);}catch(l){return e.error(e,{message:"Could not parse certificate list.",cause:l,send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.bad_certificate}})}var c=e.entity===R.ConnectionEnd.client;(c||e.verifyClient===!0)&&a.length===0?e.error(e,{message:c?"No server certificate provided.":"No client certificate provided.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.illegal_parameter}}):a.length===0?e.expect=c?JL:$v:(c?e.session.serverCertificate=a[0]:e.session.clientCertificate=a[0],R.verifyCertificateChain(e,a)&&(e.expect=c?JL:$v)),e.process();};R.handleServerKeyExchange=function(e,t,r){if(r>0)return e.error(e,{message:"Invalid key parameters. Only RSA is supported.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.unsupported_certificate}});e.expect=ire,e.process();};R.handleClientKeyExchange=function(e,t,r){if(r<48)return e.error(e,{message:"Invalid key parameters. Only RSA is supported.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.unsupported_certificate}});var n=t.fragment,i={enc_pre_master_secret:Cn(n,2).getBytes()},s=null;if(e.getPrivateKey)try{s=e.getPrivateKey(e,e.session.serverCertificate),s=fe.pki.privateKeyFromPem(s);}catch(c){e.error(e,{message:"Could not get private key.",cause:c,send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.internal_error}});}if(s===null)return e.error(e,{message:"No private key set.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.internal_error}});try{var o=e.session.sp;o.pre_master_secret=s.decrypt(i.enc_pre_master_secret);var a=e.session.clientHelloVersion;if(a.major!==o.pre_master_secret.charCodeAt(0)||a.minor!==o.pre_master_secret.charCodeAt(1))throw new Error("TLS version rollback attack detected.")}catch{o.pre_master_secret=fe.random.getBytes(48);}e.expect=jv,e.session.clientCertificate!==null&&(e.expect=fre),e.process();};R.handleCertificateRequest=function(e,t,r){if(r<3)return e.error(e,{message:"Invalid CertificateRequest. Message too short.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.illegal_parameter}});var n=t.fragment,i={certificate_types:Cn(n,1),certificate_authorities:Cn(n,2)};e.session.certificateRequest=i,e.expect=sre,e.process();};R.handleCertificateVerify=function(e,t,r){if(r<2)return e.error(e,{message:"Invalid CertificateVerify. Message too short.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.illegal_parameter}});var n=t.fragment;n.read-=4;var i=n.bytes();n.read+=4;var s={signature:Cn(n,2).getBytes()},o=fe.util.createBuffer();o.putBuffer(e.session.md5.digest()),o.putBuffer(e.session.sha1.digest()),o=o.getBytes();try{var a=e.session.clientCertificate;if(!a.publicKey.verify(o,s.signature,"NONE"))throw new Error("CertificateVerify signature does not match.");e.session.md5.update(i),e.session.sha1.update(i);}catch{return e.error(e,{message:"Bad signature in CertificateVerify.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.handshake_failure}})}e.expect=jv,e.process();};R.handleServerHelloDone=function(e,t,r){if(r>0)return e.error(e,{message:"Invalid ServerHelloDone message. Invalid length.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.record_overflow}});if(e.serverCertificate===null){var n={message:"No server certificate provided. Not enough security.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.insufficient_security}},i=0,s=e.verify(e,n.alert.description,i,[]);if(s!==!0)return (s||s===0)&&(typeof s=="object"&&!fe.util.isArray(s)?(s.message&&(n.message=s.message),s.alert&&(n.alert.description=s.alert)):typeof s=="number"&&(n.alert.description=s)),e.error(e,n)}e.session.certificateRequest!==null&&(t=R.createRecord(e,{type:R.ContentType.handshake,data:R.createCertificate(e)}),R.queue(e,t)),t=R.createRecord(e,{type:R.ContentType.handshake,data:R.createClientKeyExchange(e)}),R.queue(e,t),e.expect=ure;var o=function(a,c){a.session.certificateRequest!==null&&a.session.clientCertificate!==null&&R.queue(a,R.createRecord(a,{type:R.ContentType.handshake,data:R.createCertificateVerify(a,c)})),R.queue(a,R.createRecord(a,{type:R.ContentType.change_cipher_spec,data:R.createChangeCipherSpec()})),a.state.pending=R.createConnectionState(a),a.state.current.write=a.state.pending.write,R.queue(a,R.createRecord(a,{type:R.ContentType.handshake,data:R.createFinished(a)})),a.expect=eO,R.flush(a),a.process();};if(e.session.certificateRequest===null||e.session.clientCertificate===null)return o(e,null);R.getClientSignature(e,o);};R.handleChangeCipherSpec=function(e,t){if(t.fragment.getByte()!==1)return e.error(e,{message:"Invalid ChangeCipherSpec message received.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.illegal_parameter}});var r=e.entity===R.ConnectionEnd.client;(e.session.resuming&&r||!e.session.resuming&&!r)&&(e.state.pending=R.createConnectionState(e)),e.state.current.read=e.state.pending.read,(!e.session.resuming&&r||e.session.resuming&&!r)&&(e.state.pending=null),e.expect=r?ore:hre,e.process();};R.handleFinished=function(e,t,r){var n=t.fragment;n.read-=4;var i=n.bytes();n.read+=4;var s=t.fragment.getBytes();n=fe.util.createBuffer(),n.putBuffer(e.session.md5.digest()),n.putBuffer(e.session.sha1.digest());var o=e.entity===R.ConnectionEnd.client,a=o?"server finished":"client finished",c=e.session.sp,l=12,u=Mh;if(n=u(c.master_secret,a,n.getBytes(),l),n.getBytes()!==s)return e.error(e,{message:"Invalid verify_data in Finished message.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.decrypt_error}});e.session.md5.update(i),e.session.sha1.update(i),(e.session.resuming&&o||!e.session.resuming&&!o)&&(R.queue(e,R.createRecord(e,{type:R.ContentType.change_cipher_spec,data:R.createChangeCipherSpec()})),e.state.current.write=e.state.pending.write,e.state.pending=null,R.queue(e,R.createRecord(e,{type:R.ContentType.handshake,data:R.createFinished(e)}))),e.expect=o?are:dre,e.handshaking=!1,++e.handshakes,e.peerCertificate=o?e.session.serverCertificate:e.session.clientCertificate,R.flush(e),e.isConnected=!0,e.connected(e),e.process();};R.handleAlert=function(e,t){var r=t.fragment,n={level:r.getByte(),description:r.getByte()},i;switch(n.description){case R.Alert.Description.close_notify:i="Connection closed.";break;case R.Alert.Description.unexpected_message:i="Unexpected message.";break;case R.Alert.Description.bad_record_mac:i="Bad record MAC.";break;case R.Alert.Description.decryption_failed:i="Decryption failed.";break;case R.Alert.Description.record_overflow:i="Record overflow.";break;case R.Alert.Description.decompression_failure:i="Decompression failed.";break;case R.Alert.Description.handshake_failure:i="Handshake failure.";break;case R.Alert.Description.bad_certificate:i="Bad certificate.";break;case R.Alert.Description.unsupported_certificate:i="Unsupported certificate.";break;case R.Alert.Description.certificate_revoked:i="Certificate revoked.";break;case R.Alert.Description.certificate_expired:i="Certificate expired.";break;case R.Alert.Description.certificate_unknown:i="Certificate unknown.";break;case R.Alert.Description.illegal_parameter:i="Illegal parameter.";break;case R.Alert.Description.unknown_ca:i="Unknown certificate authority.";break;case R.Alert.Description.access_denied:i="Access denied.";break;case R.Alert.Description.decode_error:i="Decode error.";break;case R.Alert.Description.decrypt_error:i="Decrypt error.";break;case R.Alert.Description.export_restriction:i="Export restriction.";break;case R.Alert.Description.protocol_version:i="Unsupported protocol version.";break;case R.Alert.Description.insufficient_security:i="Insufficient security.";break;case R.Alert.Description.internal_error:i="Internal error.";break;case R.Alert.Description.user_canceled:i="User canceled.";break;case R.Alert.Description.no_renegotiation:i="Renegotiation not supported.";break;default:i="Unknown error.";break}if(n.description===R.Alert.Description.close_notify)return e.close();e.error(e,{message:i,send:!1,origin:e.entity===R.ConnectionEnd.client?"server":"client",alert:n}),e.process();};R.handleHandshake=function(e,t){var r=t.fragment,n=r.getByte(),i=r.getInt24();if(i>r.length())return e.fragmented=t,t.fragment=fe.util.createBuffer(),r.read-=4,e.process();e.fragmented=null,r.read-=4;var s=r.bytes(i+4);r.read+=4,n in Fh[e.entity][e.expect]?(e.entity===R.ConnectionEnd.server&&!e.open&&!e.fail&&(e.handshaking=!0,e.session={version:null,extensions:{server_name:{serverNameList:[]}},cipherSuite:null,compressionMethod:null,serverCertificate:null,clientCertificate:null,md5:fe.md.md5.create(),sha1:fe.md.sha1.create()}),n!==R.HandshakeType.hello_request&&n!==R.HandshakeType.certificate_verify&&n!==R.HandshakeType.finished&&(e.session.md5.update(s),e.session.sha1.update(s)),Fh[e.entity][e.expect][n](e,t,i)):R.handleUnexpected(e,t);};R.handleApplicationData=function(e,t){e.data.putBuffer(t.fragment),e.dataReady(e),e.process();};R.handleHeartbeat=function(e,t){var r=t.fragment,n=r.getByte(),i=r.getInt16(),s=r.getBytes(i);if(n===R.HeartbeatMessageType.heartbeat_request){if(e.handshaking||i>s.length)return e.process();R.queue(e,R.createRecord(e,{type:R.ContentType.heartbeat,data:R.createHeartbeat(R.HeartbeatMessageType.heartbeat_response,s)})),R.flush(e);}else if(n===R.HeartbeatMessageType.heartbeat_response){if(s!==e.expectedHeartbeatPayload)return e.process();e.heartbeatReceived&&e.heartbeatReceived(e,fe.util.createBuffer(s));}e.process();};var rre=0,nre=1,JL=2,ire=3,sre=4,eO=5,ore=6,are=7,ure=8,cre=0,lre=1,$v=2,fre=3,jv=4,hre=5,dre=6,T=R.handleUnexpected,tO=R.handleChangeCipherSpec,Rr=R.handleAlert,Qr=R.handleHandshake,rO=R.handleApplicationData,Ir=R.handleHeartbeat,Vv=[];Vv[R.ConnectionEnd.client]=[[T,Rr,Qr,T,Ir],[T,Rr,Qr,T,Ir],[T,Rr,Qr,T,Ir],[T,Rr,Qr,T,Ir],[T,Rr,Qr,T,Ir],[tO,Rr,T,T,Ir],[T,Rr,Qr,T,Ir],[T,Rr,Qr,rO,Ir],[T,Rr,Qr,T,Ir]];Vv[R.ConnectionEnd.server]=[[T,Rr,Qr,T,Ir],[T,Rr,Qr,T,Ir],[T,Rr,Qr,T,Ir],[T,Rr,Qr,T,Ir],[tO,Rr,T,T,Ir],[T,Rr,Qr,T,Ir],[T,Rr,Qr,rO,Ir],[T,Rr,Qr,T,Ir]];var _s=R.handleHelloRequest,pre=R.handleServerHello,nO=R.handleCertificate,ZL=R.handleServerKeyExchange,Mv=R.handleCertificateRequest,Bh=R.handleServerHelloDone,iO=R.handleFinished,Fh=[];Fh[R.ConnectionEnd.client]=[[T,T,pre,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T],[_s,T,T,T,T,T,T,T,T,T,T,nO,ZL,Mv,Bh,T,T,T,T,T,T],[_s,T,T,T,T,T,T,T,T,T,T,T,ZL,Mv,Bh,T,T,T,T,T,T],[_s,T,T,T,T,T,T,T,T,T,T,T,T,Mv,Bh,T,T,T,T,T,T],[_s,T,T,T,T,T,T,T,T,T,T,T,T,T,Bh,T,T,T,T,T,T],[_s,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T],[_s,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,iO],[_s,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T],[_s,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T]];var gre=R.handleClientHello,mre=R.handleClientKeyExchange,yre=R.handleCertificateVerify;Fh[R.ConnectionEnd.server]=[[T,gre,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T],[T,T,T,T,T,T,T,T,T,T,T,nO,T,T,T,T,T,T,T,T,T],[T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,mre,T,T,T,T],[T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,yre,T,T,T,T,T],[T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T],[T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,iO],[T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T],[T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T]];R.generateKeys=function(e,t){var r=Mh,n=t.client_random+t.server_random;e.session.resuming||(t.master_secret=r(t.pre_master_secret,"master secret",n,48).bytes(),t.pre_master_secret=null),n=t.server_random+t.client_random;var i=2*t.mac_key_length+2*t.enc_key_length,s=e.version.major===R.Versions.TLS_1_0.major&&e.version.minor===R.Versions.TLS_1_0.minor;s&&(i+=2*t.fixed_iv_length);var o=r(t.master_secret,"key expansion",n,i),a={client_write_MAC_key:o.getBytes(t.mac_key_length),server_write_MAC_key:o.getBytes(t.mac_key_length),client_write_key:o.getBytes(t.enc_key_length),server_write_key:o.getBytes(t.enc_key_length)};return s&&(a.client_write_IV=o.getBytes(t.fixed_iv_length),a.server_write_IV=o.getBytes(t.fixed_iv_length)),a};R.createConnectionState=function(e){var t=e.entity===R.ConnectionEnd.client,r=function(){var s={sequenceNumber:[0,0],macKey:null,macLength:0,macFunction:null,cipherState:null,cipherFunction:function(o){return !0},compressionState:null,compressFunction:function(o){return !0},updateSequenceNumber:function(){s.sequenceNumber[1]===4294967295?(s.sequenceNumber[1]=0,++s.sequenceNumber[0]):++s.sequenceNumber[1];}};return s},n={read:r(),write:r()};if(n.read.update=function(s,o){return n.read.cipherFunction(o,n.read)?n.read.compressFunction(s,o,n.read)||s.error(s,{message:"Could not decompress record.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.decompression_failure}}):s.error(s,{message:"Could not decrypt record or bad MAC.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.bad_record_mac}}),!s.fail},n.write.update=function(s,o){return n.write.compressFunction(s,o,n.write)?n.write.cipherFunction(o,n.write)||s.error(s,{message:"Could not encrypt record.",send:!1,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.internal_error}}):s.error(s,{message:"Could not compress record.",send:!1,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.internal_error}}),!s.fail},e.session){var i=e.session.sp;switch(e.session.cipherSuite.initSecurityParameters(i),i.keys=R.generateKeys(e,i),n.read.macKey=t?i.keys.server_write_MAC_key:i.keys.client_write_MAC_key,n.write.macKey=t?i.keys.client_write_MAC_key:i.keys.server_write_MAC_key,e.session.cipherSuite.initConnectionState(n,e,i),i.compression_algorithm){case R.CompressionMethod.none:break;case R.CompressionMethod.deflate:n.read.compressFunction=tre,n.write.compressFunction=ere;break;default:throw new Error("Unsupported compression algorithm.")}}return n};R.createRandom=function(){var e=new Date,t=+e+e.getTimezoneOffset()*6e4,r=fe.util.createBuffer();return r.putInt32(t),r.putBytes(fe.random.getBytes(28)),r};R.createRecord=function(e,t){if(!t.data)return null;var r={type:t.type,version:{major:e.version.major,minor:e.version.minor},length:t.data.length(),fragment:t.data};return r};R.createAlert=function(e,t){var r=fe.util.createBuffer();return r.putByte(t.level),r.putByte(t.description),R.createRecord(e,{type:R.ContentType.alert,data:r})};R.createClientHello=function(e){e.session.clientHelloVersion={major:e.version.major,minor:e.version.minor};for(var t=fe.util.createBuffer(),r=0;r<e.cipherSuites.length;++r){var n=e.cipherSuites[r];t.putByte(n.id[0]),t.putByte(n.id[1]);}var i=t.length(),s=fe.util.createBuffer();s.putByte(R.CompressionMethod.none);var o=s.length(),a=fe.util.createBuffer();if(e.virtualHost){var c=fe.util.createBuffer();c.putByte(0),c.putByte(0);var l=fe.util.createBuffer();l.putByte(0),Fn(l,2,fe.util.createBuffer(e.virtualHost));var u=fe.util.createBuffer();Fn(u,2,l),Fn(c,2,u),a.putBuffer(c);}var f=a.length();f>0&&(f+=2);var d=e.session.id,p=d.length+1+2+4+28+2+i+1+o+f,m=fe.util.createBuffer();return m.putByte(R.HandshakeType.client_hello),m.putInt24(p),m.putByte(e.version.major),m.putByte(e.version.minor),m.putBytes(e.session.sp.client_random),Fn(m,1,fe.util.createBuffer(d)),Fn(m,2,t),Fn(m,1,s),f>0&&Fn(m,2,a),m};R.createServerHello=function(e){var t=e.session.id,r=t.length+1+2+4+28+2+1,n=fe.util.createBuffer();return n.putByte(R.HandshakeType.server_hello),n.putInt24(r),n.putByte(e.version.major),n.putByte(e.version.minor),n.putBytes(e.session.sp.server_random),Fn(n,1,fe.util.createBuffer(t)),n.putByte(e.session.cipherSuite.id[0]),n.putByte(e.session.cipherSuite.id[1]),n.putByte(e.session.compressionMethod),n};R.createCertificate=function(e){var t=e.entity===R.ConnectionEnd.client,r=null;if(e.getCertificate){var n;t?n=e.session.certificateRequest:n=e.session.extensions.server_name.serverNameList,r=e.getCertificate(e,n);}var i=fe.util.createBuffer();if(r!==null)try{fe.util.isArray(r)||(r=[r]);for(var s=null,o=0;o<r.length;++o){var a=fe.pem.decode(r[o])[0];if(a.type!=="CERTIFICATE"&&a.type!=="X509 CERTIFICATE"&&a.type!=="TRUSTED CERTIFICATE"){var c=new Error('Could not convert certificate from PEM; PEM header type is not "CERTIFICATE", "X509 CERTIFICATE", or "TRUSTED CERTIFICATE".');throw c.headerType=a.type,c}if(a.procType&&a.procType.type==="ENCRYPTED")throw new Error("Could not convert certificate from PEM; PEM is encrypted.");var l=fe.util.createBuffer(a.body);s===null&&(s=fe.asn1.fromDer(l.bytes(),!1));var u=fe.util.createBuffer();Fn(u,3,l),i.putBuffer(u);}r=fe.pki.certificateFromAsn1(s),t?e.session.clientCertificate=r:e.session.serverCertificate=r;}catch(p){return e.error(e,{message:"Could not send certificate list.",cause:p,send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.bad_certificate}})}var f=3+i.length(),d=fe.util.createBuffer();return d.putByte(R.HandshakeType.certificate),d.putInt24(f),Fn(d,3,i),d};R.createClientKeyExchange=function(e){var t=fe.util.createBuffer();t.putByte(e.session.clientHelloVersion.major),t.putByte(e.session.clientHelloVersion.minor),t.putBytes(fe.random.getBytes(46));var r=e.session.sp;r.pre_master_secret=t.getBytes();var n=e.session.serverCertificate.publicKey;t=n.encrypt(r.pre_master_secret);var i=t.length+2,s=fe.util.createBuffer();return s.putByte(R.HandshakeType.client_key_exchange),s.putInt24(i),s.putInt16(t.length),s.putBytes(t),s};R.createServerKeyExchange=function(e){var r=fe.util.createBuffer();return r};R.getClientSignature=function(e,t){var r=fe.util.createBuffer();r.putBuffer(e.session.md5.digest()),r.putBuffer(e.session.sha1.digest()),r=r.getBytes(),e.getSignature=e.getSignature||function(n,i,s){var o=null;if(n.getPrivateKey)try{o=n.getPrivateKey(n,n.session.clientCertificate),o=fe.pki.privateKeyFromPem(o);}catch(a){n.error(n,{message:"Could not get private key.",cause:a,send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.internal_error}});}o===null?n.error(n,{message:"No private key set.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.internal_error}}):i=o.sign(i,null),s(n,i);},e.getSignature(e,r,t);};R.createCertificateVerify=function(e,t){var r=t.length+2,n=fe.util.createBuffer();return n.putByte(R.HandshakeType.certificate_verify),n.putInt24(r),n.putInt16(t.length),n.putBytes(t),n};R.createCertificateRequest=function(e){var t=fe.util.createBuffer();t.putByte(1);var r=fe.util.createBuffer();for(var n in e.caStore.certs){var i=e.caStore.certs[n],s=fe.pki.distinguishedNameToAsn1(i.subject),o=fe.asn1.toDer(s);r.putInt16(o.length()),r.putBuffer(o);}var a=1+t.length()+2+r.length(),c=fe.util.createBuffer();return c.putByte(R.HandshakeType.certificate_request),c.putInt24(a),Fn(c,1,t),Fn(c,2,r),c};R.createServerHelloDone=function(e){var t=fe.util.createBuffer();return t.putByte(R.HandshakeType.server_hello_done),t.putInt24(0),t};R.createChangeCipherSpec=function(){var e=fe.util.createBuffer();return e.putByte(1),e};R.createFinished=function(e){var t=fe.util.createBuffer();t.putBuffer(e.session.md5.digest()),t.putBuffer(e.session.sha1.digest());var r=e.entity===R.ConnectionEnd.client,n=e.session.sp,i=12,s=Mh,o=r?"client finished":"server finished";t=s(n.master_secret,o,t.getBytes(),i);var a=fe.util.createBuffer();return a.putByte(R.HandshakeType.finished),a.putInt24(t.length()),a.putBuffer(t),a};R.createHeartbeat=function(e,t,r){typeof r>"u"&&(r=t.length);var n=fe.util.createBuffer();n.putByte(e),n.putInt16(r),n.putBytes(t);var i=n.length(),s=Math.max(16,i-r-3);return n.putBytes(fe.random.getBytes(s)),n};R.queue=function(e,t){if(t&&!(t.fragment.length()===0&&(t.type===R.ContentType.handshake||t.type===R.ContentType.alert||t.type===R.ContentType.change_cipher_spec))){if(t.type===R.ContentType.handshake){var r=t.fragment.bytes();e.session.md5.update(r),e.session.sha1.update(r),r=null;}var n;if(t.fragment.length()<=R.MaxFragment)n=[t];else {n=[];for(var i=t.fragment.bytes();i.length>R.MaxFragment;)n.push(R.createRecord(e,{type:t.type,data:fe.util.createBuffer(i.slice(0,R.MaxFragment))})),i=i.slice(R.MaxFragment);i.length>0&&n.push(R.createRecord(e,{type:t.type,data:fe.util.createBuffer(i)}));}for(var s=0;s<n.length&&!e.fail;++s){var o=n[s],a=e.state.current.write;a.update(e,o)&&e.records.push(o);}}};R.flush=function(e){for(var t=0;t<e.records.length;++t){var r=e.records[t];e.tlsData.putByte(r.type),e.tlsData.putByte(r.version.major),e.tlsData.putByte(r.version.minor),e.tlsData.putInt16(r.fragment.length()),e.tlsData.putBuffer(e.records[t].fragment);}return e.records=[],e.tlsDataReady(e)};var Uv=function(e){switch(e){case!0:return !0;case fe.pki.certificateError.bad_certificate:return R.Alert.Description.bad_certificate;case fe.pki.certificateError.unsupported_certificate:return R.Alert.Description.unsupported_certificate;case fe.pki.certificateError.certificate_revoked:return R.Alert.Description.certificate_revoked;case fe.pki.certificateError.certificate_expired:return R.Alert.Description.certificate_expired;case fe.pki.certificateError.certificate_unknown:return R.Alert.Description.certificate_unknown;case fe.pki.certificateError.unknown_ca:return R.Alert.Description.unknown_ca;default:return R.Alert.Description.bad_certificate}},vre=function(e){switch(e){case!0:return !0;case R.Alert.Description.bad_certificate:return fe.pki.certificateError.bad_certificate;case R.Alert.Description.unsupported_certificate:return fe.pki.certificateError.unsupported_certificate;case R.Alert.Description.certificate_revoked:return fe.pki.certificateError.certificate_revoked;case R.Alert.Description.certificate_expired:return fe.pki.certificateError.certificate_expired;case R.Alert.Description.certificate_unknown:return fe.pki.certificateError.certificate_unknown;case R.Alert.Description.unknown_ca:return fe.pki.certificateError.unknown_ca;default:return fe.pki.certificateError.bad_certificate}};R.verifyCertificateChain=function(e,t){try{var r={};for(var n in e.verifyOptions)r[n]=e.verifyOptions[n];r.verify=function(s,o,a){var l=e.verify(e,s,o,a);if(l!==!0){if(typeof l=="object"&&!fe.util.isArray(l)){var u=new Error("The application rejected the certificate.");throw u.send=!0,u.alert={level:R.Alert.Level.fatal,description:R.Alert.Description.bad_certificate},l.message&&(u.message=l.message),l.alert&&(u.alert.description=l.alert),u}l!==s&&(l=vre(l));}return l},fe.pki.verifyCertificateChain(e.caStore,t,r);}catch(s){var i=s;(typeof i!="object"||fe.util.isArray(i))&&(i={send:!0,alert:{level:R.Alert.Level.fatal,description:Uv(s)}}),"send"in i||(i.send=!0),"alert"in i||(i.alert={level:R.Alert.Level.fatal,description:Uv(i.error)}),e.error(e,i);}return !e.fail};R.createSessionCache=function(e,t){var r=null;if(e&&e.getSession&&e.setSession&&e.order)r=e;else {r={},r.cache=e||{},r.capacity=Math.max(t||100,1),r.order=[];for(var n in e)r.order.length<=t?r.order.push(n):delete e[n];r.getSession=function(i){var s=null,o=null;if(i?o=fe.util.bytesToHex(i):r.order.length>0&&(o=r.order[0]),o!==null&&o in r.cache){s=r.cache[o],delete r.cache[o];for(var a in r.order)if(r.order[a]===o){r.order.splice(a,1);break}}return s},r.setSession=function(i,s){if(r.order.length===r.capacity){var o=r.order.shift();delete r.cache[o];}var o=fe.util.bytesToHex(i);r.order.push(o),r.cache[o]=s;};}return r};R.createConnection=function(e){var t=null;e.caStore?fe.util.isArray(e.caStore)?t=fe.pki.createCaStore(e.caStore):t=e.caStore:t=fe.pki.createCaStore();var r=e.cipherSuites||null;if(r===null){r=[];for(var n in R.CipherSuites)r.push(R.CipherSuites[n]);}var i=e.server?R.ConnectionEnd.server:R.ConnectionEnd.client,s=e.sessionCache?R.createSessionCache(e.sessionCache):null,o={version:{major:R.Version.major,minor:R.Version.minor},entity:i,sessionId:e.sessionId,caStore:t,sessionCache:s,cipherSuites:r,connected:e.connected,virtualHost:e.virtualHost||null,verifyClient:e.verifyClient||!1,verify:e.verify||function(u,f,d,p){return f},verifyOptions:e.verifyOptions||{},getCertificate:e.getCertificate||null,getPrivateKey:e.getPrivateKey||null,getSignature:e.getSignature||null,input:fe.util.createBuffer(),tlsData:fe.util.createBuffer(),data:fe.util.createBuffer(),tlsDataReady:e.tlsDataReady,dataReady:e.dataReady,heartbeatReceived:e.heartbeatReceived,closed:e.closed,error:function(u,f){f.origin=f.origin||(u.entity===R.ConnectionEnd.client?"client":"server"),f.send&&(R.queue(u,R.createAlert(u,f.alert)),R.flush(u));var d=f.fatal!==!1;d&&(u.fail=!0),e.error(u,f),d&&u.close(!1);},deflate:e.deflate||null,inflate:e.inflate||null};o.reset=function(u){o.version={major:R.Version.major,minor:R.Version.minor},o.record=null,o.session=null,o.peerCertificate=null,o.state={pending:null,current:null},o.expect=o.entity===R.ConnectionEnd.client?rre:cre,o.fragmented=null,o.records=[],o.open=!1,o.handshakes=0,o.handshaking=!1,o.isConnected=!1,o.fail=!(u||typeof u>"u"),o.input.clear(),o.tlsData.clear(),o.data.clear(),o.state.current=R.createConnectionState(o);},o.reset();var a=function(u,f){var d=f.type-R.ContentType.change_cipher_spec,p=Vv[u.entity][u.expect];d in p?p[d](u,f):R.handleUnexpected(u,f);},c=function(u){var f=0,d=u.input,p=d.length();if(p<5)f=5-p;else {u.record={type:d.getByte(),version:{major:d.getByte(),minor:d.getByte()},length:d.getInt16(),fragment:fe.util.createBuffer(),ready:!1};var m=u.record.version.major===u.version.major;m&&u.session&&u.session.version&&(m=u.record.version.minor===u.version.minor),m||u.error(u,{message:"Incompatible TLS version.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.protocol_version}});}return f},l=function(u){var f=0,d=u.input,p=d.length();if(p<u.record.length)f=u.record.length-p;else {u.record.fragment.putBytes(d.getBytes(u.record.length)),d.compact();var m=u.state.current.read;m.update(u,u.record)&&(u.fragmented!==null&&(u.fragmented.type===u.record.type?(u.fragmented.fragment.putBuffer(u.record.fragment),u.record=u.fragmented):u.error(u,{message:"Invalid fragmented record.",send:!0,alert:{level:R.Alert.Level.fatal,description:R.Alert.Description.unexpected_message}})),u.record.ready=!0);}return f};return o.handshake=function(u){if(o.entity!==R.ConnectionEnd.client)o.error(o,{message:"Cannot initiate handshake as a server.",fatal:!1});else if(o.handshaking)o.error(o,{message:"Handshake already in progress.",fatal:!1});else {o.fail&&!o.open&&o.handshakes===0&&(o.fail=!1),o.handshaking=!0,u=u||"";var f=null;u.length>0&&(o.sessionCache&&(f=o.sessionCache.getSession(u)),f===null&&(u="")),u.length===0&&o.sessionCache&&(f=o.sessionCache.getSession(),f!==null&&(u=f.id)),o.session={id:u,version:null,cipherSuite:null,compressionMethod:null,serverCertificate:null,certificateRequest:null,clientCertificate:null,sp:{},md5:fe.md.md5.create(),sha1:fe.md.sha1.create()},f&&(o.version=f.version,o.session.sp=f.sp),o.session.sp.client_random=R.createRandom().getBytes(),o.open=!0,R.queue(o,R.createRecord(o,{type:R.ContentType.handshake,data:R.createClientHello(o)})),R.flush(o);}},o.process=function(u){var f=0;return u&&o.input.putBytes(u),o.fail||(o.record!==null&&o.record.ready&&o.record.fragment.isEmpty()&&(o.record=null),o.record===null&&(f=c(o)),!o.fail&&o.record!==null&&!o.record.ready&&(f=l(o)),!o.fail&&o.record!==null&&o.record.ready&&a(o,o.record)),f},o.prepare=function(u){return R.queue(o,R.createRecord(o,{type:R.ContentType.application_data,data:fe.util.createBuffer(u)})),R.flush(o)},o.prepareHeartbeatRequest=function(u,f){return u instanceof fe.util.ByteBuffer&&(u=u.bytes()),typeof f>"u"&&(f=u.length),o.expectedHeartbeatPayload=u,R.queue(o,R.createRecord(o,{type:R.ContentType.heartbeat,data:R.createHeartbeat(R.HeartbeatMessageType.heartbeat_request,u,f)})),R.flush(o)},o.close=function(u){if(!o.fail&&o.sessionCache&&o.session){var f={id:o.session.id,version:o.session.version,sp:o.session.sp};f.sp.keys=null,o.sessionCache.setSession(f.id,f);}o.open&&(o.open=!1,o.input.clear(),(o.isConnected||o.handshaking)&&(o.isConnected=o.handshaking=!1,R.queue(o,R.createAlert(o,{level:R.Alert.Level.warning,description:R.Alert.Description.close_notify})),R.flush(o)),o.closed(o)),o.reset(u);},o};sO.exports=fe.tls=fe.tls||{};for(qh in R)typeof R[qh]!="function"&&(fe.tls[qh]=R[qh]);var qh;fe.tls.prf_tls1=Mh;fe.tls.hmac_sha1=Zte;fe.tls.createSessionCache=R.createSessionCache;fe.tls.createConnection=R.createConnection;});var uO=A((Ghe,aO)=>{var Ts=rt();Ss();Hv();var Mn=aO.exports=Ts.tls;Mn.CipherSuites.TLS_RSA_WITH_AES_128_CBC_SHA={id:[0,47],name:"TLS_RSA_WITH_AES_128_CBC_SHA",initSecurityParameters:function(e){e.bulk_cipher_algorithm=Mn.BulkCipherAlgorithm.aes,e.cipher_type=Mn.CipherType.block,e.enc_key_length=16,e.block_length=16,e.fixed_iv_length=16,e.record_iv_length=16,e.mac_algorithm=Mn.MACAlgorithm.hmac_sha1,e.mac_length=20,e.mac_key_length=20;},initConnectionState:oO};Mn.CipherSuites.TLS_RSA_WITH_AES_256_CBC_SHA={id:[0,53],name:"TLS_RSA_WITH_AES_256_CBC_SHA",initSecurityParameters:function(e){e.bulk_cipher_algorithm=Mn.BulkCipherAlgorithm.aes,e.cipher_type=Mn.CipherType.block,e.enc_key_length=32,e.block_length=16,e.fixed_iv_length=16,e.record_iv_length=16,e.mac_algorithm=Mn.MACAlgorithm.hmac_sha1,e.mac_length=20,e.mac_key_length=20;},initConnectionState:oO};function oO(e,t,r){var n=t.entity===Ts.tls.ConnectionEnd.client;e.read.cipherState={init:!1,cipher:Ts.cipher.createDecipher("AES-CBC",n?r.keys.server_write_key:r.keys.client_write_key),iv:n?r.keys.server_write_IV:r.keys.client_write_IV},e.write.cipherState={init:!1,cipher:Ts.cipher.createCipher("AES-CBC",n?r.keys.client_write_key:r.keys.server_write_key),iv:n?r.keys.client_write_IV:r.keys.server_write_IV},e.read.cipherFunction=Ere,e.write.cipherFunction=Sre,e.read.macLength=e.write.macLength=r.mac_length,e.read.macFunction=e.write.macFunction=Mn.hmac_sha1;}function Sre(e,t){var r=!1,n=t.macFunction(t.macKey,t.sequenceNumber,e);e.fragment.putBytes(n),t.updateSequenceNumber();var i;e.version.minor===Mn.Versions.TLS_1_0.minor?i=t.cipherState.init?null:t.cipherState.iv:i=Ts.random.getBytesSync(16),t.cipherState.init=!0;var s=t.cipherState.cipher;return s.start({iv:i}),e.version.minor>=Mn.Versions.TLS_1_1.minor&&s.output.putBytes(i),s.update(e.fragment),s.finish(bre)&&(e.fragment=s.output,e.length=e.fragment.length(),r=!0),r}function bre(e,t,r){if(!r){var n=e-t.length()%e;t.fillWithByte(n-1,n);}return !0}function Cre(e,t,r){var n=!0;if(r){for(var i=t.length(),s=t.last(),o=i-1-s;o<i-1;++o)n=n&&t.at(o)==s;n&&t.truncate(s+1);}return n}function Ere(e,t){var r=!1,n;e.version.minor===Mn.Versions.TLS_1_0.minor?n=t.cipherState.init?null:t.cipherState.iv:n=e.fragment.getBytes(16),t.cipherState.init=!0;var i=t.cipherState.cipher;i.start({iv:n}),i.update(e.fragment),r=i.finish(Cre);var s=t.macLength,o=Ts.random.getBytesSync(s),a=i.output.length();a>=s?(e.fragment=i.output.getBytes(a-s),o=i.output.getBytes(s)):e.fragment=i.output.getBytes(),e.fragment=Ts.util.createBuffer(e.fragment),e.length=e.fragment.length();var c=t.macFunction(t.macKey,t.sequenceNumber,e);return t.updateSequenceNumber(),r=xre(t.macKey,o,c)&&r,r}function xre(e,t,r){var n=Ts.hmac.create();return n.start("SHA1",e),n.update(t),t=n.digest().getBytes(),n.start(null,null),n.update(r),r=n.digest().getBytes(),t===r}});var zv=A((Yhe,hO)=>{var Vt=rt();Si();vt();var Ec=hO.exports=Vt.sha512=Vt.sha512||{};Vt.md.sha512=Vt.md.algorithms.sha512=Ec;var lO=Vt.sha384=Vt.sha512.sha384=Vt.sha512.sha384||{};lO.create=function(){return Ec.create("SHA-384")};Vt.md.sha384=Vt.md.algorithms.sha384=lO;Vt.sha512.sha256=Vt.sha512.sha256||{create:function(){return Ec.create("SHA-512/256")}};Vt.md["sha512/256"]=Vt.md.algorithms["sha512/256"]=Vt.sha512.sha256;Vt.sha512.sha224=Vt.sha512.sha224||{create:function(){return Ec.create("SHA-512/224")}};Vt.md["sha512/224"]=Vt.md.algorithms["sha512/224"]=Vt.sha512.sha224;Ec.create=function(e){if(fO||wre(),typeof e>"u"&&(e="SHA-512"),!(e in bo))throw new Error("Invalid SHA-512 algorithm: "+e);for(var t=bo[e],r=null,n=Vt.util.createBuffer(),i=new Array(80),s=0;s<80;++s)i[s]=new Array(2);var o=64;switch(e){case"SHA-384":o=48;break;case"SHA-512/256":o=32;break;case"SHA-512/224":o=28;break}var a={algorithm:e.replace("-","").toLowerCase(),blockLength:128,digestLength:o,messageLength:0,fullMessageLength:null,messageLengthSize:16};return a.start=function(){a.messageLength=0,a.fullMessageLength=a.messageLength128=[];for(var c=a.messageLengthSize/4,l=0;l<c;++l)a.fullMessageLength.push(0);n=Vt.util.createBuffer(),r=new Array(t.length);for(var l=0;l<t.length;++l)r[l]=t[l].slice(0);return a},a.start(),a.update=function(c,l){l==="utf8"&&(c=Vt.util.encodeUtf8(c));var u=c.length;a.messageLength+=u,u=[u/4294967296>>>0,u>>>0];for(var f=a.fullMessageLength.length-1;f>=0;--f)a.fullMessageLength[f]+=u[1],u[1]=u[0]+(a.fullMessageLength[f]/4294967296>>>0),a.fullMessageLength[f]=a.fullMessageLength[f]>>>0,u[0]=u[1]/4294967296>>>0;return n.putBytes(c),cO(r,i,n),(n.read>2048||n.length()===0)&&n.compact(),a},a.digest=function(){var c=Vt.util.createBuffer();c.putBytes(n.bytes());var l=a.fullMessageLength[a.fullMessageLength.length-1]+a.messageLengthSize,u=l&a.blockLength-1;c.putBytes(Wv.substr(0,a.blockLength-u));for(var f,d,p=a.fullMessageLength[0]*8,m=0;m<a.fullMessageLength.length-1;++m)f=a.fullMessageLength[m+1]*8,d=f/4294967296>>>0,p+=d,c.putInt32(p>>>0),p=f>>>0;c.putInt32(p);for(var S=new Array(r.length),m=0;m<r.length;++m)S[m]=r[m].slice(0);cO(S,i,c);var x=Vt.util.createBuffer(),I;e==="SHA-512"?I=S.length:e==="SHA-384"?I=S.length-2:I=S.length-4;for(var m=0;m<I;++m)x.putInt32(S[m][0]),(m!==I-1||e!=="SHA-512/224")&&x.putInt32(S[m][1]);return x},a};var Wv=null,fO=!1,Kv=null,bo=null;function wre(){Wv="\x80",Wv+=Vt.util.fillString("\0",128),Kv=[[1116352408,3609767458],[1899447441,602891725],[3049323471,3964484399],[3921009573,2173295548],[961987163,4081628472],[1508970993,3053834265],[2453635748,2937671579],[2870763221,3664609560],[3624381080,2734883394],[310598401,1164996542],[607225278,1323610764],[1426881987,3590304994],[1925078388,4068182383],[2162078206,991336113],[2614888103,633803317],[3248222580,3479774868],[3835390401,2666613458],[4022224774,944711139],[264347078,2341262773],[604807628,2007800933],[770255983,1495990901],[1249150122,1856431235],[1555081692,3175218132],[1996064986,2198950837],[2554220882,3999719339],[2821834349,766784016],[2952996808,2566594879],[3210313671,3203337956],[3336571891,1034457026],[3584528711,2466948901],[113926993,3758326383],[338241895,168717936],[666307205,1188179964],[773529912,1546045734],[1294757372,1522805485],[1396182291,2643833823],[1695183700,2343527390],[1986661051,1014477480],[2177026350,1206759142],[2456956037,344077627],[2730485921,1290863460],[2820302411,3158454273],[3259730800,3505952657],[3345764771,106217008],[3516065817,3606008344],[3600352804,1432725776],[4094571909,1467031594],[275423344,851169720],[430227734,3100823752],[506948616,1363258195],[659060556,3750685593],[883997877,3785050280],[958139571,3318307427],[1322822218,3812723403],[1537002063,2003034995],[1747873779,3602036899],[1955562222,1575990012],[2024104815,1125592928],[2227730452,2716904306],[2361852424,442776044],[2428436474,593698344],[2756734187,3733110249],[3204031479,2999351573],[3329325298,3815920427],[3391569614,3928383900],[3515267271,566280711],[3940187606,3454069534],[4118630271,4000239992],[116418474,1914138554],[174292421,2731055270],[289380356,3203993006],[460393269,320620315],[685471733,587496836],[852142971,1086792851],[1017036298,365543100],[1126000580,2618297676],[1288033470,3409855158],[1501505948,4234509866],[1607167915,987167468],[1816402316,1246189591]],bo={},bo["SHA-512"]=[[1779033703,4089235720],[3144134277,2227873595],[1013904242,4271175723],[2773480762,1595750129],[1359893119,2917565137],[2600822924,725511199],[528734635,4215389547],[1541459225,327033209]],bo["SHA-384"]=[[3418070365,3238371032],[1654270250,914150663],[2438529370,812702999],[355462360,4144912697],[1731405415,4290775857],[2394180231,1750603025],[3675008525,1694076839],[1203062813,3204075428]],bo["SHA-512/256"]=[[573645204,4230739756],[2673172387,3360449730],[596883563,1867755857],[2520282905,1497426621],[2519219938,2827943907],[3193839141,1401305490],[721525244,746961066],[246885852,2177182882]],bo["SHA-512/224"]=[[2352822216,424955298],[1944164710,2312950998],[502970286,855612546],[1738396948,1479516111],[258812777,2077511080],[2011393907,79989058],[1067287976,1780299464],[286451373,2446758561]],fO=!0;}function cO(e,t,r){for(var n,i,s,o,a,c,l,u,f,d,p,m,S,x,I,v,b,D,L,j,J,K,G,ee,M,ae,me,Le,H,W,se,Te,Fe,ze,He,ct=r.length();ct>=128;){for(H=0;H<16;++H)t[H][0]=r.getInt32()>>>0,t[H][1]=r.getInt32()>>>0;for(;H<80;++H)Te=t[H-2],W=Te[0],se=Te[1],n=((W>>>19|se<<13)^(se>>>29|W<<3)^W>>>6)>>>0,i=((W<<13|se>>>19)^(se<<3|W>>>29)^(W<<26|se>>>6))>>>0,ze=t[H-15],W=ze[0],se=ze[1],s=((W>>>1|se<<31)^(W>>>8|se<<24)^W>>>7)>>>0,o=((W<<31|se>>>1)^(W<<24|se>>>8)^(W<<25|se>>>7))>>>0,Fe=t[H-7],He=t[H-16],se=i+Fe[1]+o+He[1],t[H][0]=n+Fe[0]+s+He[0]+(se/4294967296>>>0)>>>0,t[H][1]=se>>>0;for(S=e[0][0],x=e[0][1],I=e[1][0],v=e[1][1],b=e[2][0],D=e[2][1],L=e[3][0],j=e[3][1],J=e[4][0],K=e[4][1],G=e[5][0],ee=e[5][1],M=e[6][0],ae=e[6][1],me=e[7][0],Le=e[7][1],H=0;H<80;++H)l=((J>>>14|K<<18)^(J>>>18|K<<14)^(K>>>9|J<<23))>>>0,u=((J<<18|K>>>14)^(J<<14|K>>>18)^(K<<23|J>>>9))>>>0,f=(M^J&(G^M))>>>0,d=(ae^K&(ee^ae))>>>0,a=((S>>>28|x<<4)^(x>>>2|S<<30)^(x>>>7|S<<25))>>>0,c=((S<<4|x>>>28)^(x<<30|S>>>2)^(x<<25|S>>>7))>>>0,p=(S&I|b&(S^I))>>>0,m=(x&v|D&(x^v))>>>0,se=Le+u+d+Kv[H][1]+t[H][1],n=me+l+f+Kv[H][0]+t[H][0]+(se/4294967296>>>0)>>>0,i=se>>>0,se=c+m,s=a+p+(se/4294967296>>>0)>>>0,o=se>>>0,me=M,Le=ae,M=G,ae=ee,G=J,ee=K,se=j+i,J=L+n+(se/4294967296>>>0)>>>0,K=se>>>0,L=b,j=D,b=I,D=v,I=S,v=x,se=i+o,S=n+s+(se/4294967296>>>0)>>>0,x=se>>>0;se=e[0][1]+x,e[0][0]=e[0][0]+S+(se/4294967296>>>0)>>>0,e[0][1]=se>>>0,se=e[1][1]+v,e[1][0]=e[1][0]+I+(se/4294967296>>>0)>>>0,e[1][1]=se>>>0,se=e[2][1]+D,e[2][0]=e[2][0]+b+(se/4294967296>>>0)>>>0,e[2][1]=se>>>0,se=e[3][1]+j,e[3][0]=e[3][0]+L+(se/4294967296>>>0)>>>0,e[3][1]=se>>>0,se=e[4][1]+K,e[4][0]=e[4][0]+J+(se/4294967296>>>0)>>>0,e[4][1]=se>>>0,se=e[5][1]+ee,e[5][0]=e[5][0]+G+(se/4294967296>>>0)>>>0,e[5][1]=se>>>0,se=e[6][1]+ae,e[6][0]=e[6][0]+M+(se/4294967296>>>0)>>>0,e[6][1]=se>>>0,se=e[7][1]+Le,e[7][0]=e[7][0]+me+(se/4294967296>>>0)>>>0,e[7][1]=se>>>0,ct-=128;}}});var dO=A(Gv=>{var _re=rt();ni();var Cr=_re.asn1;Gv.privateKeyValidator={name:"PrivateKeyInfo",tagClass:Cr.Class.UNIVERSAL,type:Cr.Type.SEQUENCE,constructed:!0,value:[{name:"PrivateKeyInfo.version",tagClass:Cr.Class.UNIVERSAL,type:Cr.Type.INTEGER,constructed:!1,capture:"privateKeyVersion"},{name:"PrivateKeyInfo.privateKeyAlgorithm",tagClass:Cr.Class.UNIVERSAL,type:Cr.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:Cr.Class.UNIVERSAL,type:Cr.Type.OID,constructed:!1,capture:"privateKeyOid"}]},{name:"PrivateKeyInfo",tagClass:Cr.Class.UNIVERSAL,type:Cr.Type.OCTETSTRING,constructed:!1,capture:"privateKey"}]};Gv.publicKeyValidator={name:"SubjectPublicKeyInfo",tagClass:Cr.Class.UNIVERSAL,type:Cr.Type.SEQUENCE,constructed:!0,captureAsn1:"subjectPublicKeyInfo",value:[{name:"SubjectPublicKeyInfo.AlgorithmIdentifier",tagClass:Cr.Class.UNIVERSAL,type:Cr.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:Cr.Class.UNIVERSAL,type:Cr.Type.OID,constructed:!1,capture:"publicKeyOid"}]},{tagClass:Cr.Class.UNIVERSAL,type:Cr.Type.BITSTRING,constructed:!1,composed:!0,captureBitStringValue:"ed25519PublicKey"}]};});var TO=A((Xhe,_O)=>{var Dr=rt();vc();Ln();zv();vt();var SO=dO(),Tre=SO.publicKeyValidator,Are=SO.privateKeyValidator;var Xv=Dr.util.ByteBuffer,sn=typeof Buffer>"u"?Uint8Array:Buffer;Dr.pki=Dr.pki||{};_O.exports=Dr.pki.ed25519=Dr.ed25519=Dr.ed25519||{};var ut=Dr.ed25519;ut.constants={};ut.constants.PUBLIC_KEY_BYTE_LENGTH=32;ut.constants.PRIVATE_KEY_BYTE_LENGTH=64;ut.constants.SEED_BYTE_LENGTH=32;ut.constants.SIGN_BYTE_LENGTH=64;ut.constants.HASH_BYTE_LENGTH=64;ut.generateKeyPair=function(e){e=e||{};var t=e.seed;if(t===void 0)t=Dr.random.getBytesSync(ut.constants.SEED_BYTE_LENGTH);else if(typeof t=="string"){if(t.length!==ut.constants.SEED_BYTE_LENGTH)throw new TypeError('"seed" must be '+ut.constants.SEED_BYTE_LENGTH+" bytes in length.")}else if(!(t instanceof Uint8Array))throw new TypeError('"seed" must be a node.js Buffer, Uint8Array, or a binary string.');t=Yi({message:t,encoding:"binary"});for(var r=new sn(ut.constants.PUBLIC_KEY_BYTE_LENGTH),n=new sn(ut.constants.PRIVATE_KEY_BYTE_LENGTH),i=0;i<32;++i)n[i]=t[i];return Pre(r,n),{publicKey:r,privateKey:n}};ut.privateKeyFromAsn1=function(e){var t={},r=[],n=Dr.asn1.validate(e,Are,t,r);if(!n){var i=new Error("Invalid Key.");throw i.errors=r,i}var s=Dr.asn1.derToOid(t.privateKeyOid),o=Dr.oids.EdDSA25519;if(s!==o)throw new Error('Invalid OID "'+s+'"; OID must be "'+o+'".');var a=t.privateKey,c=Yi({message:Dr.asn1.fromDer(a).value,encoding:"binary"});return {privateKeyBytes:c}};ut.publicKeyFromAsn1=function(e){var t={},r=[],n=Dr.asn1.validate(e,Tre,t,r);if(!n){var i=new Error("Invalid Key.");throw i.errors=r,i}var s=Dr.asn1.derToOid(t.publicKeyOid),o=Dr.oids.EdDSA25519;if(s!==o)throw new Error('Invalid OID "'+s+'"; OID must be "'+o+'".');var a=t.ed25519PublicKey;if(a.length!==ut.constants.PUBLIC_KEY_BYTE_LENGTH)throw new Error("Key length is invalid.");return Yi({message:a,encoding:"binary"})};ut.publicKeyFromPrivateKey=function(e){e=e||{};var t=Yi({message:e.privateKey,encoding:"binary"});if(t.length!==ut.constants.PRIVATE_KEY_BYTE_LENGTH)throw new TypeError('"options.privateKey" must have a byte length of '+ut.constants.PRIVATE_KEY_BYTE_LENGTH);for(var r=new sn(ut.constants.PUBLIC_KEY_BYTE_LENGTH),n=0;n<r.length;++n)r[n]=t[32+n];return r};ut.sign=function(e){e=e||{};var t=Yi(e),r=Yi({message:e.privateKey,encoding:"binary"});if(r.length===ut.constants.SEED_BYTE_LENGTH){var n=ut.generateKeyPair({seed:r});r=n.privateKey;}else if(r.length!==ut.constants.PRIVATE_KEY_BYTE_LENGTH)throw new TypeError('"options.privateKey" must have a byte length of '+ut.constants.SEED_BYTE_LENGTH+" or "+ut.constants.PRIVATE_KEY_BYTE_LENGTH);var i=new sn(ut.constants.SIGN_BYTE_LENGTH+t.length);kre(i,t,t.length,r);for(var s=new sn(ut.constants.SIGN_BYTE_LENGTH),o=0;o<s.length;++o)s[o]=i[o];return s};ut.verify=function(e){e=e||{};var t=Yi(e);if(e.signature===void 0)throw new TypeError('"options.signature" must be a node.js Buffer, a Uint8Array, a forge ByteBuffer, or a binary string.');var r=Yi({message:e.signature,encoding:"binary"});if(r.length!==ut.constants.SIGN_BYTE_LENGTH)throw new TypeError('"options.signature" must have a byte length of '+ut.constants.SIGN_BYTE_LENGTH);var n=Yi({message:e.publicKey,encoding:"binary"});if(n.length!==ut.constants.PUBLIC_KEY_BYTE_LENGTH)throw new TypeError('"options.publicKey" must have a byte length of '+ut.constants.PUBLIC_KEY_BYTE_LENGTH);var i=new sn(ut.constants.SIGN_BYTE_LENGTH+t.length),s=new sn(ut.constants.SIGN_BYTE_LENGTH+t.length),o;for(o=0;o<ut.constants.SIGN_BYTE_LENGTH;++o)i[o]=r[o];for(o=0;o<t.length;++o)i[o+ut.constants.SIGN_BYTE_LENGTH]=t[o];return Nre(s,i,i.length,n)>=0};function Yi(e){var t=e.message;if(t instanceof Uint8Array||t instanceof sn)return t;var r=e.encoding;if(t===void 0)if(e.md)t=e.md.digest().getBytes(),r="binary";else throw new TypeError('"options.message" or "options.md" not specified.');if(typeof t=="string"&&!r)throw new TypeError('"options.encoding" must be "binary" or "utf8".');if(typeof t=="string"){if(typeof Buffer<"u")return Buffer.from(t,r);t=new Xv(t,r);}else if(!(t instanceof Xv))throw new TypeError('"options.message" must be a node.js Buffer, a Uint8Array, a forge ByteBuffer, or a string with "options.encoding" specifying its encoding.');for(var n=new sn(t.length()),i=0;i<n.length;++i)n[i]=t.at(i);return n}var Jv=$e(),Uh=$e([1]),Rre=$e([30883,4953,19914,30187,55467,16705,2637,112,59544,30585,16505,36039,65139,11119,27886,20995]),Ire=$e([61785,9906,39828,60374,45398,33411,5274,224,53552,61171,33010,6542,64743,22239,55772,9222]),gO=$e([54554,36645,11616,51542,42930,38181,51040,26924,56412,64982,57905,49316,21502,52590,14035,8553]),mO=$e([26200,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214]),Yv=new Float64Array([237,211,245,92,26,99,18,88,214,156,247,162,222,249,222,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16]),Dre=$e([41136,18958,6951,50414,58488,44335,6150,12099,55207,15867,153,11085,57099,20417,9344,11139]);function xc(e,t){var r=Dr.md.sha512.create(),n=new Xv(e);r.update(n.getBytes(t),"binary");var i=r.digest().getBytes();if(typeof Buffer<"u")return Buffer.from(i,"binary");for(var s=new sn(ut.constants.HASH_BYTE_LENGTH),o=0;o<64;++o)s[o]=i.charCodeAt(o);return s}function Pre(e,t){var r=[$e(),$e(),$e(),$e()],n,i=xc(t,32);for(i[0]&=248,i[31]&=127,i[31]|=64,rS(r,i),tS(e,r),n=0;n<32;++n)t[n+32]=e[n];return 0}function kre(e,t,r,n){var i,s,o=new Float64Array(64),a=[$e(),$e(),$e(),$e()],c=xc(n,32);c[0]&=248,c[31]&=127,c[31]|=64;var l=r+64;for(i=0;i<r;++i)e[64+i]=t[i];for(i=0;i<32;++i)e[32+i]=c[32+i];var u=xc(e.subarray(32),r+32);for(Zv(u),rS(a,u),tS(e,a),i=32;i<64;++i)e[i]=n[i];var f=xc(e,r+64);for(Zv(f),i=32;i<64;++i)o[i]=0;for(i=0;i<32;++i)o[i]=u[i];for(i=0;i<32;++i)for(s=0;s<32;s++)o[i+s]+=f[i]*c[s];return bO(e.subarray(32),o),l}function Nre(e,t,r,n){var i,s,o=new sn(32),a=[$e(),$e(),$e(),$e()],c=[$e(),$e(),$e(),$e()];if(s=-1,r<64||Lre(c,n))return -1;for(i=0;i<r;++i)e[i]=t[i];for(i=0;i<32;++i)e[i+32]=n[i];var l=xc(e,r);if(Zv(l),xO(a,c,l),rS(c,t.subarray(32)),eS(a,c),tS(o,a),r-=64,CO(t,0,o,0)){for(i=0;i<r;++i)e[i]=0;return -1}for(i=0;i<r;++i)e[i]=t[i+64];return s=r,s}function bO(e,t){var r,n,i,s;for(n=63;n>=32;--n){for(r=0,i=n-32,s=n-12;i<s;++i)t[i]+=r-16*t[n]*Yv[i-(n-32)],r=t[i]+128>>8,t[i]-=r*256;t[i]+=r,t[n]=0;}for(r=0,i=0;i<32;++i)t[i]+=r-(t[31]>>4)*Yv[i],r=t[i]>>8,t[i]&=255;for(i=0;i<32;++i)t[i]-=r*Yv[i];for(n=0;n<32;++n)t[n+1]+=t[n]>>8,e[n]=t[n]&255;}function Zv(e){for(var t=new Float64Array(64),r=0;r<64;++r)t[r]=e[r],e[r]=0;bO(e,t);}function eS(e,t){var r=$e(),n=$e(),i=$e(),s=$e(),o=$e(),a=$e(),c=$e(),l=$e(),u=$e();ka(r,e[1],e[0]),ka(u,t[1],t[0]),Ot(r,r,u),Pa(n,e[0],e[1]),Pa(u,t[0],t[1]),Ot(n,n,u),Ot(i,e[3],t[3]),Ot(i,i,Ire),Ot(s,e[2],t[2]),Pa(s,s,s),ka(o,n,r),ka(a,s,i),Pa(c,s,i),Pa(l,n,r),Ot(e[0],o,a),Ot(e[1],l,c),Ot(e[2],c,a),Ot(e[3],o,l);}function yO(e,t,r){for(var n=0;n<4;++n)wO(e[n],t[n],r);}function tS(e,t){var r=$e(),n=$e(),i=$e();Fre(i,t[2]),Ot(r,t[0],i),Ot(n,t[1],i),$h(e,n),e[31]^=EO(r)<<7;}function $h(e,t){var r,n,i,s=$e(),o=$e();for(r=0;r<16;++r)o[r]=t[r];for(Qv(o),Qv(o),Qv(o),n=0;n<2;++n){for(s[0]=o[0]-65517,r=1;r<15;++r)s[r]=o[r]-65535-(s[r-1]>>16&1),s[r-1]&=65535;s[15]=o[15]-32767-(s[14]>>16&1),i=s[15]>>16&1,s[14]&=65535,wO(o,s,1-i);}for(r=0;r<16;r++)e[2*r]=o[r]&255,e[2*r+1]=o[r]>>8;}function Lre(e,t){var r=$e(),n=$e(),i=$e(),s=$e(),o=$e(),a=$e(),c=$e();return As(e[2],Uh),Ore(e[1],t),Co(i,e[1]),Ot(s,i,Rre),ka(i,i,e[2]),Pa(s,e[2],s),Co(o,s),Co(a,o),Ot(c,a,o),Ot(r,c,i),Ot(r,r,s),Bre(r,r),Ot(r,r,i),Ot(r,r,s),Ot(r,r,s),Ot(e[0],r,s),Co(n,e[0]),Ot(n,n,s),vO(n,i)&&Ot(e[0],e[0],Dre),Co(n,e[0]),Ot(n,n,s),vO(n,i)?-1:(EO(e[0])===t[31]>>7&&ka(e[0],Jv,e[0]),Ot(e[3],e[0],e[1]),0)}function Ore(e,t){var r;for(r=0;r<16;++r)e[r]=t[2*r]+(t[2*r+1]<<8);e[15]&=32767;}function Bre(e,t){var r=$e(),n;for(n=0;n<16;++n)r[n]=t[n];for(n=250;n>=0;--n)Co(r,r),n!==1&&Ot(r,r,t);for(n=0;n<16;++n)e[n]=r[n];}function vO(e,t){var r=new sn(32),n=new sn(32);return $h(r,e),$h(n,t),CO(r,0,n,0)}function CO(e,t,r,n){return qre(e,t,r,n,32)}function qre(e,t,r,n,i){var s,o=0;for(s=0;s<i;++s)o|=e[t+s]^r[n+s];return (1&o-1>>>8)-1}function EO(e){var t=new sn(32);return $h(t,e),t[0]&1}function xO(e,t,r){var n,i;for(As(e[0],Jv),As(e[1],Uh),As(e[2],Uh),As(e[3],Jv),i=255;i>=0;--i)n=r[i/8|0]>>(i&7)&1,yO(e,t,n),eS(t,e),eS(e,e),yO(e,t,n);}function rS(e,t){var r=[$e(),$e(),$e(),$e()];As(r[0],gO),As(r[1],mO),As(r[2],Uh),Ot(r[3],gO,mO),xO(e,r,t);}function As(e,t){var r;for(r=0;r<16;r++)e[r]=t[r]|0;}function Fre(e,t){var r=$e(),n;for(n=0;n<16;++n)r[n]=t[n];for(n=253;n>=0;--n)Co(r,r),n!==2&&n!==4&&Ot(r,r,t);for(n=0;n<16;++n)e[n]=r[n];}function Qv(e){var t,r,n=1;for(t=0;t<16;++t)r=e[t]+n+65535,n=Math.floor(r/65536),e[t]=r-n*65536;e[0]+=n-1+37*(n-1);}function wO(e,t,r){for(var n,i=~(r-1),s=0;s<16;++s)n=i&(e[s]^t[s]),e[s]^=n,t[s]^=n;}function $e(e){var t,r=new Float64Array(16);if(e)for(t=0;t<e.length;++t)r[t]=e[t];return r}function Pa(e,t,r){for(var n=0;n<16;++n)e[n]=t[n]+r[n];}function ka(e,t,r){for(var n=0;n<16;++n)e[n]=t[n]-r[n];}function Co(e,t){Ot(e,t,t);}function Ot(e,t,r){var n,i,s=0,o=0,a=0,c=0,l=0,u=0,f=0,d=0,p=0,m=0,S=0,x=0,I=0,v=0,b=0,D=0,L=0,j=0,J=0,K=0,G=0,ee=0,M=0,ae=0,me=0,Le=0,H=0,W=0,se=0,Te=0,Fe=0,ze=r[0],He=r[1],ct=r[2],Lt=r[3],xt=r[4],dt=r[5],Oe=r[6],Pt=r[7],Ut=r[8],ge=r[9],je=r[10],ce=r[11],Re=r[12],We=r[13],nt=r[14],Ge=r[15];n=t[0],s+=n*ze,o+=n*He,a+=n*ct,c+=n*Lt,l+=n*xt,u+=n*dt,f+=n*Oe,d+=n*Pt,p+=n*Ut,m+=n*ge,S+=n*je,x+=n*ce,I+=n*Re,v+=n*We,b+=n*nt,D+=n*Ge,n=t[1],o+=n*ze,a+=n*He,c+=n*ct,l+=n*Lt,u+=n*xt,f+=n*dt,d+=n*Oe,p+=n*Pt,m+=n*Ut,S+=n*ge,x+=n*je,I+=n*ce,v+=n*Re,b+=n*We,D+=n*nt,L+=n*Ge,n=t[2],a+=n*ze,c+=n*He,l+=n*ct,u+=n*Lt,f+=n*xt,d+=n*dt,p+=n*Oe,m+=n*Pt,S+=n*Ut,x+=n*ge,I+=n*je,v+=n*ce,b+=n*Re,D+=n*We,L+=n*nt,j+=n*Ge,n=t[3],c+=n*ze,l+=n*He,u+=n*ct,f+=n*Lt,d+=n*xt,p+=n*dt,m+=n*Oe,S+=n*Pt,x+=n*Ut,I+=n*ge,v+=n*je,b+=n*ce,D+=n*Re,L+=n*We,j+=n*nt,J+=n*Ge,n=t[4],l+=n*ze,u+=n*He,f+=n*ct,d+=n*Lt,p+=n*xt,m+=n*dt,S+=n*Oe,x+=n*Pt,I+=n*Ut,v+=n*ge,b+=n*je,D+=n*ce,L+=n*Re,j+=n*We,J+=n*nt,K+=n*Ge,n=t[5],u+=n*ze,f+=n*He,d+=n*ct,p+=n*Lt,m+=n*xt,S+=n*dt,x+=n*Oe,I+=n*Pt,v+=n*Ut,b+=n*ge,D+=n*je,L+=n*ce,j+=n*Re,J+=n*We,K+=n*nt,G+=n*Ge,n=t[6],f+=n*ze,d+=n*He,p+=n*ct,m+=n*Lt,S+=n*xt,x+=n*dt,I+=n*Oe,v+=n*Pt,b+=n*Ut,D+=n*ge,L+=n*je,j+=n*ce,J+=n*Re,K+=n*We,G+=n*nt,ee+=n*Ge,n=t[7],d+=n*ze,p+=n*He,m+=n*ct,S+=n*Lt,x+=n*xt,I+=n*dt,v+=n*Oe,b+=n*Pt,D+=n*Ut,L+=n*ge,j+=n*je,J+=n*ce,K+=n*Re,G+=n*We,ee+=n*nt,M+=n*Ge,n=t[8],p+=n*ze,m+=n*He,S+=n*ct,x+=n*Lt,I+=n*xt,v+=n*dt,b+=n*Oe,D+=n*Pt,L+=n*Ut,j+=n*ge,J+=n*je,K+=n*ce,G+=n*Re,ee+=n*We,M+=n*nt,ae+=n*Ge,n=t[9],m+=n*ze,S+=n*He,x+=n*ct,I+=n*Lt,v+=n*xt,b+=n*dt,D+=n*Oe,L+=n*Pt,j+=n*Ut,J+=n*ge,K+=n*je,G+=n*ce,ee+=n*Re,M+=n*We,ae+=n*nt,me+=n*Ge,n=t[10],S+=n*ze,x+=n*He,I+=n*ct,v+=n*Lt,b+=n*xt,D+=n*dt,L+=n*Oe,j+=n*Pt,J+=n*Ut,K+=n*ge,G+=n*je,ee+=n*ce,M+=n*Re,ae+=n*We,me+=n*nt,Le+=n*Ge,n=t[11],x+=n*ze,I+=n*He,v+=n*ct,b+=n*Lt,D+=n*xt,L+=n*dt,j+=n*Oe,J+=n*Pt,K+=n*Ut,G+=n*ge,ee+=n*je,M+=n*ce,ae+=n*Re,me+=n*We,Le+=n*nt,H+=n*Ge,n=t[12],I+=n*ze,v+=n*He,b+=n*ct,D+=n*Lt,L+=n*xt,j+=n*dt,J+=n*Oe,K+=n*Pt,G+=n*Ut,ee+=n*ge,M+=n*je,ae+=n*ce,me+=n*Re,Le+=n*We,H+=n*nt,W+=n*Ge,n=t[13],v+=n*ze,b+=n*He,D+=n*ct,L+=n*Lt,j+=n*xt,J+=n*dt,K+=n*Oe,G+=n*Pt,ee+=n*Ut,M+=n*ge,ae+=n*je,me+=n*ce,Le+=n*Re,H+=n*We,W+=n*nt,se+=n*Ge,n=t[14],b+=n*ze,D+=n*He,L+=n*ct,j+=n*Lt,J+=n*xt,K+=n*dt,G+=n*Oe,ee+=n*Pt,M+=n*Ut,ae+=n*ge,me+=n*je,Le+=n*ce,H+=n*Re,W+=n*We,se+=n*nt,Te+=n*Ge,n=t[15],D+=n*ze,L+=n*He,j+=n*ct,J+=n*Lt,K+=n*xt,G+=n*dt,ee+=n*Oe,M+=n*Pt,ae+=n*Ut,me+=n*ge,Le+=n*je,H+=n*ce,W+=n*Re,se+=n*We,Te+=n*nt,Fe+=n*Ge,s+=38*L,o+=38*j,a+=38*J,c+=38*K,l+=38*G,u+=38*ee,f+=38*M,d+=38*ae,p+=38*me,m+=38*Le,S+=38*H,x+=38*W,I+=38*se,v+=38*Te,b+=38*Fe,i=1,n=s+i+65535,i=Math.floor(n/65536),s=n-i*65536,n=o+i+65535,i=Math.floor(n/65536),o=n-i*65536,n=a+i+65535,i=Math.floor(n/65536),a=n-i*65536,n=c+i+65535,i=Math.floor(n/65536),c=n-i*65536,n=l+i+65535,i=Math.floor(n/65536),l=n-i*65536,n=u+i+65535,i=Math.floor(n/65536),u=n-i*65536,n=f+i+65535,i=Math.floor(n/65536),f=n-i*65536,n=d+i+65535,i=Math.floor(n/65536),d=n-i*65536,n=p+i+65535,i=Math.floor(n/65536),p=n-i*65536,n=m+i+65535,i=Math.floor(n/65536),m=n-i*65536,n=S+i+65535,i=Math.floor(n/65536),S=n-i*65536,n=x+i+65535,i=Math.floor(n/65536),x=n-i*65536,n=I+i+65535,i=Math.floor(n/65536),I=n-i*65536,n=v+i+65535,i=Math.floor(n/65536),v=n-i*65536,n=b+i+65535,i=Math.floor(n/65536),b=n-i*65536,n=D+i+65535,i=Math.floor(n/65536),D=n-i*65536,s+=i-1+37*(i-1),i=1,n=s+i+65535,i=Math.floor(n/65536),s=n-i*65536,n=o+i+65535,i=Math.floor(n/65536),o=n-i*65536,n=a+i+65535,i=Math.floor(n/65536),a=n-i*65536,n=c+i+65535,i=Math.floor(n/65536),c=n-i*65536,n=l+i+65535,i=Math.floor(n/65536),l=n-i*65536,n=u+i+65535,i=Math.floor(n/65536),u=n-i*65536,n=f+i+65535,i=Math.floor(n/65536),f=n-i*65536,n=d+i+65535,i=Math.floor(n/65536),d=n-i*65536,n=p+i+65535,i=Math.floor(n/65536),p=n-i*65536,n=m+i+65535,i=Math.floor(n/65536),m=n-i*65536,n=S+i+65535,i=Math.floor(n/65536),S=n-i*65536,n=x+i+65535,i=Math.floor(n/65536),x=n-i*65536,n=I+i+65535,i=Math.floor(n/65536),I=n-i*65536,n=v+i+65535,i=Math.floor(n/65536),v=n-i*65536,n=b+i+65535,i=Math.floor(n/65536),b=n-i*65536,n=D+i+65535,i=Math.floor(n/65536),D=n-i*65536,s+=i-1+37*(i-1),e[0]=s,e[1]=o,e[2]=a,e[3]=c,e[4]=l,e[5]=u,e[6]=f,e[7]=d,e[8]=p,e[9]=m,e[10]=S,e[11]=x,e[12]=I,e[13]=v,e[14]=b,e[15]=D;}});var DO=A((Jhe,IO)=>{var En=rt();vt();Ln();vc();IO.exports=En.kem=En.kem||{};var AO=En.jsbn.BigInteger;En.kem.rsa={};En.kem.rsa.create=function(e,t){t=t||{};var r=t.prng||En.random,n={};return n.encrypt=function(i,s){var o=Math.ceil(i.n.bitLength()/8),a;do a=new AO(En.util.bytesToHex(r.getBytesSync(o)),16).mod(i.n);while(a.compareTo(AO.ONE)<=0);a=En.util.hexToBytes(a.toString(16));var c=o-a.length;c>0&&(a=En.util.fillString("\0",c)+a);var l=i.encrypt(a,"NONE"),u=e.generate(a,s);return {encapsulation:l,key:u}},n.decrypt=function(i,s,o){var a=i.decrypt(s,"NONE");return e.generate(a,o)},n};En.kem.kdf1=function(e,t){RO(this,e,0,t||e.digestLength);};En.kem.kdf2=function(e,t){RO(this,e,1,t||e.digestLength);};function RO(e,t,r,n){e.generate=function(i,s){for(var o=new En.util.ByteBuffer,a=Math.ceil(s/n)+r,c=new En.util.ByteBuffer,l=r;l<a;++l){c.putInt32(l),t.start(),t.update(i+c.getBytes());var u=t.digest();o.putBytes(u.getBytes(n));}return o.truncate(o.length()-s),o.getBytes()};}});var LO=A((Zhe,NO)=>{var ft=rt();vt();NO.exports=ft.log=ft.log||{};ft.log.levels=["none","error","warning","info","debug","verbose","max"];var jh={},sS=[],_c=null;ft.log.LEVEL_LOCKED=2;ft.log.NO_LEVEL_CHECK=4;ft.log.INTERPOLATE=8;for(Ai=0;Ai<ft.log.levels.length;++Ai)nS=ft.log.levels[Ai],jh[nS]={index:Ai,name:nS.toUpperCase()};var nS,Ai;ft.log.logMessage=function(e){for(var t=jh[e.level].index,r=0;r<sS.length;++r){var n=sS[r];if(n.flags&ft.log.NO_LEVEL_CHECK)n.f(e);else {var i=jh[n.level].index;t<=i&&n.f(n,e);}}};ft.log.prepareStandard=function(e){"standard"in e||(e.standard=jh[e.level].name+" ["+e.category+"] "+e.message);};ft.log.prepareFull=function(e){if(!("full"in e)){var t=[e.message];t=t.concat([]),e.full=ft.util.format.apply(this,t);}};ft.log.prepareStandardFull=function(e){"standardFull"in e||(ft.log.prepareStandard(e),e.standardFull=e.standard);};for(iS=["error","warning","info","debug","verbose"],Ai=0;Ai<iS.length;++Ai)(function(t){ft.log[t]=function(r,n){var i=Array.prototype.slice.call(arguments).slice(2),s={timestamp:new Date,level:t,category:r,message:n,arguments:i};ft.log.logMessage(s);};})(iS[Ai]);var iS,Ai;ft.log.makeLogger=function(e){var t={flags:0,f:e};return ft.log.setLevel(t,"none"),t};ft.log.setLevel=function(e,t){var r=!1;if(e&&!(e.flags&ft.log.LEVEL_LOCKED))for(var n=0;n<ft.log.levels.length;++n){var i=ft.log.levels[n];if(t==i){e.level=t,r=!0;break}}return r};ft.log.lock=function(e,t){typeof t>"u"||t?e.flags|=ft.log.LEVEL_LOCKED:e.flags&=~ft.log.LEVEL_LOCKED;};ft.log.addLogger=function(e){sS.push(e);};typeof console<"u"&&"log"in console?(console.error&&console.warn&&console.info&&console.debug?(PO={error:console.error,warning:console.warn,info:console.info,debug:console.debug,verbose:console.debug},Tc=function(e,t){ft.log.prepareStandard(t);var r=PO[t.level],n=[t.standard];n=n.concat(t.arguments.slice()),r.apply(console,n);},Na=ft.log.makeLogger(Tc)):(Tc=function(t,r){ft.log.prepareStandardFull(r),console.log(r.standardFull);},Na=ft.log.makeLogger(Tc)),ft.log.setLevel(Na,"debug"),ft.log.addLogger(Na),_c=Na):console={log:function(){}};var Na,PO,Tc;_c!==null&&typeof window<"u"&&window.location&&(wc=new URL(window.location.href).searchParams,wc.has("console.level")&&ft.log.setLevel(_c,wc.get("console.level").slice(-1)[0]),wc.has("console.lock")&&(kO=wc.get("console.lock").slice(-1)[0],kO=="true"&&ft.log.lock(_c)));var wc,kO;ft.log.consoleLogger=_c;});var BO=A((ede,OO)=>{OO.exports=Si();Ch();Ta();vv();zv();});var MO=A((tde,FO)=>{var Ce=rt();Ss();ni();mc();bs();po();kv();Ln();vt();Oh();var $=Ce.asn1,Xr=FO.exports=Ce.pkcs7=Ce.pkcs7||{};Xr.messageFromPem=function(e){var t=Ce.pem.decode(e)[0];if(t.type!=="PKCS7"){var r=new Error('Could not convert PKCS#7 message from PEM; PEM header type is not "PKCS#7".');throw r.headerType=t.type,r}if(t.procType&&t.procType.type==="ENCRYPTED")throw new Error("Could not convert PKCS#7 message from PEM; PEM is encrypted.");var n=$.fromDer(t.body);return Xr.messageFromAsn1(n)};Xr.messageToPem=function(e,t){var r={type:"PKCS7",body:$.toDer(e.toAsn1()).getBytes()};return Ce.pem.encode(r,{maxline:t})};Xr.messageFromAsn1=function(e){var t={},r=[];if(!$.validate(e,Xr.asn1.contentInfoValidator,t,r)){var n=new Error("Cannot read PKCS#7 message. ASN.1 object is not an PKCS#7 ContentInfo.");throw n.errors=r,n}var i=$.derToOid(t.contentType),s;switch(i){case Ce.pki.oids.envelopedData:s=Xr.createEnvelopedData();break;case Ce.pki.oids.encryptedData:s=Xr.createEncryptedData();break;case Ce.pki.oids.signedData:s=Xr.createSignedData();break;default:throw new Error("Cannot read PKCS#7 message. ContentType with OID "+i+" is not (yet) supported.")}return s.fromAsn1(t.content.value[0]),s};Xr.createSignedData=function(){var e=null;return e={type:Ce.pki.oids.signedData,version:1,certificates:[],crls:[],signers:[],digestAlgorithmIdentifiers:[],contentInfo:null,signerInfos:[],fromAsn1:function(n){if(aS(e,n,Xr.asn1.signedDataValidator),e.certificates=[],e.crls=[],e.digestAlgorithmIdentifiers=[],e.contentInfo=null,e.signerInfos=[],e.rawCapture.certificates)for(var i=e.rawCapture.certificates.value,s=0;s<i.length;++s)e.certificates.push(Ce.pki.certificateFromAsn1(i[s]));},toAsn1:function(){e.contentInfo||e.sign();for(var n=[],i=0;i<e.certificates.length;++i)n.push(Ce.pki.certificateToAsn1(e.certificates[i]));var s=[],o=$.create($.Class.CONTEXT_SPECIFIC,0,!0,[$.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.INTEGER,!1,$.integerToDer(e.version).getBytes()),$.create($.Class.UNIVERSAL,$.Type.SET,!0,e.digestAlgorithmIdentifiers),e.contentInfo])]);return n.length>0&&o.value[0].value.push($.create($.Class.CONTEXT_SPECIFIC,0,!0,n)),s.length>0&&o.value[0].value.push($.create($.Class.CONTEXT_SPECIFIC,1,!0,s)),o.value[0].value.push($.create($.Class.UNIVERSAL,$.Type.SET,!0,e.signerInfos)),$.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.OID,!1,$.oidToDer(e.type).getBytes()),o])},addSigner:function(n){var i=n.issuer,s=n.serialNumber;if(n.certificate){var o=n.certificate;typeof o=="string"&&(o=Ce.pki.certificateFromPem(o)),i=o.issuer.attributes,s=o.serialNumber;}var a=n.key;if(!a)throw new Error("Could not add PKCS#7 signer; no private key specified.");typeof a=="string"&&(a=Ce.pki.privateKeyFromPem(a));var c=n.digestAlgorithm||Ce.pki.oids.sha1;switch(c){case Ce.pki.oids.sha1:case Ce.pki.oids.sha256:case Ce.pki.oids.sha384:case Ce.pki.oids.sha512:case Ce.pki.oids.md5:break;default:throw new Error("Could not add PKCS#7 signer; unknown message digest algorithm: "+c)}var l=n.authenticatedAttributes||[];if(l.length>0){for(var u=!1,f=!1,d=0;d<l.length;++d){var p=l[d];if(!u&&p.type===Ce.pki.oids.contentType){if(u=!0,f)break;continue}if(!f&&p.type===Ce.pki.oids.messageDigest){if(f=!0,u)break;continue}}if(!u||!f)throw new Error("Invalid signer.authenticatedAttributes. If signer.authenticatedAttributes is specified, then it must contain at least two attributes, PKCS #9 content-type and PKCS #9 message-digest.")}e.signers.push({key:a,version:1,issuer:i,serialNumber:s,digestAlgorithm:c,signatureAlgorithm:Ce.pki.oids.rsaEncryption,signature:null,authenticatedAttributes:l,unauthenticatedAttributes:[]});},sign:function(n){if(n=n||{},(typeof e.content!="object"||e.contentInfo===null)&&(e.contentInfo=$.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.OID,!1,$.oidToDer(Ce.pki.oids.data).getBytes())]),"content"in e)){var i;e.content instanceof Ce.util.ByteBuffer?i=e.content.bytes():typeof e.content=="string"&&(i=Ce.util.encodeUtf8(e.content)),n.detached?e.detachedContent=$.create($.Class.UNIVERSAL,$.Type.OCTETSTRING,!1,i):e.contentInfo.value.push($.create($.Class.CONTEXT_SPECIFIC,0,!0,[$.create($.Class.UNIVERSAL,$.Type.OCTETSTRING,!1,i)]));}if(e.signers.length!==0){var s=t();r(s);}},verify:function(){throw new Error("PKCS#7 signature verification not yet implemented.")},addCertificate:function(n){typeof n=="string"&&(n=Ce.pki.certificateFromPem(n)),e.certificates.push(n);},addCertificateRevokationList:function(n){throw new Error("PKCS#7 CRL support not yet implemented.")}},e;function t(){for(var n={},i=0;i<e.signers.length;++i){var s=e.signers[i],o=s.digestAlgorithm;o in n||(n[o]=Ce.md[Ce.pki.oids[o]].create()),s.authenticatedAttributes.length===0?s.md=n[o]:s.md=Ce.md[Ce.pki.oids[o]].create();}e.digestAlgorithmIdentifiers=[];for(var o in n)e.digestAlgorithmIdentifiers.push($.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.OID,!1,$.oidToDer(o).getBytes()),$.create($.Class.UNIVERSAL,$.Type.NULL,!1,"")]));return n}function r(n){var i;if(e.detachedContent?i=e.detachedContent:(i=e.contentInfo.value[1],i=i.value[0]),!i)throw new Error("Could not sign PKCS#7 message; there is no content to sign.");var s=$.derToOid(e.contentInfo.value[0].value),o=$.toDer(i);o.getByte(),$.getBerValueLength(o),o=o.getBytes();for(var a in n)n[a].start().update(o);for(var c=new Date,l=0;l<e.signers.length;++l){var u=e.signers[l];if(u.authenticatedAttributes.length===0){if(s!==Ce.pki.oids.data)throw new Error("Invalid signer; authenticatedAttributes must be present when the ContentInfo content type is not PKCS#7 Data.")}else {u.authenticatedAttributesAsn1=$.create($.Class.CONTEXT_SPECIFIC,0,!0,[]);for(var f=$.create($.Class.UNIVERSAL,$.Type.SET,!0,[]),d=0;d<u.authenticatedAttributes.length;++d){var p=u.authenticatedAttributes[d];p.type===Ce.pki.oids.messageDigest?p.value=n[u.digestAlgorithm].digest():p.type===Ce.pki.oids.signingTime&&(p.value||(p.value=c)),f.value.push(oS(p)),u.authenticatedAttributesAsn1.value.push(oS(p));}o=$.toDer(f).getBytes(),u.md.start().update(o);}u.signature=u.key.sign(u.md,"RSASSA-PKCS1-V1_5");}e.signerInfos=Hre(e.signers);}};Xr.createEncryptedData=function(){var e=null;return e={type:Ce.pki.oids.encryptedData,version:0,encryptedContent:{algorithm:Ce.pki.oids["aes256-CBC"]},fromAsn1:function(t){aS(e,t,Xr.asn1.encryptedDataValidator);},decrypt:function(t){t!==void 0&&(e.encryptedContent.key=t),qO(e);}},e};Xr.createEnvelopedData=function(){var e=null;return e={type:Ce.pki.oids.envelopedData,version:0,recipients:[],encryptedContent:{algorithm:Ce.pki.oids["aes256-CBC"]},fromAsn1:function(t){var r=aS(e,t,Xr.asn1.envelopedDataValidator);e.recipients=$re(r.recipientInfos.value);},toAsn1:function(){return $.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.OID,!1,$.oidToDer(e.type).getBytes()),$.create($.Class.CONTEXT_SPECIFIC,0,!0,[$.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.INTEGER,!1,$.integerToDer(e.version).getBytes()),$.create($.Class.UNIVERSAL,$.Type.SET,!0,jre(e.recipients)),$.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,Wre(e.encryptedContent))])])])},findRecipient:function(t){for(var r=t.issuer.attributes,n=0;n<e.recipients.length;++n){var i=e.recipients[n],s=i.issuer;if(i.serialNumber===t.serialNumber&&s.length===r.length){for(var o=!0,a=0;a<r.length;++a)if(s[a].type!==r[a].type||s[a].value!==r[a].value){o=!1;break}if(o)return i}}return null},decrypt:function(t,r){if(e.encryptedContent.key===void 0&&t!==void 0&&r!==void 0)switch(t.encryptedContent.algorithm){case Ce.pki.oids.rsaEncryption:case Ce.pki.oids.desCBC:var n=r.decrypt(t.encryptedContent.content);e.encryptedContent.key=Ce.util.createBuffer(n);break;default:throw new Error("Unsupported asymmetric cipher, OID "+t.encryptedContent.algorithm)}qO(e);},addRecipient:function(t){e.recipients.push({version:0,issuer:t.issuer.attributes,serialNumber:t.serialNumber,encryptedContent:{algorithm:Ce.pki.oids.rsaEncryption,key:t.publicKey}});},encrypt:function(t,r){if(e.encryptedContent.content===void 0){r=r||e.encryptedContent.algorithm,t=t||e.encryptedContent.key;var n,i,s;switch(r){case Ce.pki.oids["aes128-CBC"]:n=16,i=16,s=Ce.aes.createEncryptionCipher;break;case Ce.pki.oids["aes192-CBC"]:n=24,i=16,s=Ce.aes.createEncryptionCipher;break;case Ce.pki.oids["aes256-CBC"]:n=32,i=16,s=Ce.aes.createEncryptionCipher;break;case Ce.pki.oids["des-EDE3-CBC"]:n=24,i=8,s=Ce.des.createEncryptionCipher;break;default:throw new Error("Unsupported symmetric cipher, OID "+r)}if(t===void 0)t=Ce.util.createBuffer(Ce.random.getBytes(n));else if(t.length()!=n)throw new Error("Symmetric key has wrong length; got "+t.length()+" bytes, expected "+n+".");e.encryptedContent.algorithm=r,e.encryptedContent.key=t,e.encryptedContent.parameter=Ce.util.createBuffer(Ce.random.getBytes(i));var o=s(t);if(o.start(e.encryptedContent.parameter.copy()),o.update(e.content),!o.finish())throw new Error("Symmetric encryption failed.");e.encryptedContent.content=o.output;}for(var a=0;a<e.recipients.length;++a){var c=e.recipients[a];if(c.encryptedContent.content===void 0)switch(c.encryptedContent.algorithm){case Ce.pki.oids.rsaEncryption:c.encryptedContent.content=c.encryptedContent.key.encrypt(e.encryptedContent.key.data);break;default:throw new Error("Unsupported asymmetric cipher, OID "+c.encryptedContent.algorithm)}}}},e};function Mre(e){var t={},r=[];if(!$.validate(e,Xr.asn1.recipientInfoValidator,t,r)){var n=new Error("Cannot read PKCS#7 RecipientInfo. ASN.1 object is not an PKCS#7 RecipientInfo.");throw n.errors=r,n}return {version:t.version.charCodeAt(0),issuer:Ce.pki.RDNAttributesAsArray(t.issuer),serialNumber:Ce.util.createBuffer(t.serial).toHex(),encryptedContent:{algorithm:$.derToOid(t.encAlgorithm),parameter:t.encParameter?t.encParameter.value:void 0,content:t.encKey}}}function Ure(e){return $.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.INTEGER,!1,$.integerToDer(e.version).getBytes()),$.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[Ce.pki.distinguishedNameToAsn1({attributes:e.issuer}),$.create($.Class.UNIVERSAL,$.Type.INTEGER,!1,Ce.util.hexToBytes(e.serialNumber))]),$.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.OID,!1,$.oidToDer(e.encryptedContent.algorithm).getBytes()),$.create($.Class.UNIVERSAL,$.Type.NULL,!1,"")]),$.create($.Class.UNIVERSAL,$.Type.OCTETSTRING,!1,e.encryptedContent.content)])}function $re(e){for(var t=[],r=0;r<e.length;++r)t.push(Mre(e[r]));return t}function jre(e){for(var t=[],r=0;r<e.length;++r)t.push(Ure(e[r]));return t}function Vre(e){var t=$.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.INTEGER,!1,$.integerToDer(e.version).getBytes()),$.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[Ce.pki.distinguishedNameToAsn1({attributes:e.issuer}),$.create($.Class.UNIVERSAL,$.Type.INTEGER,!1,Ce.util.hexToBytes(e.serialNumber))]),$.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.OID,!1,$.oidToDer(e.digestAlgorithm).getBytes()),$.create($.Class.UNIVERSAL,$.Type.NULL,!1,"")])]);if(e.authenticatedAttributesAsn1&&t.value.push(e.authenticatedAttributesAsn1),t.value.push($.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.OID,!1,$.oidToDer(e.signatureAlgorithm).getBytes()),$.create($.Class.UNIVERSAL,$.Type.NULL,!1,"")])),t.value.push($.create($.Class.UNIVERSAL,$.Type.OCTETSTRING,!1,e.signature)),e.unauthenticatedAttributes.length>0){for(var r=$.create($.Class.CONTEXT_SPECIFIC,1,!0,[]),n=0;n<e.unauthenticatedAttributes.length;++n){var i=e.unauthenticatedAttributes[n];r.values.push(oS(i));}t.value.push(r);}return t}function Hre(e){for(var t=[],r=0;r<e.length;++r)t.push(Vre(e[r]));return t}function oS(e){var t;if(e.type===Ce.pki.oids.contentType)t=$.create($.Class.UNIVERSAL,$.Type.OID,!1,$.oidToDer(e.value).getBytes());else if(e.type===Ce.pki.oids.messageDigest)t=$.create($.Class.UNIVERSAL,$.Type.OCTETSTRING,!1,e.value.bytes());else if(e.type===Ce.pki.oids.signingTime){var r=new Date("1950-01-01T00:00:00Z"),n=new Date("2050-01-01T00:00:00Z"),i=e.value;if(typeof i=="string"){var s=Date.parse(i);isNaN(s)?i.length===13?i=$.utcTimeToDate(i):i=$.generalizedTimeToDate(i):i=new Date(s);}i>=r&&i<n?t=$.create($.Class.UNIVERSAL,$.Type.UTCTIME,!1,$.dateToUtcTime(i)):t=$.create($.Class.UNIVERSAL,$.Type.GENERALIZEDTIME,!1,$.dateToGeneralizedTime(i));}return $.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.OID,!1,$.oidToDer(e.type).getBytes()),$.create($.Class.UNIVERSAL,$.Type.SET,!0,[t])])}function Wre(e){return [$.create($.Class.UNIVERSAL,$.Type.OID,!1,$.oidToDer(Ce.pki.oids.data).getBytes()),$.create($.Class.UNIVERSAL,$.Type.SEQUENCE,!0,[$.create($.Class.UNIVERSAL,$.Type.OID,!1,$.oidToDer(e.algorithm).getBytes()),e.parameter?$.create($.Class.UNIVERSAL,$.Type.OCTETSTRING,!1,e.parameter.getBytes()):void 0]),$.create($.Class.CONTEXT_SPECIFIC,0,!0,[$.create($.Class.UNIVERSAL,$.Type.OCTETSTRING,!1,e.content.getBytes())])]}function aS(e,t,r){var n={},i=[];if(!$.validate(t,r,n,i)){var s=new Error("Cannot read PKCS#7 message. ASN.1 object is not a supported PKCS#7 message.");throw s.errors=s,s}var o=$.derToOid(n.contentType);if(o!==Ce.pki.oids.data)throw new Error("Unsupported PKCS#7 message. Only wrapped ContentType Data supported.");if(n.encryptedContent){var a="";if(Ce.util.isArray(n.encryptedContent))for(var c=0;c<n.encryptedContent.length;++c){if(n.encryptedContent[c].type!==$.Type.OCTETSTRING)throw new Error("Malformed PKCS#7 message, expecting encrypted content constructed of only OCTET STRING objects.");a+=n.encryptedContent[c].value;}else a=n.encryptedContent;e.encryptedContent={algorithm:$.derToOid(n.encAlgorithm),parameter:Ce.util.createBuffer(n.encParameter.value),content:Ce.util.createBuffer(a)};}if(n.content){var a="";if(Ce.util.isArray(n.content))for(var c=0;c<n.content.length;++c){if(n.content[c].type!==$.Type.OCTETSTRING)throw new Error("Malformed PKCS#7 message, expecting content constructed of only OCTET STRING objects.");a+=n.content[c].value;}else a=n.content;e.content=Ce.util.createBuffer(a);}return e.version=n.version.charCodeAt(0),e.rawCapture=n,n}function qO(e){if(e.encryptedContent.key===void 0)throw new Error("Symmetric key not available.");if(e.content===void 0){var t;switch(e.encryptedContent.algorithm){case Ce.pki.oids["aes128-CBC"]:case Ce.pki.oids["aes192-CBC"]:case Ce.pki.oids["aes256-CBC"]:t=Ce.aes.createDecryptionCipher(e.encryptedContent.key);break;case Ce.pki.oids.desCBC:case Ce.pki.oids["des-EDE3-CBC"]:t=Ce.des.createDecryptionCipher(e.encryptedContent.key);break;default:throw new Error("Unsupported symmetric cipher, OID "+e.encryptedContent.algorithm)}if(t.start(e.encryptedContent.parameter),t.update(e.encryptedContent.content),!t.finish())throw new Error("Symmetric decryption failed.");e.content=t.output;}}});var $O=A((rde,UO)=>{var or=rt();Ss();Ea();Ch();Ta();vt();var Hh=UO.exports=or.ssh=or.ssh||{};Hh.privateKeyToPutty=function(e,t,r){r=r||"",t=t||"";var n="ssh-rsa",i=t===""?"none":"aes256-cbc",s="PuTTY-User-Key-File-2: "+n+`\r
`;s+="Encryption: "+i+`\r
`,s+="Comment: "+r+`\r
`;var o=or.util.createBuffer();La(o,n),Ri(o,e.e),Ri(o,e.n);var a=or.util.encode64(o.bytes(),64),c=Math.floor(a.length/66)+1;s+="Public-Lines: "+c+`\r
`,s+=a;var l=or.util.createBuffer();Ri(l,e.d),Ri(l,e.p),Ri(l,e.q),Ri(l,e.qInv);var u;if(!t)u=or.util.encode64(l.bytes(),64);else {var f=l.length()+16-1;f-=f%16;var d=Vh(l.bytes());d.truncate(d.length()-f+l.length()),l.putBuffer(d);var p=or.util.createBuffer();p.putBuffer(Vh("\0\0\0\0",t)),p.putBuffer(Vh("\0\0\0",t));var m=or.aes.createEncryptionCipher(p.truncate(8),"CBC");m.start(or.util.createBuffer().fillWithByte(0,16)),m.update(l.copy()),m.finish();var S=m.output;S.truncate(16),u=or.util.encode64(S.bytes(),64);}c=Math.floor(u.length/66)+1,s+=`\r
Private-Lines: `+c+`\r
`,s+=u;var x=Vh("putty-private-key-file-mac-key",t),I=or.util.createBuffer();La(I,n),La(I,i),La(I,r),I.putInt32(o.length()),I.putBuffer(o),I.putInt32(l.length()),I.putBuffer(l);var v=or.hmac.create();return v.start("sha1",x),v.update(I.bytes()),s+=`\r
Private-MAC: `+v.digest().toHex()+`\r
`,s};Hh.publicKeyToOpenSSH=function(e,t){var r="ssh-rsa";t=t||"";var n=or.util.createBuffer();return La(n,r),Ri(n,e.e),Ri(n,e.n),r+" "+or.util.encode64(n.bytes())+" "+t};Hh.privateKeyToOpenSSH=function(e,t){return t?or.pki.encryptRsaPrivateKey(e,t,{legacy:!0,algorithm:"aes128"}):or.pki.privateKeyToPem(e)};Hh.getPublicKeyFingerprint=function(e,t){t=t||{};var r=t.md||or.md.md5.create(),n="ssh-rsa",i=or.util.createBuffer();La(i,n),Ri(i,e.e),Ri(i,e.n),r.start(),r.update(i.getBytes());var s=r.digest();if(t.encoding==="hex"){var o=s.toHex();return t.delimiter?o.match(/.{2}/g).join(t.delimiter):o}else {if(t.encoding==="binary")return s.getBytes();if(t.encoding)throw new Error('Unknown encoding "'+t.encoding+'".')}return s};function Ri(e,t){var r=t.toString(16);r[0]>="8"&&(r="00"+r);var n=or.util.hexToBytes(r);e.putInt32(n.length),e.putBytes(n);}function La(e,t){e.putInt32(t.length),e.putString(t);}function Vh(){for(var e=or.md.sha1.create(),t=arguments.length,r=0;r<t;++r)e.update(arguments[r]);return e.digest()}});var uS=A((nde,jO)=>{jO.exports=rt();Ss();uO();ni();ph();mc();TO();Ea();DO();LO();BO();Nv();_h();po();Av();Bv();MO();Fv();Iv();Sv();kh();Ln();Ev();$O();Hv();vt();});var HO=A((ide,VO)=>{VO.exports={dc:"0.9.2342.19200300.100.1.25"};});var cS=A((sde,WO)=>{var Wh;WO.exports=Kre;function Kre(){var e,t,r,n;if(!Wh){Wh=uS(),e=Wh.oids;for(t in r=HO())n=r[t],e[t]==null&&(e[t]=n),e[n]==null&&(e[n]=t);}return Wh}});var Rc=A((ode,XO)=>{var Kh,fS,Ac,lS,KO,zO,hS;XO.exports=zh;Kh=cS();fS={der:GO,pem:YO,txt:zre,asn1:QO,x509:Gre};Ac=[];for(lS in fS)KO=fS[lS],zh[lS]=Ac.length,Ac.push(KO);zh.forge=zh.x509;zO=Buffer.isBuffer;hS=Buffer.from||function(e,t){return new Buffer(e,t)};function zh(e,t){var r;return r=Ac[e]||Ac[0],t!=null?r(t):r}function GO(e){return zO(e)?e:hS(e,"binary")}function YO(e){var t,r,n,i;for(e=GO(e).toString("base64"),t=["-----BEGIN CERTIFICATE-----"],r=0,n=e.length;r<n;r+=64)i=r,t.push(e.substr(i,64));return t.push("-----END CERTIFICATE-----",""),t.join(`\r
`)}function zre(e){var t;return t=QO(e),"Subject	"+t.subject.value.map(function(r){return hS(r.value[0].value[1].value,"binary").toString("utf8")}).join("/")+`
Valid	`+t.valid.value.map(function(r){return r.value}).join(" - ")+`
`+YO(e)}function QO(e){var t,r,n,i;return t=Kh().asn1,e=e.toString("binary"),r=t.fromDer(e).value[0].value,n=r[0],i=n.tagClass===t.Class.CONTEXT_SPECIFIC&&n.type===0&&n.constructed,r=r.slice(i),{serial:r[0],valid:r[3],issuer:r[2],subject:r[4]}}function Gre(e){return Kh().pki.certificateFromAsn1(Kh().asn1.fromDer(e.toString("binary")))}});var ZO=A(pS=>{pS.all=Qre;pS.each=JO;JO.async=Yre;function JO(){var e;dS(arguments,e={unique:!0,ondata:function(t){typeof e.$cb=="function"&&e.$cb(t);}});}function Yre(){var e;dS(arguments,e={async:!0,ondata:function(t){typeof e.$cb=="function"&&e.$cb(void 0,t);},onend:function(){typeof e.$cb=="function"&&e.$cb();}});}function Qre(){var e;return dS(arguments,{ondata:e=[]}),e}function dS(e,t){var r,n;r=fc(),n=e[0],t.unique==null&&(t.unique=!1),t.format=n??r.der2.x509,t.$cb=e[1]||n,r(t);}});var SS=A((ude,rB)=>{var yS,eB,gS,Ic,vS,mS;yS=he("crypto");eB=cS();gS=Rc();Ic=eB().asn1;vS=gS(gS.asn1);rB.exports=Zre;mS=Buffer.from||function(e,t){return new Buffer(e,t)};function Xre(e){var t;return t=yS.createHash("sha1"),vS(e).subject.value.forEach(function(r){var n,i;r=Ic.copy(r),n=r.value[0].value[1],n.value&&(n.type=Ic.Type.UTF8,i=mS(n.value,"binary").toString("utf8"),i=i.trim().replace(/[A-Z]+/g,function(s){return s.toLowerCase()}).replace(/\s+/g," "),n.value=mS(i,"utf8").toString("binary"),t.update(Ic.toDer(r).getBytes(),"binary"));}),tB(t)}function Jre(e){var t,r;return t=yS.createHash("md5"),r=vS(e).subject,t.update(Ic.toDer(r).getBytes(),"binary"),tB(t)}function tB(e){return e=e.digest().slice(0,4),e.writeUInt32LE(e.readUInt32BE(0),0),e.toString("hex")}function Zre(e,t){var r;return r=e===0?Jre:Xre,t!=null?r(t):r}});var CS=A((cde,uB)=>{var iB,Dc,bS,sB,Gh,Rs,kc,Pc;iB=he("https");Dc=he("tls");bS=Rc();uB.exports=oB;oB.inject=aB;sB=bS(bS.pem);Gh=iB.globalAgent.options;Rs=[];function oB(e){return aB(e,[]),ene}function ene(e){Rs.push(sB(e));}kc=0;function aB(e,t){if(t&&(Rs.length=0,Rs.push.apply(Rs,t)),e=e==="+"?2:e?1:0,e!==kc){switch(kc){case 1:Gh.ca===Rs&&delete Gh.ca;break;case 2:Dc.createSecureContext===nB&&(Dc.createSecureContext=Pc,Pc=void 0);}switch(kc=e){case 1:Gh.ca=Rs;break;case 2:Pc||(Pc=Dc.createSecureContext,Dc.createSecureContext=nB);}}}function nB(e){var t,r,n,i,s;if(t=Pc.apply(this,arguments),kc===2&&!(e!=null&&e.ca))for(r=0,i=(n=Rs).length;r<i;++r)s=n[r],t.context.addCACert(s);return t}});var fB=A((cB,lB)=>{var tne=he("stream");lB.exports=ES;ES.through=ES;function ES(e,t,r){e=e||function(u){this.queue(u);},t=t||function(){this.queue(null);};var n=!1,i=!1,s=[],o=!1,a=new tne;a.readable=a.writable=!0,a.paused=!1,a.autoDestroy=!(r&&r.autoDestroy===!1),a.write=function(u){return e.call(this,u),!a.paused};function c(){for(;s.length&&!a.paused;){var u=s.shift();if(u===null)return a.emit("end");a.emit("data",u);}}a.queue=a.push=function(u){return o||(u===null&&(o=!0),s.push(u),c()),a},a.on("end",function(){a.readable=!1,!a.writable&&a.autoDestroy&&process.nextTick(function(){a.destroy();});});function l(){a.writable=!1,t.call(a),!a.readable&&a.autoDestroy&&a.destroy();}return a.end=function(u){if(!n)return n=!0,arguments.length&&a.write(u),l(),a},a.destroy=function(){if(!i)return i=!0,n=!0,s.length=0,a.writable=a.readable=!1,a.emit("close"),a},a.pause=function(){if(!a.paused)return a.paused=!0,a},a.resume=function(){return a.paused&&(a.paused=!1,a.emit("resume")),c(),a.paused||a.emit("drain"),a},a}});var dB=A((lde,hB)=>{var rne=fB(),nne=he("string_decoder").StringDecoder;hB.exports=ine;function ine(e,t,r){var n=new nne,i="",s=r&&r.maxLength,o=!(r&&r.trailing===!1);typeof e=="function"&&(t=e,e=null),e||(e=/\r?\n/);function a(l,u){if(t){try{u=t(u);}catch(f){return l.emit("error",f)}typeof u<"u"&&l.queue(u);}else l.queue(u);}function c(l,u){var f=((i??"")+u).split(e);if(i=f.pop(),s&&i.length>s)return l.emit("error",new Error("maximum buffer reached"));for(var d=0;d<f.length;d++){var p=f[d];a(l,p);}}return rne(function(l){c(this,n.write(l));},function(){n.end&&c(this,n.end()),o&&i!=null&&a(this,i),this.queue(null);})}});var TS=A(Yh=>{var pB,xS,gB,Qh,wS,mB,_S=typeof Yh<"u"&&Yh||Yh;pB=he("path");xS=he("child_process");gB=dB();wS={maxBuffer:1024*1024*1024};function yB(e){var t;return e==null&&(e="roots.exe"),t=Qh,Qh=pB.resolve(__dirname,e),t}yB();_S.exe=yB;_S.sync=sne;function sne(e){var t,r;return {run:s,next:n,done:i};function n(){if(t||(t=[],r=0,s(function(o){o&&t.push(o);})),r<t.length)return t[r++];t=[];}function i(){t=[];}function s(o){vB(o).on("end",function(){o();}).end(xS.execFileSync(Qh,e,wS));}}_S.async=one;function one(e){var t,r,n;return {run:c,next:i,done:o};function i(){return t||(t=[],r=[],c(s)),t.length?Promise.resolve(t.shift()):n?Promise.resolve():new Promise(function(l){r.push(l);})}function s(l){n||(l?r.length?r.shift()(l):t.push(l):a());}function o(){t=[],a();}function a(){var l,u,f,d;for(n=!0,l=0,f=(u=r).length;l<f;++l)d=u[l],d();}function c(l){xS.execFile(Qh,e,wS,function(){}).stdout.pipe(vB(l)).on("end",function(){l();});}}function vB(e){return gB(function(t){t.length&&e(mB(t,"hex"));})}mB=Buffer.from||function(e,t){return new Buffer(e,t)};});var CB=A(Xh=>{var SB=typeof Xh<"u"&&Xh||Xh;SB.sync=bB;function bB(){return {next:function(){},done:function(){},run:function(e){return e()}}}SB.async=bB;});var EB=A(()=>{});var xB=A(()=>{});var Sde,AS=gE(()=>{Sde=pE({"./crypt32-ia32.node":()=>EB(),"./crypt32-x64.node":()=>xB()});});var TB=A(Jh=>{AS();var RS,wB=typeof Jh<"u"&&Jh||Jh;RS=Sde("./crypt32-"+process.arch);wB.sync=_B;function _B(e){var t,r;return r=e.length?0:-1,{next:n,done:i,run:s};function n(){for(var o;r<e.length;){if(t==null&&(t=r<0?RS():RS(e[r])),o=t.next())return o;t.done(),t=void 0,r++;}}function i(){t?.done(),t=void 0,r=e.length;}function s(o){for(var a;a=n();)o(a);o();}}wB.async=une;function une(e){var t,r;return t=_B(e),r=t.next,t.run=n,t;function n(i){function s(){return Promise.resolve().then(r).then(function(o){if(o)return i(o),s();i();})}s();}}});var IB=A((Ede,RB)=>{var AB;AB=he("crypto");RB.exports=cne;function cne(){var e;e=new Set;function t(r){var n;if(n=AB.createHash("sha256").update(r).digest("base64"),!e.has(n))return e.add(n),!0}return t}});var kB=A((xde,PB)=>{var DB=(e,t)=>function(){let r=t.promiseModule,n=new Array(arguments.length);for(let i=0;i<arguments.length;i++)n[i]=arguments[i];return new r((i,s)=>{t.errorFirst?n.push(function(o,a){if(t.multiArgs){let c=new Array(arguments.length-1);for(let l=1;l<arguments.length;l++)c[l-1]=arguments[l];o?(c.unshift(o),s(c)):i(c);}else o?s(o):i(a);}):n.push(function(o){if(t.multiArgs){let a=new Array(arguments.length-1);for(let c=0;c<arguments.length;c++)a[c]=arguments[c];i(a);}else i(o);}),e.apply(this,n);})};PB.exports=(e,t)=>{t=Object.assign({exclude:[/.+(Sync|Stream)$/],errorFirst:!0,promiseModule:Promise},t);let r=i=>{let s=o=>typeof o=="string"?i===o:o.test(i);return t.include?t.include.some(s):!t.exclude.some(s)},n;typeof e=="function"?n=function(){return t.excludeMain?e.apply(this,arguments):DB(e,t).apply(this,arguments)}:n=Object.create(Object.getPrototypeOf(e));for(let i in e){let s=e[i];n[i]=typeof s=="function"&&r(i)?DB(s,t):s;}return n};});var BB=A((wde,IS)=>{var lne=he("fs"),Eo=he("path"),NB=kB(),LB={mode:511&~process.umask(),fs:lne},OB=e=>{if(process.platform==="win32"&&/[<>:"|?*]/.test(e.replace(Eo.parse(e).root,""))){let r=new Error(`Path contains invalid characters: ${e}`);throw r.code="EINVAL",r}};IS.exports=(e,t)=>Promise.resolve().then(()=>{OB(e),t=Object.assign({},LB,t);let r=NB(t.fs.mkdir),n=NB(t.fs.stat),i=s=>r(s,t.mode).then(()=>s).catch(o=>{if(o.code==="ENOENT"){if(o.message.includes("null bytes")||Eo.dirname(s)===s)throw o;return i(Eo.dirname(s)).then(()=>i(s))}return n(s).then(a=>a.isDirectory()?s:Promise.reject()).catch(()=>{throw o})});return i(Eo.resolve(e))});IS.exports.sync=(e,t)=>{OB(e),t=Object.assign({},LB,t);let r=n=>{try{t.fs.mkdirSync(n,t.mode);}catch(i){if(i.code==="ENOENT"){if(i.message.includes("null bytes")||Eo.dirname(n)===n)throw i;return r(Eo.dirname(n)),r(n)}try{if(!t.fs.statSync(n).isDirectory())throw new Error("The path is not a directory")}catch{throw i}}return n};return r(Eo.resolve(e))};});var KB=A((_de,WB)=>{var Lc,qB,Nc,FB,PS,MB,UB,$B,jB,VB,HB;Lc=he("fs");qB=he("os");Nc=he("path");FB=BB();PS=Rc();MB=SS();WB.exports=fne;UB=PS(PS.txt);$B=MB();jB=kS(Lc.writeFile);VB=kS(Lc.readdir);HB=kS(Lc.unlink);function fne(e){var t,r,n,i,s;return i={},s=new Set,o;function o(f){return Promise.resolve(f).then(a)}function a(f){f?(r||(r=dne(e.save||e.$ave).then(function(d){return t=d})),r=r.then(function(){if(t)return c(f)})):r?r.then(u).then(function(){n?.end(),t&&e.$ave&&(process.env.SSL_CERT_DIR=fc().path=t),typeof e.onsave=="function"&&e.onsave(t);}):typeof e.onsave=="function"&&e.onsave();}function c(f){var d,p;return (n||(n=Lc.createWriteStream(l("roots.pem")))).write(d=UB(f)),i[p=$B(f)]||(i[p]=0),jB(l(p+"."+i[p]++),d).catch(DS)}function l(f){return s.add(f),Nc.join(t,f)}function u(){t&&VB(t).then(function(f){return Promise.all(f.filter(function(d){return !s.has(d)}).map(function(d){return Nc.join(t,d)}).map(function(d){return HB(d).catch(DS)}))}).catch(DS);}}function hne(){return [Nc.join(__dirname,"../pem"),Nc.join(qB.homedir(),".local/win-ca/pem")]}function dne(e){var t;return typeof e=="string"?e=[e]:Array.isArray(e)||(e=hne()),t=0,r();function r(){return t<e.length?FB(e[t++]).catch(r):Promise.resolve()}}function kS(e){return function(){var t,r=this;return t=[].slice.call(arguments),new Promise(function(n,i){t.push(s),e.apply(r,t);function s(o,a){o?i(o):n(a);}})}}function DS(){}});var fc=A((Tde,QB)=>{var NS,GB,YB;QB.exports=Jr;Jr.disabled=NS=process.platform!=="win32";Jr.nApi=GB=!!process.versions.napi&&Jr===_N()&&!(Jr.electron=AN()());Jr.der2=YB=Rc();Jr.hash=pne;Jr.inject=gne;Jr.exe=mne;yne(Jr,ZO());!NS&&Jr===LS()&&Jr({inject:!0,$ave:!0,async:!0});function pne(){return (Jr.hash=SS()).apply(this,arguments)}function gne(){return (Jr.inject=CS().inject).apply(this,arguments)}function mne(){return (Jr.exe=TS().exe).apply(this,arguments)}function Jr(e){var t,r,n,i,s,o,a,c,l;if(e==null&&(e={}),t=NS||e.disabled?CB():((r=e.fallback)!=null?r:!GB)?TS():TB(),(n=e.store)?Array.isArray(n)||(n=[n]):n=[],t=t[(i=e.async)?"async":"sync"](n),s=i?f:u,e.unique!==!1&&(o=IB()()),a=YB(e.format),Array.isArray(e.ondata)&&(e.ondata=e.ondata.push.bind(e.ondata)),(e.save||e.$ave)&&(c=KB()(e)),e.inject&&(l=CS()(e.inject)),e.generator)return (i?p:d)();t.run(function(v){(!v||!o||o(v))&&s(v);});function u(v){c&&c(v),v?(l&&l(v),typeof e.ondata=="function"&&e.ondata(a(v))):typeof e.onend=="function"&&e.onend();}function f(v){Promise.resolve(v).then(u);}function d(){var v;return v={},v[Symbol.iterator]=zB,v.return=S,v.next=x,v}function p(){var v,b;return v={},v[(b=Symbol.asyncIterator)!=null?b:"@"]=zB,v.return=S,v.next=I,v}function m(v){return s(v),{done:!v,value:v!=null?a(v):v}}function S(v){return t.done(),{done:!0,value:v}}function x(){for(var v;(v=t.next())&&o&&!o(v););return m(v)}function I(){function v(){return Promise.resolve().then(t.next).then(function(b){return b&&o&&!o(b)?v():m(b)})}return v()}}function zB(){return this}function yne(e,t){for(var r in t)e[r]=t[r];return e}});var LS=A((Ade,XB)=>{XB.exports=fc();});var eq=A(xo=>{Object.defineProperty(xo,"__esModule",{value:!0});xo.convert=xo.Format=void 0;var Oc=uS(),Is;(function(e){e.der="der",e.pem="pem",e.txt="txt",e.asn1="asn1",e.x509="x509",e.fingerprint="fingerprint";})(Is=xo.Format||(xo.Format={}));function JB(e){var t=Oc.pki.pemToDer(e),r=Oc.asn1,n=r.fromDer(t.data.toString("binary")).value[0].value,i=n[0],s=i.tagClass===r.Class.CONTEXT_SPECIFIC&&i.type===0&&i.constructed,o=n.slice(s);return {serial:o[0],issuer:o[2],valid:o[3],subject:o[4]}}function vne(e){var t=JB(e),r=t.subject.value.map(function(i){return i.value[0].value[1].value}).join("/"),n=t.valid.value.map(function(i){return i.value}).join(" - ");return ["Subject	".concat(r),"Valid	".concat(n),String(e)].join(`
`)}function ZB(e,t){switch(t){case Is.der:return Oc.pki.pemToDer(e);case Is.pem:return e;case Is.txt:return vne(e);case Is.asn1:return JB(e);case Is.fingerprint:var r=Oc.md.sha1.create(),n=ZB(e,Is.der);return r.update(n.getBytes()),r.digest().toHex();case Is.x509:return Oc.pki.certificateFromPem(e);default:throw new Error("unknown format ".concat(t))}}xo.convert=ZB;});var sq=A(on=>{var wo=on&&on.__assign||function(){return wo=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++){t=arguments[r];for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);}return e},wo.apply(this,arguments)},Zh=on&&on.__spreadArray||function(e,t,r){if(r||arguments.length===2)for(var n=0,i=t.length,s;n<i;n++)(s||!(n in t))&&(s||(s=Array.prototype.slice.call(t,0,n)),s[n]=t[n]);return e.concat(s||Array.prototype.slice.call(t))};Object.defineProperty(on,"__esModule",{value:!0});on.convert=on.Format=on.addToGlobalAgent=on.get=void 0;var rq=he("https"),Sne=he("tls"),tq=he("child_process"),Qi=eq();Object.defineProperty(on,"Format",{enumerable:!0,get:function(){return Qi.Format}});Object.defineProperty(on,"convert",{enumerable:!0,get:function(){return Qi.convert}});var nq=process.platform==="darwin",td={keychain:"all",unique:!0,excludeBundled:!0,format:Qi.Format.pem};function iq(e){if(e===void 0&&(e=td),!nq)return [];e=wo(wo({},td),e);var t=/(?=-----BEGIN\sCERTIFICATE-----)/g,r=["find-certificate","-a","-p"],n=[];if(e.keychain==="all"||e.keychain==="SystemRootCertificates"){var i="/System/Library/Keychains/SystemRootCertificates.keychain",s=(0, tq.spawnSync)("/usr/bin/security",r.concat(i)).stdout.toString().split(t).map(function(l){return l.trim()});n=Zh(Zh([],n,!0),s,!0);}if(e.keychain==="all"||e.keychain==="SystemRootCertificates"){var o=(0, tq.spawnSync)("/usr/bin/security",r).stdout.toString().split(t).map(function(l){return l.trim()});n=Zh(Zh([],n,!0),o,!0);}if(e.unique||e.excludeBundled){var a=n.map(function(l){return (0, Qi.convert)(l,Qi.Format.fingerprint)}),c=e.excludeBundled?Sne.rootCertificates.map(function(l){return (0, Qi.convert)(l,Qi.Format.fingerprint)}):[];n=n.filter(function(l,u){var f=a[u];return !(e.unique&&u!==a.indexOf(f)||e.excludeBundled&&c.includes(f))});}return n.map(function(l){return (0, Qi.convert)(l,e.format)})}on.get=iq;var ed=rq.globalAgent.options.ca,bne=function(e){if(e===void 0&&(e=td),!!nq){var t;Array.isArray(ed)?t=Array.from(ed):t=typeof ed<"u"?[ed]:[],iq(wo(wo(wo({},td),e),{format:Qi.Format.pem})).forEach(function(r){return t.push(r)}),rq.globalAgent.options.ca=t;}};on.addToGlobalAgent=bne;});var ad=A(ar=>{Object.defineProperty(ar,"__esModule",{value:!0});ar.thenable=ar.typedArray=ar.stringArray=ar.array=ar.func=ar.error=ar.number=ar.string=ar.boolean=void 0;function Ene(e){return e===!0||e===!1}ar.boolean=Ene;function pq(e){return typeof e=="string"||e instanceof String}ar.string=pq;function xne(e){return typeof e=="number"||e instanceof Number}ar.number=xne;function wne(e){return e instanceof Error}ar.error=wne;function gq(e){return typeof e=="function"}ar.func=gq;function mq(e){return Array.isArray(e)}ar.array=mq;function _ne(e){return mq(e)&&e.every(t=>pq(t))}ar.stringArray=_ne;function Tne(e,t){return Array.isArray(e)&&e.every(t)}ar.typedArray=Tne;function Ane(e){return e&&gq(e.then)}ar.thenable=Ane;});var Oa=A(Or=>{Object.defineProperty(Or,"__esModule",{value:!0});Or.stringArray=Or.array=Or.func=Or.error=Or.number=Or.string=Or.boolean=void 0;function Rne(e){return e===!0||e===!1}Or.boolean=Rne;function yq(e){return typeof e=="string"||e instanceof String}Or.string=yq;function Ine(e){return typeof e=="number"||e instanceof Number}Or.number=Ine;function Dne(e){return e instanceof Error}Or.error=Dne;function Pne(e){return typeof e=="function"}Or.func=Pne;function vq(e){return Array.isArray(e)}Or.array=vq;function kne(e){return vq(e)&&e.every(t=>yq(t))}Or.stringArray=kne;});var ub=A(qe=>{Object.defineProperty(qe,"__esModule",{value:!0});qe.Message=qe.NotificationType9=qe.NotificationType8=qe.NotificationType7=qe.NotificationType6=qe.NotificationType5=qe.NotificationType4=qe.NotificationType3=qe.NotificationType2=qe.NotificationType1=qe.NotificationType0=qe.NotificationType=qe.RequestType9=qe.RequestType8=qe.RequestType7=qe.RequestType6=qe.RequestType5=qe.RequestType4=qe.RequestType3=qe.RequestType2=qe.RequestType1=qe.RequestType=qe.RequestType0=qe.AbstractMessageSignature=qe.ParameterStructures=qe.ResponseError=qe.ErrorCodes=void 0;var To=Oa(),FS;(function(e){e.ParseError=-32700,e.InvalidRequest=-32600,e.MethodNotFound=-32601,e.InvalidParams=-32602,e.InternalError=-32603,e.jsonrpcReservedErrorRangeStart=-32099,e.serverErrorStart=-32099,e.MessageWriteError=-32099,e.MessageReadError=-32098,e.PendingResponseRejected=-32097,e.ConnectionInactive=-32096,e.ServerNotInitialized=-32002,e.UnknownErrorCode=-32001,e.jsonrpcReservedErrorRangeEnd=-32e3,e.serverErrorEnd=-32e3;})(FS||(qe.ErrorCodes=FS={}));var MS=class e extends Error{constructor(t,r,n){super(r),this.code=To.number(t)?t:FS.UnknownErrorCode,this.data=n,Object.setPrototypeOf(this,e.prototype);}toJson(){let t={code:this.code,message:this.message};return this.data!==void 0&&(t.data=this.data),t}};qe.ResponseError=MS;var an=class e{constructor(t){this.kind=t;}static is(t){return t===e.auto||t===e.byName||t===e.byPosition}toString(){return this.kind}};qe.ParameterStructures=an;an.auto=new an("auto");an.byPosition=new an("byPosition");an.byName=new an("byName");var Ht=class{constructor(t,r){this.method=t,this.numberOfParams=r;}get parameterStructures(){return an.auto}};qe.AbstractMessageSignature=Ht;var US=class extends Ht{constructor(t){super(t,0);}};qe.RequestType0=US;var $S=class extends Ht{constructor(t,r=an.auto){super(t,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};qe.RequestType=$S;var jS=class extends Ht{constructor(t,r=an.auto){super(t,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};qe.RequestType1=jS;var VS=class extends Ht{constructor(t){super(t,2);}};qe.RequestType2=VS;var HS=class extends Ht{constructor(t){super(t,3);}};qe.RequestType3=HS;var WS=class extends Ht{constructor(t){super(t,4);}};qe.RequestType4=WS;var KS=class extends Ht{constructor(t){super(t,5);}};qe.RequestType5=KS;var zS=class extends Ht{constructor(t){super(t,6);}};qe.RequestType6=zS;var GS=class extends Ht{constructor(t){super(t,7);}};qe.RequestType7=GS;var YS=class extends Ht{constructor(t){super(t,8);}};qe.RequestType8=YS;var QS=class extends Ht{constructor(t){super(t,9);}};qe.RequestType9=QS;var XS=class extends Ht{constructor(t,r=an.auto){super(t,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};qe.NotificationType=XS;var JS=class extends Ht{constructor(t){super(t,0);}};qe.NotificationType0=JS;var ZS=class extends Ht{constructor(t,r=an.auto){super(t,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};qe.NotificationType1=ZS;var eb=class extends Ht{constructor(t){super(t,2);}};qe.NotificationType2=eb;var tb=class extends Ht{constructor(t){super(t,3);}};qe.NotificationType3=tb;var rb=class extends Ht{constructor(t){super(t,4);}};qe.NotificationType4=rb;var nb=class extends Ht{constructor(t){super(t,5);}};qe.NotificationType5=nb;var ib=class extends Ht{constructor(t){super(t,6);}};qe.NotificationType6=ib;var sb=class extends Ht{constructor(t){super(t,7);}};qe.NotificationType7=sb;var ob=class extends Ht{constructor(t){super(t,8);}};qe.NotificationType8=ob;var ab=class extends Ht{constructor(t){super(t,9);}};qe.NotificationType9=ab;var Sq;(function(e){function t(i){let s=i;return s&&To.string(s.method)&&(To.string(s.id)||To.number(s.id))}e.isRequest=t;function r(i){let s=i;return s&&To.string(s.method)&&i.id===void 0}e.isNotification=r;function n(i){let s=i;return s&&(s.result!==void 0||!!s.error)&&(To.string(s.id)||To.number(s.id)||s.id===null)}e.isResponse=n;})(Sq||(qe.Message=Sq={}));});var lb=A(Ds=>{var bq;Object.defineProperty(Ds,"__esModule",{value:!0});Ds.LRUCache=Ds.LinkedMap=Ds.Touch=void 0;var Br;(function(e){e.None=0,e.First=1,e.AsOld=e.First,e.Last=2,e.AsNew=e.Last;})(Br||(Ds.Touch=Br={}));var ud=class{constructor(){this[bq]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0;}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++;}isEmpty(){return !this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=Br.None){let n=this._map.get(t);if(n)return r!==Br.None&&this.touch(n,r),n.value}set(t,r,n=Br.None){let i=this._map.get(t);if(i)i.value=r,n!==Br.None&&this.touch(i,n);else {switch(i={key:t,value:r,next:void 0,previous:void 0},n){case Br.None:this.addItemLast(i);break;case Br.First:this.addItemFirst(i);break;case Br.Last:this.addItemLast(i);break;default:this.addItemLast(i);break}this._map.set(t,i),this._size++;}return this}delete(t){return !!this.remove(t)}remove(t){let r=this._map.get(t);if(r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");let t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){let n=this._state,i=this._head;for(;i;){if(r?t.bind(r)(i.value,i.key,this):t(i.value,i.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");i=i.next;}}keys(){let t=this._state,r=this._head,n={[Symbol.iterator]:()=>n,next:()=>{if(this._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){let i={value:r.key,done:!1};return r=r.next,i}else return {value:void 0,done:!0}}};return n}values(){let t=this._state,r=this._head,n={[Symbol.iterator]:()=>n,next:()=>{if(this._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){let i={value:r.value,done:!1};return r=r.next,i}else return {value:void 0,done:!0}}};return n}entries(){let t=this._state,r=this._head,n={[Symbol.iterator]:()=>n,next:()=>{if(this._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){let i={value:[r.key,r.value],done:!1};return r=r.next,i}else return {value:void 0,done:!0}}};return n}[(bq=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>t;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++;}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++;}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++;}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next;}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous;}else {let r=t.next,n=t.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r;}t.next=void 0,t.previous=void 0,this._state++;}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==Br.First&&r!==Br.Last)){if(r===Br.First){if(t===this._head)return;let n=t.next,i=t.previous;t===this._tail?(i.next=void 0,this._tail=i):(n.previous=i,i.next=n),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++;}else if(r===Br.Last){if(t===this._tail)return;let n=t.next,i=t.previous;t===this._head?(n.previous=void 0,this._head=n):(n.previous=i,i.next=n),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++;}}}toJSON(){let t=[];return this.forEach((r,n)=>{t.push([n,r]);}),t}fromJSON(t){this.clear();for(let[r,n]of t)this.set(r,n);}};Ds.LinkedMap=ud;var cb=class extends ud{constructor(t,r=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,r),1);}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim();}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim();}get(t,r=Br.AsNew){return super.get(t,r)}peek(t){return super.get(t,Br.None)}set(t,r){return super.set(t,r,Br.Last),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio));}};Ds.LRUCache=cb;});var Eq=A(cd=>{Object.defineProperty(cd,"__esModule",{value:!0});cd.Disposable=void 0;var Cq;(function(e){function t(r){return {dispose:r}}e.create=t;})(Cq||(cd.Disposable=Cq={}));});var Ps=A(db=>{Object.defineProperty(db,"__esModule",{value:!0});var fb;function hb(){if(fb===void 0)throw new Error("No runtime abstraction layer installed");return fb}(function(e){function t(r){if(r===void 0)throw new Error("No runtime abstraction layer provided");fb=r;}e.install=t;})(hb||(hb={}));db.default=hb;});var qa=A(Ba=>{Object.defineProperty(Ba,"__esModule",{value:!0});Ba.Emitter=Ba.Event=void 0;var Nne=Ps(),xq;(function(e){let t={dispose(){}};e.None=function(){return t};})(xq||(Ba.Event=xq={}));var pb=class{add(t,r=null,n){this._callbacks||(this._callbacks=[],this._contexts=[]),this._callbacks.push(t),this._contexts.push(r),Array.isArray(n)&&n.push({dispose:()=>this.remove(t,r)});}remove(t,r=null){if(!this._callbacks)return;let n=!1;for(let i=0,s=this._callbacks.length;i<s;i++)if(this._callbacks[i]===t)if(this._contexts[i]===r){this._callbacks.splice(i,1),this._contexts.splice(i,1);return}else n=!0;if(n)throw new Error("When adding a listener with a context, you should remove it with the same context")}invoke(...t){if(!this._callbacks)return [];let r=[],n=this._callbacks.slice(0),i=this._contexts.slice(0);for(let s=0,o=n.length;s<o;s++)try{r.push(n[s].apply(i[s],t));}catch(a){(0, Nne.default)().console.error(a);}return r}isEmpty(){return !this._callbacks||this._callbacks.length===0}dispose(){this._callbacks=void 0,this._contexts=void 0;}},ld=class e{constructor(t){this._options=t;}get event(){return this._event||(this._event=(t,r,n)=>{this._callbacks||(this._callbacks=new pb),this._options&&this._options.onFirstListenerAdd&&this._callbacks.isEmpty()&&this._options.onFirstListenerAdd(this),this._callbacks.add(t,r);let i={dispose:()=>{this._callbacks&&(this._callbacks.remove(t,r),i.dispose=e._noop,this._options&&this._options.onLastListenerRemove&&this._callbacks.isEmpty()&&this._options.onLastListenerRemove(this));}};return Array.isArray(n)&&n.push(i),i}),this._event}fire(t){this._callbacks&&this._callbacks.invoke.call(this._callbacks,t);}dispose(){this._callbacks&&(this._callbacks.dispose(),this._callbacks=void 0);}};Ba.Emitter=ld;ld._noop=function(){};});var dd=A(Fa=>{Object.defineProperty(Fa,"__esModule",{value:!0});Fa.CancellationTokenSource=Fa.CancellationToken=void 0;var Lne=Ps(),One=Oa(),gb=qa(),fd;(function(e){e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:gb.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:gb.Event.None});function t(r){let n=r;return n&&(n===e.None||n===e.Cancelled||One.boolean(n.isCancellationRequested)&&!!n.onCancellationRequested)}e.is=t;})(fd||(Fa.CancellationToken=fd={}));var Bne=Object.freeze(function(e,t){let r=(0, Lne.default)().timer.setTimeout(e.bind(t),0);return {dispose(){r.dispose();}}}),hd=class{constructor(){this._isCancelled=!1;}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()));}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?Bne:(this._emitter||(this._emitter=new gb.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=void 0);}},mb=class{get token(){return this._token||(this._token=new hd),this._token}cancel(){this._token?this._token.cancel():this._token=fd.Cancelled;}dispose(){this._token?this._token instanceof hd&&this._token.dispose():this._token=fd.None;}};Fa.CancellationTokenSource=mb;});var wq=A(Ma=>{Object.defineProperty(Ma,"__esModule",{value:!0});Ma.SharedArrayReceiverStrategy=Ma.SharedArraySenderStrategy=void 0;var qne=dd(),Bc;(function(e){e.Continue=0,e.Cancelled=1;})(Bc||(Bc={}));var yb=class{constructor(){this.buffers=new Map;}enableCancellation(t){if(t.id===null)return;let r=new SharedArrayBuffer(4),n=new Int32Array(r,0,1);n[0]=Bc.Continue,this.buffers.set(t.id,r),t.$cancellationData=r;}async sendCancellation(t,r){let n=this.buffers.get(r);if(n===void 0)return;let i=new Int32Array(n,0,1);Atomics.store(i,0,Bc.Cancelled);}cleanup(t){this.buffers.delete(t);}dispose(){this.buffers.clear();}};Ma.SharedArraySenderStrategy=yb;var vb=class{constructor(t){this.data=new Int32Array(t,0,1);}get isCancellationRequested(){return Atomics.load(this.data,0)===Bc.Cancelled}get onCancellationRequested(){throw new Error("Cancellation over SharedArrayBuffer doesn't support cancellation events")}},Sb=class{constructor(t){this.token=new vb(t);}cancel(){}dispose(){}},bb=class{constructor(){this.kind="request";}createCancellationTokenSource(t){let r=t.$cancellationData;return r===void 0?new qne.CancellationTokenSource:new Sb(r)}};Ma.SharedArrayReceiverStrategy=bb;});var Eb=A(pd=>{Object.defineProperty(pd,"__esModule",{value:!0});pd.Semaphore=void 0;var Fne=Ps(),Cb=class{constructor(t=1){if(t<=0)throw new Error("Capacity must be greater than 0");this._capacity=t,this._active=0,this._waiting=[];}lock(t){return new Promise((r,n)=>{this._waiting.push({thunk:t,resolve:r,reject:n}),this.runNext();})}get active(){return this._active}runNext(){this._waiting.length===0||this._active===this._capacity||(0, Fne.default)().timer.setImmediate(()=>this.doRunNext());}doRunNext(){if(this._waiting.length===0||this._active===this._capacity)return;let t=this._waiting.shift();if(this._active++,this._active>this._capacity)throw new Error("To many thunks active");try{let r=t.thunk();r instanceof Promise?r.then(n=>{this._active--,t.resolve(n),this.runNext();},n=>{this._active--,t.reject(n),this.runNext();}):(this._active--,t.resolve(r),this.runNext());}catch(r){this._active--,t.reject(r),this.runNext();}}};pd.Semaphore=Cb;});var Tq=A(ks=>{Object.defineProperty(ks,"__esModule",{value:!0});ks.ReadableStreamMessageReader=ks.AbstractMessageReader=ks.MessageReader=void 0;var wb=Ps(),Ua=Oa(),xb=qa(),Mne=Eb(),_q;(function(e){function t(r){let n=r;return n&&Ua.func(n.listen)&&Ua.func(n.dispose)&&Ua.func(n.onError)&&Ua.func(n.onClose)&&Ua.func(n.onPartialMessage)}e.is=t;})(_q||(ks.MessageReader=_q={}));var gd=class{constructor(){this.errorEmitter=new xb.Emitter,this.closeEmitter=new xb.Emitter,this.partialMessageEmitter=new xb.Emitter;}dispose(){this.errorEmitter.dispose(),this.closeEmitter.dispose();}get onError(){return this.errorEmitter.event}fireError(t){this.errorEmitter.fire(this.asError(t));}get onClose(){return this.closeEmitter.event}fireClose(){this.closeEmitter.fire(void 0);}get onPartialMessage(){return this.partialMessageEmitter.event}firePartialMessage(t){this.partialMessageEmitter.fire(t);}asError(t){return t instanceof Error?t:new Error(`Reader received error. Reason: ${Ua.string(t.message)?t.message:"unknown"}`)}};ks.AbstractMessageReader=gd;var _b;(function(e){function t(r){let n,s,o=new Map,a,c=new Map;if(r===void 0||typeof r=="string")n=r??"utf-8";else {if(n=r.charset??"utf-8",r.contentDecoder!==void 0&&(s=r.contentDecoder,o.set(s.name,s)),r.contentDecoders!==void 0)for(let l of r.contentDecoders)o.set(l.name,l);if(r.contentTypeDecoder!==void 0&&(a=r.contentTypeDecoder,c.set(a.name,a)),r.contentTypeDecoders!==void 0)for(let l of r.contentTypeDecoders)c.set(l.name,l);}return a===void 0&&(a=(0, wb.default)().applicationJson.decoder,c.set(a.name,a)),{charset:n,contentDecoder:s,contentDecoders:o,contentTypeDecoder:a,contentTypeDecoders:c}}e.fromOptions=t;})(_b||(_b={}));var Tb=class extends gd{constructor(t,r){super(),this.readable=t,this.options=_b.fromOptions(r),this.buffer=(0, wb.default)().messageBuffer.create(this.options.charset),this._partialMessageTimeout=1e4,this.nextMessageLength=-1,this.messageToken=0,this.readSemaphore=new Mne.Semaphore(1);}set partialMessageTimeout(t){this._partialMessageTimeout=t;}get partialMessageTimeout(){return this._partialMessageTimeout}listen(t){this.nextMessageLength=-1,this.messageToken=0,this.partialMessageTimer=void 0,this.callback=t;let r=this.readable.onData(n=>{this.onData(n);});return this.readable.onError(n=>this.fireError(n)),this.readable.onClose(()=>this.fireClose()),r}onData(t){try{for(this.buffer.append(t);;){if(this.nextMessageLength===-1){let n=this.buffer.tryReadHeaders(!0);if(!n)return;let i=n.get("content-length");if(!i){this.fireError(new Error(`Header must provide a Content-Length property.
${JSON.stringify(Object.fromEntries(n))}`));return}let s=parseInt(i);if(isNaN(s)){this.fireError(new Error(`Content-Length value must be a number. Got ${i}`));return}this.nextMessageLength=s;}let r=this.buffer.tryReadBody(this.nextMessageLength);if(r===void 0){this.setPartialMessageTimer();return}this.clearPartialMessageTimer(),this.nextMessageLength=-1,this.readSemaphore.lock(async()=>{let n=this.options.contentDecoder!==void 0?await this.options.contentDecoder.decode(r):r,i=await this.options.contentTypeDecoder.decode(n,this.options);this.callback(i);}).catch(n=>{this.fireError(n);});}}catch(r){this.fireError(r);}}clearPartialMessageTimer(){this.partialMessageTimer&&(this.partialMessageTimer.dispose(),this.partialMessageTimer=void 0);}setPartialMessageTimer(){this.clearPartialMessageTimer(),!(this._partialMessageTimeout<=0)&&(this.partialMessageTimer=(0, wb.default)().timer.setTimeout((t,r)=>{this.partialMessageTimer=void 0,t===this.messageToken&&(this.firePartialMessage({messageToken:t,waitingTime:r}),this.setPartialMessageTimer());},this._partialMessageTimeout,this.messageToken,this._partialMessageTimeout));}};ks.ReadableStreamMessageReader=Tb;});var Pq=A(Ns=>{Object.defineProperty(Ns,"__esModule",{value:!0});Ns.WriteableStreamMessageWriter=Ns.AbstractMessageWriter=Ns.MessageWriter=void 0;var Aq=Ps(),qc=Oa(),Une=Eb(),Rq=qa(),$ne="Content-Length: ",Iq=`\r
`,Dq;(function(e){function t(r){let n=r;return n&&qc.func(n.dispose)&&qc.func(n.onClose)&&qc.func(n.onError)&&qc.func(n.write)}e.is=t;})(Dq||(Ns.MessageWriter=Dq={}));var md=class{constructor(){this.errorEmitter=new Rq.Emitter,this.closeEmitter=new Rq.Emitter;}dispose(){this.errorEmitter.dispose(),this.closeEmitter.dispose();}get onError(){return this.errorEmitter.event}fireError(t,r,n){this.errorEmitter.fire([this.asError(t),r,n]);}get onClose(){return this.closeEmitter.event}fireClose(){this.closeEmitter.fire(void 0);}asError(t){return t instanceof Error?t:new Error(`Writer received error. Reason: ${qc.string(t.message)?t.message:"unknown"}`)}};Ns.AbstractMessageWriter=md;var Ab;(function(e){function t(r){return r===void 0||typeof r=="string"?{charset:r??"utf-8",contentTypeEncoder:(0, Aq.default)().applicationJson.encoder}:{charset:r.charset??"utf-8",contentEncoder:r.contentEncoder,contentTypeEncoder:r.contentTypeEncoder??(0, Aq.default)().applicationJson.encoder}}e.fromOptions=t;})(Ab||(Ab={}));var Rb=class extends md{constructor(t,r){super(),this.writable=t,this.options=Ab.fromOptions(r),this.errorCount=0,this.writeSemaphore=new Une.Semaphore(1),this.writable.onError(n=>this.fireError(n)),this.writable.onClose(()=>this.fireClose());}async write(t){return this.writeSemaphore.lock(async()=>this.options.contentTypeEncoder.encode(t,this.options).then(n=>this.options.contentEncoder!==void 0?this.options.contentEncoder.encode(n):n).then(n=>{let i=[];return i.push($ne,n.byteLength.toString(),Iq),i.push(Iq),this.doWrite(t,i,n)},n=>{throw this.fireError(n),n}))}async doWrite(t,r,n){try{return await this.writable.write(r.join(""),"ascii"),this.writable.write(n)}catch(i){return this.handleError(i,t),Promise.reject(i)}}handleError(t,r){this.errorCount++,this.fireError(t,r,this.errorCount);}end(){this.writable.end();}};Ns.WriteableStreamMessageWriter=Rb;});var kq=A(yd=>{Object.defineProperty(yd,"__esModule",{value:!0});yd.AbstractMessageBuffer=void 0;var jne=13,Vne=10,Hne=`\r
`,Ib=class{constructor(t="utf-8"){this._encoding=t,this._chunks=[],this._totalLength=0;}get encoding(){return this._encoding}append(t){let r=typeof t=="string"?this.fromString(t,this._encoding):t;this._chunks.push(r),this._totalLength+=r.byteLength;}tryReadHeaders(t=!1){if(this._chunks.length===0)return;let r=0,n=0,i=0,s=0;e:for(;n<this._chunks.length;){let l=this._chunks[n];for(i=0;i<l.length;){switch(l[i]){case jne:switch(r){case 0:r=1;break;case 2:r=3;break;default:r=0;}break;case Vne:switch(r){case 1:r=2;break;case 3:r=4,i++;break e;default:r=0;}break;default:r=0;}i++;}s+=l.byteLength,n++;}if(r!==4)return;let o=this._read(s+i),a=new Map,c=this.toString(o,"ascii").split(Hne);if(c.length<2)return a;for(let l=0;l<c.length-2;l++){let u=c[l],f=u.indexOf(":");if(f===-1)throw new Error(`Message header must separate key and value using ':'
${u}`);let d=u.substr(0,f),p=u.substr(f+1).trim();a.set(t?d.toLowerCase():d,p);}return a}tryReadBody(t){if(!(this._totalLength<t))return this._read(t)}get numberOfBytes(){return this._totalLength}_read(t){if(t===0)return this.emptyBuffer();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){let s=this._chunks[0];return this._chunks.shift(),this._totalLength-=t,this.asNative(s)}if(this._chunks[0].byteLength>t){let s=this._chunks[0],o=this.asNative(s,t);return this._chunks[0]=s.slice(t),this._totalLength-=t,o}let r=this.allocNative(t),n=0,i=0;for(;t>0;){let s=this._chunks[i];if(s.byteLength>t){let o=s.slice(0,t);r.set(o,n),n+=t,this._chunks[i]=s.slice(t),this._totalLength-=t,t-=t;}else r.set(s,n),n+=s.byteLength,this._chunks.shift(),this._totalLength-=s.byteLength,t-=s.byteLength;}return r}};yd.AbstractMessageBuffer=Ib;});var qq=A(et=>{Object.defineProperty(et,"__esModule",{value:!0});et.createMessageConnection=et.ConnectionOptions=et.MessageStrategy=et.CancellationStrategy=et.CancellationSenderStrategy=et.CancellationReceiverStrategy=et.RequestCancellationReceiverStrategy=et.IdCancellationReceiverStrategy=et.ConnectionStrategy=et.ConnectionError=et.ConnectionErrors=et.LogTraceNotification=et.SetTraceNotification=et.TraceFormat=et.TraceValues=et.Trace=et.NullLogger=et.ProgressType=et.ProgressToken=void 0;var Nq=Ps(),Xt=Oa(),Ve=ub(),Lq=lb(),Fc=qa(),Db=dd(),$c;(function(e){e.type=new Ve.NotificationType("$/cancelRequest");})($c||($c={}));var Pb;(function(e){function t(r){return typeof r=="string"||typeof r=="number"}e.is=t;})(Pb||(et.ProgressToken=Pb={}));var Mc;(function(e){e.type=new Ve.NotificationType("$/progress");})(Mc||(Mc={}));var kb=class{constructor(){}};et.ProgressType=kb;var Nb;(function(e){function t(r){return Xt.func(r)}e.is=t;})(Nb||(Nb={}));et.NullLogger=Object.freeze({error:()=>{},warn:()=>{},info:()=>{},log:()=>{}});var _t;(function(e){e[e.Off=0]="Off",e[e.Messages=1]="Messages",e[e.Compact=2]="Compact",e[e.Verbose=3]="Verbose";})(_t||(et.Trace=_t={}));var Oq;(function(e){e.Off="off",e.Messages="messages",e.Compact="compact",e.Verbose="verbose";})(Oq||(et.TraceValues=Oq={}));(function(e){function t(n){if(!Xt.string(n))return e.Off;switch(n=n.toLowerCase(),n){case"off":return e.Off;case"messages":return e.Messages;case"compact":return e.Compact;case"verbose":return e.Verbose;default:return e.Off}}e.fromString=t;function r(n){switch(n){case e.Off:return "off";case e.Messages:return "messages";case e.Compact:return "compact";case e.Verbose:return "verbose";default:return "off"}}e.toString=r;})(_t||(et.Trace=_t={}));var xn;(function(e){e.Text="text",e.JSON="json";})(xn||(et.TraceFormat=xn={}));(function(e){function t(r){return Xt.string(r)?(r=r.toLowerCase(),r==="json"?e.JSON:e.Text):e.Text}e.fromString=t;})(xn||(et.TraceFormat=xn={}));var Lb;(function(e){e.type=new Ve.NotificationType("$/setTrace");})(Lb||(et.SetTraceNotification=Lb={}));var vd;(function(e){e.type=new Ve.NotificationType("$/logTrace");})(vd||(et.LogTraceNotification=vd={}));var Uc;(function(e){e[e.Closed=1]="Closed",e[e.Disposed=2]="Disposed",e[e.AlreadyListening=3]="AlreadyListening";})(Uc||(et.ConnectionErrors=Uc={}));var $a=class e extends Error{constructor(t,r){super(r),this.code=t,Object.setPrototypeOf(this,e.prototype);}};et.ConnectionError=$a;var Ob;(function(e){function t(r){let n=r;return n&&Xt.func(n.cancelUndispatched)}e.is=t;})(Ob||(et.ConnectionStrategy=Ob={}));var Sd;(function(e){function t(r){let n=r;return n&&(n.kind===void 0||n.kind==="id")&&Xt.func(n.createCancellationTokenSource)&&(n.dispose===void 0||Xt.func(n.dispose))}e.is=t;})(Sd||(et.IdCancellationReceiverStrategy=Sd={}));var Bb;(function(e){function t(r){let n=r;return n&&n.kind==="request"&&Xt.func(n.createCancellationTokenSource)&&(n.dispose===void 0||Xt.func(n.dispose))}e.is=t;})(Bb||(et.RequestCancellationReceiverStrategy=Bb={}));var bd;(function(e){e.Message=Object.freeze({createCancellationTokenSource(r){return new Db.CancellationTokenSource}});function t(r){return Sd.is(r)||Bb.is(r)}e.is=t;})(bd||(et.CancellationReceiverStrategy=bd={}));var Cd;(function(e){e.Message=Object.freeze({sendCancellation(r,n){return r.sendNotification($c.type,{id:n})},cleanup(r){}});function t(r){let n=r;return n&&Xt.func(n.sendCancellation)&&Xt.func(n.cleanup)}e.is=t;})(Cd||(et.CancellationSenderStrategy=Cd={}));var Ed;(function(e){e.Message=Object.freeze({receiver:bd.Message,sender:Cd.Message});function t(r){let n=r;return n&&bd.is(n.receiver)&&Cd.is(n.sender)}e.is=t;})(Ed||(et.CancellationStrategy=Ed={}));var xd;(function(e){function t(r){let n=r;return n&&Xt.func(n.handleMessage)}e.is=t;})(xd||(et.MessageStrategy=xd={}));var Bq;(function(e){function t(r){let n=r;return n&&(Ed.is(n.cancellationStrategy)||Ob.is(n.connectionStrategy)||xd.is(n.messageStrategy))}e.is=t;})(Bq||(et.ConnectionOptions=Bq={}));var si;(function(e){e[e.New=1]="New",e[e.Listening=2]="Listening",e[e.Closed=3]="Closed",e[e.Disposed=4]="Disposed";})(si||(si={}));function Wne(e,t,r,n){let i=r!==void 0?r:et.NullLogger,s=0,o=0,a=0,c="2.0",l,u=new Map,f,d=new Map,p=new Map,m,S=new Lq.LinkedMap,x=new Map,I=new Set,v=new Map,b=_t.Off,D=xn.Text,L,j=si.New,J=new Fc.Emitter,K=new Fc.Emitter,G=new Fc.Emitter,ee=new Fc.Emitter,M=new Fc.Emitter,ae=n&&n.cancellationStrategy?n.cancellationStrategy:Ed.Message;function me(q){if(q===null)throw new Error("Can't send requests with id null since the response can't be correlated.");return "req-"+q.toString()}function Le(q){return q===null?"res-unknown-"+(++a).toString():"res-"+q.toString()}function H(){return "not-"+(++o).toString()}function W(q,ne){Ve.Message.isRequest(ne)?q.set(me(ne.id),ne):Ve.Message.isResponse(ne)?q.set(Le(ne.id),ne):q.set(H(),ne);}function se(q){}function Te(){return j===si.Listening}function Fe(){return j===si.Closed}function ze(){return j===si.Disposed}function He(){(j===si.New||j===si.Listening)&&(j=si.Closed,K.fire(void 0));}function ct(q){J.fire([q,void 0,void 0]);}function Lt(q){J.fire(q);}e.onClose(He),e.onError(ct),t.onClose(He),t.onError(Lt);function xt(){m||S.size===0||(m=(0, Nq.default)().timer.setImmediate(()=>{m=void 0,Oe();}));}function dt(q){Ve.Message.isRequest(q)?Ut(q):Ve.Message.isNotification(q)?je(q):Ve.Message.isResponse(q)?ge(q):ce(q);}function Oe(){if(S.size===0)return;let q=S.shift();try{let ne=n?.messageStrategy;xd.is(ne)?ne.handleMessage(q,dt):dt(q);}finally{xt();}}let Pt=q=>{try{if(Ve.Message.isNotification(q)&&q.method===$c.type.method){let ne=q.params.id,be=me(ne),Pe=S.get(be);if(Ve.Message.isRequest(Pe)){let yt=n?.connectionStrategy,kt=yt&&yt.cancelUndispatched?yt.cancelUndispatched(Pe,se):void 0;if(kt&&(kt.error!==void 0||kt.result!==void 0)){S.delete(be),v.delete(ne),kt.id=Pe.id,Ge(kt,q.method,Date.now()),t.write(kt).catch(()=>i.error("Sending response for canceled message failed."));return}}let wt=v.get(ne);if(wt!==void 0){wt.cancel(),Mr(q);return}else I.add(ne);}W(S,q);}finally{xt();}};function Ut(q){if(ze())return;function ne(it,Rt,pt){let Wt={jsonrpc:c,id:q.id};it instanceof Ve.ResponseError?Wt.error=it.toJson():Wt.result=it===void 0?null:it,Ge(Wt,Rt,pt),t.write(Wt).catch(()=>i.error("Sending response failed."));}function be(it,Rt,pt){let Wt={jsonrpc:c,id:q.id,error:it.toJson()};Ge(Wt,Rt,pt),t.write(Wt).catch(()=>i.error("Sending response failed."));}function Pe(it,Rt,pt){it===void 0&&(it=null);let Wt={jsonrpc:c,id:q.id,result:it};Ge(Wt,Rt,pt),t.write(Wt).catch(()=>i.error("Sending response failed."));}_n(q);let wt=u.get(q.method),yt,kt;wt&&(yt=wt.type,kt=wt.handler);let Bt=Date.now();if(kt||l){let it=q.id??String(Date.now()),Rt=Sd.is(ae.receiver)?ae.receiver.createCancellationTokenSource(it):ae.receiver.createCancellationTokenSource(q);q.id!==null&&I.has(q.id)&&Rt.cancel(),q.id!==null&&v.set(it,Rt);try{let pt;if(kt)if(q.params===void 0){if(yt!==void 0&&yt.numberOfParams!==0){be(new Ve.ResponseError(Ve.ErrorCodes.InvalidParams,`Request ${q.method} defines ${yt.numberOfParams} params but received none.`),q.method,Bt);return}pt=kt(Rt.token);}else if(Array.isArray(q.params)){if(yt!==void 0&&yt.parameterStructures===Ve.ParameterStructures.byName){be(new Ve.ResponseError(Ve.ErrorCodes.InvalidParams,`Request ${q.method} defines parameters by name but received parameters by position`),q.method,Bt);return}pt=kt(...q.params,Rt.token);}else {if(yt!==void 0&&yt.parameterStructures===Ve.ParameterStructures.byPosition){be(new Ve.ResponseError(Ve.ErrorCodes.InvalidParams,`Request ${q.method} defines parameters by position but received parameters by name`),q.method,Bt);return}pt=kt(q.params,Rt.token);}else l&&(pt=l(q.method,q.params,Rt.token));let Wt=pt;pt?Wt.then?Wt.then(er=>{v.delete(it),ne(er,q.method,Bt);},er=>{v.delete(it),er instanceof Ve.ResponseError?be(er,q.method,Bt):er&&Xt.string(er.message)?be(new Ve.ResponseError(Ve.ErrorCodes.InternalError,`Request ${q.method} failed with message: ${er.message}`),q.method,Bt):be(new Ve.ResponseError(Ve.ErrorCodes.InternalError,`Request ${q.method} failed unexpectedly without providing any details.`),q.method,Bt);}):(v.delete(it),ne(pt,q.method,Bt)):(v.delete(it),Pe(pt,q.method,Bt));}catch(pt){v.delete(it),pt instanceof Ve.ResponseError?ne(pt,q.method,Bt):pt&&Xt.string(pt.message)?be(new Ve.ResponseError(Ve.ErrorCodes.InternalError,`Request ${q.method} failed with message: ${pt.message}`),q.method,Bt):be(new Ve.ResponseError(Ve.ErrorCodes.InternalError,`Request ${q.method} failed unexpectedly without providing any details.`),q.method,Bt);}}else be(new Ve.ResponseError(Ve.ErrorCodes.MethodNotFound,`Unhandled method ${q.method}`),q.method,Bt);}function ge(q){if(!ze())if(q.id===null)q.error?i.error(`Received response message without id: Error is: 
${JSON.stringify(q.error,void 0,4)}`):i.error("Received response message without id. No further error information provided.");else {let ne=q.id,be=x.get(ne);if(js(q,be),be!==void 0){x.delete(ne);try{if(q.error){let Pe=q.error;be.reject(new Ve.ResponseError(Pe.code,Pe.message,Pe.data));}else if(q.result!==void 0)be.resolve(q.result);else throw new Error("Should never happen.")}catch(Pe){Pe.message?i.error(`Response handler '${be.method}' failed with message: ${Pe.message}`):i.error(`Response handler '${be.method}' failed unexpectedly.`);}}}}function je(q){if(ze())return;let ne,be;if(q.method===$c.type.method){let Pe=q.params.id;I.delete(Pe),Mr(q);return}else {let Pe=d.get(q.method);Pe&&(be=Pe.handler,ne=Pe.type);}if(be||f)try{if(Mr(q),be)if(q.params===void 0)ne!==void 0&&ne.numberOfParams!==0&&ne.parameterStructures!==Ve.ParameterStructures.byName&&i.error(`Notification ${q.method} defines ${ne.numberOfParams} params but received none.`),be();else if(Array.isArray(q.params)){let Pe=q.params;q.method===Mc.type.method&&Pe.length===2&&Pb.is(Pe[0])?be({token:Pe[0],value:Pe[1]}):(ne!==void 0&&(ne.parameterStructures===Ve.ParameterStructures.byName&&i.error(`Notification ${q.method} defines parameters by name but received parameters by position`),ne.numberOfParams!==q.params.length&&i.error(`Notification ${q.method} defines ${ne.numberOfParams} params but received ${Pe.length} arguments`)),be(...Pe));}else ne!==void 0&&ne.parameterStructures===Ve.ParameterStructures.byPosition&&i.error(`Notification ${q.method} defines parameters by position but received parameters by name`),be(q.params);else f&&f(q.method,q.params);}catch(Pe){Pe.message?i.error(`Notification handler '${q.method}' failed with message: ${Pe.message}`):i.error(`Notification handler '${q.method}' failed unexpectedly.`);}else G.fire(q);}function ce(q){if(!q){i.error("Received empty message.");return}i.error(`Received message which is neither a response nor a notification message:
${JSON.stringify(q,null,4)}`);let ne=q;if(Xt.string(ne.id)||Xt.number(ne.id)){let be=ne.id,Pe=x.get(be);Pe&&Pe.reject(new Error("The received response has neither a result nor an error property."));}}function Re(q){if(q!=null)switch(b){case _t.Verbose:return JSON.stringify(q,null,4);case _t.Compact:return JSON.stringify(q);default:return}}function We(q){if(!(b===_t.Off||!L))if(D===xn.Text){let ne;(b===_t.Verbose||b===_t.Compact)&&q.params&&(ne=`Params: ${Re(q.params)}

`),L.log(`Sending request '${q.method} - (${q.id})'.`,ne);}else Ur("send-request",q);}function nt(q){if(!(b===_t.Off||!L))if(D===xn.Text){let ne;(b===_t.Verbose||b===_t.Compact)&&(q.params?ne=`Params: ${Re(q.params)}

`:ne=`No parameters provided.

`),L.log(`Sending notification '${q.method}'.`,ne);}else Ur("send-notification",q);}function Ge(q,ne,be){if(!(b===_t.Off||!L))if(D===xn.Text){let Pe;(b===_t.Verbose||b===_t.Compact)&&(q.error&&q.error.data?Pe=`Error data: ${Re(q.error.data)}

`:q.result?Pe=`Result: ${Re(q.result)}

`:q.error===void 0&&(Pe=`No result returned.

`)),L.log(`Sending response '${ne} - (${q.id})'. Processing request took ${Date.now()-be}ms`,Pe);}else Ur("send-response",q);}function _n(q){if(!(b===_t.Off||!L))if(D===xn.Text){let ne;(b===_t.Verbose||b===_t.Compact)&&q.params&&(ne=`Params: ${Re(q.params)}

`),L.log(`Received request '${q.method} - (${q.id})'.`,ne);}else Ur("receive-request",q);}function Mr(q){if(!(b===_t.Off||!L||q.method===vd.type.method))if(D===xn.Text){let ne;(b===_t.Verbose||b===_t.Compact)&&(q.params?ne=`Params: ${Re(q.params)}

`:ne=`No parameters provided.

`),L.log(`Received notification '${q.method}'.`,ne);}else Ur("receive-notification",q);}function js(q,ne){if(!(b===_t.Off||!L))if(D===xn.Text){let be;if((b===_t.Verbose||b===_t.Compact)&&(q.error&&q.error.data?be=`Error data: ${Re(q.error.data)}

`:q.result?be=`Result: ${Re(q.result)}

`:q.error===void 0&&(be=`No result returned.

`)),ne){let Pe=q.error?` Request failed: ${q.error.message} (${q.error.code}).`:"";L.log(`Received response '${ne.method} - (${q.id})' in ${Date.now()-ne.timerStart}ms.${Pe}`,be);}else L.log(`Received response ${q.id} without active response promise.`,be);}else Ur("receive-response",q);}function Ur(q,ne){if(!L||b===_t.Off)return;let be={isLSPMessage:!0,type:q,message:ne,timestamp:Date.now()};L.log(be);}function Zr(){if(Fe())throw new $a(Uc.Closed,"Connection is closed.");if(ze())throw new $a(Uc.Disposed,"Connection is disposed.")}function Vs(){if(Te())throw new $a(Uc.AlreadyListening,"Connection is already listening")}function Lo(){if(!Te())throw new Error("Call listen() first.")}function hn(q){return q===void 0?null:q}function Hs(q){if(q!==null)return q}function Ws(q){return q!=null&&!Array.isArray(q)&&typeof q=="object"}function Ni(q,ne){switch(q){case Ve.ParameterStructures.auto:return Ws(ne)?Hs(ne):[hn(ne)];case Ve.ParameterStructures.byName:if(!Ws(ne))throw new Error("Received parameters by name but param is not an object literal.");return Hs(ne);case Ve.ParameterStructures.byPosition:return [hn(ne)];default:throw new Error(`Unknown parameter structure ${q.toString()}`)}}function Ks(q,ne){let be,Pe=q.numberOfParams;switch(Pe){case 0:be=void 0;break;case 1:be=Ni(q.parameterStructures,ne[0]);break;default:be=[];for(let wt=0;wt<ne.length&&wt<Pe;wt++)be.push(hn(ne[wt]));if(ne.length<Pe)for(let wt=ne.length;wt<Pe;wt++)be.push(null);break}return be}let Kn={sendNotification:(q,...ne)=>{Zr();let be,Pe;if(Xt.string(q)){be=q;let yt=ne[0],kt=0,Bt=Ve.ParameterStructures.auto;Ve.ParameterStructures.is(yt)&&(kt=1,Bt=yt);let it=ne.length,Rt=it-kt;switch(Rt){case 0:Pe=void 0;break;case 1:Pe=Ni(Bt,ne[kt]);break;default:if(Bt===Ve.ParameterStructures.byName)throw new Error(`Received ${Rt} parameters for 'by Name' notification parameter structure.`);Pe=ne.slice(kt,it).map(pt=>hn(pt));break}}else {let yt=ne;be=q.method,Pe=Ks(q,yt);}let wt={jsonrpc:c,method:be,params:Pe};return nt(wt),t.write(wt).catch(yt=>{throw i.error("Sending notification failed."),yt})},onNotification:(q,ne)=>{Zr();let be;return Xt.func(q)?f=q:ne&&(Xt.string(q)?(be=q,d.set(q,{type:void 0,handler:ne})):(be=q.method,d.set(q.method,{type:q,handler:ne}))),{dispose:()=>{be!==void 0?d.delete(be):f=void 0;}}},onProgress:(q,ne,be)=>{if(p.has(ne))throw new Error(`Progress handler for token ${ne} already registered`);return p.set(ne,be),{dispose:()=>{p.delete(ne);}}},sendProgress:(q,ne,be)=>Kn.sendNotification(Mc.type,{token:ne,value:be}),onUnhandledProgress:ee.event,sendRequest:(q,...ne)=>{Zr(),Lo();let be,Pe,wt;if(Xt.string(q)){be=q;let it=ne[0],Rt=ne[ne.length-1],pt=0,Wt=Ve.ParameterStructures.auto;Ve.ParameterStructures.is(it)&&(pt=1,Wt=it);let er=ne.length;Db.CancellationToken.is(Rt)&&(er=er-1,wt=Rt);let $r=er-pt;switch($r){case 0:Pe=void 0;break;case 1:Pe=Ni(Wt,ne[pt]);break;default:if(Wt===Ve.ParameterStructures.byName)throw new Error(`Received ${$r} parameters for 'by Name' request parameter structure.`);Pe=ne.slice(pt,er).map(Oo=>hn(Oo));break}}else {let it=ne;be=q.method,Pe=Ks(q,it);let Rt=q.numberOfParams;wt=Db.CancellationToken.is(it[Rt])?it[Rt]:void 0;}let yt=s++,kt;wt&&(kt=wt.onCancellationRequested(()=>{let it=ae.sender.sendCancellation(Kn,yt);return it===void 0?(i.log(`Received no promise from cancellation strategy when cancelling id ${yt}`),Promise.resolve()):it.catch(()=>{i.log(`Sending cancellation messages for id ${yt} failed`);})}));let Bt={jsonrpc:c,id:yt,method:be,params:Pe};return We(Bt),typeof ae.sender.enableCancellation=="function"&&ae.sender.enableCancellation(Bt),new Promise(async(it,Rt)=>{let pt=$r=>{it($r),ae.sender.cleanup(yt),kt?.dispose();},Wt=$r=>{Rt($r),ae.sender.cleanup(yt),kt?.dispose();},er={method:be,timerStart:Date.now(),resolve:pt,reject:Wt};try{await t.write(Bt),x.set(yt,er);}catch($r){throw i.error("Sending request failed."),er.reject(new Ve.ResponseError(Ve.ErrorCodes.MessageWriteError,$r.message?$r.message:"Unknown reason")),$r}})},onRequest:(q,ne)=>{Zr();let be=null;return Nb.is(q)?(be=void 0,l=q):Xt.string(q)?(be=null,ne!==void 0&&(be=q,u.set(q,{handler:ne,type:void 0}))):ne!==void 0&&(be=q.method,u.set(q.method,{type:q,handler:ne})),{dispose:()=>{be!==null&&(be!==void 0?u.delete(be):l=void 0);}}},hasPendingResponse:()=>x.size>0,trace:async(q,ne,be)=>{let Pe=!1,wt=xn.Text;be!==void 0&&(Xt.boolean(be)?Pe=be:(Pe=be.sendNotification||!1,wt=be.traceFormat||xn.Text)),b=q,D=wt,b===_t.Off?L=void 0:L=ne,Pe&&!Fe()&&!ze()&&await Kn.sendNotification(Lb.type,{value:_t.toString(q)});},onError:J.event,onClose:K.event,onUnhandledNotification:G.event,onDispose:M.event,end:()=>{t.end();},dispose:()=>{if(ze())return;j=si.Disposed,M.fire(void 0);let q=new Ve.ResponseError(Ve.ErrorCodes.PendingResponseRejected,"Pending response rejected since connection got disposed");for(let ne of x.values())ne.reject(q);x=new Map,v=new Map,I=new Set,S=new Lq.LinkedMap,Xt.func(t.dispose)&&t.dispose(),Xt.func(e.dispose)&&e.dispose();},listen:()=>{Zr(),Vs(),j=si.Listening,e.listen(Pt);},inspect:()=>{(0, Nq.default)().console.log("inspect");}};return Kn.onNotification(vd.type,q=>{if(b===_t.Off||!L)return;let ne=b===_t.Verbose||b===_t.Compact;L.log(q.message,ne?q.verbose:void 0);}),Kn.onNotification(Mc.type,q=>{let ne=p.get(q.token);ne?ne(q.value):ee.fire(q);}),Kn}et.createMessageConnection=Wne;});var wd=A(te=>{Object.defineProperty(te,"__esModule",{value:!0});te.ProgressType=te.ProgressToken=te.createMessageConnection=te.NullLogger=te.ConnectionOptions=te.ConnectionStrategy=te.AbstractMessageBuffer=te.WriteableStreamMessageWriter=te.AbstractMessageWriter=te.MessageWriter=te.ReadableStreamMessageReader=te.AbstractMessageReader=te.MessageReader=te.SharedArrayReceiverStrategy=te.SharedArraySenderStrategy=te.CancellationToken=te.CancellationTokenSource=te.Emitter=te.Event=te.Disposable=te.LRUCache=te.Touch=te.LinkedMap=te.ParameterStructures=te.NotificationType9=te.NotificationType8=te.NotificationType7=te.NotificationType6=te.NotificationType5=te.NotificationType4=te.NotificationType3=te.NotificationType2=te.NotificationType1=te.NotificationType0=te.NotificationType=te.ErrorCodes=te.ResponseError=te.RequestType9=te.RequestType8=te.RequestType7=te.RequestType6=te.RequestType5=te.RequestType4=te.RequestType3=te.RequestType2=te.RequestType1=te.RequestType0=te.RequestType=te.Message=te.RAL=void 0;te.MessageStrategy=te.CancellationStrategy=te.CancellationSenderStrategy=te.CancellationReceiverStrategy=te.ConnectionError=te.ConnectionErrors=te.LogTraceNotification=te.SetTraceNotification=te.TraceFormat=te.TraceValues=te.Trace=void 0;var Mt=ub();Object.defineProperty(te,"Message",{enumerable:!0,get:function(){return Mt.Message}});Object.defineProperty(te,"RequestType",{enumerable:!0,get:function(){return Mt.RequestType}});Object.defineProperty(te,"RequestType0",{enumerable:!0,get:function(){return Mt.RequestType0}});Object.defineProperty(te,"RequestType1",{enumerable:!0,get:function(){return Mt.RequestType1}});Object.defineProperty(te,"RequestType2",{enumerable:!0,get:function(){return Mt.RequestType2}});Object.defineProperty(te,"RequestType3",{enumerable:!0,get:function(){return Mt.RequestType3}});Object.defineProperty(te,"RequestType4",{enumerable:!0,get:function(){return Mt.RequestType4}});Object.defineProperty(te,"RequestType5",{enumerable:!0,get:function(){return Mt.RequestType5}});Object.defineProperty(te,"RequestType6",{enumerable:!0,get:function(){return Mt.RequestType6}});Object.defineProperty(te,"RequestType7",{enumerable:!0,get:function(){return Mt.RequestType7}});Object.defineProperty(te,"RequestType8",{enumerable:!0,get:function(){return Mt.RequestType8}});Object.defineProperty(te,"RequestType9",{enumerable:!0,get:function(){return Mt.RequestType9}});Object.defineProperty(te,"ResponseError",{enumerable:!0,get:function(){return Mt.ResponseError}});Object.defineProperty(te,"ErrorCodes",{enumerable:!0,get:function(){return Mt.ErrorCodes}});Object.defineProperty(te,"NotificationType",{enumerable:!0,get:function(){return Mt.NotificationType}});Object.defineProperty(te,"NotificationType0",{enumerable:!0,get:function(){return Mt.NotificationType0}});Object.defineProperty(te,"NotificationType1",{enumerable:!0,get:function(){return Mt.NotificationType1}});Object.defineProperty(te,"NotificationType2",{enumerable:!0,get:function(){return Mt.NotificationType2}});Object.defineProperty(te,"NotificationType3",{enumerable:!0,get:function(){return Mt.NotificationType3}});Object.defineProperty(te,"NotificationType4",{enumerable:!0,get:function(){return Mt.NotificationType4}});Object.defineProperty(te,"NotificationType5",{enumerable:!0,get:function(){return Mt.NotificationType5}});Object.defineProperty(te,"NotificationType6",{enumerable:!0,get:function(){return Mt.NotificationType6}});Object.defineProperty(te,"NotificationType7",{enumerable:!0,get:function(){return Mt.NotificationType7}});Object.defineProperty(te,"NotificationType8",{enumerable:!0,get:function(){return Mt.NotificationType8}});Object.defineProperty(te,"NotificationType9",{enumerable:!0,get:function(){return Mt.NotificationType9}});Object.defineProperty(te,"ParameterStructures",{enumerable:!0,get:function(){return Mt.ParameterStructures}});var qb=lb();Object.defineProperty(te,"LinkedMap",{enumerable:!0,get:function(){return qb.LinkedMap}});Object.defineProperty(te,"LRUCache",{enumerable:!0,get:function(){return qb.LRUCache}});Object.defineProperty(te,"Touch",{enumerable:!0,get:function(){return qb.Touch}});var Kne=Eq();Object.defineProperty(te,"Disposable",{enumerable:!0,get:function(){return Kne.Disposable}});var Fq=qa();Object.defineProperty(te,"Event",{enumerable:!0,get:function(){return Fq.Event}});Object.defineProperty(te,"Emitter",{enumerable:!0,get:function(){return Fq.Emitter}});var Mq=dd();Object.defineProperty(te,"CancellationTokenSource",{enumerable:!0,get:function(){return Mq.CancellationTokenSource}});Object.defineProperty(te,"CancellationToken",{enumerable:!0,get:function(){return Mq.CancellationToken}});var Uq=wq();Object.defineProperty(te,"SharedArraySenderStrategy",{enumerable:!0,get:function(){return Uq.SharedArraySenderStrategy}});Object.defineProperty(te,"SharedArrayReceiverStrategy",{enumerable:!0,get:function(){return Uq.SharedArrayReceiverStrategy}});var Fb=Tq();Object.defineProperty(te,"MessageReader",{enumerable:!0,get:function(){return Fb.MessageReader}});Object.defineProperty(te,"AbstractMessageReader",{enumerable:!0,get:function(){return Fb.AbstractMessageReader}});Object.defineProperty(te,"ReadableStreamMessageReader",{enumerable:!0,get:function(){return Fb.ReadableStreamMessageReader}});var Mb=Pq();Object.defineProperty(te,"MessageWriter",{enumerable:!0,get:function(){return Mb.MessageWriter}});Object.defineProperty(te,"AbstractMessageWriter",{enumerable:!0,get:function(){return Mb.AbstractMessageWriter}});Object.defineProperty(te,"WriteableStreamMessageWriter",{enumerable:!0,get:function(){return Mb.WriteableStreamMessageWriter}});var zne=kq();Object.defineProperty(te,"AbstractMessageBuffer",{enumerable:!0,get:function(){return zne.AbstractMessageBuffer}});var Pr=qq();Object.defineProperty(te,"ConnectionStrategy",{enumerable:!0,get:function(){return Pr.ConnectionStrategy}});Object.defineProperty(te,"ConnectionOptions",{enumerable:!0,get:function(){return Pr.ConnectionOptions}});Object.defineProperty(te,"NullLogger",{enumerable:!0,get:function(){return Pr.NullLogger}});Object.defineProperty(te,"createMessageConnection",{enumerable:!0,get:function(){return Pr.createMessageConnection}});Object.defineProperty(te,"ProgressToken",{enumerable:!0,get:function(){return Pr.ProgressToken}});Object.defineProperty(te,"ProgressType",{enumerable:!0,get:function(){return Pr.ProgressType}});Object.defineProperty(te,"Trace",{enumerable:!0,get:function(){return Pr.Trace}});Object.defineProperty(te,"TraceValues",{enumerable:!0,get:function(){return Pr.TraceValues}});Object.defineProperty(te,"TraceFormat",{enumerable:!0,get:function(){return Pr.TraceFormat}});Object.defineProperty(te,"SetTraceNotification",{enumerable:!0,get:function(){return Pr.SetTraceNotification}});Object.defineProperty(te,"LogTraceNotification",{enumerable:!0,get:function(){return Pr.LogTraceNotification}});Object.defineProperty(te,"ConnectionErrors",{enumerable:!0,get:function(){return Pr.ConnectionErrors}});Object.defineProperty(te,"ConnectionError",{enumerable:!0,get:function(){return Pr.ConnectionError}});Object.defineProperty(te,"CancellationReceiverStrategy",{enumerable:!0,get:function(){return Pr.CancellationReceiverStrategy}});Object.defineProperty(te,"CancellationSenderStrategy",{enumerable:!0,get:function(){return Pr.CancellationSenderStrategy}});Object.defineProperty(te,"CancellationStrategy",{enumerable:!0,get:function(){return Pr.CancellationStrategy}});Object.defineProperty(te,"MessageStrategy",{enumerable:!0,get:function(){return Pr.MessageStrategy}});var Gne=Ps();te.RAL=Gne.default;});var Vq=A(Vb=>{Object.defineProperty(Vb,"__esModule",{value:!0});var $q=he("util"),Xi=wd(),_d=class e extends Xi.AbstractMessageBuffer{constructor(t="utf-8"){super(t);}emptyBuffer(){return e.emptyBuffer}fromString(t,r){return Buffer.from(t,r)}toString(t,r){return t instanceof Buffer?t.toString(r):new $q.TextDecoder(r).decode(t)}asNative(t,r){return r===void 0?t instanceof Buffer?t:Buffer.from(t):t instanceof Buffer?t.slice(0,r):Buffer.from(t,0,r)}allocNative(t){return Buffer.allocUnsafe(t)}};_d.emptyBuffer=Buffer.allocUnsafe(0);var Ub=class{constructor(t){this.stream=t;}onClose(t){return this.stream.on("close",t),Xi.Disposable.create(()=>this.stream.off("close",t))}onError(t){return this.stream.on("error",t),Xi.Disposable.create(()=>this.stream.off("error",t))}onEnd(t){return this.stream.on("end",t),Xi.Disposable.create(()=>this.stream.off("end",t))}onData(t){return this.stream.on("data",t),Xi.Disposable.create(()=>this.stream.off("data",t))}},$b=class{constructor(t){this.stream=t;}onClose(t){return this.stream.on("close",t),Xi.Disposable.create(()=>this.stream.off("close",t))}onError(t){return this.stream.on("error",t),Xi.Disposable.create(()=>this.stream.off("error",t))}onEnd(t){return this.stream.on("end",t),Xi.Disposable.create(()=>this.stream.off("end",t))}write(t,r){return new Promise((n,i)=>{let s=o=>{o==null?n():i(o);};typeof t=="string"?this.stream.write(t,r,s):this.stream.write(t,s);})}end(){this.stream.end();}},jq=Object.freeze({messageBuffer:Object.freeze({create:e=>new _d(e)}),applicationJson:Object.freeze({encoder:Object.freeze({name:"application/json",encode:(e,t)=>{try{return Promise.resolve(Buffer.from(JSON.stringify(e,void 0,0),t.charset))}catch(r){return Promise.reject(r)}}}),decoder:Object.freeze({name:"application/json",decode:(e,t)=>{try{return e instanceof Buffer?Promise.resolve(JSON.parse(e.toString(t.charset))):Promise.resolve(JSON.parse(new $q.TextDecoder(t.charset).decode(e)))}catch(r){return Promise.reject(r)}}})}),stream:Object.freeze({asReadableStream:e=>new Ub(e),asWritableStream:e=>new $b(e)}),console,timer:Object.freeze({setTimeout(e,t,...r){let n=setTimeout(e,t,...r);return {dispose:()=>clearTimeout(n)}},setImmediate(e,...t){let r=setImmediate(e,...t);return {dispose:()=>clearImmediate(r)}},setInterval(e,t,...r){let n=setInterval(e,t,...r);return {dispose:()=>clearInterval(n)}}})});function jb(){return jq}(function(e){function t(){Xi.RAL.install(jq);}e.install=t;})(jb||(jb={}));Vb.default=jb;});var Io=A(ht=>{var Yne=ht&&ht.__createBinding||(Object.create?function(e,t,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(t,r);(!i||("get"in i?!t.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,i);}:function(e,t,r,n){n===void 0&&(n=r),e[n]=t[r];}),Qne=ht&&ht.__exportStar||function(e,t){for(var r in e)r!=="default"&&!Object.prototype.hasOwnProperty.call(t,r)&&Yne(t,e,r);};Object.defineProperty(ht,"__esModule",{value:!0});ht.createMessageConnection=ht.createServerSocketTransport=ht.createClientSocketTransport=ht.createServerPipeTransport=ht.createClientPipeTransport=ht.generateRandomPipeName=ht.StreamMessageWriter=ht.StreamMessageReader=ht.SocketMessageWriter=ht.SocketMessageReader=ht.PortMessageWriter=ht.PortMessageReader=ht.IPCMessageWriter=ht.IPCMessageReader=void 0;var ja=Vq();ja.default.install();var Hq=he("path"),Xne=he("os"),Jne=he("crypto"),Rd=he("net"),wn=wd();Qne(wd(),ht);var Hb=class extends wn.AbstractMessageReader{constructor(t){super(),this.process=t;let r=this.process;r.on("error",n=>this.fireError(n)),r.on("close",()=>this.fireClose());}listen(t){return this.process.on("message",t),wn.Disposable.create(()=>this.process.off("message",t))}};ht.IPCMessageReader=Hb;var Wb=class extends wn.AbstractMessageWriter{constructor(t){super(),this.process=t,this.errorCount=0;let r=this.process;r.on("error",n=>this.fireError(n)),r.on("close",()=>this.fireClose);}write(t){try{return typeof this.process.send=="function"&&this.process.send(t,void 0,void 0,r=>{r?(this.errorCount++,this.handleError(r,t)):this.errorCount=0;}),Promise.resolve()}catch(r){return this.handleError(r,t),Promise.reject(r)}}handleError(t,r){this.errorCount++,this.fireError(t,r,this.errorCount);}end(){}};ht.IPCMessageWriter=Wb;var Kb=class extends wn.AbstractMessageReader{constructor(t){super(),this.onData=new wn.Emitter,t.on("close",()=>this.fireClose),t.on("error",r=>this.fireError(r)),t.on("message",r=>{this.onData.fire(r);});}listen(t){return this.onData.event(t)}};ht.PortMessageReader=Kb;var zb=class extends wn.AbstractMessageWriter{constructor(t){super(),this.port=t,this.errorCount=0,t.on("close",()=>this.fireClose()),t.on("error",r=>this.fireError(r));}write(t){try{return this.port.postMessage(t),Promise.resolve()}catch(r){return this.handleError(r,t),Promise.reject(r)}}handleError(t,r){this.errorCount++,this.fireError(t,r,this.errorCount);}end(){}};ht.PortMessageWriter=zb;var Ao=class extends wn.ReadableStreamMessageReader{constructor(t,r="utf-8"){super((0, ja.default)().stream.asReadableStream(t),r);}};ht.SocketMessageReader=Ao;var Ro=class extends wn.WriteableStreamMessageWriter{constructor(t,r){super((0, ja.default)().stream.asWritableStream(t),r),this.socket=t;}dispose(){super.dispose(),this.socket.destroy();}};ht.SocketMessageWriter=Ro;var Td=class extends wn.ReadableStreamMessageReader{constructor(t,r){super((0, ja.default)().stream.asReadableStream(t),r);}};ht.StreamMessageReader=Td;var Ad=class extends wn.WriteableStreamMessageWriter{constructor(t,r){super((0, ja.default)().stream.asWritableStream(t),r);}};ht.StreamMessageWriter=Ad;var Wq=process.env.XDG_RUNTIME_DIR,Zne=new Map([["linux",107],["darwin",103]]);function eie(){let e=(0, Jne.randomBytes)(21).toString("hex");if(process.platform==="win32")return `\\\\.\\pipe\\vscode-jsonrpc-${e}-sock`;let t;Wq?t=Hq.join(Wq,`vscode-ipc-${e}.sock`):t=Hq.join(Xne.tmpdir(),`vscode-${e}.sock`);let r=Zne.get(process.platform);return r!==void 0&&t.length>r&&(0, ja.default)().console.warn(`WARNING: IPC handle "${t}" is longer than ${r} characters.`),t}ht.generateRandomPipeName=eie;function tie(e,t="utf-8"){let r,n=new Promise((i,s)=>{r=i;});return new Promise((i,s)=>{let o=(0, Rd.createServer)(a=>{o.close(),r([new Ao(a,t),new Ro(a,t)]);});o.on("error",s),o.listen(e,()=>{o.removeListener("error",s),i({onConnected:()=>n});});})}ht.createClientPipeTransport=tie;function rie(e,t="utf-8"){let r=(0, Rd.createConnection)(e);return [new Ao(r,t),new Ro(r,t)]}ht.createServerPipeTransport=rie;function nie(e,t="utf-8"){let r,n=new Promise((i,s)=>{r=i;});return new Promise((i,s)=>{let o=(0, Rd.createServer)(a=>{o.close(),r([new Ao(a,t),new Ro(a,t)]);});o.on("error",s),o.listen(e,"127.0.0.1",()=>{o.removeListener("error",s),i({onConnected:()=>n});});})}ht.createClientSocketTransport=nie;function iie(e,t="utf-8"){let r=(0, Rd.createConnection)(e,"127.0.0.1");return [new Ao(r,t),new Ro(r,t)]}ht.createServerSocketTransport=iie;function sie(e){let t=e;return t.read!==void 0&&t.addListener!==void 0}function oie(e){let t=e;return t.write!==void 0&&t.addListener!==void 0}function aie(e,t,r,n){r||(r=wn.NullLogger);let i=sie(e)?new Td(e):e,s=oie(t)?new Ad(t):t;return wn.ConnectionStrategy.is(n)&&(n={connectionStrategy:n}),(0, wn.createMessageConnection)(i,s,r,n)}ht.createMessageConnection=aie;});var Gb=A((Ppe,Kq)=>{Kq.exports=Io();});var Dd=A((zq,Id)=>{(function(e){if(typeof Id=="object"&&typeof Id.exports=="object"){var t=e(he,zq);t!==void 0&&(Id.exports=t);}else typeof define=="function"&&define.amd&&define(["require","exports"],e);})(function(e,t){Object.defineProperty(t,"__esModule",{value:!0}),t.TextDocument=t.EOL=t.WorkspaceFolder=t.InlineCompletionContext=t.SelectedCompletionInfo=t.InlineCompletionTriggerKind=t.InlineCompletionList=t.InlineCompletionItem=t.StringValue=t.InlayHint=t.InlayHintLabelPart=t.InlayHintKind=t.InlineValueContext=t.InlineValueEvaluatableExpression=t.InlineValueVariableLookup=t.InlineValueText=t.SemanticTokens=t.SemanticTokenModifiers=t.SemanticTokenTypes=t.SelectionRange=t.DocumentLink=t.FormattingOptions=t.CodeLens=t.CodeAction=t.CodeActionContext=t.CodeActionTriggerKind=t.CodeActionKind=t.DocumentSymbol=t.WorkspaceSymbol=t.SymbolInformation=t.SymbolTag=t.SymbolKind=t.DocumentHighlight=t.DocumentHighlightKind=t.SignatureInformation=t.ParameterInformation=t.Hover=t.MarkedString=t.CompletionList=t.CompletionItem=t.CompletionItemLabelDetails=t.InsertTextMode=t.InsertReplaceEdit=t.CompletionItemTag=t.InsertTextFormat=t.CompletionItemKind=t.MarkupContent=t.MarkupKind=t.TextDocumentItem=t.OptionalVersionedTextDocumentIdentifier=t.VersionedTextDocumentIdentifier=t.TextDocumentIdentifier=t.WorkspaceChange=t.WorkspaceEdit=t.DeleteFile=t.RenameFile=t.CreateFile=t.TextDocumentEdit=t.AnnotatedTextEdit=t.ChangeAnnotationIdentifier=t.ChangeAnnotation=t.TextEdit=t.Command=t.Diagnostic=t.CodeDescription=t.DiagnosticTag=t.DiagnosticSeverity=t.DiagnosticRelatedInformation=t.FoldingRange=t.FoldingRangeKind=t.ColorPresentation=t.ColorInformation=t.Color=t.LocationLink=t.Location=t.Range=t.Position=t.uinteger=t.integer=t.URI=t.DocumentUri=void 0;var r;(function(_){function F(U){return typeof U=="string"}_.is=F;})(r||(t.DocumentUri=r={}));var n;(function(_){function F(U){return typeof U=="string"}_.is=F;})(n||(t.URI=n={}));var i;(function(_){_.MIN_VALUE=-2147483648,_.MAX_VALUE=2147483647;function F(U){return typeof U=="number"&&_.MIN_VALUE<=U&&U<=_.MAX_VALUE}_.is=F;})(i||(t.integer=i={}));var s;(function(_){_.MIN_VALUE=0,_.MAX_VALUE=2147483647;function F(U){return typeof U=="number"&&_.MIN_VALUE<=U&&U<=_.MAX_VALUE}_.is=F;})(s||(t.uinteger=s={}));var o;(function(_){function F(P,C){return P===Number.MAX_VALUE&&(P=s.MAX_VALUE),C===Number.MAX_VALUE&&(C=s.MAX_VALUE),{line:P,character:C}}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&Q.uinteger(C.line)&&Q.uinteger(C.character)}_.is=U;})(o||(t.Position=o={}));var a;(function(_){function F(P,C,z,ie){if(Q.uinteger(P)&&Q.uinteger(C)&&Q.uinteger(z)&&Q.uinteger(ie))return {start:o.create(P,C),end:o.create(z,ie)};if(o.is(P)&&o.is(C))return {start:P,end:C};throw new Error("Range#create called with invalid arguments[".concat(P,", ").concat(C,", ").concat(z,", ").concat(ie,"]"))}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&o.is(C.start)&&o.is(C.end)}_.is=U;})(a||(t.Range=a={}));var c;(function(_){function F(P,C){return {uri:P,range:C}}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&a.is(C.range)&&(Q.string(C.uri)||Q.undefined(C.uri))}_.is=U;})(c||(t.Location=c={}));var l;(function(_){function F(P,C,z,ie){return {targetUri:P,targetRange:C,targetSelectionRange:z,originSelectionRange:ie}}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&a.is(C.targetRange)&&Q.string(C.targetUri)&&a.is(C.targetSelectionRange)&&(a.is(C.originSelectionRange)||Q.undefined(C.originSelectionRange))}_.is=U;})(l||(t.LocationLink=l={}));var u;(function(_){function F(P,C,z,ie){return {red:P,green:C,blue:z,alpha:ie}}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&Q.numberRange(C.red,0,1)&&Q.numberRange(C.green,0,1)&&Q.numberRange(C.blue,0,1)&&Q.numberRange(C.alpha,0,1)}_.is=U;})(u||(t.Color=u={}));var f;(function(_){function F(P,C){return {range:P,color:C}}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&a.is(C.range)&&u.is(C.color)}_.is=U;})(f||(t.ColorInformation=f={}));var d;(function(_){function F(P,C,z){return {label:P,textEdit:C,additionalTextEdits:z}}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&Q.string(C.label)&&(Q.undefined(C.textEdit)||L.is(C))&&(Q.undefined(C.additionalTextEdits)||Q.typedArray(C.additionalTextEdits,L.is))}_.is=U;})(d||(t.ColorPresentation=d={}));var p;(function(_){_.Comment="comment",_.Imports="imports",_.Region="region";})(p||(t.FoldingRangeKind=p={}));var m;(function(_){function F(P,C,z,ie,Ye,Kt){var Nt={startLine:P,endLine:C};return Q.defined(z)&&(Nt.startCharacter=z),Q.defined(ie)&&(Nt.endCharacter=ie),Q.defined(Ye)&&(Nt.kind=Ye),Q.defined(Kt)&&(Nt.collapsedText=Kt),Nt}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&Q.uinteger(C.startLine)&&Q.uinteger(C.startLine)&&(Q.undefined(C.startCharacter)||Q.uinteger(C.startCharacter))&&(Q.undefined(C.endCharacter)||Q.uinteger(C.endCharacter))&&(Q.undefined(C.kind)||Q.string(C.kind))}_.is=U;})(m||(t.FoldingRange=m={}));var S;(function(_){function F(P,C){return {location:P,message:C}}_.create=F;function U(P){var C=P;return Q.defined(C)&&c.is(C.location)&&Q.string(C.message)}_.is=U;})(S||(t.DiagnosticRelatedInformation=S={}));var x;(function(_){_.Error=1,_.Warning=2,_.Information=3,_.Hint=4;})(x||(t.DiagnosticSeverity=x={}));var I;(function(_){_.Unnecessary=1,_.Deprecated=2;})(I||(t.DiagnosticTag=I={}));var v;(function(_){function F(U){var P=U;return Q.objectLiteral(P)&&Q.string(P.href)}_.is=F;})(v||(t.CodeDescription=v={}));var b;(function(_){function F(P,C,z,ie,Ye,Kt){var Nt={range:P,message:C};return Q.defined(z)&&(Nt.severity=z),Q.defined(ie)&&(Nt.code=ie),Q.defined(Ye)&&(Nt.source=Ye),Q.defined(Kt)&&(Nt.relatedInformation=Kt),Nt}_.create=F;function U(P){var C,z=P;return Q.defined(z)&&a.is(z.range)&&Q.string(z.message)&&(Q.number(z.severity)||Q.undefined(z.severity))&&(Q.integer(z.code)||Q.string(z.code)||Q.undefined(z.code))&&(Q.undefined(z.codeDescription)||Q.string((C=z.codeDescription)===null||C===void 0?void 0:C.href))&&(Q.string(z.source)||Q.undefined(z.source))&&(Q.undefined(z.relatedInformation)||Q.typedArray(z.relatedInformation,S.is))}_.is=U;})(b||(t.Diagnostic=b={}));var D;(function(_){function F(P,C){for(var z=[],ie=2;ie<arguments.length;ie++)z[ie-2]=arguments[ie];var Ye={title:P,command:C};return Q.defined(z)&&z.length>0&&(Ye.arguments=z),Ye}_.create=F;function U(P){var C=P;return Q.defined(C)&&Q.string(C.title)&&Q.string(C.command)}_.is=U;})(D||(t.Command=D={}));var L;(function(_){function F(z,ie){return {range:z,newText:ie}}_.replace=F;function U(z,ie){return {range:{start:z,end:z},newText:ie}}_.insert=U;function P(z){return {range:z,newText:""}}_.del=P;function C(z){var ie=z;return Q.objectLiteral(ie)&&Q.string(ie.newText)&&a.is(ie.range)}_.is=C;})(L||(t.TextEdit=L={}));var j;(function(_){function F(P,C,z){var ie={label:P};return C!==void 0&&(ie.needsConfirmation=C),z!==void 0&&(ie.description=z),ie}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&Q.string(C.label)&&(Q.boolean(C.needsConfirmation)||C.needsConfirmation===void 0)&&(Q.string(C.description)||C.description===void 0)}_.is=U;})(j||(t.ChangeAnnotation=j={}));var J;(function(_){function F(U){var P=U;return Q.string(P)}_.is=F;})(J||(t.ChangeAnnotationIdentifier=J={}));var K;(function(_){function F(z,ie,Ye){return {range:z,newText:ie,annotationId:Ye}}_.replace=F;function U(z,ie,Ye){return {range:{start:z,end:z},newText:ie,annotationId:Ye}}_.insert=U;function P(z,ie){return {range:z,newText:"",annotationId:ie}}_.del=P;function C(z){var ie=z;return L.is(ie)&&(j.is(ie.annotationId)||J.is(ie.annotationId))}_.is=C;})(K||(t.AnnotatedTextEdit=K={}));var G;(function(_){function F(P,C){return {textDocument:P,edits:C}}_.create=F;function U(P){var C=P;return Q.defined(C)&&Fe.is(C.textDocument)&&Array.isArray(C.edits)}_.is=U;})(G||(t.TextDocumentEdit=G={}));var ee;(function(_){function F(P,C,z){var ie={kind:"create",uri:P};return C!==void 0&&(C.overwrite!==void 0||C.ignoreIfExists!==void 0)&&(ie.options=C),z!==void 0&&(ie.annotationId=z),ie}_.create=F;function U(P){var C=P;return C&&C.kind==="create"&&Q.string(C.uri)&&(C.options===void 0||(C.options.overwrite===void 0||Q.boolean(C.options.overwrite))&&(C.options.ignoreIfExists===void 0||Q.boolean(C.options.ignoreIfExists)))&&(C.annotationId===void 0||J.is(C.annotationId))}_.is=U;})(ee||(t.CreateFile=ee={}));var M;(function(_){function F(P,C,z,ie){var Ye={kind:"rename",oldUri:P,newUri:C};return z!==void 0&&(z.overwrite!==void 0||z.ignoreIfExists!==void 0)&&(Ye.options=z),ie!==void 0&&(Ye.annotationId=ie),Ye}_.create=F;function U(P){var C=P;return C&&C.kind==="rename"&&Q.string(C.oldUri)&&Q.string(C.newUri)&&(C.options===void 0||(C.options.overwrite===void 0||Q.boolean(C.options.overwrite))&&(C.options.ignoreIfExists===void 0||Q.boolean(C.options.ignoreIfExists)))&&(C.annotationId===void 0||J.is(C.annotationId))}_.is=U;})(M||(t.RenameFile=M={}));var ae;(function(_){function F(P,C,z){var ie={kind:"delete",uri:P};return C!==void 0&&(C.recursive!==void 0||C.ignoreIfNotExists!==void 0)&&(ie.options=C),z!==void 0&&(ie.annotationId=z),ie}_.create=F;function U(P){var C=P;return C&&C.kind==="delete"&&Q.string(C.uri)&&(C.options===void 0||(C.options.recursive===void 0||Q.boolean(C.options.recursive))&&(C.options.ignoreIfNotExists===void 0||Q.boolean(C.options.ignoreIfNotExists)))&&(C.annotationId===void 0||J.is(C.annotationId))}_.is=U;})(ae||(t.DeleteFile=ae={}));var me;(function(_){function F(U){var P=U;return P&&(P.changes!==void 0||P.documentChanges!==void 0)&&(P.documentChanges===void 0||P.documentChanges.every(function(C){return Q.string(C.kind)?ee.is(C)||M.is(C)||ae.is(C):G.is(C)}))}_.is=F;})(me||(t.WorkspaceEdit=me={}));var Le=function(){function _(F,U){this.edits=F,this.changeAnnotations=U;}return _.prototype.insert=function(F,U,P){var C,z;if(P===void 0?C=L.insert(F,U):J.is(P)?(z=P,C=K.insert(F,U,P)):(this.assertChangeAnnotations(this.changeAnnotations),z=this.changeAnnotations.manage(P),C=K.insert(F,U,z)),this.edits.push(C),z!==void 0)return z},_.prototype.replace=function(F,U,P){var C,z;if(P===void 0?C=L.replace(F,U):J.is(P)?(z=P,C=K.replace(F,U,P)):(this.assertChangeAnnotations(this.changeAnnotations),z=this.changeAnnotations.manage(P),C=K.replace(F,U,z)),this.edits.push(C),z!==void 0)return z},_.prototype.delete=function(F,U){var P,C;if(U===void 0?P=L.del(F):J.is(U)?(C=U,P=K.del(F,U)):(this.assertChangeAnnotations(this.changeAnnotations),C=this.changeAnnotations.manage(U),P=K.del(F,C)),this.edits.push(P),C!==void 0)return C},_.prototype.add=function(F){this.edits.push(F);},_.prototype.all=function(){return this.edits},_.prototype.clear=function(){this.edits.splice(0,this.edits.length);},_.prototype.assertChangeAnnotations=function(F){if(F===void 0)throw new Error("Text edit change is not configured to manage change annotations.")},_}(),H=function(){function _(F){this._annotations=F===void 0?Object.create(null):F,this._counter=0,this._size=0;}return _.prototype.all=function(){return this._annotations},Object.defineProperty(_.prototype,"size",{get:function(){return this._size},enumerable:!1,configurable:!0}),_.prototype.manage=function(F,U){var P;if(J.is(F)?P=F:(P=this.nextId(),U=F),this._annotations[P]!==void 0)throw new Error("Id ".concat(P," is already in use."));if(U===void 0)throw new Error("No annotation provided for id ".concat(P));return this._annotations[P]=U,this._size++,P},_.prototype.nextId=function(){return this._counter++,this._counter.toString()},_}(),W=function(){function _(F){var U=this;this._textEditChanges=Object.create(null),F!==void 0?(this._workspaceEdit=F,F.documentChanges?(this._changeAnnotations=new H(F.changeAnnotations),F.changeAnnotations=this._changeAnnotations.all(),F.documentChanges.forEach(function(P){if(G.is(P)){var C=new Le(P.edits,U._changeAnnotations);U._textEditChanges[P.textDocument.uri]=C;}})):F.changes&&Object.keys(F.changes).forEach(function(P){var C=new Le(F.changes[P]);U._textEditChanges[P]=C;})):this._workspaceEdit={};}return Object.defineProperty(_.prototype,"edit",{get:function(){return this.initDocumentChanges(),this._changeAnnotations!==void 0&&(this._changeAnnotations.size===0?this._workspaceEdit.changeAnnotations=void 0:this._workspaceEdit.changeAnnotations=this._changeAnnotations.all()),this._workspaceEdit},enumerable:!1,configurable:!0}),_.prototype.getTextEditChange=function(F){if(Fe.is(F)){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var U={uri:F.uri,version:F.version},P=this._textEditChanges[U.uri];if(!P){var C=[],z={textDocument:U,edits:C};this._workspaceEdit.documentChanges.push(z),P=new Le(C,this._changeAnnotations),this._textEditChanges[U.uri]=P;}return P}else {if(this.initChanges(),this._workspaceEdit.changes===void 0)throw new Error("Workspace edit is not configured for normal text edit changes.");var P=this._textEditChanges[F];if(!P){var C=[];this._workspaceEdit.changes[F]=C,P=new Le(C),this._textEditChanges[F]=P;}return P}},_.prototype.initDocumentChanges=function(){this._workspaceEdit.documentChanges===void 0&&this._workspaceEdit.changes===void 0&&(this._changeAnnotations=new H,this._workspaceEdit.documentChanges=[],this._workspaceEdit.changeAnnotations=this._changeAnnotations.all());},_.prototype.initChanges=function(){this._workspaceEdit.documentChanges===void 0&&this._workspaceEdit.changes===void 0&&(this._workspaceEdit.changes=Object.create(null));},_.prototype.createFile=function(F,U,P){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var C;j.is(U)||J.is(U)?C=U:P=U;var z,ie;if(C===void 0?z=ee.create(F,P):(ie=J.is(C)?C:this._changeAnnotations.manage(C),z=ee.create(F,P,ie)),this._workspaceEdit.documentChanges.push(z),ie!==void 0)return ie},_.prototype.renameFile=function(F,U,P,C){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var z;j.is(P)||J.is(P)?z=P:C=P;var ie,Ye;if(z===void 0?ie=M.create(F,U,C):(Ye=J.is(z)?z:this._changeAnnotations.manage(z),ie=M.create(F,U,C,Ye)),this._workspaceEdit.documentChanges.push(ie),Ye!==void 0)return Ye},_.prototype.deleteFile=function(F,U,P){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var C;j.is(U)||J.is(U)?C=U:P=U;var z,ie;if(C===void 0?z=ae.create(F,P):(ie=J.is(C)?C:this._changeAnnotations.manage(C),z=ae.create(F,P,ie)),this._workspaceEdit.documentChanges.push(z),ie!==void 0)return ie},_}();t.WorkspaceChange=W;var se;(function(_){function F(P){return {uri:P}}_.create=F;function U(P){var C=P;return Q.defined(C)&&Q.string(C.uri)}_.is=U;})(se||(t.TextDocumentIdentifier=se={}));var Te;(function(_){function F(P,C){return {uri:P,version:C}}_.create=F;function U(P){var C=P;return Q.defined(C)&&Q.string(C.uri)&&Q.integer(C.version)}_.is=U;})(Te||(t.VersionedTextDocumentIdentifier=Te={}));var Fe;(function(_){function F(P,C){return {uri:P,version:C}}_.create=F;function U(P){var C=P;return Q.defined(C)&&Q.string(C.uri)&&(C.version===null||Q.integer(C.version))}_.is=U;})(Fe||(t.OptionalVersionedTextDocumentIdentifier=Fe={}));var ze;(function(_){function F(P,C,z,ie){return {uri:P,languageId:C,version:z,text:ie}}_.create=F;function U(P){var C=P;return Q.defined(C)&&Q.string(C.uri)&&Q.string(C.languageId)&&Q.integer(C.version)&&Q.string(C.text)}_.is=U;})(ze||(t.TextDocumentItem=ze={}));var He;(function(_){_.PlainText="plaintext",_.Markdown="markdown";function F(U){var P=U;return P===_.PlainText||P===_.Markdown}_.is=F;})(He||(t.MarkupKind=He={}));var ct;(function(_){function F(U){var P=U;return Q.objectLiteral(U)&&He.is(P.kind)&&Q.string(P.value)}_.is=F;})(ct||(t.MarkupContent=ct={}));var Lt;(function(_){_.Text=1,_.Method=2,_.Function=3,_.Constructor=4,_.Field=5,_.Variable=6,_.Class=7,_.Interface=8,_.Module=9,_.Property=10,_.Unit=11,_.Value=12,_.Enum=13,_.Keyword=14,_.Snippet=15,_.Color=16,_.File=17,_.Reference=18,_.Folder=19,_.EnumMember=20,_.Constant=21,_.Struct=22,_.Event=23,_.Operator=24,_.TypeParameter=25;})(Lt||(t.CompletionItemKind=Lt={}));var xt;(function(_){_.PlainText=1,_.Snippet=2;})(xt||(t.InsertTextFormat=xt={}));var dt;(function(_){_.Deprecated=1;})(dt||(t.CompletionItemTag=dt={}));var Oe;(function(_){function F(P,C,z){return {newText:P,insert:C,replace:z}}_.create=F;function U(P){var C=P;return C&&Q.string(C.newText)&&a.is(C.insert)&&a.is(C.replace)}_.is=U;})(Oe||(t.InsertReplaceEdit=Oe={}));var Pt;(function(_){_.asIs=1,_.adjustIndentation=2;})(Pt||(t.InsertTextMode=Pt={}));var Ut;(function(_){function F(U){var P=U;return P&&(Q.string(P.detail)||P.detail===void 0)&&(Q.string(P.description)||P.description===void 0)}_.is=F;})(Ut||(t.CompletionItemLabelDetails=Ut={}));var ge;(function(_){function F(U){return {label:U}}_.create=F;})(ge||(t.CompletionItem=ge={}));var je;(function(_){function F(U,P){return {items:U||[],isIncomplete:!!P}}_.create=F;})(je||(t.CompletionList=je={}));var ce;(function(_){function F(P){return P.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}_.fromPlainText=F;function U(P){var C=P;return Q.string(C)||Q.objectLiteral(C)&&Q.string(C.language)&&Q.string(C.value)}_.is=U;})(ce||(t.MarkedString=ce={}));var Re;(function(_){function F(U){var P=U;return !!P&&Q.objectLiteral(P)&&(ct.is(P.contents)||ce.is(P.contents)||Q.typedArray(P.contents,ce.is))&&(U.range===void 0||a.is(U.range))}_.is=F;})(Re||(t.Hover=Re={}));var We;(function(_){function F(U,P){return P?{label:U,documentation:P}:{label:U}}_.create=F;})(We||(t.ParameterInformation=We={}));var nt;(function(_){function F(U,P){for(var C=[],z=2;z<arguments.length;z++)C[z-2]=arguments[z];var ie={label:U};return Q.defined(P)&&(ie.documentation=P),Q.defined(C)?ie.parameters=C:ie.parameters=[],ie}_.create=F;})(nt||(t.SignatureInformation=nt={}));var Ge;(function(_){_.Text=1,_.Read=2,_.Write=3;})(Ge||(t.DocumentHighlightKind=Ge={}));var _n;(function(_){function F(U,P){var C={range:U};return Q.number(P)&&(C.kind=P),C}_.create=F;})(_n||(t.DocumentHighlight=_n={}));var Mr;(function(_){_.File=1,_.Module=2,_.Namespace=3,_.Package=4,_.Class=5,_.Method=6,_.Property=7,_.Field=8,_.Constructor=9,_.Enum=10,_.Interface=11,_.Function=12,_.Variable=13,_.Constant=14,_.String=15,_.Number=16,_.Boolean=17,_.Array=18,_.Object=19,_.Key=20,_.Null=21,_.EnumMember=22,_.Struct=23,_.Event=24,_.Operator=25,_.TypeParameter=26;})(Mr||(t.SymbolKind=Mr={}));var js;(function(_){_.Deprecated=1;})(js||(t.SymbolTag=js={}));var Ur;(function(_){function F(U,P,C,z,ie){var Ye={name:U,kind:P,location:{uri:z,range:C}};return ie&&(Ye.containerName=ie),Ye}_.create=F;})(Ur||(t.SymbolInformation=Ur={}));var Zr;(function(_){function F(U,P,C,z){return z!==void 0?{name:U,kind:P,location:{uri:C,range:z}}:{name:U,kind:P,location:{uri:C}}}_.create=F;})(Zr||(t.WorkspaceSymbol=Zr={}));var Vs;(function(_){function F(P,C,z,ie,Ye,Kt){var Nt={name:P,detail:C,kind:z,range:ie,selectionRange:Ye};return Kt!==void 0&&(Nt.children=Kt),Nt}_.create=F;function U(P){var C=P;return C&&Q.string(C.name)&&Q.number(C.kind)&&a.is(C.range)&&a.is(C.selectionRange)&&(C.detail===void 0||Q.string(C.detail))&&(C.deprecated===void 0||Q.boolean(C.deprecated))&&(C.children===void 0||Array.isArray(C.children))&&(C.tags===void 0||Array.isArray(C.tags))}_.is=U;})(Vs||(t.DocumentSymbol=Vs={}));var Lo;(function(_){_.Empty="",_.QuickFix="quickfix",_.Refactor="refactor",_.RefactorExtract="refactor.extract",_.RefactorInline="refactor.inline",_.RefactorRewrite="refactor.rewrite",_.Source="source",_.SourceOrganizeImports="source.organizeImports",_.SourceFixAll="source.fixAll";})(Lo||(t.CodeActionKind=Lo={}));var hn;(function(_){_.Invoked=1,_.Automatic=2;})(hn||(t.CodeActionTriggerKind=hn={}));var Hs;(function(_){function F(P,C,z){var ie={diagnostics:P};return C!=null&&(ie.only=C),z!=null&&(ie.triggerKind=z),ie}_.create=F;function U(P){var C=P;return Q.defined(C)&&Q.typedArray(C.diagnostics,b.is)&&(C.only===void 0||Q.typedArray(C.only,Q.string))&&(C.triggerKind===void 0||C.triggerKind===hn.Invoked||C.triggerKind===hn.Automatic)}_.is=U;})(Hs||(t.CodeActionContext=Hs={}));var Ws;(function(_){function F(P,C,z){var ie={title:P},Ye=!0;return typeof C=="string"?(Ye=!1,ie.kind=C):D.is(C)?ie.command=C:ie.edit=C,Ye&&z!==void 0&&(ie.kind=z),ie}_.create=F;function U(P){var C=P;return C&&Q.string(C.title)&&(C.diagnostics===void 0||Q.typedArray(C.diagnostics,b.is))&&(C.kind===void 0||Q.string(C.kind))&&(C.edit!==void 0||C.command!==void 0)&&(C.command===void 0||D.is(C.command))&&(C.isPreferred===void 0||Q.boolean(C.isPreferred))&&(C.edit===void 0||me.is(C.edit))}_.is=U;})(Ws||(t.CodeAction=Ws={}));var Ni;(function(_){function F(P,C){var z={range:P};return Q.defined(C)&&(z.data=C),z}_.create=F;function U(P){var C=P;return Q.defined(C)&&a.is(C.range)&&(Q.undefined(C.command)||D.is(C.command))}_.is=U;})(Ni||(t.CodeLens=Ni={}));var Ks;(function(_){function F(P,C){return {tabSize:P,insertSpaces:C}}_.create=F;function U(P){var C=P;return Q.defined(C)&&Q.uinteger(C.tabSize)&&Q.boolean(C.insertSpaces)}_.is=U;})(Ks||(t.FormattingOptions=Ks={}));var Kn;(function(_){function F(P,C,z){return {range:P,target:C,data:z}}_.create=F;function U(P){var C=P;return Q.defined(C)&&a.is(C.range)&&(Q.undefined(C.target)||Q.string(C.target))}_.is=U;})(Kn||(t.DocumentLink=Kn={}));var q;(function(_){function F(P,C){return {range:P,parent:C}}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&a.is(C.range)&&(C.parent===void 0||_.is(C.parent))}_.is=U;})(q||(t.SelectionRange=q={}));var ne;(function(_){_.namespace="namespace",_.type="type",_.class="class",_.enum="enum",_.interface="interface",_.struct="struct",_.typeParameter="typeParameter",_.parameter="parameter",_.variable="variable",_.property="property",_.enumMember="enumMember",_.event="event",_.function="function",_.method="method",_.macro="macro",_.keyword="keyword",_.modifier="modifier",_.comment="comment",_.string="string",_.number="number",_.regexp="regexp",_.operator="operator",_.decorator="decorator";})(ne||(t.SemanticTokenTypes=ne={}));var be;(function(_){_.declaration="declaration",_.definition="definition",_.readonly="readonly",_.static="static",_.deprecated="deprecated",_.abstract="abstract",_.async="async",_.modification="modification",_.documentation="documentation",_.defaultLibrary="defaultLibrary";})(be||(t.SemanticTokenModifiers=be={}));var Pe;(function(_){function F(U){var P=U;return Q.objectLiteral(P)&&(P.resultId===void 0||typeof P.resultId=="string")&&Array.isArray(P.data)&&(P.data.length===0||typeof P.data[0]=="number")}_.is=F;})(Pe||(t.SemanticTokens=Pe={}));var wt;(function(_){function F(P,C){return {range:P,text:C}}_.create=F;function U(P){var C=P;return C!=null&&a.is(C.range)&&Q.string(C.text)}_.is=U;})(wt||(t.InlineValueText=wt={}));var yt;(function(_){function F(P,C,z){return {range:P,variableName:C,caseSensitiveLookup:z}}_.create=F;function U(P){var C=P;return C!=null&&a.is(C.range)&&Q.boolean(C.caseSensitiveLookup)&&(Q.string(C.variableName)||C.variableName===void 0)}_.is=U;})(yt||(t.InlineValueVariableLookup=yt={}));var kt;(function(_){function F(P,C){return {range:P,expression:C}}_.create=F;function U(P){var C=P;return C!=null&&a.is(C.range)&&(Q.string(C.expression)||C.expression===void 0)}_.is=U;})(kt||(t.InlineValueEvaluatableExpression=kt={}));var Bt;(function(_){function F(P,C){return {frameId:P,stoppedLocation:C}}_.create=F;function U(P){var C=P;return Q.defined(C)&&a.is(P.stoppedLocation)}_.is=U;})(Bt||(t.InlineValueContext=Bt={}));var it;(function(_){_.Type=1,_.Parameter=2;function F(U){return U===1||U===2}_.is=F;})(it||(t.InlayHintKind=it={}));var Rt;(function(_){function F(P){return {value:P}}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&(C.tooltip===void 0||Q.string(C.tooltip)||ct.is(C.tooltip))&&(C.location===void 0||c.is(C.location))&&(C.command===void 0||D.is(C.command))}_.is=U;})(Rt||(t.InlayHintLabelPart=Rt={}));var pt;(function(_){function F(P,C,z){var ie={position:P,label:C};return z!==void 0&&(ie.kind=z),ie}_.create=F;function U(P){var C=P;return Q.objectLiteral(C)&&o.is(C.position)&&(Q.string(C.label)||Q.typedArray(C.label,Rt.is))&&(C.kind===void 0||it.is(C.kind))&&C.textEdits===void 0||Q.typedArray(C.textEdits,L.is)&&(C.tooltip===void 0||Q.string(C.tooltip)||ct.is(C.tooltip))&&(C.paddingLeft===void 0||Q.boolean(C.paddingLeft))&&(C.paddingRight===void 0||Q.boolean(C.paddingRight))}_.is=U;})(pt||(t.InlayHint=pt={}));var Wt;(function(_){function F(U){return {kind:"snippet",value:U}}_.createSnippet=F;})(Wt||(t.StringValue=Wt={}));var er;(function(_){function F(U,P,C,z){return {insertText:U,filterText:P,range:C,command:z}}_.create=F;})(er||(t.InlineCompletionItem=er={}));var $r;(function(_){function F(U){return {items:U}}_.create=F;})($r||(t.InlineCompletionList=$r={}));var Oo;(function(_){_.Invoked=0,_.Automatic=1;})(Oo||(t.InlineCompletionTriggerKind=Oo={}));var Zi;(function(_){function F(U,P){return {range:U,text:P}}_.create=F;})(Zi||(t.SelectedCompletionInfo=Zi={}));var es;(function(_){function F(U,P){return {triggerKind:U,selectedCompletionInfo:P}}_.create=F;})(es||(t.InlineCompletionContext=es={}));var nu;((function(_){function F(U){var P=U;return Q.objectLiteral(P)&&n.is(P.uri)&&Q.string(P.name)}_.is=F;}))(nu||(t.WorkspaceFolder=nu={})),t.EOL=[`
`,`\r
`,"\r"];var iu;(function(_){function F(z,ie,Ye,Kt){return new Xc(z,ie,Ye,Kt)}_.create=F;function U(z){var ie=z;return !!(Q.defined(ie)&&Q.string(ie.uri)&&(Q.undefined(ie.languageId)||Q.string(ie.languageId))&&Q.uinteger(ie.lineCount)&&Q.func(ie.getText)&&Q.func(ie.positionAt)&&Q.func(ie.offsetAt))}_.is=U;function P(z,ie){for(var Ye=z.getText(),Kt=C(ie,function(ts,Bo){var Jc=ts.range.start.line-Bo.range.start.line;return Jc===0?ts.range.start.character-Bo.range.start.character:Jc}),Nt=Ye.length,dn=Kt.length-1;dn>=0;dn--){var pn=Kt[dn],zn=z.offsetAt(pn.range.start),st=z.offsetAt(pn.range.end);if(st<=Nt)Ye=Ye.substring(0,zn)+pn.newText+Ye.substring(st,Ye.length);else throw new Error("Overlapping edit");Nt=zn;}return Ye}_.applyEdits=P;function C(z,ie){if(z.length<=1)return z;var Ye=z.length/2|0,Kt=z.slice(0,Ye),Nt=z.slice(Ye);C(Kt,ie),C(Nt,ie);for(var dn=0,pn=0,zn=0;dn<Kt.length&&pn<Nt.length;){var st=ie(Kt[dn],Nt[pn]);st<=0?z[zn++]=Kt[dn++]:z[zn++]=Nt[pn++];}for(;dn<Kt.length;)z[zn++]=Kt[dn++];for(;pn<Nt.length;)z[zn++]=Nt[pn++];return z}})(iu||(t.TextDocument=iu={}));var Xc=function(){function _(F,U,P,C){this._uri=F,this._languageId=U,this._version=P,this._content=C,this._lineOffsets=void 0;}return Object.defineProperty(_.prototype,"uri",{get:function(){return this._uri},enumerable:!1,configurable:!0}),Object.defineProperty(_.prototype,"languageId",{get:function(){return this._languageId},enumerable:!1,configurable:!0}),Object.defineProperty(_.prototype,"version",{get:function(){return this._version},enumerable:!1,configurable:!0}),_.prototype.getText=function(F){if(F){var U=this.offsetAt(F.start),P=this.offsetAt(F.end);return this._content.substring(U,P)}return this._content},_.prototype.update=function(F,U){this._content=F.text,this._version=U,this._lineOffsets=void 0;},_.prototype.getLineOffsets=function(){if(this._lineOffsets===void 0){for(var F=[],U=this._content,P=!0,C=0;C<U.length;C++){P&&(F.push(C),P=!1);var z=U.charAt(C);P=z==="\r"||z===`
`,z==="\r"&&C+1<U.length&&U.charAt(C+1)===`
`&&C++;}P&&U.length>0&&F.push(U.length),this._lineOffsets=F;}return this._lineOffsets},_.prototype.positionAt=function(F){F=Math.max(Math.min(F,this._content.length),0);var U=this.getLineOffsets(),P=0,C=U.length;if(C===0)return o.create(0,F);for(;P<C;){var z=Math.floor((P+C)/2);U[z]>F?C=z:P=z+1;}var ie=P-1;return o.create(ie,F-U[ie])},_.prototype.offsetAt=function(F){var U=this.getLineOffsets();if(F.line>=U.length)return this._content.length;if(F.line<0)return 0;var P=U[F.line],C=F.line+1<U.length?U[F.line+1]:this._content.length;return Math.max(Math.min(P+F.character,C),P)},Object.defineProperty(_.prototype,"lineCount",{get:function(){return this.getLineOffsets().length},enumerable:!1,configurable:!0}),_}(),Q;(function(_){var F=Object.prototype.toString;function U(st){return typeof st<"u"}_.defined=U;function P(st){return typeof st>"u"}_.undefined=P;function C(st){return st===!0||st===!1}_.boolean=C;function z(st){return F.call(st)==="[object String]"}_.string=z;function ie(st){return F.call(st)==="[object Number]"}_.number=ie;function Ye(st,ts,Bo){return F.call(st)==="[object Number]"&&ts<=st&&st<=Bo}_.numberRange=Ye;function Kt(st){return F.call(st)==="[object Number]"&&-2147483648<=st&&st<=2147483647}_.integer=Kt;function Nt(st){return F.call(st)==="[object Number]"&&0<=st&&st<=2147483647}_.uinteger=Nt;function dn(st){return F.call(st)==="[object Function]"}_.func=dn;function pn(st){return st!==null&&typeof st=="object"}_.objectLiteral=pn;function zn(st,ts){return Array.isArray(st)&&st.every(ts)}_.typedArray=zn;})(Q||(Q={}));});});var Gt=A(un=>{Object.defineProperty(un,"__esModule",{value:!0});un.ProtocolNotificationType=un.ProtocolNotificationType0=un.ProtocolRequestType=un.ProtocolRequestType0=un.RegistrationType=un.MessageDirection=void 0;var Va=Io(),Gq;(function(e){e.clientToServer="clientToServer",e.serverToClient="serverToClient",e.both="both";})(Gq||(un.MessageDirection=Gq={}));var Yb=class{constructor(t){this.method=t;}};un.RegistrationType=Yb;var Qb=class extends Va.RequestType0{constructor(t){super(t);}};un.ProtocolRequestType0=Qb;var Xb=class extends Va.RequestType{constructor(t){super(t,Va.ParameterStructures.byName);}};un.ProtocolRequestType=Xb;var Jb=class extends Va.NotificationType0{constructor(t){super(t);}};un.ProtocolNotificationType0=Jb;var Zb=class extends Va.NotificationType{constructor(t){super(t,Va.ParameterStructures.byName);}};un.ProtocolNotificationType=Zb;});var Pd=A(ur=>{Object.defineProperty(ur,"__esModule",{value:!0});ur.objectLiteral=ur.typedArray=ur.stringArray=ur.array=ur.func=ur.error=ur.number=ur.string=ur.boolean=void 0;function uie(e){return e===!0||e===!1}ur.boolean=uie;function Yq(e){return typeof e=="string"||e instanceof String}ur.string=Yq;function cie(e){return typeof e=="number"||e instanceof Number}ur.number=cie;function lie(e){return e instanceof Error}ur.error=lie;function fie(e){return typeof e=="function"}ur.func=fie;function Qq(e){return Array.isArray(e)}ur.array=Qq;function hie(e){return Qq(e)&&e.every(t=>Yq(t))}ur.stringArray=hie;function die(e,t){return Array.isArray(e)&&e.every(t)}ur.typedArray=die;function pie(e){return e!==null&&typeof e=="object"}ur.objectLiteral=pie;});var Zq=A(kd=>{Object.defineProperty(kd,"__esModule",{value:!0});kd.ImplementationRequest=void 0;var Xq=Gt(),Jq;(function(e){e.method="textDocument/implementation",e.messageDirection=Xq.MessageDirection.clientToServer,e.type=new Xq.ProtocolRequestType(e.method);})(Jq||(kd.ImplementationRequest=Jq={}));});var rF=A(Nd=>{Object.defineProperty(Nd,"__esModule",{value:!0});Nd.TypeDefinitionRequest=void 0;var eF=Gt(),tF;(function(e){e.method="textDocument/typeDefinition",e.messageDirection=eF.MessageDirection.clientToServer,e.type=new eF.ProtocolRequestType(e.method);})(tF||(Nd.TypeDefinitionRequest=tF={}));});var sF=A(Ha=>{Object.defineProperty(Ha,"__esModule",{value:!0});Ha.DidChangeWorkspaceFoldersNotification=Ha.WorkspaceFoldersRequest=void 0;var Ld=Gt(),nF;(function(e){e.method="workspace/workspaceFolders",e.messageDirection=Ld.MessageDirection.serverToClient,e.type=new Ld.ProtocolRequestType0(e.method);})(nF||(Ha.WorkspaceFoldersRequest=nF={}));var iF;(function(e){e.method="workspace/didChangeWorkspaceFolders",e.messageDirection=Ld.MessageDirection.clientToServer,e.type=new Ld.ProtocolNotificationType(e.method);})(iF||(Ha.DidChangeWorkspaceFoldersNotification=iF={}));});var uF=A(Od=>{Object.defineProperty(Od,"__esModule",{value:!0});Od.ConfigurationRequest=void 0;var oF=Gt(),aF;(function(e){e.method="workspace/configuration",e.messageDirection=oF.MessageDirection.serverToClient,e.type=new oF.ProtocolRequestType(e.method);})(aF||(Od.ConfigurationRequest=aF={}));});var fF=A(Wa=>{Object.defineProperty(Wa,"__esModule",{value:!0});Wa.ColorPresentationRequest=Wa.DocumentColorRequest=void 0;var Bd=Gt(),cF;(function(e){e.method="textDocument/documentColor",e.messageDirection=Bd.MessageDirection.clientToServer,e.type=new Bd.ProtocolRequestType(e.method);})(cF||(Wa.DocumentColorRequest=cF={}));var lF;(function(e){e.method="textDocument/colorPresentation",e.messageDirection=Bd.MessageDirection.clientToServer,e.type=new Bd.ProtocolRequestType(e.method);})(lF||(Wa.ColorPresentationRequest=lF={}));});var pF=A(Ka=>{Object.defineProperty(Ka,"__esModule",{value:!0});Ka.FoldingRangeRefreshRequest=Ka.FoldingRangeRequest=void 0;var qd=Gt(),hF;(function(e){e.method="textDocument/foldingRange",e.messageDirection=qd.MessageDirection.clientToServer,e.type=new qd.ProtocolRequestType(e.method);})(hF||(Ka.FoldingRangeRequest=hF={}));var dF;(function(e){e.method="workspace/foldingRange/refresh",e.messageDirection=qd.MessageDirection.serverToClient,e.type=new qd.ProtocolRequestType0(e.method);})(dF||(Ka.FoldingRangeRefreshRequest=dF={}));});var yF=A(Fd=>{Object.defineProperty(Fd,"__esModule",{value:!0});Fd.DeclarationRequest=void 0;var gF=Gt(),mF;(function(e){e.method="textDocument/declaration",e.messageDirection=gF.MessageDirection.clientToServer,e.type=new gF.ProtocolRequestType(e.method);})(mF||(Fd.DeclarationRequest=mF={}));});var bF=A(Md=>{Object.defineProperty(Md,"__esModule",{value:!0});Md.SelectionRangeRequest=void 0;var vF=Gt(),SF;(function(e){e.method="textDocument/selectionRange",e.messageDirection=vF.MessageDirection.clientToServer,e.type=new vF.ProtocolRequestType(e.method);})(SF||(Md.SelectionRangeRequest=SF={}));});var wF=A(Ls=>{Object.defineProperty(Ls,"__esModule",{value:!0});Ls.WorkDoneProgressCancelNotification=Ls.WorkDoneProgressCreateRequest=Ls.WorkDoneProgress=void 0;var gie=Io(),Ud=Gt(),CF;(function(e){e.type=new gie.ProgressType;function t(r){return r===e.type}e.is=t;})(CF||(Ls.WorkDoneProgress=CF={}));var EF;(function(e){e.method="window/workDoneProgress/create",e.messageDirection=Ud.MessageDirection.serverToClient,e.type=new Ud.ProtocolRequestType(e.method);})(EF||(Ls.WorkDoneProgressCreateRequest=EF={}));var xF;(function(e){e.method="window/workDoneProgress/cancel",e.messageDirection=Ud.MessageDirection.clientToServer,e.type=new Ud.ProtocolNotificationType(e.method);})(xF||(Ls.WorkDoneProgressCancelNotification=xF={}));});var RF=A(Os=>{Object.defineProperty(Os,"__esModule",{value:!0});Os.CallHierarchyOutgoingCallsRequest=Os.CallHierarchyIncomingCallsRequest=Os.CallHierarchyPrepareRequest=void 0;var za=Gt(),_F;(function(e){e.method="textDocument/prepareCallHierarchy",e.messageDirection=za.MessageDirection.clientToServer,e.type=new za.ProtocolRequestType(e.method);})(_F||(Os.CallHierarchyPrepareRequest=_F={}));var TF;(function(e){e.method="callHierarchy/incomingCalls",e.messageDirection=za.MessageDirection.clientToServer,e.type=new za.ProtocolRequestType(e.method);})(TF||(Os.CallHierarchyIncomingCallsRequest=TF={}));var AF;(function(e){e.method="callHierarchy/outgoingCalls",e.messageDirection=za.MessageDirection.clientToServer,e.type=new za.ProtocolRequestType(e.method);})(AF||(Os.CallHierarchyOutgoingCallsRequest=AF={}));});var LF=A(cn=>{Object.defineProperty(cn,"__esModule",{value:!0});cn.SemanticTokensRefreshRequest=cn.SemanticTokensRangeRequest=cn.SemanticTokensDeltaRequest=cn.SemanticTokensRequest=cn.SemanticTokensRegistrationType=cn.TokenFormat=void 0;var Ji=Gt(),IF;(function(e){e.Relative="relative";})(IF||(cn.TokenFormat=IF={}));var jc;(function(e){e.method="textDocument/semanticTokens",e.type=new Ji.RegistrationType(e.method);})(jc||(cn.SemanticTokensRegistrationType=jc={}));var DF;(function(e){e.method="textDocument/semanticTokens/full",e.messageDirection=Ji.MessageDirection.clientToServer,e.type=new Ji.ProtocolRequestType(e.method),e.registrationMethod=jc.method;})(DF||(cn.SemanticTokensRequest=DF={}));var PF;(function(e){e.method="textDocument/semanticTokens/full/delta",e.messageDirection=Ji.MessageDirection.clientToServer,e.type=new Ji.ProtocolRequestType(e.method),e.registrationMethod=jc.method;})(PF||(cn.SemanticTokensDeltaRequest=PF={}));var kF;(function(e){e.method="textDocument/semanticTokens/range",e.messageDirection=Ji.MessageDirection.clientToServer,e.type=new Ji.ProtocolRequestType(e.method),e.registrationMethod=jc.method;})(kF||(cn.SemanticTokensRangeRequest=kF={}));var NF;(function(e){e.method="workspace/semanticTokens/refresh",e.messageDirection=Ji.MessageDirection.serverToClient,e.type=new Ji.ProtocolRequestType0(e.method);})(NF||(cn.SemanticTokensRefreshRequest=NF={}));});var qF=A($d=>{Object.defineProperty($d,"__esModule",{value:!0});$d.ShowDocumentRequest=void 0;var OF=Gt(),BF;(function(e){e.method="window/showDocument",e.messageDirection=OF.MessageDirection.serverToClient,e.type=new OF.ProtocolRequestType(e.method);})(BF||($d.ShowDocumentRequest=BF={}));});var UF=A(jd=>{Object.defineProperty(jd,"__esModule",{value:!0});jd.LinkedEditingRangeRequest=void 0;var FF=Gt(),MF;(function(e){e.method="textDocument/linkedEditingRange",e.messageDirection=FF.MessageDirection.clientToServer,e.type=new FF.ProtocolRequestType(e.method);})(MF||(jd.LinkedEditingRangeRequest=MF={}));});var GF=A(qr=>{Object.defineProperty(qr,"__esModule",{value:!0});qr.WillDeleteFilesRequest=qr.DidDeleteFilesNotification=qr.DidRenameFilesNotification=qr.WillRenameFilesRequest=qr.DidCreateFilesNotification=qr.WillCreateFilesRequest=qr.FileOperationPatternKind=void 0;var Un=Gt(),$F;(function(e){e.file="file",e.folder="folder";})($F||(qr.FileOperationPatternKind=$F={}));var jF;(function(e){e.method="workspace/willCreateFiles",e.messageDirection=Un.MessageDirection.clientToServer,e.type=new Un.ProtocolRequestType(e.method);})(jF||(qr.WillCreateFilesRequest=jF={}));var VF;(function(e){e.method="workspace/didCreateFiles",e.messageDirection=Un.MessageDirection.clientToServer,e.type=new Un.ProtocolNotificationType(e.method);})(VF||(qr.DidCreateFilesNotification=VF={}));var HF;(function(e){e.method="workspace/willRenameFiles",e.messageDirection=Un.MessageDirection.clientToServer,e.type=new Un.ProtocolRequestType(e.method);})(HF||(qr.WillRenameFilesRequest=HF={}));var WF;(function(e){e.method="workspace/didRenameFiles",e.messageDirection=Un.MessageDirection.clientToServer,e.type=new Un.ProtocolNotificationType(e.method);})(WF||(qr.DidRenameFilesNotification=WF={}));var KF;(function(e){e.method="workspace/didDeleteFiles",e.messageDirection=Un.MessageDirection.clientToServer,e.type=new Un.ProtocolNotificationType(e.method);})(KF||(qr.DidDeleteFilesNotification=KF={}));var zF;(function(e){e.method="workspace/willDeleteFiles",e.messageDirection=Un.MessageDirection.clientToServer,e.type=new Un.ProtocolRequestType(e.method);})(zF||(qr.WillDeleteFilesRequest=zF={}));});var ZF=A(Bs=>{Object.defineProperty(Bs,"__esModule",{value:!0});Bs.MonikerRequest=Bs.MonikerKind=Bs.UniquenessLevel=void 0;var YF=Gt(),QF;(function(e){e.document="document",e.project="project",e.group="group",e.scheme="scheme",e.global="global";})(QF||(Bs.UniquenessLevel=QF={}));var XF;(function(e){e.$import="import",e.$export="export",e.local="local";})(XF||(Bs.MonikerKind=XF={}));var JF;(function(e){e.method="textDocument/moniker",e.messageDirection=YF.MessageDirection.clientToServer,e.type=new YF.ProtocolRequestType(e.method);})(JF||(Bs.MonikerRequest=JF={}));});var n4=A(qs=>{Object.defineProperty(qs,"__esModule",{value:!0});qs.TypeHierarchySubtypesRequest=qs.TypeHierarchySupertypesRequest=qs.TypeHierarchyPrepareRequest=void 0;var Ga=Gt(),e4;(function(e){e.method="textDocument/prepareTypeHierarchy",e.messageDirection=Ga.MessageDirection.clientToServer,e.type=new Ga.ProtocolRequestType(e.method);})(e4||(qs.TypeHierarchyPrepareRequest=e4={}));var t4;(function(e){e.method="typeHierarchy/supertypes",e.messageDirection=Ga.MessageDirection.clientToServer,e.type=new Ga.ProtocolRequestType(e.method);})(t4||(qs.TypeHierarchySupertypesRequest=t4={}));var r4;(function(e){e.method="typeHierarchy/subtypes",e.messageDirection=Ga.MessageDirection.clientToServer,e.type=new Ga.ProtocolRequestType(e.method);})(r4||(qs.TypeHierarchySubtypesRequest=r4={}));});var o4=A(Ya=>{Object.defineProperty(Ya,"__esModule",{value:!0});Ya.InlineValueRefreshRequest=Ya.InlineValueRequest=void 0;var Vd=Gt(),i4;(function(e){e.method="textDocument/inlineValue",e.messageDirection=Vd.MessageDirection.clientToServer,e.type=new Vd.ProtocolRequestType(e.method);})(i4||(Ya.InlineValueRequest=i4={}));var s4;(function(e){e.method="workspace/inlineValue/refresh",e.messageDirection=Vd.MessageDirection.serverToClient,e.type=new Vd.ProtocolRequestType0(e.method);})(s4||(Ya.InlineValueRefreshRequest=s4={}));});var l4=A(Fs=>{Object.defineProperty(Fs,"__esModule",{value:!0});Fs.InlayHintRefreshRequest=Fs.InlayHintResolveRequest=Fs.InlayHintRequest=void 0;var Qa=Gt(),a4;(function(e){e.method="textDocument/inlayHint",e.messageDirection=Qa.MessageDirection.clientToServer,e.type=new Qa.ProtocolRequestType(e.method);})(a4||(Fs.InlayHintRequest=a4={}));var u4;(function(e){e.method="inlayHint/resolve",e.messageDirection=Qa.MessageDirection.clientToServer,e.type=new Qa.ProtocolRequestType(e.method);})(u4||(Fs.InlayHintResolveRequest=u4={}));var c4;(function(e){e.method="workspace/inlayHint/refresh",e.messageDirection=Qa.MessageDirection.serverToClient,e.type=new Qa.ProtocolRequestType0(e.method);})(c4||(Fs.InlayHintRefreshRequest=c4={}));});var y4=A($n=>{Object.defineProperty($n,"__esModule",{value:!0});$n.DiagnosticRefreshRequest=$n.WorkspaceDiagnosticRequest=$n.DocumentDiagnosticRequest=$n.DocumentDiagnosticReportKind=$n.DiagnosticServerCancellationData=void 0;var m4=Io(),mie=Pd(),Xa=Gt(),f4;(function(e){function t(r){let n=r;return n&&mie.boolean(n.retriggerRequest)}e.is=t;})(f4||($n.DiagnosticServerCancellationData=f4={}));var h4;(function(e){e.Full="full",e.Unchanged="unchanged";})(h4||($n.DocumentDiagnosticReportKind=h4={}));var d4;(function(e){e.method="textDocument/diagnostic",e.messageDirection=Xa.MessageDirection.clientToServer,e.type=new Xa.ProtocolRequestType(e.method),e.partialResult=new m4.ProgressType;})(d4||($n.DocumentDiagnosticRequest=d4={}));var p4;(function(e){e.method="workspace/diagnostic",e.messageDirection=Xa.MessageDirection.clientToServer,e.type=new Xa.ProtocolRequestType(e.method),e.partialResult=new m4.ProgressType;})(p4||($n.WorkspaceDiagnosticRequest=p4={}));var g4;(function(e){e.method="workspace/diagnostic/refresh",e.messageDirection=Xa.MessageDirection.serverToClient,e.type=new Xa.ProtocolRequestType0(e.method);})(g4||($n.DiagnosticRefreshRequest=g4={}));});var w4=A(Zt=>{Object.defineProperty(Zt,"__esModule",{value:!0});Zt.DidCloseNotebookDocumentNotification=Zt.DidSaveNotebookDocumentNotification=Zt.DidChangeNotebookDocumentNotification=Zt.NotebookCellArrayChange=Zt.DidOpenNotebookDocumentNotification=Zt.NotebookDocumentSyncRegistrationType=Zt.NotebookDocument=Zt.NotebookCell=Zt.ExecutionSummary=Zt.NotebookCellKind=void 0;var Vc=Dd(),oi=Pd(),Ii=Gt(),eC;(function(e){e.Markup=1,e.Code=2;function t(r){return r===1||r===2}e.is=t;})(eC||(Zt.NotebookCellKind=eC={}));var tC;(function(e){function t(i,s){let o={executionOrder:i};return (s===!0||s===!1)&&(o.success=s),o}e.create=t;function r(i){let s=i;return oi.objectLiteral(s)&&Vc.uinteger.is(s.executionOrder)&&(s.success===void 0||oi.boolean(s.success))}e.is=r;function n(i,s){return i===s?!0:i==null||s===null||s===void 0?!1:i.executionOrder===s.executionOrder&&i.success===s.success}e.equals=n;})(tC||(Zt.ExecutionSummary=tC={}));var Hd;(function(e){function t(s,o){return {kind:s,document:o}}e.create=t;function r(s){let o=s;return oi.objectLiteral(o)&&eC.is(o.kind)&&Vc.DocumentUri.is(o.document)&&(o.metadata===void 0||oi.objectLiteral(o.metadata))}e.is=r;function n(s,o){let a=new Set;return s.document!==o.document&&a.add("document"),s.kind!==o.kind&&a.add("kind"),s.executionSummary!==o.executionSummary&&a.add("executionSummary"),(s.metadata!==void 0||o.metadata!==void 0)&&!i(s.metadata,o.metadata)&&a.add("metadata"),(s.executionSummary!==void 0||o.executionSummary!==void 0)&&!tC.equals(s.executionSummary,o.executionSummary)&&a.add("executionSummary"),a}e.diff=n;function i(s,o){if(s===o)return !0;if(s==null||o===null||o===void 0||typeof s!=typeof o||typeof s!="object")return !1;let a=Array.isArray(s),c=Array.isArray(o);if(a!==c)return !1;if(a&&c){if(s.length!==o.length)return !1;for(let l=0;l<s.length;l++)if(!i(s[l],o[l]))return !1}if(oi.objectLiteral(s)&&oi.objectLiteral(o)){let l=Object.keys(s),u=Object.keys(o);if(l.length!==u.length||(l.sort(),u.sort(),!i(l,u)))return !1;for(let f=0;f<l.length;f++){let d=l[f];if(!i(s[d],o[d]))return !1}}return !0}})(Hd||(Zt.NotebookCell=Hd={}));var v4;(function(e){function t(n,i,s,o){return {uri:n,notebookType:i,version:s,cells:o}}e.create=t;function r(n){let i=n;return oi.objectLiteral(i)&&oi.string(i.uri)&&Vc.integer.is(i.version)&&oi.typedArray(i.cells,Hd.is)}e.is=r;})(v4||(Zt.NotebookDocument=v4={}));var Ja;(function(e){e.method="notebookDocument/sync",e.messageDirection=Ii.MessageDirection.clientToServer,e.type=new Ii.RegistrationType(e.method);})(Ja||(Zt.NotebookDocumentSyncRegistrationType=Ja={}));var S4;(function(e){e.method="notebookDocument/didOpen",e.messageDirection=Ii.MessageDirection.clientToServer,e.type=new Ii.ProtocolNotificationType(e.method),e.registrationMethod=Ja.method;})(S4||(Zt.DidOpenNotebookDocumentNotification=S4={}));var b4;(function(e){function t(n){let i=n;return oi.objectLiteral(i)&&Vc.uinteger.is(i.start)&&Vc.uinteger.is(i.deleteCount)&&(i.cells===void 0||oi.typedArray(i.cells,Hd.is))}e.is=t;function r(n,i,s){let o={start:n,deleteCount:i};return s!==void 0&&(o.cells=s),o}e.create=r;})(b4||(Zt.NotebookCellArrayChange=b4={}));var C4;(function(e){e.method="notebookDocument/didChange",e.messageDirection=Ii.MessageDirection.clientToServer,e.type=new Ii.ProtocolNotificationType(e.method),e.registrationMethod=Ja.method;})(C4||(Zt.DidChangeNotebookDocumentNotification=C4={}));var E4;(function(e){e.method="notebookDocument/didSave",e.messageDirection=Ii.MessageDirection.clientToServer,e.type=new Ii.ProtocolNotificationType(e.method),e.registrationMethod=Ja.method;})(E4||(Zt.DidSaveNotebookDocumentNotification=E4={}));var x4;(function(e){e.method="notebookDocument/didClose",e.messageDirection=Ii.MessageDirection.clientToServer,e.type=new Ii.ProtocolNotificationType(e.method),e.registrationMethod=Ja.method;})(x4||(Zt.DidCloseNotebookDocumentNotification=x4={}));});var A4=A(Wd=>{Object.defineProperty(Wd,"__esModule",{value:!0});Wd.InlineCompletionRequest=void 0;var _4=Gt(),T4;(function(e){e.method="textDocument/inlineCompletion",e.messageDirection=_4.MessageDirection.clientToServer,e.type=new _4.ProtocolRequestType(e.method);})(T4||(Wd.InlineCompletionRequest=T4={}));});var U3=A(N=>{Object.defineProperty(N,"__esModule",{value:!0});N.WorkspaceSymbolRequest=N.CodeActionResolveRequest=N.CodeActionRequest=N.DocumentSymbolRequest=N.DocumentHighlightRequest=N.ReferencesRequest=N.DefinitionRequest=N.SignatureHelpRequest=N.SignatureHelpTriggerKind=N.HoverRequest=N.CompletionResolveRequest=N.CompletionRequest=N.CompletionTriggerKind=N.PublishDiagnosticsNotification=N.WatchKind=N.RelativePattern=N.FileChangeType=N.DidChangeWatchedFilesNotification=N.WillSaveTextDocumentWaitUntilRequest=N.WillSaveTextDocumentNotification=N.TextDocumentSaveReason=N.DidSaveTextDocumentNotification=N.DidCloseTextDocumentNotification=N.DidChangeTextDocumentNotification=N.TextDocumentContentChangeEvent=N.DidOpenTextDocumentNotification=N.TextDocumentSyncKind=N.TelemetryEventNotification=N.LogMessageNotification=N.ShowMessageRequest=N.ShowMessageNotification=N.MessageType=N.DidChangeConfigurationNotification=N.ExitNotification=N.ShutdownRequest=N.InitializedNotification=N.InitializeErrorCodes=N.InitializeRequest=N.WorkDoneProgressOptions=N.TextDocumentRegistrationOptions=N.StaticRegistrationOptions=N.PositionEncodingKind=N.FailureHandlingKind=N.ResourceOperationKind=N.UnregistrationRequest=N.RegistrationRequest=N.DocumentSelector=N.NotebookCellTextDocumentFilter=N.NotebookDocumentFilter=N.TextDocumentFilter=void 0;N.MonikerRequest=N.MonikerKind=N.UniquenessLevel=N.WillDeleteFilesRequest=N.DidDeleteFilesNotification=N.WillRenameFilesRequest=N.DidRenameFilesNotification=N.WillCreateFilesRequest=N.DidCreateFilesNotification=N.FileOperationPatternKind=N.LinkedEditingRangeRequest=N.ShowDocumentRequest=N.SemanticTokensRegistrationType=N.SemanticTokensRefreshRequest=N.SemanticTokensRangeRequest=N.SemanticTokensDeltaRequest=N.SemanticTokensRequest=N.TokenFormat=N.CallHierarchyPrepareRequest=N.CallHierarchyOutgoingCallsRequest=N.CallHierarchyIncomingCallsRequest=N.WorkDoneProgressCancelNotification=N.WorkDoneProgressCreateRequest=N.WorkDoneProgress=N.SelectionRangeRequest=N.DeclarationRequest=N.FoldingRangeRefreshRequest=N.FoldingRangeRequest=N.ColorPresentationRequest=N.DocumentColorRequest=N.ConfigurationRequest=N.DidChangeWorkspaceFoldersNotification=N.WorkspaceFoldersRequest=N.TypeDefinitionRequest=N.ImplementationRequest=N.ApplyWorkspaceEditRequest=N.ExecuteCommandRequest=N.PrepareRenameRequest=N.RenameRequest=N.PrepareSupportDefaultBehavior=N.DocumentOnTypeFormattingRequest=N.DocumentRangesFormattingRequest=N.DocumentRangeFormattingRequest=N.DocumentFormattingRequest=N.DocumentLinkResolveRequest=N.DocumentLinkRequest=N.CodeLensRefreshRequest=N.CodeLensResolveRequest=N.CodeLensRequest=N.WorkspaceSymbolResolveRequest=void 0;N.InlineCompletionRequest=N.DidCloseNotebookDocumentNotification=N.DidSaveNotebookDocumentNotification=N.DidChangeNotebookDocumentNotification=N.NotebookCellArrayChange=N.DidOpenNotebookDocumentNotification=N.NotebookDocumentSyncRegistrationType=N.NotebookDocument=N.NotebookCell=N.ExecutionSummary=N.NotebookCellKind=N.DiagnosticRefreshRequest=N.WorkspaceDiagnosticRequest=N.DocumentDiagnosticRequest=N.DocumentDiagnosticReportKind=N.DiagnosticServerCancellationData=N.InlayHintRefreshRequest=N.InlayHintResolveRequest=N.InlayHintRequest=N.InlineValueRefreshRequest=N.InlineValueRequest=N.TypeHierarchySupertypesRequest=N.TypeHierarchySubtypesRequest=N.TypeHierarchyPrepareRequest=void 0;var ve=Gt(),R4=Dd(),Er=Pd(),yie=Zq();Object.defineProperty(N,"ImplementationRequest",{enumerable:!0,get:function(){return yie.ImplementationRequest}});var vie=rF();Object.defineProperty(N,"TypeDefinitionRequest",{enumerable:!0,get:function(){return vie.TypeDefinitionRequest}});var B3=sF();Object.defineProperty(N,"WorkspaceFoldersRequest",{enumerable:!0,get:function(){return B3.WorkspaceFoldersRequest}});Object.defineProperty(N,"DidChangeWorkspaceFoldersNotification",{enumerable:!0,get:function(){return B3.DidChangeWorkspaceFoldersNotification}});var Sie=uF();Object.defineProperty(N,"ConfigurationRequest",{enumerable:!0,get:function(){return Sie.ConfigurationRequest}});var q3=fF();Object.defineProperty(N,"DocumentColorRequest",{enumerable:!0,get:function(){return q3.DocumentColorRequest}});Object.defineProperty(N,"ColorPresentationRequest",{enumerable:!0,get:function(){return q3.ColorPresentationRequest}});var F3=pF();Object.defineProperty(N,"FoldingRangeRequest",{enumerable:!0,get:function(){return F3.FoldingRangeRequest}});Object.defineProperty(N,"FoldingRangeRefreshRequest",{enumerable:!0,get:function(){return F3.FoldingRangeRefreshRequest}});var bie=yF();Object.defineProperty(N,"DeclarationRequest",{enumerable:!0,get:function(){return bie.DeclarationRequest}});var Cie=bF();Object.defineProperty(N,"SelectionRangeRequest",{enumerable:!0,get:function(){return Cie.SelectionRangeRequest}});var oC=wF();Object.defineProperty(N,"WorkDoneProgress",{enumerable:!0,get:function(){return oC.WorkDoneProgress}});Object.defineProperty(N,"WorkDoneProgressCreateRequest",{enumerable:!0,get:function(){return oC.WorkDoneProgressCreateRequest}});Object.defineProperty(N,"WorkDoneProgressCancelNotification",{enumerable:!0,get:function(){return oC.WorkDoneProgressCancelNotification}});var aC=RF();Object.defineProperty(N,"CallHierarchyIncomingCallsRequest",{enumerable:!0,get:function(){return aC.CallHierarchyIncomingCallsRequest}});Object.defineProperty(N,"CallHierarchyOutgoingCallsRequest",{enumerable:!0,get:function(){return aC.CallHierarchyOutgoingCallsRequest}});Object.defineProperty(N,"CallHierarchyPrepareRequest",{enumerable:!0,get:function(){return aC.CallHierarchyPrepareRequest}});var Za=LF();Object.defineProperty(N,"TokenFormat",{enumerable:!0,get:function(){return Za.TokenFormat}});Object.defineProperty(N,"SemanticTokensRequest",{enumerable:!0,get:function(){return Za.SemanticTokensRequest}});Object.defineProperty(N,"SemanticTokensDeltaRequest",{enumerable:!0,get:function(){return Za.SemanticTokensDeltaRequest}});Object.defineProperty(N,"SemanticTokensRangeRequest",{enumerable:!0,get:function(){return Za.SemanticTokensRangeRequest}});Object.defineProperty(N,"SemanticTokensRefreshRequest",{enumerable:!0,get:function(){return Za.SemanticTokensRefreshRequest}});Object.defineProperty(N,"SemanticTokensRegistrationType",{enumerable:!0,get:function(){return Za.SemanticTokensRegistrationType}});var Eie=qF();Object.defineProperty(N,"ShowDocumentRequest",{enumerable:!0,get:function(){return Eie.ShowDocumentRequest}});var xie=UF();Object.defineProperty(N,"LinkedEditingRangeRequest",{enumerable:!0,get:function(){return xie.LinkedEditingRangeRequest}});var Do=GF();Object.defineProperty(N,"FileOperationPatternKind",{enumerable:!0,get:function(){return Do.FileOperationPatternKind}});Object.defineProperty(N,"DidCreateFilesNotification",{enumerable:!0,get:function(){return Do.DidCreateFilesNotification}});Object.defineProperty(N,"WillCreateFilesRequest",{enumerable:!0,get:function(){return Do.WillCreateFilesRequest}});Object.defineProperty(N,"DidRenameFilesNotification",{enumerable:!0,get:function(){return Do.DidRenameFilesNotification}});Object.defineProperty(N,"WillRenameFilesRequest",{enumerable:!0,get:function(){return Do.WillRenameFilesRequest}});Object.defineProperty(N,"DidDeleteFilesNotification",{enumerable:!0,get:function(){return Do.DidDeleteFilesNotification}});Object.defineProperty(N,"WillDeleteFilesRequest",{enumerable:!0,get:function(){return Do.WillDeleteFilesRequest}});var uC=ZF();Object.defineProperty(N,"UniquenessLevel",{enumerable:!0,get:function(){return uC.UniquenessLevel}});Object.defineProperty(N,"MonikerKind",{enumerable:!0,get:function(){return uC.MonikerKind}});Object.defineProperty(N,"MonikerRequest",{enumerable:!0,get:function(){return uC.MonikerRequest}});var cC=n4();Object.defineProperty(N,"TypeHierarchyPrepareRequest",{enumerable:!0,get:function(){return cC.TypeHierarchyPrepareRequest}});Object.defineProperty(N,"TypeHierarchySubtypesRequest",{enumerable:!0,get:function(){return cC.TypeHierarchySubtypesRequest}});Object.defineProperty(N,"TypeHierarchySupertypesRequest",{enumerable:!0,get:function(){return cC.TypeHierarchySupertypesRequest}});var M3=o4();Object.defineProperty(N,"InlineValueRequest",{enumerable:!0,get:function(){return M3.InlineValueRequest}});Object.defineProperty(N,"InlineValueRefreshRequest",{enumerable:!0,get:function(){return M3.InlineValueRefreshRequest}});var lC=l4();Object.defineProperty(N,"InlayHintRequest",{enumerable:!0,get:function(){return lC.InlayHintRequest}});Object.defineProperty(N,"InlayHintResolveRequest",{enumerable:!0,get:function(){return lC.InlayHintResolveRequest}});Object.defineProperty(N,"InlayHintRefreshRequest",{enumerable:!0,get:function(){return lC.InlayHintRefreshRequest}});var Hc=y4();Object.defineProperty(N,"DiagnosticServerCancellationData",{enumerable:!0,get:function(){return Hc.DiagnosticServerCancellationData}});Object.defineProperty(N,"DocumentDiagnosticReportKind",{enumerable:!0,get:function(){return Hc.DocumentDiagnosticReportKind}});Object.defineProperty(N,"DocumentDiagnosticRequest",{enumerable:!0,get:function(){return Hc.DocumentDiagnosticRequest}});Object.defineProperty(N,"WorkspaceDiagnosticRequest",{enumerable:!0,get:function(){return Hc.WorkspaceDiagnosticRequest}});Object.defineProperty(N,"DiagnosticRefreshRequest",{enumerable:!0,get:function(){return Hc.DiagnosticRefreshRequest}});var Di=w4();Object.defineProperty(N,"NotebookCellKind",{enumerable:!0,get:function(){return Di.NotebookCellKind}});Object.defineProperty(N,"ExecutionSummary",{enumerable:!0,get:function(){return Di.ExecutionSummary}});Object.defineProperty(N,"NotebookCell",{enumerable:!0,get:function(){return Di.NotebookCell}});Object.defineProperty(N,"NotebookDocument",{enumerable:!0,get:function(){return Di.NotebookDocument}});Object.defineProperty(N,"NotebookDocumentSyncRegistrationType",{enumerable:!0,get:function(){return Di.NotebookDocumentSyncRegistrationType}});Object.defineProperty(N,"DidOpenNotebookDocumentNotification",{enumerable:!0,get:function(){return Di.DidOpenNotebookDocumentNotification}});Object.defineProperty(N,"NotebookCellArrayChange",{enumerable:!0,get:function(){return Di.NotebookCellArrayChange}});Object.defineProperty(N,"DidChangeNotebookDocumentNotification",{enumerable:!0,get:function(){return Di.DidChangeNotebookDocumentNotification}});Object.defineProperty(N,"DidSaveNotebookDocumentNotification",{enumerable:!0,get:function(){return Di.DidSaveNotebookDocumentNotification}});Object.defineProperty(N,"DidCloseNotebookDocumentNotification",{enumerable:!0,get:function(){return Di.DidCloseNotebookDocumentNotification}});var wie=A4();Object.defineProperty(N,"InlineCompletionRequest",{enumerable:!0,get:function(){return wie.InlineCompletionRequest}});var rC;(function(e){function t(r){let n=r;return Er.string(n)||Er.string(n.language)||Er.string(n.scheme)||Er.string(n.pattern)}e.is=t;})(rC||(N.TextDocumentFilter=rC={}));var nC;(function(e){function t(r){let n=r;return Er.objectLiteral(n)&&(Er.string(n.notebookType)||Er.string(n.scheme)||Er.string(n.pattern))}e.is=t;})(nC||(N.NotebookDocumentFilter=nC={}));var iC;(function(e){function t(r){let n=r;return Er.objectLiteral(n)&&(Er.string(n.notebook)||nC.is(n.notebook))&&(n.language===void 0||Er.string(n.language))}e.is=t;})(iC||(N.NotebookCellTextDocumentFilter=iC={}));var sC;(function(e){function t(r){if(!Array.isArray(r))return !1;for(let n of r)if(!Er.string(n)&&!rC.is(n)&&!iC.is(n))return !1;return !0}e.is=t;})(sC||(N.DocumentSelector=sC={}));var I4;(function(e){e.method="client/registerCapability",e.messageDirection=ve.MessageDirection.serverToClient,e.type=new ve.ProtocolRequestType(e.method);})(I4||(N.RegistrationRequest=I4={}));var D4;(function(e){e.method="client/unregisterCapability",e.messageDirection=ve.MessageDirection.serverToClient,e.type=new ve.ProtocolRequestType(e.method);})(D4||(N.UnregistrationRequest=D4={}));var P4;(function(e){e.Create="create",e.Rename="rename",e.Delete="delete";})(P4||(N.ResourceOperationKind=P4={}));var k4;(function(e){e.Abort="abort",e.Transactional="transactional",e.TextOnlyTransactional="textOnlyTransactional",e.Undo="undo";})(k4||(N.FailureHandlingKind=k4={}));var N4;(function(e){e.UTF8="utf-8",e.UTF16="utf-16",e.UTF32="utf-32";})(N4||(N.PositionEncodingKind=N4={}));var L4;(function(e){function t(r){let n=r;return n&&Er.string(n.id)&&n.id.length>0}e.hasId=t;})(L4||(N.StaticRegistrationOptions=L4={}));var O4;(function(e){function t(r){let n=r;return n&&(n.documentSelector===null||sC.is(n.documentSelector))}e.is=t;})(O4||(N.TextDocumentRegistrationOptions=O4={}));var B4;(function(e){function t(n){let i=n;return Er.objectLiteral(i)&&(i.workDoneProgress===void 0||Er.boolean(i.workDoneProgress))}e.is=t;function r(n){let i=n;return i&&Er.boolean(i.workDoneProgress)}e.hasWorkDoneProgress=r;})(B4||(N.WorkDoneProgressOptions=B4={}));var q4;(function(e){e.method="initialize",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(q4||(N.InitializeRequest=q4={}));var F4;(function(e){e.unknownProtocolVersion=1;})(F4||(N.InitializeErrorCodes=F4={}));var M4;(function(e){e.method="initialized",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolNotificationType(e.method);})(M4||(N.InitializedNotification=M4={}));var U4;(function(e){e.method="shutdown",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType0(e.method);})(U4||(N.ShutdownRequest=U4={}));var $4;(function(e){e.method="exit",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolNotificationType0(e.method);})($4||(N.ExitNotification=$4={}));var j4;(function(e){e.method="workspace/didChangeConfiguration",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolNotificationType(e.method);})(j4||(N.DidChangeConfigurationNotification=j4={}));var V4;(function(e){e.Error=1,e.Warning=2,e.Info=3,e.Log=4,e.Debug=5;})(V4||(N.MessageType=V4={}));var H4;(function(e){e.method="window/showMessage",e.messageDirection=ve.MessageDirection.serverToClient,e.type=new ve.ProtocolNotificationType(e.method);})(H4||(N.ShowMessageNotification=H4={}));var W4;(function(e){e.method="window/showMessageRequest",e.messageDirection=ve.MessageDirection.serverToClient,e.type=new ve.ProtocolRequestType(e.method);})(W4||(N.ShowMessageRequest=W4={}));var K4;(function(e){e.method="window/logMessage",e.messageDirection=ve.MessageDirection.serverToClient,e.type=new ve.ProtocolNotificationType(e.method);})(K4||(N.LogMessageNotification=K4={}));var z4;(function(e){e.method="telemetry/event",e.messageDirection=ve.MessageDirection.serverToClient,e.type=new ve.ProtocolNotificationType(e.method);})(z4||(N.TelemetryEventNotification=z4={}));var G4;(function(e){e.None=0,e.Full=1,e.Incremental=2;})(G4||(N.TextDocumentSyncKind=G4={}));var Y4;(function(e){e.method="textDocument/didOpen",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolNotificationType(e.method);})(Y4||(N.DidOpenTextDocumentNotification=Y4={}));var Q4;(function(e){function t(n){let i=n;return i!=null&&typeof i.text=="string"&&i.range!==void 0&&(i.rangeLength===void 0||typeof i.rangeLength=="number")}e.isIncremental=t;function r(n){let i=n;return i!=null&&typeof i.text=="string"&&i.range===void 0&&i.rangeLength===void 0}e.isFull=r;})(Q4||(N.TextDocumentContentChangeEvent=Q4={}));var X4;(function(e){e.method="textDocument/didChange",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolNotificationType(e.method);})(X4||(N.DidChangeTextDocumentNotification=X4={}));var J4;(function(e){e.method="textDocument/didClose",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolNotificationType(e.method);})(J4||(N.DidCloseTextDocumentNotification=J4={}));var Z4;(function(e){e.method="textDocument/didSave",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolNotificationType(e.method);})(Z4||(N.DidSaveTextDocumentNotification=Z4={}));var e3;(function(e){e.Manual=1,e.AfterDelay=2,e.FocusOut=3;})(e3||(N.TextDocumentSaveReason=e3={}));var t3;(function(e){e.method="textDocument/willSave",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolNotificationType(e.method);})(t3||(N.WillSaveTextDocumentNotification=t3={}));var r3;(function(e){e.method="textDocument/willSaveWaitUntil",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(r3||(N.WillSaveTextDocumentWaitUntilRequest=r3={}));var n3;(function(e){e.method="workspace/didChangeWatchedFiles",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolNotificationType(e.method);})(n3||(N.DidChangeWatchedFilesNotification=n3={}));var i3;(function(e){e.Created=1,e.Changed=2,e.Deleted=3;})(i3||(N.FileChangeType=i3={}));var s3;(function(e){function t(r){let n=r;return Er.objectLiteral(n)&&(R4.URI.is(n.baseUri)||R4.WorkspaceFolder.is(n.baseUri))&&Er.string(n.pattern)}e.is=t;})(s3||(N.RelativePattern=s3={}));var o3;(function(e){e.Create=1,e.Change=2,e.Delete=4;})(o3||(N.WatchKind=o3={}));var a3;(function(e){e.method="textDocument/publishDiagnostics",e.messageDirection=ve.MessageDirection.serverToClient,e.type=new ve.ProtocolNotificationType(e.method);})(a3||(N.PublishDiagnosticsNotification=a3={}));var u3;(function(e){e.Invoked=1,e.TriggerCharacter=2,e.TriggerForIncompleteCompletions=3;})(u3||(N.CompletionTriggerKind=u3={}));var c3;(function(e){e.method="textDocument/completion",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(c3||(N.CompletionRequest=c3={}));var l3;(function(e){e.method="completionItem/resolve",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(l3||(N.CompletionResolveRequest=l3={}));var f3;(function(e){e.method="textDocument/hover",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(f3||(N.HoverRequest=f3={}));var h3;(function(e){e.Invoked=1,e.TriggerCharacter=2,e.ContentChange=3;})(h3||(N.SignatureHelpTriggerKind=h3={}));var d3;(function(e){e.method="textDocument/signatureHelp",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(d3||(N.SignatureHelpRequest=d3={}));var p3;(function(e){e.method="textDocument/definition",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(p3||(N.DefinitionRequest=p3={}));var g3;(function(e){e.method="textDocument/references",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(g3||(N.ReferencesRequest=g3={}));var m3;(function(e){e.method="textDocument/documentHighlight",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(m3||(N.DocumentHighlightRequest=m3={}));var y3;(function(e){e.method="textDocument/documentSymbol",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(y3||(N.DocumentSymbolRequest=y3={}));var v3;(function(e){e.method="textDocument/codeAction",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(v3||(N.CodeActionRequest=v3={}));var S3;(function(e){e.method="codeAction/resolve",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(S3||(N.CodeActionResolveRequest=S3={}));var b3;(function(e){e.method="workspace/symbol",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(b3||(N.WorkspaceSymbolRequest=b3={}));var C3;(function(e){e.method="workspaceSymbol/resolve",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(C3||(N.WorkspaceSymbolResolveRequest=C3={}));var E3;(function(e){e.method="textDocument/codeLens",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(E3||(N.CodeLensRequest=E3={}));var x3;(function(e){e.method="codeLens/resolve",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(x3||(N.CodeLensResolveRequest=x3={}));var w3;(function(e){e.method="workspace/codeLens/refresh",e.messageDirection=ve.MessageDirection.serverToClient,e.type=new ve.ProtocolRequestType0(e.method);})(w3||(N.CodeLensRefreshRequest=w3={}));var _3;(function(e){e.method="textDocument/documentLink",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(_3||(N.DocumentLinkRequest=_3={}));var T3;(function(e){e.method="documentLink/resolve",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(T3||(N.DocumentLinkResolveRequest=T3={}));var A3;(function(e){e.method="textDocument/formatting",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(A3||(N.DocumentFormattingRequest=A3={}));var R3;(function(e){e.method="textDocument/rangeFormatting",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(R3||(N.DocumentRangeFormattingRequest=R3={}));var I3;(function(e){e.method="textDocument/rangesFormatting",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(I3||(N.DocumentRangesFormattingRequest=I3={}));var D3;(function(e){e.method="textDocument/onTypeFormatting",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(D3||(N.DocumentOnTypeFormattingRequest=D3={}));var P3;(function(e){e.Identifier=1;})(P3||(N.PrepareSupportDefaultBehavior=P3={}));var k3;(function(e){e.method="textDocument/rename",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(k3||(N.RenameRequest=k3={}));var N3;(function(e){e.method="textDocument/prepareRename",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(N3||(N.PrepareRenameRequest=N3={}));var L3;(function(e){e.method="workspace/executeCommand",e.messageDirection=ve.MessageDirection.clientToServer,e.type=new ve.ProtocolRequestType(e.method);})(L3||(N.ExecuteCommandRequest=L3={}));var O3;(function(e){e.method="workspace/applyEdit",e.messageDirection=ve.MessageDirection.serverToClient,e.type=new ve.ProtocolRequestType("workspace/applyEdit");})(O3||(N.ApplyWorkspaceEditRequest=O3={}));});var j3=A(Kd=>{Object.defineProperty(Kd,"__esModule",{value:!0});Kd.createProtocolConnection=void 0;var $3=Io();function _ie(e,t,r,n){return $3.ConnectionStrategy.is(n)&&(n={connectionStrategy:n}),(0, $3.createMessageConnection)(e,t,r,n)}Kd.createProtocolConnection=_ie;});var H3=A(ln=>{var Tie=ln&&ln.__createBinding||(Object.create?function(e,t,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(t,r);(!i||("get"in i?!t.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,i);}:function(e,t,r,n){n===void 0&&(n=r),e[n]=t[r];}),zd=ln&&ln.__exportStar||function(e,t){for(var r in e)r!=="default"&&!Object.prototype.hasOwnProperty.call(t,r)&&Tie(t,e,r);};Object.defineProperty(ln,"__esModule",{value:!0});ln.LSPErrorCodes=ln.createProtocolConnection=void 0;zd(Io(),ln);zd(Dd(),ln);zd(Gt(),ln);zd(U3(),ln);var Aie=j3();Object.defineProperty(ln,"createProtocolConnection",{enumerable:!0,get:function(){return Aie.createProtocolConnection}});var V3;(function(e){e.lspReservedErrorRangeStart=-32899,e.RequestFailed=-32803,e.ServerCancelled=-32802,e.ContentModified=-32801,e.RequestCancelled=-32800,e.lspReservedErrorRangeEnd=-32800;})(V3||(ln.LSPErrorCodes=V3={}));});var ir=A(Pi=>{var Rie=Pi&&Pi.__createBinding||(Object.create?function(e,t,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(t,r);(!i||("get"in i?!t.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,i);}:function(e,t,r,n){n===void 0&&(n=r),e[n]=t[r];}),W3=Pi&&Pi.__exportStar||function(e,t){for(var r in e)r!=="default"&&!Object.prototype.hasOwnProperty.call(t,r)&&Rie(t,e,r);};Object.defineProperty(Pi,"__esModule",{value:!0});Pi.createProtocolConnection=void 0;var Iie=Gb();W3(Gb(),Pi);W3(H3(),Pi);function Die(e,t,r,n){return (0, Iie.createMessageConnection)(e,t,r,n)}Pi.createProtocolConnection=Die;});var fC=A(jn=>{Object.defineProperty(jn,"__esModule",{value:!0});jn.generateUuid=jn.parse=jn.isUUID=jn.v4=jn.empty=void 0;var Wc=class{constructor(t){this._value=t;}asHex(){return this._value}equals(t){return this.asHex()===t.asHex()}},Kc=class e extends Wc{static _oneOf(t){return t[Math.floor(t.length*Math.random())]}static _randomHex(){return e._oneOf(e._chars)}constructor(){super([e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),"-",e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),"-","4",e._randomHex(),e._randomHex(),e._randomHex(),"-",e._oneOf(e._timeHighBits),e._randomHex(),e._randomHex(),e._randomHex(),"-",e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex()].join(""));}};Kc._chars=["0","1","2","3","4","5","6","6","7","8","9","a","b","c","d","e","f"];Kc._timeHighBits=["8","9","a","b"];jn.empty=new Wc("00000000-0000-0000-0000-000000000000");function K3(){return new Kc}jn.v4=K3;var Pie=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function z3(e){return Pie.test(e)}jn.isUUID=z3;function kie(e){if(!z3(e))throw new Error("invalid uuid");return new Wc(e)}jn.parse=kie;function Nie(){return K3().asHex()}jn.generateUuid=Nie;});var G3=A(Us=>{Object.defineProperty(Us,"__esModule",{value:!0});Us.attachPartialResult=Us.ProgressFeature=Us.attachWorkDone=void 0;var Ms=ir(),Lie=fC(),Po=class e{constructor(t,r){this._connection=t,this._token=r,e.Instances.set(this._token,this);}begin(t,r,n,i){let s={kind:"begin",title:t,percentage:r,message:n,cancellable:i};this._connection.sendProgress(Ms.WorkDoneProgress.type,this._token,s);}report(t,r){let n={kind:"report"};typeof t=="number"?(n.percentage=t,r!==void 0&&(n.message=r)):n.message=t,this._connection.sendProgress(Ms.WorkDoneProgress.type,this._token,n);}done(){e.Instances.delete(this._token),this._connection.sendProgress(Ms.WorkDoneProgress.type,this._token,{kind:"end"});}};Po.Instances=new Map;var Gd=class extends Po{constructor(t,r){super(t,r),this._source=new Ms.CancellationTokenSource;}get token(){return this._source.token}done(){this._source.dispose(),super.done();}cancel(){this._source.cancel();}},zc=class{constructor(){}begin(){}report(){}done(){}},Yd=class extends zc{constructor(){super(),this._source=new Ms.CancellationTokenSource;}get token(){return this._source.token}done(){this._source.dispose();}cancel(){this._source.cancel();}};function Oie(e,t){if(t===void 0||t.workDoneToken===void 0)return new zc;let r=t.workDoneToken;return delete t.workDoneToken,new Po(e,r)}Us.attachWorkDone=Oie;var Bie=e=>class extends e{constructor(){super(),this._progressSupported=!1;}initialize(t){super.initialize(t),t?.window?.workDoneProgress===!0&&(this._progressSupported=!0,this.connection.onNotification(Ms.WorkDoneProgressCancelNotification.type,r=>{let n=Po.Instances.get(r.token);(n instanceof Gd||n instanceof Yd)&&n.cancel();}));}attachWorkDoneProgress(t){return t===void 0?new zc:new Po(this.connection,t)}createWorkDoneProgress(){if(this._progressSupported){let t=(0, Lie.generateUuid)();return this.connection.sendRequest(Ms.WorkDoneProgressCreateRequest.type,{token:t}).then(()=>new Gd(this.connection,t))}else return Promise.resolve(new Yd)}};Us.ProgressFeature=Bie;var hC;(function(e){e.type=new Ms.ProgressType;})(hC||(hC={}));var dC=class{constructor(t,r){this._connection=t,this._token=r;}report(t){this._connection.sendProgress(hC.type,this._token,t);}};function qie(e,t){if(t===void 0||t.partialResultToken===void 0)return;let r=t.partialResultToken;return delete t.partialResultToken,new dC(e,r)}Us.attachPartialResult=qie;});var Y3=A(Qd=>{Object.defineProperty(Qd,"__esModule",{value:!0});Qd.ConfigurationFeature=void 0;var Fie=ir(),Mie=ad(),Uie=e=>class extends e{getConfiguration(t){return t?Mie.string(t)?this._getConfiguration({section:t}):this._getConfiguration(t):this._getConfiguration({})}_getConfiguration(t){let r={items:Array.isArray(t)?t:[t]};return this.connection.sendRequest(Fie.ConfigurationRequest.type,r).then(n=>Array.isArray(n)?Array.isArray(t)?n:n[0]:Array.isArray(t)?[]:null)}};Qd.ConfigurationFeature=Uie;});var Q3=A(Jd=>{Object.defineProperty(Jd,"__esModule",{value:!0});Jd.WorkspaceFoldersFeature=void 0;var Xd=ir(),$ie=e=>class extends e{constructor(){super(),this._notificationIsAutoRegistered=!1;}initialize(t){super.initialize(t);let r=t.workspace;r&&r.workspaceFolders&&(this._onDidChangeWorkspaceFolders=new Xd.Emitter,this.connection.onNotification(Xd.DidChangeWorkspaceFoldersNotification.type,n=>{this._onDidChangeWorkspaceFolders.fire(n.event);}));}fillServerCapabilities(t){super.fillServerCapabilities(t);let r=t.workspace?.workspaceFolders?.changeNotifications;this._notificationIsAutoRegistered=r===!0||typeof r=="string";}getWorkspaceFolders(){return this.connection.sendRequest(Xd.WorkspaceFoldersRequest.type)}get onDidChangeWorkspaceFolders(){if(!this._onDidChangeWorkspaceFolders)throw new Error("Client doesn't support sending workspace folder change events.");return !this._notificationIsAutoRegistered&&!this._unregistration&&(this._unregistration=this.connection.client.register(Xd.DidChangeWorkspaceFoldersNotification.type)),this._onDidChangeWorkspaceFolders.event}};Jd.WorkspaceFoldersFeature=$ie;});var X3=A(Zd=>{Object.defineProperty(Zd,"__esModule",{value:!0});Zd.CallHierarchyFeature=void 0;var pC=ir(),jie=e=>class extends e{get callHierarchy(){return {onPrepare:t=>this.connection.onRequest(pC.CallHierarchyPrepareRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r),void 0)),onIncomingCalls:t=>{let r=pC.CallHierarchyIncomingCallsRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onOutgoingCalls:t=>{let r=pC.CallHierarchyOutgoingCallsRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};Zd.CallHierarchyFeature=jie;});var mC=A($s=>{Object.defineProperty($s,"__esModule",{value:!0});$s.SemanticTokensBuilder=$s.SemanticTokensDiff=$s.SemanticTokensFeature=void 0;var ep=ir(),Vie=e=>class extends e{get semanticTokens(){return {refresh:()=>this.connection.sendRequest(ep.SemanticTokensRefreshRequest.type),on:t=>{let r=ep.SemanticTokensRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onDelta:t=>{let r=ep.SemanticTokensDeltaRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onRange:t=>{let r=ep.SemanticTokensRangeRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};$s.SemanticTokensFeature=Vie;var tp=class{constructor(t,r){this.originalSequence=t,this.modifiedSequence=r;}computeDiff(){let t=this.originalSequence.length,r=this.modifiedSequence.length,n=0;for(;n<r&&n<t&&this.originalSequence[n]===this.modifiedSequence[n];)n++;if(n<r&&n<t){let i=t-1,s=r-1;for(;i>=n&&s>=n&&this.originalSequence[i]===this.modifiedSequence[s];)i--,s--;(i<n||s<n)&&(i++,s++);let o=i-n+1,a=this.modifiedSequence.slice(n,s+1);return a.length===1&&a[0]===this.originalSequence[i]?[{start:n,deleteCount:o-1}]:[{start:n,deleteCount:o,data:a}]}else return n<r?[{start:n,deleteCount:0,data:this.modifiedSequence.slice(n)}]:n<t?[{start:n,deleteCount:t-n}]:[]}};$s.SemanticTokensDiff=tp;var gC=class{constructor(){this._prevData=void 0,this.initialize();}initialize(){this._id=Date.now(),this._prevLine=0,this._prevChar=0,this._data=[],this._dataLen=0;}push(t,r,n,i,s){let o=t,a=r;this._dataLen>0&&(o-=this._prevLine,o===0&&(a-=this._prevChar)),this._data[this._dataLen++]=o,this._data[this._dataLen++]=a,this._data[this._dataLen++]=n,this._data[this._dataLen++]=i,this._data[this._dataLen++]=s,this._prevLine=t,this._prevChar=r;}get id(){return this._id.toString()}previousResult(t){this.id===t&&(this._prevData=this._data),this.initialize();}build(){return this._prevData=void 0,{resultId:this.id,data:this._data}}canBuildEdits(){return this._prevData!==void 0}buildEdits(){return this._prevData!==void 0?{resultId:this.id,edits:new tp(this._prevData,this._data).computeDiff()}:this.build()}};$s.SemanticTokensBuilder=gC;});var J3=A(rp=>{Object.defineProperty(rp,"__esModule",{value:!0});rp.ShowDocumentFeature=void 0;var Hie=ir(),Wie=e=>class extends e{showDocument(t){return this.connection.sendRequest(Hie.ShowDocumentRequest.type,t)}};rp.ShowDocumentFeature=Wie;});var Z3=A(np=>{Object.defineProperty(np,"__esModule",{value:!0});np.FileOperationsFeature=void 0;var eu=ir(),Kie=e=>class extends e{onDidCreateFiles(t){return this.connection.onNotification(eu.DidCreateFilesNotification.type,r=>{t(r);})}onDidRenameFiles(t){return this.connection.onNotification(eu.DidRenameFilesNotification.type,r=>{t(r);})}onDidDeleteFiles(t){return this.connection.onNotification(eu.DidDeleteFilesNotification.type,r=>{t(r);})}onWillCreateFiles(t){return this.connection.onRequest(eu.WillCreateFilesRequest.type,(r,n)=>t(r,n))}onWillRenameFiles(t){return this.connection.onRequest(eu.WillRenameFilesRequest.type,(r,n)=>t(r,n))}onWillDeleteFiles(t){return this.connection.onRequest(eu.WillDeleteFilesRequest.type,(r,n)=>t(r,n))}};np.FileOperationsFeature=Kie;});var eM=A(ip=>{Object.defineProperty(ip,"__esModule",{value:!0});ip.LinkedEditingRangeFeature=void 0;var zie=ir(),Gie=e=>class extends e{onLinkedEditingRange(t){return this.connection.onRequest(zie.LinkedEditingRangeRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r),void 0))}};ip.LinkedEditingRangeFeature=Gie;});var tM=A(sp=>{Object.defineProperty(sp,"__esModule",{value:!0});sp.TypeHierarchyFeature=void 0;var yC=ir(),Yie=e=>class extends e{get typeHierarchy(){return {onPrepare:t=>this.connection.onRequest(yC.TypeHierarchyPrepareRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r),void 0)),onSupertypes:t=>{let r=yC.TypeHierarchySupertypesRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onSubtypes:t=>{let r=yC.TypeHierarchySubtypesRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};sp.TypeHierarchyFeature=Yie;});var nM=A(op=>{Object.defineProperty(op,"__esModule",{value:!0});op.InlineValueFeature=void 0;var rM=ir(),Qie=e=>class extends e{get inlineValue(){return {refresh:()=>this.connection.sendRequest(rM.InlineValueRefreshRequest.type),on:t=>this.connection.onRequest(rM.InlineValueRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r)))}}};op.InlineValueFeature=Qie;});var sM=A(ap=>{Object.defineProperty(ap,"__esModule",{value:!0});ap.FoldingRangeFeature=void 0;var iM=ir(),Xie=e=>class extends e{get foldingRange(){return {refresh:()=>this.connection.sendRequest(iM.FoldingRangeRefreshRequest.type),on:t=>{let r=iM.FoldingRangeRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};ap.FoldingRangeFeature=Xie;});var oM=A(up=>{Object.defineProperty(up,"__esModule",{value:!0});up.InlayHintFeature=void 0;var vC=ir(),Jie=e=>class extends e{get inlayHint(){return {refresh:()=>this.connection.sendRequest(vC.InlayHintRefreshRequest.type),on:t=>this.connection.onRequest(vC.InlayHintRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r))),resolve:t=>this.connection.onRequest(vC.InlayHintResolveRequest.type,(r,n)=>t(r,n))}}};up.InlayHintFeature=Jie;});var aM=A(cp=>{Object.defineProperty(cp,"__esModule",{value:!0});cp.DiagnosticFeature=void 0;var Gc=ir(),Zie=e=>class extends e{get diagnostics(){return {refresh:()=>this.connection.sendRequest(Gc.DiagnosticRefreshRequest.type),on:t=>this.connection.onRequest(Gc.DocumentDiagnosticRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r),this.attachPartialResultProgress(Gc.DocumentDiagnosticRequest.partialResult,r))),onWorkspace:t=>this.connection.onRequest(Gc.WorkspaceDiagnosticRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r),this.attachPartialResultProgress(Gc.WorkspaceDiagnosticRequest.partialResult,r)))}}};cp.DiagnosticFeature=Zie;});var bC=A(lp=>{Object.defineProperty(lp,"__esModule",{value:!0});lp.TextDocuments=void 0;var ko=ir(),SC=class{constructor(t){this._configuration=t,this._syncedDocuments=new Map,this._onDidChangeContent=new ko.Emitter,this._onDidOpen=new ko.Emitter,this._onDidClose=new ko.Emitter,this._onDidSave=new ko.Emitter,this._onWillSave=new ko.Emitter;}get onDidOpen(){return this._onDidOpen.event}get onDidChangeContent(){return this._onDidChangeContent.event}get onWillSave(){return this._onWillSave.event}onWillSaveWaitUntil(t){this._willSaveWaitUntil=t;}get onDidSave(){return this._onDidSave.event}get onDidClose(){return this._onDidClose.event}get(t){return this._syncedDocuments.get(t)}all(){return Array.from(this._syncedDocuments.values())}keys(){return Array.from(this._syncedDocuments.keys())}listen(t){t.__textDocumentSync=ko.TextDocumentSyncKind.Incremental;let r=[];return r.push(t.onDidOpenTextDocument(n=>{let i=n.textDocument,s=this._configuration.create(i.uri,i.languageId,i.version,i.text);this._syncedDocuments.set(i.uri,s);let o=Object.freeze({document:s});this._onDidOpen.fire(o),this._onDidChangeContent.fire(o);})),r.push(t.onDidChangeTextDocument(n=>{let i=n.textDocument,s=n.contentChanges;if(s.length===0)return;let{version:o}=i;if(o==null)throw new Error(`Received document change event for ${i.uri} without valid version identifier`);let a=this._syncedDocuments.get(i.uri);a!==void 0&&(a=this._configuration.update(a,s,o),this._syncedDocuments.set(i.uri,a),this._onDidChangeContent.fire(Object.freeze({document:a})));})),r.push(t.onDidCloseTextDocument(n=>{let i=this._syncedDocuments.get(n.textDocument.uri);i!==void 0&&(this._syncedDocuments.delete(n.textDocument.uri),this._onDidClose.fire(Object.freeze({document:i})));})),r.push(t.onWillSaveTextDocument(n=>{let i=this._syncedDocuments.get(n.textDocument.uri);i!==void 0&&this._onWillSave.fire(Object.freeze({document:i,reason:n.reason}));})),r.push(t.onWillSaveTextDocumentWaitUntil((n,i)=>{let s=this._syncedDocuments.get(n.textDocument.uri);return s!==void 0&&this._willSaveWaitUntil?this._willSaveWaitUntil(Object.freeze({document:s,reason:n.reason}),i):[]})),r.push(t.onDidSaveTextDocument(n=>{let i=this._syncedDocuments.get(n.textDocument.uri);i!==void 0&&this._onDidSave.fire(Object.freeze({document:i}));})),ko.Disposable.create(()=>{r.forEach(n=>n.dispose());})}};lp.TextDocuments=SC;});var EC=A(tu=>{Object.defineProperty(tu,"__esModule",{value:!0});tu.NotebookDocuments=tu.NotebookSyncFeature=void 0;var Vn=ir(),uM=bC(),ese=e=>class extends e{get synchronization(){return {onDidOpenNotebookDocument:t=>this.connection.onNotification(Vn.DidOpenNotebookDocumentNotification.type,r=>{t(r);}),onDidChangeNotebookDocument:t=>this.connection.onNotification(Vn.DidChangeNotebookDocumentNotification.type,r=>{t(r);}),onDidSaveNotebookDocument:t=>this.connection.onNotification(Vn.DidSaveNotebookDocumentNotification.type,r=>{t(r);}),onDidCloseNotebookDocument:t=>this.connection.onNotification(Vn.DidCloseNotebookDocumentNotification.type,r=>{t(r);})}}};tu.NotebookSyncFeature=ese;var fp=class e{onDidOpenTextDocument(t){return this.openHandler=t,Vn.Disposable.create(()=>{this.openHandler=void 0;})}openTextDocument(t){this.openHandler&&this.openHandler(t);}onDidChangeTextDocument(t){return this.changeHandler=t,Vn.Disposable.create(()=>{this.changeHandler=t;})}changeTextDocument(t){this.changeHandler&&this.changeHandler(t);}onDidCloseTextDocument(t){return this.closeHandler=t,Vn.Disposable.create(()=>{this.closeHandler=void 0;})}closeTextDocument(t){this.closeHandler&&this.closeHandler(t);}onWillSaveTextDocument(){return e.NULL_DISPOSE}onWillSaveTextDocumentWaitUntil(){return e.NULL_DISPOSE}onDidSaveTextDocument(){return e.NULL_DISPOSE}};fp.NULL_DISPOSE=Object.freeze({dispose:()=>{}});var CC=class{constructor(t){t instanceof uM.TextDocuments?this._cellTextDocuments=t:this._cellTextDocuments=new uM.TextDocuments(t),this.notebookDocuments=new Map,this.notebookCellMap=new Map,this._onDidOpen=new Vn.Emitter,this._onDidChange=new Vn.Emitter,this._onDidSave=new Vn.Emitter,this._onDidClose=new Vn.Emitter;}get cellTextDocuments(){return this._cellTextDocuments}getCellTextDocument(t){return this._cellTextDocuments.get(t.document)}getNotebookDocument(t){return this.notebookDocuments.get(t)}getNotebookCell(t){let r=this.notebookCellMap.get(t);return r&&r[0]}findNotebookDocumentForCell(t){let r=typeof t=="string"?t:t.document,n=this.notebookCellMap.get(r);return n&&n[1]}get onDidOpen(){return this._onDidOpen.event}get onDidSave(){return this._onDidSave.event}get onDidChange(){return this._onDidChange.event}get onDidClose(){return this._onDidClose.event}listen(t){let r=new fp,n=[];return n.push(this.cellTextDocuments.listen(r)),n.push(t.notebooks.synchronization.onDidOpenNotebookDocument(i=>{this.notebookDocuments.set(i.notebookDocument.uri,i.notebookDocument);for(let s of i.cellTextDocuments)r.openTextDocument({textDocument:s});this.updateCellMap(i.notebookDocument),this._onDidOpen.fire(i.notebookDocument);})),n.push(t.notebooks.synchronization.onDidChangeNotebookDocument(i=>{let s=this.notebookDocuments.get(i.notebookDocument.uri);if(s===void 0)return;s.version=i.notebookDocument.version;let o=s.metadata,a=!1,c=i.change;c.metadata!==void 0&&(a=!0,s.metadata=c.metadata);let l=[],u=[],f=[],d=[];if(c.cells!==void 0){let I=c.cells;if(I.structure!==void 0){let v=I.structure.array;if(s.cells.splice(v.start,v.deleteCount,...v.cells!==void 0?v.cells:[]),I.structure.didOpen!==void 0)for(let b of I.structure.didOpen)r.openTextDocument({textDocument:b}),l.push(b.uri);if(I.structure.didClose)for(let b of I.structure.didClose)r.closeTextDocument({textDocument:b}),u.push(b.uri);}if(I.data!==void 0){let v=new Map(I.data.map(b=>[b.document,b]));for(let b=0;b<=s.cells.length;b++){let D=v.get(s.cells[b].document);if(D!==void 0){let L=s.cells.splice(b,1,D);if(f.push({old:L[0],new:D}),v.delete(D.document),v.size===0)break}}}if(I.textContent!==void 0)for(let v of I.textContent)r.changeTextDocument({textDocument:v.document,contentChanges:v.changes}),d.push(v.document.uri);}this.updateCellMap(s);let p={notebookDocument:s};a&&(p.metadata={old:o,new:s.metadata});let m=[];for(let I of l)m.push(this.getNotebookCell(I));let S=[];for(let I of u)S.push(this.getNotebookCell(I));let x=[];for(let I of d)x.push(this.getNotebookCell(I));(m.length>0||S.length>0||f.length>0||x.length>0)&&(p.cells={added:m,removed:S,changed:{data:f,textContent:x}}),(p.metadata!==void 0||p.cells!==void 0)&&this._onDidChange.fire(p);})),n.push(t.notebooks.synchronization.onDidSaveNotebookDocument(i=>{let s=this.notebookDocuments.get(i.notebookDocument.uri);s!==void 0&&this._onDidSave.fire(s);})),n.push(t.notebooks.synchronization.onDidCloseNotebookDocument(i=>{let s=this.notebookDocuments.get(i.notebookDocument.uri);if(s!==void 0){this._onDidClose.fire(s);for(let o of i.cellTextDocuments)r.closeTextDocument({textDocument:o});this.notebookDocuments.delete(i.notebookDocument.uri);for(let o of s.cells)this.notebookCellMap.delete(o.document);}})),Vn.Disposable.create(()=>{n.forEach(i=>i.dispose());})}updateCellMap(t){for(let r of t.cells)this.notebookCellMap.set(r.document,[r,t]);}};tu.NotebookDocuments=CC;});var cM=A(hp=>{Object.defineProperty(hp,"__esModule",{value:!0});hp.MonikerFeature=void 0;var tse=ir(),rse=e=>class extends e{get moniker(){return {on:t=>{let r=tse.MonikerRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};hp.MonikerFeature=rse;});var RC=A(Et=>{Object.defineProperty(Et,"__esModule",{value:!0});Et.createConnection=Et.combineFeatures=Et.combineNotebooksFeatures=Et.combineLanguagesFeatures=Et.combineWorkspaceFeatures=Et.combineWindowFeatures=Et.combineClientFeatures=Et.combineTracerFeatures=Et.combineTelemetryFeatures=Et.combineConsoleFeatures=Et._NotebooksImpl=Et._LanguagesImpl=Et.BulkUnregistration=Et.BulkRegistration=Et.ErrorMessageTracker=void 0;var Ee=ir(),Hn=ad(),wC=fC(),Qe=G3(),nse=Y3(),ise=Q3(),sse=X3(),ose=mC(),ase=J3(),use=Z3(),cse=eM(),lse=tM(),fse=nM(),hse=sM(),dse=oM(),pse=aM(),gse=EC(),mse=cM();function xC(e){if(e!==null)return e}var _C=class{constructor(){this._messages=Object.create(null);}add(t){let r=this._messages[t];r||(r=0),r++,this._messages[t]=r;}sendErrors(t){Object.keys(this._messages).forEach(r=>{t.window.showErrorMessage(r);});}};Et.ErrorMessageTracker=_C;var dp=class{constructor(){}rawAttach(t){this._rawConnection=t;}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}fillServerCapabilities(t){}initialize(t){}error(t){this.send(Ee.MessageType.Error,t);}warn(t){this.send(Ee.MessageType.Warning,t);}info(t){this.send(Ee.MessageType.Info,t);}log(t){this.send(Ee.MessageType.Log,t);}debug(t){this.send(Ee.MessageType.Debug,t);}send(t,r){this._rawConnection&&this._rawConnection.sendNotification(Ee.LogMessageNotification.type,{type:t,message:r}).catch(()=>{(0, Ee.RAL)().console.error("Sending log message failed");});}},TC=class{constructor(){}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}showErrorMessage(t,...r){let n={type:Ee.MessageType.Error,message:t,actions:r};return this.connection.sendRequest(Ee.ShowMessageRequest.type,n).then(xC)}showWarningMessage(t,...r){let n={type:Ee.MessageType.Warning,message:t,actions:r};return this.connection.sendRequest(Ee.ShowMessageRequest.type,n).then(xC)}showInformationMessage(t,...r){let n={type:Ee.MessageType.Info,message:t,actions:r};return this.connection.sendRequest(Ee.ShowMessageRequest.type,n).then(xC)}},lM=(0, ase.ShowDocumentFeature)((0, Qe.ProgressFeature)(TC)),fM;(function(e){function t(){return new pp}e.create=t;})(fM||(Et.BulkRegistration=fM={}));var pp=class{constructor(){this._registrations=[],this._registered=new Set;}add(t,r){let n=Hn.string(t)?t:t.method;if(this._registered.has(n))throw new Error(`${n} is already added to this registration`);let i=wC.generateUuid();this._registrations.push({id:i,method:n,registerOptions:r||{}}),this._registered.add(n);}asRegistrationParams(){return {registrations:this._registrations}}},hM;(function(e){function t(){return new Yc(void 0,[])}e.create=t;})(hM||(Et.BulkUnregistration=hM={}));var Yc=class{constructor(t,r){this._connection=t,this._unregistrations=new Map,r.forEach(n=>{this._unregistrations.set(n.method,n);});}get isAttached(){return !!this._connection}attach(t){this._connection=t;}add(t){this._unregistrations.set(t.method,t);}dispose(){let t=[];for(let n of this._unregistrations.values())t.push(n);let r={unregisterations:t};this._connection.sendRequest(Ee.UnregistrationRequest.type,r).catch(()=>{this._connection.console.info("Bulk unregistration failed.");});}disposeSingle(t){let r=Hn.string(t)?t:t.method,n=this._unregistrations.get(r);if(!n)return !1;let i={unregisterations:[n]};return this._connection.sendRequest(Ee.UnregistrationRequest.type,i).then(()=>{this._unregistrations.delete(r);},s=>{this._connection.console.info(`Un-registering request handler for ${n.id} failed.`);}),!0}},gp=class{attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}register(t,r,n){return t instanceof pp?this.registerMany(t):t instanceof Yc?this.registerSingle1(t,r,n):this.registerSingle2(t,r)}registerSingle1(t,r,n){let i=Hn.string(r)?r:r.method,s=wC.generateUuid(),o={registrations:[{id:s,method:i,registerOptions:n||{}}]};return t.isAttached||t.attach(this.connection),this.connection.sendRequest(Ee.RegistrationRequest.type,o).then(a=>(t.add({id:s,method:i}),t),a=>(this.connection.console.info(`Registering request handler for ${i} failed.`),Promise.reject(a)))}registerSingle2(t,r){let n=Hn.string(t)?t:t.method,i=wC.generateUuid(),s={registrations:[{id:i,method:n,registerOptions:r||{}}]};return this.connection.sendRequest(Ee.RegistrationRequest.type,s).then(o=>Ee.Disposable.create(()=>{this.unregisterSingle(i,n).catch(()=>{this.connection.console.info(`Un-registering capability with id ${i} failed.`);});}),o=>(this.connection.console.info(`Registering request handler for ${n} failed.`),Promise.reject(o)))}unregisterSingle(t,r){let n={unregisterations:[{id:t,method:r}]};return this.connection.sendRequest(Ee.UnregistrationRequest.type,n).catch(()=>{this.connection.console.info(`Un-registering request handler for ${t} failed.`);})}registerMany(t){let r=t.asRegistrationParams();return this.connection.sendRequest(Ee.RegistrationRequest.type,r).then(()=>new Yc(this._connection,r.registrations.map(n=>({id:n.id,method:n.method}))),n=>(this.connection.console.info("Bulk registration failed."),Promise.reject(n)))}},AC=class{constructor(){}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}applyEdit(t){function r(i){return i&&!!i.edit}let n=r(t)?t:{edit:t};return this.connection.sendRequest(Ee.ApplyWorkspaceEditRequest.type,n)}},dM=(0, use.FileOperationsFeature)((0, ise.WorkspaceFoldersFeature)((0, nse.ConfigurationFeature)(AC))),mp=class{constructor(){this._trace=Ee.Trace.Off;}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}set trace(t){this._trace=t;}log(t,r){this._trace!==Ee.Trace.Off&&this.connection.sendNotification(Ee.LogTraceNotification.type,{message:t,verbose:this._trace===Ee.Trace.Verbose?r:void 0}).catch(()=>{});}},yp=class{constructor(){}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}logEvent(t){this.connection.sendNotification(Ee.TelemetryEventNotification.type,t).catch(()=>{this.connection.console.log("Sending TelemetryEventNotification failed");});}},vp=class{constructor(){}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}attachWorkDoneProgress(t){return (0, Qe.attachWorkDone)(this.connection,t)}attachPartialResultProgress(t,r){return (0, Qe.attachPartialResult)(this.connection,r)}};Et._LanguagesImpl=vp;var pM=(0, hse.FoldingRangeFeature)((0, mse.MonikerFeature)((0, pse.DiagnosticFeature)((0, dse.InlayHintFeature)((0, fse.InlineValueFeature)((0, lse.TypeHierarchyFeature)((0, cse.LinkedEditingRangeFeature)((0, ose.SemanticTokensFeature)((0, sse.CallHierarchyFeature)(vp))))))))),Sp=class{constructor(){}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}attachWorkDoneProgress(t){return (0, Qe.attachWorkDone)(this.connection,t)}attachPartialResultProgress(t,r){return (0, Qe.attachPartialResult)(this.connection,r)}};Et._NotebooksImpl=Sp;var gM=(0, gse.NotebookSyncFeature)(Sp);function mM(e,t){return function(r){return t(e(r))}}Et.combineConsoleFeatures=mM;function yM(e,t){return function(r){return t(e(r))}}Et.combineTelemetryFeatures=yM;function vM(e,t){return function(r){return t(e(r))}}Et.combineTracerFeatures=vM;function SM(e,t){return function(r){return t(e(r))}}Et.combineClientFeatures=SM;function bM(e,t){return function(r){return t(e(r))}}Et.combineWindowFeatures=bM;function CM(e,t){return function(r){return t(e(r))}}Et.combineWorkspaceFeatures=CM;function EM(e,t){return function(r){return t(e(r))}}Et.combineLanguagesFeatures=EM;function xM(e,t){return function(r){return t(e(r))}}Et.combineNotebooksFeatures=xM;function yse(e,t){function r(i,s,o){return i&&s?o(i,s):i||s}return {__brand:"features",console:r(e.console,t.console,mM),tracer:r(e.tracer,t.tracer,vM),telemetry:r(e.telemetry,t.telemetry,yM),client:r(e.client,t.client,SM),window:r(e.window,t.window,bM),workspace:r(e.workspace,t.workspace,CM),languages:r(e.languages,t.languages,EM),notebooks:r(e.notebooks,t.notebooks,xM)}}Et.combineFeatures=yse;function vse(e,t,r){let n=r&&r.console?new(r.console(dp)):new dp,i=e(n);n.rawAttach(i);let s=r&&r.tracer?new(r.tracer(mp)):new mp,o=r&&r.telemetry?new(r.telemetry(yp)):new yp,a=r&&r.client?new(r.client(gp)):new gp,c=r&&r.window?new(r.window(lM)):new lM,l=r&&r.workspace?new(r.workspace(dM)):new dM,u=r&&r.languages?new(r.languages(pM)):new pM,f=r&&r.notebooks?new(r.notebooks(gM)):new gM,d=[n,s,o,a,c,l,u,f];function p(v){return v instanceof Promise?v:Hn.thenable(v)?new Promise((b,D)=>{v.then(L=>b(L),L=>D(L));}):Promise.resolve(v)}let m,S,x,I={listen:()=>i.listen(),sendRequest:(v,...b)=>i.sendRequest(Hn.string(v)?v:v.method,...b),onRequest:(v,b)=>i.onRequest(v,b),sendNotification:(v,b)=>{let D=Hn.string(v)?v:v.method;return i.sendNotification(D,b)},onNotification:(v,b)=>i.onNotification(v,b),onProgress:i.onProgress,sendProgress:i.sendProgress,onInitialize:v=>(S=v,{dispose:()=>{S=void 0;}}),onInitialized:v=>i.onNotification(Ee.InitializedNotification.type,v),onShutdown:v=>(m=v,{dispose:()=>{m=void 0;}}),onExit:v=>(x=v,{dispose:()=>{x=void 0;}}),get console(){return n},get telemetry(){return o},get tracer(){return s},get client(){return a},get window(){return c},get workspace(){return l},get languages(){return u},get notebooks(){return f},onDidChangeConfiguration:v=>i.onNotification(Ee.DidChangeConfigurationNotification.type,v),onDidChangeWatchedFiles:v=>i.onNotification(Ee.DidChangeWatchedFilesNotification.type,v),__textDocumentSync:void 0,onDidOpenTextDocument:v=>i.onNotification(Ee.DidOpenTextDocumentNotification.type,v),onDidChangeTextDocument:v=>i.onNotification(Ee.DidChangeTextDocumentNotification.type,v),onDidCloseTextDocument:v=>i.onNotification(Ee.DidCloseTextDocumentNotification.type,v),onWillSaveTextDocument:v=>i.onNotification(Ee.WillSaveTextDocumentNotification.type,v),onWillSaveTextDocumentWaitUntil:v=>i.onRequest(Ee.WillSaveTextDocumentWaitUntilRequest.type,v),onDidSaveTextDocument:v=>i.onNotification(Ee.DidSaveTextDocumentNotification.type,v),sendDiagnostics:v=>i.sendNotification(Ee.PublishDiagnosticsNotification.type,v),onHover:v=>i.onRequest(Ee.HoverRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),void 0)),onCompletion:v=>i.onRequest(Ee.CompletionRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onCompletionResolve:v=>i.onRequest(Ee.CompletionResolveRequest.type,v),onSignatureHelp:v=>i.onRequest(Ee.SignatureHelpRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),void 0)),onDeclaration:v=>i.onRequest(Ee.DeclarationRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onDefinition:v=>i.onRequest(Ee.DefinitionRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onTypeDefinition:v=>i.onRequest(Ee.TypeDefinitionRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onImplementation:v=>i.onRequest(Ee.ImplementationRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onReferences:v=>i.onRequest(Ee.ReferencesRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onDocumentHighlight:v=>i.onRequest(Ee.DocumentHighlightRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onDocumentSymbol:v=>i.onRequest(Ee.DocumentSymbolRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onWorkspaceSymbol:v=>i.onRequest(Ee.WorkspaceSymbolRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onWorkspaceSymbolResolve:v=>i.onRequest(Ee.WorkspaceSymbolResolveRequest.type,v),onCodeAction:v=>i.onRequest(Ee.CodeActionRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onCodeActionResolve:v=>i.onRequest(Ee.CodeActionResolveRequest.type,(b,D)=>v(b,D)),onCodeLens:v=>i.onRequest(Ee.CodeLensRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onCodeLensResolve:v=>i.onRequest(Ee.CodeLensResolveRequest.type,(b,D)=>v(b,D)),onDocumentFormatting:v=>i.onRequest(Ee.DocumentFormattingRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),void 0)),onDocumentRangeFormatting:v=>i.onRequest(Ee.DocumentRangeFormattingRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),void 0)),onDocumentOnTypeFormatting:v=>i.onRequest(Ee.DocumentOnTypeFormattingRequest.type,(b,D)=>v(b,D)),onRenameRequest:v=>i.onRequest(Ee.RenameRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),void 0)),onPrepareRename:v=>i.onRequest(Ee.PrepareRenameRequest.type,(b,D)=>v(b,D)),onDocumentLinks:v=>i.onRequest(Ee.DocumentLinkRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onDocumentLinkResolve:v=>i.onRequest(Ee.DocumentLinkResolveRequest.type,(b,D)=>v(b,D)),onDocumentColor:v=>i.onRequest(Ee.DocumentColorRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onColorPresentation:v=>i.onRequest(Ee.ColorPresentationRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onFoldingRanges:v=>i.onRequest(Ee.FoldingRangeRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onSelectionRanges:v=>i.onRequest(Ee.SelectionRangeRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),(0, Qe.attachPartialResult)(i,b))),onExecuteCommand:v=>i.onRequest(Ee.ExecuteCommandRequest.type,(b,D)=>v(b,D,(0, Qe.attachWorkDone)(i,b),void 0)),dispose:()=>i.dispose()};for(let v of d)v.attach(I);return i.onRequest(Ee.InitializeRequest.type,v=>{t.initialize(v),Hn.string(v.trace)&&(s.trace=Ee.Trace.fromString(v.trace));for(let b of d)b.initialize(v.capabilities);if(S){let b=S(v,new Ee.CancellationTokenSource().token,(0, Qe.attachWorkDone)(i,v),void 0);return p(b).then(D=>{if(D instanceof Ee.ResponseError)return D;let L=D;L||(L={capabilities:{}});let j=L.capabilities;j||(j={},L.capabilities=j),j.textDocumentSync===void 0||j.textDocumentSync===null?j.textDocumentSync=Hn.number(I.__textDocumentSync)?I.__textDocumentSync:Ee.TextDocumentSyncKind.None:!Hn.number(j.textDocumentSync)&&!Hn.number(j.textDocumentSync.change)&&(j.textDocumentSync.change=Hn.number(I.__textDocumentSync)?I.__textDocumentSync:Ee.TextDocumentSyncKind.None);for(let J of d)J.fillServerCapabilities(j);return L})}else {let b={capabilities:{textDocumentSync:Ee.TextDocumentSyncKind.None}};for(let D of d)D.fillServerCapabilities(b.capabilities);return b}}),i.onRequest(Ee.ShutdownRequest.type,()=>{if(t.shutdownReceived=!0,m)return m(new Ee.CancellationTokenSource().token)}),i.onNotification(Ee.ExitNotification.type,()=>{try{x&&x();}finally{t.shutdownReceived?t.exit(0):t.exit(1);}}),i.onNotification(Ee.SetTraceNotification.type,v=>{s.trace=Ee.Trace.fromString(v.value);}),I}Et.createConnection=vse;});var wM=A(fn=>{Object.defineProperty(fn,"__esModule",{value:!0});fn.resolveModulePath=fn.FileSystem=fn.resolveGlobalYarnPath=fn.resolveGlobalNodePath=fn.resolve=fn.uriToFilePath=void 0;var Sse=he("url"),ai=he("path"),IC=he("fs"),NC=he("child_process");function bse(e){let t=Sse.parse(e);if(t.protocol!=="file:"||!t.path)return;let r=t.path.split("/");for(var n=0,i=r.length;n<i;n++)r[n]=decodeURIComponent(r[n]);if(process.platform==="win32"&&r.length>1){let s=r[0],o=r[1];s.length===0&&o.length>1&&o[1]===":"&&r.shift();}return ai.normalize(r.join("/"))}fn.uriToFilePath=bse;function DC(){return process.platform==="win32"}function bp(e,t,r,n){let i="NODE_PATH",s=["var p = process;","p.on('message',function(m){","if(m.c==='e'){","p.exit(0);","}","else if(m.c==='rs'){","try{","var r=require.resolve(m.a);","p.send({c:'r',s:true,r:r});","}","catch(err){","p.send({c:'r',s:false});","}","}","});"].join("");return new Promise((o,a)=>{let c=process.env,l=Object.create(null);Object.keys(c).forEach(u=>l[u]=c[u]),t&&IC.existsSync(t)&&(l[i]?l[i]=t+ai.delimiter+l[i]:l[i]=t,n&&n(`NODE_PATH value is: ${l[i]}`)),l.ELECTRON_RUN_AS_NODE="1";try{let u=(0, NC.fork)("",[],{cwd:r,env:l,execArgv:["-e",s]});if(u.pid===void 0){a(new Error(`Starting process to resolve node module  ${e} failed`));return}u.on("error",d=>{a(d);}),u.on("message",d=>{d.c==="r"&&(u.send({c:"e"}),d.s?o(d.r):a(new Error(`Failed to resolve module: ${e}`)));});let f={c:"rs",a:e};u.send(f);}catch(u){a(u);}})}fn.resolve=bp;function PC(e){let t="npm",r=Object.create(null);Object.keys(process.env).forEach(s=>r[s]=process.env[s]),r.NO_UPDATE_NOTIFIER="true";let n={encoding:"utf8",env:r};DC()&&(t="npm.cmd",n.shell=!0);let i=()=>{};try{process.on("SIGPIPE",i);let s=(0, NC.spawnSync)(t,["config","get","prefix"],n).stdout;if(!s){e&&e("'npm config get prefix' didn't return a value.");return}let o=s.trim();return e&&e(`'npm config get prefix' value is: ${o}`),o.length>0?DC()?ai.join(o,"node_modules"):ai.join(o,"lib","node_modules"):void 0}catch{return}finally{process.removeListener("SIGPIPE",i);}}fn.resolveGlobalNodePath=PC;function Cse(e){let t="yarn",r={encoding:"utf8"};DC()&&(t="yarn.cmd",r.shell=!0);let n=()=>{};try{process.on("SIGPIPE",n);let i=(0, NC.spawnSync)(t,["global","dir","--json"],r),s=i.stdout;if(!s){e&&(e("'yarn global dir' didn't return a value."),i.stderr&&e(i.stderr));return}let o=s.trim().split(/\r?\n/);for(let a of o)try{let c=JSON.parse(a);if(c.type==="log")return ai.join(c.data,"node_modules")}catch{}return}catch{return}finally{process.removeListener("SIGPIPE",n);}}fn.resolveGlobalYarnPath=Cse;var kC;(function(e){let t;function r(){return t!==void 0||(process.platform==="win32"?t=!1:t=!IC.existsSync(__filename.toUpperCase())||!IC.existsSync(__filename.toLowerCase())),t}e.isCaseSensitive=r;function n(i,s){return r()?ai.normalize(s).indexOf(ai.normalize(i))===0:ai.normalize(s).toLowerCase().indexOf(ai.normalize(i).toLowerCase())===0}e.isParent=n;})(kC||(fn.FileSystem=kC={}));function Ese(e,t,r,n){return r?(ai.isAbsolute(r)||(r=ai.join(e,r)),bp(t,r,r,n).then(i=>kC.isParent(r,i)?i:Promise.reject(new Error(`Failed to load ${t} from node path location.`))).then(void 0,i=>bp(t,PC(n),e,n))):bp(t,PC(n),e,n)}fn.resolveModulePath=Ese;});var LC=A((Uge,_M)=>{_M.exports=ir();});var TM=A(Cp=>{Object.defineProperty(Cp,"__esModule",{value:!0});Cp.InlineCompletionFeature=void 0;var xse=ir(),wse=e=>class extends e{get inlineCompletion(){return {on:t=>this.connection.onRequest(xse.InlineCompletionRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r)))}}};Cp.InlineCompletionFeature=wse;});var IM=A(Fr=>{var _se=Fr&&Fr.__createBinding||(Object.create?function(e,t,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(t,r);(!i||("get"in i?!t.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,i);}:function(e,t,r,n){n===void 0&&(n=r),e[n]=t[r];}),RM=Fr&&Fr.__exportStar||function(e,t){for(var r in e)r!=="default"&&!Object.prototype.hasOwnProperty.call(t,r)&&_se(t,e,r);};Object.defineProperty(Fr,"__esModule",{value:!0});Fr.ProposedFeatures=Fr.NotebookDocuments=Fr.TextDocuments=Fr.SemanticTokensBuilder=void 0;var Tse=mC();Object.defineProperty(Fr,"SemanticTokensBuilder",{enumerable:!0,get:function(){return Tse.SemanticTokensBuilder}});var Ase=TM();RM(ir(),Fr);var Rse=bC();Object.defineProperty(Fr,"TextDocuments",{enumerable:!0,get:function(){return Rse.TextDocuments}});var Ise=EC();Object.defineProperty(Fr,"NotebookDocuments",{enumerable:!0,get:function(){return Ise.NotebookDocuments}});RM(RC(),Fr);var AM;(function(e){e.all={__brand:"features",languages:Ase.InlineCompletionFeature};})(AM||(Fr.ProposedFeatures=AM={}));});var OM=A(Wn=>{var Dse=Wn&&Wn.__createBinding||(Object.create?function(e,t,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(t,r);(!i||("get"in i?!t.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,i);}:function(e,t,r,n){n===void 0&&(n=r),e[n]=t[r];}),NM=Wn&&Wn.__exportStar||function(e,t){for(var r in e)r!=="default"&&!Object.prototype.hasOwnProperty.call(t,r)&&Dse(t,e,r);};Object.defineProperty(Wn,"__esModule",{value:!0});Wn.createConnection=Wn.Files=void 0;var DM=he("util"),OC=ad(),Pse=RC(),Qc=wM(),No=LC();NM(LC(),Wn);NM(IM(),Wn);var PM;(function(e){e.uriToFilePath=Qc.uriToFilePath,e.resolveGlobalNodePath=Qc.resolveGlobalNodePath,e.resolveGlobalYarnPath=Qc.resolveGlobalYarnPath,e.resolve=Qc.resolve,e.resolveModulePath=Qc.resolveModulePath;})(PM||(Wn.Files=PM={}));var ru=!1,LM;function kse(){let e="--clientProcessId";function t(r){try{let n=parseInt(r);isNaN(n)||(LM=setInterval(()=>{try{process.kill(n,0);}catch{process.exit(ru?0:1);}},3e3));}catch{}}for(let r=2;r<process.argv.length;r++){let n=process.argv[r];if(n===e&&r+1<process.argv.length){t(process.argv[r+1]);return}else {let i=n.split("=");i[0]===e&&t(i[1]);}}}kse();var Nse={initialize:e=>{let t=e.processId;OC.number(t)&&LM===void 0&&setInterval(()=>{try{process.kill(t,0);}catch{process.exit(ru?0:1);}},3e3);},get shutdownReceived(){return ru},set shutdownReceived(e){ru=e;},exit:e=>{process.exit(e);}};function Lse(e,t,r,n){let i,s,o,a;return e!==void 0&&e.__brand==="features"&&(i=e,e=t,t=r,r=n),No.ConnectionStrategy.is(e)||No.ConnectionOptions.is(e)?a=e:(s=e,o=t,a=r),Ose(s,o,a,i)}Wn.createConnection=Lse;function Ose(e,t,r,n){let i=!1;if(!e&&!t&&process.argv.length>2){let c,l,u=process.argv.slice(2);for(let f=0;f<u.length;f++){let d=u[f];if(d==="--node-ipc"){e=new No.IPCMessageReader(process),t=new No.IPCMessageWriter(process);break}else if(d==="--stdio"){i=!0,e=process.stdin,t=process.stdout;break}else if(d==="--socket"){c=parseInt(u[f+1]);break}else if(d==="--pipe"){l=u[f+1];break}else {var s=d.split("=");if(s[0]==="--socket"){c=parseInt(s[1]);break}else if(s[0]==="--pipe"){l=s[1];break}}}if(c){let f=(0, No.createServerSocketTransport)(c);e=f[0],t=f[1];}else if(l){let f=(0, No.createServerPipeTransport)(l);e=f[0],t=f[1];}}var o="Use arguments of createConnection or set command line parameters: '--node-ipc', '--stdio' or '--socket={number}'";if(!e)throw new Error("Connection input stream is not set. "+o);if(!t)throw new Error("Connection output stream is not set. "+o);if(OC.func(e.read)&&OC.func(e.on)){let c=e;c.on("end",()=>{process.exit(ru?0:1);}),c.on("close",()=>{process.exit(ru?0:1);});}let a=c=>{let l=(0, No.createProtocolConnection)(e,t,c,r);return i&&Bse(c),l};return (0, Pse.createConnection)(a,Nse,n)}function Bse(e){function t(n){return n.map(i=>typeof i=="string"?i:(0, DM.inspect)(i)).join(" ")}let r=new Map;console.assert=function(i,...s){if(!i)if(s.length===0)e.error("Assertion failed");else {let[o,...a]=s;e.error(`Assertion failed: ${o} ${t(a)}`);}},console.count=function(i="default"){let s=String(i),o=r.get(s)??0;o+=1,r.set(s,o),e.log(`${s}: ${s}`);},console.countReset=function(i){i===void 0?r.clear():r.delete(String(i));},console.debug=function(...i){e.log(t(i));},console.dir=function(i,s){e.log((0, DM.inspect)(i,s));},console.log=function(...i){e.log(t(i));},console.error=function(...i){e.error(t(i));},console.trace=function(...i){let s=new Error().stack.replace(/(.+\n){2}/,""),o="Trace";i.length!==0&&(o+=`: ${t(i)}`),e.log(`${o}
${s}`);},console.warn=function(...i){e.warn(t(i));};}});var qM=A((Wge,BM)=>{BM.exports=OM();});var ol=new Uint8Array(256),sl=ol.length;function Op(){return sl>ol.length-16&&(P5__default.default.randomFillSync(ol),sl=0),ol.slice(sl,sl+=16)}var Tr=[];for(let e=0;e<256;++e)Tr.push((e+256).toString(16).slice(1));function yE(e,t=0){return Tr[e[t+0]]+Tr[e[t+1]]+Tr[e[t+2]]+Tr[e[t+3]]+"-"+Tr[e[t+4]]+Tr[e[t+5]]+"-"+Tr[e[t+6]]+Tr[e[t+7]]+"-"+Tr[e[t+8]]+Tr[e[t+9]]+"-"+Tr[e[t+10]]+Tr[e[t+11]]+Tr[e[t+12]]+Tr[e[t+13]]+Tr[e[t+14]]+Tr[e[t+15]]}var Bp={randomUUID:P5__default.default.randomUUID};function N5(e,t,r){if(Bp.randomUUID&&!t&&!e)return Bp.randomUUID();e=e||{};let n=e.random||(e.rng||Op)();if(n[6]=n[6]&15|64,n[8]=n[8]&63|128,t){r=r||0;for(let i=0;i<16;++i)t[r+i]=n[i];return t}return yE(n)}var ui=N5;var _o=cr(Su());var us={defaultMerge:Symbol("deepmerge-ts: default merge"),skip:Symbol("deepmerge-ts: skip")};function g$(e,t){return t}function p_(e){return typeof e!="object"||e===null?0:Array.isArray(e)?2:v$(e)?1:e instanceof Set?3:e instanceof Map?4:5}function m$(e){let t=new Set;for(let r of e)for(let n of [...Object.keys(r),...Object.getOwnPropertySymbols(r)])t.add(n);return t}function y$(e,t){return typeof e=="object"&&Object.prototype.propertyIsEnumerable.call(e,t)}function m_(e){return {*[Symbol.iterator](){for(let t of e)for(let r of t)yield r;}}}var g_=new Set(["[object Object]","[object Module]"]);function v$(e){if(!g_.has(Object.prototype.toString.call(e)))return !1;let{constructor:t}=e;if(t===void 0)return !0;let r=t.prototype;return !(r===null||typeof r!="object"||!g_.has(Object.prototype.toString.call(r))||!r.hasOwnProperty("isPrototypeOf"))}function S$(e,t,r){let n={};for(let i of m$(e)){let s=[];for(let c of e)y$(c,i)&&s.push(c[i]);if(s.length===0)continue;let o=t.metaDataUpdater(r,{key:i,parents:e}),a=v_(s,t,o);a!==us.skip&&(i==="__proto__"?Object.defineProperty(n,i,{value:a,configurable:!0,enumerable:!0,writable:!0}):n[i]=a);}return n}function b$(e){return e.flat()}function C$(e){return new Set(m_(e))}function E$(e){return new Map(m_(e))}function y_(e){return e.at(-1)}var Mg=Object.freeze({__proto__:null,mergeArrays:b$,mergeMaps:E$,mergeOthers:y_,mergeRecords:S$,mergeSets:C$});function $l(...e){return x$({})(...e)}function x$(e,t){let r=w$(e,n);function n(...i){return v_(i,r,t)}return n}function w$(e,t){return {defaultMergeFunctions:Mg,mergeFunctions:{...Mg,...Object.fromEntries(Object.entries(e).filter(([r,n])=>Object.hasOwn(Mg,r)).map(([r,n])=>n===!1?[r,y_]:[r,n]))},metaDataUpdater:e.metaDataUpdater??g$,deepmerge:t,useImplicitDefaultMerging:e.enableImplicitDefaultMerging??!1,actions:us}}function v_(e,t,r){if(e.length===0)return;if(e.length===1)return Ug(e,t,r);let n=p_(e[0]);if(n!==0&&n!==5){for(let i=1;i<e.length;i++)if(p_(e[i])!==n)return Ug(e,t,r)}switch(n){case 1:return _$(e,t,r);case 2:return T$(e,t,r);case 3:return A$(e,t,r);case 4:return R$(e,t,r);default:return Ug(e,t,r)}}function _$(e,t,r){let n=t.mergeFunctions.mergeRecords(e,t,r);return n===us.defaultMerge||t.useImplicitDefaultMerging&&n===void 0&&t.mergeFunctions.mergeRecords!==t.defaultMergeFunctions.mergeRecords?t.defaultMergeFunctions.mergeRecords(e,t,r):n}function T$(e,t,r){let n=t.mergeFunctions.mergeArrays(e,t,r);return n===us.defaultMerge||t.useImplicitDefaultMerging&&n===void 0&&t.mergeFunctions.mergeArrays!==t.defaultMergeFunctions.mergeArrays?t.defaultMergeFunctions.mergeArrays(e):n}function A$(e,t,r){let n=t.mergeFunctions.mergeSets(e,t,r);return n===us.defaultMerge||t.useImplicitDefaultMerging&&n===void 0&&t.mergeFunctions.mergeSets!==t.defaultMergeFunctions.mergeSets?t.defaultMergeFunctions.mergeSets(e):n}function R$(e,t,r){let n=t.mergeFunctions.mergeMaps(e,t,r);return n===us.defaultMerge||t.useImplicitDefaultMerging&&n===void 0&&t.mergeFunctions.mergeMaps!==t.defaultMergeFunctions.mergeMaps?t.defaultMergeFunctions.mergeMaps(e):n}function Ug(e,t,r){let n=t.mergeFunctions.mergeOthers(e,t,r);return n===us.defaultMerge||t.useImplicitDefaultMerging&&n===void 0&&t.mergeFunctions.mergeOthers!==t.defaultMergeFunctions.mergeOthers?t.defaultMergeFunctions.mergeOthers(e):n}var bu=e=>{let t=typeof e;return e!==null&&(t==="object"||t==="function")};var $g=new Set(["__proto__","prototype","constructor"]),I$=new Set("0123456789");function jg(e){let t=[],r="",n="start",i=!1;for(let s of e)switch(s){case"\\":{if(n==="index")throw new Error("Invalid character in an index");if(n==="indexEnd")throw new Error("Invalid character after an index");i&&(r+=s),n="property",i=!i;break}case".":{if(n==="index")throw new Error("Invalid character in an index");if(n==="indexEnd"){n="property";break}if(i){i=!1,r+=s;break}if($g.has(r))return [];t.push(r),r="",n="property";break}case"[":{if(n==="index")throw new Error("Invalid character in an index");if(n==="indexEnd"){n="index";break}if(i){i=!1,r+=s;break}if(n==="property"){if($g.has(r))return [];t.push(r),r="";}n="index";break}case"]":{if(n==="index"){t.push(Number.parseInt(r,10)),r="",n="indexEnd";break}if(n==="indexEnd")throw new Error("Invalid character after an index")}default:{if(n==="index"&&!I$.has(s))throw new Error("Invalid character in an index");if(n==="indexEnd")throw new Error("Invalid character after an index");n==="start"&&(n="property"),i&&(i=!1,r+="\\"),r+=s;}}switch(i&&(r+="\\"),n){case"property":{if($g.has(r))return [];t.push(r);break}case"index":throw new Error("Index was not closed");case"start":{t.push("");break}}return t}function S_(e,t){if(typeof t!="number"&&Array.isArray(e)){let r=Number.parseInt(t,10);return Number.isInteger(r)&&e[r]===e[t]}return !1}function b_(e,t){if(S_(e,t))throw new Error("Cannot use string index")}function jl(e,t,r){if(!bu(e)||typeof t!="string")return r===void 0?e:r;let n=jg(t);if(n.length===0)return r;for(let i=0;i<n.length;i++){let s=n[i];if(S_(e,s)?e=i===n.length-1?void 0:null:e=e[s],e==null){if(i!==n.length-1)return r;break}}return e===void 0?r:e}function Yo(e,t,r){if(!bu(e)||typeof t!="string")return e;let n=e,i=jg(t);for(let s=0;s<i.length;s++){let o=i[s];b_(e,o),s===i.length-1?e[o]=r:bu(e[o])||(e[o]=typeof i[s+1]=="number"?[]:{}),e=e[o];}return n}function Vl(e,t){if(!bu(e)||typeof t!="string")return !1;let r=jg(t);for(let n=0;n<r.length;n++){let i=r[n];if(b_(e,i),n===r.length-1)return delete e[i],!0;if(e=e[i],!bu(e))return !1}}var D$={"Content-Type":"application/json"};function Qs(e={}){let{fetch:t=globalThis.fetch,querySerializer:r,bodySerializer:n,...i}=e,s=i.baseUrl??"";s.endsWith("/")&&(s=s.slice(0,-1));async function o(a,c){let{fetch:l=t,headers:u,body:f,params:d={},parseAs:p="json",querySerializer:m=r??P$,bodySerializer:S=n??k$,...x}=c||{},I=N$(a,{baseUrl:s,params:d,querySerializer:m}),v=L$(D$,e?.headers,u,d.header),b={redirect:"follow",...i,...x,headers:v};f&&(b.body=S(f)),b.body instanceof FormData&&v.delete("Content-Type");let D=await l(I,b);if(D.status===204||D.headers.get("Content-Length")==="0")return D.ok?{data:{},response:D}:{error:{},response:D};if(D.ok){let j;if(p!=="stream"){let J=D.clone();j=typeof J[p]=="function"?await J[p]():await J.text();}else j=D.clone().body;return {data:j,response:D}}let L={};try{L=await D.clone().json();}catch{L=await D.clone().text();}return {error:L,response:D}}return {async GET(a,...c){return o(a,{...c[0],method:"GET"})},async PUT(a,...c){return o(a,{...c[0],method:"PUT"})},async POST(a,...c){return o(a,{...c[0],method:"POST"})},async DELETE(a,...c){return o(a,{...c[0],method:"DELETE"})},async OPTIONS(a,...c){return o(a,{...c[0],method:"OPTIONS"})},async HEAD(a,...c){return o(a,{...c[0],method:"HEAD"})},async PATCH(a,...c){return o(a,{...c[0],method:"PATCH"})},async TRACE(a,...c){return o(a,{...c[0],method:"TRACE"})}}}function P$(e){let t=new URLSearchParams;if(e&&typeof e=="object")for(let[r,n]of Object.entries(e))n!=null&&t.set(r,n);return t.toString()}function k$(e){return JSON.stringify(e)}function N$(e,t){let r=`${t.baseUrl}${e}`;if(t.params.path)for(let[i,s]of Object.entries(t.params.path))r=r.replace(`{${i}}`,encodeURIComponent(String(s)));let n=t.querySerializer(t.params.query??{});return n&&(r+=`?${n}`),r}function L$(...e){let t=new Headers;for(let r of e){if(!r||typeof r!="object")continue;let n=r instanceof Headers?r.entries():Object.entries(r);for(let[i,s]of n)s===null?t.delete(i):s!==void 0&&t.set(i,s);}return t}var sd=cr(vA());var Em=cr(hf()),cD=cr(Su()),lD=cr(Cm());var xm=class extends HJ.EventEmitter{constructor(r){super();this.filepath=r;this.data={};}async load(){this.data=await Em.default.readJson(wm,{throws:!1})||{};}async save(){await Em.default.outputJson(wm,this.data);}watch(){this.watcher=lD.default.watch(this.filepath,{interval:1e3});let r=async()=>{let n=this.data;await this.load(),(0, cD.default)(n,this.data)||super.emit("updated",this.data);};this.watcher.on("add",r),this.watcher.on("change",r);}},wm=Zy__default.default.join(xN__default.default.homedir(),".tabby-client","agent","data.json"),_m=new xm(wm);var yD=cr(pD());function ji(e){let t=e.match(/.*(?:$|\r?\n)/g)?.filter(Boolean)??[];return t.length>0&&t[t.length-1]?.endsWith(`
`)&&t.push(""),t}function Je(e){return e.trim().length===0}function pi(e,t){if(t===void 0)return e.match(/^[ \t]*/)?.[0]?.length??0;if(t==="	")return e.match(/^\t*/)?.[0].length??0;if(t.match(/^ *$/))return (e.match(/^ */)?.[0].length??0)/t.length;throw new Error(`Invalid indentation: ${t}`)}function Am(e,t){return t<0||t>=e.length-1?!1:pi(e[t])<pi(e[t+1])}function kf(e,t){return t<=0||t>e.length-1?!1:pi(e[t-1])>pi(e[t])}var zz=[{open:{chars:"(",reg:/\(/},close:{chars:")",reg:/\)/}},{open:{chars:"[",reg:/\[/},close:{chars:"]",reg:/\]/}},{open:{chars:"{",reg:/\{/},close:{chars:"}",reg:/\}/}},{open:{chars:"<",reg:/<(?=\w)/},close:{chars:"/>",reg:/\/>/}},{open:{chars:"<",reg:/<(?=[/\w])/},close:{chars:">",reg:/>/}},{openOrClose:{chars:'"',reg:/"/}},{openOrClose:{chars:"'",reg:/'/}},{openOrClose:{chars:"`",reg:/`/}}],gD=/^([)\]}>"'`]|(\/>))*$/g;function mD(e){let t=[],r=0;for(;r<e.length;){let n=e.slice(r),i={index:n.length,found:void 0};if(zz.forEach(s=>{Object.entries(s).forEach(([o,a])=>{let c=n.match(a.reg);c&&c.index!==void 0&&c.index<i.index&&(i={index:c.index,found:{pair:s,pos:o,pattern:a}});});}),!i.found)break;switch(i.found.pos){case"openOrClose":{let s=i.found.pattern.chars;t.length>0&&t.includes(s)?t.splice(t.lastIndexOf(s),t.length-t.lastIndexOf(s)):t.push(s);break}case"open":{t.push(i.found.pattern.chars);break}case"close":{let s=i.found.pair;t.length>0&&"open"in s&&t[t.length-1]===s.open.chars?t.pop():t.push(i.found.pattern.chars);break}}r+=i.index+i.found.pattern.chars.length;}return t}function la(e,t){return yD.get(e,t)}function Yu(e){let t=new AbortController;for(let r of e){if(r?.aborted)return t.abort(r.reason),r;r?.addEventListener("abort",()=>t.abort(r.reason),{signal:t.signal});}return t.signal}var lr=class extends Error{constructor(r){super(`${r.status} ${r.statusText}`);this.name="HttpError",this.status=r.status,this.statusText=r.statusText,this.response=r;}};function Rm(e){return e instanceof Error&&e.name==="TimeoutError"||e instanceof lr&&[408,499].includes(e.status)}function gi(e){return e instanceof Error&&e.name==="AbortError"}function fa(e){return e instanceof lr&&[401,403].includes(e.status)}function Im(e){let t=e.message||e.toString();return e.cause&&(t+=`
Caused by: `+Im(e.cause)),t}async function*Gz(e){let t=e.body?.getReader(),r=new TextDecoder("utf8"),n=!1;for(;t&&!n;){let{done:i,value:s}=await t.read();if(s){let o=r.decode(Buffer.from(s)),a="data: ";if(o.startsWith(a)){let c=JSON.parse(o.slice(a.length));n||=!!c.choices[0]?.finish_reason;let l=c.choices[0]?.delta.content;typeof l=="string"&&(yield l);}}n||=i;}}async function vD(e,t){let r=[];for await(let n of Gz(e)){if(t?.aborted)break;r.push(n);}return r.join("")}function Dm(e){this.message=e;}Dm.prototype=new Error,Dm.prototype.name="InvalidCharacterError";var SD=typeof window<"u"&&window.atob&&window.atob.bind(window)||function(e){var t=String(e).replace(/=+$/,"");if(t.length%4==1)throw new Dm("'atob' failed: The string to be decoded is not correctly encoded.");for(var r,n,i=0,s=0,o="";n=t.charAt(s++);~n&&(r=i%4?64*r+n:n,i++%4)?o+=String.fromCharCode(255&r>>(-2*i&6)):0)n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(n);return o};function Yz(e){var t=e.replace(/-/g,"+").replace(/_/g,"/");switch(t.length%4){case 0:break;case 2:t+="==";break;case 3:t+="=";break;default:throw "Illegal base64url string!"}try{return function(r){return decodeURIComponent(SD(r).replace(/(.)/g,function(n,i){var s=i.charCodeAt(0).toString(16).toUpperCase();return s.length<2&&(s="0"+s),"%"+s}))}(t)}catch{return SD(t)}}function Nf(e){this.message=e;}function Qz(e,t){if(typeof e!="string")throw new Nf("Invalid token specified");var r=(t=t||{}).header===!0?0:1;try{return JSON.parse(Yz(e.split(".")[r]))}catch(n){throw new Nf("Invalid token specified: "+n.message)}}Nf.prototype=new Error,Nf.prototype.name="InvalidTokenError";var Lf=Qz;var Fk=cr(Su());var Oy=cr(Ak()),Bk=cr(Ok());var By=class{write(t){this.stream||(this.stream=Bk.getStream({filename:Zy__default.default.join(xN__default.default.homedir(),".tabby-client","agent","logs","%DATE%"),frequency:"daily",size:"10M",max_logs:"30d",extension:".log",create_symlink:!0})),this.stream.write(t);}},qy=class{constructor(t,r){this.baseLogger=t;this.tag=r;}tagMsg(t){return `[${this.tag}] ${t}`}error(t,r){this.baseLogger.error(this.tagMsg(t),{error:r});}warn(t){this.baseLogger.warn(this.tagMsg(t));}info(t){this.baseLogger.info(this.tagMsg(t));}debug(t){this.baseLogger.debug(this.tagMsg(t));}trace(t,r){this.baseLogger.trace(this.tagMsg(t),r);}},rh=class e{constructor(t){this.baseLogger=t;this.childLoggers=[];this.baseLogger.onChild=r=>{this.childLoggers.push(r);};}get level(){return this.baseLogger.level}set level(t){this.baseLogger.level=t,this.childLoggers.forEach(r=>{r.level=t;});}child(t){return new e(this.baseLogger.child({tag:t}))}error(t,r){this.baseLogger.error({error:r},t);}warn(t){this.baseLogger.warn(t);}info(t){this.baseLogger.info(t);}debug(t){this.baseLogger.debug(t);}trace(t,r){this.baseLogger.trace(r,t);}},Fy=class extends HJ__default.default{constructor(r=[]){super();this.destinations=r;}attach(...r){this.destinations.push(...r),this.emit("newAttached",r);}},My=class{constructor(t,r){this.destinations=t;this.tag=r;this.loggers=[];this.loggers.push(...t.destinations.map(n=>this.createTaggedLogger(n))),t.on("newAttached",n=>{this.loggers.push(...n.map(i=>this.createTaggedLogger(i)));});}createTaggedLogger(t){return this.tag?t instanceof rh?t.child(this.tag):new qy(t,this.tag):t}error(t,r){this.loggers.forEach(n=>n.error(t,r));}warn(t){this.loggers.forEach(r=>r.warn(t));}info(t){this.loggers.forEach(r=>r.info(t));}debug(t){this.loggers.forEach(r=>r.debug(t));}trace(t,r){this.loggers.forEach(n=>n.trace(t,r));}},nh=new Fy,tc=new rh((0, Oy.default)({serializers:{error:Oy.default.stdSerializers.err}},new By));tc&&nh.attach(tc);function yr(e){return new My(nh,e)}var Uy=class extends Error{constructor(r){super();this.cause=r;this.name="RetryLimitReachedError";}},ih=class e extends HJ.EventEmitter{constructor(r){super();this.endpoint=r;this.logger=yr("Auth");this.authApi=Qs({baseUrl:"https://app.tabbyml.com/api"});}static{this.authPageUrl="https://app.tabbyml.com/account/device-token";}static{this.tokenStrategy={polling:{interval:5e3,timeout:5*60*1e3},refresh:{interval:15*60*1e3,beforeExpire:30*60*1e3,whenLoaded:{maxTry:5,retryDelay:1e3},whenScheduled:{maxTry:60,retryDelay:30*1e3}}};}async init(r){this.dataStore=r?.dataStore,this.dataStore instanceof HJ.EventEmitter&&this.dataStore.on("updated",async()=>{let n=this.jwt;await this.load(),(0, Fk.default)(n,this.jwt)||super.emit("updated",this.jwt);}),this.scheduleRefreshToken(),await this.load();}get token(){return this.jwt?.token}get user(){return this.jwt?.payload.email}async load(){if(this.dataStore)try{await this.dataStore.load();let r=this.dataStore.data.auth?.[this.endpoint]?.jwt;if(typeof r=="string"&&this.jwt?.token!==r){this.logger.debug("Loaded auth data from data store.");let n={token:r,payload:Lf(r)};n.payload.exp*1e3-Date.now()<e.tokenStrategy.refresh.beforeExpire?(this.jwt=await this.refreshToken(n,e.tokenStrategy.refresh.whenLoaded),await this.save()):this.jwt=n;}}catch{this.logger.debug("Failed to load auth data from data store.");}}async save(){if(this.dataStore)try{if(this.jwt){if(this.dataStore.data.auth?.[this.endpoint]?.jwt===this.jwt.token)return;this.dataStore.data.auth={...this.dataStore.data.auth,[this.endpoint]:{jwt:this.jwt.token}};}else {if(typeof this.dataStore.data.auth?.[this.endpoint]>"u")return;delete this.dataStore.data.auth[this.endpoint];}await this.dataStore.save(),this.logger.debug("Saved auth data to data store.");}catch(r){this.logger.error("Failed to save auth data to data store.",r);}}async reset(){this.jwt&&(this.jwt=void 0,await this.save());}async requestAuthUrl(r){try{if(await this.reset(),r?.signal?.aborted)throw r.signal.reason;this.logger.debug("Requesting device token...");let n=await this.authApi.POST("/device-token",{body:{auth_url:this.endpoint},signal:r?.signal});if(n.error||!n.response.ok)throw new lr(n.response);let i=n.data,s=new URL(e.authPageUrl);return s.searchParams.append("code",i.data.code),{authUrl:s.toString(),code:i.data.code}}catch(n){throw this.logger.error("Failed to request device token",n),n}}async pollingToken(r,n){return new Promise((i,s)=>{let o=Yu([AbortSignal.timeout(e.tokenStrategy.polling.timeout),n?.signal]),a=setInterval(async()=>{try{this.logger.debug("Polling auth token...");let c=await this.authApi.POST("/device-token/accept",{params:{query:{code:r}},signal:o});if(c.error||!c.response.ok)throw new lr(c.response);let l=c.data;this.jwt={token:l.data.jwt,payload:Lf(l.data.jwt)},super.emit("updated",this.jwt),await this.save(),clearInterval(a),i(!0);}catch(c){c instanceof lr&&[400,401,403,405].includes(c.status)&&this.logger.error("Failed due to unknown error when polling auth token",c);}},e.tokenStrategy.polling.interval);o.aborted?(clearInterval(a),s(o.reason)):o.addEventListener("abort",()=>{clearInterval(a),s(o.reason);});})}async refreshToken(r,n={maxTry:1,retryDelay:1e3},i=0){try{this.logger.debug("Refreshing auth token...");let s=await this.authApi.POST("/device-token/refresh",{headers:{Authorization:`Bearer ${r.token}`}});if(s.error||!s.response.ok)throw new lr(s.response);let o=s.data;return {token:o.data.jwt,payload:Lf(o.data.jwt)}}catch(s){if(s instanceof lr&&[400,401,403,405].includes(s.status)&&(this.logger.error("Failed due to unknown error when refreshing auth token.",s),i<n.maxTry))return this.logger.debug(`Retry refreshing auth token after ${n.retryDelay}ms`),await new Promise(o=>setTimeout(o,n.retryDelay)),this.refreshToken(r,n,i+1);throw new Uy(s)}}scheduleRefreshToken(){setInterval(async()=>{if(this.jwt)if(this.logger.debug("Checking auth token..."),this.jwt.payload.exp*1e3-Date.now()<e.tokenStrategy.refresh.beforeExpire)try{this.jwt=await this.refreshToken(this.jwt,e.tokenStrategy.refresh.whenScheduled),super.emit("updated",this.jwt),await this.save();}catch(r){this.logger.error("Failed to refresh auth token.",r);}else this.logger.debug("Auth token is still valid.");},e.tokenStrategy.refresh.interval);}};var rc={server:{endpoint:"http://localhost:8080",token:"",requestHeaders:{},requestTimeout:12e4},completion:{prompt:{maxPrefixLines:20,maxSuffixLines:20,fillDeclarations:{enabled:!0,maxSnippets:5,maxCharsPerSnippet:500},collectSnippetsFromRecentChangedFiles:{enabled:!0,maxSnippets:3,indexing:{checkingChangesInterval:500,changesDebouncingInterval:1e3,prefixLines:20,suffixLines:20,maxChunks:100,chunkSize:500,overlapLines:1}},clipboard:{minChars:3,maxChars:2e3}},debounce:{mode:"adaptive",interval:250},solution:{maxItems:3,maxTries:6,temperature:.8}},postprocess:{limitScope:{},calculateReplaceRange:{}},experimentalChat:{generateCommitMessage:{maxDiffLength:3600,promptTemplate:`Generate a commit message based on the given diff. 
You should only reply with the commit message, and the commit message should be in the following format: 
\`<type>(<scope>): <description>\` 
examples: 
 * feat(chat): add support for chat. 
 * fix(ui): fix homepage links. 
The diff is: 

\`\`\`diff 
{{diff}} 
\`\`\` 
`}},logs:{level:"silent"},tls:{caCerts:"system"},anonymousUsageTracking:{disable:!1}};var $y=cr(hf()),Kk=cr(Hk()),zk=cr(Cm()),Gk=cr(Su());var Wk=`## Tabby agent configuration file

## Online documentation: https://tabby.tabbyml.com/docs/extensions/configurations
## You can uncomment and edit the values below to change the default settings.
## Configurations in this file have lower priority than the IDE settings.

## Server
## You can set the server endpoint here and an optional authentication token if required.
# [server]
# endpoint = "http://localhost:8080" # http or https URL
# token = "your-token-here" # if token is set, request header Authorization = "Bearer $token" will be added automatically

## You can add custom request headers.
# [server.requestHeaders]
# Header1 = "Value1" # list your custom headers here
# Header2 = "Value2" # values can be strings, numbers or booleans

## Logs
## You can set the log level here. The log file is located at ~/.tabby-client/agent/logs/.
# [logs]
# level = "silent" # "silent" or "error" or "debug"

## Anonymous usage tracking
## Tabby collects anonymous usage data and sends it to the Tabby team to help improve our products.
## Your code, generated completions, or any sensitive information is never tracked or sent.
## For more details on data collection, see https://tabby.tabbyml.com/docs/extensions/configurations#usage-collection
## Your contribution is greatly appreciated. However, if you prefer not to participate, you can disable anonymous usage tracking here.
# [anonymousUsageTracking]
# disable = false # set to true to disable

`,XJ={server:"object","server.endpoint":"string","server.token":"string","server.requestHeaders":"object","server.requestTimeout":"number",completion:"object","completion.prompt":"object","completion.prompt.maxPrefixLines":"number","completion.prompt.maxSuffixLines":"number","completion.prompt.fillDeclarations":"object","completion.prompt.fillDeclarations.enabled":"boolean","completion.prompt.fillDeclarations.maxSnippets":"number","completion.prompt.fillDeclarations.maxChars":"number","completion.prompt.collectSnippetsFromRecentChangedFiles":"object","completion.prompt.collectSnippetsFromRecentChangedFiles.enabled":"boolean","completion.prompt.collectSnippetsFromRecentChangedFiles.maxSnippets":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing":"object","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.checkingChangesInterval":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.changesDebouncingInterval":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.prefixLines":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.suffixLines":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.maxChunks":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.chunkSize":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.overlapLines":"number","completion.prompt.clipboard":"object","completion.prompt.clipboard.minChars":"number","completion.prompt.clipboard.maxChars":"number","completion.debounce":"object","completion.debounce.mode":"string","completion.debounce.interval":"number","completion.solution":"object","completion.solution.maxItems":"number","completion.solution.maxTries":"number","completion.solution.temperature":"number",experimentalChat:"object","experimentalChat.generateCommitMessage":"object","experimentalChat.generateCommitMessage.maxDiffLength":"number","experimentalChat.generateCommitMessage.promptTemplate":"string",logs:"object","logs.level":"string",tls:"object","tls.caCerts":"string",anonymousUsageTracking:"object","anonymousUsageTracking.disable":"boolean"};function JJ(e){for(let[t,r]of Object.entries(XJ))typeof jl(e,t)!==r&&Vl(e,t);return e}var jy=class extends HJ.EventEmitter{constructor(r){super();this.filepath=r;this.data={};this.logger=yr("ConfigFile");}get config(){return this.data}async load(){try{let r=await $y.default.readFile(this.filepath,"utf8"),n=Kk.default.parse(r);if(Object.keys(n).length===0&&r.trim()!==Wk.trim()){await this.createTemplate();return}this.data=JJ(n);}catch(r){r instanceof Error&&"code"in r&&r.code==="ENOENT"?await this.createTemplate():this.logger.error("Failed to load config file.",r);}}watch(){this.watcher=zk.default.watch(this.filepath,{interval:1e3});let r=async()=>{let n=this.data;await this.load(),(0, Gk.default)(n,this.data)||super.emit("updated",this.data);};this.watcher.on("add",r),this.watcher.on("change",r);}async createTemplate(){try{await $y.default.outputFile(this.filepath,Wk);}catch(r){this.logger.error("Failed to create config template file.",r);}}},ZJ=Zy__default.default.join(xN__default.default.homedir(),".tabby-client","agent","config.toml"),ya=new jy(ZJ);var nc=typeof performance=="object"&&performance&&typeof performance.now=="function"?performance:Date,Qk=new Set,Vy=typeof process=="object"&&process?process:{},Xk=(e,t,r,n)=>{typeof Vy.emitWarning=="function"?Vy.emitWarning(e,t,r,n):console.error(`[${r}] ${t}: ${e}`);},sh=globalThis.AbortController,Yk=globalThis.AbortSignal;if(typeof sh>"u"){Yk=class{onabort;_onabort=[];reason;aborted=!1;addEventListener(n,i){this._onabort.push(i);}},sh=class{constructor(){t();}signal=new Yk;abort(n){if(!this.signal.aborted){this.signal.reason=n,this.signal.aborted=!0;for(let i of this.signal._onabort)i(n);this.signal.onabort?.(n);}}};let e=Vy.env?.LRU_CACHE_IGNORE_AC_WARNING!=="1",t=()=>{e&&(e=!1,Xk("AbortController is not defined. If using lru-cache in node 14, load an AbortController polyfill from the `node-abort-controller` package. A minimal polyfill is provided for use by LRUCache.fetch(), but it should not be relied upon in other contexts (eg, passing it to other APIs that use AbortController/AbortSignal might have undesirable effects). You may disable this with LRU_CACHE_IGNORE_AC_WARNING=1 in the env.","NO_ABORT_CONTROLLER","ENOTSUP",t));};}var eZ=e=>!Qk.has(e),gs=e=>e&&e===Math.floor(e)&&e>0&&isFinite(e),Jk=e=>gs(e)?e<=Math.pow(2,8)?Uint8Array:e<=Math.pow(2,16)?Uint16Array:e<=Math.pow(2,32)?Uint32Array:e<=Number.MAX_SAFE_INTEGER?va:null:null,va=class extends Array{constructor(t){super(t),this.fill(0);}},Hy=class e{heap;length;static#u=!1;static create(t){let r=Jk(t);if(!r)return [];e.#u=!0;let n=new e(t,r);return e.#u=!1,n}constructor(t,r){if(!e.#u)throw new TypeError("instantiate Stack using Stack.create(n)");this.heap=new r(t),this.length=0;}push(t){this.heap[this.length++]=t;}pop(){return this.heap[--this.length]}},oh=class e{#u;#f;#v;#p;#I;ttl;ttlResolution;ttlAutopurge;updateAgeOnGet;updateAgeOnHas;allowStale;noDisposeOnSet;noUpdateTTL;maxEntrySize;sizeCalculation;noDeleteOnFetchRejection;noDeleteOnStaleGet;allowStaleOnFetchAbort;allowStaleOnFetchRejection;ignoreFetchAbort;#n;#g;#i;#r;#e;#c;#h;#a;#s;#m;#o;#E;#x;#y;#S;#_;#l;static unsafeExposeInternals(t){return {starts:t.#x,ttls:t.#y,sizes:t.#E,keyMap:t.#i,keyList:t.#r,valList:t.#e,next:t.#c,prev:t.#h,get head(){return t.#a},get tail(){return t.#s},free:t.#m,isBackgroundFetch:r=>t.#t(r),backgroundFetch:(r,n,i,s)=>t.#k(r,n,i,s),moveToTail:r=>t.#R(r),indexes:r=>t.#b(r),rindexes:r=>t.#C(r),isStale:r=>t.#d(r)}}get max(){return this.#u}get maxSize(){return this.#f}get calculatedSize(){return this.#g}get size(){return this.#n}get fetchMethod(){return this.#I}get dispose(){return this.#v}get disposeAfter(){return this.#p}constructor(t){let{max:r=0,ttl:n,ttlResolution:i=1,ttlAutopurge:s,updateAgeOnGet:o,updateAgeOnHas:a,allowStale:c,dispose:l,disposeAfter:u,noDisposeOnSet:f,noUpdateTTL:d,maxSize:p=0,maxEntrySize:m=0,sizeCalculation:S,fetchMethod:x,noDeleteOnFetchRejection:I,noDeleteOnStaleGet:v,allowStaleOnFetchRejection:b,allowStaleOnFetchAbort:D,ignoreFetchAbort:L}=t;if(r!==0&&!gs(r))throw new TypeError("max option must be a nonnegative integer");let j=r?Jk(r):Array;if(!j)throw new Error("invalid max value: "+r);if(this.#u=r,this.#f=p,this.maxEntrySize=m||this.#f,this.sizeCalculation=S,this.sizeCalculation){if(!this.#f&&!this.maxEntrySize)throw new TypeError("cannot set sizeCalculation without setting maxSize or maxEntrySize");if(typeof this.sizeCalculation!="function")throw new TypeError("sizeCalculation set to non-function")}if(x!==void 0&&typeof x!="function")throw new TypeError("fetchMethod must be a function if specified");if(this.#I=x,this.#_=!!x,this.#i=new Map,this.#r=new Array(r).fill(void 0),this.#e=new Array(r).fill(void 0),this.#c=new j(r),this.#h=new j(r),this.#a=0,this.#s=0,this.#m=Hy.create(r),this.#n=0,this.#g=0,typeof l=="function"&&(this.#v=l),typeof u=="function"?(this.#p=u,this.#o=[]):(this.#p=void 0,this.#o=void 0),this.#S=!!this.#v,this.#l=!!this.#p,this.noDisposeOnSet=!!f,this.noUpdateTTL=!!d,this.noDeleteOnFetchRejection=!!I,this.allowStaleOnFetchRejection=!!b,this.allowStaleOnFetchAbort=!!D,this.ignoreFetchAbort=!!L,this.maxEntrySize!==0){if(this.#f!==0&&!gs(this.#f))throw new TypeError("maxSize must be a positive integer if specified");if(!gs(this.maxEntrySize))throw new TypeError("maxEntrySize must be a positive integer if specified");this.#F();}if(this.allowStale=!!c,this.noDeleteOnStaleGet=!!v,this.updateAgeOnGet=!!o,this.updateAgeOnHas=!!a,this.ttlResolution=gs(i)||i===0?i:1,this.ttlAutopurge=!!s,this.ttl=n||0,this.ttl){if(!gs(this.ttl))throw new TypeError("ttl must be a positive integer if specified");this.#N();}if(this.#u===0&&this.ttl===0&&this.#f===0)throw new TypeError("At least one of max, maxSize, or ttl is required");if(!this.ttlAutopurge&&!this.#u&&!this.#f){let J="LRU_CACHE_UNBOUNDED";eZ(J)&&(Qk.add(J),Xk("TTL caching without ttlAutopurge, max, or maxSize can result in unbounded memory consumption.","UnboundedCacheWarning",J,e));}}getRemainingTTL(t){return this.#i.has(t)?1/0:0}#N(){let t=new va(this.#u),r=new va(this.#u);this.#y=t,this.#x=r,this.#L=(s,o,a=nc.now())=>{if(r[s]=o!==0?a:0,t[s]=o,o!==0&&this.ttlAutopurge){let c=setTimeout(()=>{this.#d(s)&&this.delete(this.#r[s]);},o+1);c.unref&&c.unref();}},this.#T=s=>{r[s]=t[s]!==0?nc.now():0;},this.#w=(s,o)=>{if(t[o]){let a=t[o],c=r[o];s.ttl=a,s.start=c,s.now=n||i();let l=s.now-c;s.remainingTTL=a-l;}};let n=0,i=()=>{let s=nc.now();if(this.ttlResolution>0){n=s;let o=setTimeout(()=>n=0,this.ttlResolution);o.unref&&o.unref();}return s};this.getRemainingTTL=s=>{let o=this.#i.get(s);if(o===void 0)return 0;let a=t[o],c=r[o];if(a===0||c===0)return 1/0;let l=(n||i())-c;return a-l},this.#d=s=>t[s]!==0&&r[s]!==0&&(n||i())-r[s]>t[s];}#T=()=>{};#w=()=>{};#L=()=>{};#d=()=>!1;#F(){let t=new va(this.#u);this.#g=0,this.#E=t,this.#A=r=>{this.#g-=t[r],t[r]=0;},this.#O=(r,n,i,s)=>{if(this.#t(n))return 0;if(!gs(i))if(s){if(typeof s!="function")throw new TypeError("sizeCalculation must be a function");if(i=s(n,r),!gs(i))throw new TypeError("sizeCalculation return invalid (expect positive integer)")}else throw new TypeError("invalid size value (must be positive integer). When maxSize or maxEntrySize is used, sizeCalculation or size must be set.");return i},this.#D=(r,n,i)=>{if(t[r]=n,this.#f){let s=this.#f-t[r];for(;this.#g>s;)this.#P(!0);}this.#g+=t[r],i&&(i.entrySize=n,i.totalCalculatedSize=this.#g);};}#A=t=>{};#D=(t,r,n)=>{};#O=(t,r,n,i)=>{if(n||i)throw new TypeError("cannot set size without setting maxSize or maxEntrySize on cache");return 0};*#b({allowStale:t=this.allowStale}={}){if(this.#n)for(let r=this.#s;!(!this.#B(r)||((t||!this.#d(r))&&(yield r),r===this.#a));)r=this.#h[r];}*#C({allowStale:t=this.allowStale}={}){if(this.#n)for(let r=this.#a;!(!this.#B(r)||((t||!this.#d(r))&&(yield r),r===this.#s));)r=this.#c[r];}#B(t){return t!==void 0&&this.#i.get(this.#r[t])===t}*entries(){for(let t of this.#b())this.#e[t]!==void 0&&this.#r[t]!==void 0&&!this.#t(this.#e[t])&&(yield [this.#r[t],this.#e[t]]);}*rentries(){for(let t of this.#C())this.#e[t]!==void 0&&this.#r[t]!==void 0&&!this.#t(this.#e[t])&&(yield [this.#r[t],this.#e[t]]);}*keys(){for(let t of this.#b()){let r=this.#r[t];r!==void 0&&!this.#t(this.#e[t])&&(yield r);}}*rkeys(){for(let t of this.#C()){let r=this.#r[t];r!==void 0&&!this.#t(this.#e[t])&&(yield r);}}*values(){for(let t of this.#b())this.#e[t]!==void 0&&!this.#t(this.#e[t])&&(yield this.#e[t]);}*rvalues(){for(let t of this.#C())this.#e[t]!==void 0&&!this.#t(this.#e[t])&&(yield this.#e[t]);}[Symbol.iterator](){return this.entries()}find(t,r={}){for(let n of this.#b()){let i=this.#e[n],s=this.#t(i)?i.__staleWhileFetching:i;if(s!==void 0&&t(s,this.#r[n],this))return this.get(this.#r[n],r)}}forEach(t,r=this){for(let n of this.#b()){let i=this.#e[n],s=this.#t(i)?i.__staleWhileFetching:i;s!==void 0&&t.call(r,s,this.#r[n],this);}}rforEach(t,r=this){for(let n of this.#C()){let i=this.#e[n],s=this.#t(i)?i.__staleWhileFetching:i;s!==void 0&&t.call(r,s,this.#r[n],this);}}purgeStale(){let t=!1;for(let r of this.#C({allowStale:!0}))this.#d(r)&&(this.delete(this.#r[r]),t=!0);return t}dump(){let t=[];for(let r of this.#b({allowStale:!0})){let n=this.#r[r],i=this.#e[r],s=this.#t(i)?i.__staleWhileFetching:i;if(s===void 0||n===void 0)continue;let o={value:s};if(this.#y&&this.#x){o.ttl=this.#y[r];let a=nc.now()-this.#x[r];o.start=Math.floor(Date.now()-a);}this.#E&&(o.size=this.#E[r]),t.unshift([n,o]);}return t}load(t){this.clear();for(let[r,n]of t){if(n.start){let i=Date.now()-n.start;n.start=nc.now()-i;}this.set(r,n.value,n);}}set(t,r,n={}){if(r===void 0)return this.delete(t),this;let{ttl:i=this.ttl,start:s,noDisposeOnSet:o=this.noDisposeOnSet,sizeCalculation:a=this.sizeCalculation,status:c}=n,{noUpdateTTL:l=this.noUpdateTTL}=n,u=this.#O(t,r,n.size||0,a);if(this.maxEntrySize&&u>this.maxEntrySize)return c&&(c.set="miss",c.maxEntrySizeExceeded=!0),this.delete(t),this;let f=this.#n===0?void 0:this.#i.get(t);if(f===void 0)f=this.#n===0?this.#s:this.#m.length!==0?this.#m.pop():this.#n===this.#u?this.#P(!1):this.#n,this.#r[f]=t,this.#e[f]=r,this.#i.set(t,f),this.#c[this.#s]=f,this.#h[f]=this.#s,this.#s=f,this.#n++,this.#D(f,u,c),c&&(c.set="add"),l=!1;else {this.#R(f);let d=this.#e[f];if(r!==d){if(this.#_&&this.#t(d)?d.__abortController.abort(new Error("replaced")):o||(this.#S&&this.#v?.(d,t,"set"),this.#l&&this.#o?.push([d,t,"set"])),this.#A(f),this.#D(f,u,c),this.#e[f]=r,c){c.set="replace";let p=d&&this.#t(d)?d.__staleWhileFetching:d;p!==void 0&&(c.oldValue=p);}}else c&&(c.set="update");}if(i!==0&&!this.#y&&this.#N(),this.#y&&(l||this.#L(f,i,s),c&&this.#w(c,f)),!o&&this.#l&&this.#o){let d=this.#o,p;for(;p=d?.shift();)this.#p?.(...p);}return this}pop(){try{for(;this.#n;){let t=this.#e[this.#a];if(this.#P(!0),this.#t(t)){if(t.__staleWhileFetching)return t.__staleWhileFetching}else if(t!==void 0)return t}}finally{if(this.#l&&this.#o){let t=this.#o,r;for(;r=t?.shift();)this.#p?.(...r);}}}#P(t){let r=this.#a,n=this.#r[r],i=this.#e[r];return this.#_&&this.#t(i)?i.__abortController.abort(new Error("evicted")):(this.#S||this.#l)&&(this.#S&&this.#v?.(i,n,"evict"),this.#l&&this.#o?.push([i,n,"evict"])),this.#A(r),t&&(this.#r[r]=void 0,this.#e[r]=void 0,this.#m.push(r)),this.#n===1?(this.#a=this.#s=0,this.#m.length=0):this.#a=this.#c[r],this.#i.delete(n),this.#n--,r}has(t,r={}){let{updateAgeOnHas:n=this.updateAgeOnHas,status:i}=r,s=this.#i.get(t);if(s!==void 0){let o=this.#e[s];if(this.#t(o)&&o.__staleWhileFetching===void 0)return !1;if(this.#d(s))i&&(i.has="stale",this.#w(i,s));else return n&&this.#T(s),i&&(i.has="hit",this.#w(i,s)),!0}else i&&(i.has="miss");return !1}peek(t,r={}){let{allowStale:n=this.allowStale}=r,i=this.#i.get(t);if(i!==void 0&&(n||!this.#d(i))){let s=this.#e[i];return this.#t(s)?s.__staleWhileFetching:s}}#k(t,r,n,i){let s=r===void 0?void 0:this.#e[r];if(this.#t(s))return s;let o=new sh,{signal:a}=n;a?.addEventListener("abort",()=>o.abort(a.reason),{signal:o.signal});let c={signal:o.signal,options:n,context:i},l=(S,x=!1)=>{let{aborted:I}=o.signal,v=n.ignoreFetchAbort&&S!==void 0;if(n.status&&(I&&!x?(n.status.fetchAborted=!0,n.status.fetchError=o.signal.reason,v&&(n.status.fetchAbortIgnored=!0)):n.status.fetchResolved=!0),I&&!v&&!x)return f(o.signal.reason);let b=p;return this.#e[r]===p&&(S===void 0?b.__staleWhileFetching?this.#e[r]=b.__staleWhileFetching:this.delete(t):(n.status&&(n.status.fetchUpdated=!0),this.set(t,S,c.options))),S},u=S=>(n.status&&(n.status.fetchRejected=!0,n.status.fetchError=S),f(S)),f=S=>{let{aborted:x}=o.signal,I=x&&n.allowStaleOnFetchAbort,v=I||n.allowStaleOnFetchRejection,b=v||n.noDeleteOnFetchRejection,D=p;if(this.#e[r]===p&&(!b||D.__staleWhileFetching===void 0?this.delete(t):I||(this.#e[r]=D.__staleWhileFetching)),v)return n.status&&D.__staleWhileFetching!==void 0&&(n.status.returnedStale=!0),D.__staleWhileFetching;if(D.__returned===D)throw S},d=(S,x)=>{let I=this.#I?.(t,s,c);I&&I instanceof Promise&&I.then(v=>S(v),x),o.signal.addEventListener("abort",()=>{(!n.ignoreFetchAbort||n.allowStaleOnFetchAbort)&&(S(),n.allowStaleOnFetchAbort&&(S=v=>l(v,!0)));});};n.status&&(n.status.fetchDispatched=!0);let p=new Promise(d).then(l,u),m=Object.assign(p,{__abortController:o,__staleWhileFetching:s,__returned:void 0});return r===void 0?(this.set(t,m,{...c.options,status:void 0}),r=this.#i.get(t)):this.#e[r]=m,m}#t(t){if(!this.#_)return !1;let r=t;return !!r&&r instanceof Promise&&r.hasOwnProperty("__staleWhileFetching")&&r.__abortController instanceof sh}async fetch(t,r={}){let{allowStale:n=this.allowStale,updateAgeOnGet:i=this.updateAgeOnGet,noDeleteOnStaleGet:s=this.noDeleteOnStaleGet,ttl:o=this.ttl,noDisposeOnSet:a=this.noDisposeOnSet,size:c=0,sizeCalculation:l=this.sizeCalculation,noUpdateTTL:u=this.noUpdateTTL,noDeleteOnFetchRejection:f=this.noDeleteOnFetchRejection,allowStaleOnFetchRejection:d=this.allowStaleOnFetchRejection,ignoreFetchAbort:p=this.ignoreFetchAbort,allowStaleOnFetchAbort:m=this.allowStaleOnFetchAbort,context:S,forceRefresh:x=!1,status:I,signal:v}=r;if(!this.#_)return I&&(I.fetch="get"),this.get(t,{allowStale:n,updateAgeOnGet:i,noDeleteOnStaleGet:s,status:I});let b={allowStale:n,updateAgeOnGet:i,noDeleteOnStaleGet:s,ttl:o,noDisposeOnSet:a,size:c,sizeCalculation:l,noUpdateTTL:u,noDeleteOnFetchRejection:f,allowStaleOnFetchRejection:d,allowStaleOnFetchAbort:m,ignoreFetchAbort:p,status:I,signal:v},D=this.#i.get(t);if(D===void 0){I&&(I.fetch="miss");let L=this.#k(t,D,b,S);return L.__returned=L}else {let L=this.#e[D];if(this.#t(L)){let ee=n&&L.__staleWhileFetching!==void 0;return I&&(I.fetch="inflight",ee&&(I.returnedStale=!0)),ee?L.__staleWhileFetching:L.__returned=L}let j=this.#d(D);if(!x&&!j)return I&&(I.fetch="hit"),this.#R(D),i&&this.#T(D),I&&this.#w(I,D),L;let J=this.#k(t,D,b,S),G=J.__staleWhileFetching!==void 0&&n;return I&&(I.fetch=j?"stale":"refresh",G&&j&&(I.returnedStale=!0)),G?J.__staleWhileFetching:J.__returned=J}}get(t,r={}){let{allowStale:n=this.allowStale,updateAgeOnGet:i=this.updateAgeOnGet,noDeleteOnStaleGet:s=this.noDeleteOnStaleGet,status:o}=r,a=this.#i.get(t);if(a!==void 0){let c=this.#e[a],l=this.#t(c);return o&&this.#w(o,a),this.#d(a)?(o&&(o.get="stale"),l?(o&&n&&c.__staleWhileFetching!==void 0&&(o.returnedStale=!0),n?c.__staleWhileFetching:void 0):(s||this.delete(t),o&&n&&(o.returnedStale=!0),n?c:void 0)):(o&&(o.get="hit"),l?c.__staleWhileFetching:(this.#R(a),i&&this.#T(a),c))}else o&&(o.get="miss");}#q(t,r){this.#h[r]=t,this.#c[t]=r;}#R(t){t!==this.#s&&(t===this.#a?this.#a=this.#c[t]:this.#q(this.#h[t],this.#c[t]),this.#q(this.#s,t),this.#s=t);}delete(t){let r=!1;if(this.#n!==0){let n=this.#i.get(t);if(n!==void 0)if(r=!0,this.#n===1)this.clear();else {this.#A(n);let i=this.#e[n];this.#t(i)?i.__abortController.abort(new Error("deleted")):(this.#S||this.#l)&&(this.#S&&this.#v?.(i,t,"delete"),this.#l&&this.#o?.push([i,t,"delete"])),this.#i.delete(t),this.#r[n]=void 0,this.#e[n]=void 0,n===this.#s?this.#s=this.#h[n]:n===this.#a?this.#a=this.#c[n]:(this.#c[this.#h[n]]=this.#c[n],this.#h[this.#c[n]]=this.#h[n]),this.#n--,this.#m.push(n);}}if(this.#l&&this.#o?.length){let n=this.#o,i;for(;i=n?.shift();)this.#p?.(...i);}return r}clear(){for(let t of this.#C({allowStale:!0})){let r=this.#e[t];if(this.#t(r))r.__abortController.abort(new Error("deleted"));else {let n=this.#r[t];this.#S&&this.#v?.(r,n,"delete"),this.#l&&this.#o?.push([r,n,"delete"]);}}if(this.#i.clear(),this.#e.fill(void 0),this.#r.fill(void 0),this.#y&&this.#x&&(this.#y.fill(0),this.#x.fill(0)),this.#E&&this.#E.fill(0),this.#a=0,this.#s=0,this.#m.length=0,this.#g=0,this.#n=0,this.#l&&this.#o){let t=this.#o,r;for(;r=t?.shift();)this.#p?.(...r);}}};var Wy={isIncomplete:!0,items:[]},bn=class e{constructor(t,r,n="",i="",s){this.context=t;this.fullText=r;this.replacePrefix=n;this.replaceSuffix=i;this.eventId=s;this.text=r.substring(n.length),this.lines=ji(this.text),this.currentLine=this.lines[0]??"",this.isBlank=Je(this.text);}static createBlankItem(t){return new e(t,"")}static createFromResponse(t,r,n=0){return new e(t,r.choices[n]?.text??"","","",{completionId:r.id,choiceIndex:r.choices[n]?.index??n})}withFullText(t){return new e(this.context,t,this.replacePrefix,this.replaceSuffix,this.eventId)}withText(t){return new e(this.context,this.replacePrefix+t,this.replacePrefix,this.replaceSuffix,this.eventId)}withSuffix(t){return new e(this.context,this.fullText,this.replacePrefix,t,this.eventId)}withContext(t){return t.hash===this.context.hash?new e(t,this.fullText,this.replacePrefix,this.replaceSuffix,this.eventId):e.createBlankItem(t)}forward(t){if(t<=0)return this;let r=this.text.substring(0,t);if(t<this.currentLine.length)return new e(this.context.forward(r),this.fullText,this.replacePrefix+r,this.replaceSuffix,this.eventId);let n=r.lastIndexOf(`
`)+1,i=r.substring(n),s=i.search(/\S/);s<0&&(s=i.length);let o=n+s,a=this.text.substring(o),c=r.substring(o);return new e(this.context.forward(r),a,c,this.replaceSuffix,this.eventId)}isSameWith(t){return this.context.hash===t.context.hash&&this.text===t.text}toInlineCompletionItem(){return {insertText:this.fullText,range:{start:this.context.currentLinePrefix.endsWith(this.replacePrefix)?this.context.position-this.replacePrefix.length:this.context.position,end:this.context.currentLineSuffix.startsWith(this.replaceSuffix)?this.context.position+this.replaceSuffix.length:this.context.position},data:{eventId:this.eventId}}}},ms=class e{constructor(t,r=[],n=!1){this.context=t;this.items=[];this.isCompleted=!1;this.add(...r),this.isCompleted=n;}static merge(t,r){return t.context.hash===r.context.hash?new e(t.context,[...t.items,...r.items],t.isCompleted||r.isCompleted):t}add(...t){this.items.push(...t.map(r=>r.withContext(this.context)).filter((r,n,i)=>!r.isBlank&&i.findIndex(s=>s.isSameWith(r))===n&&this.items.findIndex(s=>s.isSameWith(r))===-1));}withContext(t){return t.hash===this.context.hash?new e(t,this.items,this.isCompleted):new e(t)}withItems(...t){return new e(this.context,t,this.isCompleted)}toInlineCompletionList(){return {isIncomplete:!this.isCompleted,items:this.items.map(t=>t.toInlineCompletionItem())}}};var ah=class{constructor(){this.logger=yr("CompletionCache");this.config={maxCount:1e3,forwardCachingChars:50};this.cache=new oh({max:this.config.maxCount});}has(t){return this.cache.has(t)}update(t){this.logger.debug(`Updating completion cache, cache number before updating: ${this.cache.size}`);let r=[t,...this.generateForwardSolutions(t)];r.forEach(n=>{let i=this.cache.get(n.context.hash);i?this.cache.set(n.context.hash,ms.merge(i,n)):this.cache.set(n.context.hash,n);}),this.logger.debug(`Updated entries number: ${r.length}`),this.logger.debug(`Completion cache updated, cache number: ${this.cache.size}`);}get(t){return this.cache.get(t)}generateForwardSolutions(t){let r=[],n=i=>{let s=r.find(o=>o.context.hash===i.context.hash);s?s.add(i):r.push(new ms(i.context,[i]));};for(let i of t.items){for(let s=1;s<Math.min(this.config.forwardCachingChars,i.currentLine.length);s++)n(i.forward(s));if(i.lines.length>2){n(i.forward(i.currentLine.length-1)),n(i.forward(i.currentLine.length));let s=i.lines[1],o=s.search(/\S/);o<0&&(o=s.length-1),n(i.forward(i.currentLine.length+o));}}return r}};function Ky(e,t,r){return Math.max(e,Math.min(t,r))}var uh=class{constructor(){this.lastCalledTimeStamp=0;this.baseInterval=200;this.calledIntervalHistory=[];this.options={baseIntervalSlideWindowAvg:{minSize:20,maxSize:100,min:100,max:400},adaptiveRate:{min:1.5,max:3},contextScoreWeights:{triggerCharacter:.5,noSuffixInCurrentLine:.4,noSuffix:.1},requestDelay:{min:100,max:1e3}};}async debounce(t,r){let{request:n,config:i,responseTime:s}=t;if(n.manually)return this.sleep(0,r);if(i.mode==="fixed")return this.sleep(i.interval,r);let o=Date.now();this.updateBaseInterval(o-this.lastCalledTimeStamp),this.lastCalledTimeStamp=o;let a=this.calcContextScore(n),l=(this.options.adaptiveRate.max-(this.options.adaptiveRate.max-this.options.adaptiveRate.min)*a)*this.baseInterval,u=Ky(this.options.requestDelay.min,this.options.requestDelay.max,l-s);return this.sleep(u,r)}async sleep(t,r){return new Promise((n,i)=>{let s=setTimeout(n,Math.min(t,2147483647)),o=r?.signal;o&&(o.aborted?(clearTimeout(s),i(o.reason)):o.addEventListener("abort",()=>{clearTimeout(s),i(o.reason);}));})}updateBaseInterval(t){if(!(t>this.options.baseIntervalSlideWindowAvg.max)&&(this.calledIntervalHistory.push(t),this.calledIntervalHistory.length>this.options.baseIntervalSlideWindowAvg.maxSize&&this.calledIntervalHistory.shift(),this.calledIntervalHistory.length>this.options.baseIntervalSlideWindowAvg.minSize)){let r=this.calledIntervalHistory.reduce((n,i)=>n+i,0)/this.calledIntervalHistory.length;this.baseInterval=Ky(this.options.baseIntervalSlideWindowAvg.min,this.options.baseIntervalSlideWindowAvg.max,r);}}calcContextScore(t){let r=0,n=this.options.contextScoreWeights,i=t.text[t.position-1]??"";r+=i.match(/^\W*$/)?n.triggerCharacter:0;let s=t.text.slice(t.position)??"",o=ji(s)[0]??"";return r+=o.match(/^\W*$/)?n.noSuffixInCurrentLine:0,r+=s.match(/^\W*$/)?n.noSuffix:0,r=Ky(0,1,r),r}};var Qy=cr(rN()),ch=class{constructor(){this.autoCompletionCount=0;this.manualCompletionCount=0;this.eventMap=new Map;this.completionRequestLatencyStats=new Qy.Univariate;this.completionRequestCanceledCount=0;this.completionRequestTimeoutCount=0;}addProviderStatsEntry(t){let{triggerMode:r}=t;r==="auto"?this.autoCompletionCount+=1:this.manualCompletionCount+=1;}addRequestStatsEntry(t){let{canceled:r,timeout:n,latency:i}=t;r?this.completionRequestCanceledCount+=1:n?this.completionRequestTimeoutCount+=1:this.completionRequestLatencyStats.add(i);}addEvent(t){let r=this.eventMap.get(t)||0;this.eventMap.set(t,r+1);}reset(){this.autoCompletionCount=0,this.manualCompletionCount=0,this.eventMap=new Map,this.completionRequestLatencyStats=new Qy.Univariate,this.completionRequestCanceledCount=0,this.completionRequestTimeoutCount=0;}stats(){let t=Object.fromEntries(Array.from(this.eventMap.entries()).map(([r,n])=>["count_"+r,n]));return {completion:{count_auto:this.autoCompletionCount,count_manual:this.manualCompletionCount,...t},completion_request:{count:this.completionRequestLatencyStats.count(),latency_avg:this.completionRequestLatencyStats.mean(),latency_p50:this.completionRequestLatencyStats.percentile(50),latency_p95:this.completionRequestLatencyStats.percentile(95),latency_p99:this.completionRequestLatencyStats.percentile(99)},completion_request_canceled:{count:this.completionRequestCanceledCount},completion_request_timeout:{count:this.completionRequestTimeoutCount}}}},lh=class{constructor(t){this.maxSize=t;this.values=[];}add(t){this.values.push(t),this.values.length>this.maxSize&&this.values.shift();}getValues(){return this.values}},ac=class e{constructor(){this.latencies=new lh(e.config.windowSize);}static{this.config={windowSize:10,checks:{disable:!1,healthy:{windowSize:1,latency:3e3},slowResponseTime:{latency:5e3,count:1},highTimeoutRate:{rate:.5,count:1}}};}static check(t){if(this.config.checks.disable)return null;let r=this.config.checks,{values:n,stats:{total:i,timeouts:s,responses:o,averageResponseTime:a}}=t;return n.slice(-Math.min(this.config.windowSize,r.healthy.windowSize)).every(c=>c<r.healthy.latency)?"healthy":s/i>r.highTimeoutRate.rate&&s>=r.highTimeoutRate.count?"highTimeoutRate":a>r.slowResponseTime.latency&&o>=r.slowResponseTime.count?"slowResponseTime":null}add(t){this.latencies.add(t);}reset(){this.latencies=new lh(e.config.windowSize);}stats(){let t=this.latencies.getValues(),r=t.filter(s=>Number.isNaN(s)),n=t.filter(s=>!Number.isNaN(s)),i=n.reduce((s,o)=>s+o,0)/n.length;return {values:t,stats:{total:t.length,timeouts:r.length,responses:n.length,averageResponseTime:i}}}};var cN=cr(uN());function iZ(e){return e.trimEnd().match(gD)}var fh=class e{constructor(t){this.filepath=t.filepath,this.language=t.language,this.text=t.text,this.position=t.position,this.indentation=t.indentation,this.prefix=t.text.slice(0,t.position),this.suffix=t.text.slice(t.position),this.prefixLines=ji(this.prefix),this.suffixLines=ji(this.suffix),this.currentLinePrefix=this.prefixLines[this.prefixLines.length-1]??"",this.currentLineSuffix=this.suffixLines[0]??"",this.clipboard=t.clipboard?.trim()??"",this.workspace=t.workspace,this.git=t.git,this.declarations=t.declarations,this.relevantSnippetsFromChangedFiles=t.relevantSnippetsFromChangedFiles;let r=iZ(this.currentLineSuffix);this.mode=r?"default":"fill-in-line",this.hash=(0, cN.default)({filepath:this.filepath,language:this.language,prefix:this.prefix,currentLineSuffix:r?"":this.currentLineSuffix,nextLines:this.suffixLines.slice(1).join(""),position:this.position,clipboard:this.clipboard,declarations:this.declarations,relevantSnippetsFromChangedFiles:this.relevantSnippetsFromChangedFiles});}isValid(){return !Je(this.prefix)}forward(t){return new e({filepath:this.filepath,language:this.language,text:this.text.substring(0,this.position)+t+this.text.substring(this.position),position:this.position+t.length,indentation:this.indentation,workspace:this.workspace,git:this.git,declarations:this.declarations,relevantSnippetsFromChangedFiles:this.relevantSnippetsFromChangedFiles})}buildSegments(t){let r=this.prefixLines.slice(Math.max(this.prefixLines.length-t.maxPrefixLines,0)).join(""),n=this.suffixLines.slice(0,t.maxSuffixLines).join(""),i,s,o;if(this.git&&this.git.remotes.length>0){let u=this.git.remotes.find(f=>f.name==="origin")||this.git.remotes.find(f=>f.name==="upstream")||this.git.remotes[0];u&&(i=this.git.root,o=u.url);}!i&&this.workspace&&(i=this.workspace),i&&(s=Zy__default.default.relative(i,this.filepath));let a=this.declarations?.map(u=>{let f=u.filepath;return i&&f.startsWith(i)&&(f=Zy__default.default.relative(i,f)),{filepath:f,body:u.text}}),c=this.relevantSnippetsFromChangedFiles?.filter(u=>!this.declarations?.find(f=>f.filepath===u.filepath&&Math.max(f.offset,u.offset)<=Math.min(f.offset+f.text.length,u.offset+u.text.length))).map(u=>{let f=u.filepath;return i&&f.startsWith(i)&&(f=Zy__default.default.relative(i,f)),{filepath:f,body:u.text,score:u.score}}).sort((u,f)=>f.score-u.score),l;return this.clipboard.length>=t.clipboard.minChars&&this.clipboard.length<=t.clipboard.maxChars&&(l=this.clipboard),{prefix:r,suffix:n,filepath:s,git_url:o,declarations:a,relevant_snippets_from_changed_files:c,clipboard:l}}};Array.prototype.distinct||(Array.prototype.distinct=function(e){return [...new Map(this.map(t=>[e?.(t)??t,t])).values()]});Array.prototype.mapAsync||(Array.prototype.mapAsync=async function(e,t){return await Promise.all(this.map((r,n)=>e.call(t,r,n,this)))});var sr=yr("Postprocess");function sZ(e){return /\n(\s*)\n/g}function lN(){return e=>{let r=e.text.split(sZ()),n=0,i=2,s=r.length-2;for(;s>=1;){if(Je(r[s])){s--;continue}let o=s-1;for(;o>=0&&Je(r[o]);)o--;if(o<0)break;let a=r[s].trim(),c=r[o].trim(),l=Math.max(.1*a.length,.1*c.length);if(la(a,c)<=l)n++,s--;else break}return n>=i?(sr.trace("Remove repetitive blocks.",{inputBlocks:r,repetitionCount:n}),e.withText(r.slice(0,s+1).join("").trimEnd())):e}}function fN(){return e=>{let t=e.lines,r=0,n=5,i=t.length-2;for(;i>=1;){if(Je(t[i])){i--;continue}let s=i-1;for(;s>=0&&Je(t[s]);)s--;if(s<0)break;let o=t[i].trim(),a=t[s].trim(),c=Math.max(.1*o.length,.1*a.length);if(la(o,a)<=c)r++,i=s;else break}return sr.trace("No Remove repetitive lines.",{inputLines:t,repetitionCount:r}),r>=n?(sr.trace("Remove repetitive lines.",{inputLines:t,repetitionCount:r}),e.withText(t.slice(0,i+1).join("").trimEnd())):e}}var oZ=[/(.{3,}?)\1{5,}$/g,/(.{10,}?)\1{3,}$/g];function hN(){return e=>{let t=e.context,r=e.lines,n=r.length-1;for(;n>=0&&Je(r[n]);)n--;if(n<0)return e;for(let i of oZ){let s=r[n].match(i);if(s)return sr.trace("Remove line ends with repetition.",{inputLines:r,lineNumber:n,match:s}),n<1?bn.createBlankItem(t):e.withText(r.slice(0,n).join("").trimEnd())}return e}}function dN(){return e=>{let t=e.context,{suffixLines:r,currentLinePrefix:n}=t,i=e.lines;if(i.length<2)return e;let s=i.map((l,u)=>u===0?n+l:l);if(!kf(s,i.length-1))return e;let o=i[i.length-1],a=1;for(;a<r.length&&Je(r[a]);)a++;if(a>=r.length)return e;let c=r[a];return o.startsWith(c.trimEnd())||c.startsWith(o.trimEnd())?(sr.trace("Remove duplicated block closing line.",{inputLines:i,suffixLines:r}),e.withText(i.slice(0,i.length-1).join("").trimEnd())):e}}function aZ(e,t,r){let n={indentLevelLimit:0,allowClosingLine:!0},{prefixLines:i,suffixLines:s,currentLinePrefix:o}=r;if(e.length==0||i.length==0)return n;let a=Je(o),c=i.length-1;for(;c>=0&&Je(i[c]);)c--;if(c<0)return n;let l=i[c],u=pi(l),f=e[0],d=Je(f),p=0;for(;p<e.length&&Je(e[p]);)p++;if(p>=e.length)return n;let m=e[p],S;d?S=pi(m):S=pi(o+m),!d&&!a?(n.indentLevelLimit=u+1,n.allowClosingLine&&=Am(t,0)):S>u?n.indentLevelLimit=u+1:(n.indentLevelLimit=u);let x=1;for(;x<s.length&&Je(s[x]);)x++;if(x<s.length){let I=s[x];n.allowClosingLine&&=pi(I)<n.indentLevelLimit;}return n}function pN(){return e=>{let{context:t,lines:r}=e,{prefixLines:n,suffixLines:i,currentLinePrefix:s}=t,o=r.map((l,u)=>u===0?s+l:l),a=aZ(r,o,t),c=1;for(;c<r.length;){let l=r[c],u=r[c-1];if(Je(l)){c++;continue}if(pi(l)<a.indentLevelLimit){if(kf(o,c)&&Am(o,c)){c++;continue}a.allowClosingLine&&(t.language!=="python"||!Je(u))&&c++;break}c++;}return c<r.length?(sr.trace("Remove content out of indent scope.",{inputLines:r,prefixLines:n,suffixLines:i,trimAtInputLine:c}),e.withText(r.slice(0,c).join("").trimEnd())):e}}function gN(){return async e=>pN()(e)}function ev(e){let t={"	":0,"  ":0,"    ":0};for(let r of e)if(r.match(/^\t/))t["	"]++;else {let n=r.match(/^ */)?.[0].length??0;n>0&&(n%4===0&&t["    "]++,n%2===0&&t["  "]++);}return t["	"]>0?"	":t["  "]>t["    "]?"  ":t["    "]>0?"    ":null}function uZ(e,t){return t==="	"?e.match(/^\t*/)?.[0].length??0:(e.match(/^ */)?.[0].length??0)/t.length}function mN(){return e=>{let t=e.context,{prefixLines:r,suffixLines:n,currentLinePrefix:i,indentation:s}=t,o=e.lines;if(!s)return e;let a=Je(i)?r.slice(0,r.length-1):r;if(r.length>1&&ev(a)!==null)return e;let c=n.slice(1);if(n.length>1&&ev(c)!==null)return e;let l=o.map((d,p)=>p===0?i+d:d),u=ev(l);if(u===null||u===s)return e;let f=l.map((d,p)=>{let m=uZ(d,u);if(m===0)return o[p];let S=d.slice(u.length*m);return p===0?Je(i)?s.repeat(m).slice(i.length)+S:o[0]:s.repeat(m)+S});return sr.trace("Format indentation.",{inputLines:o,formatted:f}),e.withText(f.join(""))}}function tv(){return e=>{let t=e.context,{currentLinePrefix:r,currentLineSuffix:n}=t,i=e.text;return !Je(r)&&r.match(/\s$/)&&(i=i.trimStart()),(Je(n)||!Je(n)&&n.match(/^\s/))&&(i=i.trimEnd()),i!==e.text?e.withText(i):e}}function yN(){return e=>{let t=e.context,r=e.lines;if(t.mode==="fill-in-line"&&r.length>1){let n=t.currentLineSuffix.trimEnd(),i=r[0].trimEnd();if(i.endsWith(n)){let s=i.slice(0,-n.length);if(s.length>0)return sr.trace("Trim content with multiple lines.",{inputLines:r,trimmedInputLine:s}),e.withText(s)}return sr.trace("Drop content with multiple lines.",{inputLines:r}),bn.createBlankItem(t)}return e}}function rv(){return e=>{let t=e.context,{suffixLines:r}=t,n=e.lines,i=0;for(;i<n.length&&Je(n[i]);)i++;let s=0;for(;s<r.length&&Je(r[s]);)s++;let o=Math.min(3,n.length-i,r.length-s);if(o<1)return e;let a=n.slice(i,i+o).join("").trim(),c=r.slice(s,s+o).join("").trim(),l=Math.max(1,.05*a.length,.05*c.length),u=la(a,c);return u<=l?(sr.trace("Drop completion due to duplicated.",{inputToCompare:a,suffixToCompare:c,distance:u,threshold:l}),bn.createBlankItem(t)):e}}function nv(){return e=>Je(e.fullText)||Je(e.text)?bn.createBlankItem(e.context):e}function vN(e){let t=e.context,{currentLineSuffix:r}=t,n=r.trimEnd();if(Je(n))return e;let i=mD(e.text).join("");if(Je(i))return e;let s;return n.startsWith(i)?s=e.withSuffix(i):i.startsWith(n)&&(s=e.withSuffix(n)),s?(sr.trace("Adjust replace range by bracket stack.",{position:t.position,currentLineSuffix:r,completionText:e.text,unpaired:i,replaceSuffix:e.replaceSuffix}),s):e}function SN(){return async e=>vN(e)}function bN(e,t){let r=e(t);return async n=>await n.mapAsync(r)}async function iv(e,t){let r=n=>bN(n,t);return Promise.resolve(e).then(r(yN)).then(r(hN)).then(r(rv)).then(r(tv)).then(r(nv))}async function CN(e,t){let r=n=>bN(n,t);return Promise.resolve(e).then(r(lN)).then(r(fN)).then(r(gN)).then(r(dN)).then(r(mN)).then(r(rv)).then(r(tv)).then(r(nv)).then(r(SN))}var cc="tabby-agent",lc="1.6.0-dev";var hh=class{constructor(){this.anonymousUsageTrackingApi=Qs({baseUrl:"https://app.tabbyml.com/api"});this.logger=yr("AnonymousUsage");this.systemData={agent:`${cc}, ${lc}`,browser:void 0,node:`${process.version} ${process.platform} ${xN__default.default.arch()} ${xN__default.default.release()}`};this.sessionProperties={};this.userProperties={};this.userPropertiesUpdated=!1;this.emittedUniqueEvent=[];this.disabled=!1;}async init(t){if(this.dataStore=t?.dataStore,this.dataStore)if(typeof this.dataStore.data.anonymousId=="string")this.anonymousId=this.dataStore.data.anonymousId;else {this.anonymousId=ui(),this.dataStore.data.anonymousId=this.anonymousId;try{await this.dataStore.save();}catch(r){this.logger.error("Failed to save anonymous Id.",r);}}else this.anonymousId=ui();}setSessionProperties(t,r){Yo(this.sessionProperties,t,r);}setUserProperties(t,r){Yo(this.userProperties,t,r),this.userPropertiesUpdated=!0;}async uniqueEvent(t,r={}){await this.event(t,r,!0);}async event(t,r={},n=!1){if(this.disabled||!this.anonymousId||n&&this.emittedUniqueEvent.includes(t))return;n&&this.emittedUniqueEvent.push(t);let i={...this.systemData,...this.sessionProperties,...r};this.userPropertiesUpdated&&(Yo(i,"$set",this.userProperties),this.userPropertiesUpdated=!1);try{await this.anonymousUsageTrackingApi.POST("/usage",{body:{distinctId:this.anonymousId,event:t,properties:i}});}catch(s){this.logger.error("Failed to send anonymous usage data.",s);}}};var uq=cr(hf()),qS=cr(LS()),cq=cr(sq());var nd=yr("CaCert"),rd=[],OS;function lq(e){OS||(OS=oq__default.default.createSecureContext);let t=e.filter(n=>typeof n=="string"?n.trim().length>0:!0),r=[...rd,...t].distinct();nd.debug(`Loaded ${r.length-rd.length} extra certs.`),rd=r,oq__default.default.createSecureContext=n=>{let i=OS(n);return rd.forEach(s=>{i.context.addCACert(s);}),i};}async function aq(e){nd.debug(`Loading extra certs from ${e}.`);let t=(await e.split(Zy__default.default.delimiter).mapAsync(async r=>{try{return (await uq.default.readFile(r)).toString()}catch{return null}})).join(`
`).split(/(?=-----BEGIN\sCERTIFICATE-----)/g).distinct();lq(t);}async function fq(e){if(e.caCerts!=="bundled")if(e.caCerts==="system")if(process.platform==="win32")nd.debug("Loading extra certs from win-ca."),qS.default.exe(Zy__default.default.join("win-ca","roots.exe")),(0, qS.default)({fallback:!0,inject:"+"});else if(process.platform==="darwin"){nd.debug("Loading extra certs from mac-ca.");let t=cq.get();lq(t);}else await aq(Zy__default.default.join("/etc/ssl/certs/ca-certificates.crt"));else e.caCerts&&await aq(e.caCerts);}var id=class e extends HJ.EventEmitter{constructor(){super();this.logger=yr("TabbyAgent");this.anonymousUsageLogger=new hh;this.config=rc;this.userConfig={};this.clientConfig={};this.serverProvidedConfig={};this.status="notInitialized";this.issues=[];this.completionCache=new ah;this.completionDebounce=new uh;this.completionStats=new ch;this.completionRequestStats=new ac;this.tryingConnectTimer=setInterval(async()=>{this.status==="disconnected"&&(this.logger.debug("Trying to connect..."),await this.healthCheck());},e.tryConnectInterval),this.submitStatsTimer=setInterval(async()=>{await this.submitStats();},e.submitStatsInterval);}static{this.tryConnectInterval=1e3*30;}static{this.submitStatsInterval=1e3*60*60*24;}async applyConfig(){this.logger.info("Applying updated config...");let r=this.config,n=this.status;this.config=$l(rc,this.userConfig,this.clientConfig,this.serverProvidedConfig),this.logger.trace("Updated config:",this.config),tc&&(tc.level=this.config.logs.level),this.anonymousUsageLogger.disabled=this.config.anonymousUsageTracking.disable,await fq(this.config.tls),Je(this.config.server.token)&&this.config.server.requestHeaders.Authorization===void 0?this.config.server.endpoint!==this.auth?.endpoint&&(this.auth=new ih(this.config.server.endpoint),await this.auth.init({dataStore:this.dataStore}),this.auth.on("updated",()=>{this.setupApi();})):this.auth=void 0,(0, _o.default)(r.server,this.config.server)||(this.serverHealthState=void 0,this.completionRequestStats.reset(),this.popIssue("slowCompletionResponseTime"),this.popIssue("highCompletionTimeoutRate"),this.popIssue("connectionFailed"),this.connectionErrorMessage=void 0),(!this.api||!(0, _o.default)(r.server,this.config.server))&&await this.setupApi(),this.logger.info("Completed applying updated config.");let i={event:"configUpdated",config:this.config};super.emit("configUpdated",i),!(0, _o.default)(r.server,this.config.server)&&n==="unauthorized"&&this.status==="unauthorized"&&this.emitAuthRequired();}async setupApi(){let r=Je(this.config.server.token)?this.auth?.token?`Bearer ${this.auth.token}`:void 0:`Bearer ${this.config.server.token}`;this.api=Qs({baseUrl:this.config.server.endpoint.replace(/\/+$/,""),headers:{Authorization:r,...this.config.server.requestHeaders}}),await this.healthCheck();}changeStatus(r){if(this.status!=r){this.status=r,this.logger.info(`Status changed: ${r}.`);let n={event:"statusChanged",status:r};super.emit("statusChanged",n),this.status==="unauthorized"&&this.emitAuthRequired();}}issueFromName(r){switch(r){case"highCompletionTimeoutRate":return {name:"highCompletionTimeoutRate",completionResponseStats:this.completionRequestStats.stats().stats};case"slowCompletionResponseTime":return {name:"slowCompletionResponseTime",completionResponseStats:this.completionRequestStats.stats().stats};case"connectionFailed":return {name:"connectionFailed",message:this.connectionErrorMessage}}}pushIssue(r){this.issues.includes(r)||(this.issues.push(r),this.logger.info(`Issue created: ${r}.`),this.emitIssueUpdated());}popIssue(r){let n=this.issues.indexOf(r);n>=0&&(this.issues.splice(n,1),this.logger.info(`Issue removed: ${r}.`),this.emitIssueUpdated());}emitAuthRequired(){let r={event:"authRequired",server:this.config.server};super.emit("authRequired",r);}emitIssueUpdated(){let r={event:"issuesUpdated",issues:this.issues};super.emit("issuesUpdated",r);}async submitStats(){let r=this.completionStats.stats();r.completion_request.count>0&&(await this.anonymousUsageLogger.event("AgentStats",{stats:r}),this.completionStats.reset());}createAbortSignal(r){let n=Math.min(2147483647,r?.timeout||this.config.server.requestTimeout);return Yu([AbortSignal.timeout(n),r?.signal])}async healthCheck(r){let n=ui(),i="/v1/health",s=`${r?.method||"GET"} ${this.config.server.endpoint+i}`,o={signal:this.createAbortSignal({signal:r?.signal})};try{if(!this.api)throw new Error("http client not initialized");this.logger.debug(`Health check request: ${s}. [${n}]`);let a;if(r?.method==="POST"?a=await this.api.POST(i,o):a=await this.api.GET(i,o),this.logger.debug(`Health check response status: ${a.response.status}. [${n}]`),a.error||!a.response.ok)throw new lr(a.response);this.logger.trace(`Health check response data: [${n}]`,a.data);let c=a.data;this.popIssue("connectionFailed"),this.connectionErrorMessage=void 0,typeof c=="object"&&c.model!==void 0&&c.device!==void 0&&(this.serverHealthState=c,this.anonymousUsageLogger.uniqueEvent("AgentConnected",c),this.fetchServerProvidedConfig()),this.changeStatus("ready");}catch(a){if(this.serverHealthState=void 0,a instanceof lr&&a.status==405&&r?.method!=="POST")return await this.healthCheck({method:"POST"});if(fa(a))this.changeStatus("unauthorized");else {if(gi(a))this.logger.debug(`Health check request canceled. [${n}]`),this.connectionErrorMessage=`${s} canceled.`;else if(Rm(a))this.logger.error(`Health check request timed out. [${n}]`,a),this.connectionErrorMessage=`${s} timed out.`;else {this.logger.error(`Health check request failed. [${n}]`,a);let c=a instanceof Error?Im(a):JSON.stringify(a);this.connectionErrorMessage=`${s} failed: 
${c}`;}this.pushIssue("connectionFailed"),this.changeStatus("disconnected");}}}async fetchServerProvidedConfig(){let r=sd.coerce(this.serverHealthState?.version.git_describe);if(r&&sd.lt(r,"0.9.0")){this.logger.debug(`Skip fetching server provided config due to server version: ${r}.`);return}let n=ui();try{if(!this.api)throw new Error("http client not initialized");let i="/v1beta/server_setting",s=`GET ${this.config.server.endpoint+i}`;this.logger.debug(`Fetch server provided config request: ${s}. [${n}]`);let o=await this.api.GET(i);if(this.logger.debug(`Fetch server provided config response status: ${o.response.status}. [${n}]`),o.error||!o.response.ok)throw new lr(o.response);this.logger.trace(`Fetch server provided config response data: [${n}]`,o.data);let a=o.data,c={};if(a.disable_client_side_telemetry&&(c.anonymousUsageTracking={disable:!0}),!(0, _o.default)(c,this.serverProvidedConfig)&&(this.serverProvidedConfig=c,await this.applyConfig(),this.dataStore)){this.dataStore.data.serverConfig||(this.dataStore.data.serverConfig={}),this.dataStore.data.serverConfig[this.config.server.endpoint]=this.serverProvidedConfig;try{await this.dataStore.save();}catch(l){this.logger.error("Failed to save server provided config.",l);}}}catch(i){fa(i)?this.logger.debug(`Fetch server provided config request failed due to unauthorized. [${n}]`):i instanceof lr&&this.logger.error(`Fetch server provided config request failed. [${n}]`,i);}}async initialize(r){if(this.logger.info("Initializing..."),this.logger.trace("Initialization options:",r),r.loggers&&nh.attach(...r.loggers),this.dataStore=r.dataStore??_m,this.dataStore)try{await this.dataStore.load(),"watch"in this.dataStore&&typeof this.dataStore.watch=="function"&&this.dataStore.watch();}catch(n){this.logger.error("Failed to load stored data.",n);}if(await this.anonymousUsageLogger.init({dataStore:this.dataStore}),r.clientProperties&&(r.clientProperties.session&&Object.entries(r.clientProperties.session).forEach(([n,i])=>{this.anonymousUsageLogger.setSessionProperties(n,i);}),r.clientProperties.user&&Object.entries(r.clientProperties.user).forEach(([n,i])=>{this.anonymousUsageLogger.setUserProperties(n,i);})),ya&&(await ya.load(),this.userConfig=ya.config,ya.on("updated",async n=>{this.userConfig=n,await this.applyConfig();}),ya.watch()),r.config&&(this.clientConfig=r.config),this.dataStore){let n=$l(rc,this.userConfig,this.clientConfig);this.serverProvidedConfig=this.dataStore?.data.serverConfig?.[n.server.endpoint]??{},this.dataStore instanceof HJ.EventEmitter&&this.dataStore.on("updated",async()=>{let i=$l(rc,this.userConfig,this.clientConfig),s=_m?.data.serverConfig?.[i.server.endpoint];(0, _o.default)(s,this.serverProvidedConfig)||(this.serverProvidedConfig=s??{},await this.applyConfig());});}return await this.applyConfig(),await this.anonymousUsageLogger.uniqueEvent("AgentInitialized"),this.logger.info("Initialized."),this.status!=="notInitialized"}async finalize(){return this.status==="finalized"?!1:(this.logger.info("Finalizing..."),await this.submitStats(),this.tryingConnectTimer&&clearInterval(this.tryingConnectTimer),this.submitStatsTimer&&clearInterval(this.submitStatsTimer),this.changeStatus("finalized"),this.logger.info("Finalized."),!0)}async updateClientProperties(r,n,i){switch(this.logger.trace("Client properties updated.",{type:r,key:n,value:i}),r){case"session":this.anonymousUsageLogger.setSessionProperties(n,i);break;case"user":this.anonymousUsageLogger.setUserProperties(n,i);break}return !0}async updateConfig(r,n){this.logger.trace("Config updated.",{key:r,value:n});let i=jl(this.clientConfig,r);return (0, _o.default)(i,n)||(n===void 0?Vl(this.clientConfig,r):Yo(this.clientConfig,r,n),await this.applyConfig()),!0}async clearConfig(r){return await this.updateConfig(r,void 0)}getConfig(){return this.config}getStatus(){return this.status}getIssues(){return this.issues}getIssueDetail(r){let n=this.getIssues();return r.index!==void 0&&r.index<n.length?this.issueFromName(n[r.index]):r.name!==void 0&&this.issues.includes(r.name)?this.issueFromName(r.name):null}getServerHealthState(){return this.serverHealthState??null}async requestAuthUrl(r){if(this.status==="notInitialized")throw new Error("Agent is not initialized");return await this.healthCheck(r),this.status!=="unauthorized"||!this.auth?null:await this.auth.requestAuthUrl(r)}async waitForAuthToken(r,n){if(this.status==="notInitialized")throw new Error("Agent is not initialized");this.status!=="unauthorized"||!this.auth||(await this.auth.pollingToken(r,n),await this.setupApi());}async provideCompletions(r,n){if(this.status==="notInitialized")throw new Error("Agent is not initialized");if(this.logger.debug("Function providedCompletions called."),this.completionMutexAbortController){let c=new Error("Aborted due to new request.");c.name="AbortError",this.completionMutexAbortController.abort(c);}this.completionMutexAbortController=new AbortController;let i=Yu([this.completionMutexAbortController.signal,n?.signal]),s=new fh(r);if(!s.isValid())return Wy;let o,a;this.completionCache.has(s.hash)&&(a=this.completionCache.get(s.hash));try{if(a&&(!r.manually||a.isCompleted))await this.completionDebounce.debounce({request:r,config:this.config.completion.debounce,responseTime:0},{signal:i}),o=a.withContext(s),this.logger.info("Completion cache hit.");else if(r.manually){o=a?.withContext(s)??new ms(s),this.logger.info("Fetching more completions...");try{let c=0;for(;o.items.length<this.config.completion.solution.maxItems&&c<this.config.completion.solution.maxTries;){c++;let l=await this.fetchCompletion(s.language,s.buildSegments(this.config.completion.prompt),this.config.completion.solution.temperature,i),u=bn.createFromResponse(s,l);if(o.add(...await iv([u],this.config.postprocess)),i.aborted)throw i.reason}o.isCompleted=!0;}catch(c){gi(c)&&(this.logger.info("Fetching completion canceled."),o=void 0);}}else {await this.completionDebounce.debounce({request:r,config:this.config.completion.debounce,responseTime:this.completionRequestStats.stats().stats.averageResponseTime},{signal:i}),o=new ms(s),this.logger.info("Fetching completion...");try{let c=await this.fetchCompletion(s.language,s.buildSegments(this.config.completion.prompt),void 0,i),l=bn.createFromResponse(s,c);o.add(...await iv([l],this.config.postprocess));}catch(c){gi(c)&&(this.logger.info("Fetching completion canceled."),o=void 0);}}if(o&&(this.completionCache.update(o),o=o.withItems(...await CN(o.items,this.config.postprocess)),i.aborted))throw i.reason}catch(c){gi(c)||this.logger.error("Providing completions failed.",c);}if(o){let c=o.toInlineCompletionList();return this.logger.info(`Completed processing completions, choices returned: ${c.items.length}.`),this.logger.trace("Completion solution:",{result:c}),c}return Wy}async fetchCompletion(r,n,i,s){let o=ui(),a={latency:NaN,canceled:!1,timeout:!1,notAvailable:!1},c=performance.now();try{if(!this.api)throw new Error("http client not initialized");let l="/v1/completions",u={body:{language:r,segments:n,temperature:i},signal:this.createAbortSignal({signal:s})},f=`POST ${this.config.server.endpoint+l}`;this.logger.debug(`Completion request: ${f}. [${o}]`),this.logger.trace(`Completion request body: [${o}]`,u.body);let d=await this.api.POST(l,u);if(this.logger.debug(`Completion response status: ${d.response.status}. [${o}]`),d.error||!d.response.ok)throw new lr(d.response);return this.logger.trace(`Completion response data: [${o}]`,d.data),a.latency=performance.now()-c,d.data}catch(l){throw gi(l)?(this.logger.debug(`Completion request canceled. [${o}]`),a.canceled=!0):Rm(l)?(this.logger.debug(`Completion request timed out. [${o}]`),a.timeout=!0):fa(l)?(this.logger.debug(`Completion request failed due to unauthorized. [${o}]`),a.notAvailable=!0,this.healthCheck()):(this.logger.error(`Completion request failed. [${o}]`,l),a.notAvailable=!0,this.healthCheck()),l}finally{if(a.notAvailable||this.completionStats.addRequestStatsEntry(a),!a.notAvailable&&!a.canceled){this.completionRequestStats.add(a.latency);let l=this.completionRequestStats.stats();switch(ac.check(l)){case"healthy":this.popIssue("slowCompletionResponseTime"),this.popIssue("highCompletionTimeoutRate");break;case"highTimeoutRate":this.popIssue("slowCompletionResponseTime"),this.pushIssue("highCompletionTimeoutRate");break;case"slowResponseTime":this.popIssue("highCompletionTimeoutRate"),this.pushIssue("slowCompletionResponseTime");break}}}}async postEvent(r,n){if(this.status==="notInitialized")throw new Error("Agent is not initialized");this.completionStats.addEvent(r.type);let i=ui();try{if(!this.api)throw new Error("http client not initialized");let s="/v1/events",o={body:r,params:{query:{select_kind:r.select_kind}},signal:this.createAbortSignal(n),parseAs:"text"},a=`POST ${this.config.server.endpoint+s}`;this.logger.debug(`Event request: ${a}. [${i}]`),this.logger.trace(`Event request body: [${i}]`,o.body);let c=await this.api.POST(s,o);if(this.logger.debug(`Event response status: ${c.response.status}. [${i}]`),c.error||!c.response.ok)throw new lr(c.response);return this.logger.trace(`Event response data: [${i}]`,c.data),!0}catch(s){return fa(s)?this.logger.debug(`Completion request failed due to unauthorized. [${i}]`):this.logger.error(`Event request failed. [${i}]`,s),this.healthCheck(),!1}}async generateCommitMessage(r,n){if(this.status==="notInitialized")throw new Error("Agent is not initialized");let{maxDiffLength:i,promptTemplate:s}=this.config.experimentalChat.generateCommitMessage,o;typeof r=="string"?o=r.split(/\n(?=diff)/):o=r;let a="";for(let l of o)a.length+l.length<i&&(a+=l+`
`);if(Je(a)&&(typeof r=="string"?a=r.substring(0,i):a=r.join(`
`).substring(0,i)),Je(a))return "";let c=ui();try{if(!this.api)throw new Error("http client not initialized");let l=n?.useBetaVersion?"/v1beta/chat/completions":"/v1/chat/completions",f={body:{messages:[{role:"user",content:s.replace("{{diff}}",a)}]},signal:this.createAbortSignal(n),parseAs:"stream"},d=`POST ${this.config.server.endpoint+l}`;this.logger.debug(`Chat request: ${d}. [${c}]`),this.logger.trace(`Chat request body: [${c}]`,f.body);let p=await this.api.POST(l,f);if(this.logger.debug(`Chat response status: ${p.response.status}. [${c}]`),p.error||!p.response.ok)throw new lr(p.response);let m=await vD(p.response,f.signal);return this.logger.trace(`Chat response message: [${c}]`,{responseMessage:m}),m.trim()}catch(l){if(l instanceof lr&&l.status==404&&!n?.useBetaVersion)return await this.generateCommitMessage(r,{...n,useBetaVersion:!0});fa(l)?this.logger.debug(`Chat request failed due to unauthorized. [${c}]`):this.logger.error(`Chat request failed. [${c}]`,l),this.healthCheck();}return ""}};var dq=["statusChanged","configUpdated","authRequired","issuesUpdated"];var od=class{constructor(){this.process=process;this.inStream=process.stdin;this.outStream=process.stdout;this.logger=yr("JsonLineServer");this.abortControllers={};}async handleLine(t){let r;try{r=JSON.parse(t);}catch(i){this.logger.error(`Failed to parse request: ${t}`,i);return}this.logger.debug(`Processing request ${r[0]} ${r[1].func}.`),this.logger.trace("Request data:",{request:r});let n=await this.handleRequest(r);this.sendResponse(n),this.logger.debug(`Completed processing request ${r[0]}.`),this.logger.trace("Response data:",{response:n});}async handleRequest(t){let r=0,n=[0,null],i=new AbortController;try{if(!this.agent)throw new Error(`Agent not bound.
`);r=t[0],n[0]=r;let s=t[1].func;if(s==="cancelRequest")n[1]=this.cancelRequest(t);else {let o=this.agent[s];if(!o)throw new Error(`Unknown function: ${s}`);let a=t[1].args;a.length>0&&typeof a[a.length-1]=="object"&&a[a.length-1].signal&&(this.abortControllers[r]=i,a[a.length-1].signal=i.signal),n[1]=await o.apply(this.agent,a);}}catch(s){gi(s)?this.logger.debug(`Request ${t[0]} canceled.`):this.logger.error(`Failed to handle request ${t[0]}`,s);}finally{this.abortControllers[r]&&delete this.abortControllers[r];}return n}cancelRequest(t){let r=t[1].args[0],n=this.abortControllers[r];return n?(n.abort(),!0):!1}sendResponse(t){this.outStream.write(JSON.stringify(t)+`
`);}bind(t){this.agent=t;for(let r of dq)this.agent.on(r,n=>{this.sendResponse([0,n]);});}listen(){Cne__default.default.createInterface({input:this.inStream}).on("line",t=>{this.handleLine(t);}),["SIGTERM","SIGINT"].forEach(t=>{this.process.on(t,async()=>{this.agent&&this.agent.getStatus()!=="finalized"&&await this.agent.finalize(),this.process.exit(0);});});}};var ki=cr(qM());var xp=class e{constructor(t,r,n,i){this._uri=t,this._languageId=r,this._version=n,this._content=i,this._lineOffsets=void 0;}get uri(){return this._uri}get languageId(){return this._languageId}get version(){return this._version}getText(t){if(t){let r=this.offsetAt(t.start),n=this.offsetAt(t.end);return this._content.substring(r,n)}return this._content}update(t,r){for(let n of t)if(e.isIncremental(n)){let i=MM(n.range),s=this.offsetAt(i.start),o=this.offsetAt(i.end);this._content=this._content.substring(0,s)+n.text+this._content.substring(o,this._content.length);let a=Math.max(i.start.line,0),c=Math.max(i.end.line,0),l=this._lineOffsets,u=FM(n.text,!1,s);if(c-a===u.length)for(let d=0,p=u.length;d<p;d++)l[d+a+1]=u[d];else u.length<1e4?l.splice(a+1,c-a,...u):this._lineOffsets=l=l.slice(0,a+1).concat(u,l.slice(c+1));let f=n.text.length-(o-s);if(f!==0)for(let d=a+1+u.length,p=l.length;d<p;d++)l[d]=l[d]+f;}else if(e.isFull(n))this._content=n.text,this._lineOffsets=void 0;else throw new Error("Unknown change event received");this._version=r;}getLineOffsets(){return this._lineOffsets===void 0&&(this._lineOffsets=FM(this._content,!0)),this._lineOffsets}positionAt(t){t=Math.max(Math.min(t,this._content.length),0);let r=this.getLineOffsets(),n=0,i=r.length;if(i===0)return {line:0,character:t};for(;n<i;){let o=Math.floor((n+i)/2);r[o]>t?i=o:n=o+1;}let s=n-1;return {line:s,character:t-r[s]}}offsetAt(t){let r=this.getLineOffsets();if(t.line>=r.length)return this._content.length;if(t.line<0)return 0;let n=r[t.line],i=t.line+1<r.length?r[t.line+1]:this._content.length;return Math.max(Math.min(n+t.character,i),n)}get lineCount(){return this.getLineOffsets().length}static isIncremental(t){let r=t;return r!=null&&typeof r.text=="string"&&r.range!==void 0&&(r.rangeLength===void 0||typeof r.rangeLength=="number")}static isFull(t){let r=t;return r!=null&&typeof r.text=="string"&&r.range===void 0&&r.rangeLength===void 0}},wp;(function(e){function t(i,s,o,a){return new xp(i,s,o,a)}e.create=t;function r(i,s,o){if(i instanceof xp)return i.update(s,o),i;throw new Error("TextDocument.update: document must be created by TextDocument.create")}e.update=r;function n(i,s){let o=i.getText(),a=BC(s.map(qse),(u,f)=>{let d=u.range.start.line-f.range.start.line;return d===0?u.range.start.character-f.range.start.character:d}),c=0,l=[];for(let u of a){let f=i.offsetAt(u.range.start);if(f<c)throw new Error("Overlapping edit");f>c&&l.push(o.substring(c,f)),u.newText.length&&l.push(u.newText),c=i.offsetAt(u.range.end);}return l.push(o.substr(c)),l.join("")}e.applyEdits=n;})(wp||(wp={}));function BC(e,t){if(e.length<=1)return e;let r=e.length/2|0,n=e.slice(0,r),i=e.slice(r);BC(n,t),BC(i,t);let s=0,o=0,a=0;for(;s<n.length&&o<i.length;)t(n[s],i[o])<=0?e[a++]=n[s++]:e[a++]=i[o++];for(;s<n.length;)e[a++]=n[s++];for(;o<i.length;)e[a++]=i[o++];return e}function FM(e,t,r=0){let n=t?[r]:[];for(let i=0;i<e.length;i++){let s=e.charCodeAt(i);(s===13||s===10)&&(s===13&&i+1<e.length&&e.charCodeAt(i+1)===10&&i++,n.push(r+i+1));}return n}function MM(e){let t=e.start,r=e.end;return t.line>r.line||t.line===r.line&&t.character>r.character?{start:r,end:t}:e}function qse(e){let t=MM(e.range);return t!==e.range?{newText:e.newText,range:t}:e}var _p=class{constructor(){this.connection=(0, ki.createConnection)();this.documents=new ki.TextDocuments(wp);this.logger=yr("LSP");this.connection.onInitialize(async t=>await this.initialize(t)),this.connection.onShutdown(async()=>await this.shutdown()),this.connection.onExit(async()=>this.exit()),this.connection.onCompletion(async t=>await this.completion(t));}bind(t){this.agent=t,this.agent.on("statusChanged",r=>{(r.status==="disconnected"||r.status==="unauthorized")&&this.showMessage({type:ki.MessageType.Warning,message:`Tabby agent status: ${r.status}`});});}listen(){this.documents.listen(this.connection),this.connection.listen();}async initialize(t){if(this.logger.debug("[-->] Initialize Request"),this.logger.trace("Initialize params:",t),!this.agent)throw new Error(`Agent not bound.
`);let{clientInfo:r,capabilities:n}=t;await this.agent.initialize({clientProperties:{session:{client:`${r?.name} ${r?.version??""}`,ide:{name:r?.name,version:r?.version},tabby_plugin:{name:`${cc} (LSP)`,version:lc}}}});let i={capabilities:{textDocumentSync:{openClose:!0,change:ki.TextDocumentSyncKind.Incremental},completionProvider:{}},serverInfo:{name:cc,version:lc}};return this.logger.debug("[<--] Initialize Response"),this.logger.trace("Initialize result:",i),i}async shutdown(){if(this.logger.debug("[-->] shutdown"),!this.agent)throw new Error(`Agent not bound.
`);await this.agent.finalize(),this.logger.debug("[<--] shutdown");}exit(){return this.logger.debug("[-->] exit"),process.exit(0)}async showMessage(t){this.logger.debug("[<--] window/showMessage"),this.logger.trace("ShowMessage params:",t),await this.connection.sendNotification("window/showMessage",t);}async completion(t){if(this.logger.debug("[-->] textDocument/completion"),this.logger.trace("Completion params:",t),!this.agent)throw new Error(`Agent not bound.
`);let r={isIncomplete:!0,items:[]};try{let n=this.buildCompletionRequest(t),i=await this.agent.provideCompletions(n);r=this.toCompletionList(i,t);}catch(n){gi(n)?this.logger.debug("Completion request canceled."):this.logger.error("Completion request failed.",n);}return this.logger.debug("[<--] textDocument/completion"),this.logger.trace("Completion result:",r),r}buildCompletionRequest(t,r=!1){let{textDocument:n,position:i}=t,s=this.documents.get(n.uri);return {filepath:s.uri,language:s.languageId,text:s.getText(),position:s.offsetAt(i),manually:r}}toCompletionList(t,r){let{textDocument:n,position:i}=r,s=this.documents.get(n.uri),o=s.getText({start:{line:i.line,character:0},end:i}),a=o.match(/(\w+)$/)?.[0]??"";return {isIncomplete:t.isIncomplete,items:t.items.map(c=>{let l=c.insertText.slice(s.offsetAt(i)-c.range.start),u=ji(l),f=u[0]||"",d=u[1]||"";return {label:a+f,labelDetails:{detail:d,description:"Tabby"},kind:ki.CompletionItemKind.Text,documentation:{kind:"markdown",value:`\`\`\`
${o+l}
\`\`\`
 ---
Suggested by Tabby.`},textEdit:{newText:a+l,range:{start:{line:i.line,character:i.character-a.length},end:s.positionAt(c.range.end)}},data:c.data}})}}};var Fse=process.argv.slice(2),Tp;Fse.indexOf("--lsp")>=0?Tp=new _p:Tp=new od;var Mse=new id;Tp.bind(Mse);Tp.listen();
/*! Bundled license information:

normalize-path/index.js:
  (*!
   * normalize-path <https://github.com/jonschlinkert/normalize-path>
   *
   * Copyright (c) 2014-2018, Jon Schlinkert.
   * Released under the MIT License.
   *)

is-extglob/index.js:
  (*!
   * is-extglob <https://github.com/jonschlinkert/is-extglob>
   *
   * Copyright (c) 2014-2016, Jon Schlinkert.
   * Licensed under the MIT License.
   *)

is-glob/index.js:
  (*!
   * is-glob <https://github.com/jonschlinkert/is-glob>
   *
   * Copyright (c) 2014-2017, Jon Schlinkert.
   * Released under the MIT License.
   *)

is-number/index.js:
  (*!
   * is-number <https://github.com/jonschlinkert/is-number>
   *
   * Copyright (c) 2014-present, Jon Schlinkert.
   * Released under the MIT License.
   *)

to-regex-range/index.js:
  (*!
   * to-regex-range <https://github.com/micromatch/to-regex-range>
   *
   * Copyright (c) 2015-present, Jon Schlinkert.
   * Released under the MIT License.
   *)

fill-range/index.js:
  (*!
   * fill-range <https://github.com/jonschlinkert/fill-range>
   *
   * Copyright (c) 2014-present, Jon Schlinkert.
   * Licensed under the MIT License.
   *)
*/
//# sourceMappingURL=out.js.map
//# sourceMappingURL=cli.js.map